<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-api-action/apiaction.php");

class GetOrderForms extends MB_AdminAPIAction
{
	public $params = array("getTLDs", "orderFormID");

	public function execute()
	{
		parent::execute();

		dbg("#### Original _REQUEST Data ####");
		dbg($_REQUEST);

		$params = array();
		$exclude = array("getTLDs");
		foreach( $this->params as $key ) {
			if (notNull( $_REQUEST[ $key ] ) && !in_array($key, $exclude))
				$params[ $key ] =& $_REQUEST[ $key ];
		}

		dbg("#### Params that matched keys (these are what we'll use ####");
		dbg($params);

		$orderFormInfo = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetWebsiteWidgets",
				"params" => $params + array(
						"getOrderFormData" => 1,
						"getProductInformation" => 1,
						) ) ));
		dbg("Website Widgets");
		dbg($orderFormInfo);

		// need to grab local info, WebsiteWidgets isn't formated correctly to
		// allow return of product information + locale
		$orderFormMeta = grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetOrderForms",
				"params" => $params + array(
					"getOrderFormParams" => 1,
				)
			)
		));
		dbg("Detailed Order Form Information");
		dbg($orderFormMeta);

		for( $i=0, $n=count($orderFormInfo); $i<$n; $i++ ) {
			if ($orderFormInfo[ $i ]["orderFormID"] != $orderFormMeta[ $i ]["orderFormID"]) {
				foreach( $orderFormMeta as $meta ) {
					if ($meta["orderFormID"] == $orderFormInfo[ $i ]["orderFormID"]) {
						$orderFormInfo[ $i ]["languageISO2"] = $meta["languageISO2"];
						$orderFormInfo[ $i ]["countriesISO2"] = $meta["countriesISO2"];
						$orderFormInfo[ $i ]["orderFormParams"] = $meta["orderFormParams"];
					}
				}
				unset( $meta );
			} else {
				$orderFormInfo[ $i ]["languageISO2"] = $orderFormMeta[ $i ]["languageISO2"];
				$orderFormInfo[ $i ]["countriesISO2"] = $orderFormMeta[ $i ]["countriesISO2"];
				$orderFormInfo[ $i ]["orderFormParams"] = $orderFormMeta[ $i ]["orderFormParams"];
			}
		}
		unset( $orderFormMeta );

		// grab product varients
		for( $i=0, $n=count( (array)$orderFormInfo ); $i<$n; $i++ ) {
			foreach( (array)$orderFormInfo[ $i ]["products"][0]["product"] as $k => $prod ) {
				$thisProdDetails = grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetProducts",
							"params" => array(
								"productID" => (int)$prod["productID"],
								"orderFormID" => (int)$_REQUEST["orderFormID"],
								"getActiveProductVariantPriceData" => 1,
								"getActiveCycleData" => 1,
								)
								)
								));
				$orderFormInfo[ $i ]["products"][0]["product"][ $k ] = $thisProdDetails[0];
			}
		}
		unset( $i, $k, $prod );
		/**/
		dbg("Final Order Form Info");
		dbg($orderFormInfo);

		$output = array("orderForms" => array("orderForm"=>$orderFormInfo));

		if (notZero( $_REQUEST["getTLDs"] )) {
			$tlds = arrayFor("TLDs", array("tldActive" => 1));

			dbg("We were ordered to grab some TLDs and this is what we got");
			dbg($tlds);

			$output = array_merge($output, array("tlds" => array("tld" => $tlds)));
		}

		dbg("#########################################\n########### FINAL OUTPUT #####################\n#########################################");
		dbg($output);

		$this->writeOutput( $output );

		return true;
	}

	function addErrorTemplates() {
		$this->writeOutput(array());
	}

	function writeOutput( $apiContent ) {

		$headers = array(
			"app" => "action-api",
			"success" => 1,
			"timestamp" => time());

		foreach( (array)$this->getErrors() as $err ) {
			$headers['success'] = 0;
			$headers['errorCount']++;
			$headers['errors']['error'][] = array();
			$headers['errors']['error'][ count($headers['errors']['error'])-1 ]['title'] = $err[0];
			$headers['errors']['error'][ count($headers['errors']['error'])-1 ]['message'] = $err[1];
		}	unset($err);

		mbHeader("Content-Type: text/xml; charset: UTF-8");
		echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";

		echo toXML(array("api" => array("header" => $headers,"results"=>$apiContent) ));

		exit;
	}

	protected $restrictAction = 0;
}
