<?php

require_once("lib-action/AccountingReportAction.php");

class ShowGeneralJournal extends AccountingReportAction
{
	public function __construct()
	{
		parent::__construct();

		$this->params = array(
            "generalJournalID",
            "generalDescription",
            "currencyID",

            // generalDebitAmount options
            "generalDebitAmount",
            "generalDebitAmountLessThan",
            "generalDebitAmountGreaterThan",

            // generalCreditAmount options
            "generalCreditAmount",
            "generalCreditAmountLessThan",
            "generalCreditAmountGreaterThan",

            // generalDateCreated options
            "generalDateCreated",
            "generalDateCreatedLessThan",
            "generalDateCreatedGreaterThan",
        );

        // handle date searches and correct mismatch of amount labels
        $this->setupDateRequestArgs();

        // handle amount searches and correct mismatch of amount labels
        $this->setupAmountRequestArgs();

        // search in a specific column
        if ($_REQUEST["queryColumn"]!=""){
            if ($_REQUEST["query"]!="") {
                $_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
            }
        } else if ($_REQUEST["query"]!="") {
            $_REQUEST["generalDescription"] = $_REQUEST["query"];
        }

        $this->sortColumns = array(
            "generalJournalID",
            "generalDateCreated",
            "generalDescription",
            "generalDebitAmount",
            "generalCreditAmount",
            "currencyID"
        );
	}

	public function execute()
	{
		parent::execute();

		$query = $this->getMBAPIQuery("GetAccountingGeneralJournal", "",  array(), 1, 1, 1, 1);
		$data = dispatchMBAPI($query, 1);
		$results =& $data["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($data) === 0) {
			// set master invoices data array
			$this->smartyVars["entries"] = collapseArrayElements(protectArray($results["journalEntries"][0]["entry"]));

			$this->smartyVars["paginationLinks"] = collapseArrayElements($results["paginationLinks"][0]);

			$this->smartyVars['tabs'] = $this->getTabs("generalJournal");

			$this->addTemplate("accounting/ShowGeneralJournal");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
    }
}