<?php

require_once("lib-action/AccountingReportAction.php");

class ShowLedgerAccounts extends AccountingReportAction
{
	public function __construct()
	{
		parent::__construct();

		$this->params = array("ledgerAccountNumber");

		// if we are searching for any possible match, set VALID params now
		if ($_REQUEST["query"]!="") {
			// test if the searching for a specific column
			if ($_REQUEST["queryColumn"]!="") {
				$_REQUEST[$_REQUEST["queryColumn"]] = $_REQUEST["query"];
			} else {
				// test if query is an int, if yes, assume we are searching for the ID
				if (((int) $_REQUEST["query"])) {
					$_REQUEST["clientID"] = $_REQUEST["query"];
				} else {
					// if not an int, then search all other non-ID columns
					foreach($this->params as $value) {
						if ($value!="clientID") {
							$_REQUEST[$value] = $_REQUEST["query"];
						}
					}
				}
			}
		}

		$this->sortColumns = array("ledgerAccountNumber");
	}

	public function execute()
	{
		parent::execute();

		global $CONF;
		$this->smartyVars["accountTypes"] = $CONF["ledgerCategories"];

		$query = $this->getMBAPIQuery("GetAccountingLedgerAccounts");
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {
			$this->smartyVars["ledgerAccounts"] = collapseArrayElements($results["ledger_accounts"][0]["account"]);
			if($data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
				$this->smartyVars["ledgerAccounts"] = array(0 => collapseArrayElements($results["ledger_accounts"][0]["account"]));
			}
			$this->smartyVars['tabs'] = $this->getTabs("ledgerAccounts");
			$this->addTemplate("accounting/ShowLedgerAccounts");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}