<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");
require_once("objects/Admin.php");

class AddAdminResponse extends AddResponseAction
{
	public function __construct()
	{
		parent::AddResponseAction();
		$this->stringRep = "AddAdminResponse";
		$this->setDataSource(new DataSource("admins"));
		$this->params[] = "adminGroups";
	}

	public function addResponseValidationHandler()
	{
		$this->validateParam("adminGroups", 0);
		return true;
	}

	public function overrideValidateColumnParamType($column, $columnType, $mode, $paramType, $isRequired)
	{
		switch($column)
		{
			case "adminPassword":
				$paramType |= INPUT_RESTRICTION_PASSWORD|INPUT_RESTRICTION_REQUIRED;
				$args = array();
				break;
		}
        return array($paramType, $isRequired, $args);
	}


	public function addResponseParamHandler()
	{
        $adminID = (int) $_REQUEST["adminID"];

		$currentAdminGroupIDs = array();
		$selectedAdminGroupIDs = isset($_REQUEST["adminGroups"]) && is_array($_REQUEST["adminGroups"]) ? $_REQUEST["adminGroups"] : array();
		$params = $this->getRelationParams($selectedAdminGroupIDs, $currentAdminGroupIDs, "adminGroupIDs", "adminGroupID");

		$params["skinID"] = bgpc("skinID");
		$this->d->mergeParams($params);

		return true;
	}
}

?>
