<?php

require_once("lib-action/genericactions.php");

class EditAdminResponse extends EditResponseAction
{
	public function __construct()
	{
		parent::EditResponseAction();
		$this->stringRep = "EditAdminResponse";
		$this->setDataSource(new DataSource("admins"));

		if ($this->doUpdateGroups = bgpc("updateGroups", false))
			$this->params[] = "adminGroup";
	}

	public function execute()
	{
		if (!Billing\validate_forgery_protection_token()) {
			redirect("admins.php", "ShowAdminDetails", array("adminID" => bgpc("adminID")));
		}
		parent::execute();
	}

	public function editResponseValidationHandler()
	{
		if ($this->doUpdateGroups)
			$this->validateParam("adminGroups", 0, true);

		return true;
	}

	public function editResponseParamHandler()
	{
		global $CONF;
		$this->admin_id = bgpc("adminID");

		$q = new MBQuery("GetAdmins", "", array("adminID" => $this->admin_id, "getAdminGroupData" => 1));
		if(!$this->addErrorsFromResult($r =& $q->getResult())) return false;

		if(!empty($_REQUEST["updateGroups"])) {
			$adminGroupTable = $r->getTableFrom(array("mbapi", "results", "admins", "admin", "adminGroupIDs"));
			$currentAdminGroupIDs = $adminGroupTable->getColumnDistinct("adminGroupID");
			$selectedAdminGroupIDs = isset($_REQUEST["adminGroups"]) && is_array($_REQUEST["adminGroups"]) ? $_REQUEST["adminGroups"] : array();
			$params = $this->getRelationParams($selectedAdminGroupIDs, $currentAdminGroupIDs, "adminGroupIDs", "adminGroupID");
		}

		require_once("objects/Admin.php");
		if (Factory()->Admin($this->admin_id)->admin_username == Admin::MASTER_USERNAME)
			$params["adminUsername"] = Admin::MASTER_USERNAME;

		$params["skinID"] = bgpc("skinID");
		$this->d->mergeParams($params);

		return true;
	}

	public function redirect()
	{
		if (0 < count($generic_errors = $this->d->getErrors()))
		{
			$this->errors = array();
			foreach ($generic_errors as $err_msg)
				$this->errors[] = array(blmsg("TRANS_ERROR"), $err_msg);
			$this->addErrorTemplates();
			exit;
		}
		$this->postModify();

		parent::redirect();
	}

	private function postModify()
	{
		// only update the accessHash if set
		if (NULL != bgpc("accessHash"))
		{
			require_once("object_managers/AdminManager.php");
			AdminManager::update(Factory()->Admin($this->admin_id), true);
		}
	}

	private $doUpdateGroups = false;
	private $admin_id;
}
