<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");

class EditMyProfileResponse extends EditResponseAction
{
	public function EditMyProfileResponse()
	{
		global $CONF;
		parent::__construct();

		$this->setDataSource(new DataSource("admins"));

		$description = $this->d->getDescription();
		$description["names"]["singular"] = "MyProfile";
		$description["display"]["detailsAction"] = "EditMyProfile";
		$description["display"]["editTemplate"] = "admins/EditMyProfile";
		$this->d->setDescription($description);

		$_REQUEST["adminID"] = $CONF["user"]["id"];
	}

	public function editResponseParamHandler()
	{
        // only update the accessHash if set
		$params = array();
		if(!empty($_REQUEST["accessHash"])) {
			$params["adminRemoteAccessHash"] = sha1(microtime(1) + mt_rand(1,1000000000));
		}

		require_once("objects/Admin.php");
		$oldAdminData = Factory()->Admin(bgpc("adminID"));
		if ($oldAdminData->admin_username == Admin::MASTER_USERNAME)
			$params["adminUsername"] = Admin::MASTER_USERNAME;

		$params["skinID"] = bgpc("skinID");
		$this->d->mergeParams($params);

		return true;
	}

	public function redirect()
	{
		if (0 < count($generic_errors = $this->d->getErrors()))
		{
			$this->errors = array();
			foreach ($generic_errors as $err_msg)
				$this->errors[] = array(blmsg("TRANS_ERROR"), $err_msg);
			$this->addErrorTemplates();
			exit;
		}
		parent::redirect();
	}
}
