<?php

require_once("lib-action/action.php");

class RemoveAdminGroupResponse extends MB_Action
{
	public $params = array("adminGroupID");

	public function execute()
	{
		parent::execute();

		$adminGroupID = ((int) $_REQUEST["adminGroupID"]);
		if(!$adminGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No AdminGroup ID given.");
		} else {
			if (!Billing\validate_forgery_protection_token()) {
				redirect("admins.php", "RemoveAdminGroup", array("adminGroupID" => bgpc("adminGroupID")));
			}
			$query = $this->getMBAPIQuery("SetAdminGroups", "delete");
			require_once("lib-mbapi/mbapi.php");
			$data = dispatchMBAPI($query, 1);
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if(!redirect("admins.php",getActionID("ShowAdminGroups"))) {
					$this->addError(TRANS_ACTIONERROR, "Failed to redirect to adminGroup detail.");
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}