<?php

require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/toolkit.php");
use Billing\Skin;

class ShowAdminDetails extends MB_Action
{
	public $params = array("adminID");

	public function execute()
	{
		parent::execute();

 		do {
			if($this->err($adminID = getParam("adminID"), "No admin ID given.")) break;
			//echo '<pre>';

			$adminQuery = new MBQuery(
				"GetAdmins", "",
				array(
					"adminID" => $adminID,
					"getAdminGroupData" => 1,
					"getBookmarkData" => 1,
					"getAllHelpdeskDepartmentData" => 1,
					"getHelpdeskBucketData" => 1,
					"getAssignedTicketData" => 1,
					"getTransferredTicketData" => 1,
				)
			);
			if(!$this->addErrorsFromResult($adminResult =& $adminQuery->getResult())) break;
			$adminTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin"),
				"adminID", "adminName"
			);
			$this->smartyVars['admin'] = $adminTable->getOne();

			$adminGroupTable =& $adminResult->getTableFrom(array("mbapi", "results", "admins", "admin", "adminGroupIDs"));
			$adminGroups = $adminGroupTable->getTable();
			$this->smartyVars['adminGroups'] = $adminGroups;

			$bkQuery = new MBQuery("GetBookmarks", "", array("adminID" => $adminID, "sortDir" => "desc"));
			$bkData = $bkQuery->GetResult();

			if (!$bkData->getErrorCount()) {
				$this->smartyVars["bookmarkList"] = grabSimpleMBAPIResults( $bkData->getStructure() );
			}

			$this->smartyVars["bookmarkTargets"] = array(
							"_self" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
							"_top" => TRANS_LOAD_BOOKMARK_MAIN_PAGE,
							"_blank" => TRANS_LOAD_BOOKMARK_NEW_PAGE);
			unset( $bkData, $bkQuery );

			$helpdeskDepartmentTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskDepartments", "helpdeskDepartment"),
				"hdDepartmentID", "hdDepartmentName"
			);
			$this->smartyVars['helpdeskDepartments'] = $helpdeskDepartmentTable->getTable();

			$helpdeskBucketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskBuckets", "helpdeskBucket"),
				"hdBucketID", "hdBucketName"
			);
			$this->smartyVars['helpdeskBuckets'] = $helpdeskBucketTable->getTable();

			$helpdeskAssignedTicketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskAssignedTickets", "helpdeskAssignedTicket"),
				"hdTicketID", "hdTicketSubject"
			);
			$this->smartyVars['helpdeskAssignedTickets'] = $helpdeskAssignedTicketTable->getTable();

			$helpdeskTransferredTicketTable =& $adminResult->getTableFrom(
				array("mbapi", "results", "admins", "admin", "helpdeskTransferredTickets", "helpdeskTransferredTickets"),
				"hdTicketID", "hdTicketSubject"
			);
			$this->smartyVars['helpdeskTransferredTickets'] = $helpdeskTransferredTicketTable->getTable();

			$this->smartyVars["saved"] = (int) $_REQUEST["saved"];

			require_once("Skin.php");
			$this->smartyVars["skinList"] = Skin::getSkins();

			$this->mergeSystemNavData();
			$this->mergeCountryData();
			$this->mergeLanguageData();
			$this->mergeThemeData();

			if ("" == $this->smartyVars["admin"]["skinID"])
				$this->smartyVars["admin"]["skinID"] = Skin::DEFAULT_SKIN_ID;

			$admin = Factory()->Admin($adminID);

			require_once("object_managers/SecurityManager.php");
			SecurityManager::pushCurrentActionIntoLog(
				SecurityManager::USER_TYPE_ADMIN,
				$adminID,
				$admin->admin_username,
				"TRANS_ACTION_LOG_REASON_SHOW_USER_DETAILS",
				blmsg("TRANS_ACTION_LOG_COMMENT_ADMIN", array("ADMIN_ID" => $adminID), SecurityManager::getActionLogLocale())
			);

			if ($admin->isSyncable() && !is_null($admin->sync_error)) {
				$this->smartyVars["errorMessages"][] = blmsg("TRANS_SYNC_THIS_ADMIN_ERROR_MSG", array("ERROR" => nl2br(billing_safetyhtml($admin->sync_error))));
			}

			$this->addTemplate("admins/ShowAdminDetails", $this->smartyVars, 1);

		} while(false);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
