<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowAdmins extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (1 == bgpc("sync")) {
			$this->processSync();
		}

		$tools_panel = UIFactory()->ToolsPanel(blmsg("TRANS_TOOLS"));

		// Tools Area Buttons
		$tools_panel->addButton(UIFactory()->ToolButton("new-admin", blmsg("TRANS_ADD_ADMIN"), action_url("admins", "AddAdmin")));
		$tools_panel->addButton(UIFactory()->ToolButton("manage-admin-groups", blmsg("TRANS_MANAGE_ADMIN_GROUPS"), action_url("admins", "ShowAdminGroups")));

		$page = UIFactory()->Page();
		$page->addToolsPanel($tools_panel);
		$page->title = blmsg("TRANS_ADMINS");
		$page->parent_title = blmsg("TRANS_MANAGE_SYSTEM");
		$page->parent_url = admin_action_url("configs", "system", "show");

		require_once("UI/List/UIAdminList.php");
		$page->addListPanel(new UIAdminList());

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}

	private function processSync()
	{
		$adminIDs = bgpc("id", array());
		if (empty($adminIDs)) {
			return;
		}
		$errors = array();
		foreach ($adminIDs as $adminID) {
			try {
				$admin = Factory()->Admin($adminID);
				$admin->sync_tasks |= Admin::SYNC_NEED_REPAIR_SSO;
				require_once("object_managers/AdminManager.php");
				AdminManager::sync($admin);
				if (!is_null($admin->sync_error)) {
					$errors[] = blmsg("TRANS_SYNC_ADMIN_ERROR_MSG", array("ADMIN_ID" => $admin->id, "ERROR" => $admin->sync_error));
				}
			} catch (ProductException $e) {
				$errors[] = blmsg("TRANS_SYNC_ADMIN_ERROR_MSG", array("ADMIN_ID" => $adminID, "ERROR" => $e->getMessage()));
			}
		}
		if (empty($errors)) {
			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_ADMINS_SUCCESS_MSG");
		} else {
			getCurrentSession()->Storage->errorMessages[] = blmsg(
				"TRANS_SYNC_ADMINS_FAILURE_MSG",
				array("ERROR" => billing_safetyhtml(implode("\n", $errors)))
			);
		}
	}
}
