<?php
require_once("lib-action/action.php");
require_once("UI/Page/UIBatchFileConfirmationPage.php");

class CompleteBatchFileConfirmationPage extends UIBatchFileConfirmationPage
{
	protected function executeAction($id)
	{
		require_once("object_managers/BatchFileManager.php");
		BatchFileManager::completeBatchFile($id);
	}
}

class CompleteBatchFile extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_COMPLETE_BATCH_FILE"),
			"list_title" => blmsg("TRANS_APPROVE"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_COMPLETION"), "confirm_check" => blmsg("TRANS_CONFIRM_COMPLETION_MESSAGE")),
			"error_title" => blmsg("TRANS_APPROVED"),
			"successfully_processed_list_title" => blmsg("TRANS_BATCH_FILES_SUCCESSFULLY_COMPLETED_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_BATCH_FILES_EMPTY_COMPLETED_LIST_TITLE"),
		);

		$back_url = action_url("batchfiles", "ShowBatchFiles");
		$controller  = UIFactory()->PageController($back_url);
		$page = $controller->addPage(new CompleteBatchFileConfirmationPage( $controller, $confirmation_page_strings ));
		$page->parent_title = blmsg("TRANS_BATCH_FILES_MANAGER");
		$page->parent_url = $back_url;
		$controller->setValue("id", bgpc("id"));
		$controller->processRequest();
		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");

		return $this->hasExecutedSuccessfully();
	}
}