<?php
require_once("lib-action/action.php");
require_once("UI/Page/UIBatchFileTransactionsConfirmationPage.php");

class CompleteBatchFileTransactionsConfirmationPage extends UIBatchFileTransactionsConfirmationPage
{
	protected function executeAction($id)
	{
		require_once("object_managers/BatchFileTransactionManager.php");
		BatchFileTransactionManager::completeBatchFileTransaction($id);
	}
}

class CompleteBatchFileTransactions extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_COMPLETE_BATCH_FILE_TRANSACTIONS"),
			"list_title" => blmsg("TRANS_APPROVE"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_COMPLETION"), "confirm_check" => blmsg("TRANS_CONFIRM_COMPLETION_MESSAGE")),
			"error_title" => blmsg("TRANS_APPROVED"),
			"successfully_processed_list_title" => blmsg("TRANS_BATCH_FILE_TRANSACTIONS_SUCCESSFULLY_COMPLETED_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_BATCH_FILE_TRANSACTIONS_EMPTY_COMPLETED_LIST_TITLE"),
		);

		$back_url = bgpc("back_url");
		$parent_url = action_url("batchfiles", "ShowBatchFilesTransactions");
		$back_url = is_null($back_url) ? $parent_url : $back_url;
		$controller  = UIFactory()->PageController($back_url);
		$page = $controller->addPage(new CompleteBatchFileTransactionsConfirmationPage( $controller, $confirmation_page_strings ));
		$page->parent_title = blmsg("TRANS_BATCH_FILE_TRANSACTIONS");
		$page->parent_url = $parent_url;
		$controller->setValue("id", bgpc("id"));
		$controller->processRequest();
		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");

		return $this->hasExecutedSuccessfully();
	}
}