<?php
require_once("lib-action/action.php");

class ShowBatchFileDetails extends MB_Action
{

	public function execute()
	{
		parent::execute();

		if ( is_null($batch_file_id = bgpc("id")) )
			throw new Exception("Missing parameter 'id'");

		$page  = UIFactory()->Page();
		
		$batch_file = Factory()->BatchFile($batch_file_id);
		$has_transactions_assigned = 0 < count($batch_file->BatchFileTransactionList());

		$tools_panel = UIFactory()->ToolsPanel(blmsg("TRANS_TOOLS"));

		$has_buttons = false;
		switch ($batch_file->batch_file_status)
		{
			case BatchFile::STATUS_IN_PROGRESS:
				$tools_panel->addButton(UIFactory()->ToolButton(
					"cancel-batchfile",
					blmsg("TRANS_CANCEL_BATCHPROCESSING"),
					action_url("batchfiles", "CancelBatchFile", array("id" => $batch_file_id))
				));
				$has_buttons = true;
				break;
			case BatchFile::STATUS_OPEN:
				if (! $has_transactions_assigned)
					break;
				$tools_panel->addButton(UIFactory()->ToolButton(
					"process-batchfile",
					blmsg("TRANS_PROCESS"),
					action_url("batchfiles", "ProcessBatchFile", array("id" => $batch_file_id))
				));
				$has_buttons = true;
				break;
			default:
				$has_buttons = false;
		}
		if ($has_buttons)
			$page->addToolsPanel($tools_panel);

		$page->title = blmsg("TRANS_BATCH_FILE")." #{$batch_file->batch_file_id}";
		if (!is_null($batch_file->batch_file_name))
			$page->title .= " '{$batch_file->batch_file_name}'";
		$page->parent_title = blmsg("TRANS_BATCH_FILES_MANAGER");
		$page->parent_url = action_url("batchfiles", "ShowBatchFiles");

		require_once("UI/List/UIBatchFileTransactionList.php");
		$page->addListPanel( new UIBatchFileTransactionList($batch_file_id, $batch_file->batch_file_status) );

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}
