<?php

require_once("lib-action/action.php");

class ShowBatchFilesTransactions extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$page  = UIFactory()->Page();
		require_once("UI/Tabs/UIBatchFilesScreenTabs.php");
		$batch_files_tabs = new UIBatchFilesScreenTabs();
		$batch_files_tabs->setCurrent("transactions");
		$page->setScreenTabs($batch_files_tabs);

		$stat_panel = UIFactory()->InputPanel(blmsg("TRANS_AMOUNT_TRANSACTION_BY_STATUS"));
		$statuses_stats = $this->getTransactionStatusesStat();
		foreach ( $statuses_stats as $status_stats )
		{
			$input_label = UIFactory()->InputLabel();
			$input_label->title = $status_stats["title"];
			$input_label->value = $status_stats["value"];
			$stat_panel->addInputControl($input_label);
		}
		$page->addInputPanel($stat_panel);

		$page->title = blmsg("TRANS_TRANSACTIONS");
		$page->parent_title = blmsg("TRANS_BATCH_FILES_MANAGER");
		$page->parent_url = action_url("batchfiles", "ShowBatchFiles");

		require_once("UI/List/UIBatchFileTransactionList.php");
		$page->addListPanel(new UIBatchFileTransactionList());

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}

	private function getTransactionStatusesStat()
	{
		$statuses_stats = array();
		require_once ("objects/BatchFileTransaction.php");
		foreach (BatchFileTransaction::statuses() as $key => $status)
		{
			$statuses_stats[$key]["value"] = $this->getTransactionStatusStat($key)." ".blmsg("TRANS_CURRENCY_EUR");
			$statuses_stats[$key]["title"] = blmsg($status);
		}
		return $statuses_stats;
	}

	private function getTransactionStatusStat($key)
	{
		$query = "SELECT SUM(tl.transaction_amount) AS transaction_amount
				  	FROM batch_file_transactions AS bft
				  		 INNER JOIN transaction_log AS tl ON ( tl.transaction_id = bft.transaction_id )
				   WHERE bft.batch_file_transaction_status = ".DatabaseManager::getConnection()->quote($key);
		return floatval(DatabaseManager::getConnection()->getOne($query));
	}
}
