<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");
require_once("objects/ClientBillingAccount.php");

class AddBillingAccountResponse extends MB_Action
{
	public $params = array(
			"clientID",
			"clientContactID",
			// account
			"billingAccountType",
			"billingAccountOrder",
			"billingAccountPercent",
			"billingAccountPercentEqual",
			// card account
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardIssueNum",
			"billingCardStartDate",
			// bank account
			"billingBankType",
			"billingBankName",
			"billingBankState",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankDob",
	);

	public function execute()
	{
		global $CONF;
		parent::execute();

		require_once("object_managers/CryptManager.php");
		if (CryptManager::MODE_PASSPHRASE == CryptManager::getEncryptionMode()) {
			CryptManager::setKey(bgpc("encKey"));
		} else if (CryptManager::MODE_LEK == CryptManager::getEncryptionMode()) {
			CryptManager::setDefaultKey();
		}

		$this->setReferralActionID(getActionID("AddBillingAccount"));
		$this->setReferralActionFile("clients.php");

		// save for later
		//$billingAccountPercentEqual = (int) $_REQUEST["billingAccountPercentEqual"];
		$billingAccountType = (int) $_REQUEST["billingAccountType"];
		$edit = array();
		$additional_validation_fields = array();

		$success_validation = true;

		require_once "objects/ClientBillingAccount.php";
		if (ClientBillingAccount::TYPE_MANUAL_PAYMENT == $billingAccountType || ClientBillingAccount::TYPE_THIRD_PARTY_GATEWAY == $billingAccountType) {
			unset($_REQUEST['billingBankType']);
			unset($_REQUEST['billingBankName']);
			unset($_REQUEST['billingBankState']);
			unset($_REQUEST['billingBankABACode']);
			unset($_REQUEST['billingBankAccountNum']);
			unset($_REQUEST['billingBankLicenseNum']);
			unset($_REQUEST['billingBankLicenseState']);
			unset($_REQUEST['billingBankDob']);

			unset($_REQUEST['billingCardNameOnCard']);
			unset($_REQUEST['billingCardType']);
			unset($_REQUEST['billingCardNum']);
			unset($_REQUEST['billingCardExpMonth']);
			unset($_REQUEST['billingCardExpYear']);
			unset($_REQUEST['billingCardIssueNum']);
			unset($_REQUEST['billingCardStartDate']);
			$edit = array(
				"clientID",
				"clientContactID",
				"billingAccountID",
			);
		} else if (ClientBillingAccount::TYPE_CREDIT_CARD == $billingAccountType) {
			unset($_REQUEST['billingBankType']);
			unset($_REQUEST['billingBankName']);
			unset($_REQUEST['billingBankState']);
			unset($_REQUEST['billingBankABACode']);
			unset($_REQUEST['billingBankAccountNum']);
			unset($_REQUEST['billingBankLicenseNum']);
			unset($_REQUEST['billingBankLicenseState']);
			unset($_REQUEST['billingBankDob']);
			$edit = array(
				"clientID",
				"clientContactID",
				// account
				"billingAccountType",
				"billingAccountOrder",
				"billingAccountPercent",
				// card account
				"billingCardNameOnCard",
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
			);
			$billingCardType = (int) $_REQUEST["billingCardType"];
			$cardExtraTypes = $CONF["types"]["cardExtraIDs"];
			if(in_array($billingCardType, $cardExtraTypes)) {
				$edit = array_merge(
					$edit,
					array(
						"billingCardIssueNum",
						"billingCardStartDate",
					)
				);
			} else {
				unset($_REQUEST['billingCardIssueNum']);
				unset($_REQUEST['billingCardStartDate']);
			}
		} else if (ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER == $billingAccountType) {
			require_once("ModuleTool.php");
			$gateway_id = bgpc("selected_ddbp_gateway_id");
			$plugin = ModuleTool::getModuleInstance("gateway", "HSPCBankTransfer", array("gateway_id" => $gateway_id));
			$billing_account = !is_null($billingAccountID = bgpc("billingAccountID")) ?
				Factory()->ClientBillingAccount($billingAccountID) : Factory()->ClientBillingAccount();
			$billing_account->payment_gateway_id = $gateway_id;
			$adapter = $plugin->getPaymentMethodAdapter($billing_account);
			$adapter->collectInputFields("_{$gateway_id}");
			$adapter_input_fields = $adapter->getInputFields();
			$edit = array(
				"clientID",
				"clientContactID",
				"billingAccountType",
			);
			foreach (array_keys($adapter_input_fields) as $field_name) {
				$additional_validation_fields[$field = "{$field_name}_{$gateway_id}"] = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
				$edit[] = $field;
			}
			$adapter_validation = $adapter->validate();
			if (HSPC_PM_Adapter::VALIDATION_OK != $adapter_validation) {
				$success_validation = false;
				billing_put_error($adapter_validation);
			}
		}else {
			unset($_REQUEST['billingCardNameOnCard']);
			unset($_REQUEST['billingCardType']);
			unset($_REQUEST['billingCardNum']);
			unset($_REQUEST['billingCardExpMonth']);
			unset($_REQUEST['billingCardExpYear']);
			unset($_REQUEST['billingCardIssueNum']);
			unset($_REQUEST['billingCardStartDate']);
			$edit = array(
				"clientID",
				"clientContactID",
				// account
				"billingAccountType",
				"billingAccountOrder",
				"billingAccountPercent",
				// bank account
				"billingBankType",
				"billingBankName",
				"billingBankState",
				"billingBankAbaCode",
				"billingBankAccountNum",
				"billingBankLicenseNum",
				"billingBankLicenseState",
				"billingBankDob",
			);
		}

		$success_validation = $this->validateMultiInputs(
			array_merge(array(
				"clientID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
				"clientContactID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
				// account
				"billingAccountType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingAccountOrder" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingAccountPercent" => INPUT_RESTRICTION_DOUBLE|INPUT_RESTRICTION_REQUIRED,
				"billingAccountPercentEqual" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				// card account
				"billingCardNameOnCard" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingCardType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingCardNum" => array(
					INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD,
					array(
						'maxLength' => 19,
						'minLength' => 13,
						'allowedCardTypes' => array(getAPITypeName("card", $_REQUEST['billingCardType'])),
					),
				),
				"billingCardExpMonth" => INPUT_RESTRICTION_MONTH|INPUT_RESTRICTION_REQUIRED,
				"billingCardExpYear" => INPUT_RESTRICTION_YEAR|INPUT_RESTRICTION_REQUIRED,
				"billingCardIssueNum" => INPUT_RESTRICTION_STRING,
				"billingCardStartDate" => INPUT_RESTRICTION_STRING,
				// bank account
				"billingBankType" => INPUT_RESTRICTION_UNSIGNED_INT,
				"billingBankName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"billingBankState" => INPUT_RESTRICTION_STRING,
				"billingBankAbaCode" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingBankAccountNum" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"billingBankLicenseNum" => INPUT_RESTRICTION_STRING,
				"billingBankLicenseState" => INPUT_RESTRICTION_STRING,
				"billingBankDob" => INPUT_RESTRICTION_STRING,
				"comboAction" => INPUT_RESTRICTION_STRING,
			), $additional_validation_fields),
			array(
				// secure params
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
				"billingCardIssueNum",
				"billingCardStartDate",
				"billingBankAccountNum",
				// perhaps more bank data should be stripped as well
			),
			$edit,
			NULL,
			array("selected_ddbp_gateway_id" => bgpc("selected_ddbp_gateway_id"))
		) && $success_validation;

		if (! $success_validation) {
			$args = array();
			if (ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER == $billingAccountType) {
				$args["selected_ddbp_gateway_id"] = $gateway_id;
			}
			$this->validationRedirect($args, array(), true); //Force redirect
			exit;
		}

		$clientID = (int) $_REQUEST["clientID"];
		$clientContactID = (int) $_REQUEST["clientContactID"];
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else if(!$clientContactID) {
			$this->addError(TRANS_ACTIONERROR, "No client contact ID given.");
		} else {

			// set all possible xml params here, $_REQUEST is already cleaned
			$params = array
			(
				// account
				"billingAccountType",
				"billingAccountOrder",
				"billingAccountPercent",
				// card account
				"billingCardNameOnCard",
				"billingCardType",
				"billingCardNum",
				"billingCardExpMonth",
				"billingCardExpYear",
				"billingCardIssueNum",
				"billingCardStartDate",
				// bank account
				"billingBankType",
				"billingBankName",
				"billingBankState",
				"billingBankAbaCode",
				"billingBankAccountNum",
				"billingBankLicenseNum",
				"billingBankLicenseState",
				"billingBankDob",
			);
			$xmlParams = "";
			foreach ($params as $paramName) {
				if (isset($_REQUEST["$paramName"]) && $_REQUEST["$paramName"]!='') {

					// set xml paramValue
					$xmlParams = $xmlParams."<$paramName>".utf8_xml_entity_encode(bgpc($paramName))."</$paramName>\n";
				}
			}

			// create sanatized xml command
			$cmd = "
			<mbapi>
				<command>SetClients</command>
				<subCommand>update</subCommand>
				<params>
					<clientID>$clientID</clientID>
					<clientContacts>
						<clientContact>
							<clientContactID>$clientContactID</clientContactID>
							<clientBillingAccounts>
								<clientBillingAccount>
									".(("" != ($encKey = bgpc("encKey"))) ? "<encKey>".utf8_xml_entity_encode($encKey)."</encKey>" : "")."
									$xmlParams
								</clientBillingAccount>
							</clientBillingAccounts>
						</clientContact>
					</clientContacts>
				</params>
			</mbapi>
			";

			dbg($cmd);

			$data = dispatchMBAPI($cmd, 1);
			$results =& $data["mbapi"][0]["results"][0];

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				if (bgpc("billingAccountType") == ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER) {
					$billingAccountID = $results["newClientBillingAccounts"][0]["clientBillingAccountID"][0];

					require_once("ModuleTool.php");
					$gateway_id = bgpc("selected_ddbp_gateway_id");
					$plugin = ModuleTool::getModuleInstance("gateway", "HSPCBankTransfer", array("gateway_id" => $gateway_id));

					$billing_account = Factory()->ClientBillingAccount($billingAccountID);
					$billing_account->payment_gateway_id = $gateway_id;
					$billing_account->client_contact_id = bgpc("clientContactID");
					$billing_account->billing_account_type = bgpc("billingAccountType");

					$adapter = $plugin->getPaymentMethodAdapter($billing_account);
					$adapter->collectInputFields("_{$gateway_id}");
					$adapter->save();
				}

				// because the SetClients mbapi command doesn't return the ID
				// of the new billing account we have to get it here by selecting
				// the last billing account added for this contact.
				if (($billingAccounts = arrayFor(":billingAccounts", array(
					"clientContactID" => $clientContactID,
					"sortColumn" => "billingAccountID",
					"sortDir" => "DESC",
				))) && (int)$_REQUEST['defaultBillingAccount']){
					updateForKey(":clientsGeneric", $clientID, array(
						"defaultBillingAccountID" => $billingAccounts[0]['billingAccountID'],
					));
				}

				// If this billing account was added as part of a combo action,
				// fetch its id, then update the client's default billing account with it!
				if ($_REQUEST["comboAction"] == "AddNewClient") {
					$clientData = grabResultsFromMBAPIArray(array(
						"mbapi" => array(
							"command" => "GetClients",
							"params" => array(
								"clientID" => $clientID,
								"mergePrimaryContact" => 1,
								"clientContactID" => $clientContactID,
								"getBillingData" => 3
							),
						),
					));
					$billingAccountID = $clientData[0]["billingAccounts"][0]["billingAccount"][0]["billingAccountID"];
					updateForKey("clients",$clientID,array("defaultBillingAccountID"=>$billingAccountID));
				}

				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect("clients.php", getActionID("ShowBillingAccounts"), array("clientID"=>$clientID, "clientContactID"=>$clientContactID));
				}
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
}
