<?php
require_once("lib-action/action.php");
use Billing\Skin;

class AddClient extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$this->smartyVars["paymentList"] = $CONF["types"]["payments"];
		$this->smartyVars["statusList"] = getStatuses("client");
		$this->mergeLanguageData($CONF["user"]["locale"]->language);
		$this->mergeCountryData();
		$this->smartyVars["emailActions"] = blmsg_array($CONF["types"]["emailAction"]);
		require_once("objects/Client.php");
		foreach (Client::types() as $key => $type) {
			$this->smartyVars["clientTypes"][$key] = blmsg($type);
		}

		$this->mergeThemeData();

		$formDefaults = array(
			"clientActive" => 1,
			"countriesID" => $this->smartyVars["selectedCountry"],
			"languageID"  => $this->smartyVars["selectedLanguage"],
			"contactEmailFormat" => 1,
		);
		$this->smartyVars['attributeGroups'] =array();
		foreach (arrayFor("attributeGroups", array("groupActive"=>1)) as $grp){
			$this->smartyVars['attributeGroups'][$grp['groupID']] = $grp['groupName'];
		}


		$this->smartyVars["billingAccountTypes"] = $CONF["types"]["billingAccount"];
		unset($this->smartyVars["billingAccountTypes"][getAPITypeID("billingAccount", "hspcbanktransfer")]);
		$this->smartyVars["bankAccountTypes"] = $CONF["types"]["bankAccount"];
		$this->smartyVars["cardTypes"] = $CONF["types"]["card"];
		$this->smartyVars["cardExtraTypes"] = $CONF["types"]["cardExtraIDs"];

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["needKey"] = (CryptManager::isLekEnabled() ? 0 : 1);

		$this->mergeFormState($formDefaults);

		require_once("Skin.php");
		$this->smartyVars["skinList"] = Skin::getSkins();
		if (! isset($this->smartyVars["formValues"]["skinID"]))
			$this->smartyVars["formValues"]["skinID"] = Skin::DEFAULT_SKIN_ID;

        $this->smartyVars["billingSecureUrl"] = Config()->system_secureBaseUrl;
		$this->addTemplate("clients/AddClient", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}