<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");

class AddClientContact extends MB_Action
{
	public $params = array("clientID");

	public function execute()
	{
		global $CONF;
		parent::execute();

		if ( false === ($clientID = getParam("clientID")) ) {
			throw new Exception("Missing parameter 'clientID'");
		}

		$query = $this->getMBAPIQuery("GetClients", "", array("mergePrimaryContact" => 1));
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$this->mergeCountryData();
			$this->mergeLanguageData($CONF["user"]["locale"]->language);
			$this->smartyVars["client"] = correctArray($results["clients"][0]["client"][0]);

			require_once("lib-billing/include/config/internal/emailactions.php");
			$this->smartyVars["emailActions"] = blmsg_array($CONF["types"]["emailAction"]);
			$formDefaults = array(
				"clientID" => $clientID,
				"countriesID" => $this->smartyVars["client"]["countriesID"],
				"languageID" => $this->smartyVars["selectedLanguage"],
				"contactActive" => 1,
				"contactEmailFormat" => 1,
			);

			$this->mergeFormState($formDefaults);
			$this->addTemplate("clients/AddClientContact", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
