<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");

class AddClientContactResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();
		
		$this->setReferralActionID(getActionID("AddClientContact"));
		$this->setReferralActionFile("clients.php");
		
		$this->validateMultiInputs(array(
			"clientID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"contactFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactEmail" => array(INPUT_RESTRICTION_EMAIL|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_NOTINCOL, array("source" => "contacts", "col" => "contactEmail")),
			"contactEmailFormat" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			"contactCompany" => INPUT_RESTRICTION_STRING,
			"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactAddress2" => INPUT_RESTRICTION_STRING,
			"contactCity" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactZip" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"contactPhone1" => INPUT_RESTRICTION_PHONE|INPUT_RESTRICTION_REQUIRED,
			"contactPhone2" => INPUT_RESTRICTION_PHONE,
			"contactFax" => INPUT_RESTRICTION_PHONE,
			"contactMobilePhone" => INPUT_RESTRICTION_PHONE,
			"contactCounty" => INPUT_RESTRICTION_STRING,
			"emailActionIDs" => INPUT_RESTRICTION_ARRAY,
			"contactUseSpecifiedEmailRulesOnly" => INPUT_RESTRICTION_BOOL,
			"contactPassword" => array(INPUT_RESTRICTION_PASSWORD|INPUT_RESTRICTION_REQUIRED, array("confirm" => "contactPasswordConfirm")),
		));
		$contact = Factory()->ClientContact();
		$contact->contact_primary = 0;
		foreach ( ClientContact::$attrsDescriptor as $attr_name => $attr_desc ) {
			switch ($attr_name) {
				case "contact_primary":
					continue;
				case "contact_password":
					$plain_password = bgpc("contactPassword");
					$contact->contact_password = getPasswordHash($plain_password);
					continue;
				default:
					if ( false === ($param_name = getDBXMLCol($attr_name)) || is_null($param_value = bgpc($param_name)) ) {
						continue;
					}
					$contact->$attr_name = $param_value;
			}
		}
		if ( !is_null($emailActionIDs = bgpc("emailActionIDs")) ) {
			$contact->emailActionIDs = $emailActionIDs;
		}

		try {
			require_once("object_managers/ClientContactManager.php");
			ClientContactManager::update($contact, $plain_password);

			if ( "" != ($redirectURL = bgpc("redirectURL")) && "" != ($redirectAction = bgpc("redirectAction")) ) {
				redirect($redirectURL."?action=".getActionID($redirectAction)."&".bgpc("redirectArgs"));
			}
			redirect("clients.php", getActionID("ShowClientContacts"), array("clientID" => $contact->client_id));
		} catch ( ProductException $e ) {
			$this->addOperationErrors($e);
			$this->addErrorTemplates();
        }
		return $this->hasExecutedSuccessfully();
	}
}
