<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class AddClientResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();
		// XXX hack
		require_once("object_managers/CompanyManager.php");
		$_REQUEST['companyID'] = CompanyManager::getProviderCompany()->id;

		$validate = array(
			"clientCompany" => INPUT_RESTRICTION_STRING,
			"clientType" => INPUT_RESTRICTION_UNSIGNED_INT,
			"clientMailInvoices" => INPUT_RESTRICTION_BOOL,
			"clientBillingDay" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"applyTax" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			"taxIDNumber" => INPUT_RESTRICTION_STRING,
			"skinID" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"groupID" => INPUT_RESTRICTION_UNSIGNED_INT,
			"companyID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"clientStatus" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"clientActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			"contactFirstName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactLastName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactEmail" => array(INPUT_RESTRICTION_EMAIL|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_NOTINCOL, array("source" => "contacts", "col" => "contactEmail")),
			"contactEmailFormat" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			"contactCompany" => INPUT_RESTRICTION_STRING,
			"contactAddress1" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactAddress2" => INPUT_RESTRICTION_STRING,
			"contactCity" => array(INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN,array('minLength' => 2, 'maxLength' => 50)),
			"contactState" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
			"contactZip" => array(INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_MAXLEN,array('maxLength' => 10)),
			"countriesID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"languageID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			"contactPhone1" => INPUT_RESTRICTION_PHONE|INPUT_RESTRICTION_REQUIRED,
			"contactPhone2" => INPUT_RESTRICTION_PHONE,
			"contactFax" => INPUT_RESTRICTION_PHONE,
			"contactPrimary" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			"contactMobilePhone" => INPUT_RESTRICTION_PHONE,
			"contactCounty" => INPUT_RESTRICTION_STRING,
			"contactPassword" => array(INPUT_RESTRICTION_PASSWORD|INPUT_RESTRICTION_REQUIRED, array("confirm" => "contactPasswordConfirm")),
			"comboAction" => INPUT_RESTRICTION_STRING,
			"contactUseSpecifiedEmailRulesOnly" => INPUT_RESTRICTION_BOOL,
			"emailActionIDs" => INPUT_RESTRICTION_ARRAY,
			// account
			"billingAccountType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			// card account
		);

		$billingAccountType = bgpc("billingAccountType");
		switch ($billingAccountType)
		{
			case getAPITypeID("billingAccount", "card"):
				$validate["billingCardNameOnCard"] = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
				$validate["billingCardType"] = array(
					INPUT_RESTRICTION_INSET|INPUT_RESTRICTION_REQUIRED,
					array('set' => $CONF['types']['card'])
				);
				$validate["billingCardExpMonth"] = INPUT_RESTRICTION_MONTH|INPUT_RESTRICTION_REQUIRED;
				$validate["billingCardExpYear"] = INPUT_RESTRICTION_YEAR|INPUT_RESTRICTION_REQUIRED;
				$validate["billingCardNum"] = array(
					INPUT_RESTRICTION_INT|INPUT_RESTRICTION_MAXLEN|INPUT_RESTRICTION_MINLEN|INPUT_RESTRICTION_CARD|INPUT_RESTRICTION_REQUIRED,
					array(
						'maxLength' => 19,
						'minLength' => 13,
						'allowedCardTypes' => array(getAPITypeName("card", bgpc('billingCardType'))),
					),
				);
				break;
			case getAPITypeID("billingAccount", "echeck"):
			case getAPITypeID("billingAccount", "bank"):
			case getAPITypeID("billingAccount", "wire"):
				$validate["billingBankType"] = INPUT_RESTRICTION_UNSIGNED_INT;
				$validate["billingBankName"] = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
				$validate["billingBankState"] = INPUT_RESTRICTION_STRING;
				$validate["billingBankAbaCode"] = INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED;
				$validate["billingBankAccountNum"] = INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED;
				$validate["billingBankLicenseNum"] = INPUT_RESTRICTION_STRING;
				$validate["billingBankLicenseState"] = INPUT_RESTRICTION_STRING;
				$validate["billingBankDob"] = INPUT_RESTRICTION_STRING;
				break;
		}

		if (!is_null(bgpc("contactUsername"))) {
			if (false !== $this->validateParam("contactUsername", array(INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_NOTINCOL, array("source" => "contacts", "col" => "contactUsername"))))
			$this->validateParam("contactUsername", array(INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED|INPUT_RESTRICTION_NOTINCOL, array("source" => "admins", "col" => "adminUsername")));
			$validate["contactUsername"] = INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED;
		}

		$this->setReferralActionID(getActionID("AddClient"));
		$this->setReferralActionFile("clients.php");
		$this->validateMultiInputs($validate);

		unset($_REQUEST['contactPasswordConfirm']);

		$_REQUEST["clientDateCreated"] = microtime_float();
		$_REQUEST["contactDateCreated"] = mktime();

		$cmd = array(
			"mbapi" => array(
				"command" => "SetClients",
				"subCommand" => "insert",
				"params" => array(
					"clientContacts" => array(
						"clientContact" => array(
							"clientBillingAccounts" => array(
								"clientBillingAccount" => array(

								),
							),
						),
					),
				),
			),
		);
		foreach (array(
			"clientCompany",
			"clientType",
			"applyTax",
			"clientMailInvoices",
			"taxIDNumber",
			"countriesID",
			"skinID",
			"groupID",
			"companyID",
			"clientActive",
			"clientStatus",
			"clientDateCreated",
			// to be converted to extra params and stripped:
			"clientBillingDay",
		) as $paramName){
			if (isset($_REQUEST[$paramName]) && isset($validate[$paramName])){
				$cmd["mbapi"]["params"][$paramName] = bgpc($paramName);
			}
		}
		foreach (array(
			"contactFirstName",
			"contactLastName",
			"contactUsername",
			"contactPassword",
			"contactEmail",
			"contactEmailFormat",
			"contactCompany",
			"contactAddress1",
			"contactAddress2",
			"contactCity",
			"contactState",
			"contactZip",
			"countriesID",
			"languageID",
			"contactPhone1",
			"contactPhone2",
			"contactFax",
			"contactPrimary",
			"contactMobilePhone",
			"contactCounty",
			"contactUseSpecifiedEmailRulesOnly",
			"emailActionIDs",
			"contactActive",
		) as $paramName){
			if (isset($_REQUEST[$paramName]) && isset($validate[$paramName])){
				if ($paramName == "emailActionIDs"){
					$cmd["mbapi"]["params"]["clientContacts"]["clientContact"][$paramName]["emailActionID"] = array_values(bgpc($paramName));
				} else {
					$cmd["mbapi"]["params"]["clientContacts"]["clientContact"][$paramName] = bgpc($paramName);
				}
			}
		}
		foreach (array(
			// account
			"billingAccountType",
			"billingAccountOrder",
			"billingAccountPercent",
			// card account
			"billingCardNameOnCard",
			"billingCardType",
			"billingCardNum",
			"billingCardExpMonth",
			"billingCardExpYear",
			"billingCardIssueNum",
			"billingCardStartDate",
			// bank account
			"billingBankType",
			"billingBankName",
			"billingBankState",
			"billingBankAbaCode",
			"billingBankAccountNum",
			"billingBankLicenseNum",
			"billingBankLicenseState",
			"billingBankDob",
		) as $paramName){
			if (isset($_REQUEST[$paramName]) && isset($validate[$paramName])){
				$cmd["mbapi"]["params"]["clientContacts"]["clientContact"]["clientBillingAccounts"]["clientBillingAccount"][$paramName] = bgpc($paramName);
			}
		}
		if ($_REQUEST["encKey"]){
			$cmd["mbapi"]["params"]["clientContacts"]["clientContact"]["clientBillingAccounts"]["clientBillingAccount"]["encKey"] = quoteXML(bgpc("encKey"));
		}
		$data = dispatchMBAPI($cmd, 1);

		if ( 0 !== $this->addMBAPIErrors($data) ) {
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		$data = collapseArrayElements($data);
		$clientID = (int)$data["mbapi"]["header"]["lastInsertID"];
		$contact = oneOf(":contacts", array(
			"clientID" => $clientID,
		));
		$billingAccount = oneOf(":billingAccounts", array(
			"clientContactID" => $contact["clientContactID"],
		));
		updateForKey(":clients", $clientID, array(
			"defaultBillingAccountID" => $billingAccount["billingAccountID"],
		));

		redirect("clients.php", getActionID("ShowClientDetails"), array("clientID" => $clientID));
	}
}
