<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+


require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

/**
 * This class is a child class of MB_Action. It takes $_REQUEST["clientID"] and displays
 * the attributes for that client to be edited.
 *
 * @author  modernbill
 */
class EditBasicClientAttributes extends MB_Action {

	function EditBasicClientAttributes() {
		parent::MB_Action();
		$this->stringRep = "EditBasicClientAttributes";
		$this->params = array("clientID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$clientID = getParam('clientID');
		if(!$clientID) {
			$this->addError(TRANS_ACTIONERROR, "No client ID given.");
		} else {

			$client = oneById("clients", $clientID, array("mergePrimaryContact" => 1));
            $keyedAttributes = optionsFor("attributes", array());
			$namedAttributes = array_flip($keyedAttributes);
			dbg("attributes:");
			dbg($namedAttributes);

            require_once('objects/GroupAttributes.php');
            $attributeGroups = $attributeGroupValues = array();
            foreach(Factory()->AttributeGroupList() as $group) {
                $attributeGroups[$group->group_id] = $group->group_name;
                $attributeGroupValues[$group->group_id] = array(
                    GroupAttributes::MAXIMUM_DISCOUNT => !is_null($group->GroupAttributes[GroupAttributes::MAXIMUM_DISCOUNT]->value) ? $group->GroupAttributes[GroupAttributes::MAXIMUM_DISCOUNT]->value : "" ,
                    GroupAttributes::MINIMUM_DISCOUNT => !is_null($group->GroupAttributes[GroupAttributes::MINIMUM_DISCOUNT]->value) ? $group->GroupAttributes[GroupAttributes::MINIMUM_DISCOUNT]->value : "" ,
                );
                if (!is_null($value = $group->GroupAttributes[GroupAttributes::SUSPENTION_EXEMPT]->value)) {
                    $attributeGroupValues[$group->group_id][GroupAttributes::SUSPENTION_EXEMPT] = (1 == $value)
                        ? blmsg("TRANS_YES")
                        : blmsg("TRANS_NO");
                } else {
                    $attributeGroupValues[$group->group_id][GroupAttributes::SUSPENTION_EXEMPT] ="";
                }
            }
            $this->smartyVars["attributeGroups"] = $attributeGroups;
            $this->smartyVars["attributeGroupValues"] = $attributeGroupValues;
            $this->smartyVars["suspentionExemptAttribute"] = GroupAttributes::SUSPENTION_EXEMPT;

            require_once('objects/GroupAttributes.php');
            $programaticAttributes = GroupAttributes::types();
			$defaultAttrs = array_keys($programaticAttributes);
			foreach ($defaultAttrs as $attrName){
				if (!$namedAttributes[$attrName]){
					$namedAttributes[$attrName] = "x";
				}
			}

			$this->smartyVars["customerGroupAttributes"] = array_intersect_key($namedAttributes, $programaticAttributes);
			$this->smartyVars["namedAttributes"] = array_diff_key($namedAttributes, $programaticAttributes);
			$this->smartyVars["programaticAttributes"] = $programaticAttributes;
			$clientAttributes = arrayFor("clientAttributes", array("clientID" => $clientID));

			$this->smartyVars["attributeValues"] = array();
			foreach ($clientAttributes as $attr){
				$this->smartyVars["attributeValues"][$attr["attributeID"]] = $attr;
			}

			$this->smartyVars["client"] = $client;
			$this->mergeFormState($client);
			$this->addTemplate("clients/EditBasicClientAttributes", $this->smartyVars);

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditBasicClientAttributes
?>
