<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

/**
 * This class is a child class of MB_Action. When the clientContactID and clientID is passed
 * and the user is an administrator type, then the admin will be "droped" into the client
 * interface for clientContactID.
 */
class ForwardToClientInterface extends MB_Action
{
	public $params = array("clientID", "clientContactID");

	public function execute()
	{
		global $CONF;
		parent::execute();

		$clientID = (int)$_REQUEST["clientID"];
		$clientContactID = (int)$_REQUEST["clientContactID"];

		if(!notZero($clientID) || !notZero( $clientContactID)) {
			$this->addError(TRANS_ACTIONERROR, "Client ID and Client Contact ID are required.");
		} else {
			$getUrl = new MBQuery("GetClients", "", array(
							"clientID" => $clientID,
							"getCompanyData" => 1));
			$urlResult = $getUrl->getResult();

			$clientInterfaceLocation = "";
			if ($urlResult->getErrorCount()) {
				$this->addError(TRANS_ACTIONERROR, "Failed to fetch Client URL information.");
			} else {
				$urlResult = grabSimpleMBAPIResults( $urlResult->getStructure() );
				$clientInterfaceLocation = $urlResult[0]["companyClientURL"];
			}
			unset( $urlResult, $getUrl );

			if (!notNull( $clientInterfaceLocation )) {
				$this->addError(TRANS_ACTIONERROR, "Client interface location is not set in the system configuration.");
			} elseif ($this->getErrors()) {
				// do nothing

			} else {
				if ((int)$CONF["user"]["type"] == 2) { // The current user IS an admin
					$clientQuery = new MBQuery("GetClients", "", array(
										"clientID" => $clientID,
										"clientContactID" => $clientContactID,
										"getContactData" => 4));
					$clientResult = $clientQuery->getResult();
					unset($clientQuery);
					if (!$clientResult->getErrorCount()) {
						// golden
						$clientResults = grabSimpleMBAPIResults($clientResult->getStructure());
						$clientResults = $clientResults[0];
						unset($clientResult);

						if (notZero( $clientResults["clientID"] ) && notZero( $clientResults["contacts"][0]["contact"][0]["clientContactID"] )) {
							$realUserID = getCurrentSession()->real_user_id;
							$realUserType = getCurrentSession()->real_user_type;

							require_once("object_managers/SecurityManager.php");
							SecurityManager::pushCurrentActionIntoLog(
								SecurityManager::USER_TYPE_CLIENT,
								$clientID,
								Factory()->Client($clientID)->PrimaryContact->contact_username,
								"TRANS_ACTION_LOG_REASON_LOGIN",
								blmsg(
									"TRANS_ACTION_LOG_COMMENT_ADMIN_IMPERSONATED",
									array(
										"ADMIN_ID" => getCurrentSession()->user_id,
										"CLIENT_ID" => $clientID,
										"CONTACT_ID" => $clientContactID,
										"USERNAME" => $clientResults["contacts"][0]["contact"][0]["contactUsername"],
									),
									SecurityManager::getActionLogLocale()
								)
							);

							$newSid = sha1(strval(mt_rand(0, 200000000)).strval(microtime()).strval(mt_rand(0, 200000000)));

							$newSessionQuery = new MBQuery("SetSession", "insert", array(
													"userID" => $clientContactID,
													"userType" => 1, // regular user type
													"realUserID" => $realUserID,
													"realUserType" => $realUserType,
													"sessionIP" => $CONF["user"]["ip"],
													"sessionActive" => 1,
													"sessionID" => $newSid,
													"sessionDateActive" => mktime(),
													"sessionDateCreated" => mktime(),
													"sessionDateExpired" => (int)(mktime() + Settings()->session_AdminSessionDuration * 60)));
							$newSessionQuery->getResult();	// create the new session
							unset($newSessionQuery);

							$addr = str_replace(array("//",":/"), array("/","://"),$clientInterfaceLocation."/index.php?ctr=dashboard&act=".getActionID("ShowDashboard")."&sid=".$newSid);
							dbg("SENDING TO:\t".$addr);

							if (headers_sent() && PHP_SAPI!="cli") {
								dbg("Redirecting VIA Javascript");
								echo "<script language=\"javascript\" type=\"text/javascript\">"
									."//<![CDATA[\n"
									."\tdocument.location.href = '$addr';\n"
									."//]]>\n"
									."</script>";
							} else {
								dbg("Redirecting VIA Header Redirect");
								mbHeader("Location: ".$addr);
							}
						}
					} else {
						$this->addError(TRANS_ACTIONERROR, "Unable to fetch Client Information.");
					}
				} else {
					$this->addError(TRANS_ACTIONERROR, "Must be an admin to process.");
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}