<?php
require_once dirname(__FILE__)."/".str_repeat("../", 4)."lib-tk/shield.php";
require_once "lib-action/action.php";
require_once "UI/Page/RemoveClientContacts/UIRemoveClientContactsPage.php";

class RemoveClientContact extends MB_Action
{
	public function execute()
	{
		parent::execute();
		
		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_CLIENT_CONTACTS_REMOVE"),
			"list_title" => blmsg("TRANS_REMOVE"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_REMOVAL"), "confirm_check" => blmsg("TRANS_CONFIRM_REMOVAL_MESSAGE")),
			"error_title" => blmsg("TRANS_CANCELLED"),
			"successfully_processed_list_title" => blmsg("TRANS_CLIENT_CONTACTS_SUCCESSFULLY_REMOVAL_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_CLIENT_CONTACTS_EMPTY_REMOVAL_LIST_TITLE"),
		);

		if (!is_null($clientID = bgpc('client_id'))) {
			$back_url = action_url("clients", "ShowClientContacts", array('clientID' => bgpc('client_id')));
		} else {
			$back_url = action_url("clients", "ShowClientContacts");
		}
		$controller  = UIFactory()->PageController($back_url);
		$remove_page = $controller->addPage(new UIRemoveClientContactsPage($controller, $confirmation_page_strings, "client_contact_ids"));
		$remove_page->parent_title = blmsg("TRANS_CLIENT_CONTACTS");
		$remove_page->parent_url = $back_url;
		$controller->setValue("client_contact_ids", bgpc("id"));
		$controller->processRequest();

		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}
}