<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("lib-action/action.php");

class ResetContactPasswordResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		try {
			// generate the new password
			require_once("lib-tk/include/crypt/crypt.php");
			$newPassword = getRandomPassword(12,1);

			// update password
			$contact = Factory()->ClientContact(bgpc("clientContactID"));
			$contact->contact_temp_password = getPasswordHash($newPassword);
			require_once("object_managers/ClientContactManager.php");
			ClientContactManager::update($contact);

			// send email
			require_once("lib-mbapi/include/mail/emailTemplates/passwordNotificationEmail.php");
			$email = new PasswordNotificationEmail($newPassword, $contact->id);
			if (!$email->execute()) {
				throw new ProductException(ProductException::E_FAIL_OPERATION, "Failed to send email");
			}

			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_PASSWORD_RESET");

			if (bgpc("redirectActionID") && bgpc("redirectActionFile")) {
				$numMatches = preg_match("/[a-zA-Z0-9\-\_]*\.php/", bgpc("redirectActionFile"), $matches);
				if (1 === $numMatches && $matches[0]) {
					redirect($matches[0]."?action=".bgpc("redirectActionID")."&".bgpc("redirectArgs"));
				}
			}
			redirect("clients.php", "ShowClientContacts", array("clientID" => $contact->client_id, "clientContactID" => $contact->id));
		} catch (ProductException $e) {
			$this->addOperationErrors($e);
			$this->addErrorTemplates();
		}

		return $this->hasExecutedSuccessfully();
	}
}
