<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowClientContactDetails extends MB_Action
{
	public $params = array("clientContactID");

	public function execute()
	{
		parent::execute();

		$clientContactID = ((int) $_REQUEST["clientContactID"]);
		if ( !$clientContactID ) {
			$this->addError(blmsg("TRANS_ACTIONERROR"), "No contact ID given.");
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

		$contact = Factory()->ClientContact($clientContactID);

		require_once("object_managers/SecurityManager.php");
		SecurityManager::pushCurrentActionIntoLog(
			SecurityManager::USER_TYPE_CLIENT,
			$contact->client_id,
			$contact->Client->PrimaryContact->contact_username,
			"TRANS_ACTION_LOG_REASON_SHOW_USER_DETAILS",
			blmsg(
				"TRANS_ACTION_LOG_COMMENT_CLIENT_CONTACT",
				array("CLIENT_ID" => $contact->client_id, "CONTACT_ID" => $contact->id),
				SecurityManager::getActionLogLocale()
			)
		);

		$query = $this->getMBAPIQuery("GetClients", "", array("getContactData"=>"4", "mergePrimaryContact" => 1));
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$this->mergeCountryData();
			$this->smartyVars["client"] = collapseArrayElements($results["clients"][0]["client"]);
			$this->smartyVars["contact"] = collapseArrayElements($results["clients"][0]["client"][0]["contacts"][0]["contact"]);

			$this->addTemplate("clients/ShowClientContactDetails", $this->smartyVars);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
