<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowClientContacts extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if (1 == bgpc("sync")) {
			$this->processSync();
		}

		$clientID = bgpc("clientID");

		$page  = UIFactory()->Page();
		$page->title = blmsg("TRANS_CONTACTS");

		if (!is_null($clientID)) {
			$toolsPanel = UIFactory()->ToolsPanel(blmsg("TRANS_TOOLS"));
			$toolsPanel->addButton(UIFactory()->ToolButton( "new-contact",	blmsg("TRANS_ADD_CONTACT"),	action_url("clients", "AddClientContact", array( "clientID" => $clientID ))));
			$page->addToolsPanel($toolsPanel);

			$customer = Factory()->Client($clientID);
			$page->parent_title = $customer->PrimaryContact->contact_fullname;
			$page->parent_url = action_url("clients", "ShowClientDetails", array("clientID"	=> $clientID));
		} else {
			$page->parent_title = blmsg("TRANS_CLIENTS");
			$page->parent_url = action_url("clients", "ShowClients");
		}

		require_once("UI/List/UIClientContactList.php");
		$page->addListPanel(new UIClientContactList($clientID));
		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}

	private function processSync()
	{
		$contactIDs = bgpc("id", array());
		if (empty($contactIDs)) {
			return;
		}
		$errors = array();
		foreach ($contactIDs as $contactID) {
			try {
				$contact = Factory()->ClientContact($contactID);
				$contact->sync_tasks |= ClientContact::SYNC_NEED_UPDATE | ClientContact::SYNC_NEED_REPAIR_SSO;
				require_once("object_managers/ClientContactManager.php");
				ClientContactManager::sync($contact);
				if (!is_null($contact->sync_error)) {
					$errors[] = blmsg("TRANS_SYNC_CONTACT_ERROR_MSG", array("CONTACT_ID" => $contact->id, "ERROR" => $contact->sync_error));
				}
			} catch (ProductException $e) {
				$errors[] = blmsg("TRANS_SYNC_CONTACT_ERROR_MSG", array("CONTACT_ID" => $contactID, "ERROR" => $e->getMessage()));
			}
		}
		if (empty($errors)) {
			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_CONTACTS_SUCCESS_MSG");
		} else {
			getCurrentSession()->Storage->errorMessages[] = blmsg(
				"TRANS_SYNC_CONTACTS_FAILURE_MSG",
				array("ERROR" => billing_safetyhtml(implode("\n", $errors)))
			);
		}
	}
}
