<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowClients extends MB_Action
{
	public function execute()
	{
		parent::execute();
		
		if (1 == bgpc("sync")) {
			$this->processSync();
		}

		$tools_panel = UIFactory()->ToolsPanel(blmsg("TRANS_TOOLS"));

		// Tools Area Buttons
		$tools_panel->addButton(UIFactory()->ToolButton(
			"new-client",
			blmsg("TRANS_ADD_NEW_CLIENT"),
			action_url("clients", "AddClient")
		));
		$tools_panel->addButton(UIFactory()->ToolButton(
			"quick-stats-client",
			blmsg("TRANS_QUICK_STATS"),
			action_url("clients", "ShowClientStats")
		));
		$tools_panel->addButton(UIFactory()->ToolButton(
			"contacts",
			blmsg("TRANS_SHOW_CONTACTS_BUTTON"),
			action_url("clients", "ShowClientContacts")
		));
		$page  = UIFactory()->Page();
		$page->addToolsPanel($tools_panel);
		if (bgpc('search')) {
			$page->title = blmsg("TRANS_CLIENTS_SEARCH", array('SEARCH' => bgpc('search')));
		} else {
			$page->title = blmsg("TRANS_CLIENTS");
		}
		$page->parent_url = action_url("dashboard", "ShowDashboard");

		require_once("UI/List/UIClientList.php");
		$page->addListPanel(new UIClientList());

		$this->smartyVars["page"] = $page;
		$this->addTemplate("page");
		return $this->hasExecutedSuccessfully();
	}

	private function processSync()
	{
		$customerIDs = bgpc("id", array());
		if (empty($customerIDs)) {
			return;
		}
		$errors = array();
		foreach ($customerIDs as $customerID) {
			try {
				$customer = Factory()->Client($customerID);
				$customer->sync_tasks |= Client::SYNC_NEED_REPAIR;
				require_once("object_managers/ClientManager.php");
				ClientManager::sync($customer);
				if (!is_null($customer->sync_error)) {
					$errors[] = blmsg("TRANS_SYNC_CUSTOMER_ERROR_MSG", array("CUSTOMER_ID" => $customer->id, "ERROR" => $customer->sync_error));
				}
			} catch (ProductException $e) {
				$errors[] = blmsg("TRANS_SYNC_CUSTOMER_ERROR_MSG", array("CUSTOMER_ID" => $customerID, "ERROR" => $e->getMessage()));
			}
		}
		if (empty($errors)) {
			getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_CUSTOMERS_SUCCESS_MSG");
		} else {
			getCurrentSession()->Storage->errorMessages[] = blmsg(
				"TRANS_SYNC_CUSTOMERS_FAILURE_MSG",
				array("ERROR" => billing_safetyhtml(implode("\n", $errors)))
			);
		}
	}
}
