<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class ShowLastFiveClientInvoices extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$client_id = bgpc("clientID");
		if (is_null($client_id))
			throw new Exception("The required parameter 'clientID' is missing.");

		$query = $this->getMBAPIQuery("GetInvoices", "", array(
			"clientID" => $client_id,
			"sortDir" => "desc",
			"sortColumn" => "invoiceID",
			"numRecords" => "5",
		));

		$data = dispatchMBAPI($query, 1);
		$results = $data["mbapi"][0]["results"][0]["invoices"][0]["invoice"];

		if($this->addMBAPIErrors($data) === 0) {

			// set master invoices data array
			$this->smartyVars["invoices"] = collapseArrayElements(protectArray($results));

			// call the display template
			$this->addTemplate("clients/ShowLastFiveClientInvoices");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
