<?php

class Clients_GroupController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('clients', 'ShowAttributeGroups');
	}

	public function addAction()
	{
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_ADD_CLIENT_GROUP'));
        $addForm = new Billing_Zend_Form_Final_CustomerGroupForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'operation' =>  Billing_Zend_Form_Final_CustomerGroupForm::OPERATION_ADD,
        )));
        if ($this->_request->isPost() && $addForm->isValid($this->_request->getPost()))
        {
            try {
                $addForm->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_ADD_CUSTOMER_GROUP_SUCCESS_MSG"), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $addForm;
    }

	public function editAction()
	{
        $attributeGroup = Factory()->AttributeGroup($this->_request->getParam('groupID'));
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_OBJECT', array('NAME' => $attributeGroup->group_name)));
        $editForm = new Billing_Zend_Form_Final_CustomerGroupForm(array('context' => array(
            'cancelLink' =>  $this->_backUrl,
            'operation' =>  Billing_Zend_Form_Final_CustomerGroupForm::OPERATION_EDIT,
            'attributeGroup' => $attributeGroup,
        )));
        if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost()))
        {
            try {
                $editForm->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_EDIT_CUSTOMER_GROUP_SAVED_MSG"), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
        $this->view->form = $editForm;
    }
}