<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class EditEncryptionConfigs extends MB_Action
{
	public function execute()
	{
		parent::execute();

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["agree"] = CryptManager::getEncryptionAgree();
		$this->smartyVars["isLekEnabled"] = CryptManager::isLekEnabled();
		$this->smartyVars["encryption_key_expiration_interval"] = CryptManager::getEncryptionKeyExpirationInterval();
		$this->smartyVars["encryption_key_age"] = is_null($encryption_key_age = CryptManager::getEncryptionKeyAge()) ?
			blmsg("TRANS_ENCRYPTION_KEY_AGE_UNKNOWN") : $encryption_key_age;
		$this->smartyVars["genericType"] = "editobject";
		$this->smartyVars["parentName"] = "TRANS_MANAGE_SYSTEM";
		$this->smartyVars["grandchildName"] = "TRANS_ENCRYPTION_SETTINGS";
		$this->smartyVars["sideNavMajor"] = "system";

		$this->smartyVars["saved"] = (int)$_REQUEST["saved"];

		/** AUTO GENERATE FORM DATA BEGIN **/
		$this->smartyVars["editForm"] = new MBAutoFormFields();
		$this->smartyVars["editForm"]->addFields(array(
			"encryptionAgree" => array("text", "TRANS_ENCRYPTION_TYPE_AGREE_TO_ENABLE"),
			"lekPin" => array("password", "TRANS_LEK_PIN"),
			"passPhrase" => array("password", "TRANS_PASSPHRASE"),
		));

		$this->smartyVars["editForm"]->setFieldData("encryptionAgree", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("encryptionAgree", "helpText", blmsg("TRANS_YOU_MUST_TYPE_AGREE_TO_ENABLE"));

		$this->smartyVars["editForm"]->setFieldData("lekPin", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("lekPin", "helpText", TRANS_ENTER_THE_FOUR_DIGIT_PIN_YOU_USED_WHEN_MAKING_YOUR_HASH);

		$this->smartyVars["editForm"]->setFieldData("encryptionHash", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("encryptionHash", "helpText", TRANS_ENTER_YOUR_ENCRYPTION_HASH_HERE_BUT_ONLY_LEK);

		$this->smartyVars["editForm"]->setFieldData("passPhrase", "helpTitle", TRANS_HELP);
		$this->smartyVars["editForm"]->setFieldData("passPhrase", "helpText", TRANS_ENTER_PASSPRASE_IF_NOT_LEK);

		$this->smartyVars["editForm"]->addFieldValue("encryptionAgree", $this->smartyVars["agree"]);
		$this->smartyVars["editForm"] = $this->smartyVars["editForm"]->getData();

		if($config = oneOf("configParams", array("configParamName" => "priorCypherType"))) {
			$this->smartyVars["priorCypherType"] = $config["configParamValue"];
			$this->smartyVars["priorCypherTypeID"] = getAPITypeID("encryption", $config["configParamValue"]);
		}

		require_once("object_managers/AdminManager.php");
		$admin = AdminManager::getAdmin();
		require_once("object_managers/CryptManager.php");
		$this->smartyVars["isMasterAdmin"] = $admin->isMasterAdmin();
		$this->smartyVars["isLekBackupOperator"] = CryptManager::isLekBackupOperator($admin);
		$this->smartyVars["firstLekBackupOperatorID"] = is_null(CryptManager::getLekBackupOperator(1)) ? null : CryptManager::getLekBackupOperator(1)->id;
		$this->smartyVars["secondLekBackupOperatorID"] = is_null(CryptManager::getLekBackupOperator(2)) ? null : CryptManager::getLekBackupOperator(2)->id;
		$this->smartyVars["firstLekBackupDate"] = ("" == CryptManager::getLastLekBackupDate(1)) ?
			"" : BillingLocale::getDateTimeMedium(strtotime(CryptManager::getLastLekBackupDate(1)));
		$this->smartyVars["secondLekBackupDate"] = ("" == CryptManager::getLastLekBackupDate(2)) ?
			"" : BillingLocale::getDateTimeMedium(strtotime(CryptManager::getLastLekBackupDate(2)));
		$this->smartyVars["lekBackupOperators"] = array("" => "");
		foreach (Factory()->AdminList(array("admin_active" => 1)) as $admin) {
			$this->smartyVars["lekBackupOperators"][$admin->id] = $admin->fullName;
		}

		$this->addTemplate("configs/EditEncryptionConfigs", $this->smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
