<?php

class Configs_InitialWizardController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_helper->layout->setLayout("initial-wizard");
		$this->_backUrl = $this->view->ActionUrl("dashboard", "ShowDashboard");
	}

	public function eulaAction()
	{
		$eulaForm = new Billing_Zend_Form_Final_InitialWizardForm(array("context" => array(
			"operation" =>  Billing_Zend_Form_Final_InitialWizardForm::OPERATION_EULA,
			"postData" => $postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL,
		)));
		if (! is_null($postData) && $eulaForm->isValid($postData))
        {
			try {
            	if ($eulaForm->processEulaForm($postData[Billing_Zend_Form_Final_InitialWizardForm::OPERATION_EULA])) {
	                $this->_redirect($this->view->adminActionUrl("configs", "initial-wizard", "config"));
				}
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
		$this->view->title = "TRANS_EULA_TITLE";
		$this->view->form = $eulaForm;
    }

	public function configAction()
	{
		$configForm = new Billing_Zend_Form_Final_InitialWizardForm(array("context" => array(
			"operation" =>  Billing_Zend_Form_Final_InitialWizardForm::OPERATION_CONFIGURATION,
			"postData" => $postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL,
			"cancelLink" => $this->_backUrl,
		)));
		if (! is_null($postData) && $configForm->isValid($postData))
        {
			try {
            	$configForm->processConfigForm($postData);
                $this->_redirect($this->_backUrl);
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }
        }
		$this->view->title = "TRANS_INITIAL_CONFIGURATION_TITLE";
		$this->view->form = $configForm;
    }

	private $_backUrl = NULL;
}