<?php

require_once("lib-action/action.php");

class ShowSystemSetup extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$this->smartyVars["paymentGateways"]["status"] = (0 == count(Factory()->PaymentGatewayList())) ? "not-configured" : "done";

		require_once("object_managers/BillingRegistrarManager.php");
		$this->smartyVars["registrars"]["status"] = sizeof(BillingRegistrarManager::getEnabledRegistrars()) ? "done" : (sizeof(BillingRegistrarManager::getDisabledRegistrars()) ? "not-managed" : "not-configured");

		$this->smartyVars["taxes"]["status"] = (0 == count(Factory()->TaxZoneGroupList())) ? "not-configured" : "done";

		$this->smartyVars["fraud"]["status"] = (1 == Factory()->ConfigGroup(0)->getChild("securitySettings")->getChild("fraudguardian")->getChild("0")->ConfigParams["enableFraudGuardian"]->value) ? "done" : "not-configured";

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["encryption"]["status"] = (CryptManager::isEncryptionEnabled()) ? "done" : "not-configured";

		$this->smartyVars["warningHide"] = bgpc("dashboard-system-setup-warning-hide", 0);

		$this->addTemplate("dashboard/ShowSystemSetup");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
