<?php
require_once("lib-action/action.php");
require_once("UI/Page/UIConfirmationGroupPage.php");

class RemoveCouponPage extends UIConfirmationGroupPage
{
	protected function getObject($id)
	{
		return Factory()->Coupon($id);
	}

	protected function getObjectDisplayName($object)
	{
		return $object->coupon_code;
	}

	protected function executeAction($id)
	{
		require_once("object_managers/CouponManager.php");
		CouponManager::delete(Factory()->Coupon($id));
	}
}

class RemoveCoupon extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_COUPON_REMOVE"),
			"list_title" => blmsg("TRANS_COUPON_CONFIRM_GROUP_REMOVAL"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_REMOVAL"), "confirm_check" => blmsg("TRANS_CONFIRM_REMOVAL_MESSAGE")),
			"error_title" => blmsg("TRANS_APPROVED"),
			"successfully_processed_list_title" => blmsg("TRANS_COUPON_EMPTY_REMOVAL_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_COUPON_EMPTY_REMOVAL_LIST_TITLE"),
		);

		$parent_url = action_url("discounts", "ShowCoupons");
		$controller  = UIFactory()->PageController($parent_url);
		$page = $controller->addPage(new RemoveCouponPage( $controller, $confirmation_page_strings ));
		$page->parent_title = blmsg("TRANS_COUPONS");
		$page->parent_url = $parent_url;
		$controller->setValue("id", bgpc("id"));
		$controller->processRequest();
		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");

		return $this->hasExecutedSuccessfully();
	}
}
