<?php
require_once("lib-action/action.php");
require_once("UI/Page/UIConfirmationGroupPage.php");

class RemoveCycleDiscountGroupPage extends UIConfirmationGroupPage
{
	protected function getObject($id)
	{
		return Factory()->CycleDiscountGroup($id);
	}

	protected function getObjectDisplayName($object)
	{
		return $object->cycle_discount_group_name;
	}

	protected function executeAction($id)
	{
		require_once("object_managers/DiscountManager.php");
		DiscountManager::delete(Factory()->CycleDiscountGroup($id));
	}
}

class RemoveCycleDiscountGroup extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$confirmation_page_strings = array (
			"title" => blmsg("TRANS_DISCOUNT_REMOVE_GROUPS"),
			"list_title" => blmsg("TRANS_DISCOUNT_CONFIRM_GROUP_REMOVAL"),
			"confirm_messages" => array( "confirm" => blmsg("TRANS_CONFIRM_REMOVAL"), "confirm_check" => blmsg("TRANS_CONFIRM_REMOVAL_MESSAGE")),
			"error_title" => blmsg("TRANS_APPROVED"),
			"successfully_processed_list_title" => blmsg("TRANS_DISCOUNT_EMPTY_REMOVAL_LIST_TITLE"),
			"empty_processed_list_title" => blmsg("TRANS_DISCOUNT_EMPTY_REMOVAL_LIST_TITLE"),
		);

		$parent_url = action_url("discounts", "ShowCycleDiscountGroups");
		$controller  = UIFactory()->PageController($parent_url);
		$page = $controller->addPage(new RemoveCycleDiscountGroupPage( $controller, $confirmation_page_strings ));
		$page->parent_title = blmsg("TRANS_DISCOUNTS");
		$page->parent_url = $parent_url;
		$controller->setValue("id", bgpc("id"));
		$controller->processRequest();
		$this->smartyVars["page"] = $controller->getPage();
		$this->addTemplate("page");

		return $this->hasExecutedSuccessfully();
	}
}
