<?php

class Discounts_CouponController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('discounts', 'ShowCoupons');
	}

	public function addAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_ADD_COUPON'));
		$addForm = new Billing_Zend_Form_Final_EditCouponForm(array('context' => array(
			'cancelLink' =>  $this->_backUrl,
			'coupon' =>  NULL,
			'postData' => $postData,
		)));
		try {
			if ($this->_request->isPost() && $addForm->isValid($postData)) {
				$addForm->processForm();
				$this->_redirect($this->_backUrl);
			}
		} catch (ProductException $e) {
			$this->_status->addError($e->getMessage());
		}
		$this->view->form = $addForm;
	}

	public function editAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
        $coupon = Factory()->Coupon($this->_request->getParam('couponID'));
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_OBJECT', array('NAME' => $coupon->coupon_code)));
		$editForm = new Billing_Zend_Form_Final_EditCouponForm(array('context' => array(
			'cancelLink' => $this->_backUrl,
			'coupon' =>  $coupon,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $editForm->isValid($postData))
		{
			try {
				$editForm->processForm();
				$this->_redirect($this->_backUrl);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $editForm;
	}

	private $_backUrl = NULL;
}