<?php

class Discounts_IndexController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('discounts', 'ShowCycleDiscountGroups');
	}

	public function addAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_ADD_DISCOUNT'));
		$addForm = new Billing_Zend_Form_Final_EditCycleDiscountGroupForm(array('context' => array(
			'cancelLink' =>  $this->_backUrl,
			'cycleDiscountGroup' =>  NULL,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $addForm->isValid($postData)) {
			try {
            			$addForm->processForm();
				$this->_redirect($this->_backUrl);
            		} catch (ProductException $e) {
                		$this->_status->addError($e->getMessage());
            		}
        	}
		$this->view->form = $addForm;
	}

	public function editAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
		$cycleDiscountGroup = Factory()->CycleDiscountGroup($this->_request->getParam('cycleDiscountGroupID'));
		$this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_OBJECT', array('NAME' => $cycleDiscountGroup->cycle_discount_group_name)));
        $editForm = new Billing_Zend_Form_Final_EditCycleDiscountGroupForm(array('context' => array(
			'cancelLink' => $this->_backUrl,
			'cycleDiscountGroup' =>  $cycleDiscountGroup,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $editForm->isValid($postData))
		{
			try {
				$editForm->processForm();
				$this->_redirect($this->_backUrl);
			} catch (ProductException $e) {
				$this->_status->addError($e->getMessage());
			}
		}
		$this->view->form = $editForm;
	}

	private $_backUrl = NULL;
}