<?php
require_once ("lib-action/action.php");

class EditDomain extends MB_Action {

	public function __construct()
    {
		parent::MB_Action();
		$this->params = array("domainID");
	}

	function execute()
    {
		parent::execute();
		$domainID = bgpc("domainID");
		if(!$domainID) {
			$this->addError(TRANS_ACTIONERROR, "No domain ID given.");
		} else {
			$registrars = array(0 => "");
            require_once ('object_managers/BillingRegistrarManager.php');
            foreach(BillingRegistrarManager::getEnabledRegistrars() as $registrar) {
                $registrars[$registrar->id] = $registrar->module_name;
            }

			$query = $this->getMBAPIQuery("GetDomains", "", array());
			$data = dispatchMBAPI($query, 1);

			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$s = array();
				$s["tldRenew"] = getTypes('tldRenew');
				$s["registrars"] = $registrars;
				$s["domain"] = collapseArrayElements($data["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
				$this->addTemplate("domains/EditDomain", $s);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} 
?>