<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class EditDomainAccessPassword extends DomainAction
{
	/**
	 * The main method of this class that executes the EditDomainAccessPassword action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$mbapiData = $this->getDomain();

		// build XML for fetching domain data from the registrar
		$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$x = "
		<mbapi>
		  <command>ProcessRegistrar</command>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
		    <subCommand>getDomainAccessPassword</subCommand>
		    <configID>0</configID>
			<domainID>".$domainID."</domainID>
			<domainSLD>".$domainSLD."</domainSLD>
			<domainTLD>".$domainTLD."</domainTLD>
		  </params>
		</mbapi>";

		$registrarData = dispatchMBAPI($x,1);
		$registrarResults =& $registrarData["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($registrarData) === 0) {

			$smartyVars = array();
			$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
			$smartyVars["domainAccessPassword"] = collapseArrayElements($registrarResults["DomainAccessPassword"]);
			$this->addTemplate("domains/EditDomainAccessPassword", collapseArrayElements($smartyVars));

		} else {
			$this->redirectWithErrorMessage(billing_safetyhtml($this->getErrorMessage()));
		}

		return $this->hasExecutedSuccessfully();
	}
} // EditDomainAccessPassword
?>