<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");


class EditDomainDNS extends DomainAction
{
	public function execute()
	{
		parent::execute();

		$domain = Factory()->PackageDomain(bgpc("domainID"));
		$registrar = Factory()->BillingRegistrar($domain->registrar_id);
		if ("rucenter" == $registrar->module_name) {

			$this->smartyVars["domain"] = array(
				"domainID" => $domain->id,
				"domainSLD" => $domain->domain_sld,
				"domainTLD" => $domain->domain_tld
			);
			try {
				$this->smartyVars["listDNS"] = $registrar->getModule()->getDomainDNS($domain);
				$this->addTemplate("domains/EditDomainDNS");
			} catch (ProductException $e) {
				$this->redirectWithErrorMessage(billing_safetyhtml($e->getMessage()));
			}

		} else {

			$mbapiData = $this->getDomain();

			$domain = correctArray($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
			$domainSLD = $domain["domainSLD"];
			$domainTLD = $domain["domainTLD"];
			$domainID = $domain["domainID"];

			$x = "
			<mbapi>
				<command>ProcessRegistrar</command>
				<subCommand>getDomainDNS</subCommand>
				<params>
					<configID>0</configID>
					<domainID>".$domainID."</domainID>
					<domainSLD>".$domainSLD."</domainSLD>
					<domainTLD>".$domainTLD."</domainTLD>
				</params>
			</mbapi>";

			$registrarData = dispatchMBAPI($x,1);
			$registrarResults =& $registrarData["mbapi"][0]["results"][0];

			if ($this->addMBAPIErrors($registrarData) === 0) {

				$smartyVars = array();
				$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);

				if(!isset($_REQUEST["invalidDNS"])) {
					$smartyVars["dnsCount"] = count($registrarResults["listDNS"]);
					//This is an experimental way to show 8 fields per domain.
					if (count($registrarResults["listDNS"]) < 8) {
						$smartyVars["dnsShowExtra"] = 8 - count($registrarResults["listDNS"]);
					} else {
						$smartyVars["dnsShowExtra"] = 0;
					}
					$smartyVars["listDNS"] = $registrarResults["listDNS"];

					if (!is_array($smartyVars["listDNS"]))
						$smartyVars["listDNS"] = array($smartyVars["listDNS"]);

					$smartyVars["useDNS"] = collapseArrayElements($registrarResults["UseDNS"]);
				} else {
					$smartyVars["listDNS"] = unserialize(bgpc("listDNS"));
					$smartyVars["dnsCount"] = count($smartyVars["listDNS"]);
					$smartyVars["dnsShowExtra"] = 0;
					$smartyVars["invalidDNS"] = unserialize(bgpc("invalidDNS"));
					$smartyVars["useDNS"] = bgpc("useDNS");
				}

				$smartyVars["host"] = correctArray($registrarResults["host"]);
				$smartyVars["domainServices"] = correctArray($registrarResults["DomainServices"][0]);
				//This is an array to loop over, a smarty helper
				$smartyVars["hostLoop"] = array("","","","","","","","","","");
				while ((count($smartyVars["host"])+4) > count($smartyVars["hostLoop"])) {
					$smartyVars["hostLoop"][] = '';
				}

				$smartyVars["dnsOptions"] = array_merge(array('0' => 'None'), correctArray($registrarResults["dnsOptions"][0]));
				$smartyVars["dnsOptionsDescKey"] = 'TRANS_REGISTRAR_' . strtoupper($registrar->module_name) . '_DNS_RECORD_TYPES_DESC';
				$this->addTemplate("domains/EditDomainDNS", $smartyVars);
			} else {
				$this->redirectWithErrorMessage(billing_safetyhtml($this->getErrorMessage()));
			}
		}

		return $this->hasExecutedSuccessfully();
	}
}