<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the EditDomainRegistrarLockOptions action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class EditDomainRegistrarLockOptionsResponse extends DomainAction {

	/**
	 * The main method of this class that executes the EditDomainRegistrarLockOptionsResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

	 	$mbapiData = $this->getDomain();

	 	// fetching domain data from the registrar
	 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$domainRegistrarLock = ($_REQUEST["domainRegistrarLock"]) ? 1 : 0 ;

		$xml = "
		<mbapi>
		  <command>ProcessRegistrar</command>
		  <subCommand>setDomainRegistrarLockOptions</subCommand>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
			<subCommand>setDomainRegistrarLockOptions</subCommand>
			<configGroupName>0</configGroupName>
			<configID>0</configID>
			<domainID>".$domainID."</domainID>
			<domainSLD>".$domainSLD."</domainSLD>
			<domainTLD>".$domainTLD."</domainTLD>
			<domainRegistrarLock>".$domainRegistrarLock."</domainRegistrarLock>
		</params>
		</mbapi>";
		$data = dispatchMBAPI($xml,1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>