<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the RenewDomain action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class RenewDomainResponse extends DomainAction {
	/**
	 * The constructor for an RenewDomainResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->params = array
		(
			"domainID",
			"domainYears",
		);
	}

	/**
	 * The main method of this class that executes the RenewDomainResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$mbapiData = $this->getDomain();
		$domainYears = (int) $_REQUEST["domainYears"];

		// is the domainID valid?
		if (!$domainYears || $domainYears > 10) {
			$this->redirectWithErrorMessage("Invalid domain years.");
		}

	 	// fetching domain data from the registrar
	 	$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = (int)$mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$xml = "
		<mbapi>
		  <command>ProcessRegistrar</command>
		  <showXMLHeader>0</showXMLHeader>
		  <params>
		    <subCommand>renewDomain</subCommand>
            <configID>0</configID>
            <domainID>".$domainID."</domainID>
			<domainSLD>".$domainSLD."</domainSLD>
			<domainTLD>".$domainTLD."</domainTLD>
			<domainYears>".$domainYears."</domainYears>
		  </params>
		</mbapi>";
		$data = dispatchMBAPI($xml,1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>