<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");

/**
 * This Action object takes information provided by the SyncDomainDates action, and sends
 * it to the registrar class for processing.
 *
 * @author  Michael Fountain
 */
class SyncDomainDatesResponse extends DomainAction {
	/**
	 * The constructor for an SyncDomainDatesResponse action object. This merely calls the parent constructor,
	 * and sets the string representation of this object. It also sets up $this->params.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->params = array
		(
			"domainID",
			"domainDateExpires",
		);
	}

	/**
	 * The main method of this class that executes the SyncDomainDatesResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("SetDomains", "update", array());
		$data = dispatchMBAPI($query, 1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	} // execute

} // EditDomainResponse
?>