<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class EditEmailTemplateGroupResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$email_tpl_group = !is_null($emailTplGroupID = bgpc("emailTplGroupID")) ?
			Factory()->EmailTemplateGroup($emailTplGroupID) : Factory()->EmailTemplateGroup();

		$trans_keys = array(
			"email_action_id" => "TRANS_EMAIL_ACTION",
			"email_tpl_group_priority" => "TRANS_EMAIL_TPL_GROUP_PRIORITY",
			"email_tpl_group_name" => "TRANS_EMAIL_TPL_GROUP_NAME",
			"email_tpl_group_from_name" => "TRANS_EMAIL_FROM_NAME",
			"email_tpl_group_from_address" => "TRANS_EMAIL_FROM_ADDRESS",
			"email_tpl_group_reply_name" => "TRANS_EMAIL_REPLY_NAME",
			"email_tpl_group_reply_address" => "TRANS_EMAIL_REPLY_ADDRESS",
			"email_tpl_group_cc_address" => "TRANS_EMAIL_CC_ADDRESS",
			"email_tpl_group_bcc_address" => "TRANS_EMAIL_BCC_ADDRESS",
		);
		foreach ( $trans_keys as $attr_name => $locale_key ) {
			$param_name = getDBXMLCol($attr_name);
			$email_tpl_group->$attr_name = bgpc($param_name);
		}

		try {
			require_once("object_managers/EmailTemplateGroupManager.php");
			EmailTemplateGroupManager::update($email_tpl_group);
			redirect("emails.php", getActionID("EditEmailTemplateGroup"), array("emailTplGroupID" => $email_tpl_group->id, "saved" => 1));
		} catch ( ProductException $e ) {
			$this->addOperationErrors($e, $trans_keys);
			$this->addErrorTemplates();
		}
		return $this->hasExecutedSuccessfully();
	}
}