<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";

class EditEmailTemplateResponse extends EditResponseAction {
	function EditEmailTemplateResponse() {
		$this->setDataSource(new DataSource("emailTemplates"));
		EditResponseAction::EditResponseAction();
	}

	function editResponseParamHandler() {
		$tplSubject = healUTF8(bgpc("emailTplSubject"));
		$tplBody = healUTF8(bgpc("emailTplBody"));
		$tplTextBody = healUTF8(bgpc("emailTplTextBody"));

		$pass = true;

		if ( false === $tplSubject ) {
			$pass = false;
			$this->addError(MBAPI_ACTIONERROR, "Bad character encoding detected in the subject.");
		}
		if ( false === $tplBody ) {
			$pass = false;
			$this->addError(MBAPI_ACTIONERROR, "Bad character encoding detected in the HTML body.");
		}
		if ( false === $tplTextBody ) {
			$pass = false;
			$this->addError(MBAPI_ACTIONERROR, "Bad character encoding detected in the text body.");
		}

		if ( $pass )  {
			// These are double-quoted because they need to be pre-quoted for coming out of the database for now.
			$this->d->params["emailTplSubject"] = $tplSubject;
			$this->d->params["emailTplBody"] = utf8_html_entity_encode($tplBody);
			$this->d->params["emailTplTextBody"] = utf8_html_entity_encode($tplTextBody);
			return true;
		} else {
			return false;
		}
	}

	function redirect() {
		redirect("emails.php", getActionID("EditEmailTemplateGroup"), array("emailTplGroupID" => (int) $_REQUEST["emailTplGroupID"]));
	}
}
header('Content-Type: text/html; charset=UTF-8');

function convertEncoding( $str, $to, $from ) {
	if (function_exists('iconv')) {
		return iconv( $to, $from.'//TRANSLIT', $str );
	} elseif (function_exists('mb_convert_encoding')) {
		return mb_convert_encoding( $str, $to, $from );
	} else {
		// TEMPORARY!
		// do nothing
		// echo 'Neither Iconv nor mb_convert_encoding are present, this is a development function. Please contact Modern Bill Support and register a ticket. Thank you';
		// exit;
		return $str;
	}
}

function detectUTF8($str) {
	$len = strlen($str);
	$current_byte = 0x00;
	$count_good_utf = 0;
	$count_bad_utf = 0;

	for($i; $i < $len; $i++) {
		$previous_byte = $current_byte;
		$current_byte = ord(substr($str, $i, 1));
		//show("x: ${current_byte}; y: ${previous_byte}");

		if(($current_byte & 0xC0) == 0x80) {
			if(($previous_byte & 0xC0) == 0xC0) {
				$count_good_utf++;
			} else if (($previous_byte & 0x80) == 0x00) {
				$count_bad_utf++;
			}
		} else if(($previous_byte & 0xC0) == 0xC0) {
			$count_bad_utf++;
		}
	}
	//show("good: ${count_good_utf}; bad: ${count_bad_utf}");
	return $count_good_utf >= $count_bad_utf;
}

function healUTF8($str) {
	if(detectUTF8($str)) {
		// was utf-8
		//show("was utf-8");
		return $str;
	} else {
		// guess latin-1
		//show("guess latin-1");
		$try_str = convertEncoding($str, "ISO-8859-1", "UTF-8");
		if(detectUTF8($try_str)) {
			// was apparently latin-1
			//show("was apparently latin-1");
			return $try_str;
		} else {
			// was apparently something else
			//show("was apparently something else");
			return false;
		}
	}
}
