<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 * This action resend an email from the queue.
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Brian Smith
 */
class ResendEmail extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function ResendEmail() {
		parent::MB_Action();
		$this->stringRep = "ResendEmail";
		$this->params = array("emailID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$emailID = (int)$_REQUEST["emailID"];

		if (!notZero( $emailID )) {
			$this->addError( TRANS_ACTIONERROR, "No Email ID Given" );
		} else {
			$query = $this->getMBAPIQuery("GetEmailQueue", "", array("emailID" => $emailID));
			$data = grabSimpleMBAPIResults( dispatchMBAPI( $query, 1 ) );
			$data = $data[0];

			dbg("#### Returned from GetEmail ####");
			dbg($data);

			if (notZero( $data["emailID"] )) {
				$this->smartyVars["email"] = $data;
				$this->smartyVars["email"]["emailSubject"] = utf8_html_entity_encode($data["emailSubject"]);
				$this->addTemplate("events/ResendEmail");
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}