<?php
if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

/**
 *
 * @package  modernbill
 * @subpackage  action
 * @author  Brian Smith
 */
class ShowEmailDetails extends MB_Action {
	/**
	 * Call the parent constructor, setup a string representation for ourselves, and setup the allowed parameters.
	 */
	function ShowEmailDetails() {
		parent::MB_Action();
		$this->stringRep = "ShowEmailDetails";
		$this->params = array("emailID");
	}

	/**
	 * Execute this action and return 1 for success, or 0 for failure.
	 *
	 * @return  int  1 if execution succeeded or 0 if otherwise.
	 */
	function execute() {
		parent::execute();

		if(!notZero((int)$this->paramArgs["emailID"])) {
			$this->addError(TRANS_ACTIONERROR, "No email ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetEmailQueue");
			$data = dispatchMBAPI($query, 1);

			dbg("########### Returned from GetEmailQueue #############");
			dbg($data);


			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$data = grabSimpleMBAPIResults( $data );
				$this->smartyVars["email"] = $data[0];
				$this->smartyVars["email"]["emailSubject"] = utf8_html_entity_encode($this->smartyVars["email"]["emailSubject"]);

				dbg("########### Sent to Smarty ###############");
				dbg($this->smartyVars);

				$this->addTemplate("events/ShowEmailDetails");
			}
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditEmail
