<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class AddSingleInvoiceResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if(!(int)$_REQUEST["clientID"]) {
			$this->addError( TRANS_ACTIONERROR, "Client ID not found." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}
		$clientID = (int)$_REQUEST["clientID"];

		$params = array(
			"clientID" => $clientID,
			"packageName" => $_REQUEST["packageName"],
			"packageDescription" => $_REQUEST["packageDescription"],
			"amount" => $this->getNumberFromInput($_REQUEST["amount"]),
			"invoiceDate" => getMBDateFromRequest("invoiceDate"),
			"cycleID" => $_REQUEST["cycleID"],
			"orderFormID" => $_REQUEST["orderFormID"],
			"enableInvoiceEmail" => $_REQUEST["enableInvoiceEmail"],
		);

		if (1 == bgpc("applyPaymentAsWell")) {
			$params["amountPaid"] = $this->getNumberFromInput(bgpc("amountPaid"));
			$params["paymentComments"] = bgpc("paymentComments");
			$params["transactionDateCreated"] = getMBDateFromRequest("transactionDateCreated");
			$params["enablePaymentEmail"] = bgpc("enablePaymentEmail");
			$params["billingAccountID"] = bgpc("billingAccountID");

			require_once("objects/ClientBillingAccount.php");
			switch (Factory()->ClientBillingAccount($params["billingAccountID"])->billing_account_type) {
			case ClientBillingAccount::TYPE_CREDIT_CARD:
				$params["paymentMethod"] = "ccsingle";
				break;
			case ClientBillingAccount::TYPE_ECHECK:
				$params["paymentMethod"] = "echeck";
				break;
			case ClientBillingAccount::TYPE_BANK_DRAFT:
				$params["paymentMethod"] = "bank";
				break;
			case ClientBillingAccount::TYPE_MANUAL_PAYMENT:
				$params["paymentMethod"] = "check";
				break;
			case ClientBillingAccount::TYPE_THIRD_PARTY_GATEWAY:
				$params["paymentMethod"] = "thirdparty";
				break;
			case ClientBillingAccount::TYPE_WIRE:
				$params["paymentMethod"] = "wire";
				break;
			case ClientBillingAccount::TYPE_HSPC_BANK_TRANSFER:
				$params["paymentMethod"] = "hspcbanktransfer";
				break;
			default:
				$params["paymentMethod"] = "other";
			}
		}

		$results = dispatchMBAPI(array(
			"mbapi" => array(
				"command" => "ProcessSingleInvoice",
				"params" => $params,
			),
		), 1);

		$invoiceID = $results["mbapi"][0]["results"][0]["invoiceID"];
		$invoiceID = is_array($invoiceID) ? (int)$invoiceID[0] : 0;

		if ($invoiceID){
			redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID"=>$invoiceID));
		} else {
			$this->addError( TRANS_ACTIONERROR, "Error generating invoice." );
			$this->addErrorTemplates();
			return $this->hasExecutedSuccessfully();
		}

	}
}
