<?php

require_once ("lib-mbapi/include/mail/emailTemplates/invoiceEmail.php");
require_once ("lib-mbapi/include/mail/mail.php");
require_once ("lib-billing/include/config/internal/emailactions.php");

class ShowResendInvoiceResponse extends MB_Action {
	/**
	 * The constructor for a ShowResendInvoiceResponse object. This merely sets up our string represenation, calls
	 * the parent constructor, and sets up $this->params.
	 */
	function __construct() {
		parent::__construct();
		$this->stringRep = "ShowResendInvoiceResponse";
		$this->params = array("invoiceID", "previewInvoice");
	}

	/**
	 * Execute this action object, and display any output generated to the screen.
	 *
	 * @return  1 if no errors occurred during execution, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();
		set_time_limit(0);

		$invoiceID = (int) $this->paramArgs["invoiceID"];
		$previewInvoice = (bool)((int) $this->paramArgs["previewInvoice"]);
		
		if(!$invoiceID) {
			$this->addError(TRANS_ACTIONERROR, "No Invoice ID given.");
		} else {
			// lets try to send this
			switch ( $this->sendInvoice( $invoiceID, $previewInvoice ) ) {
				case true: // sucess
					if (notNull( $this->getReferralActionFile() )) {
						redirect($this->getReferralActionFile(), $this->getReferralActionID(), array("invoiceID" => $invoiceID));
					} else {
						redirect("invoices.php", "ShowInvoiceDetails", array("invoiceID" => $invoiceID));
					}
					break;

				case -1: // errrror
					$this->addError( TRANS_ACTIONERROR, "Invoice ID not provided.");
					break;

				case false: // failed to send
					$this->addError( TRANS_ACTIONERROR, "Invoice Email Failed to send.");
					break;
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	/**
	 *	@short generate a new invoice email
	 *	@param int the invoiceID to generate
	 *	@param bool if to make this a preview invoice and return the results of the mail body
	 *	@return mixed
	 *		-1 means the invoiceID was not proper
	 *		true success
	 *		false failure
	 */
	function sendInvoice( $invoiceID, $previewInvoice = false ) {
		global $CONF;
		if (!notZero( $invoiceID )) {
			return -1;
		}
		
		$email = new InvoiceEmail($invoiceID);
		return $email->execute($previewInvoice);
	}
}