<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");
require_once("lib-mbapi/mbapi.php");

class LoginResponse extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$adminRemoteAccessHash = $CONF["user"]["remoteAccessHash"];
		$internalAdmin = $CONF["user"]["internalAdmin"];

		if($CONF["user"]["remoteSessionID"]) {
			list($isSessionActive, $logoutReason) = setSession($CONF["user"]["remoteSessionID"]);
			if($isSessionActive) {
				$this->hasExecutedSuccessfully = 1;
				$CONF["user"]["sessionID"] = $_REQUEST["sid"] = $CONF["user"]["remoteSessionID"];
				return $this->hasExecutedSuccessfully();
			}
		}

		$query = $this->getMBAPIQuery("ProcessAdminLogin", "", array(
			"adminIP" => $CONF["user"]["ip"],
			"adminRemoteAccessHash" => $adminRemoteAccessHash,
			"internalAdmin" => $internalAdmin,
			"adminUsername" => bgpc("user_name"),
			"adminPassword" => bgpc("user_password"),
		));
		$data = dispatchMBAPI($query, 1);

		if (0 === $this->addMBAPIErrors($data) && ! $this->getNumErrors())
		{
			if(is_array($data["mbapi"][0]["results"][0]["adminID"])) {
			 	dbg("inside");
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				require_once("object_managers/SessionManager.php");
				SessionManager::deleteExpiredSessions();

				// Allow expired users to resume a new session from where their last one left off
				if ($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					if (preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
						redirect($_REQUEST["redirectActionFile"]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
					}
				} else {
					//If it's a remote API call, let it bubble back instead of redirect
					if ($adminRemoteAccessHash || $internalAdmin){
						$_REQUEST["adminID"] = $data["mbapi"][0]["results"][0]["adminID"][0];
						$CONF["user"]["type"] = 2;
						$CONF["user"]["sessionID"] = $_REQUEST["sid"];
						$this->hasExecutedSuccessfully = 1;
						return $this->hasExecutedSuccessfully();
					} else {
						// a change in login process
						redirect("dashboard.php", getActionID("ShowDashboard"));
					}
				}
			} else {
				if ($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					redirect("login.php",getActionID("ShowLogin"), array(
						"msg" => "TRANS_AUTH_FAILED",
						"redirectActionID" => $_REQUEST['redirectActionID'],
						"redirectActionFile" => $_REQUEST['redirectActionFile'],
						"redirectArgs" => $_REQUEST['redirectArgs'],
					));
				} else {
					redirect("login.php",getActionID("ShowLogin"), array("msg" => "TRANS_AUTH_FAILED"));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
