<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

/**
 * This action displays a login form to the user. This instance of this action is hit whenever an admin user's session
 * has expired. To alleviate frustration, when posting to the admin/login/LoginResponse action, the redirectActionID
 * and redirectActionFile request parameters should also be passed, so that LoginResponse can redirect accordingly. This
 * is not a security issue, because the admin is required to authenticate before redirect, and even if they hit the
 * given action file and action ID, they'd be denied access unless their user is allowed access by the system.
 */
class ShowLogin extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		if (PLESKBUNDLE==1){
			$admin = oneOf(":admins", array(
				"adminPassword" => "UNKNOWN",
			));
			if ((int)$admin["adminID"]){
				$this->smartyVars["redirectToPlesk"] = 1;
				$this->smartyVars["serverName"] = $_SERVER["SERVER_NAME"];
			}
		}

		$msg = bgpc("msg");
		$infoMsg = bgpc("info_msg");
		$this->smartyVars["msg"] = ($lmsg = blmsg($msg)) == $msg ? billing_safetyhtml($msg) : $lmsg;
		$this->smartyVars["info_msg"] = ($lmsg = blmsg($infoMsg)) == $infoMsg ? billing_safetyhtml($infoMsg) : $lmsg;

		// force usage of the admin login template since we are not logged in yet
		$CONF["theme"]["type"] = "admin";

		// We allow for action redirects here, so if someone's session expired, they can at least get to the same
		// page immediately
		if (!is_null($redirectActionID = bgpc("redirectActionID")) && !is_null($redirectActionFile = bgpc("redirectActionFile"))) {
			$this->smartyVars = array(
				"redirectActionID" => $redirectActionID,
				"redirectActionFile" => $redirectActionFile,
				"redirectActionArgs" => bgpc("redirectActionArgs"),
			);
		}
		$this->addTemplate("login/ShowLogin");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
