<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("lib-action/action.php");

/**
 * This action walks a user through the GoDaddy certification process
 */
class CertifyGoDaddyAccount extends MB_Action
{
	public function execute()
	{
		if (1 == bgpc('certifyAccount')) {
			$configParams = arrayFor(':configParams', array(
				'configGroupID' => bgpc('configGroupID'),
			));
			$registrarConfig = array();
			foreach ((array)$configParams as $param){
				if ($param['configParamName']=='moduleCertified'){
					$certifiedParamID = $param['configParamID'];
				}
				$registrarConfig[$param['configParamName']] = $param['configParamValue'];
			}

			$registrarConfig['modulePassword'] = getStuff($registrarConfig['modulePassword']);
			// password has to be at least 1 character, I believe GoDaddy requires more too...
			if (!$registrarConfig['moduleUsername'] || strlen($registrarConfig['modulePassword'])<1){
				$this->smartyVars['error'] = blmsg("TRANS_YOU_MUST_SAVE_YOUR_GODADDY_USERNAME_AND_PASSWORD");
			} else {
				require_once('lib-mbapi/include/modules/registrar/core/godaddy/WWDAPI.php');
				$wwd = new WWDAPI($registrarConfig['moduleUsername'], $registrarConfig['modulePassword']);
				$passed = $wwd->certifyAccount();
				if ($passed){
					$this->smartyVars['success'] = 1;
					updateForKey(':configParams', $certifiedParamID, array(
						'configParamValue' => 1,
					));
				} else {
					$errors = array(blmsg("TRANS_GODADDY_CERTIFICATION_ERROR_MSG"));
					foreach (array_reverse($wwd->getErrors()) as $error) {
						$errors[] = billing_safetyhtml($error);
					}
					$this->smartyVars['error'] = @implode('<br />', $errors);
				}
			}
		} else {
			$this->smartyVars['displayInstructions'] = 1;
		}
		$this->addTemplate("modules/CertifyGoDaddyAccount", $this->smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
