<?php

require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once ("lib-action/action.php");

class ShowSystemLicenseInfo extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$this->smartyVars['numKeys'] = countFor(":configParams", array(
			"configGroupID" => internalConfigGroupID,
			"configParamName" => "license",
		)) + countFor(":configParams", array(
			"configGroupID" => internalConfigGroupID,
			"configParamName" => "license_archived",
		));

		// lets check if there is a possibility they can use the bundle :-)
		// first want to assertain the status of whether we have bundle capabilities
		global $CONF;
		$this->smartyVars['pleskLicensePPBAccounts'] = checkForPPBBundledLicenseCapability();
		$this->smartyVars['suppressBundleLicenseWarning'] = $CONF["system"]["internal"]["suppressBundleLicenseWarning"];
		if ($this->smartyVars['pleskLicensePPBAccounts'] && !$CONF["system"]["internal"]["suppressBundleLicenseWarning"]){
			$CONF["system"]["internal"]["suppressBundleLicenseWarning"] = 1;
			storeConfigs("system", "internal");
		}

		if (KA_LICENSING==1 && INVALIDLICENSE!=1){
			$current = new OPEN_FUSION_LICENSE(CURRENT_LICENSE_KEY);
			sort($placeHolder = (array)$current->supportedVersions);
			$current->supportedVersions = $placeHolder;
			$this->smartyVars["supportedVersions"] = implode(", ", (array)$current->supportedVersions);
			$this->smartyVars["showStoreLinks"] = (int)$current->storeID;
		} else {
			$this->smartyVars['showStoreLinks'] = 1;
			$this->smartyVars['hideUpgradeLink'] = 1;
		}

		$this->smartyVars['licenseErrors'] = implode("<br />", $GLOBALS['licenseErrors']);

		require_once("object_managers/AdminManager.php");
		$this->smartyVars["showRussianCertification"] = ("RU" == AdminManager::getMasterAdmin()->Country->countries_iso_2);

		$this->addTemplate("modules/ShowSystemLicenseInfo");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();

	}
}
