<?php

require_once("lib-action/action.php");

class ShowSystemServerInfo extends MB_Action
{
	public function execute()
	{
		parent::execute();

		$this->smartyVars["productVersion"] = PRODUCT_VERSION;
		$this->smartyVars["productBuild"] = PRODUCT_BUILD;

		global $CONF;
		$this->smartyVars["system"]["db"]["version"] = $CONF["system"]["db"]["version"];
		$this->smartyVars["system"]["db"]["description"] = ($CONF["system"]["db"]["description"]) ? $CONF["system"]["db"]["description"] : blmsg("TRANS_UNKNOWN");
		$this->smartyVars["system"]["php"]["version"] = phpversion();
		$this->smartyVars["system"]["php"]["memory_limit"] = ini_get("memory_limit");
		$this->smartyVars["system"]["server"]["uname"] = php_uname("s") . " " . php_uname("r") . " " . php_uname("m");
		$this->smartyVars["system"]["server"]["version"] = $_SERVER["SERVER_SOFTWARE"];
		require_once("lib-mbapi/include/curl/curl.php");
		$this->smartyVars["system"]["curl"]["version"] = Curl::getCurlVersion();

		$query = $this->getMBAPIQuery("GetModules", "", array("moduleType" => "all"));
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);
		$results = $data["mbapi"][0]["results"][0];
		if (0 === $this->addMBAPIErrors($data) && !$this->getNumErrors()) {
            $results = collapseArrayElements($results);
			require_once("objects/PaymentGateway.php");
			require_once("lib-mbapi/include/modules/registrar/registrar.php");
            foreach ($results as $type => $modules) {
                foreach ($modules as $module => $values) {
                    $this->smartyVars[$type][$module] = $values;
					switch ($type) {
					case "gateway":
						$this->smartyVars[$type][$module]["status"] = PaymentGateway::statusName($values["status"]);
						break;
					case "registrar":
						$this->smartyVars[$type][$module]["status"] = (Registrar::STATUS_STABLE == $values["status"]) ? "TRANS_STABLE" : "TRANS_TESTING";
						break;
					}
                }
				uasort($this->smartyVars[$type], array($this, "compareDisplayName"));
            }
        }

		$this->addTemplate("modules/ShowSystemServerInfo");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	private function compareDisplayName($moduleLeft, $moduleRight)
	{
		return strcasecmp($moduleLeft["displayName"], $moduleRight["displayName"]);
	}
}
