<?php

require_once(dirname(__FILE__)."/".str_repeat("../",5)."lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowPanelDetails extends MB_Action
{
	public $params = array("configGroupID");

	public function execute()
	{
		parent::execute();

		$moduleEnabled = NULL;

		$configGroupID = (int)($_REQUEST["configGroupID"]);
		$serverGroupID = (int)($_REQUEST["serverGroupID"]);

		require_once("lib-mbapi/mbapi.php");
		$xml = $this->getMBAPIQuery("GetConfigs", "", array("configGroupID" => $configGroupID,"getFormAttributes" => 1));
		$data = dispatchMBAPI($xml, 1);

		$configParams =& correctArray($data["mbapi"][0]["results"][0]["configs"][0]["config"]);
		foreach($configParams as $mod) {
			if($mod["configParamName"]=="panelMaxAccounts" && (int) $mod["configParamValue"]) {
				$moduleDisplayInfo[$mod["configParamName"]] = $mod["configParamValue"];
			} else if($mod["configParamName"]!="panelMaxAccounts"){
				$moduleDisplayInfo[$mod["configParamName"]] = $mod["configParamValue"];
			}
		}
		if(isset($moduleDisplayInfo["modulePassword"])) {
			unset($moduleDisplayInfo["modulePassword"]);
		}

		$panelName = Factory()->ControlPanel($configGroupID)->module_name;

		require_once ("ModuleTool.php");
		$p = ModuleTool::getModuleInstance("panel", $panelName, array("subCommand" => "panelDummy", "configGroupID" => $configGroupID));
		$capabilities = $p->getCapabilities();

		/*
			PANEL_GETTESTS
			PANEL_GETSERVERLOAD
			PANEL_SETPACKAGES
			PANEL_GETCLIENTS
			PANEL_GETDOMAINS
			PANEL_GETBANDWIDTH
			PANEL_CLIENTLOGIN
			PANEL_ADDONUPGRADE
			PANEL_ADDONDOWNGRADE
			PANEL_PACKAGEUPGRADE
			PANEL_PACKAGEDOWNGRADE
		*/

		//Make sure that the module is enabled
		foreach($configParams as $key => $value) {

			if($value["configParamName"] == "moduleEnabled") {
				$moduleEnabled = (int) $value["configParamValue"];
			}
		}

		$loadResults = $clientResults = $domainResults = NULL;

		if($moduleEnabled) {

			//Check each capability relevent for this page
			if($capabilities[PANEL_GETSERVERLOAD]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetServerLoad</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$load = dispatchMBAPI($xml,1);
				$loadResults =& correctArray($load["mbapi"][0]["results"][0]);
				$load = NULL;
			} else if($capabilities[PANEL_GETTESTS]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetTest</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$load = dispatchMBAPI($xml,1);
				$loadResults =& correctArray($load["mbapi"][0]["results"][0]);
				$load = NULL;
			}
			$clientsPerPage = 50;
			if($capabilities[PANEL_GETCLIENTS]) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetClients</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<numRecords>".$clientsPerPage."</numRecords>
							<recordOffset>".(int)$_REQUEST["recordOffset"]."</recordOffset>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$clients = dispatchMBAPI($xml,1);
				$clientResultsTemp =& correctArray($clients["mbapi"][0]["results"][0]);

				unset($clients);

				$this->smartyVars["totalPanelClients"] = $clientResultsTemp["totalClients"];
				$this->smartyVars["clientsPerPage"] = $clientsPerPage;
				$this->smartyVars["recordOffset"] = (int)$_REQUEST["recordOffset"];

				$this->smartyVars["pcpages"] = array();
				for ($xi=0; $xi<$clientResultsTemp["totalClients"]/$clientsPerPage; $xi++){
					$this->smartyVars["pcpages"][] = $xi*$clientsPerPage;
				}

				//See if they are MB clients and fix the IDs
				foreach($clientResultsTemp as $id => $value) {
					if ($id=="totalClients") continue;
					if(is_array($value) && $value[0]["password"]) {
						//encrypt the password before sending to the template
						$pr = dispatchMBAPI(toXML(array(
							"mbapi" => array(
								"command" => "GetEncryptedText",
								"params" => array(
									"text" => $value[0]["password"]
								),
							),
						)),1);
						$encryptedPassword = $pr["mbapi"][0]["results"][0]["text"][0];
						$value[0]["password"] = $clientResultsTemp[$id][0]["password"] = $encryptedPassword;
					}

					$mbClient = NULL;
					$value[0]["clientID"] = 0;
					$query = $this->getMBAPIQuery("GetContacts", "", array("contactEmail" => $value[0]["email"]));
					$data = dispatchMBAPI($query, 1);

					if((int) $data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
						//Grab the first clientID
						$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
						$value[0]["clientID"] = $mbClient["clientID"];
					} else {
						//Try the company name
						$query = $this->getMBAPIQuery("GetClients", "", array("clientCompany" => $value[0]["company_name"]));
						$data = dispatchMBAPI($query, 1);

						if((int) $data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
							$mbClient =& correctArray($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]);
							$value[0]["clientID"] = $mbClient["clientID"];
						}
					}

					$clientResults[str_replace("client_","",$id)] = $value[0];
				}
				$clientResultsTemp = NULL;
			}

			//To reduce the risk of memory overload, don't make the domain call if more than 50 clients were pulled in
			$runDomainsCall = TRUE;
			if((array) $clientResults) {
				$runDomainsCall = (count($clientResults) > $clientsPerPage+1)? FALSE : TRUE;
			}
			//Check each capability relevent for this page
			if($capabilities[PANEL_GETDOMAINS] && $runDomainsCall) {
				$xml = "
				<mbapi>
				<command>ProcessPanel</command>
				<subCommand>panelGetDomains</subCommand>
				<showXMLHeader>0</showXMLHeader>
				<params>
					<panel>
						<$panelName>
						<params>
							<numRecords>".$clientsPerPage."</numRecords>
							<recordOffset>".(int)$_REQUEST["recordOffset"]."</recordOffset>
							<configGroupID>$configGroupID</configGroupID>
						</params>
						</$panelName>
					</panel>
				</params>
				</mbapi>";

				$domain = dispatchMBAPI($xml,1);

				$domainResultsTemp =& correctArray($domain["mbapi"][0]["results"][0]);
				$domain = NULL;

				//See if they are MB clients and fix the IDs
				foreach($domainResultsTemp as $id => $value) {
					$mbClient = $data = $e = $d = NULL;
					$value[0]["clientID"] = 0;

					if($value[0]["email"]) {
						$query = $this->getMBAPIQuery("GetContacts", "", array("contactEmail" => $value[0]["email"]));
						$data = dispatchMBAPI($query, 1);

						if((int) $data["mbapi"][0]["header"][0]["numResults"][0]) {
							$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
							$value[0]["clientID"] = $mbClient["clientID"];
						}
					}

					if(!$value[0]["clientID"]) {
						//need to change this in the future to account for tlds like .co.uk
						$domain = explode(".",$value[0]["domain_name"]);

						$d = new DataSource(
							"domainsGeneric",
							array(
								"domainSLD" => $domain[0],
								"domainTLD" => $domain[1],
								"packages" => array(
									"packageType" => "hosting",
								),
							)
						);

						$e = $d->getEssential();

						if((array) $e[0]["packages"][0]["clientID"]) {
							$value[0]["clientID"] = $e[0]["packages"][0]["clientID"];
						} else if((array) $e[1]["packages"][0]["clientID"]) {
							$value[0]["clientID"] = $e[1]["packages"][0]["clientID"];
						}
					}

					if((int) $data["mbapi"][0]["header"][0]["numResults"][0] > 0) {
						$mbClient =& correctArray($data["mbapi"][0]["results"][0]["contacts"][0]["contact"][0]);
						$value[0]["clientID"] = $mbClient["clientID"];
					} else {
						//Try the company name
						if($value[0]["company_name"]) {
							$query = $this->getMBAPIQuery("GetClients", "", array("clientCompany" => $value[0]["company_name"]));
							$data = dispatchMBAPI($query, 1);

							if((int) $data["mbapi"][0]["header"][0]["numResults"][0] == 1) {
								$mbClient =& correctArray($data["mbapi"][0]["results"][0]["clients"][0]["client"][0]);
								$value[0]["clientID"] = $mbClient["clientID"];
							}
						}
					}

					$domainResults[str_replace("domain_","",$id)] = $value[0];
				}
				$domainResultsTemp = NULL;
			}

			//Put the client and domain arrays together if needed
			if($clientResults && $domainResults) {
				foreach($domainResults as $panelDomainID => $value) {
					$clientResults[$value["client_id"]]["domain"][] = $value;
					$clientResults[$value["client_id"]]["domains"] .= $value["domain_name"]."|";
				}
			}

			//Move the MB client IDs up from the domain record if they are set
			$tempClient = NULL;
			foreach((array)$clientResults as $panelClientID => $value) {
				$tempClient = $value;
				unset($tempClient["domain"]);
				$tunnelVars[$panelClientID] = base64_encode(serialize($tempClient));
				if(!$value["clientID"]) {
					if(is_array($value["domain"])) {
						foreach($value["domain"] as $k => $domain) {
							if($domain["clientID"]) {
								$clientResults[$panelClientID]["clientID"] = $domain["clientID"];
							}
						}
					}
				}
			}
		}// Module Enabled

		$smartyVars = $this->smartyVars;
		if($loadResults) {
			$this->smartyVars["load"] = $loadResults;
		}
		if($clientResults) {
			$this->smartyVars["clientResults"] = $clientResults;
		}
		if($domainResults) {
			$this->smartyVars["domainResults"] = $domainResults;
		}
		if($tunnelVars) {
			$this->smartyVars["tunnelVars"] = $tunnelVars;
		}
		$this->smartyVars["moduleDisplayInfo"] = $moduleDisplayInfo;
		$this->addTemplate("modules/ShowPanelDetails", collapseArrayElements($smartyVars), 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}