<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

/**
 * This action takes the information provided by the AddNews action, and tries to store it in the 
 * database as a news article. Note that the adminID associated with the new news article will be 
 * that of the current session. Once complete, this action redirects to the ShowNewsDetails action 
 * for the new news article, so long as an error has not occurred.
 */
class AddNewsResponse extends MB_Action
{
	public $params = array(
		"newsGroupID",
		"newsSubject",
		"newsShortBody",
		"newsBody",
		"newsActive",
		"priorityID",
	);

	public function execute()
	{
		global $CONF;
		parent::execute();
		
		$this->setReferralActionID( getActionID("AddNews") );
		$this->setReferralActionFile( "news.php" );
		
		$success = $this->validateMultiInputs(array(
					"newsGroupID" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					"newsSubject" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"newsShortBody" => INPUT_RESTRICTION_STRING,
					"newsBody" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
					"newsActive" => INPUT_RESTRICTION_INT|INPUT_RESTRICTION_REQUIRED,
					"priorityID" => INPUT_RESTRICTION_INT));
		
		$custom = array(
			"adminID" => $CONF["user"]["id"],
			"newsGroupIDs" => array("newsGroupID" => bgpc("newsGroupID")),
		);
		$query = $this->getMBAPIQuery("SetNews", "insert", $custom);
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			redirect("news.php", "ShowNews");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}