<?php
require_once dirname(__FILE__) . "/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class AddHistoricalPackage extends MB_Action
{
	public function execute()
	{
		$this->assignMode();
		$this->assignProductInfo();
		$this->assignClientInfo();
		$this->assignDateHandlers();
		$this->assignDefaults();

		$domainParams = array();
		if (!is_null($domainName = bgpc("domainName"))) {
			$domainParams["domainName"] = billing_safetyhtml($domainName);
		}
		if (!is_null($domainTLD = bgpc("domainTLD"))) {
			$domainParams["domainTLD"] = billing_safetyhtml($domainTLD);
		}

		$this->mergeFormState($domainParams);
		$this->addTemplate("packages/AddHistoricalPackage");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	protected function assignMode()
	{
			$this->smartyVars["mode"] = $mode = $_REQUEST["mode"];
			$this->smartyVars["historical"] =
			$this->historical =
				$mode == "2" ? true : false;

			$this->smartyVars["clientID"] = getParam("clientID");
			$this->smartyVars["orderFormID"] = getParam("orderFormID");
			$this->smartyVars["productID"] = getParam("productID");
			$this->smartyVars["productVariantID"] = getParam("productVariantID");
			$this->smartyVars["cycleID"] = getParam("cycleID");
	}

	protected function assignProductInfo()
	{
		$d = new DataSource(":products", $params = array(
			"productID" => $_REQUEST["productID"],
			"orderFormItems" => array(
				"orderFormID" => $_REQUEST["orderFormID"],
				"orderForm" => array(
				),
			),
			"productVariants" => array(
				"productVariantID" => $_REQUEST["productVariantID"],
				"TLD" => array(
				),
				"productVariantPrices" => array(
					"cycleID" => $_REQUEST["cycleID"],
					"cycle" => array(
					),
				),
			),
			"productAttributes" => array(
				"serverGroupID" => "*",
				//"groupBy" => array(
				//	"column" => "serverGroupID",
				//),
				"serverGroup" => array(
					"configGroups" => array(
						"column" => array(
							"configGroupID",
						),
						"configParams" => array(
							"column" => array(
								"configGroupID",
								"configParamValue",
							),
							"configParamName" => "moduleDisplayName",
							"comparisonOperator" => "=",
						),
					),
				),
			),
		));
		//show($params);
		$this->e = $e = $d->getEssential();
		//show($e);
		$vars = array(
			"product" => $this->product = $e[0],
			"orderForm" => $this->orderForm = $e[0]["orderFormItems"][0]["orderForm"][0],
			"productVariant" => $this->productVariant = $e[0]["productVariants"][0],
			"TLD" => $this->TLD = $this->productVariant["TLD"][0],
			"productVariantPrices" => $this->productVariantPrices = $this->productVariant["productVariantPrices"],
			"cycle" => $this->cycle = $this->productVariantPrices[0]["cycle"][0],
			"serverGroupAttributes" => $this->serverGroupAttributes = $this->product["productAttributes"],
		);
		$this->productID = $this->product["productID"];
		$this->orderFormID = $this->orderForm["orderFormID"];
		$this->productVariantID = $this->productVariant["productVariantID"];
		$this->tldID = $this->TLD["tldID"];
		$this->cycleID = $this->cycle["cycleID"];

		$this->currencyID = $vars["currencyID"] = $this->orderForm["currencyID"];

		$this->clientID = (int) $_REQUEST["clientID"];
		//show($vars);

		$vars["cycle"]["cycleDisplayName"] = $this->cycle["cycleDisplayName"] = constantize($this->cycle["cycleDisplayName"]);

		$productVariantPrices = array();
		foreach((array)$this->productVariantPrices as $price) {
			if($price["currencyID"] == $this->currencyID) $productVariantPrices[] = $price;
		}
		$priceT = new Table($productVariantPrices);
		$priceT->setSource("variantPrices");
		$priceT->alterState(TABLE_STATE_INTERNAL);
		$priceT->setKey("productVariantPriceType");
		$priceT->setName("productVariantPriceAmount");
		$prices = $priceT->getOptions();
		$vars["prices"] = $prices;

		$productT = new Table(array($this->product));
		$productT->setSource("products");
		$productT->alterState(TABLE_STATE_INTERNAL);
		$this->product = $productT->getOne();
		$vars["productType"] = $this->type = $type = $this->product["productType"];

		if($type == "domain") {
			$this->smartyVars["tldID"] = $this->TLD["tldID"];
			$this->smartyVars["tldExtension"] = $this->TLD["tldExtension"];
		} else {
			// uniquize it by server group id
			$serverGroups = array();
			foreach((array)$this->serverGroupAttributes as $serverGroupAttribute) {
				$serverGroups[$serverGroupAttribute["serverGroupID"]] = $serverGroupAttribute;
			}
			$this->serverGroupAttributes = array_values($serverGroups);
			$vars["NotPleskPanel"] = false;
			foreach (array_keys($serverGroups) as $serverGroupId) {
				$controlPanels = Factory()->ServerGroup($serverGroupId)->ControlPanelList();
				foreach ($controlPanels as $panel) {
					if (false === $panel->isPlesk()) {
						$vars["NotPleskPanel"] = true;
						break;
					}
				}
				if (true === $vars["NotPleskPanel"]) {
					break;
				}
			}

			$serverGroups = $panelsByServerGroupID = array();
			foreach((array)$this->serverGroupAttributes as $serverGroupAttribute) {
				$serverGroup = $serverGroupAttribute["serverGroup"][0];
				$serverGroupID = $serverGroup["serverGroupID"];
				$serverGroupName = $serverGroup["serverGroupName"];
				$serverGroups[$serverGroupID] = $serverGroupName;

				$panelsByServerGroupID[$serverGroupID] = array();
				foreach($serverGroup["configGroups"] as $configGroup) {
					$serverID = $configGroup["configGroupID"];
					$serverName = $configGroup["configParams"][0]["configParamValue"];
					$panelsByServerGroupID[$serverGroupID][$serverID] = $serverName;
				}

			}

			$this->serverGroups = $vars["serverGroups"] = $serverGroups;
			$this->panelsByServerGroupID = $vars["panelsByServerGroupID"] = $panelsByServerGroupID;
		}

		// do we have an lek stored?
		require_once("object_managers/CryptManager.php");
		if ( CryptManager::isEncryptionEnabled() ) {
			$this->smartyVars["needKey"] = (CryptManager::isLekEnabled() ? 0 : 1);
		}
		//show($vars);
		$this->smartyVars += $vars;
	}

	protected function assignClientInfo()
	{
		$type = $this->smartyVars["productType"];
		$vars = array();

		require_once('objects/ClientBillingAccount.php');
		$params = array(
			"clientID" => $this->clientID,
			"contacts" => array(
				"contactActive" => "true",
				"billingAccounts" => array(
					"billingAccountActive" => "true"
				),
			),
		);

		$domainParams = array();
		switch($type) {
			case "domain":
				$domainParams = array(
					"domainTLD" => $this->TLD["domainTLD"],
					"comparisonOperator" => "=",
				);
			case "hosting":
				$vars["associateDomain"] = true;

				$params += array(
					"packages" => array(
						"packageActive" => "true",
						"column" => array(
							"packageID",
							"clientID",
						),
						"domains" => array(
							"domainActive" => "true",
							"column" => array(
								"domainID",
								"domainSLD",
								"domainTLD",
							),
						) + $domainParams,
					),
				);
				break;
			default:
				$vars["associateDomain"] = false;
		}

		$d = new DataSource(":clients", $params);
		$e = $d->getEssential();

		require_once mb_path("/lib-billing/include/config/internal/mbapimap/billingAccounts.php");
		$billingAccounts = array();
		$this->primaryContact = array();
		foreach($e[0]["contacts"] as $contact) {
			if($contact["contactPrimary"]) {
				$this->primaryContact = $contact;
			}
			foreach((array)$contact["billingAccounts"] as $billingAccount) {
				refBillingAccountColumnGenerator($billingAccount);
				$billingAccounts[$billingAccount["billingAccountID"]] = $billingAccount["billingAccountDisplayName"];
			}
		}
		$vars["clientInfo"] = $e[0] + $this->primaryContact;
		$vars["clientBillingAccounts"] = $billingAccounts;
		$vars["clientDomains"] = array();
		if($vars["associateDomain"]) {
			foreach((array)$e[0]["packages"] as $package) {
				foreach((array)$package["domains"] as $domain) {
					$vars["clientDomains"][$domain["domainID"]] = $domain["domainSLD"] . "." . $domain["domainTLD"];
				}
			}
		}

		//show($vars);
		//show($params);
		//show($e);
		//exit;

		$this->smartyVars += $vars;
	}

	private function assignDateHandlers()
	{
		if($this->product["productStopNumCycles"] != 1) {
			$this->formDefaults["packageNextRenewal"] = mktime();
			$this->setupDateSelector("packageNextRenewal");
		}
		$this->formDefaults["packageStartDate"] = mktime();
		$this->setupDateSelector("packageStartDate");

		if($this->type == "domain") {
			$this->formDefaults["registerDomain"] = mktime();
			$this->setupDateSelector("registerDomain", !$this->historical);
		} else {
			foreach($this->serverGroups as $serverGroupID => $serverGroupName) {
				$this->formDefaults["sg" . $serverGroupID . "create"] = mktime();
				$this->setupDateSelector("sg" . $serverGroupID . "create", !$this->historical);
			}
		}
	}

	private function assignDefaults()
	{
			$this->formDefaults["generalPrice"] = isset($this->smartyVars["prices"]["general"]) ? $this->smartyVars["prices"]["general"] : -1;
			$this->formDefaults["setupPrice"] = isset($this->smartyVars["prices"]["setup"]) ? $this->smartyVars["prices"]["setup"] : -1;
			$this->formDefaults["transferPrice"] = isset($this->smartyVars["prices"]["transfer"]) ? $this->smartyVars["prices"]["transfer"] : -1;
	}
}
