<?php
// +----------------------------------------------------------------------+
// | ModernBill [TM] .:. Client Billing System                            |
// +----------------------------------------------------------------------+
// | Copyright (c) 2001-2005 ModernGigabyte, LLC                          |
// +----------------------------------------------------------------------+
// | This source file is subject to the ModernBill End User License       |
// | Agreement (EULA), that is bundled with this package in the file      |
// | LICENSE, and is available at through the world-wide-web at           |
// | http://www.modernbill.com/extranet/LICENSE.txt                       |
// | If you did not receive a copy of the ModernBill license and are      |
// | unable to obtain it through the world-wide-web, please send a note   |
// | to license@modernbill.com so we can email you a copy immediately.    |
// +----------------------------------------------------------------------+
// | Authors: ModernGigabyte, LLC <info@moderngigabyte.com>               |
// | Support: http://www.modernsupport.com/modernbill/                    |
// +----------------------------------------------------------------------+
// | ModernGigabyte and ModernBill are trademarks of ModernGigabyte, LLC. |
// +----------------------------------------------------------------------+

require_once dirname(__FILE__) . "/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-tk/toolkit.php");

class AddHistoricalPackageMenu extends MB_Action {
	function AddHistoricalPackageMenu() {
		parent::MB_Action();
		$this->stringRep = "AddHistoricalPackageMenu";
		$this->params = array();
	}

	function execute() {
		global $CONF;

		//echo '<pre>';
		//print_r($_REQUEST);
		//echo '</pre>';

		$mode = getParam("mode");
		$clientID = getParam("clientID");
		$orderFormID = getParam("orderFormID");
		$productID = getParam("productID");
		$productVariantID = getParam("productVariantID");
		$cycleID = getParam("cycleID");
		$response = getParam("response", "s");

		$historical = $mode == "2" ? true : false;
		$this->smartyVars["historical"] = $historical;
		do {
			$try = false;
			// get selected information
			if($mode) {
				$this->smartyVars["mode"] = $mode;
			}
			if($clientID) {
				$this->smartyVars["clientID"] = $clientID;
			}
			if($orderFormID && !isset($this->smartyVars["orderForm"])) {
				$this->smartyVars["orderFormID"] = $orderFormID;
				$oft =& $this->getTableFromSource(new DataSource("orderForms", array("orderFormID" => $orderFormID)));
				$this->smartyVars["orderForm"] = $oft->getOne();
				$this->smartyVars["orderFormName"] = $oft->getOneName();
			}
			if($productID && !isset($this->smartyVars["product"])) {
				$this->smartyVars["productID"] = $productID;
				$pt =& $this->getTableFromSource(new DataSource("products", array("productID" => $productID)));
				$this->smartyVars["product"] = $pt->getOne();
				$this->smartyVars["productName"] = $pt->getOneName();
			}
			if($productVariantID && !isset($this->smartyVars["productVariant"])) {
				$this->smartyVars["productVariantID"] = $productVariantID;
				$pvt =& $this->getTableFromSource(new DataSource("productVariants", array("productVariantID" => $productVariantID)));
				$this->smartyVars["productVariant"] = $pvt->getOne();
				$this->smartyVars["productVariantPrimaryName"] = $pvt->getOneName();
			}
			if($cycleID && !isset($this->smartyVars["cycle"])) {
				$this->smartyVars["cycleID"] = $cycleID;
				$ct =& $this->getTableFromSource(new DataSource("cycles", array("cycleID" => $cycleID)));
				$this->smartyVars["cycle"] = $ct->getOne();
				$this->smartyVars["cycleDisplayName"] = $ct->getOneName();
			}

			// get selection information
			if($clientID && $orderFormID && $productID && $productVariantID && $cycleID) {
				redirect("packages.php", getActionID("AddHistoricalPackage"), array(
					"mode" => $mode,
					"clientID" => $clientID,
					"orderFormID" => $orderFormID,
					"productID" => $productID,
					"productVariantID" => $productVariantID,
					"cycleID" => $cycleID,
				));
			} else if($clientID && $orderFormID && $productID && $productVariantID) {
				// get cycles associated with the product of the selected product variant
				$productVariant = Factory()->ProductVariant($productVariantID);
                $this->smartyVars["cycleOptions"] = DataObject::getMapOf($productVariant->getConfiguredCycles(), "cycle_id", "cycle_display_name");
				$this->addTemplate("packages/AddHistoricalPackageMenu");
                
			} else if($clientID && $orderFormID && $productID) {
				// get product variants of the products associated with the order form
				$this->smartyVars["productVariantOptions"] = optionsFor("productVariants", array("orderFormID" => $orderFormID, "productID" => $productID, "productVariantActive" => 1));
				if(count($this->smartyVars["productVariantOptions"]) == 1) {
					$try = true;
					$productVariantID = current($phpsucks = array_keys($this->smartyVars["productVariantOptions"]));
					unset($this->smartyVars["productVariantOptions"]);
					continue;
				}
				foreach($this->smartyVars["productVariantOptions"] as $productVariantID => $productVariantDisplayName) {
					if("" != $productVariantDisplayName) {
						continue;
					}

					$this->smartyVars["productVariantOptions"][$productVariantID] = Factory()->TLD(Factory()->ProductVariant($productVariantID)->tld_id)->tld_name;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID && $orderFormID) {
				// get product variants of the products associated with the order form
				// Use generic data source for optimized option fetching
				$this->smartyVars["productOptions"] = array();
				$products = optionsFor("products", array("orderFormID" => $orderFormID, "productActive" => 1, "getNonAddons" => "1"));
				require_once("object_managers/ProductManager.php");
				foreach ( $products as $key => $product ) {
					$currentProduct = Factory()->Product($key);
					if (ProductManager::isValidStoreHostingProduct($currentProduct)) {
						$this->smartyVars["productOptions"][$currentProduct->id] = $currentProduct->product_name;
					}
				}
				if(count($this->smartyVars["productOptions"]) == 1) {
					$try = true;
					$productID = current($phpsucks = array_keys($this->smartyVars["productOptions"]));
					unset($this->smartyVars["productOptions"]);
					continue;
				}
				if (0 == count($this->smartyVars["productOptions"]))
				{
					$this->smartyVars["noObjectsMessage"] = blmsg("TRANS_NO_ACTIVE_PLANS_ASSIGNED_TO_SELECTED_ONLINE_STORE");
					unset($this->smartyVars["productOptions"]);
					$orderFormID = NULL;
					$try = true;
					continue;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else if($clientID) {
				// get order forms
				if($productID) {
					$oD = new DataSource(
						"productsGeneric",
						array(
							"productID" => $productID,
							"orderForms" => array(
								"optionColumns" => 1,
							)
						)
					);
					$oE = $oD->getEssential();
					$oT = new Table($oE[0]["orderForms"], "orderFormID", "orderFormName");
					$this->smartyVars["orderFormOptions"] = $oT->getOptions();
				} else {
					$this->smartyVars["orderFormOptions"] = optionsFor("orderForms");
				}
				if(count($this->smartyVars["orderFormOptions"]) == 1) {
					$try = true;
					$orderFormID = current($phpsucks = array_keys($this->smartyVars["orderFormOptions"]));
					unset($this->smartyVars["orderFormOptions"]);
					continue;
				}
				$this->addTemplate("packages/AddHistoricalPackageMenu");
			} else {
				$this->addError(TRANS_ACTIONERROR, "Needs at least a client ID to get started.");
				break;
			}

		} while($try);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
