<?php
require_once("lib-action/action.php");

class ChargeVirtualTerminal extends MB_Action
{
	public function execute()
	{
		parent::execute();

		if ( is_null($paymentGatewayID = bgpc("paymentGatewayID")) ) {
			throw new Exception("Missing parameter 'paymentGatewayID'");
		}
		$payment_gateway = Factory()->PaymentGateway($paymentGatewayID);
		$this->smartyVars["paymentGateway"] = $payment_gateway;

		$this->mergeCountryData(billing_get_user_locale()->country);

		$this->smartyVars["doaccounting"] = bgpc("doaccounting");

		$this->smartyVars["transactionAction"] = array(
			"charge" => TRANS_CHARGE,
			"auth" => TRANS_AUTH_ONLY,
		);
		loadConfigs("payment");
		global $CONF;
		$this->smartyVars["selectedTransactionAction"] = Settings()->paymentQueue_transactionAction;

		$this->smartyVars["cardTypes"] = $payment_gateway->acceptedCardTypes;
		$this->smartyVars["accepteCheck"] = $payment_gateway->acceptECheck;

		$this->smartyVars["billingCardExpYear"] = array();
		for ($i=date("Y"); $i<date("Y")+21; $i++){
			$this->smartyVars["billingCardExpYear"][$i] = $i;
		}
		$this->smartyVars["billingCardExpMonth"] = array();
		for ($i=1; $i<13; $i++){
			$this->smartyVars["billingCardExpMonth"][$i] = $i;
		}
		$this->smartyVars["accounttypes"] = getTypes("bankAccount");

		if ( "" != ($invoiceID = bgpc("invoiceID")) ) {
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $invoiceID,
						"getInvoiceLineItemsData" => 1,
						"getInvoiceLineItemsPaymentsData" => 1,
						"getTaxZonesData" => 1,
					),
				),
			)));
			$this->smartyVars["invoiceInfo"]["amountDue"] = $this->smartyVars["invoiceInfo"]["invoiceAmount"]-$this->smartyVars["invoiceInfo"]["invoiceAmountPaid"];
			if ( $this->smartyVars["invoiceInfo"]["lineItems"] ) {
				$this->smartyVars["clientInfo"] = $this->smartyVars["invoiceInfo"]["lineItems"][0];
			}
			$this->smartyVars["currencyID"] = $this->smartyVars["invoiceInfo"]["currencyID"];
		} else {
			$this->smartyVars["currencyID"] = bgpc("currencyID");
		}

		foreach ((array)$_REQUEST["lineItemPayments"] as $k=>$pm){
			$_REQUEST["lineItemPayments"][$k] = $this->getNumberFromInput($pm);
		}

		$this->smartyVars["formValues"] = array(
			"invoiceID" => (int)$_REQUEST["invoiceID"],
			"contactAddress1" => $_REQUEST["contactAddress1"],
			"contactAddress2" => $_REQUEST["contactAddress2"],
			"countriesID" => (int)$this->smartyVars["selectedCountry"],
			"paymentAmount" => $this->getNumberFromInput($_REQUEST["paymentAmount"] ? $_REQUEST["paymentAmount"] : $this->smartyVars["invoiceInfo"]["amountDue"]),
			"paymentComments" => $_REQUEST["paymentComments"],
			"paymentMethod" => ($_REQUEST["paymentMethod"]!="echeck")?"card":"echeck",
			"billingCardNameOnCard" => ($_REQUEST["billingCardNameOnCard"])?$_REQUEST["billingCardNameOnCard"]:($this->smartyVars["clientInfo"]["clientID"])? billing_get_full_name($this->smartyVars["clientInfo"]["contactFirstname"], $this->smartyVars["clientInfo"]["contactLastname"]):"",
			"billingCardType" => (int)$_REQUEST["billingCardType"],
			"billingCardNum" => $_REQUEST["billingCardNum"],
			"billingCardExpMonth" => (int)$_REQUEST["billingCardExpMonth"],
			"billingCardExpYear" => (int)$_REQUEST["billingCardExpYear"],
			"cardCVV2" => $_REQUEST["cardCVV2"],
			"billingBankName" => $_REQUEST["billingBankName"],
			"billingBankState" => $_REQUEST["billingBankState"],
			"billingBankType" => $_REQUEST["billingBankType"],
			"billingBankAbaCode" => $_REQUEST["billingBankAbaCode"],
			"billingBankAccountNum" => $_REQUEST["billingBankAccountNum"],
			"billingBankLicenseNum" => $_REQUEST["billingBankLicenseNum"],
			"billingBankLicenseState" => $_REQUEST["billingBankLicenseState"],
			"billingBankDob" => $_REQUEST["billingBankDob"],
			"applyPaymentTo" => ($_REQUEST["applyPaymentsTo"]!="lineitems")?"invoice":"lineitems",
			"lineItemPayments" => $_REQUEST["lineItemPayments"],
			"paymentComments" => $_REQUEST["paymentComments"],
			"contactFirstName" => ($_REQUEST["contactFirstName"])?$_REQUEST["contactFirstName"]:$this->smartyVars["clientInfo"]["contactFirstName"],
		);

		$contactFields = array("contactFirstName", "contactLastName", "contactAddress1", "contactAddress2",
			"contactCity", "contactState", "contactZip", "contactPhone1", "contactEmail", "contactFax"
		);
		if ( "" != $invoiceID ) {
			foreach ( $contactFields as $field ) {
				$this->smartyVars["formValues"][$field] = bgpc($field, $this->smartyVars["clientInfo"][$field]);
			}
		} else {
			foreach ( $contactFields as $field ) {
				$this->smartyVars["formValues"][$field] = bgpc($field);
			}
		}

		$this->addTemplate("modules/ChargeVirtualTerminal", $this->smartyVars, 1);
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
