<?php
require_once("lib-action/action.php");

class ShowVirtualTerminals extends MB_Action
{
	public function execute()
	{
		parent::execute();

		require_once("objects/PaymentGateway.php" );
		$gatewayFilter = array("payment_gateway_type" => array(PaymentGateway::TYPE_PRIMARY));
		if (!is_null($invoiceID = bgpc("invoiceID"))) {
			$gatewayFilter["payment_gateway_type"][] = PaymentGateway::TYPE_HSPC_CREDIT_CARD;
		} else if (!is_null($paymentGatewayID = bgpc("paymentGatewayID"))) {
			$gatewayFilter["payment_gateway_id"] = $paymentGatewayID;
		}

		$this->smartyVars["paymentGateways"] = Factory()->PaymentGatewayList($gatewayFilter);
		if ( empty($this->smartyVars["paymentGateways"]) ) {
			$this->smartyVars["warningMessages"][] = blmsg("TRANS_PAYMENT_GATEWAYS_EMPTY_CONFIGURED_LIST");
		}


		if ( "" != ($invoiceID = bgpc("invoiceID")) ) {
			require_once("lib-mbapi/mbapi.php");
			$this->smartyVars["invoiceInfo"] = correctArray(grabFirstResultFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetInvoices",
					"params" => array(
						"invoiceID" => $invoiceID,
						"getInvoiceLineItemsData" => 1,
						"getInvoiceLineItemsPaymentsData" => 1,
						"getTaxZonesData" => 1,
					),
				),
			)));
			if ( $this->smartyVars["invoiceInfo"]["lineItems"] ) {
				$this->smartyVars["clientInfo"] = $this->smartyVars["invoiceInfo"]["lineItems"][0];
			}
		} else {
			require_once("object_managers/PaymentGatewayManager.php");
			$this->smartyVars["currencyList"] = PaymentGatewayManager::getAcceptedCurrencies();
			$this->smartyVars["selectedCurrency"] = billing_get_user_locale()->currency;
		}

		$this->addTemplate("modules/ShowVirtualTerminals");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}