<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class CaptureFunds extends MB_Action
{
	public function execute()
	{
		parent::execute();

		set_time_limit(0);
		ignore_user_abort();

		$failedTransactions = array();

		require_once("object_managers/CryptManager.php");
		if (CryptManager::MODE_LEK == CryptManager::getEncryptionMode()) {
			$key = CryptManager::getLekPin();
		} else if (CryptManager::MODE_PASSPHRASE == CryptManager::getEncryptionMode()) {
			$key = bgpc("key");
		} else {
			$key = null;
		}

		$captureQuery = array(
			"mbapi" => array(
				"command" => "ProcessCaptureFunds",
				"params" => array(
				),
			),
		);
		if (!is_null($key)) {
			$gatewayCall["mbapi"]["params"]["key"] = $key;
		}

		require_once("lib-mbapi/mbapi.php");
		foreach (bgpc("captureIDs", array()) as $tid => $v) {
			if ($v=='y'){
				$captureQuery["mbapi"]["params"]["transactionID"] = $tid;
				$results = dispatchMBAPI($captureQuery, 1);
				$result = $results["mbapi"][0]["results"][0]["result"][0];
				if ("success" != $result) {
					$failedTransactions[] = $tid;
                    getCurrentSession()->Storage->errorMessages[] = blmsg(
						"TRANS_PAYMENT_TRANSACTION_CAPTURE_ERROR_MSG",
						array("TRANSACTION_ID" => $tid, "ERROR" => $results["mbapi"][0]["header"][0]["errors"][0]["error"][0]["message"][0])
					);
				}
			}
		}

		if ((int)$_REQUEST["invoiceID"]){
	            redirect("invoices.php?action=".getActionID("ShowInvoiceDetails")."&invoiceID=".((int)$_REQUEST["invoiceID"])."&failedID=".$failedTransactions[0]."&sid=".secureInput($_REQUEST["sid"]));
		} else {
	        if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
	            redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
	        } else {
	            redirect("paymentqueue.php?action=".getActionID("ShowUncapturedFunds")."&failedID[]=".@implode("&failedID[]=", $failedTransactions)."&sid=".secureInput($_REQUEST["sid"]));
	        }
		}


		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}