<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");

class ShowCallbackLog extends MB_Action
{
	public function __construct()
	{
		parent::MB_Action();
		$this->params = array(
			"callbackLogAction",
			"callbackLogID",
			"clientID",
			"callbackLogType",
			"callbackLogTransactionID",
			"callbackLogDateCreated",
		);
		$this->sortColumns = array("callbackLogDateCreated");
	}

	public function execute()
	{
		parent::execute();

		$params = array(
			"callbackLogAttributes" => "",
		);

		if ((int)$_REQUEST["clientID"]){
			$this->smartyVars["paginationArgs"] = "clientID=".$params["clientID"];
		} elseif ((int)$_REQUEST["errors"]){
			$this->smartyVars["errorsOnly"] = 1;
			$params["clientID"] = 0;
			$this->smartyVars["paginationArgs"] = "errors=1";
		}


		$query = $this->getMBAPIQuery("GetCallbackLogs", "", $params, 1, 1, 1, 1);

		require_once mb_path("/lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);

		if ($data["mbapi"][0]["results"][0]["paginationLinks"]){
			$this->smartyVars["paginationLinks"] = collapseArrayElements($data["mbapi"][0]["results"][0]["paginationLinks"][0]);
		}

		$this->smartyVars["callbackLogs"] = correctArray(grabSimpleMBAPIResults($data));

		if ((int)$_REQUEST["clientID"]){
			$this->smartyVars["clientInfo"] = oneByID("clients", (int)$_REQUEST["clientID"], array("mergePrimaryContact"=>1));
		} else {
			// get all tax zone as simple results
			$clientIDs = array();
			foreach ((array)$this->smartyVars["callbackLogs"] as $cbl){
				$clientIDs[$cbl["clientID"]] = 1;
			}
			$clientIDs = array_keys($clientIDs);

			$clients = arrayFor("clientWithPrimary", array("clientID"=>$clientIDs));
			// grab the selectable ones while passing the ignore ID array
			$this->smartyVars["clients"] = grabHTMLOpsFromArray($clients, "clientID", "buildClientNameFromRecord");
			$this->smartyVars["clientContactIDs"] = grabHTMLOpsFromArray($clients, "clientID", "clientContactID");
		}

		$this->smartyVars["callbackLogTypes"] = getTypes("callbackLog");
		$this->smartyVars["callbackLogActions"] = getTypes("callbackAction");
		$this->addTemplate("paymentqueue/ShowCallbackLog");

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}

function buildClientNameFromRecord($row)
{
	return billing_get_full_name($row["contactFirstName"], $row["contactLastName"]);
}