<?php

require_once("lib-action/action.php");

class ShowUncapturedFunds extends MB_Action
{
	public $params = array("transactionID", "clientID", "billingAccountID");
	public $sortColumns = array("transaction_date_created");

	public function execute()
	{
		parent::execute();

		$this->smartyVars = array("invalidpoint"=>time()-(24*60*60*30));

		require_once("object_managers/CryptManager.php");
		$this->smartyVars["showPassword"] = (CryptManager::isLekEnabled() ? 0 : 1);

		if ($_REQUEST['failedID']){
			$this->smartyVars['failed'] = $_REQUEST['failedID'];
		}

		$transactionsQuery = "	<mbapi>
									<command>GetTransactions</command>
									<params>
										<authReturn>".getAPIStatusID("transactions", "authorized")."</authReturn>
										<getClientNames>1</getClientNames>
									</params>
								</mbapi>";

		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($transactionsQuery, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0) {

		 	$this->smartyVars["transactions"] = collapseArrayElements($results["transactions"][0]["transaction"]);
			if ($this->smartyVars["transactions"]["transactionID"]) {
				$this->smartyVars["transactions"] = array($this->smartyVars["transactions"]);
			}
			$smartyVars["paginationLinks"] = $results["paginationLinks"][0];

			$this->smartyVars['tabs'] = array(
				"transactions" => array(
					"url" => action_url("paymentqueue", "ShowTransactionLog"),
					"title" => blmsg("TRANS_SHOW_TRANSACTIONS"),
					"current" => false,
				),
				"uncapturedFunds" => array(
					"url" => action_url("paymentqueue", "ShowUncapturedFunds"),
					"title" => blmsg("TRANS_SHOW_UNCAPTURED_FUNDS"),
					"current" => true,
				),
				"paymentQueue" => array(
					"url" => action_url("paymentqueue", "ShowPaymentQueue"),
					"title" => blmsg("TRANS_SHOW_PAYMENT_QUEUE"),
					"current" => false,
				),
			);

			$this->addTemplate("paymentqueue/ShowUncapturedFunds");
		}
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}