<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class AddTLD extends MB_Action {

	function AddTLD() {
		parent::MB_Action();
		$this->stringRep = "AddTLD";
		$this->params = array("tldID");
	}

	function execute() {
		global $CONF;
		parent::execute();

		$tldNotSupported = (int) $_REQUEST["tldNotSupported"];
		//$this->smartyVars["TLDs"] = collapseArrayElements(protectArray($results["TLDs"][0]["TLD"]));
		$this->smartyVars["tldRenewTypes"] = $CONF["types"]["tldRenew"];
		$this->smartyVars["enabledDisabled"] = array(TRANS_DISABLED, TRANS_ENABLED);
		$this->smartyVars["yesNo"] = array(TRANS_YES, TRANS_NO);
		$this->smartyVars["transferTypes"] = $CONF["types"]["tldTransfer"];
		$this->smartyVars["IDNTypes"] = $CONF["types"]["tldIDN"];

		if($tldNotSupported) {
			$this->smartyVars["tldNotSupported"] = 1;
		}

		$registrars = array("");
		$registrarTLDs = array(" ", array());
		require_once("object_managers/BillingRegistrarManager.php");
		try {
			foreach(BillingRegistrarManager::getEnabledRegistrars() as $registrar) {
				$registrars[$registrar->id] = blmsg($registrar->name);
				$registrarTLDs[$registrar->id] = $registrar->getTLDs();
			}
		} catch (ProductException $e) {
			// skip Registrar errors
		}

		$this->smartyVars["registrars"] = $registrars;
		$this->smartyVars["registrarTLDs"] = $registrarTLDs;

		$this->mergeCycleData();

		$formDefaults = array();
		$this->mergeFormState($formDefaults);

		$this->addTemplate("products/AddTLD", $this->smartyVars);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}

	protected function mergeCycleData()
	{
		$conn = DatabaseManager::getConnection();
		$cycles = $conn->getAll(
			"SELECT * FROM cycles WHERE
				cycle_num_years >= 1 AND
				cycle_num_years <= 10 AND
				cycle_num_seconds = 0 AND
				cycle_num_minutes = 0 AND
				cycle_num_hours = 0 AND
				cycle_num_days = 0 AND
				cycle_num_months = 0
		");
		$this->smartyVars["cycleList"] = array();
		foreach ($cycles as $cycle) {
			$this->smartyVars["cycleList"][$cycle["cycle_id"]] = blmsg($cycle["cycle_display_name"]);
		}
		return 1;
	}
} // MB_Action
