<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class AddTLDResponse extends MB_Action {

	function AddTLDResponse() {
		parent::MB_Action();
		$this->stringRep = "AddTLDResponse";
		$this->params = array(
			"tldName",
			"tldExtension",
			"tldCustomExtensionActive",
			"registrarID",
			"tldActive",
			"tldWhoisServer",
			"tldWhoisResp",
			"tldWhoisMatchRule",
			"tldAutoSearch",
			"tldTransferMinimumCycleID",
			"tldMinimumCycleID",
			"tldMaximumCycleID",
			"tldRenewType",
			"tldIsTransferable",
			"tldTransferType",
			"tldIDNSupport",
			"tldIDNType",
			"tldRemoteLockEnabled",
			"tldNotSupported"
		);
	}

	/**
	 * The main method of this class that executes the AddTLDResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();


		$this->setReferralActionID(getActionID("AddTLD"));
		$this->setReferralActionFile("products.php");

		$thisTLD = bgpc("tldExtension");
		$registrarID = bgpc("registrarID");
		loadConfigs("domain");
		$registrarData = $CONF["domain"]["registrar"];

		$tldNotSupported = 0;
		$_REQUEST["tldNotSupported"] = 0;

		$success = $this->validateMultiInputs(
			array(
				"tldName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"tldExtension" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"tldCustomExtensionActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"registrarID" => INPUT_RESTRICTION_UNSIGNED_INT,
				"tldActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldWhoisServer" => INPUT_RESTRICTION_STRING,
				"tldWhoisResp" => INPUT_RESTRICTION_STRING,
				"tldWhoisMatchRule" => INPUT_RESTRICTION_STRING,
				"tldAutoSearch" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMaximumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRenewType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIsTransferable" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIDNSupport" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldIDNType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRemoteLockEnabled" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldNotSupported" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED
			), array(), array(), 0, array("tldNotSupported" => $tldNotSupported)
		);

		if($success) {
			$params = array();
			$this->applyRequestTo($params);

			$setQuery = new MBQuery("SetTLDs", "insert", $params);
			if($this->addErrorsFromResult($r =& $setQuery->getResult())) {
				$tldID = $r->getLastInsertID();
				$tld = Factory()->TLD($tldID);
				// upon new insert, create a default value for the sort order
				updateForKey(":TLDs", $tldID, array(
					"tldDisplayOrder" => $tldID,
				));
				$pd = new DataSource("products");
				$ps =& $pd->getSubject();
				$pt =& $ps->getTable();
				$productOptions = $pt->getOptions();
				if($productOptions) {
					$ptByType =& $pt->getAssociatedTablesBy("productType");
					$productIDs =
						  isset($ptByType[getTypeID("products", TRANS_DOMAIN_PRODUCT)])
						? $ptByType[getTypeID("products", TRANS_DOMAIN_PRODUCT)]->getKeys()
						: array();
					//print_r($productIDs);
					$productVariants = array();
					foreach($productIDs as $productID) {
						$productVariant = array(
							"productID" => $productID,
							"productVariantActive" => 0,
							"productVariantDisplayName" => $tld->tld_name,
							"tldID" => $tldID,
						);
						$productVariants[] = $productVariant;
					}
					//print_r($productVariants);

					if($productVariants) {
						$setVariantQuery = new MBQuery(
							"SetProducts", "insert",
							array(
								"productVariants" => array(
									"productVariant" => $productVariants,
								),
							)
						);
						if(!$this->addErrorsFromResult($r =& $setVariantQuery->getResult()))  break;
						//echo '<pre>';
						//echo htmlentities($setVariantQuery->getXMLQuery());
						//echo '</pre>';
					}
				}
				if(!$this->goBack()) redirect("products.php", getActionID("ShowTLDs"), array());

				//exit;
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTLDResponse