<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class EditPanelAttributeResponse extends MB_Action
{
	public $params = array("productID");

	public function execute()
	{
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
			),
			array(),
			array(),
			0,
			array(
				"loadActionFile" => "products",
				"loadActionID" => getActionID("EditProductAttributes"),
			)
		);
		if($success) {

			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
				$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getProductAttributeData" => 1, "getServerGroupGhostData" => 1));
				$r =& $q->getResult();
				if($r->getSuccess()) {
				}
				$ps =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product"),
					"productID", "productName"
				);
				$pt =& $ps->getTable();
				$product = $pt->getOne();

				$gs =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", "ghostServerGroups", "ghostServerGroup"),
					"serverGroupID", "serverGroupName"
				);
				$serverGroups = $gs->getAssociated();
				$serverGroups[0] = array();

				$attributes = array();
				$invalidParams = array();
				$secure = array();
				foreach($serverGroups as $serverGroupID => $serverGroupData) {
					$attributes[$serverGroupID] = array();
					$serverGroupAttributeData =& $attributes[$serverGroupID];

					$panelAttributes = $this->getAttributesForServerGroupID($serverGroupID, $product, false, true);

					if ($panelAttributes && !is_numeric(key($panelAttributes))){
						$iter = 0;
						foreach($panelAttributes as $attrName => $attrData) {
							$q =& $attrData['question'];
							if($attrData['secure']) {
								$secureArgs[] = $attrName;
							}

							$question = 'question_' . $serverGroupID . '_' . ++$iter;
							if(isset($_REQUEST[$question])) {
								$answers = $_REQUEST[$question];

								// handle input validation
								$errors = $q->validateFor($answers);
								if($errors) {
									$invalidParams[] = $question . '-' . dechex($errors);
								}
							} else {
								$answers = NULL;
							}

							$answerSet = (array) $answers;
							if (isset($attrData['valueMap']) && $q->type!='b'){
								$valueMap = $attrData['valueMap'];

								foreach ($valueMap as $searchValue => $mappings){
									foreach($mappings as $mappedAttributeName => $possibleValues) {
										list($matchValue, $noMatchValue) = $possibleValues;

										$serverGroupAttributeData[$mappedAttributeName] = in_array($searchValue, $answerSet) ? $matchValue : $noMatchValue;
									}
								}
							} elseif ($q->type=='b'){
								$serverGroupAttributeData[$attrName] = $answerSet[0];
								$serverGroupAttributeData[$attrName.'UNIT'] = $answerSet[1];
							} else {
								$serverGroupAttributeData[$attrName] = end($answerSet);
							}
						}
					} elseif ($panelAttributes){
						deleteFor(":productAttributes", array(
							"productID" => $productID,
							"serverGroupID" => $serverGroupID,
						));
						foreach ($_REQUEST["panelAttributes"][$serverGroupID] as $attrName=>$attrValue){
							$attrValue = (array)$attrValue;
							foreach ($attrValue as $val){
								insertFor(":productAttributes", array(
									"productID" => $productID,
									"serverGroupID" => $serverGroupID,
									"productAttributeName" => $attrName,
									"productAttributeValue" => $attrValue,
									"productAttributeDateCreated" => time(),
								));
							}
						}
					}
				}

				if($invalidParams) {
					$referralArgs = array();
					foreach($_REQUEST as $defaultParam => $defaultValue) {
						if(!in_array($defaultParam, $secure) && preg_match("/^question_/", $defaultParam)) {
							$referralArgs[DEFAULT_PREFIX . $defaultParam] = requestArgSerialize($defaultValue);
						}
					}
					$referralArgs['invalid'] = implode('_', $invalidParams);

					redirect(
						"products.php",
						getActionID("EditProductAttributes"),
						array("productID" => $productID, "loadActionFile" => "products", "loadActionID" => getActionID("EditProductAttributes")),
						$referralArgs
					);
				} else {

					$serverGroupIDs = $gs->getKeys();
					$as =& $r->getSubjectFrom(
						array("mbapi", "results", "products", "product", "productAttributes", "productAttribute"),
						"serverGroupID"
					);
					$oldAttributesByServerGroup = $as->getAssociatedSets();
					$oldAttributesByServerGroup[0] = array();

					$deleteParams = array();
					foreach($oldAttributesByServerGroup as $serverGroupID => $serverGroupAttrs) {
						if(!in_array($serverGroupID, $serverGroupIDs) && (string) $serverGroupID != "") {
							foreach($serverGroupAttrs as $attrData) {
								$deleteParams[] = $attrData['productAttributeID'];
							}
						}
					}


					$productAttributeParams = array();
					foreach($serverGroups as $serverGroupID => $serverGroupData) {
						$oldAttributesByName = associateArrayRowByID($oldAttributesByServerGroup[$serverGroupID], "productAttributeName");
						$newAttributesByName = $attributes[$serverGroupID];
						foreach($oldAttributesByName as $attrName => $attrData) {
							$oldAttributeValue = $attrData['productAttributeValue'];
							$newAttributeValue = $newAttributesByName[$attrName];
							if($oldAttributeValue !== $newAttributeValue) {
								$productAttributeParams[] = array(
									'productAttributeID' => $attrData['productAttributeID'],
									'productAttributeValue' => $newAttributeValue,
								);
							}
						}

						foreach($newAttributesByName as $attrName => $attrVal) {
							if(!isset($oldAttributesByName[$attrName])) {
								$productAttributeParams[] = array(
									'serverGroupID' => $serverGroupID,
									'productAttributeName' => $attrName,
									'productAttributeValue' => $attrVal,
									'productAttributeDateCreated' => mktime(),
								);
							}
						}
					}

					if($productAttributeParams || $deleteParams) {
						$skipSuccess = false;
						$params = array(
							'productID' => $productID,
						);
						if($productAttributeParams) {
							$params += array(
								'productAttributes' => array(
									'productAttribute' => $productAttributeParams,
								),
							);
						}
						if($deleteParams) {
							$params += array(
								'removeProductAttributeIDs' => array(
									'productAttributeID' => $deleteParams,
								),
							);
						}

						$sq = new MBQuery("SetProducts", "update", $params);

						$setResult =& $sq->getResult();
					} else {
						$skipSuccess = true;
					}

					if ($skipSuccess || $setResult->getSuccess()) {
						redirect(
							"products.php", getActionID("EditProductAttributes"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductAttributes"),
							)
						);
					}
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
