<?php
require_once("admin/include/lib-action/products/ShowProductDetailsAction.php");

class EditProductApplications extends MB_ProductAction
{
	
	public function __construct()
	{
		parent::MB_ProductAction("applications");
		$this->params = array("productID");
	}

	public function execute()
	{
		global $CONF;
		parent::execute();

		if ("" == ($productID = getParam("productID"))) {
			throw new Exception("No product ID given");
		}

		$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getServerGroupGhostData" => 1));
		$r =& $q->getResult();
		if($r->getSuccess()) {
			$s =& $r->getSubjectFrom(
				array("mbapi", "results", "products", "product", 0),
				"productID", "productName"
			);

			$product = $s->getCollapsed();
			$types = $CONF["types"]["products"];

			$this->smartyVars['product'] = $product;
			$this->smartyVars['types'] = $types;

			$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
				"productID" => $productID,
			));

			$this->setupTypeButtons($product["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$plan = Factory()->Product($productID);
			$serverGroups = $plan->ServerGroupList();

			$serverGroupsDescriptor = array();
			foreach ($serverGroups as $serverGroup) {
				// get APS applications
				if (!$panel = reset($serverGroup->ControlPanelList())) {
					continue;
				}
				$moduleParams = array(
					"subCommand" => "panelGetApsPackages",
					"panelID" => $panel->id,
				);

				require_once ("ModuleTool.php");
				$module = ModuleTool::getModuleInstance("panel", $panel->module_name, $moduleParams);
				if (!$module->hasExecutedSuccessfully()) {
					foreach ($module->getErrors() as $error) {
						$this->smartyVars["errorMessages"][] = $error[1];
					}
				}
				
				list($planAttributes) = $plan->ProductAttributesList(array("server_group_id" => $serverGroup->id));
				$enable = isset($planAttributes['applications_filter']) && ($planAttributes['applications_filter']->value == ProductAttributes::APPLICATIONS_FILTER_ON) ? true : false;
				
				// fill APS applications lists
				$selected = array();
				foreach (Factory()->ProductApplications(array($plan->id, $serverGroup->id)) as $application) {
					$key = strtolower($application->name);
					$selected[$key] = $application->name;
				}
				asort($selected);
				$selectable = array();
				foreach ($module->arrayData["packages"] as $package) {
					$key = strtolower($package["name"]);
					if (isset($selected[$key])) {
						$selected[$key] = $package["name"];
					} else {
						$selectable[$key] = $package["name"];
					}
				}
				asort($selectable);

				$serverGroupsDescriptor[] = array(
					'id' => $serverGroup->id,
					'name' => $serverGroup->server_group_name,
					'enable' => $enable,
					'selected' => $selected,
					'selectable' => $selectable
				);
			}
			$this->smartyVars["serverGroupsDescriptor"] = $serverGroupsDescriptor;

			$formDefaults = $product;
			$this->mergeFormState($formDefaults);

			$this->checkPlanNameUniqueForMasterPanel($productID);

			$this->addTemplate("widgets/products/EditProductApplications");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
