<?php
require_once("lib-action/action.php");

class EditProductApplicationsResponse extends MB_Action
{
	
	public function __construct()
	{
		parent::MB_Action();
		$this->params = array(
			"productID",
			"applications",
		);
	}

	public function execute()
	{
		parent::execute();

		$this->setReferralActionID(getActionID("ShowProductDetails"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT,
			),
			array(),
			array(),
			0,
			array("loadActionFile"=>"products","loadActionID"=>getActionID("EditProductApplications"))
		);
		if($success) {
			$productID = ((int)bgpc("productID"));
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
				try {
					$plan = Factory()->Product($productID);
					$serverGroups = $plan->ServerGroupList();
					foreach ($serverGroups as $serverGroup) {
						$panel = reset($serverGroup->ControlPanelList());
						list($applications) = $plan->ProductApplicationsList(array("server_group_id" => $serverGroup->id));
						$applications->clear();
						list($planAttributes) = $plan->ProductAttributesList(array("server_group_id" => $serverGroup->id));
						if (bgpc('applications_filter_' . $serverGroup->id, false)) {
							$planAttributes['applications_filter']->value = ProductAttributes::APPLICATIONS_FILTER_ON;
							foreach (bgpc('applications_' . $serverGroup->id, array()) as $key) {
								$applications[] = array("name" => $key);
							}
						} else {
							$planAttributes['applications_filter']->value = ProductAttributes::APPLICATIONS_FILTER_OFF;
						}
					}
					require_once("object_managers/ProductManager.php");
					ProductManager::update($plan);
					if ($_REQUEST["redirectURL"] != "" && $_REQUEST["redirectAction"] != "") {
						redirect($_REQUEST["redirectURL"] . "?action=" . getActionID($_REQUEST["redirectAction"]) . "&" . $_REQUEST["redirectArgs"]);
					} else {
						redirect(
							"products.php", getActionID("EditProductApplications"),
							array(
								"productID" => $productID,
								"loadActionFile" => "products",
								"loadActionID" => getActionID("EditProductApplications"),
							)
						);
					}
				} catch (Exception $exception) {
					$this->addError(TRANS_ACTIONERROR, $exception->getMessage());
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
