<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-tk/toolkit.php");

class EditProductMiscellaneousResponse extends MB_Action
{
	public $params = array(
		"productID",
		"coupons",
		"preAppliedCouponID",
	);

	public function execute()
	{
		parent::execute();

		$this->setReferralActionID(getActionID("EditProductMiscellaneous"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"productID" => INPUT_RESTRICTION_UNSIGNED_INT,
			),
			array(),
			array(),
			1,
			array("loadActionFile"=>"products","loadActionID"=>getActionID("EditProductMiscellaneous"))
		);
		if($success) {

			$productID = ((int) $_REQUEST["productID"]);
			if(!$productID) {
				$this->addError(TRANS_ACTIONERROR, "No product ID given.");
			} else {
				//////// coupons setting
				$params = array();
				$this->applyRequestTo(
					$params,
					array(
						'coupons',
					)
				);
				$params["preAppliedCouponID"] = (int)$_REQUEST["preAppliedCouponID"];

				$q = new MBQuery(
					"GetProducts", "",
					array(
						"productID" => $productID,
						"getCouponData" => 1,
					)
				);
				$r =& $q->getResult();

				$coupons =& $r->getSubjectFrom(
					array("mbapi", "results", "products", "product", "coupons", "coupon"),
					"couponID"
				);
				$relParams = $this->getRelationParamsFromSubject($coupons, "couponIDs", "couponID", "coupons");
				$params += $relParams;

				// email group setting
				$templateID = ((int) $_REQUEST["welcomeEmailTemplateGroup"]);
				$params["emailTplGroupID"] = $templateID;
				// notification group setting
				$params["notifyAdminGroupID"] = (int)$_REQUEST["notifyAdminGroupID"];

				$setQuery = new MBQuery("SetProducts", "update", $params);
				dbg("set query for products");
				dbg($setQuery->getXMLQuery());
				$setResult =& $setQuery->getResult();
				$skipSuccess = false;

				//////// set the relations
				$params = array();
				$productUpgradeIDs = (array)$_REQUEST["productUpgradeIDs"];
				$productDowngradeIDs = (array)$_REQUEST["productDowngradeIDs"];
				$skipUpgradeIDs = array();
				$skipDowngradeIDs = array();

				$oldUpgradeRelations = arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "upgrade")));
				$oldDowngradeRelations = arrayFor("productRelations", array("subjectProductID" => $productID, "productRelationType" => getAPITypeID("productrelations", "downgrade")));


				foreach ((array)$oldUpgradeRelations as $relation){
					if (!in_array($relation["relatedProductID"], $productUpgradeIDs)){
						deleteFor("productRelations", array("productRelationID"=>$relation["productRelationID"]));
					} else {
						$skipUpgradeIDs[] = $relation["relatedProductID"];
					}
				}
				foreach ((array)$oldDowngradeRelations as $relation){
					if (!in_array($relation["relatedProductID"], $productDowngradeIDs)){
						deleteFor("productRelations", array("productRelationID"=>$relation["productRelationID"]));
					} else {
						$skipDowngradeIDs[] = $relation["relatedProductID"];
					}
				}


				foreach ($productUpgradeIDs as $uid){
					if (!in_array($uid, $skipUpgradeIDs)){
						insertFor("productRelations", array("subjectProductID" => $productID, "relatedProductID" => $uid, "productRelationType" => getAPITypeID("productrelations", "upgrade")));
					}
				}
				foreach ($productDowngradeIDs as $did){
					if (!in_array($did, $skipDowngradeIDs)){
						insertFor("productRelations", array("subjectProductID" => $productID, "relatedProductID" => $did, "productRelationType" => getAPITypeID("productrelations", "downgrade")));
					}
				}


				////// usage pricing setting
				dbg("== usage pricing ==");
				$delQueryXML = "
					<mbapi>
						<command>SetProductUsagePrice</command>
						<subCommand>delete</subCommand>
						<params>
							<productID>".$productID."</productID>
						</params>
					</mbapi>
					";
				$delResults = dispatchMBAPI($delQueryXML, 1);
				dbg("");
				$prices = (array)$_REQUEST["usagePricing"];
				dbg("");

				$setPrices = array();
				dbg("");
				foreach ($prices as $k=>$v){
					$setPrices[] = array(secureInput($k), $this->getNumberFromInput($v));
				}
				dbg("");

				foreach ($setPrices as $price){
				dbg("");
					$setPriceXML = "
						<mbapi>
							<command>SetProductUsagePrice</command>
							<subCommand>insert</subCommand>
							<params>
								<productID>".$productID."</productID>
								<currencyID>".$price[0]."</currencyID>
								<productUsagePriceAmount>".$price[1]."</productUsagePriceAmount>
							</params>
						</mbapi>
						";
				dbg("");
					$setResult = dispatchMBAPI($setPriceXML, 1);
				dbg("");
				}
				dbg("");


				if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
					redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
				} else {
					redirect(
						"products.php", getActionID("EditProductMiscellaneous"),
						array(
							"productID" => $productID,
						)
					);
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
