<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("admin/include/lib-action/products/ShowProductDetailsAction.php");

class EditProductServerGroups extends MB_ProductAction
{
	function __construct()
	{
		parent::MB_ProductAction("servergroups");
		$this->params = array("productID");
	}

	public function execute()
	{
		global $CONF;
		parent::execute();

		if ("" == ($productID = getParam("productID"))) {
			throw new Exception("No product ID given");
		}

		$q = new MBQuery("GetProducts", "", array("productID" => $productID, "getServerGroupGhostData" => 1));
		$r =& $q->getResult();
		if($r->getSuccess()) {
			$s =& $r->getSubjectFrom(
				array("mbapi", "results", "products", "product", 0),
				"productID", "productName"
			);

			$product = $s->getCollapsed();
			$types = $CONF["types"]["products"];

			$this->smartyVars['product'] = $product;
			$this->smartyVars['types'] = $types;

			$this->smartyVars["productVariants"] = arrayFor(":productVariants", array(
				"productID" => $productID,
			));

			$this->setupTypeButtons($product["productType"]);
			$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

			$q = new MBQuery("GetServerGroups", "", array());
			$serverGroupResult =& $q->getResult();
			$serverGroupSubject =& $serverGroupResult->getSubjectFrom(
				array("mbapi", "results", "serverGroups", "serverGroup"),
				"serverGroupID", "serverGroupName"
			);
			dbg($r);
			$r->setPath(array("mbapi", "results", "products", "product", "ghostServerGroups", "ghostServerGroup"));
			$this->assignMultiOptionsFromSubject("serverGroups", $serverGroupSubject, "serverGroups", $r, "serverGroupID");

			$formDefaults = $product;
			$this->mergeFormState($formDefaults);

			$this->checkPlanNameUniqueForMasterPanel($productID);

			$this->addTemplate("widgets/products/EditProductServerGroups");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
