<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class EditTLDResponse extends MB_Action {

	function EditTLDResponse() {
		parent::MB_Action();
		$this->stringRep = "EditTLDResponse";
		$this->params = array(
			"tldID",
			"tldName",
			"tldExtension",
			"registrarID",
			"tldActive",
			"tldWhoisServer",
			"tldWhoisResp",
			"tldWhoisMatchRule",
			"tldAutoSearch",
			"tldTransferMinimumCycleID",
			"tldMinimumCycleID",
			"tldMaximumCycleID",
			"tldRenewType",
			"tldIsTransferable",
			"tldTransferType",
			"tldIDNSupport",
			"tldIDNType",
			"tldRemoteLockEnabled",
			"orderForms",
			"cycles",
		);
	}

	function execute() {
		global $CONF;
		parent::execute();


		if ((int)$_REQUEST["moveUpTldID"]){
			$tld = oneByID(":TLDs", (int)$_REQUEST["moveUpTldID"]);

			if ((int)$tld["tldDisplayOrder"]){
				$moveTo = oneOf(":TLDs", array(
					"tldDisplayOrderLessThan" => $tld["tldDisplayOrder"],
					"sortDir" => "DESC",
					"sortColumn" => "tldDisplayOrder",
					"numRecords" => 1,
				));

				if ($moveTo["tldID"]){
					if (updateForKey(":TLDs", $tld["tldID"], array(
						"tldDisplayOrder" => $moveTo["tldDisplayOrder"],
					))){
						updateForKey(":TLDs", $moveTo["tldID"], array(
							"tldDisplayOrder" => $tld["tldDisplayOrder"],
						));
					}
				}
			}
			redirect("products.php", "ShowTLDs");
		}
		if ((int)$_REQUEST["moveDownTldID"]){
			$tld = oneByID(":TLDs", (int)$_REQUEST["moveDownTldID"]);
			if ((int)$tld["tldDisplayOrder"]){
				$moveTo = oneOf(":TLDs", array(
					"tldDisplayOrderGreaterThan" => $tld["tldDisplayOrder"],
					"sortDir" => "ASC",
					"sortColumn" => "tldDisplayOrder",
					"numRecords" => 1,
				));
				if ($moveTo["tldID"]){
					if (updateForKey(":TLDs", $tld["tldID"], array(
						"tldDisplayOrder" => $moveTo["tldDisplayOrder"],
					))){
						updateForKey(":TLDs", $moveTo["tldID"], array(
							"tldDisplayOrder" => $tld["tldDisplayOrder"],
						));
					}
				}
			}
			redirect("products.php", "ShowTLDs");
		}

		$this->setReferralActionID(getActionID("EditTLD"));
		$this->setReferralActionFile("products.php");
		$success = $this->validateMultiInputs(
			array(
				"tldID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldName" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"tldExtension" => INPUT_RESTRICTION_STRING|INPUT_RESTRICTION_REQUIRED,
				"registrarID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldActive" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldWhoisServer" => INPUT_RESTRICTION_STRING,
				"tldWhoisResp" => INPUT_RESTRICTION_STRING,
				"tldWhoisMatchRule" => INPUT_RESTRICTION_STRING,
				"tldAutoSearch" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMinimumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldMaximumCycleID" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRenewType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIsTransferable" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldTransferType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldIDNSupport" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
				"tldIDNType" => INPUT_RESTRICTION_UNSIGNED_INT|INPUT_RESTRICTION_REQUIRED,
				"tldRemoteLockEnabled" => INPUT_RESTRICTION_BOOL|INPUT_RESTRICTION_REQUIRED,
			),
			array(),
			array(),
			1
		);
		if($success) {

			$tldID = ((int) $_REQUEST["tldID"]);
			if(!$tldID) {
				$this->addError(TRANS_ACTIONERROR, "No TLD ID given.");
			} else {
				$query = $this->getMBAPIQuery("SetTLDs", "update", array());
				$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
				$data = dispatchMBAPI($query, 1);
				$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
				if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
					if ($_REQUEST["redirectURL"]!="" && $_REQUEST["redirectAction"]!="") {
						redirect($_REQUEST["redirectURL"]."?action=".getActionID($_REQUEST["redirectAction"])."&".$_REQUEST["redirectArgs"]);
					} else {
						redirect("products.php", getActionID("ShowTLDs"), array());
					}
				}
			}

		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditTLDResponse
