<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("admin/include/lib-action/products/ShowProductDetailsAction.php");

class ShowProductAddons extends MB_ProductAction
{
	public function __construct()
	{
		parent::__construct("children");
	}

	public function execute()
	{
		global $CONF;
		parent::execute();

		if (is_null($productID = bgpc("productID"))) {
			throw new Exception("No product ID given");
		}

		require_once("lib-mbapi/mbapi.php");
		$this->productInfo = correctArray(grabFirstResultFromMBAPIArray(
			array(
				"mbapi" => array(
					"command" => "GetProducts",
					"params" => array(
						"productID" => (int)$_REQUEST["productID"],
						"getProductAttributeData" => 1,
						"getProductChildData" => 1,
						"getProductVariantPriceData" => 1,
						"getEmailTemplateData" => 1,
						"getEmailActionGroupData" => 1,
						"getCouponData" => 1,
						"getOrderFormData" => 1,
						"getProductVariantData" => 1,
						"getTLDData" => 1,
						"getCycleGhostData" => 1,
						"getServerGroupGhostData" => 1
					)
				)
			)
		));
		$this->smartyVars["product"] =& $this->productInfo;
		$this->smartyVars["canDoAddons"] = count($this->smartyVars["product"]["productAttributes"]);
		$types = $CONF["types"]["products"];
		$this->smartyVars['types'] = $types;


		$this->serverGroups = correctArray(
			grabResultsFromMBAPIArray(array(
				"mbapi" => array(
					"command" => "GetServerGroups",
					"params" => array()
				)
			))
		);
		$this->keyedServerGroups = array();
		foreach ((array)$this->serverGroups as $k=>$group){
			$this->keyedServerGroups[$group["serverGroupID"]] =& $this->serverGroups[$k];
		}
		$this->smartyVars["serverGroups"] =& $this->keyedServerGroups;

		$this->setupTypeButtons($this->smartyVars["product"]["productType"]);
		$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

		$this->smartyVars["rawAddons"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProducts",
				"params" => array(
					"parentProductID" => $_REQUEST["productID"],
					"getProductAttributeData" => 1
				)
			)
		)));


		$this->smartyVars["addons"] = array();

		$groups = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array(
					"getGroupsByProductID" => $_REQUEST["productID"],
				)
			)
		)));


		$this->smartyVars["addonGroups"] = array();
		foreach ((array)$groups as $group){
			$this->smartyVars["addons"][$group["productAddonGroupID"]] = array();
			$this->smartyVars["addonGroups"][$group["productAddonGroupID"]] = $group;
		}

		foreach ((array)$this->smartyVars["rawAddons"] as $addon){
			$this->checkPlanNameUniqueForMasterPanel($addon["productID"]);
			$this->smartyVars["addons"][$addon["productAddonGroupID"]][] = $addon;
		}

		$this->smartyVars["addoninputs"] = getTypes("addoninputs");


		$this->addTemplate("widgets/products/ShowProductAddons");
		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
