<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");
require_once("admin/include/lib-action/products/ShowProductDetailsAction.php");

class ShowProductDetails extends ShowProductDetailsAction
{
	public function __construct()
	{
		$_REQUEST["productID"] = $this->_getProduct()->id;

		parent::__construct("details");
		$this->setDataSource(new DataSource("products", array("getServerGroupGhostData" => 1, "getProductAttributeData"=>1, "getProductGroupData"=>1, "getVendorData"=>1)));
	}

	public function showDetailsHandler()
	{
		$this->smartyVars["product"]["productAddonGroupID"] = (int)$this->smartyVars["product"]["productAddonGroupID"];
		$product = $this->smartyVars['product'];

		$sub = $this->d->getSubject();
		$sub = $sub->getEssential();
		$serverGroups = $sub[0]["ghostServerGroups"];
		$attribute = $sub[0]["productAttributes"][0];
		dbg($sub);

		if($product["productType"] != getAPITypeID("products", "domain") && $product["productType"] != getAPITypeID("products", "cert")) {
			$this->smartyVars["productVariables"] = optionsFor("productVariables");
		}

		if($product["productStopNumCycles"] == 0) {
			$billingPlan = 1;
		} else if($product["productStopNumCycles"] == 1) {
			$billingPlan = 2;
		} else {
			$billingPlan = 3;
		}
		$billingPlans = array(
			"1" => TRANS_FOREVER,
			"2" => TRANS_ONE_TIME_ONLY,
			"3" => TRANS_FIXED_DURATION,
		);


		$this->smartyVars["addonGroups"] = correctArray(grabResultsFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetProductAddonGroups",
				"params" => array()
			)
		)));
		$this->smartyVars["chooseGroups"] = (0 == $product["productIsAddon"] ? array(0=>TRANS_NONE) : array());
		$this->smartyVars["chooseGroups"] += grabHTMLOpsFromArray($this->smartyVars["addonGroups"], "productAddonGroupID", "productAddonGroupName");

		$this->smartyVars["chooseAttributes"] = array();

		if ($product['productAddonGroupID'] || $_REQUEST['advanced']==1){
			foreach ((array)$serverGroups as $sg){
				$rawAttributes = $this->getAttributesForServerGroupID($sg["serverGroupID"], NULL, true);
				$attributes = array();
				foreach ((array)$rawAttributes as $k=>$v){
					if (!$attributes[$v]){
						$this->smartyVars["chooseAttributes"][$sg["serverGroupID"]."|".$k] = $sg["serverGroupName"]." >> ".$v;
						$attributes[$v] = 1;
					}
				}
			}
		}

		$this->smartyVars["selectedProductGroups"] = grabHTMLOpsFromArray($sub[0]["productGroups"], "productGroupID", "productGroupName");
		$this->smartyVars["selectableProductGroups"] = grabHTMLOpsFromArray(arrayFor("productGroups", array()), "productGroupID", "productGroupName", array_keys($this->smartyVars["selectedProductGroups"]));

		$this->smartyVars["selectedAttribute"] = $attribute["serverGroupID"]."|".$product["productAddonAttributeName"];
		$this->smartyVars["billingPlan"] = $billingPlan;
		$this->smartyVars["billingPlans"] = $billingPlans;
		$this->smartyVars["advanced"] = (int)$_REQUEST["advanced"];
		$this->smartyVars["productdependencyrules"] = getStatuses("productdependencyrules");
		$this->smartyVars["productCancellationRules"] = getTypes("cancellation");
		$this->smartyVars["productTypes"] = getTypes("products");
		$this->smartyVars["loadActionFile"] = $_REQUEST["loadActionFile"];
		$this->smartyVars["loadActionID"] = (INT) $_REQUEST["loadActionID"];

		$productID = bgpc("productID");
		$this->smartyVars["productVariants"] = arrayFor(":productVariants", array("productID" => $productID));
		$this->setupTypeButtons($product["productType"]);
		$this->smartyVars["productButtons"] = $this->productButtons->getButtons();

		$this->mergeFormState();

		$this->checkPlanNameUniqueForMasterPanel($productID);

		$product = Factory()->Product($productID);
		if ($product->isSyncable() && !is_null($product->sync_error)) {
			$transKey = $product->isAddon() ? "TRANS_SYNC_THIS_PLAN_ADDON_ERROR_MSG" : "TRANS_SYNC_THIS_PLAN_ERROR_MSG";
			$this->smartyVars["errorMessages"][] = blmsg($transKey, array("ERROR" => nl2br(billing_safetyhtml($product->sync_error))));
		}

		return true;
	}
}
