<?php

class Products_GroupController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('products', 'ShowProducts');
	}

	public function editAction()
	{
		$group = Factory()->ProductAddonGroup($this->_request->getParam('groupID'));
		$editForm = new Billing_Zend_Form_Final_EditAddonGroupForm(array('context' => array(
			'cancelLink' => $this->_backUrl,
			'group' =>  $group,
		)));
		if ($this->_request->isPost()) {
			if ($editForm->isValid($this->_request->getPost())) {
				try {
	            	$editForm->processForm();;
	                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_EDIT_ADDON_GROUP_SAVED_MSG"), "info");
	            } catch (ProductException $e) {
	                $this->_status->addError($e->getMessage());
	            }
			} else {
				$this->_status->addError($this->_translator->translate('TRANS_ADDON_GROUP_SETTINGS_INVALID'));
			}
        }
		$this->view->form = $editForm;
	}

	private $_backUrl = NULL;
}
 
