<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

class ShowReportAction extends MB_Action
{
	protected function mergeReportsData()
	{
		$this->sourcePath = $sourcePath = mb_path("/admin/include/lib-action/reports/sources");

		$files = getMatchingFilesInDir($sourcePath, "^.*[.].*[.]php\$"); // preg match regex
		$this->smartyVars["reportGroupNames"] = array(
			"Accounting" => "TRANS_REPORTS_ACCOUNTING_REPORTS",
			"Clients" => "TRANS_REPORTS_CLIENT_REPORTS",
			"Invoices" => "TRANS_REPORTS_INVOICE_REPORTS",
			"Packages" => "TRANS_REPORTS_PACKAGE_REPORTS",
			"Products" => "TRANS_REPORTS_PRODUCT_REPORTS",
			"Tax" => "TRANS_REPORTS_TAX_REPORTS",
			"Coupons" => "TRANS_REPORTS_COUPON_REPORTS",
			"Transactions" => "TRANS_REPORTS_TRANSACTION_REPORTS",
			"General" => "TRANS_REPORTS_GENERAL_REPORTS",
		);

		$this->smartyVars["reportGroups"] = array();

		$this->smartyVars["totalReports"] = count($files);
		$this->smartyVars["firstColNum"] = floor($this->smartyVars["totalReports"]/2);

		foreach ($files as $file) {
			list($cat, $name, $fname) = $this->getNamePieces($file);
			if (!$this->smartyVars["reportGroupNames"][$cat]) {
				$cat = "General";
			}
			$this->reportData[$fname] = $this->getReportData($fname);
			$this->smartyVars["reportGroups"][$cat][$fname] = blmsg($this->reportData[$fname]["name"]);
		}
	}

	protected function getNamePieces($name)
	{
		$p = explode(".", $name);
		return array($p[0], $p[1], $p[0].".".$p[1]);
	}

	protected function getReportData($fname)
	{
		global $CONF;
		require_once ($this->sourcePath."/".$fname.".php");
		return $CONF["reportData"][$fname];
	}

	protected $reportData;
}
