<?php
require_once ("lib-action/action.php");
require_once ("lib-mbapi/include/modules/panel/panel.php");


class EditServerGroup extends MB_Action
{

	function __construct()
    {
		parent::MB_Action();
		$this->params = array("serverGroupID", "serverGroupFillType");
	}


	function execute() {
		global $CONF;
		parent::execute();
		
		$serverGroupID = bgpc("serverGroupID");
		if(!$serverGroupID) {
			$this->addError(TRANS_ACTIONERROR, "No servergroup ID given.");
		} else {
			$query = $this->getMBAPIQuery("GetServerGroups", "", array("getPanels" => 1));
			$CONF["debug"]->add("Action Command", htmlentities($query), __FILE__, __LINE__);
			$data = dispatchMBAPI($query, 1);

			$CONF["debug"]->add("Action Result", $data, __FILE__, __LINE__);
			if(!$data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]["panels"][0]) {
				//Get list of files in modules/panel to build panel list
				// Only if a Panel isn't associated yet, otherwise, must keep the same Panel.
				$panels = getAvailableModules("panel");
				sort($panels);
				foreach ($panels as $panelClass => $panelFile) {
					require_once ("lib-mbapi/include/modules/panel/".$panelFile);
					$moduleInfo = call_user_func(array($panelClass, "getModuleInfo"));
					$smartyVars["panels"][$panelClass] = $moduleInfo["displayName"];
				}
			}
			if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
				$smartyVars = array();

				$smartyVars["panelSelectionOptions"] = Panel::getPanelSelectionOptions();
				foreach ($smartyVars["panelSelectionOptions"] as $k=>$v){
					$smartyVars["panelSelectionOptions"][$k] = (defined($v))?constant($v):$v;
				}
				$smartyVars["serverGroup"] = collapseArrayElements($data["mbapi"][0]["results"][0]["serverGroups"][0]["serverGroup"][0]);
				$smartyVars["serverGroupFillType"] = Factory()->ServerGroup($serverGroupID)->server_group_fill_type;
                $this->addTemplate("servers/EditServerGroup", $smartyVars, 1);
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditServerGroup
?>
