<?php
require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/action.php");

class AddIPLogResponse extends MB_Action
{
	public function execute()
	{
		parent::execute();

		require_once ('object_managers/IPAddressManager.php');

		$minIP = bgpc("ip");
		$maxIP =  bgpc("ipMax");

		if(!IPAddressManager::isAddress($minIP)) {
			getCurrentSession()->Storage->errorMessages[] =blmsg("TRANS_IP_RANGE_IP_WRONG_FORMAT_MSG", array("IP" => $minIP));
			redirect("servers.php", "AddIPLog");
		}

		if("" != trim($maxIP)) {
			if(!IPAddressManager::isAddress($maxIP)) {
				getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_IP_RANGE_IP_WRONG_FORMAT_MSG", array("IP" => $maxIP));
				redirect("servers.php", "AddIPLog");
			} else if(!IPAddressManager::hasSameVersion($minIP, $maxIP)) {
				getCurrentSession()->Storage->errorMessages[] = blmsg("TRANS_IP_RANGE_DIFFERENT_VERSIONS_MSG", array("MIN_IP" => $minIP, "MAX_IP" => $maxIP));
				redirect("servers.php", "AddIPLog");
			}
		} else {
			$maxIP = $minIP;
		}

		$range = IPAddressManager::getRange($minIP, $maxIP);
		$configGroupID = bgpc('configGroupID');
		foreach($range as $ip) {
			$ipLog = Factory()->IPLog();
			$ipLog->ip = $ip;
			$ipLog->config_group_id =  $configGroupID;
			$ipLog->ip_version = IPAddressManager::getVersion($ip);
			$ipLog->update();
		}
		redirect("servers.php", "ShowIPLog", array("configGroupID" => $configGroupID));

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}