<?php

require_once("lib-action/action.php");

class SyncSSO extends MB_Action
{
	public function execute()
	{
		parent::execute();

		try {
			require_once("object_managers/SSOManager.php");
			$syncTasks = SSOManager::getSSOServerSyncTasks();
			$syncTasks |= SSOManager::SYNC_NEED_REPAIR;
			SSOManager::setSSOServerSyncTasks($syncTasks);
			SSOManager::sync();
			if (is_null(SSOManager::getSSOServerSyncError())) {
				getCurrentSession()->Storage->infoMessages[] = blmsg("TRANS_SYNC_SSO_SERVER_SUCCESS_MSG");
			} else {
				getCurrentSession()->Storage->errorMessages[] = blmsg(
					"TRANS_SYNC_SSO_SERVER_FAILURE_MSG", array("ERROR" => billing_safetyhtml(SSOManager::getSSOServerSyncError()))
				);
			}
		} catch (ProductException $e) {
			getCurrentSession()->Storage->errorMessages[] = blmsg(
				"TRANS_SYNC_SSO_SERVER_FAILURE_MSG", array("ERROR" => billing_safetyhtml($e->getMessage()))
			);
		}
		redirect("dashboard.php", getActionID("ShowDashboard"));
	}
}
