<?php

class Taxes_IndexController extends Billing_Zend_Controller_Action_AdminController
{
	public function init()
	{
		parent::init();
		$this->_backUrl = $this->view->ActionUrl('taxes', 'ShowTaxZoneGroups');
	}

	public function addAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_ADD_TAX_ZONE_GROUP'));
		$addForm = new Billing_Zend_Form_Final_EditTaxesForm(array('context' => array(
			'cancelLink' =>  $this->_backUrl,
			'operation' =>  Billing_Zend_Form_Final_EditTaxesForm::TZG_OPERATION_ADD,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $addForm->isValid($this->_request->getPost())) {
			try {
            	$addForm->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_ADD_TAX_ZONE_GROUP_SUCCESS_MSG"), "info");
            } catch (ProductException $e) {
                $this->_status->addError($e->getMessage());
            }

        }
		$this->view->form = $addForm;
    }

	public function editAction()
	{
		$postData = ($this->_request->isPost()) ? $this->_request->getPost() : NULL ;
		$taxZoneGroup = Factory()->TaxZoneGroup($this->_request->getParam('taxZoneGroupID'));
        $this->view->placeholder('pageTitle')->set($this->view->translate('TRANS_PAGE_TITLE_EDIT_OBJECT', array('NAME' => $taxZoneGroup->tax_zone_group_name)));
		$editForm = new Billing_Zend_Form_Final_EditTaxesForm(array('context' => array(
			'cancelLink' => $this->view->ActionUrl('taxes', 'ShowTaxZoneGroups'),
			'taxZones' =>  $taxZoneGroup->taxZoneList(),
			'taxZoneGroup' =>  $taxZoneGroup,
			'operation' =>  Billing_Zend_Form_Final_EditTaxesForm::TZG_OPERATION_EDIT,
			'postData' => $postData,
		)));
		if ($this->_request->isPost() && $editForm->isValid($this->_request->getPost()))
        {
			try {
            	$editForm->processForm();
                $this->_redirectWithMessage($this->_backUrl, $this->_translator->translate("TRANS_EDIT_TAX_ZONE_GROUP_SAVED_MSG"), "info");
            } catch (ProductException $e) {
                $this->_redirectWithMessage($this->_backUrl, $e->getMessage(), "error");
            }
        }
		$this->view->form = $editForm;
	}

	private $_backUrl = NULL;
}