<?php
require_once mb_path("/lib-action/action.php");

class RemoveWebsiteWidget extends MB_Action
{
	function execute()
	{
		parent::execute();
		
		if(!isset($_REQUEST["websiteWidgetID"])) {
			$this->addError(TRANS_ACTIONERROR, "No Widget ID given.");
		} else {
			$websiteWidgetIDs = bgpc("websiteWidgetID");
			if(!is_array($websiteWidgetIDs)) {
				$websiteWidgetIDs = array($websiteWidgetIDs);
			}

			$widgets = Factory()->WebsiteWidgetList(array("website_widget_id" => $websiteWidgetIDs));
			$this->smartyVars["widgets"] = array();
			foreach($widgets as $widget) {

				$this->smartyVars["widgets"][] = array(
					"websiteWidgetID" => $widget->website_widget_id,
					"websiteWidgetName" => $widget->website_widget_name,
				);
			}

			if(isset($_REQUEST['backURL'])) {
				$this->smartyVars["backURL"] = bgpc("backURL");
			}
			
			$this->addTemplate("websitewidgets/RemoveWebsiteWidget");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
?>
