<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");

class EditDomainContactDataResponse extends DomainAction
{
	public function __construct()
	{
		parent::__construct();
		$this->params = array(
			"domainID",

			"registrantAddress1", "registrantAddress2", "registrantCity", "registrantCountry",
			"registrantEmailAddress", "registrantFax", "registrantFirstName", "registrantJobTitle",
			"registrantLastName", "registrantOrganizationName", "registrantPhone", "registrantPhoneExt",
			"registrantPostalCode", "registrantStateProvince", "registrantStateProvinceChoice",

			"auxAddress1", "auxAddress2", "auxCity", "auxCountry", "auxEmailAddress", "auxFax",
			"auxFirstName", "auxJobTitle", "auxLastName", "auxOrganizationName", "auxPhone",
			"auxPhoneExt", "auxPostalCode", "auxStateProvince", "auxStateProvinceChoice",

			"techAddress1", "techAddress2", "techCity", "techCountry", "techEmailAddress",
			"techFax", "techFirstName", "techJobTitle", "techLastName", "techOrganizationName",
			"techPhone", "techPhoneExt", "techPostalCode", "techStateProvince",
			"techStateProvinceChoice",

			"adminAddress1", "adminAddress2", "adminCity", "adminCountry", "adminEmailAddress",
			"adminFax", "adminFirstName", "adminJobTitle", "adminLastName", "adminOrganizationName",
			"adminPhone", "adminPhoneExt", "adminPostalCode", "adminStateProvince",
			"adminStateProvinceChoice",

			"billingPartyID", "billingAddress1", "billingAddress2", "billingCity",
			"billingCountry", "billingEmailAddress", "billingFax", "billingFirstName",
			"billingJobTitle", "billingLastName", "billingOrganizationName", "billingPhone",
			"billingPhoneExt", "billingPostalCode", "billingStateProvince", "billingStateProvinceChoice",
			"billingFullCountry", "useBelowAuxInfo"
		);
	}

	public function execute()
	{
		parent::execute();

	 	$mbapiData = $this->getDomain();

		// fetching domain data from the registrar
		$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$contactXML = "\n";
		$contactData = array("registrant","admin","tech","auxBilling");

		foreach($contactData as $contactType) {

			// clean up state/province data
			if (eregi("S",$_REQUEST[$contactType]["StateProvinceChoice"])) {
				$_REQUEST[$contactType]["StateProvince"] = $_REQUEST[$contactType]["State"];
			} else if (eregi("P",$_REQUEST[$contactType]["StateProvinceChoice"])) {
				$_REQUEST[$contactType]["StateProvince"] = $_REQUEST[$contactType]["Province"];
			} else {
				$_REQUEST[$contactType]["StateProvince"] = "";
			}

			// remove variables not needed by registrars
			unset($_REQUEST[$contactType]["State"],$_REQUEST[$contactType]["Province"]);

			// build XML command
			if (is_array($_REQUEST[$contactType])) {
			 	$contactXML .= "                              <$contactType>\n";
				foreach($_REQUEST[$contactType] as $key => $value) {
					$contactXML .= "                                <$contactType$key>$value</$contactType$key>\n";
				}
				$contactXML .=	"                              </$contactType>\n";
			}
		}
		$contactXML .= "\n";

		$xml = "
		<mbapi>
			<command>ProcessRegistrar</command>
			<showXMLHeader>0</showXMLHeader>
			<subCommand>setDomainContactData</subCommand>
			<params>
				<subCommand>setDomainContactData</subCommand>
				<configGroupName>0</configGroupName>
				<configID>0</configID>
				<domainSLD>".$domainSLD."</domainSLD>
				<domainTLD>".$domainTLD."</domainTLD>
				<domainID>".$domainID."</domainID>
				<domainContactData>$contactXML
				</domainContactData>
			</params>
		</mbapi>";
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($xml,1);
		$this->processRegistrarResponse($data);
		return $this->hasExecutedSuccessfully();

	}

	protected function redirectWithInfoMessage($message = NULL)
	{
		getCurrentSession()->Storage->infoMessages[] = is_null($message) ? blmsg('TRANS_INFORMATION_UPDATED_SUCCESSFULLY') : $message;
		getCurrentSession()->Storage->warningMessages[] = blmsg('TRANS_REGISTRAR_CONTACT_CHANGES_TAKE_TIME_MSG');
		redirect("domains.php", getActionID("ShowDomainDetails"), array("domainID" => $this->domainID));
	}
}
