<?php

require_once(dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php");
require_once("lib-action/DomainAction.php");
require_once("lib-mbapi/mbapi.php");
require_once("lib-tk/include/xml/xml.php");

/**
 * This Action object collects information on domains that match the given parameters, and
 * generates the display of that information.
 *
 * @author  Michael Fountain
 */
class EditDomainRenewTypeOptions extends DomainAction {

	/**
	 * The main method of this class that executes the EditDomainRenewTypeOptions action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	function execute() {
		global $CONF;
		parent::execute();

		$mbapiData = $this->getDomain();

		// build XML for fetching domain data from the registrar
		$domainSLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainSLD"][0];
		$domainTLD = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainTLD"][0];
		$domainID = $mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]["domainID"][0];

		$x = "
		<mbapi>
			<command>ProcessRegistrar</command>
			<subCommand>getDomainRenewTypeOptions</subCommand>
			<showXMLHeader>0</showXMLHeader>
			<params>
				<subCommand>getDomainRenewTypeOptions</subCommand>
				<configID>0</configID>
				<domainSLD>".$domainSLD."</domainSLD>
				<domainTLD>".$domainTLD."</domainTLD>
				<domainID>".$domainID."</domainID>
			</params>
		</mbapi>";

		$registrarData = dispatchMBAPI($x,1);
		$registrarResults =& $registrarData["mbapi"][0]["results"][0];

		if($this->addMBAPIErrors($registrarData) === 0) {

			$smartyVars = array();
			$smartyVars["domain"] = collapseArrayElements($mbapiData["mbapi"][0]["results"][0]["domains"][0]["domain"][0]);
			$smartyVars["domainRenewType"] = collapseArrayElements($registrarResults["domainRenewType"]);
			$this->addTemplate("domains/EditDomainRenewTypeOptions", collapseArrayElements($smartyVars));

		} else {
			$message = $this->createErrorReportMessage();
			$this->redirectWithErrorMessage($message);
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // EditDomainRenewTypeOptions
?>
