<?php

if(!$CONF || $_REQUEST["CONF"]) {
	if (!defined("MB_LIBPATH")){
		define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../../.."));
		require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
	}
	require_once mb_path("/lib-tk/include/common.php");
}
require_once mb_path("/lib-action/action.php");
require_once mb_path("/lib-mbapi/mbapi.php");

class LoginResponse extends MB_Action
{
	/**
	 * The main method of this class that executes the LoginResponse action, and returns success or failure.
	 *
	 * @return  1 if this action executed successfully, or 0 if otherwise.
	 */
	public function execute()
	{
		global $CONF;
		parent::execute();

		$query = $this->getMBAPIQuery("ProcessClientLogin", "",	array(
			"clientIP" => $CONF["user"]["ip"],
			"contactUsername" => bgpc("user_name"),
			"contactPassword" => bgpc("user_password"),
		));
		$data = dispatchMBAPI($query, 1);
		//show($data, 1);
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {

			if(is_array($data["mbapi"][0]["results"][0]["clientID"])) {
				$_REQUEST["sid"] = $data["mbapi"][0]["results"][0]["sessionID"][0];

				require_once("object_managers/SessionManager.php");
				SessionManager::deleteExpiredSessions();

				// Allow expired users to resume a new session from where their last one left off
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					if(preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])) {
						redirect($_REQUEST["redirectActionFile"]."?action=".((int) $_REQUEST["redirectActionID"])."&".$_REQUEST["redirectArgs"]);
					}
				} else {
					redirect("dashboard.php", getActionID("ShowDashboard"));
				}
			} else {
				if($_REQUEST["redirectActionID"] && $_REQUEST["redirectActionFile"] && preg_match("/^[a-zA-Z0-9\-\_]*\.php$/", $_REQUEST["redirectActionFile"])){
					redirect("login.php",getActionID("ShowLogin"), array(
						"msg" => "TRANS_AUTH_FAILED",
						"redirectActionID" => $_REQUEST['redirectActionID'],
						"redirectActionFile" => $_REQUEST['redirectActionFile'],
						"redirectArgs" => $_REQUEST['redirectArgs'],
					));
				} else {
					redirect("login.php",getActionID("ShowLogin"), array("msg" => "TRANS_AUTH_FAILED"));
				}
			}
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
} // LoginResponse
?>
