<?php
require_once dirname(__FILE__)."/".str_repeat("../",4)."lib-tk/shield.php";
require_once mb_path("/admin/include/lib-action/packages/UpgradeDowngradeAction.php");

class UpgradePackageResponse extends UpgradeDowngradeAction
{
	public function __construct()
	{
		parent::UpgradeDowngradeAction();
		global $CONF;
		loadConfigs("product", "managementrules");
		$this->stringRep = "UpgradePackage";
		$this->constants = array(
			"TRANS_PRORATED_X_FEE" => TRANS_PRORATED_UPGRADE_FEE,
			"TRANS_ITEMIZED_X_CREDITS" => TRANS_ITEMIZED_UPGRADE_CREDITS,
			"TRANS_PACKAGE_X" => TRANS_PACKAGE_UPGRADE,
			"TRANS_PACKAGE_X_DESC" => TRANS_PACKAGE_UPGRADE_DESC,
			"TRANS_PACKAGE_ADDON_X" => TRANS_PACKAGE_ADDON_UPGRADE,
			"TRANS_PACKAGE_ADDON_X_DESC" => TRANS_PACKAGE_ADDON_UPGRADE_DESC,
			"TRANS_X_FEE" => TRANS_UPGRADE_FEE,
		);
		$this->subCommand = "panelUpgrade";
		$this->params = array("packageID");

		$clientID = $CONF["user"]["id"];

		$rules =& $CONF["product"]["managementrules"];
		$_REQUEST["packageUpgradeDowngradeType"] = ((int)$rules["whenUpgrade"]==0) ? ((int)$rules["applyUpgradeCredits"]==1 ? 0 : 1 ) : 2;
		$_REQUEST["packageProvision"] = (int)$rules["provisionUpgrades"];
		$_REQUEST["generateInvoice"] = (int)$rules["generateUpgradeInvoice"];
		$_REQUEST["packageComments"] = "";

		$_REQUEST["packagePrices"] = array(
			"original" => 0,
			"general" => 0,
			"fee" => 0,
			"coupon" => 0,
			"couponcycles" => 0,
		);

		$params = array(
			"packageID" => (int)$_REQUEST["packageID"],
			"getPackageAttributeData" => 1,
			"getPackageDatabaseData" => 1,
			"getDomainData" => 1,
			"getCertData" => 1,
			"getPackageAddonData" => 1,
		);
		if (0 != $clientID) {
			$params["clientID"] = $clientID;
		}
		$this->packageInfo = correctArray(grabFirstResultFromMBAPIArray(array(
			"mbapi" => array(
				"command" => "GetPackages",
				"params" => $params,
			),
		)));

		$this->packageInfoCache[(int)$_REQUEST["packageID"]] =& $this->packageInfo;
		$packageInfo =& $this->packageInfo;
		if (!$packageInfo["packageID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid packageID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		}

		$currencyID = Factory()->Package($packageInfo["packageID"])->OrderForm->currency_id;
		$productInfo = oneOf("products", array(
			"productID" => (int)$_REQUEST["productID"],
			"productActive" => 1,
			"getProductVariantData" => 1,
			"getProductVariantPriceData" => 1,
			"getCycleData" => 1,
		));
		$prices = array();
		if (!$productInfo["productID"]){
			$this->addError("TRANS_ACTIONERROR", "Invalid productID.");
			$this->addErrorTemplates();
			$this->hasExecutedSuccessfully();
			exit;
		} else {
			foreach ($productInfo["productVariantPrices"] as $p){
				if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$currencyID && $p["productVariantID"]==(int)$_REQUEST["productVariantID"]){
					$prices[$p["productVariantPriceType"]] = $p;
				}
			}
			$_REQUEST["packagePrices"] = array(
				"original" => (float)$prices[0]["productVariantPriceAmount"],
				"general" => (float)$prices[0]["productVariantPriceAmount"],
				"fee" => (float)$prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"],
			);

			$addonsInfo = arrayFor("products", array(
				"parentProductID" => $productInfo["productID"],
				"productActive" => 1,
				"getProductVariantData" => 1,
				"getProductVariantPriceData" => 1,
				"getCycleData" => 1,
			));

			foreach ($addonsInfo as $addon){
				$prices = array();
				foreach ($addon["productVariantPrices"] as $p){
					if ($p["cycleID"]==$packageInfo["cycleID"] && $p["currencyID"]==$currencyID){
						$prices[$p["productVariantPriceType"]] = $p;
					}
				}
				$_REQUEST["prices"][$addon["productID"]] = array(
					"general" => (float)$prices[0]["productVariantPriceAmount"],
					"original" => (float)$prices[0]["productVariantPriceAmount"],
					"fee" => (float)$prices[getAPITypeID("price", "upgradefee")]["productVariantPriceAmount"],
					"coupon" => 0,
					"couponcycles" => 0,
				);
			}
		}
	}
}
