<?php
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class AddBillingAccount extends AddAction
{
	public function __construct()
	{
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		$_REQUEST["clientContactID"] = $clientContactID;
		
		require_once("object_managers/ClientBillingAccountManager.php");
		if (!$this->_allowedBillingAccountTypes = ClientBillingAccountManager::getAllowedBillingAccountTypes()) {
			$this->addError(blmsg("TRANS_ACTIONERROR"), blmsg("TRANS_NO_ALLOWED_BILLING_TYPES_FOR_ADD"));
			$this->addErrorTemplates();
			exit;
		}

		$this->d = new DataSource("billingAccounts", array("clientContactID" => $clientContactID));
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		$description["display"]["addTemplate"] = "profile/AddBillingAccount";
		$this->d->setDescription($description);
		parent::AddAction();
	}

	function addHandler()
	{

		global $CONF;
		$clientID = $CONF["user"]["id"];
		$contact = oneByID(":contacts", $CONF["user"]["clientContactID"]);
		$this->smartyVars['isPrimary'] = $contact['contactPrimary'];

		$this->smartyVars['client'] = oneByID(":clients", $CONF['user']['id']);

		loadConfigs("payment");

		$this->smartyVars["billingAccountTypes"] = $this->_allowedBillingAccountTypes;
		// remove account types that the admin wants to restrict from the client.
		foreach( (array)$this->smartyVars["billingAccountTypes"] as $k => $v ) {
			if ($CONF["payment"]["clientSidePaymentOptions"][ getAPITypeName( "billingAccount", $k ) ] != 1) {
				unset( $this->smartyVars["billingAccountTypes"][ $k ] );
			}
		}	unset( $k, $v );

		$this->smartyVars["bankAccountTypes"] = getTypes("bankAccount");
		$this->smartyVars["cardExtraTypes"] = getTypes("cardExtraIDs");

        require_once("object_managers/PaymentGatewayManager.php");
        $this->smartyVars["cardTypes"] = PaymentGatewayManager::getCardTypes();

		$this->smartyVars["selectablePackages"] = optionsFor("packages", array("clientID" => $clientID));

		require_once("objects/PaymentGateway.php");
		$bt_gateways = Factory()->PaymentGatewayList(array("payment_gateway_type" => PaymentGateway::TYPE_HSPC_BANK_TRANSFER));
		if (0 < count($bt_gateways)) {
			$fake_billing_account = Factory()->ClientBillingAccount();
			foreach ($bt_gateways as $bt_gateway) {
				$plugin = ModuleTool::getModuleInstance("gateway", "HSPCBankTransfer", array("gateway_id" => $bt_gateway->id));
				$fake_billing_account->payment_gateway_id = $bt_gateway->id;
				$adapter_input_fields = $plugin->getPaymentMethodAdapter($fake_billing_account)->getInputFields(true);
				$input_fields = array();
				foreach ($adapter_input_fields as $field_name => $field_opts) {
					$input_fields[] = array(
						"field_name" => "{$field_name}_{$bt_gateway->id}",
						"field_title" => $field_opts[0],
						"field_desc" => $field_opts[2],
					);
				}
				$this->smartyVars["ddbp_accounts"][] = array(
					"gateway_id" => $bt_gateway->id,
					"gateway_name" => $bt_gateway->payment_gateway_name,
					"gateway_desc" => $bt_gateway->payment_gateway_description,
					"fields" => $input_fields,
				);
			}
			$this->smartyVars["selected_ddbp_gateway_id"] = bgpc("selected_ddbp_gateway_id");
		}
		
		return true;
	}
	
	private $_allowedBillingAccountTypes;
}
