<?php

require_once("lib-tk/shield.php");
require_once("lib-action/action.php");

class AddClientContact extends MB_Action
{
	public function execute()
	{
		global $CONF;
		parent::execute();

		$current_contact = Factory()->ClientContact(getCurrentSession()->user_id);

		$query = $this->getMBAPIQuery("GetClients", "", array("clientID" => $current_contact->client_id));
		require_once("lib-mbapi/mbapi.php");
		$data = dispatchMBAPI($query, 1);

		$results =& $data["mbapi"][0]["results"][0];
		if($this->addMBAPIErrors($data) === 0 && !$this->getNumErrors()) {
			$this->mergeCountryData();
			$this->mergeLanguageData();
			$this->smartyVars["client"] = correctArray($results["clients"][0]["client"][0]);

			require_once("lib-billing/include/config/internal/emailactions.php");
			$this->smartyVars["emailActions"] = blmsg_array($CONF["types"]["emailAction"]);

			$formDefaults = array(
				"countriesID" => $this->smartyVars["client"]["countriesID"],
				"languageID" => $current_contact->language_id,
				"contactActive" => 1,
				"contactEmailFormat" => 1,
			);
			$this->mergeFormState($formDefaults);

			$this->addTemplate("profile/AddClientContact");
		}

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
