<?php
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-action/action.php");

class ReauthBillingAccountResponse extends GenericAction
{
	public function __construct()
	{
		global $CONF;
		$clientContactID = $CONF["user"]["clientContactID"];
		if(!oneOf("billingAccounts", array("clientContactID" => $clientContactID, "billingAccountID" => (int) $_REQUEST["billingAccountID"]))) {
			$this->addError(MBAPI_ACTIONERROR, "No valid match.");
			return false;
		}

		$_REQUEST["clientContactID"] = $clientContactID;

		$this->d = new DataSource("billingAccounts");
		$description = $this->d->getDescription();
		$description["names"]["file"] = "profile";
		parent::GenericAction();

		$this->d->setDescription($description);
		$this->d->setMode("update");
	}

	public function execute()
	{
		parent::execute();

		$transactionRecord = oneOf(
			"gwTransactions",
			array(
				"gwTransactionID" => (int) $_REQUEST["gwTransactionID"],
				"billingAccountID" => (int) $_REQUEST["billingAccountID"],
			)
		);
		$gateway_transaction = Factory()->GwTransaction($transactionRecord["gwTransactionID"]);

		$billingAccountID = (int) $_REQUEST["billingAccountID"];

		$paymentAmount = (float) $_REQUEST["authAmount"];
		$cardNum = $_REQUEST["cardNum"];
		$cardCVV2 = $_REQUEST["cardCVV2"];
		do {
			$q = new MBQuery("ProcessGateway", "reauth", array(
				"paymentGatewayID" => $gateway_transaction->payment_gateway_id,
				"currencyID" => $gateway_transaction->GwTransactionAttributes["currency"]->value,
				"billingAccountID" => $billingAccountID,
				"paymentDescription" => "Reauthorization",
				"paymentAmount" => $paymentAmount,
				"cardNum" => $cardNum,
				"cardCVV2" => $cardCVV2,
			));
			$r =& $q->getResult();
			if(!$status = $r->getSuccess()) {
				$this->addErrorsFromResult($r);
				break;
			}
			$s =& $r->getSubjectFrom(array("mbapi", "results", "gatewayReturn", 0));
			$results = $s->getCollapsed();
			if(!$resultStatus = ($results["status"] != 3)) {
				$this->addError(TRANS_ACTIONERROR, "Reauthorization transaction failed: " . $results["message"]);
				break;
			}

			$authedTransactionRecordIDs = IDsOf(
				"gwTransactions",
				array(
					"gwTransactionType" => "reject",
					"billingAccountID" => (int) $_REQUEST["billingAccountID"],
					"paymentGatewayID" => $gateway_transaction->payment_gateway_id,
				)
			);
			if(!$clearStatus = updateForKey(
				"gwTransactions", $authedTransactionRecordIDs,
				array(
					"gwTransactionType" => "reauthedreject",
				)
			)) {
				$this->addError(TRANS_ACTIONERROR, "Failed to clear authed rejections: " . lastError());
				break;
			}

			$this->redirect();
		} while(0);

		$this->addErrorTemplates();
		return $this->hasExecutedSuccessfully();
	}
}
