<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty gerAmount modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getAmount<br>
 * Purpose:  checks to see if sting is a constant and returns the value of that constant
 * @param 	 amount to display (double)
 * @param	 three digit currency code
 * @param    whether to return a space or formatted zeros when amount = 0
 * @return string
 */
function smarty_modifier_getAmount($amount, $curr=NULL, $returnZeros=true, $allZeros=false)
{
    if ($returnZeros==false && $amount==0)return "&nbsp;";

    $ret = (" " == $curr) ? BillingLocale::getDecimal($amount) : BillingLocale::getCurrency($amount, $curr);

    if ($allZeros==true){
        $ret = str_replace("1", "0", $ret);
    }

	return $ret;
}

?>