<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty getDate modifier plugin. Takes a UNIX timestamp and returns a string representation of it.
 *
 * Type:     modifier<br>
 * Name:     getDate<br>
 * Purpose:  To convert the given UNIX timestamp to a string.
 * @param int  The UNIX timestamp to get the string representation of.
 * @param string  The "length" of the formatted date to return.
 * @return string  A formatted string representation of the given timestamp.
 */
function smarty_modifier_getDate($timestamp, $format = "short") {
	$retval = blmsg("TRANS_NEVER");
	$timestamp = (int) $timestamp;
	if($timestamp > 0) {
		switch ($format) {
			case "short":
				return BillingLocale::getDateShort($timestamp);
			case "medium":
				return BillingLocale::getDateMedium($timestamp);
			case "long":
				return BillingLocale::getDateLong($timestamp);
			case "full":
				return BillingLocale::getDateFull($timestamp);
			default:
				throw new Exception("Incorrect date type '{$format}'");
		}
	}
	return $retval;
}
?>