<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty getDateTime modifier plugin
 *
 * Type:     modifier<br>
 * Name:     getDateTime<br>
 * Purpose:  Return the date and time in a locale sensitive format
 * @param int
 * @param string
 * @return string
 */
function smarty_modifier_getDateTime($timestamp, $format = "short") {
	$retval = blmsg("TRANS_NEVER");
	$timestamp = (int) $timestamp;
	if($timestamp) {
		switch ($format) {
			case "short":
				return BillingLocale::getDateTimeShort($timestamp);
			case "medium":
				return BillingLocale::getDateTimeMedium($timestamp);
			case "long":
				return BillingLocale::getDateTimeLong($timestamp);
			case "full":
				return BillingLocale::getDateTimeFull($timestamp);
			default:
				throw new Exception("Incorrect dateTime type '{$format}'");
		}
	}
	return $retval;
}

?>