<?php
// --------------------------------------------------------------------------
// DATABASE SETTINGS
// --------------------------------------------------------------------------

	// Define the path to local database:
$CONF["localDbFilePath"] = '@@LOCAL_DB_FILE_PATH@@';

// --------------------------------------------------------------------------
// URL SETTINGS
// --------------------------------------------------------------------------

	// Define the HTTP URL to the directory containing your ModernBill
	// applications and libraries.
	// IMPORTANT: 	Leave off the "http://" and do not set a trailing slash!
	// EXAMPLE: 	$CONF["standardURL"] = "www.yourhost.com/modernbill";
$CONF["standardURL"] = '@@STANDARD_URL@@';

	// Define the HTTPS URL to the directory containing your ModernBill
	// applications and libraries.
	// IMPORTANT: 	Leave off the "https://" and do not set a trailing slash!
	// EXAMPLE: 	$CONF["secureURL"] = "www.yourhost.com/modernbill";
$CONF["secureURL"] = '@@STANDARD_URL@@';

	// Define the protocol to use for web access to this Modernbill
	// installation.
	// Set to "http" if you DO NOT HAVE an SSL certificate.
	// Set to "https" if you DO HAVE an SSL certificate.
	// Posible Values: "http" or "https"
$CONF["secureURLProtocol"] = '@@SCHEME@@';

	// Set to a number if your web server uses a different port.
	// EXAMPLE:		$CONF["secureURLPort"] = 4562;
$CONF["secureURLPort"] = '@@PORT@@';

	// if set, points to ModernBill root at specified URL (only needs lib-themes) for static web files
	// EXAMPLE:		$CONF["staticWebRoot"] = "http://images.mydomain.com:8080"; // thttpd running on port 8080
$CONF["staticWebRoot"] = false;

// --------------------------------------------------------------------------
// DIRECTORY & GRAPH SETTINGS
// --------------------------------------------------------------------------

	// Define the world writable directory in which your Modernbill
	// installation can store temporary files
	// IMPORTANT: 	Do not set a trailing slash!
	// Unix Example: 	$CONF["tempDirectory"] = "/tmp";
	// Windows Example: $CONF["tempDirectory"] = "C:\\Windows\\Temp";
$CONF["tempDirectory"] = '@@TMP_DIR@@';

	// ** Oracle Only **
	// Define the absolute path to oracle.
	// Musth match your $ORACLE_HOME
$CONF["dbOracleHome"] = "/opt/oracle/product/10.1.0.3";

	// Define the font that JPGraph will use to render images.
	// ** If you need support for UTF-8, please see the following KB
	// ** http://kb.modernbill.com/v5/index.php?article=10
	// Default font: FF_FONT1
$CONF["graphDefaultFont"] = "FF_FONT1";

	// Define the absolute path where the email attachments will be saved.
$CONF["emailAttachmentsDirectory"] = '@@EMAIL_ATTACHMENTS_DIR@@';

	// Define the absolute path where the action log will be saved.
$CONF["actionLogDirectory"] = '@@ACTION_LOG_DIR@@';

	// Define the absolute path where the invoice logo will be saved.
$CONF["invoiceLogoDirectory"] = '@@INVOICE_LOGO_DIR@@';

	// Define the absolute path where the invoice facturas will be procesed.
$CONF["invoiceFacturaDirectory"] = '@@INVOICE_FACTURA_DIR@@';

	// Define the command, executing HTML to PDF convertion.
$CONF["htmlToPdfCommand"] = '@@HTML_TO_PDF_COMMAND@@';

// --------------------------------------------------------------------------
// cURL SETTINGS (command line curl)
// --------------------------------------------------------------------------

	// Define the absolute path to your command line cURL if not using
	// PHP's cURL
	// Unix Example 1: Use the environment path to curl "/usr/bin/env curl"
	// *nix Example 2: "/usr/bin/env curl" or "/usr/bin/curl -k"
	// Windows Example: "C:\\path\\to\\curl\\bin\\curl.exe -k"
$CONF["cliCurlPath"] = "/usr/bin/env curl";
$CONF["forceCLICurl"] = 0;

	// Define GLOBAL cURL option overrides
	// Verify valid certificate before initiating connection
	// by default, these are 0
//$CONF["cURLoverrides"]["CURLOPT_SSL_VERIFYHOST"] = 2;
//$CONF["cURLoverrides"]["CURLOPT_SSL_VERIFYPEER"] = 1;
	// If needed, set one or both to the correct paths:
//$CONF["cURLoverrides"]["CURLOPT_CAINFO"] = "/path/to/ca-bundle.crt";
//$CONF["cURLoverrides"]["CURLOPT_CAPATH"] = "/path/to/ca-bundle-folder/";

// --------------------------------------------------------------------------
// MIGRATION SETTINGS
// --------------------------------------------------------------------------

	// Change this to 1 to enable migration
define("ALLOW_MIGRATION", 0);

	// whether keep v4 client and package IDs
$CONF["syncMigrationIDs"] = true;

	// a number above any v4 package ID, to avoid namespace collision
$CONF["raisePriorBalancePackageKeysBy"] = 50000;

	// whether to migrate module config
$CONF["migrateModules"] = true;

	// whether to migrate products
$CONF["migrateProducts"] = true;

	// whether to migrate tlds
$CONF["migrateTLDs"] = true;

	// whether to migrate tlds
$CONF["migrationEncoding"] = NULL;
//$CONF["migrationEncoding"] = "ISO-8859-1";

	// whether to migrate add-on prices (requires that their prices were never changed)
$CONF["migrateAddonPrices"] = false;

	// optional group ID to associate with all non-add-on products
$CONF["migrationProductGroupID"] = NULL;

	// optional tax zone group ID to associate with all of the product variants
$CONF["migrationTaxZoneGroupID"] = NULL;

	// optional discount group ID to associate with all of the product variants
$CONF["migrationDiscountGroupID"] = NULL;

// --------------------------------------------------------------------------
// MBAPI APPLICATION SETTINGS
// --------------------------------------------------------------------------

	// Define the MBAPI install type:
	// Set to "local" if accessing the local MBAPI (Default)
	// Set to "remote" if accessing a remote MBAPI
$CONF["installType"] = "local";

	// If "installType" = "remote", define the MBAPI remote access hash (at
	// the Admin level)
	// If "installType" = "local", simply ignore (Default)
$CONF["remoteAccessHash"] = "";

	// If "installType" = "remote", define the FULL MBAPI URL
	// If "installType" = "local", simply ignore (Default)
$CONF["remoteMBAPIURL"] = "http://ENTER_THE_URL_TO/lib-billing/include/lib-mbapi/remote.php";

	/**
	 * Example of load distributing remote MBAPI url (REQUIRES ADVANCED MBAPI
	 * POOLING AND CLUSTERING)
	 * $CONF["remoteMBAPIURL"] = array(
	 * 		"http://ENTER_THE_URL_TO_1/lib-mbapi/remote.php",
	 * 		"http://ENTER_THE_URL_TO_2/lib-mbapi/remote.php",
	 * 		"http://ENTER_THE_URL_TO_3/lib-mbapi/remote.php",
	 * 		"http://ENTER_THE_URL_TO_4/lib-mbapi/remote.php",
	 * );
	*/

	// Define the MBAPI connection method to GET & POST or POST ONLY:
	// Set to "1" to allow external MBAPI calls using http GET & POST calls
	// Set to "0" to allow external MBAPI calls using http POST calls ONLY
$CONF["mbapi"]["allowGet"] = 0;

	// Define the IP addresses allowed to access this MBAPI install:
	// To allow MBAPI calls, you must add each IP address that you would like
	// to allow access to.
	// IMPORTANT:	Add one line per IP address.
	// EXAMPLE: 	$CONF["remoteIP"][] = "4.2.2.100";
//$CONF["remoteIP"][] = "4.2.2.200";

// --------------------------------------------------------------------------
// SYSTEM QUEUE SETTINGS (advanced usage only)
// --------------------------------------------------------------------------

	// The system queue can persist itself in any of 3 ways:
	// 1. by recursively doing an http client request back to RunEvents
	// 2. by forking off of a CGI process, and daemonizing the child
	// 3. by just being run from the command line
	// The following two variables affect the logic of which method to use.

	// Possible Values: NULL (for auto-detect), true, false
$CONF["forcePersistableTo"] = NULL;

	// Possible Values: NULL (for auto-detect), true, false
$CONF["forceDaemonableTo"] = NULL;

	// If you server has a firewall where the remote IP is dispatched to a
	// local IP, then enter the local IP here. This will allow the events
	// queue to call itself locally instead of using the primary domain.
$CONF["localURL"] = "";

	// Define whether to let the system queue run till its dead or give it a
	// limit. Set to "1" and the system queue thread will be stopped as soon
	// as it tries to restart itsself. See "killOldQueueThreads" example usage
	// below.
$CONF["killOldQueueThreads"] = 0;

	// Define the time in seconds that a system queue thread can keep running.
	// This should be 45 seconds to a minute less then the time that cron
	// waits to hit the system.
	// If cron hits every 5 minutes, this should be 4 minutes, or 240 seconds.
	// If cron hits every minute, this needs to be like 15 seconds.
	// If cron hits every hour, this needs to be 59 minutes, or 59*60 seconds
$CONF["killOldQueueThreadsLimit"] = 240;

	// Example usage for "killOldQueueThreads" cont'd ...
	// If its originating thread is older then the limit below
	// Reason: If there are 100 things in the system queue to run that all
	// are supposed to run right now, we dont want the system queue to start
	// a new thread running them every 5 minutes if the cron runs the system
	// queue that often.
	//
	// An ascii art illistration would look as follows:
	//
	// Timeline is in minutes:
	//
	// IF "killOldQueueThreads" = 0:
	//
	//           0     5     10    15    20    25    30    35    40    45   50
	//           |-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|
	// thread 1: .............................................................
	// thread 2:       .......................................................
	// thread 3:             .................................................
	// thread 4:                   ...........................................
	// thread 5:                         .....................................
	// thread 6:                               ...............................
	// thread 7:                                     .........................
	// thread 8:                                           ...................
	// thread 9:                                                 .............
	// thread 10:                                                      .......
	//
	// IF "killOldQueueThreads" = 1:
	//
	//           0     5     10    15    20    25    30    35    40    45   50
	//           |-----|-----|-----|-----|-----|-----|-----|-----|-----|-----|
	// thread 1: ......
	// thread 2:       ......
	// thread 3:             ......
	// thread 4:                   ......
	// thread 5:                         ......
	// thread 6:                               ......
	// thread 7:                                     ......
	// thread 8:                                           ......
	// thread 9:                                                 ......
	// thread 10:                                                      .......

// --------------------------------------------------------------------------
// IPC SETTINGS (experimental advanced performance settings)
// --------------------------------------------------------------------------
// Please do not enable these unless you are familiar with manually
// administering shared memory on a Unix box. They also do not necessarily
// flush at the appropriate times yet, and will likely break something
// eventually. It is recommended to only enable locale caching since the
// locale data rarely becomes stale and only this setting makes a
// significant impact on performance. See ipcs(1) and ipcrm(1).

	// Cache locale object in shared memory (Unix-only)
	// Cache hit saves about 0.2 seconds
	// Extensions:
	//   Required: sysvshm
	//   Optional: sysvsem
$CONF["enableSharedMemoryLocaleCache"] = false;

	// Persist admin lookups
	// Cache hit saves about 0.02 seconds
	// Extensions:
	//   Required: sysvshm, sysvsem
$CONF["enableSharedMemoryAdminCache"] = false;
$CONF["adminCacheSeconds"] = 300;

	// Persist mb_path() cache in shared memory (Unix-only)
	// Cache hit saves about 0.02 seconds.
	// Extensions:
	//   Required: sysvshm, sysvsem
$CONF["enableSharedMemoryMBPathCache"] = false;

// --------------------------------------------------------------------------
// SMARTY TEMPLATE SETTINGS
// --------------------------------------------------------------------------

	// Define the absolute path where the compiled tpl files will be saved.
	// If the directory does not exist, you must create it.
	// ** This directory must be chmod 777
$CONF["smarty"]["compileDirectory"] = '@@SMARTY_TMP_DIR@@' . DIRECTORY_SEPARATOR . "compile";

	// Define the absolute path where the cached tpl files will be saved.
	// If the directory does not exist, you must create it.
	// ** This directory must be chmod 777
$CONF["smarty"]["cacheDirectory"] = '@@SMARTY_TMP_DIR@@' . DIRECTORY_SEPARATOR . "cache";

	// Enable smarty template caching:
	// Possible Values: true (Not Recommended) or false (Default)
$CONF["smarty"]["enableCaching"] = false;

	// If "enableCaching" = "true, set the lifetime (in seconds) of cached
	// smarty templates. (1 Default)
$CONF["smarty"]["cacheLifetime"] = 1;

	// Enable smarty template compile checking:
	// Possible Values: true (Default) or false
$CONF["smarty"]["enableCompileChecking"] = true;

	// Enable high security mode in smarty templates. This will stop tpl
	// files from executing bad code.
	// Possible Values: true (Not Recommended) or false (Default)
$CONF["smarty"]["enableSecurity"] = false;

	// Enable smarty template debugging window. Tis will display the SMARTY
	// popup window for debugging tpl files.
	// Possible Values: true (Debugging Only) or false (Production Mode - Default)
$CONF["smarty"]["enableDebugging"] = false;

// --------------------------------------------------------------------------
// SMARTY TEMPLATE SETTINGS (advanced settings)
// --------------------------------------------------------------------------

	// Enable the logging of unknown translation constants in smarty templates.
	// Possible Values: true (Internal Use Only) or false (Default)
$CONF["smarty"]["logUnknownConstants"] = false;

// --------------------------------------------------------------------------
// ADDITIONAL SETTINGS - DO NOT CHANGE (advanced settings)
// --------------------------------------------------------------------------

if (!defined("MB_LIBPATH")){
	define("MB_LIBPATH", realpath(dirname(__FILE__)."/../../.."));
	require_once(MB_LIBPATH."/lib-pkg/parsefunction.php");
}
require mb_path("/lib-billing/include/config/internal/ColumnMap.php");
require mb_path("/lib-billing/include/config/internal/QueryMasterMap.php");
if (substr($CONF["standardURL"], -1)=="/") {
	$CONF["standardURL"] = substr($CONF["standardURL"], 0, -1);
}
if (substr($CONF["secureURL"], -1)=="/") {
	$CONF["secureURL"] = substr($CONF["secureURL"], 0, -1);
}
$hparts = explode("/", $CONF["standardURL"]);
$CONF["standardHost"] = $hparts[0];
$hparts = explode("/", $CONF["secureURL"]);
$CONF["secureHost"] = $hparts[0];
if ($CONF["secureURLProtocol"]=="http"){
	$CONF["relativeWebRoot"] = substr($CONF["standardURL"], strpos($CONF["standardURL"], $CONF["standardHost"])+strlen($CONF["standardHost"]));
} else {
	$CONF["relativeWebRoot"] = substr($CONF["secureURL"], strpos($CONF["secureURL"], $CONF["secureHost"])+strlen($CONF["secureHost"]));
}

// set items to try again no sooner than 1 day from time of failure
$CONF["billingAccountShareRetryTime"] = (60*60*24);

define("INVOICE_PROCESS_PACKAGE_LOCK_TIMEOUT", 5*60); // 5 minutes
define("USE_PREDEFINED_RESELLER_VOLUME_DISCOUNTS", 0);
define("RESELLER_VOLUME_PRODUCT_GROUP_API_NAME", "dedicatedservers");
define("DEFAULT_MAXIMUM_DISCOUNT", 100);
define("ENABLE_MBAPI_COMMAND_HOOKS", 0);
define("NUMBER_OF_INVOICES_PER_EVENT", 25);
define("MBACTION_DEFAULT_NUM_RECORDS", 30);
define("MAX_AUTOCOMPLETE_RESULTS", 20);
define("CREATE_PLAINTEXT_PACKAGE_PASSWORD", 0);
define("DEFAULT_CONTACT_EMAIL_FORMAT", 1);

define("PAYMENT_PROCESS_PACKAGE_LOCK_TIMEOUT", 60*60);
define("BILLING_ACCOUNT_RETRY_PUSH_TIME", 60*60*24*7);

// keep this at 0 unless this is a demo.
define('DEMOMODE', 0);

//$CONF["remoteMBAPIURL"] = array_rand((array)$CONF["remoteMBAPIURL"]);

define("ALLOW_DEBUG_LOGGING", false);
