<?php

require_once(dirname(__FILE__)."/../../../../../lib-tk/shield.php");
require_once("lib-tk/mbapimap.php");

$CONF['sources']['admins'] = array(
	"names" => array(
		"singular" => "admin",
		"plural" => "admins",
		"file" => "admins",
	),
	"request" => array(
		"command" => "GetAdmins",
		"subCommand" => "",
		"params" => array("getAdminGroupData" => 1),
	),
	"response" => array(
		"path" => array("admins", "admin"),
	),
	"insert" => array(
		"command" => "SetAdmins",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetAdmins",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetAdmins",
		"subCommand" => "delete",
		"params" => new Params(new Param("adminID")),
	),
	"table" => "admins",
	"columns" => array(
		"adminID" => COLUMN_PRIMARY_KEY|COLUMN_RESTRICT_MODIFY,
		"adminFirstName" => COLUMN_TEXT,
		"adminLastName" => COLUMN_TEXT,
		"adminEmail" => COLUMN_STRING,
		"adminUsername" => COLUMN_PRIMARY_NAME,
		"adminPassword" => COLUMN_PASSWORD,
		"adminTempPassword" => COLUMN_PASSWORD,
		"adminRemoteAccessHash" => COLUMN_SEARCHABLE_STRING,
		"adminActive" => COLUMN_ACTIVE,
		"themeID" => COLUMN_ID,
		"skinID" => COLUMN_TEXT,
		"languageID" => COLUMN_ID,
		"countriesID" => COLUMN_ID,
		"guid" => COLUMN_TEXT,
		"syncStatus" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncTasks" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"syncError" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncLastTime" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
	),
	"relations" => array(
		"adminGroups" => array("admin_group_rel", "adminGroupIDs", "adminGroupID"),
	),
	"display" => array(
		"showTemplate" => "admins/ShowAdmins",
		"showDetailsTemplate" => "admins/ShowAdminDetails",
		"addTemplate" => "admins/AddAdmin",
		"editTemplate" => "admins/EditAdmin",
		"options" => array("themes", "languages", "countries", "adminGroups"),
		"context" => array(
			"themeID" => "themes",
			"languageID" => "langauges",
			"countriesID" => "countries",
		),
		"revContext" => array(
			"clientNotes" => "adminID",
			"migrationReservations" => "adminID",
		),
		"system" => true,
	),
);
