<?php
require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

function refBillingAccountColumnGenerator(&$row) {
	$row["billingAccountTypeName"] = getTypeName("billingAccount", $row["billingAccountType"]);
	switch (getAPITypeName("billingAccount", $row["billingAccountType"])) {
		case "card":
			$row["billingAccountDisplayName"] = getTypeName("card", $row["billingCardType"]) . " " . $row["billingAccountNumLastFour"] . ": " . $row["billingCardNameOnCard"];
			break;
		case "echeck":
		case "bank":
		case "hspcbanktransfer":
			$row["billingAccountDisplayName"] = $row["billingBankName"] . ": " . $row["billingAccountNumLastFour"];
			break;
		case "manual":
			$row["billingAccountDisplayName"] = TRANS_GENERAL_MANUAL_PAYMENT_ACCOUNT;
			break;
		case "wire":
			$row["billingAccountDisplayName"] = TRANS_WIRE_ACCOUNT;
			break;
		case "secondary":
			$row["billingAccountDisplayName"] = TRANS_THIRD_PARTY_GATEWAY;
			break;
	}
	return true;
}

$CONF['sources']['billingAccounts'] = array(
	"names" => array(
		"displaySingular" => TRANS_BILLING_ACCOUNT,
		"displayPlural" => TRANS_BILLING_ACCOUNTS,
		"singular" => "billingAccount",
		"plural" => "billingAccounts",
		"file" => "clients",
	),
	"request" => array(
		'command' => "GetBillingAccounts",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("billingAccounts", "billingAccount"),
	),
	"insert" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "insert",
		'params' => array(),
	),
	"update" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "update",
		'params' => array(),
	),
	"delete" => array(
		'command' => "SetBillingAccounts",
		'subCommand' => "delete",
		'params' => array(),
	),
	"table" => "client_billing_accounts",
	"columns" => array(
		"billingAccountDisplayName" => COLUMN_PRIMARY_NAME,
		"billingAccountID" => COLUMN_PRIMARY_KEY,
		"priorBillingAccountID" => COLUMN_PRIOR_PRIMARY_KEY,
		"billingAccountHistorical" => COLUMN_HISTORICAL,
		"clientContactID" => COLUMN_ID,
		"billingCardNameOnCard" => COLUMN_TEXT,
		"billingCardType" => COLUMN_TYPE,
		"billingCardNum" => COLUMN_TEXT|COLUMN_ENCRYPT,
		"billingCardExpYear" => COLUMN_INT,
		"billingCardExpMonth" => COLUMN_INT,
		"billingCardIssueNum" => COLUMN_TEXT,
		"billingCardStartDate" => COLUMN_TEXT,
		
		"protxSecurityKey" => COLUMN_TEXT,
		"protxTransactionCode" => COLUMN_TEXT,
		"protxTransactionID" => COLUMN_TEXT,
		"protxAuthorizationCode" => COLUMN_TEXT,
		
		"velocitypayCrossReference" => COLUMN_TEXT,
		"velocitypayAuthAmount" => COLUMN_AMOUNT,
		
		"billingBankType" => COLUMN_TYPE,
		"billingBankName" => COLUMN_TEXT,
		"billingBankAbaCode" => COLUMN_TEXT,
		"billingBankAccountNum" => COLUMN_TEXT|COLUMN_ENCRYPT,
		"billingBankLicenseNum" => COLUMN_TEXT,
		"billingBankLicenseState" => COLUMN_TEXT,
		"billingBankDob" => COLUMN_TEXT,
		"billingBankState" => COLUMN_TEXT,
		
		"billingAccountNumLastFour" => COLUMN_TEXT,
		"billingAccountType" => COLUMN_TYPE,
		"billingAccountStatus" => COLUMN_STATUS,
		"billingAccountActive" => COLUMN_ACTIVE,
		"paymentGatewayID" => COLUMN_ID,
		"billingAccountDateFailed" => COLUMN_IS_DATE,
	),
	"refColumnGenerator" => "refBillingAccountColumnGenerator",
	"relations" => array(
	),
	"types" => array(
		"billingCardType" => "card",
		"billingBankType" => "bankAccount",
		"billingAccountType" => "billingAccount",
	),
	"statuses" => array(
		"billingAccountStatus" => "billingAccount",
	),
	"display" => array(
		"showDetailsTemplate" => "1",
		"detailsAction" => "ShowBillingAccounts",
		"parentForeignKeys" => array(
			"clientID",
			"clientContactID",
		),
		"filterContextValues" => array(
			"clientContactID",
		),
		"context" => array(
			"clientContactID" => "contacts",
		),
		"revContext" => array(
			"clientBillingAccountShares" => "billingAccountID",
			"gwTransactions" => "billingAccountID",
			"transactionLog" => "billingAccountID",
		),
	),
);

?>
