<?php
require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF['sources']['callbackLogs'] = array(
	"names" => array(
		"singular" => "callbackLog",
		"plural" => "callbackLogs",
		"file" => "paymentqueue",
	),
	"request" => array(
		'command' => "GetCallbackLogs",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("callbackLogs", "callbackLog"),
	),
	"insert" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "insert",
		"params" => array(),//$allParamsRoot,
	),
	"update" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "update",
		"params" => array(),//$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetCallbackLogs",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeID")),
	),
	"table" => "callback_log",
	"columns" => array(
		"callbackLogID" => COLUMN_PRIMARY_KEY|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogType" => COLUMN_TYPE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogTransactionID" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogParentTransactionID" => COLUMN_NAME|COLUMN_DISPLAYABLE,
		"callbackLogAction" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogActionStatus" => COLUMN_NAME|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"transactionID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"clientID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"subscriptionID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"paymentGatewayID" => COLUMN_ID,
		"billingAccountID" => COLUMN_ID|COLUMN_DISPLAYABLE,
		"callbackLogDateCreated" => COLUMN_IS_DATE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
	),
	"types" => array(
		"callbackLogType" => "callbackLog",
	),
	"columnLabels" => array(
		"callbackLogID" => TRANS_CALLBACK_LOG_ID,
		"callbackLogType" => TRANS_CALLBACK_LOG_TYPE,
		"callbackLogTransactionID" => TRANS_TRANSACTION_ID,
		"callbackLogParentTransactionID" => TRANS_PARENT_TRANSACTION_ID,
		"callbackLogAction" => TRANS_CALLBACK_ACTION,
		"callbackLogActionStatus" => TRANS_ACTION_STATUS,
		"transactionID" => TRANS_TRANSACTION,
		"clientID" => TRANS_CLIENT,
		"subscriptionID" => TRANS_SUBSCRIPTION,
		"paymentGatewayID" => TRANS_PAYMENT_GATEWAY_ID,
		"billingAccountID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"callbackLogDateCreated" => COLUMN_IS_DATE|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_FINANCES",
		"childName" => "TRANS_MANAGE_BILLING",
		"sideNavMajor" => "finances",
		"sideNavMinor" => "billing",
		"grandchildrenLabels" => array(
			"show" => "TRANS_SHOW_CALLBACK_LOGS",
			"showdetails" => "TRANS_CALLBACK_LOG_DETAILS",
		)
	),
	"display" => array(
		'context' => array(
			'clientID' => 'clientWithPrimary',
			'transactionID' => 'transactionLog',
			'billingAccountID' => 'billingAccounts',
		),
		'revContext' => array(
			'callbackLogAttributes' => 'callbackLogID',
		),
		'showTemplate' => "1",
		'showDetailsTemplate' => "1",
		"suppressActions" => array("add","edit"),
	),
);
