<?php

require_once(dirname(__FILE__)."/../../../../../lib-tk/shield.php");
require_once("lib-tk/mbapimap.php");

$CONF["sources"]["clients"] = array(
	"names" => array(
		"singular" => "client",
		"plural" => "clients",
		"file" => "clients",
	),
	"request" => array(
		"command" => "GetClients",
		"subCommand" => "",
		"params" => array(),
	),
	"response" => array(
		"path" => array("clients", "client"),
	),
	"insert" => array(
		"command" => "SetClients",
		"subCommand" => "insert",
		"params" => array(),
	),
	"update" => array(
		"command" => "SetClients",
		"subCommand" => "update",
		"params" => array(),
	),
	"delete" => array(
		"command" => "SetClients",
		"subCommand" => "delete",
		"params" => array(),
	),
	"table" => "clients",
	"columns" => array(
		"clientID" => COLUMN_PRIMARY_KEY,
		"companyID" => COLUMN_ID,
		"clientCompany" => COLUMN_TEXT,
		"clientType" => COLUMN_INT,
		"clientStatus" => COLUMN_STATUS,
		"applyTax" => COLUMN_BOOL,
		"taxIDNumber" => COLUMN_TEXT,
		"themeID" => COLUMN_ID,
		"skinID" => COLUMN_TEXT,
		"countriesID" => COLUMN_ID,
		"clientActive" => COLUMN_ACTIVE,
		"groupID" => COLUMN_ID,
		"clientDateCreated" => COLUMN_DATE|COLUMN_RESTRICT_EDIT,
		"defaultBillingAccountID" => COLUMN_ID,
		"clientDateCancelled" => COLUMN_DATE,
		"clientBillingDay" => COLUMN_INT,
		"clientSignupIP" => COLUMN_INT,
		"clientLastIP" => COLUMN_INT,
		"clientStatusReason" => COLUMN_TEXT,
		"clientMailInvoices" => COLUMN_BOOL,
		"guid" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncStatus" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncTasks" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"syncError" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncLastTime" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
	),
	"statuses" => array(
		"clientStatus" => "client",
	),
	"display" => array(
		"context" => array(
			"companyID" => "companies",
			"themeID" => "themes",
			"countriesID" => "countries",
			"groupID" => "attributeGroups",
			"defaultBillingAccountID" => "billingAccounts",
		),
		"revContext" => array(
			"contacts" => "clientID",
			"packages" => "clientID",
			"clientNotes" => "clientID",
			"fraudResultsLog" => "clientID",
			"accountingReceiptsJournal" => "clientID",
			"accountingPurchasesJournal" => "clientID",
			"accountingGeneralLedger" => "clientID",
			"callbackLogs" => "clientID",
			"clientAttributes" => "clientID",
			"invoices" => "clientID",
		),
	),
);
