<?php
require_once("lib-tk/mbapimap.php");

$CONF['sources']['companies'] = array(
	"names" => array(
		"singular" => "company",
		"plural" => "companies",
		"file" => "companies",
	),
	"request" => array(
		"command" => "GetCompanies",
		"subCommand" => "",
		"params" => array(),
	),
	"response" => array(
		"path" => array("companies", "company"),
	),
	"insert" => array(
		"command" => "SetCompanies",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetCompanies",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetCompanies",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("companyID")),
	),
	"table" => "companies",
	"columns" => array(
		"companyID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE,
		"companyName" => COLUMN_PRIMARY_NAME|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyShortDescription" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyDescription" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyURL" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyClientURL" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyOrderURL" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyEmail" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyAddress1" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyAddress2" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyCity" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyState" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyZip" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"countriesID" => COLUMN_ID|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyPhone1" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyPhone2" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyFax" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"companyTaxIDNumber" => COLUMN_TEXT|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		"companyID" => "TRANS_ID",
		"companyName" => "TRANS_NAME",
		"companyShortDescription" => "TRANS_SHORT_DESCRIPTION",
		"companyDescription" => "TRANS_DESCRIPTION",
		"companyURL" => "TRANS_URL",
		"companyClientURL" => "TRANS_CLIENT_URL",
		"companyOrderURL" => "TRANS_ORDER_URL",
		"companyEmail" => "TRANS_EMAIL",
		"companyAddress1" => "TRANS_ADDRESS1",
		"companyAddress2" => "TRANS_ADDRESS2",
		"companyCity" => "TRANS_CITY",
		"companyState" => "TRANS_STATE",
		"companyZip" => "TRANS_ZIP",
		"countriesID" => "TRANS_COUNTRY",
		"companyPhone1" => "TRANS_PHONE1",
		"companyPhone2" => "TRANS_PHONE2",
		"companyFax" => "TRANS_FAX",
		"companyTaxIDNumber" => "TRANS_TAX_ID_NUMBER",
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_SYSTEM",
		"sideNavMajor" => "system",
		"sideNavMinor" => "company",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_COMPANY",
			//"show" => "TRANS_SHOW_COMPANIES",
			//"add" => "TRANS_ADD_COMPANY",
			//"showdetails" => "TRANS_COMPANY_DETAILS",
			//"remove" => "TRANS_REMOVE_COMPANY",
		),
		"childNameText" => "TRANS_CHANGE_COMPANY_SETTINGS_WARNING"
	),
	"display" => array(
		//'showTemplate' => "1",
		'showDetailsTemplate' => "hack",
		//'removeTemplate' => "1",
		'editTemplate' => "1",
		//'addTemplate' => "1",
		"suppressActions" => array("show", "showdetails", "add", "remove", "remove"),
		//"options" => array("countries"),
		"context" => array(
			"countriesID" => "countries",
		),
		"detailsAction" => "EditCompany",
	),
);