<?php

require_once("lib-tk/mbapimap.php");

$CONF["sources"]["cycles"] = array(
	"names" => array(
		"singular" => "cycle",
		"plural" => "cycles",
		"file" => "products",
	),
	"request" => array(
		"command" => "GetCycles",
		"subCommand" => "",
		"params" => array(),
	),
	"response" => array(
		"path" => array("cycles", "cycle"),
	),
	"insert" => array(
		"command" => "SetCycles",
		"subCommand" => "insert",
		"params" => array(),
	),
	"update" => array(
		"command" => "SetCycles",
		"subCommand" => "update",
		"params" => array(),
	),
	"delete" => array(
		"command" => "SetCycles",
		"subCommand" => "delete",
		"params" => array(),
	),
	"table" => "cycles",
	"columns" => array(
		"cycleID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		"cycleDisplayName" => COLUMN_PRIMARY_NAME|COLUMN_TRANSLATION_MESSAGE|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumSeconds" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumMinutes" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumHours" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumDays" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumMonths" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
		"cycleNumYears" => COLUMN_SEARCHABLE_INTEGER|COLUMN_LISTABLE|COLUMN_EDITABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		"cycleID" => "TRANS_ID",
		"cycleDisplayName" => "TRANS_NAME",
		"cycleNumSeconds" => "TRANS_SECONDS",
		"cycleNumMinutes" => "TRANS_MINUTES",
		"cycleNumHours" => "TRANS_HOURS",
		"cycleNumDays" => "TRANS_DAYS",
		"cycleNumMonths" => "TRANS_MONTHS",
		"cycleNumYears" => "TRANS_YEARS",
	),
	"relations" => array(
		"cycleGroups" => array("cycle_group_rel", "cycleGroupIDs", "cycleGroupID"),
		"productLedgerEntries" => array("product_ledger_cycle_rel", "productLedgerIDs", "productLedgerID"),
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_SYSTEM",
		"sideNavMajor" => "products",
		"sideNavMinor" => "cycles",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_CYCLE",
			"show" => "TRANS_SHOW_CYCLES",
			"add" => "TRANS_ADD_CYCLE",
			//"showdetails" => "TRANS_CYCLE_DETAILS",
			"remove" => "TRANS_REMOVE_CYCLE",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		//"showDetailsTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"suppressActions" => array("showdetails"),
        "showAddButton" => '1',
	),
);
