<?php

require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["shoppingSessions"] = baseMap("shopping_sessions", null, "shoppingSessions", "shoppingSession") + array(
	"columns" => array(
		'shoppingSessionID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'clientID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'clientContactID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'shoppingSessionTimestamp' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'shoppingSessionIP' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'shoppingSessionURL' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'orderFormID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'widgetTemplate' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'websiteWidgetID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'invoiceID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'fraudLevelAction' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'fraudLevelActionStatus' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'shoppingSessionFingerprint' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'shoppingSessionID' => TRANS_SHOPPING_SESSION_ID,
		'clientID' => TRANS_CLIENT_ID,
		'clientContactID' => TRANS_CLIENT_CONTACT_ID,
		'shoppingSessionTimestamp' => TRANS_SHOPPING_SESSION_TIMESTAMP,
		'shoppingSessionIP' => TRANS_SHOPPING_SESSION_IP,
		'shoppingSessionURL' => TRANS_SHOPPING_SESSION_URL,
		'orderFormID' => TRANS_ORDER_FORM_ID,
		'widgetTemplate' => TRANS_WEBSITE_WIDGET_TPL,
		'websiteWidgetID' => TRANS_WEBSITE_WIDGET_ID,
		'invoiceID' => TRANS_INVOICE_ID,
		'fraudLevelAction' => TRANS_FRAUD_LEVEL_ACTION,
		'fraudLevelActionStatus' => TRANS_FRAUD_LEVEL_ACTION_STATUS,
		'shoppingSessionFingerprint' => TRANS_SHOPPING_SESSION_FINGERPRINT,
		'billingAccountID' => TRANS_BILLING_ACCOUNT_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_SHOPPINGSESSIONS",
		"childName" => "TRANS_SHOPPINGSESSIONS",
		"sideNavMajor" => "shoppingSessions",
		"sideNavMinor" => "shoppingSessions",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_SHOPPINGSESSION",
			"show" => "TRANS_SHOW_SHOPPINGSESSIONS",
			"add" => "TRANS_ADD_SHOPPINGSESSION",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'clientID' => 'clients',
			'clientContactID' => 'clientContacts',
			'orderFormID' => 'orderForms',
			'invoiceID' => 'invoices',
			'billingAccountID' => 'clientBillingAccounts',
		),
		"revContext" => array(
			'shoppingCoupons' => 'shoppingSessionID',
			'shoppingItems' => 'shoppingSessionID',
		),
	),
);