<?php
require_once dirname(__FILE__)."/../../../../../../lib-tk/shield.php";
require_once mb_path("/lib-tk/mbapimap.php");

$CONF["sources"]["transactionLogs"] = baseMap("transaction_log", null, "transactionLogs", "transactionLog") + array(
	"columns" => array(
		'transactionID' => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_DISPLAYABLE,
		'authReturn' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionPaymentMethod' => COLUMN_INT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionNotes' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionDateCreated' => COLUMN_DATE|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'authCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'avsCode' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionAmount' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'transactionAmountRefunded' => COLUMN_AMOUNT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'currencyID' => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'paymentGatewayID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
		'billingAccountID' => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_EDITABLE|COLUMN_LISTABLE|COLUMN_IS_QUICK_EDITABLE,
	),
	"columnLabels" => array(
		'transactionID' => TRANS_TRANSACTION_ID,
		'authReturn' => TRANS_AUTH_RETURN,
		'transactionPaymentMethod' => TRANS_TRANSACTION_PAYMENT_METHOD,
		'transactionCode' => TRANS_TRANSACTION_CODE,
		'transactionNotes' => TRANS_TRANSACTION_NOTES,
		'transactionDateCreated' => TRANS_TRANSACTION_DATE_CREATED,
		'authCode' => TRANS_AUTH_CODE,
		'avsCode' => TRANS_AVS_CODE,
		'transactionAmount' => TRANS_TRANSACTION_AMOUNT,
		'transactionAmountRefunded' => TRANS_TRANSACTION_AMOUNT_REFUNDED,
		'currencyID' => TRANS_CURRENCY_ID,
		'paymentGatewayID' => TRANS_PAYMENT_GATEWAY_ID,
		'billingAccountID' => TRANS_BILLING_ACCOUNT_ID,
	),
	"smartyInfo" => array(
		"parentName" => "TRANS_MANAGE_TRANSACTIONLOGS",
		"childName" => "TRANS_TRANSACTIONLOGS",
		"sideNavMajor" => "transactionLogs",
		"sideNavMinor" => "transactionLogs",
		"grandchildrenLabels" => array(
			"edit" => "TRANS_EDIT_TRANSACTIONLOG",
			"show" => "TRANS_SHOW_TRANSACTIONLOGS",
			"add" => "TRANS_ADD_TRANSACTIONLOG",
		)
	),
	"display" => array(
		"showTemplate" => "1",
		"removeTemplate" => "1",
		"editTemplate" => "1",
		"addTemplate" => "1",
		"showAddButton" => 1,
		"context" => array(
			'billingAccountID' => 'clientBillingAccounts',
		),
		"revContext" => array(
			'accountingReceiptsJournals' => 'transactionID',
			'callbackLogs' => 'transactionID',
			'invoiceTransactionRels' => 'transactionID',
			'transactionSuccessRels' => 'transactionID',
		),
	),
);