<?php
require_once(dirname(__FILE__)."/../../../../../lib-tk/shield.php");
require_once("lib-tk/mbapimap.php");

$CONF['sources']['packages'] = array(
	"names" => array(
		"singular" => "package",
		"plural" => "packages",
		"file" => "packages",
	),
	"request" => array(
		'command' => "GetPackages",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("packages", "package"),
	),
	"insert" => array(
		"command" => "SetPackages",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetPackages",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"delete" => array(
		"command" => "SetPackages",
		"subCommand" => "delete",
		"params" => array(), //new Params(new Param("attributeMapID")),
	),
	"table" => "packages",
	"columns" => array(
		"packageID" => COLUMN_PRIMARY_KEY|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"parentPackageID" => COLUMN_ID|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"clientID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"clientContactID" => COLUMN_INT,
		"productID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageVariantID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"packageGroupID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"taxZoneGroupID" => COLUMN_ID|COLUMN_EDITABLE,
		"cycleDiscountGroupID" => COLUMN_ID|COLUMN_EDITABLE,
		"packageName" => COLUMN_PRIMARY_NAME|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageQuantity" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageProratable" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDiscountable" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateCreated" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateBeginRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateLastRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateNextRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateStopRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDateCancelled" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packagePendingCancellation" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageActive" => COLUMN_ACTIVE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageStatus" => COLUMN_STATUS|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageComments" => COLUMN_TEXT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageType" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageOriginalPrice" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packagePrice" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageDiscount" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageSetup" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageCostAmount" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageCostCurrency" => COLUMN_STRING|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageSetupCostAmount" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageSetupCostCurrency" => COLUMN_STRING|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packagePriceLock" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packagePriorID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE|COLUMN_RESTRICT_EDIT,
		"cycleID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"usageDateLastRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"usageDateNextRenewal" => COLUMN_DATE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"usageCycleID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"usageCalculateOnly" => COLUMN_BOOL|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"externalID" => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"externalID1" => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"externalID2" => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"externalID3" => COLUMN_TEXT|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"orderFormID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"couponID" => COLUMN_ID|COLUMN_DISPLAYABLE|COLUMN_LISTABLE,
		"couponNumCycles" => COLUMN_INT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"couponPrice" => COLUMN_AMOUNT|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageCancellationType" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageClientPermissions" => COLUMN_TYPE|COLUMN_EDITABLE|COLUMN_LISTABLE,
		"packageStatusReason" => COLUMN_TEXT|COLUMN_EDITABLE,
		"primaryDomainID" => COLUMN_ID,
		"packageDisableAccountStacking" => COLUMN_BOOL,
		"guid" => COLUMN_TEXT,
		"syncStatus" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncTasks" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"syncError" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncLastTime" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
	),
	"columnLabels" => array(
	),
	"types" => array(
		"packagePendingCancellation" => "pendingcancellation",
		"packageCancellationType" => "pendingcancellation",
		"packageClientPermissions" => "packagemanagement",
		"packageType" => "products",
	),
	"statuses" => array(
		"packageStatus" => "package",
	),
	"relations" => array(
		"domains" => array("package_domain_rel", "domainIDs", "domainID"),
		"invoices" => array("invoice_line_items", "invoiceIDs", "invoiceID"),
	),
	"display" => array(
		"options" => array("cycles"),
		"filterContextValues" => array(
			"clientID",
		),
		"context" => array(
			"packagePriorID" => "packages",
			"clientID" => "clients",
			"cycleID" => "cycles",
			"usageCycleID" => "cycles",
			"cycleDiscountGroupID" => "cycleDiscountGroups",
			"orderFormID" => "orderForms",
			"couponID" => "coupons",
			"primaryDomainID" => "packageDomains",
		),
		"revContext" => array(
			"lineItems" => "packageID",
			"packageAddons" => "packageID",
			"packageAttributes" => "packageID",
			"systemQueue" => "packageID",
			"clientBillingAccountShares" => "packageID",
			"packageVendorRels" => "packageID",
		),
		'showTemplate' => "packages/ShowPackageAddons",
		'showParams' => array(
			'packageAddonActive' => 1,
		),
		'suppressActions' => array('showdetails', 'remove'),
		'showDetailsTemplate' => "1",
		'removeTemplate' => "1",
		'editTemplate' => "1",
		'addTemplate' => "1",
	),
);
