<?php

require_once(dirname(__FILE__)."/../../../../../lib-tk/shield.php");
require_once("lib-tk/mbapimap.php");

$CONF['sources']['products'] = array(
	"names" => array(
		"singular" => "product",
		"plural" => "products",
		"file" => "products",
	),
	"request" => array(
		'command' => "GetProducts",
		'subCommand' => "",
		'params' => array(),
	),
	"response" => array(
		'path' => array("products", "product"),
	),
	"insert" => array(
		"command" => "SetProducts",
		"subCommand" => "insert",
		"params" => array(), //$allParamsRoot,
	),
	"update" => array(
		"command" => "SetProducts",
		"subCommand" => "update",
		"params" => array(), //$allParamsRoot,
	),
	"clone" => array(
		"command" => "SetProductsGeneric",
		"subCommand" => "clone",
		"params" => $relationalForm = array(
			"serverGroups" => array(),
			"productGroups" => array(),
			"coupons" => array(),
			"productAttributes" => array(),
			"productAddonGroups" => array(),
			"productRelations" => array(),
			"productChildren" => array(),
			"cycles" => array(),
			"productVariants" => array(
				"productVariantPrices" => array(),
				"productLedgerEntries" => array(
					"cycles" => array(),
					"productLedgerCurrencies" => array(),
				),
			),
			"productUsagePrices" => array(),
			"orderFormItems" => array(),
			"websiteWidgets" => array(),
		),
	),
	"delete" => array(
		"command" => "SetProducts",
		"subCommand" => "delete",
		"params" => $relationalForm, //new Params(new Param("productID")),
	),
	"table" => "products",
	"columns" => array(
		"productID" => COLUMN_PRIMARY_KEY|COLUMN_RESTRICT_EDIT|COLUMN_RESTRICT_REMOVE,
		"productType" => COLUMN_TYPE|COLUMN_RESTRICT_MODIFY,
		"productVariableID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productIsLockable" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productIsAddon" => COLUMN_INT,
		"productInvoiceSeparately" => COLUMN_BOOL,
		"productAddonGroupID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productName" => COLUMN_PRIMARY_NAME|COLUMN_RESTRICT_MODIFY,
		"productAddonAttributeName" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"productComments" => COLUMN_SEARCHABLE_STRING|COLUMN_RESTRICT_MODIFY,
		"productStopNumCycles" => COLUMN_NULL|COLUMN_RESTRICT_MODIFY,
		"productActive" => COLUMN_ACTIVE|COLUMN_RESTRICT_MODIFY,
		"productProratable" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productDiscountable" => COLUMN_BOOL|COLUMN_RESTRICT_MODIFY,
		"productDateCreated" => COLUMN_DATE|COLUMN_RESTRICT_MODIFY,
		"productDomainRequired" => COLUMN_STATUS|COLUMN_RESTRICT_MODIFY,
		"productAddonRequired" => COLUMN_STATUS|COLUMN_RESTRICT_MODIFY,
		"productIntroCycleID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productIntroNumCycles" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"emailTplGroupID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"notifyAdminGroupID" => COLUMN_ID|COLUMN_RESTRICT_MODIFY,
		"productCancellationType" => COLUMN_TYPE|COLUMN_RESTRICT_MODIFY,
		"guid" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncStatus" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncTasks" => COLUMN_INT|COLUMN_RESTRICT_MODIFY,
		"syncError" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
		"syncLastTime" => COLUMN_TEXT|COLUMN_RESTRICT_MODIFY,
	),
	"types" => array(
		"productType" => "products",
		"productCancellationType" => "cancellation",
	),
	"statuses" => array(
		"productDomainRequired" => "productdependencyrules",
		"productAddonRequired" => "productdependencyrules",
	),
	"relations" => array(
		"serverGroups" => array("product_server_group_ghost_rel", "serverGroupIDs", "serverGroupID"),
		"productAddonGroups" => array("product_addon_group_rel", "productAddonGroupIDs", "productAddonGroupID"),
		"coupons" => array("product_coupon_rel", "couponIDs", "couponID"),
		"orderForms" => array("order_form_items", "orderFormIDs", "orderFormID"),
		"websiteWidgets" => array("website_widgets_products_rel", "websiteWidgetIDs", "websiteWidgetID"),
		"productGroups" => array("product_group_rel", "productGroupIDs", "productGroupID"),
		"TLDs" => array("product_tld_ghost_rel", "tldIDs", "tldID"),
		"cycles" => array("product_cycle_ghost_rel", "cycleIDs", "cycleID"),
	),
	"display" => array(
		"context" => array(
			"productVariableID" => "productVariables",
			"productAddonGroupID" => "productAddonGroups",
			"productIntroCycleID" => "cycles",
			//"emailTplGroupID" => "emailTemplateGroups",
			"notifyAdminGroupID" => "adminGroups",
		),
		"revContext" => array(
			"packages" => "productID",
			"productRelations" => array("subjectProductID", "relatedProductID"),
			"productChildren" => array("productID", "childProductID"),
			"productVariants" => "productID",
			"orderFormItems" => "productID",
			"productAttributes" => "productID",
			"productUsagePrices" => "productID",
			"productVendorRels" => "productID",
		),
		'showDetailsTemplate' => "products/ShowProductDetails",
		'showTemplate' => "products/ShowProducts",
		'showParams' => array(
			"getNonAddons" => 1
		),
	),
);
