<?php

require_once dirname(__FILE__)."/../../../../../lib-tk/shield.php";
require_once dirname(__FILE__)."/Adapter.php";

class HSPC_PM_BT_Norma19 extends HSPC_PM_Adapter
{
	protected $secureFields = array("cif", "bank_agency_number", "bank_branch_number", "stored_control_dig", "account_number");

	protected $fieldsDescriptor = array(
		"billing_bank_name" => array(
			"holder_name" => array("TRANS_BT_ACCOUNT_NORMA19__HOLDER_NAME", "TRANS_BT_ACCOUNT_NORMA19__HOLDER_NAME_DESC")
		),
		"billing_bank_account_num" => array(
			"cif"					=> array("TRANS_BT_ACCOUNT_NORMA19__CIF", "TRANS_BT_ACCOUNT_NORMA19__CIF_DESC"),
			"bank_agency_number"	=> array("TRANS_BT_ACCOUNT_NORMA19__BANK_AGENCY_NUMBER", "TRANS_BT_ACCOUNT_NORMA19__BANK_AGENCY_NUMBER_DESC"),
			"bank_branch_number"	=> array("TRANS_BT_ACCOUNT_NORMA19__BANK_BRANCH_NUMBER", "TRANS_BT_ACCOUNT_NORMA19__BANK_BRANCH_NUMBER_DESC"),
			"stored_control_dig"	=> array("TRANS_BT_ACCOUNT_NORMA19__STORED_CONTROL_DIG", "TRANS_BT_ACCOUNT_NORMA19__STORED_CONTROL_DIG_DESC"),
			"account_number"		=> array("TRANS_BT_ACCOUNT_NORMA19__ACCOUNT_NUMBER", "TRANS_BT_ACCOUNT_NORMA19__ACCOUNT_NUMBER_DESC")
		)
	);

/*
	public function validate()
	{
		$hspc_data = $this->getHSPCData();
		foreach ($hspc_data["public_data"] as $hspc_field => $hspc_data) {
			if (empty($hspc_data)) {
				return "One of the required data missing: {$hspc_field}";
			}
		}
		foreach ($hspc_data["secure_data"] as $hspc_field => $hspc_data) {
			if (empty($hspc_data)) {
				return "One of the required data missing: {$hspc_field}";
			}
		}
		return "OK";
	}
*/
	protected function getLastFourDigit()
	{
		$hspc_data = $this->getHSPCData();
		$accountNumber = $hspc_data["secure_data"]["account_number"];
		return substr(preg_replace("/[^0-9]+/", "", $accountNumber), -4);
	}
}