<?php
require_once dirname(__FILE__)."/../../../../lib-tk/shield.php";
require_once mb_path("/lib-mbapi/include/modules/gateway/gateway.php");

$className = "BluePay";
$GLOBALS["moduleInfo"][$className] = array
(
    "type" => "gateway",
    "status" => PaymentGateway::STATUS_STABLE,
    "version" => "1.0.2",
    "gatewaytype" => "1",
    "displayName" => "BluePay",
    "author" => "Parallels",
    "capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_ECHECK, GATEWAY_PARTIAL_REFUND),
	"countryCodes" => array("US"),
);

class BluePay extends Gateway
{
    public function getModuleInfo()
	{
        return $GLOBALS["moduleInfo"]["BluePay"];
    }

	public function __construct($input)
	{
		parent::Gateway($input);
		$this->liveURL = "https://secure.bluepay.com/interfaces/a.net";
		$this->testURL = "https://secure.bluepay.com/interfaces/a.net";
	}

    public function addDefaultConfigParams()
	{
        static $defaultConfigParams = array(
            array(NULL, NULL, "Account_ID", "", "", "TRANS_BLUEPAY_ACCOUNTID", "TRANS_BLUEPAY_ACCOUNTID_DESC", "t", 1, 1, 0, NULL),
            array(NULL, NULL, "Secret_Key", "", "", "TRANS_BLUEPAY_SECRETKEY", "TRANS_BLUEPAY_SECRETKEY_DESC", "t", 1, 2, 0, NULL),
            array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 3, 0, NULL),
            array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 4, 0, NULL),
            array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "a", 0, 5, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 12, 0, NULL),
            array(NULL, NULL, "card_accept_5", "1", "", "TRANS_ACCEPT_ENROUTE", "TRANS_ACCEPT_ENROUTE_DESC", "b", 1, 13, 0, NULL),
            array(NULL, NULL, "card_accept_6", "1", "", "TRANS_ACCEPT_DINERS", "TRANS_ACCEPT_DINERS_DESC", "b", 1, 14, 0, NULL),
            array(NULL, NULL, "card_accept_7", "1", "", "TRANS_ACCEPT_SOLO", "TRANS_ACCEPT_SOLO_DESC", "b", 1, 15, 0, NULL),
            array(NULL, NULL, "card_accept_8", "1", "", "TRANS_ACCEPT_MAESTRO", "TRANS_ACCEPT_MAESTRO_DESC", "b", 1, 16, 0, NULL),
            array(NULL, NULL, "card_accept_9", "1", "", "TRANS_ACCEPT_DELTA", "TRANS_ACCEPT_DELTA_DESC", "b", 1, 17, 0, NULL),
            array(NULL, NULL, "card_accept_10", "1", "", "TRANS_ACCEPT_BANKCARD", "TRANS_ACCEPT_BANKCARD_DESC", "b", 1, 18, 0, NULL),
            array(NULL, NULL, "card_accept_11", "1", "", "TRANS_ACCEPT_ELECTRON", "TRANS_ACCEPT_ELECTRON_DESC", "b", 1, 19, 0, NULL),
            array(NULL, NULL, "accept_echeck", "1", "", "TRANS_ACCEPT_ECHECK", "TRANS_ACCEPT_ECHECK_DESC", "b", 1, 20, 0, NULL),
		);
        return $defaultConfigParams;
    }

	public function execute()
	{
		parent::execute();
		$overrides = array();
		$overrides["x_Password"] = $this->config["Secret_Key"];
		$overrides["x_Login"] = $this->config["Account_ID"];
		$this->runAuthNETProtocol($overrides);
	}
}
