<?php

require_once("lib-mbapi/include/modules/gateway/gateway.php");

$className = "CyoGate";
$GLOBALS["moduleInfo"][$className] = array(
	"type" => "gateway",
	"status" => PaymentGateway::STATUS_TESTING,
	"version" => "1.0.0",
	"gatewaytype" => "1",
	"displayName" => "CyoGate",
	"author" => "CyoGate",
	"capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_PARTIAL_REFUND, GATEWAY_VOID, GATEWAY_IPV6_COMPLIANCE),
	"countryCodes" => array("US"),
);

class CyoGate extends Gateway
{
	public function getModuleInfo()
	{
		return $GLOBALS["moduleInfo"]["CyoGate"];
	}

	public function __construct($params)
	{
	 	parent::Gateway($params);
		$this->liveURL = "https://secure.CyoGate.net/gateway/transact.dll";
		$this->testURL = "https://test.CyoGate.net/gateway/transact.dll";
	}

	public function addDefaultConfigParams()
	{
		static $defaultConfigParams = array(
			array(NULL, NULL, "Login_ID", "testdrive", "", "TRANS_CYOGATE_LOGINID", "TRANS_CYOGATE_LOGINID_DESC", "t", 1, 1, 0, null),
			array(NULL, NULL, "Password", "testdrive", "", "TRANS_CYOGATE_PASSWORD", "TRANS_CYOGATE_PASSWORD_DESC", "p", 1, 2, 0, null),
			array(NULL, NULL, "Version", "3.1", "", "TRANS_CYOGATE_VERSION","TRANS_CYOGATE_VERSION_DESC", "t", 1, 3, 0, null),
			array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "t", 0, 4, 0, null),
			array(NULL, NULL, "Generic_Emails", "0", "", "TRANS_GATEWAY_GEN_EMAIL","TRANS_GATEWAY_GEN_EMAIL_DESC", "b", 0, 5, 0, NULL),
			array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 6, 0, NULL),
            array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 7, 0, NULL),
            array(NULL, NULL, "Gateway_URL", "1", "", "TRANS_GATEWAY_URL", "TRANS_GATEWAY_URL_DESC", "b", 1, 7, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 12, 0, NULL),
            array(NULL, NULL, 'card_accept_6', '1', '', 'TRANS_ACCEPT_DINERS', 'TRANS_ACCEPT_DINERS_DESC', 'b', 1, 13, 0, NULL),
            array(NULL, NULL, "accept_echeck", "1", "", "TRANS_ACCEPT_ECHECK", "TRANS_ACCEPT_ECHECK_DESC", "b", 1, 13, 0, NULL),
            );
		return $defaultConfigParams;
	}

	public function execute()
	{
		$this->simulateRefundsForTestURL = 1;
		return $this->runAuthNETProtocol();
	}
}
