<?php

require_once("lib-mbapi/include/modules/gateway/gateway.php");

$className = "eProcessingNetwork";
$GLOBALS["moduleInfo"][$className] = array(
	"type" => "gateway",
	"status" => PaymentGateway::STATUS_TESTING,
	"version" => "1.0.0",
	"gatewaytype" => "1",
	"displayName" => "eProcessingNetwork",
	"author" => "Parallels",
	"capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_IPV6_COMPLIANCE),
	"countryCodes" => array("US"),
);

class eProcessingNetwork extends Gateway
{
    public function getModuleInfo()
	{
        return $GLOBALS["moduleInfo"]["eProcessingNetwork"];
    }

	public function __construct($params)
	{
	 	parent::Gateway($params);
		$this->liveURL = "https://www.eprocessingnetwork.com/cgi-bin/an/order.pl";
		$this->testURL = "https://www.eprocessingnetwork.com/cgi-bin/an/order.pl";
	}

	public function addDefaultConfigParams()
	{
		static $defaultConfigParams = array(
			array(NULL, NULL, "Login_ID", "testdrive", "", "TRANS_EPN_LOGINID", "TRANS_EPN_LOGINID_DESC", "t", 1, 1, 0, NULL),
			array(NULL, NULL, "Password", "testdrive", "", "TRANS_EPN_PASSWORD", "TRANS_EPN_PASSWORD_DESC", "t", 1, 2, 0, NULL),
			array(NULL, NULL, "Version", "3.1", "", "TRANS_EPN_VERSION","TRANS_EPN_VERSION_DESC", "t", 1, 3, 0, NULL),
			array(NULL, NULL, "Generic_Emails", "0", "", "TRANS_GATEWAY_GEN_EMAIL","TRANS_GATEWAY_GEN_EMAIL_DESC", "b", 0, 4, 0, NULL),
			array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 5, 0, NULL),
			array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 6, 0, NULL),
			array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "a", 0, 7, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            );
		return $defaultConfigParams;
	}

	public function execute()
	{
		return $this->runAuthNETProtocol();
	}
}
