<?php

require_once("lib-mbapi/include/modules/gateway/gateway.php");

$className = "Quantum";
$GLOBALS["moduleInfo"][$className] = array(
	"type" => "gateway",
	"status" => PaymentGateway::STATUS_STABLE,
	"version" => "1.0.0",
	"gatewaytype" => "1",
	"displayName" => "Quantum",
	"author" => "Quantum Gateway",
	"capabilities" => array(
		GATEWAY_CHARGE,  // comment out any line here if you don't support the option
		GATEWAY_AUTHORIZE,
		GATEWAY_PRIOR_AUTH_CHARGE,
		GATEWAY_REFUND,
		GATEWAY_PARTIAL_REFUND,
		GATEWAY_VOID,
		GATEWAY_IPV6_COMPLIANCE,
	),
	"countryCodes" => array("US"),
);

class Quantum extends Gateway
{
	public function getModuleInfo()
	{
		return $GLOBALS["moduleInfo"]["Quantum"];
	}

	public function __construct($params)
	{
	 	parent::Gateway($params);
		$this->liveURL = "https://secure.quantumgateway.com/cgi/mbT.php";
		$this->testURL = "https://secure.quantumgateway.com/cgi/mbT.php";
	}

	public function addDefaultConfigParams()
	{
		static $defaultConfigParams = array(
			array(NULL, NULL, "Login_ID", "testdrive", "", "TRANS_QUANTUM_LOGINID", "TRANS_QUANTUM_LOGINID_DESC", "t", 1, 1, 0, NULL),
			array(NULL, NULL, "Password", "testdrive", "", "TRANS_QUANTUM_PASSWORD", "TRANS_QUANTUM_PASSWORD_DESC", "p", 1, 2, 0, NULL),
			array(NULL, NULL, "Version", "3.1", "", "TRANS_QUANTUM_VERSION","TRANS_QUANTUM_VERSION_DESC", "t", 1, 3, 0, NULL),
			array(NULL, NULL, "Invoice_Description", "", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "t", 0, 4, 0, NULL),
			array(NULL, NULL, "Generic_Emails", "0", "", "TRANS_GATEWAY_GEN_EMAIL","TRANS_GATEWAY_GEN_EMAIL_DESC", "b", 0, 5, 0, NULL),
			array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 6, 0, NULL),
            array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 7, 0, NULL),
            array(NULL, NULL, "Gateway_URL", "1", "", "TRANS_GATEWAY_URL", "TRANS_GATEWAY_URL_DESC", "r", 1, 7, 0, array
                    (
                        array(NULL, NULL, "0", "TRANS_LIVE_URL", 0),
                        array(NULL, NULL, "1", "TRANS_TESTING_URL", 1)
                    )),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 8, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 9, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 12, 0, NULL),
            // array(NULL, NULL, "accept_echeck", "1", "", "TRANS_ACCEPT_ECHECK", "TRANS_ACCEPT_ECHECK_DESC", "b", 1, 13, 0, NULL),
            );
		return $defaultConfigParams;
	}

	public function execute()
	{
		$this->simulateRefundsForTestURL = 1;
		return $this->runAuthNETProtocol();
	}
}

