<?php

require_once("lib-mbapi/include/modules/gateway/gateway.php");
require_once("lib-tk/functions.php");
require_once("lib-tk/include/locale/currencycodes.php");

$className = "VelocityPay";
$GLOBALS["moduleInfo"][$className] = array(
    "type" => "gateway",
    "status" => PaymentGateway::STATUS_TESTING,
    "version" => "1.0.1",
    "gatewaytype" => "1",
    "displayName" => "Velocity Pay",
    "author" => "Parallels",
    //"capabilities" => array(GATEWAY_CHARGE),
    "capabilities" => array(GATEWAY_CHARGE, GATEWAY_AUTHORIZE, GATEWAY_PRIOR_AUTH_CHARGE, GATEWAY_REFUND, GATEWAY_VOID, GATEWAY_PARTIAL_REFUND, GATEWAY_IPV6_COMPLIANCE),
    "countryCodes" => array("GB"),
);

$CONF["VelocityPayMap"] = array();

/*******************
 * REQUEST CLASSES *
 *******************/

/*

$CONF["VelocityPayMap"]["VPEntries"] = array(
	"CARD",
	"CHIP",
	"SWIPED",
	"KEYED",
	"CNP",
	"CA",
);
defineOptions("VP_ENTRY", $VPEntries);

$CONF["VelocityPayMap"]["VPTransactions"] = array(
	"SALE",
	"SALE_CASHBACK",
	"ECOMMERCE",
);
defineOptions("VP_TRANSACTION", $VPTransactions);

$CONF["VelocityPayMap"]["VPMeta"] = array(
	"REFUND",
	"REVERSAL",
	"PAYMENT_ONLY",
);
defineFlags("VP_META", $VPMeta);

defineFlags("VP_MESSAGE", array_merge($VPEntries, $VPTransactions, $VPMeta));

$CONF["VelocityPayMap"]["VPEntryTypes"] = mapConstants("VP_ENTRY", "VP_MESSAGE", $CONF["VelocityPayMap"]["VPEntries"]);
$CONF["VelocityPayMap"]["VPTransactionTypes"] = mapConstants("VP_TRANSACTION", "VP_MESSAGE", $CONF["VelocityPayMap"]["VPTransactions"]);

$CONF["VelocityPayMap"]["VPMessageTypes"] = array(
	"SALE_CARD" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CARD,
	"SALE_CHIP" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CHIP,
	"SALE_SWIPED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_SWIPED,
	"SALE_KEYED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_KEYED,
	"SALE_CNP" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CNP,
	"SALE_CA" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CA,
	"SALE_CASHBACK_CARD" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CARD|VP_MESSAGE_CASHBACK,
	"SALE_CASHBACK_CHIP" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CHIP|VP_MESSAGE_CASHBACK,
	"SALE_CASHBACK_SWIPED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_SWIPED|VP_MESSAGE_CASHBACK,
	"SALE_CASHBACK_KEYED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_KEYED|VP_MESSAGE_CASHBACK,
	"ESALE_CARD" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CARD|VP_MESSAGE_ECOMMERCE,
	"ESALE_CHIP" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_CHIP|VP_MESSAGE_ECOMMERCE,
	"ESALE_SWIPED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_SWIPED|VP_MESSAGE_ECOMMERCE,
	"ESALE_KEYED" => VP_MESSAGE_PAYMENT_ONLY|VP_MESSAGE_SALE|VP_MESSAGE_KEYED|VP_MESSAGE_ECOMMERCE,
	"REFUND_CARD" => VP_MESSAGE_REFUND|VP_MESSAGE_CARD,
	"REFUND_CHIP" => VP_MESSAGE_REFUND|VP_MESSAGE_CHIP,
	"REFUND_SWIPED" => VP_MESSAGE_REFUND|VP_MESSAGE_SWIPED,
	"REFUND_KEYED" => VP_MESSAGE_REFUND|VP_MESSAGE_KEYED,
	"REFUND_CNP" => VP_MESSAGE_REFUND|VP_MESSAGE_CNP,
	"EREFUND_KEYED" => VP_MESSAGE_REFUND|VP_MESSAGE_ECOMMERCE|VP_MESSAGE_KEYED,
	"EREFUND_CHIP" => VP_MESSAGE_REFUND|VP_MESSAGE_ECOMMERCE|VP_MESSAGE_CHIP,
	"EREFUND_SWIPED" => VP_MESSAGE_REFUND|VP_MESSAGE_ECOMMERCE|VP_MESSAGE_SWIPED,
	"REVERSAL_CARD" => VP_MESSAGE_REVERSAL|VP_MESSAGE_CARD,
	"REVERSAL_CHIP" => VP_MESSAGE_REVERSAL|VP_MESSAGE_CHIP,
	"REVERSAL_SWIPED" => VP_MESSAGE_REVERSAL|VP_MESSAGE_SWIPED,
	"REVERSAL_KEYED" => VP_MESSAGE_REVERSAL|VP_MESSAGE_KEYED,
	"REFUND_REVERSAL_CHIP" => VP_MESSAGE_REVERSAL|VP_MESSAGE_CARD|VP_MESSAGE_REFUND,
	"REFUND_REVERSAL_SWIPED" => VP_MESSAGE_REVERSAL|VP_MESSAGE_SWIPED|VP_MESSAGE_REFUND,
	"REFUND_REVERSAL_KEYED" => VP_MESSAGE_REVERSAL|VP_MESSAGE_KEYED|VP_MESSAGE_REFUND,
);

class VPMessageType {
	public $paymentOnly;

	function VPMessageType() {
		global $CONF;

	}
}

global $VPEntries, $VPTransactions, $VPMeta, $VPEntryTypes, $VPTransactionTypes, $VPMessageTypes;

*/

/**
 * This can be thought of as a member class of VelocityPay, hence why VelocityPay is passed in.
 */
class VPGenericTransactionRequest extends TransactionRequest
{
	/**
	 * Curl  for the request call
	 */
	public $call;
	/**
	 * TransactionResponse  for the gateway response
	 */
	public $response;

	/**
	 * string  class name of the response
	 */
	public $responseClass;

	/**
	 * string  account ID
	 */
	public $account;

	/**
	 * string  account password
	 */
	public $password;

	/**
	 * int  amount of transaction in minor currency units
	 */
	public $amount;

	/**
	 * int  ISO 4217 country code *numeric*
	 */
	public $country;

	/**
	 * int  ISO 4217 currency code *numeric*
	 */
	public $currency;

	/**
	 * int  unique transaction ID generated by us
	 */
	public $id;

	/**
	 * string  order description
	 */
	public $description;

	/**
	 * string  callback URL
	 */
	public $callback;

	function VPGenericTransactionRequest(&$that) {
		global $CONF;

		$this->TransactionRequest($that);

		$this->responseClass = "VPTransactionResponse";

		$this->account = $this->config["Login_ID"];
		$this->password = $this->config["Password"];
		$this->callback = $this->config["callback"];
		$this->description = str_replace("###", $that->params["invoiceID"][0], $this->config["Invoice_Description"]);

		$this->id = sha1(
			  (string) mt_rand(0, 200000000)
			. (string) microtime()
			. (string) mt_rand(0, 200000000)
		);
		$this->amount = (string) (int) ($that->params["paymentAmount"][0] * pow(10, (int) $this->config["minorCurrencyDecimals"]));

		$currency = $that->params["currency"][0];
		$this->currency = $CONF["iso4217"][$currency];

		$h = new QueryMaster("countries.countries_iso_num");
		$h->addAndClause("countries_id", "=", $that->params["countriesID"][0], "i");
		if(!$h->execute()) return false;
		$this->country = $h->getOne();

		return true;
	}

	function initCall() {
		parent::initCall();
		$this->call->setConfigIdentity("Gateway_VelocityPay");
		$this->call->setURL($this->that->liveURL);
		$this->call->addField("VPUserAgent", $this->agent);
	}

	function buildCall() {
		$this->call->addField("VPMerchantID", $this->account);
		$this->call->addField("VPMerchantPassword", $this->password);
		$this->call->addField("VPAmount", $this->amount);
		$this->call->addField("VPCountryCode", $this->country);
		$this->call->addField("VPCurrencyCode", $this->currency);
		$this->call->addField("VPTransactionUnique", $this->id);
		$this->call->addField("VPOrderDesc", $this->description);
		$this->call->addField("VPCallBack", $this->callback);
	}
}

class VPTransactionRequest extends VPGenericTransactionRequest
{
	public $messageType;
	public $authCode;
	public $dupDelay;
	public $ca;

	function VPTransactionRequest(&$that) {
		if(!parent::VPGenericTransactionRequest($that)) return false;

		$this->ca = $this->config["Continuous_Authority"];

		switch($this->mode) {
			case "charge":
				$this->messageType = $this->ca ? "SALE_CA" : "ESALE_KEYED";
				break;
			case "auth":
				$this->messageType = "ESALE_KEYED";
				break;
			case "finalize":
				$this->messageType = "PAYMENT_ONLY_ESALE_KEYED";
				break;
			case "refund":
				$this->messageType = "EREFUND_KEYED";
				break;
			default:
				$this->that->addError(TRANS_MBAPIERROR, "No sub-command was given.");
				return false;
				break;
		}

		$this->authCode = !empty($this->that->params["referralAuth"][0]) ? $this->that->params["referralAuth"][0] : NULL;

		$this->dupDelay = 300;

		return true;
	}

	function buildCall() {
		parent::buildCall();

		$this->call->addField("VPMessageType", $this->messageType);

		if($this->authCode)
			$this->call->addField("VPAuthorisationCode", $this->authCode);

		$this->call->addField("VPDuplicateDelay", $this->dupDelay);

		if(isset($this->that->params["product"][0])) {
			$productParams = $this->that->params["product"];
			$products = array();
			foreach($productParams as $productParam) {
				if(isset($productParam["description"][0]) && isset($productParam["quantity"][0]) && isset($productParam["total"][0])) {
					$products[] = array(
						"description" => $productParam["description"][0],
						"quantity" => $productParam["quantity"][0],
						"total" => $productParam["total"][0],
					);
				}
			}

			$lines = array();
			$i = 0;
			foreach($products as $product) {
				$lines[] = $product["description"] . " x " . $product["quantity"] . " = " . $product["total"];
				++$i;
				if($i <= 6) {
					$this->call->addField("VPAEIT" . $i . "Quantity", (string) (int) $product["quantity"]);
					$this->call->addField("VPAEIT" . $i . "Description", substr($product["description"], 0, 15));
					$this->call->addField("VPAEIT" . $i . "GrossValue", (string) (int) ($product["total"] * pow(10, (int) $this->config["minorCurrencyDecimals"] * (int) $product["quantity"])));
				}
			}
			if($lines) {
				$message = implode("\n", $lines);
				$this->call->addField("VPProducts", substr($message, 0, 512));
			}
		}

		// for requesting additional information in the response
		$this->call->addField("VPAVSCV2Check", "YES");
		$this->call->addField("VPEchoAVSCV2ResponseCode", "YES");
		$this->call->addField("VPEchoAmount", "YES");
		$this->call->addField("VPReturnAVSCV2Message", "YES");
		$this->call->addField("VPEchoCardType", "YES");
		$this->call->addField("VPEchoReferralTelephoneNumber", "YES");
	}
}

class VPKeyedCardTransactionRequest extends VPTransactionRequest
{
	public $cardName;
	public $cardNum;
	public $terminal;
	public $expiryMonth;
	public $expiryYear;
	public $issueNum;
	public $startMonth;
	public $startYear;

	// cv2 verification
	public $cv2;

	// address verification
	public $houseNum;
	public $street;
	public $city;
	public $state;
	public $postcode;

	// client info
	public $email;
	public $phone;


	public $crossReference;

	function VPKeyedCardTransactionRequest(&$that) {
		if(!parent::VPTransactionRequest($that)) return false;

		switch($this->mode) {
			case "charge":
				if(
						$this->ca
					&&	!empty($that->params["velocitypayCrossReference"][0]) // cross ref for billing account
					&&	$this->amount <= $that->params["velocitypayAuthAmount"][0] // re-authorised amount
				)
					$this->crossReference = $that->params["velocitypayCrossReference"][0];
				break;
			case "finalize":
			case "refund":
				if(!empty($that->params["transactionCode"][0]))
					$this->crossReference = $that->params["transactionCode"][0];
				break;
		}

		if(empty($this->crossReference)) {
			$this->cardName = $that->params["billingCardNameOnCard"][0];
			$this->cardNum = $that->params["billingCardNum"][0];
			$this->terminal = $this->config["Testing"] ? "32" : NULL;
			$this->expiryMonth = str_pad($that->params["billingCardExpMonth"][0], 2, "0", STR_PAD_LEFT);
			$this->expiryYear = $that->params["billingCardExpYear"][0];
			$this->issueNum = !empty($that->params["billingCardIssueNum"][0]) ? $that->params["billingCardIssueNum"][0] : NULL;

			if(!empty($that->params["billingCardStartDate"][0])) {
				list($startMonth, $startYear) = explode("/", $that->params["billingCardStartDate"][0]);
				$this->startMonth = (int) $startMonth;
				$this->startYear = (int) $startYear;
			} else {
				$this->startMonth = NULL;
				$this->startYear = NULL;
			}

			if(!empty($that->params['cardCVV2'][0]))
				$this->cv2 = $that->params['cardCVV2'][0];

			$address1 = $that->params['contactAddress1'][0];
			$address2 = $that->params['contactAddress2'][0];

			/**
			 * words in address1 are assumed to be the house number until a number is reached
			 */
			$isNum = true;
			$houseNumWords = $streetWords = array();
			$address1words = explode(" ", trim($address1));
			foreach($address1words as $word) {
				if($isNum) {
					$houseNumWords[] = $word;
				} else {
					$streetWords[] = $word;
				}
				if(is_numeric($word)) $isNum = false;
			}
			$streetWords[] = $address2;

			$this->houseNum = implode(" ", $houseNumWords);
			$this->street = implode(" ", $streetWords);

			$this->city = $that->params['contactCity'][0];
			$this->state = $that->params['contactState'][0];
			$this->postcode = $that->params['contactZip'][0];

			$this->email = $that->params['contactEmail'][0];
			$this->phone = $that->params['contactPhone1'][0];
		}


		return true;
	}

	function buildCall() {
		parent::buildCall();

		switch($this->mode) {
			case "charge":
			case "refund":
				break;
			case "auth":
				$this->call->addField("VPDispatch", "LATER");
				break;
			case "finalize":
				$this->call->addField("VPDispatch", "NOW");
				break;
		}

		if(!empty($this->crossReference)) {
			$this->call->addField("VPCrossReference", $this->crossReference);
		} else {
			// card details
			$this->call->addField("VPCardName", $this->cardName);
			$this->call->addField("VPCardNumber", $this->cardNum);
			$this->call->addField("VPExpiryDateMM", $this->expiryMonth);
			$this->call->addField("VPExpiryDateYYYY", $this->expiryYear);
			$this->call->addField("VPExpiryDateYY", substr($this->expiryYear, -2));

			if($this->issueNum)
				$this->call->addField("VPIssueNumber", $this->issueNum);
			if($this->startMonth) {
				$this->call->addField("VPStartDateMM", $this->startMonth);
				$this->call->addField("VPStartDateYY", $this->startYear);
			}

			// Cv2 and AVS
			if(!empty($this->cv2))
				$this->call->addField("VPCV2", $this->cv2);

			$this->call->addField("VPBillingHouseNumber", $this->houseNum);
			$this->call->addField("VPBillingStreet", $this->street);
			$this->call->addField("VPBillingCity", $this->city);
			$this->call->addField("VPBillingState", $this->state);
			$this->call->addField("VPBillingPostCode", $this->postcode);
			$this->call->addField("VPBillingEmail", $this->email);
			$this->call->addField("VPBillingPhoneNumber", $this->phone);
		}
	}
}

/********************
 * RESPONSE CLASSES *
 ********************/

$CONF["VelocityPayMap"]["VPResponses"] = array(
	"SUCCESS",
	"REFERRED",
	"KEEP_DECLINED",
	"DECLINED",
	"ERROR",
	"UNKNOWN",
);
defineOptions("VP_RESPONSE", $CONF["VelocityPayMap"]["VPResponses"]);

$CONF["VelocityPayMap"]["VPResponseCodes"] = array(
	"00" => VP_RESPONSE_SUCCESS,
	"02" => VP_RESPONSE_REFERRED,
	"04" => VP_RESPONSE_KEEP_DECLINED,
	"05" => VP_RESPONSE_DECLINED,
	"30" => VP_RESPONSE_ERROR,
);

$CONF["VelocityPayMap"]["VPtoMBstatus"] = array(
	VP_RESPONSE_SUCCESS => GATEWAY_SUCCESS,
	VP_RESPONSE_REFERRED => GATEWAY_DECLINED,
	VP_RESPONSE_KEEP_DECLINED => GATEWAY_DECLINED,
	VP_RESPONSE_DECLINED => GATEWAY_DECLINED,
	VP_RESPONSE_ERROR => GATEWAY_FAILURE,
);


class VPGenericTransactionResponse extends TransactionResponse
{
	public $response;
	public $values;

	public $status;
	public $gatewayStatus;
	public $message;
	public $crossReference;
	public $referralPhone;

	function VPGenericTransactionResponse(&$that, $response) {
		global $CONF;
		if(!$this->TransactionResponse($that, $response)) return false;

		$this->values = array();
		parse_str($this->response, $this->values);

		$rawStatus = $this->values["VPResponseCode"];
		$this->status = isset($CONF["VelocityPayMap"]["VPResponseCodes"][$rawStatus]) ? $CONF["VelocityPayMap"]["VPResponseCodes"][$rawStatus] : VP_RESPONSE_UNKNOWN;
		$this->gatewayStatus = $CONF["VelocityPayMap"]["VPtoMBstatus"][$this->status];

		$this->message = $this->values["VPMessage"];

		$this->crossReference = $this->values["VPCrossReference"];

		if(!empty($this->values["VPReferralTelephoneNumber"]))
			$this->referralPhone = $this->values["VPReferralTelephoneNumber"];

		return true;
	}

	function getStatus() {
		return $this->status;
	}

	function getGatewayStatus() {
		return $this->gatewayStatus;
	}

	function getMessage() {
		return $this->message;
	}

	function getTransactionID() {
		return $this->crossReference;
	}

	function buildXML() {
		parent::buildXML();
		$this->gatewayResponse["referred"] = $this->getStatus() === VP_RESPONSE_REFERRED ? "1" : "0";
		if(!empty($this->referralPhone))
			$this->gatewayResponse["referralPhone"] = $this->referralPhone;
	}

	function finish() {
		return $this->that->ca ? $this->updateAccount(
			array(
				"velocitypayCrossReference" => $this->getTransactionID(), // cross ref for billing account
				"velocitypayAuthAmount" => $this->getAmount(), // re-authorised amount
			)
		) : true;
	}
}

/*

$CONF["VelocityPayMap"]["VPReturns"] = array(
	"UNCHECKED",
	"MISMATCH",
	"PARTIAL_MATCH",
	"MATCH",
);
defineOptions("VP_RETURN", $CONF["VelocityPayMap"]["VPReturns"]);

$CONF["VelocityPayMap"]["VPConditionals"] = array(
	"CV2",
	"POSTCODE",
	"ADDRESS",
);
defineOptions("VP_CONDITIONAL", $CONF["VelocityPayMap"]["VPConditionals"]);

$CONF["VelocityPayMap"]["VPAuthorisors"] = array(
	"MERCHANT",
	"ACQUIRER_HOST",
	"CARD_SCHEME",
	"ISSUER",
);
defineOptions("VP_AUTHORISORS", $CONF["VelocityPayMap"]["VPAuthorisors"]);

defineFlags("VP_AVSCV2_RESPONSE", $CONF["VelocityPayMap"]["VPReturns"], $CONF["VelocityPayMap"]["VPConditionals"], $CONF["VelocityPayMap"]["VPAuthorisors"]);

$CONF["VelocityPayMap"]["VPReturnTypes"] = mapConstants("VP_AVSCV2_RESPONSE", "VP_RETURN", $CONF["VelocityPayMap"]["VPReturns"]);
$CONF["VelocityPayMap"]["VPConditionalTypes"] = mapConstants("VP_AVSCV2_RESPONSE", "VP_CONDITIONAL", $CONF["VelocityPayMap"]["VPConditionals"]);
$CONF["VelocityPayMap"]["VPAuthorisorTypes"] = mapConstants("VP_AVSCV2_RESPONSE", "VP_AUTHORISORS", $CONF["VelocityPayMap"]["VPAuthorisors"]);

$CONF["VelocityPayMap"]["VPAVSCV2ResponseCodes"] = array(
	array(
		1 => VP_AVSCV2_RESPONSE_UNCHECKED|VP_AVSCV2_RESPONSE_CV2,
		2 => VP_AVSCV2_RESPONSE_MATCH|VP_AVSCV2_RESPONSE_CV2,
		4 => VP_AVSCV2_RESPONSE_MISMATCH|VP_AVSCV2_RESPONSE_CV2,
	),
	array(
		1 => VP_AVSCV2_RESPONSE_UNCHECKED|VP_AVSCV2_RESPONSE_POSTCODE,
		2 => VP_AVSCV2_RESPONSE_MATCH|VP_AVSCV2_RESPONSE_POSTCODE,
		4 => VP_AVSCV2_RESPONSE_MISMATCH|VP_AVSCV2_RESPONSE_POSTCODE,
		8 => VP_AVSCV2_RESPONSE_PARTIAL_MATCH|VP_AVSCV2_RESPONSE_POSTCODE,
	),
	array(
		1 => VP_AVSCV2_RESPONSE_UNCHECKED|VP_AVSCV2_RESPONSE_ADDRESS,
		2 => VP_AVSCV2_RESPONSE_MATCH|VP_AVSCV2_RESPONSE_ADDRESS,
		4 => VP_AVSCV2_RESPONSE_MISMATCH|VP_AVSCV2_RESPONSE_ADDRESS,
		8 => VP_AVSCV2_RESPONSE_PARTIAL_MATCH|VP_AVSCV2_RESPONSE_ADDRESS,
	),
	array(
		1 => VP_AVSCV2_RESPONSE_MERCHANT,
		2 => VP_AVSCV2_RESPONSE_ACQUIRER_HOST,
		4 => VP_AVSCV2_RESPONSE_CARD_SCHEME,
		8 => VP_AVSCV2_RESPONSE_ISSUER,
	),
);


class VPAVSCV2Response {
	public $response;

	public $errors;

	public $cv2;
	public $postcode;
	public $address;
	public $authorisor;

	function VPAVSCV2Response($response) {
		global $CONF;

		$this->response = $response;
		$this->errors = array();

		$responses = array();
		for($i = 0; $i < 4; $i++) {
			$value = (int) $this->response{$i};
			if(isset($CONF["VelocityPayMap"]["VPAVSCV2ResponseCodes"][$i][$value])) {
				$flags = $CONF["VelocityPayMap"]["VPAVSCV2ResponseCodes"][$i][$value];

				$conditionalOption = getOptionFrom($flags, $CONF["VelocityPayMap"]["VPConditionalTypes"]);
				$returnOption = getOptionFrom($flags, $CONF["VelocityPayMap"]["VPReturnTypes"]);
				if($conditionalOption && $conditionalOption != VP_RETURN_MATCH)
					$this->errors[$conditionalOption] = $returnOption;

				$responses[] = $flags;
			}
		}
		list($cv2Response, $postcodeResponse, $addressResponse, $authoriserResponse) = $responses;

		$this->cv2 = getOptionFrom($cv2Response, $CONF["VelocityPayMap"]["VPReturnTypes"]);
		$this->postcode = getOptionFrom($postcodeResponse, $CONF["VelocityPayMap"]["VPReturnTypes"]);
		$this->address = getOptionFrom($addressResponse, $CONF["VelocityPayMap"]["VPReturnTypes"]);
		$this->authorisor = getOptionFrom($authoriserResponse, $CONF["VelocityPayMap"]["VPAuthorisorTypes"]);
	}

	function getErrors() {
		return $this->errors;
	}
}

*/

class VPTransactionResponse extends VPGenericTransactionResponse
{
	public $amount;
	public $AVSCV2;

	function VPTransactionResponse(&$that, $response) {
		if(!parent::VPGenericTransactionResponse($that, $response)) return false;

		if(isset($this->values["VPAmountReceived"])) $this->amount = $this->values["VPAmountReceived"];
		if(isset($this->values["VPAVSCV2ResponseCode"])) $this->AVSCV2 = $this->values["VPAVSCV2ResponseCode"];



		return true;
	}

	function getAmount() {
		return $this->amount;
	}

	/*
	function getVerificationErrors() {
		$r = new VPAVSCV2Response($this->AVSCV2);
		return $r->getErrors();
	}
	*/

	function getAuthorizationCode() {
		return $this->values["VPResponseCode"];
	}

	function getAVSCode() {
		return $this->AVSCV2;
	}
}

/**************
 * MAIN CLASS *
 **************/

class VelocityPay extends Gateway
{
	/**
	 * Returns the module display for the BluePay module. This includes version number and display name.
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the display info for the module.
	 */
    function getModuleInfo() {
        return $GLOBALS["moduleInfo"]["VelocityPay"];
    }

	/**
	 * Execute the command based upon the given information, and return the result.
	 *
	 * @return  The result of the AuthorizeNet gateway command based upon the given information.
	 */
	 function VelocityPay($params){
	 	$this->stringRep = "velocitypay";
	 	parent::Gateway($params);

		$this->version = "3.0.1";
		$this->liveURL = "https://www.velocitypay.co.uk/merchantsecure/velocitypay/VPDirect.cfm";
		$this->testURL = "https://www.velocitypay.co.uk/merchantsecure/velocitypay/VPDirect.cfm";
		$this->requestClass = "VPKeyedCardTransactionRequest";
	}

	/**
	 * Returns the default configuration parameters for the BluePay module. The number of elements in each array must me identical to
	 * the columns in config_params. This array will be looped by SetConfigGroups.
	 *
	 * @return	An array of arrays containing all the parameters the module uses.
	 */
	function addDefaultConfigParams() {
		static $defaultConfigParams = array(
			array(NULL, NULL, "Login_ID", "testdrive", "", "TRANS_VELOCITYPAY_LOGINID", "TRANS_VELOCITYPAY_LOGINID_DESC", "t", 1, 1, 0, NULL),
			array(NULL, NULL, "Password", "testdrive", "", "TRANS_VELOCITYPAY_PASSWORD", "TRANS_VELOCITYPAY_PASSWORD_DESC", "t", 1, 2, 0, NULL),
			array(NULL, NULL, "Invoice_Description", "Invoice ###", "", "TRANS_INVOICE_DESCRIPTION", "TRANS_INVOICE_DESCRIPTION_DESC", "t", 0, 3, 0, NULL),
			array(NULL, NULL, "callback", "disable", "", "TRANS_VELOCITYPAY_CALLBACK_URL", "TRANS_VELOCITYPAY_DUP_CALLBACK_URL_DESC", "t", 1, 4, 0, NULL),
			array(NULL, NULL, "dupDelay", "300", "", "TRANS_VELOCITYPAY_DUP_DELAY", "TRANS_VELOCITYPAY_DUP_DELAY_DESC", "t", 1, 5, 0, NULL),
			array(NULL, NULL, "minorCurrencyDecimals", "2", "", "TRANS_VELOCITYPAY_MINOR_CUR_DEC", "TRANS_VELOCITYPAY_MINOR_CUR_DEC_DESC", "t", 1, 6, 0, NULL),
			array(NULL, NULL, "Continuous_Authority", "0", "", "TRANS_VELOCITYPAY_CONTINUOUS_AUTH","TRANS_VELOCITYPAY_CONTINUOUS_AUTH_DESC", "b", 0, 7, 0, NULL),
			array(NULL, NULL, "Generic_Emails", "0", "", "TRANS_GATEWAY_GEN_EMAIL","TRANS_GATEWAY_GEN_EMAIL_DESC", "b", 0, 8, 0, NULL),
			array(NULL, NULL, "Batch_Recurring", "1", "", "TRANS_BATCH_RECURRING","TRANS_BATCH_RECURRING_DESC", "b", 1, 9, 0, NULL),
            //array(NULL, NULL, "Testing", "1", "", "TRANS_GATEWAY_TESTING", "TRANS_GATEWAY_TESTING_DESC", "b", 1, 10, 0, NULL),
            array(NULL, NULL, "card_accept_0", "1", "", "TRANS_ACCEPT_VISA", "TRANS_ACCEPT_VISA_DESC", "b", 1, 11, 0, NULL),
            array(NULL, NULL, "card_accept_1", "1", "", "TRANS_ACCEPT_MASTERCARD", "TRANS_ACCEPT_MASTERCARD_DESC", "b", 1, 12, 0, NULL),
            array(NULL, NULL, "card_accept_2", "1", "", "TRANS_ACCEPT_AMEX", "TRANS_ACCEPT_AMEX_DESC", "b", 1, 13, 0, NULL),
            array(NULL, NULL, "card_accept_3", "1", "", "TRANS_ACCEPT_DISCOVER", "TRANS_ACCEPT_DISCOVER_DESC", "b", 1, 14, 0, NULL),
            array(NULL, NULL, "card_accept_4", "1", "", "TRANS_ACCEPT_JCB", "TRANS_ACCEPT_JCB_DESC", "b", 1, 15, 0, NULL),
            array(NULL, NULL, "card_accept_6", "1", "", "TRANS_ACCEPT_DINERS", "TRANS_ACCEPT_DINERS_DESC", "b", 1, 16, 0, NULL),
            array(NULL, NULL, "card_accept_7", "1", "", "TRANS_ACCEPT_SOLO", "TRANS_ACCEPT_SOLO_DESC", "b", 1, 17, 0, NULL),
            array(NULL, NULL, "card_accept_8", "1", "", "TRANS_ACCEPT_MAESTRO", "TRANS_ACCEPT_MAESTRO_DESC", "b", 1, 18, 0, NULL),
            array(NULL, NULL, "card_accept_9", "1", "", "TRANS_ACCEPT_DELTA", "TRANS_ACCEPT_DELTA_DESC", "b", 1, 17, 0, NULL),
            array(NULL, NULL, "card_accept_11", "1", "", "TRANS_ACCEPT_ELECTRON", "TRANS_ACCEPT_ELECTRON_DESC", "b", 1, 19, 0, NULL),
            );
		return $defaultConfigParams;
	}
}
