<?php

class RuCenterLoader {
	
	private static $register = null;
	
	public static function load($name) {
		if (self::$register == null) {
			self::_prepareRegister();
		}
		$fileName = $name . ".php";
		if (isset(self::$register[$fileName])) {
			require_once self::$register[$fileName];
		}
	}
	
	private static function _prepareRegister() {
		self::$register = array();
		self::_scanDir(realpath(dirname(__FILE__)));
	}
	
	private static function _scanDir($dir) {
		$items = scandir($dir);
		foreach ($items as $item) {
			if ($item == "." || $item == "..") {
				continue;
			}
			$path = $dir . "/" . $item;
			switch (filetype($path)) {
				case "file":
					self::$register[$item] = $path;
					break;
				case "dir":
					self::_scanDir(realpath($path));
					break;
			}
		}
	}
	
}