<?php

abstract class RuCenterMessage
{

	const CRLF = "\r\n";
	const CR = "\r";
	const LF = "\n";

	private $header;

	private $body;

	public function __construct(RuCenterMessageHeader $header, RuCenterMessageBody $body)
	{
		$this->header = $header;
		$this->body = $body;
	}

	public function getHeader()
	{
		return $this->header;
	}

	public function getBody()
	{
		return $this->body;
	}

	public function __get($name)
	{
		$methodName = "get" . ucfirst($name);
		if (method_exists($this, $methodName)) {
			return $this->$methodName();
		} else {
			return null;
		}
	}

}