<?php

class RuCenterMessageParameter
{

	private $name;

	private $values;

	public function __construct($name)
	{
		$this->name = $name;
		$this->values = array();
		for ($i = 1; $i < func_num_args(); $i++) {
			$this->addValue(func_get_arg($i));
		}
	}

	public function addValue($value)
	{
		$this->values[] = $value;
	}

	public function clean()
	{
		$this->values = array();
	}

	public function getName()
	{
		return $this->name;
	}

	public function getValue($index = 0) {
		if (isset($this->values[$index])) {
			return $this->values[$index];
		} else {
			return null;
		}
	}

	public function setValue($value, $index = 0)
	{
		if (isset($this->values[$index])) {
			$this->values[$index] = $value;
		} else {
			$this->addValue($value);
		}
	}

	public function getValues()
	{
		return $this->values;
	}

	public function getValuesCount()
	{
		return sizeof($this->values);
	}

	public function __get($name)
	{
		$methodName = "get" . ucfirst($name);
		if (method_exists($this, $methodName)) {
			return $this->$methodName();
		} else {
			return null;
		}
	}

	public function __toString()
	{
		return $this->getValue();
	}

}