<?php

//ini_set("display_errors", true);
//ini_set("display_startup_errors", true);
//ini_set('error_reporting', E_ALL);

require_once realpath(dirname(__FILE__) . "/RuCenterLoader.php");

spl_autoload_register(array("RuCenterLoader", "load"));

class RuCenterModule {
	
	const REQUEST_ATTEMPTS_COUNT = 3;
	const REQUEST_URL = "https://www.nic.ru/dns/dealer";
	const UPLOAD_IDENTITY_DOCUMENT_URL = "https://www.nic.ru/dns/dealer/identity";
	const DEFAULT_LANG = "en";
	const LANG_EN = "en";
	const LANG_RU = "ru";
	
	private static $domainsDescriptor = array(
		"ru"		=> array("service" => "domain_ru",			"template" => "client_ru"),
		"su"		=> array("service" => "domain_su",			"template" => "client_ru"),
		"рф"		=> array("service" => "domain_rf",			"template" => "domain_rf"),
		"net"		=> array("service" => "domain_rrp",			"template" => "client_rrp"),
		"com"		=> array("service" => "domain_rrp",			"template" => "client_rrp"),
		"org"		=> array("service" => "domain_rrp",			"template" => "client_rrp"),
		"biz"		=> array("service" => "domain_rrp",			"template" => "client_rrp"),
		"info"		=> array("service" => "domain_rrp",			"template" => "client_rrp"),
		"me"		=> array("service" => "domain_epp_me",		"template" => "client_rrp"),
		"cc"		=> array("service" => "domain_epp_cc",		"template" => "client_rrp"),
		"tv"		=> array("service" => "domain_epp_tv",		"template" => "client_rrp"),
		"tel"		=> array("service" => "domain_epp_tel",		"template" => "client_rrp"),
		"mobi"		=> array("service" => "domain_epp_mobi",	"template" => "client_rrp"),
		"name"		=> array("service" => "domain_epp_name",	"template" => "client_rrp"),
		"travel"	=> array("service" => "domain_epp_travel",	"template" => "client_rrp"),
		"aero"		=> array("service" => "domain_epp_aero",	"template" => "client_rrp"),
		"pro"		=> array("service" => "domain_epp_pro",		"template" => "client_rrp"),
		"ag"		=> array("service" => "domain_epp_ag",		"template" => "client_rrp"),
		"bz"		=> array("service" => "domain_epp_bz",		"template" => "client_rrp"),
		"hn"		=> array("service" => "domain_epp_hn",		"template" => "client_rrp"),
		"lc"		=> array("service" => "domain_epp_lc",		"template" => "client_rrp"),
		"mn"		=> array("service" => "domain_epp_mn",		"template" => "client_rrp"),
		"sc"		=> array("service" => "domain_epp_sc",		"template" => "client_rrp"),
		"vc"		=> array("service" => "domain_epp_vc",		"template" => "client_rrp")
	);
	
	private static $lang = self::LANG_EN;
	
	public static function generateRequestId() {
		return date("YmdHis") . "." . rand(1000, 9999) . "@" . $_SERVER['HTTP_HOST'];
	}
	
	public static function getLang() {
		return self::$lang ? self::$lang : self::DEFAULT_LANG;
	}
	
	public static function setLang($locale) {
		list($lang) = explode("_", $locale);
		switch ($lang) {
			case self::LANG_RU:
				self::$lang = self::LANG_RU;
				break;
			default:
				self::$lang = self::LANG_EN;
		}
	}
	
	public static function getServiceByTLD($tld) {
		$tld = mb_strtolower($tld, "utf8");
		return isset(self::$domainsDescriptor[$tld]) ? self::$domainsDescriptor[$tld]["service"] : false;
	}
	
	public static function getTemplateByTLD($tld) {
		$tld = mb_strtolower($tld, "utf8");
		return isset(self::$domainsDescriptor[$tld]) ? self::$domainsDescriptor[$tld]["template"] : false;
	}
	
}