<?php

class RuCenterResponce extends RuCenterMessage
{

	private $errors = array();

	static public function load($content)
	{
		list($headerContent, $bodyContent) = explode(self::LF . self::LF, str_replace(self::CRLF, self::LF, $content), 2);

		$header = new RuCenterMessageHeader();
		foreach (explode(self::LF, $headerContent) as $line) {
			list($name, $value) = explode(":", $line);
			$name = trim($name);
			$value = trim($value);
			if (!$parameter = $header->getParameter($name)) {
				$parameters = $header->addParameter(new RuCenterMessageParameter($name));
			}
			$parameters->addValue($value);
		}

		$errors =array();
		$body = new RuCenterMessageBody();
		foreach (explode(self::LF . self::LF, $bodyContent) as $sectionContent) {
			$lines = explode(self::LF, trim($sectionContent));
			$firstLine = isset($lines[0]) ? trim($lines[0]) : false;
			if (preg_match("/\[.*\]/", $firstLine)) {
				$sectionName = substr($firstLine, 1, -1);
				if ($sectionName == "errors") {
					for ($i = 1; $i < sizeof($lines); $i++) {
						if (!$error = trim($lines[$i])) {
							continue;
						}
						$errors[] = $error;
					}
				} else {
					$section = new RuCenterMessageSection($sectionName);
					for ($i = 1; $i < sizeof($lines); $i++) {
						list($name, $value) = explode(":", $lines[$i]);
						if (!$name = trim($name)) {
							continue;
						}
						$value = trim($value);
						if (!$parameter = $section->getParameter($name)) {
							$parameter = $section->addParameter(new RuCenterMessageParameter($name));
						}
						$parameter->addValue($value);
					}
					$body->addSection($section);
				}
			} else {
				for ($i = 0; $i < sizeof($lines); $i++) {
					list($name, $value) = explode(":", $lines[$i]);
					if (!$name = trim($name)) {
						continue;
					}
					$value = trim($value);
					if (!$parameter = $body->getParameter($name)) {
						$parameter = $body->addParameter(new RuCenterMessageParameter($name));
					}
					$parameter->addValue($value);
				}
			}
		}

		$responce = new RuCenterResponce($header, $body);
		if ($errors) {
			$responce->setErrors($errors);
		}
		return $responce;
	}

	public function getState()
	{
		if ($this->getHeader()->hasParameter("State")) {
			list($code) = explode(" ", $this->getHeader()->getParameter("State")->getValue(), 2);
			return (int)$code;
		} else {
			return false;
		}
	}
	
	public function getStateMessage()
	{
		if ($this->getHeader()->hasParameter("State")) {
			list($code, $message) = explode(" ", $this->getHeader()->getParameter("State")->getValue(), 2);
			return $message;
		} else {
			return false;
		}
	}

	private function setErrors($errors)
	{
		$this->errors = $errors;
	}

	private function addError($error)
	{
		$this->errors[] = $error;
	}

	public function hasErrors()
	{
		return $this->errors ? true : false;
	}

	public function getErrors()
	{
		return $this->errors;
	}

}