<?php

class RuCenterUploadIdentityDocumentAction extends RuCenterAction {
	
	const FILE_SIZE_LIMIT = 1048576;
	
	protected function execute() {
		$this->setTemplate(false);
		$file = isset($_FILES[$this->_identity_document_field_name]) ? $_FILES[$this->_identity_document_field_name] : false;
		
		if ($file) {
			
			if ($file["size"] > self::FILE_SIZE_LIMIT) {
				$this->errors = array(blmsg("TRANS_FILE_SIZE_LIMIT_EXCEEDED", array("file_size_limit" => self::FILE_SIZE_LIMIT / 1048576)));
				return; 
			}
			
			if (!in_array($file["type"], array("image/jpeg", "image/png", "image/gif", "application/pdf"))) {
				$this->errors = array(blmsg("TRANS_INCOMPATIBLE_DOCUMENTS_FORMAT", array("mime" => $file["type"])));
				return; 
			}
			
			$fileContent = file_get_contents($file["tmp_name"]);
			
			list($contractNumber) = explode("/", $this->_subjectContract);
			$url = RuCenterModule::UPLOAD_IDENTITY_DOCUMENT_URL . "/" . $contractNumber;
			
			$options = array(
				"X-Login: " . $this->_login . "/adm",
				"X-Password: " . $this->_password,
				"Content-Type: application/octet-stream",
				"Expect: ",
				"X-Request-Id: " . RuCEnterModule::generateRequestId()
			);
			
			$curl = curl_init();
			curl_setopt($curl, CURLOPT_URL, $url); 
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $options);
			curl_setopt($curl, CURLOPT_PUT, true);
			curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($curl, CURLOPT_INFILE, fopen($file["tmp_name"], "r")); 
			curl_setopt($curl, CURLOPT_INFILESIZE, strlen($fileContent));
			curl_setopt($curl, CURLOPT_VERBOSE, true);
			
			
			$attemptsCount = 0;
			while (!($output = curl_exec($curl)) && $attemptsCount < RuCenterModule::REQUEST_ATTEMPTS_COUNT) {
				$attemptsCount++;
			}
			
			curl_close($curl);
			
			if (!$output) {
				$this->errors = array(curl_error($curl));
			} else {
				list($name, $code, $message) = explode(" ", $output);
				if ((int)$code != 200) {
					$this->errors = array(curl_error($message));
				}
			}
		}
	}
	
}