{* $Id: ShowGeneralLedger.tpl 10261 2006-12-11 19:48:58Z kbailey $
 * --------------------------------------------------------------
 * This template displays the general ledger.
 *
 * Smarty Variables:
 *	$generalLedger (array of ledger entries)
 *		generalLedgerID
 *		clientID
 *		invoiceID
 *		journalTableID
 *		journalTableName
 *		generalLedgerDateCreated
 *		generalLedgerDescription
 *		generalLedgerDebitAmount
 *		generalLedgerCreditAmount
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}





{php}$GLOBALS['__pagePath'] = array('TRANS_FINANCES', 'TRANS_ACCOUNTING', 'TRANS_GENERAL_LEDGER');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_FINANCES"
	childName="TRANS_ACCOUNTING"
	grandchildName="TRANS_GENERAL_LEDGER"
	sideNavMajor="finances"
	sideNavMinor="accounting"}

{foreach key="currencyID" item="generalLedger" from=$currencies}
	<fieldset>
    <legend>{"TRANS_CURRENCY"|lmsg} {$currencyID}</legend>

		<table width="100%" cellpadding="4" class="ledger">
			{assign var="queryArgs" value="dateQuery[]=`$dateQuery.0`&generalLedgerBeginMonth=`$generalLedgerBeginMonth`&generalLedgerBeginDay=`$generalLedgerBeginDay`&generalLedgerBeginYear=`$generalLedgerBeginYear`&generalLedgerEndMonth=`$generalLedgerEndMonth`&generalLedgerEndDay=`$generalLedgerEndDay`&generalLedgerEndYear=`$generalLedgerEndYear`"}
			<tr>
				<th class="green">{include sortColumn="generalLedgerDateCreated" text=$smarty.const.TRANS_DATE file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
				<th class="green">{include sortColumn="invoiceID" text=$smarty.const.TRANS_INVOICE file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
				<th>{"TRANS_PACKAGE_NAME"|lmsg}</th>
				<th class="green">{include sortColumn="generalLedgerDescription" text=$smarty.const.TRANS_DESCRIPTION file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
				<th>{include sortColumn="ledgerAccountNumber" text=$smarty.const.TRANS_GL_ACCOUNT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
				<th class="green">{include sortColumn="generalLedgerDebitAmount" text=$smarty.const.TRANS_DEBIT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
				<th>{include sortColumn="generalLedgerCreditAmount" text=$smarty.const.TRANS_CREDIT file="$tplDirectory/widgets/headerSortLink.tpl" action="ShowGeneralLedger" queryArgs=$queryArgs}</th>
			</tr>
			{section name="i" loop=$generalLedger}
				{assign var="currencyID" value=$generalLedger[i].currencyID}
				{assign var="generalLedgerID" value=$generalLedger[i].generalLedgerID}
				{if $smarty.section.i.iteration==1}
					{assign var="class" value="first"}
				{else}
					{assign var="class" value=""}
				{/if}
				<tr class="{$class}">
					<td class="green" style="white-space: nowrap;" align="center">{$generalLedger[i].generalLedgerDateCreated|getDate}</td>
					<td class="green" align="right"><a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$generalLedger[i].invoiceID`"}">{$generalLedger[i].invoiceNumber}</a></td>
					<td><a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=`$ledgerPackageNames[$generalLedgerID].packageID`"}">{$ledgerPackageNames[$generalLedgerID].name}</a></td>
					<td class="description">{$generalLedger[i].generalLedgerDescription}</td>
                    {assign var="tkey" value=$generalLedger[i].ledgerAccountTransKey}
                    <td>{$generalLedger[i].ledgerAccountNumber} - {translate key=$tkey}</td>
					<td width="10%" align="right">{$generalLedger[i].generalLedgerDebitAmount|getAmount:$currencyID:false}</td>
					<td width="10%" align="right">{$generalLedger[i].generalLedgerCreditAmount|getAmount:$currencyID:false}</td>
				</tr>
			{/section}
		</table>

	</fieldset>
{foreachelse}
    {"TRANS_NO_GENERAL_LEDGER_ENTRIES"|lmsg}
{/foreach}


{include file="$tplDirectory/widgets/paginationLinks.tpl" queryArgs="dateQuery[]=`$dateQuery.0`&generalLedgerBeginMonth=`$generalLedgerBeginMonth`&generalLedgerBeginDay=`$generalLedgerBeginDay`&generalLedgerBeginYear=`$generalLedgerBeginYear`&generalLedgerEndMonth=`$generalLedgerEndMonth`&generalLedgerEndDay=`$generalLedgerEndDay`&generalLedgerEndYear=`$generalLedgerEndYear`"}

{include file="$tplDirectory/footer.tpl"}
