{* $Id: EditMyProfile.tpl 6697 2006-05-08 23:12:39Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a form to edit the current admin's profile.
 *
 * Smarty Variables:
 *	$profile (array of this admin's profile data)
 *		adminID			A unique admin ID
 *		adminFirstName	An admin's first name
 *		adminLastName	An admin's last name
 *		adminEmail		An admin's email address
 *		adminUsername	An admin's username
 *		adminActive		The active state of an admin
 *		themeID 		The unique themeID
 *		languageID 		The unique languageID
 *		countriesID 	The unique countriesID
 *	$actionID			The unique action ID for this page view
 *  $actionName			The action name for this action ID
 *	$imageDirectory		The image directory for this theme
 *	$tplDirectory		The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_SYSTEM', 'TRANS_MANAGE_ADMINS', 'TRANS_MYPROFILE');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_SYSTEM"
	childName="TRANS_MANAGE_ADMINS"
	grandchildName="TRANS_MYPROFILE"
	sideNavMajor="system"
	sideNavMinor="admins"}

{assign var="adminID" value=$admin.adminID}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form id="admin_settings" method="post" action="{getFormAction controller="admins"}">
<input type="hidden" name="act" value="{getActionID action="EditMyProfileResponse"}" />
<input type="hidden" name="adminID" value="{$admin.adminID}" />
<input type="hidden" name="oldAdminUsername" value="{$admin.adminUsername}" />
<input type="hidden" name="sid" value="{$sid}" />

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>
<tr>
	<td class="title">{"TRANS_ADMIN_ID"|lmsg}</td>
	<td>{$adminID}</td>
</tr>
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminFirstName"
	value=$formValues.adminFirstName|stripslashes
	title="TRANS_FIRST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminLastName"
	value=$formValues.adminLastName|stripslashes
	title="TRANS_LAST_NAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminEmail"
	value=$formValues.adminEmail|stripslashes
	title="TRANS_EMAIL"}
{include
	file="$tplDirectory/widgets/forms/validateInputText.tpl"
	name="adminUsername"
	value=$formValues.adminUsername|stripslashes
	title="TRANS_USERNAME"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="adminPassword"
	value=$formValues.adminPassword
	title="TRANS_NEW_PASSWORD"}
{include
	file="$tplDirectory/widgets/forms/validateInputPassword.tpl"
	name="adminPasswordConfirm"
	value=$admin.adminPasswordConfirm
	title="TRANS_ENTER_PASSWORD_AGAIN"}
{* Theme choosing disabled
<tr {if $invalid.themeID}class="highlight"{/if}>
	<td class="title">{"TRANS_THEME"|lmsg}</td>
	<td>
        <select id="themeID" name="themeID">
            {html_options options=$themes selected=$formValues.themeID}
        </select>  {$invalid.themeID}
    </td>
</tr>
*}
<tr {if $invalid.skinID}class="highlight"{/if}>
	<td class="title">{"TRANS_SKIN"|lmsg}</td>
	<td>
        <select id="skinID" name="skinID">
            {html_options options=$skins selected=$formValues.skinID}
        </select>  {$invalid.skinID}
    </td>
</tr>
<tr {if $invalid.languageID}class="highlight"{/if}>
	<td class="title">{"TRANS_LANGUAGE"|lmsg}</td>
	<td>
        <select id="languageID" name="languageID">
            {html_options options=$languages selected=$formValues.languageID}
        </select>  {$invalid.languageID}
    </td>
</tr>
<tr {if $invalid.countriesID}class="highlight"{/if}>
	<td class="title">{"TRANS_COUNTRY"|lmsg}</td>
	<td>
        <select id="countriesID" name="countriesID">
            {html_options options=$countries selected=$formValues.countriesID}
        </select>  {$invalid.countriesID}
    </td>
</tr>
<tr {if $invalid.adminActive}class="highlight"{/if}>
	<td class="title">{"TRANS_ACTIVE"|lmsg}</td>
	<td>
        {html_radios id="adminActive" name="adminActive" options=$activeInactive selected=$formValues.adminActive separator="<br />"}
    </td>
</tr>

<tr class="listButtons">
	<td colspan="2" class="nowrap" nowrap="nowrap"><div>
		<input class="submit" type="submit" name="submit" value="{"TRANS_UPDATE_PROFILE"|lmsg}" />
	</div></td>
</tr>
</tbody>
</table>


</form>

{include file="$tplDirectory/footer.tpl"}
