{*
 * --------------------------------------------------------------
 * This template displays a form to add a new client contact record.
 *
 * Smarty Variables:
 *	$client (array of this client's data)
 * $contact (array of this contact's data)
 *
 *}

{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_CLIENTS', 'TRANS_BILLING_ACCOUNTS', 'TRANS_ADD');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_BILLING_ACCOUNTS"
	grandchildName="TRANS_ADD"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

{include file="$tplDirectory/widgets/context/client.tpl"
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{include file="$tplDirectory/widgets/context/contact.tpl"
	client=$client contact=$contact suppressEditLink=1 suppressDeleteLink=1}

<form method="post" name="billing" id="billing" action="{getFormAction controller="clients"}">
<input type="hidden" name="act" value="{getActionID action="AddBillingAccountResponse"}" />
<input type="hidden" name="comboAction" value="{$formValues.comboAction}" />
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="clientID" value="{$client.clientID}" />
<input type="hidden" name="clientContactID" value="{$contact.clientContactID}" />

<fieldset>
<legend>{"TRANS_BILLING_ACCOUNT_LEGEND"|lmsg}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
<tbody>
<tr {if $invalid.billingAccountType}class="highlight"{/if}>
	<td class="title">{"TRANS_TYPE"|lmsg}</td>
	<td>
		{section name=billing loop=$billingAccountTypes}
			{assign var="thisBillingAccountType" value=$billingAccountTypes[billing]}
			{assign var="thisBillingAccountTypeIndex" value=$smarty.section.billing.index}
			<label for="type_{$thisBillingAccountTypeIndex}"><input onclick="updateTypeEnableState()" id="type_{$thisBillingAccountTypeIndex}" type="radio" name="billingAccountType" value="{$thisBillingAccountTypeIndex}" {if $thisBillingAccountTypeIndex == $formValues.billingAccountType}checked="checked"{/if} /> {$thisBillingAccountType}</label>
			<br />
		{/section}

		{* {html_radios name="billingAccountType" separator="<br />" options=$billingAccountTypes selected=$formValues.billingAccountType} *}
		{$invalid.billingAccountType}
	</td>
</tr>
<tr>
	<td class="title">{"TRANS_DEFAULT"|lmsg}</th>
	<td>
		<label for="defaultBillingAccount">
			<input id="defaultBillingAccount" type="checkbox" name="defaultBillingAccount" value="1"/>
			 - {"TRANS_THIS_ACCOUNT_IS_THE_DEFAULT_BILLING_ACCOUNT_FOR_THIS_CLIENT"|lmsg}
		</label>
	</td>
</tr>
</tbody>
</table>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
<tbody>
<tr>
	<td valign="top" id="ccard_account" style="display:none;">
		<fieldset>
		<legend>{"TRANS_CREDIT_CARD_ACCOUNT_LEGEND"|lmsg}</legend>
		<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
		<tr {if $invalid.billingCardNameOnCard}class="highlight"{/if}>
			<td class="title"><label for="billingCardNameOnCard">{"TRANS_NAME_ON_CARD"|lmsg}</label>:</td>
			<td><input size="25" maxlength="75" type="text" style="width:175px;" id="billingCardNameOnCard" name="billingCardNameOnCard" value="{$formValues.billingCardNameOnCard|safetyhtml}" /> {$invalid.billingCardNameOnCard}</td>
		</tr>
		<tr {if $invalid.billingCardType}class="highlight"{/if}>
			<td class="title"><label for="billingCardType">{"TRANS_TYPE"|lmsg}</label>:</td>
			<td><select id="billingCardType" style="width:175px;" name="billingCardType" onchange="updateCardExtraEnableState()"> {html_options options=$cardTypes selected=$formValues.billingCardType} </select> {$invalid.billingCardType}</td>
		</tr>
		<tr {if $invalid.billingCardNum}class="highlight"{/if}>
			<td class="title"><label for="billingCardNum">{"TRANS_CARD_NUMBER"|lmsg}</label>:</td>
			<td><input size="16" maxlength="19" type="text" style="width:175px;" id="billingCardNum" name="billingCardNum" onkeyup="this.value=XKfilterString(this.value, '0123456789');" value="" /> {$invalid.billingCardNum}</td>
		</tr>
		<tr {if $invalid.billingCardExpMonth}class="highlight"{/if}>
			<td class="title"><label for="billingCardExpMonth">{"TRANS_EXPIRY_MONTH"|lmsg}</label>:</td>
			<td><input size="2" maxlength="2" type="text" style="width:50px;" id="billingCardExpMonth" name="billingCardExpMonth" value="{$formValues.billingCardExpMonth|safetyhtml}" /> [00] {$invalid.billingCardExpMonth}</td>
		</tr>
		<tr {if $invalid.billingCardExpYear}class="highlight"{/if}>
			<td class="title"><label for="billingCardExpYear">{"TRANS_EXPIRY_YEAR"|lmsg}</label>:</td>
			<td><input size="4" maxlength="4" type="text" style="width:50px;" id="billingCardExpYear" name="billingCardExpYear" value="{$formValues.billingCardExpYear|safetyhtml}" /> [0000] {$invalid.billingCardExpYear}</td>
		</tr>
		<tr {if $invalid.billingCardIssueNum}class="highlight"{/if}>
			<td class="title"><label for="billingCardIssueNum">{"TRANS_ISSUE_NUMBER"|lmsg}</label>:</td>
			<td><input size="3" maxlength="3" type="text" style="width:50px;" id="billingCardIssueNum" name="billingCardIssueNum" value="{$formValues.billingCardIssueNum|safetyhtml}" /> {$invalid.billingCardIssueNum}</td>
		</tr>
		<tr {if $invalid.billingCardStartDate}class="highlight"{/if}>
			<td class="title"><label for="billingCardStartDate">{"TRANS_START_DATE"|lmsg}</label>:</td>
			<td><input size="25" maxlength="50" type="text" style="width:50px;" id="billingCardStartDate" name="billingCardStartDate" value="{$formValues.billingCardStartDate|safetyhtml}" /> {$invalid.billingCardStartDate}</td>
		</tr>
		<tr {cycle values="alt1,alt2"}">
			<td class="title">&nbsp;</td>
			<td>&nbsp;</td>
		</tr>
		</table>
		</fieldset>
	</td>
	<td valign="top" id="bank_account" style="display:none;">
		<fieldset>
		<legend>{"TRANS_BANK_ACCOUNT"|lmsg}</legend>
		<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
		<tr {if $invalid.billingBankName}class="highlight"{/if} id="row_billingBankName">
			<td class="title"><label for="billingBankName" id="label_billingBankName">{"TRANS_BANK_NAME"|lmsg}</label>:</td>
			<td><input size="25" maxlength="50" type="text" style="width:175px;" id="billingBankName" name="billingBankName" value="{$formValues.billingBankName|safetyhtml}" /> {$invalid.billingBankName}</td>
		</tr>
		<tr {if $invalid.billingBankState}class="highlight"{/if} id="row_billingBankState">
			<td class="title"><label for="billingBankState">{"TRANS_BANK_STATE"|lmsg}</label>:</td>
			<td><input size="25" maxlength="50" type="text" style="width:175px;" id="billingBankState" name="billingBankState" value="{$formValues.billingBankState|safetyhtml}" /> {$invalid.billingBankState}</td>
		</tr>
		<tr {if $invalid.billingBankType}class="highlight"{/if} id="row_billingBankType">
			<td class="title"><label for="billingBankType">{"TRANS_TYPE"|lmsg}</label>:</td>
			<td><select id="billingBankType" style="width:175px;" name="billingBankType"> {html_options options=$bankAccountTypes selected=$formValues.billingBankType} </select> {$invalid.billingBankType}</td>
		</tr>
		<tr {if $invalid.billingBankAbaCode}class="highlight"{/if} id="row_billingBankAbaCode">
			<td class="title"><label for="billingBankAbaCode" id="label_billingBankAbaCode">{"TRANS_ROUTING_NUMBER"|lmsg}</label>:</td>
			<td><input size="20" maxlength="20" type="text" style="width:175px;" id="billingBankAbaCode" name="billingBankAbaCode" value="{$formValues.billingBankAbaCode|safetyhtml}" /> {$invalid.billingBankAbaCode}</td>
		</tr>
		<tr {if $invalid.billingBankAccountNum}class="highlight"{/if} id="row_billingBankAccountNum">
			<td class="title"><label for="billingBankAccountNum" id="label_billingBankAccountNum">{"TRANS_ACCOUNT_NUMBER"|lmsg}</label>:</td>
			<td><input size="20" maxlength="20" type="text" style="width:175px;" id="billingBankAccountNum" name="billingBankAccountNum" value="" /> {$invalid.billingBankAccountNum}</td>
		</tr>
		<tr {if $invalid.billingBankLicenseNum}class="highlight"{/if} id="row_billingBankLicenseNum">
			<td class="title"><label for="billingBankLicenseNum">{"TRANS_LICENSE_NUMBER"|lmsg}</label>:</td>
			<td><input size="20" maxlength="20" type="text" style="width:175px;" id="billingBankLicenseNum" name="billingBankLicenseNum" value="{$formValues.billingBankLicenseNum|safetyhtml}" /> {$invalid.billingBankLicenseNum}</td>
		</tr>
		<tr {if $invalid.billingBankLicenseState}class="highlight"{/if} id="row_billingBankLicenseState">
			<td class="title"><label for="billingBankLicenseState">{"TRANS_LICENSE_STATE"|lmsg}</label>:</td>
			<td><input size="25" maxlength="50" type="text" style="width:175px;" id="billingBankLicenseState" name="billingBankLicenseState" value="{$formValues.billingBankLicenseState|safetyhtml}" /> {$invalid.billingBankLicenseState}</td>
		</tr>
		<tr {if $invalid.billingBankDob}class="highlight"{/if} id="row_billingBankDob">
			<td class="title"><label for="billingBankDob">{"TRANS_DOB"|lmsg}</label>:</td>
			<td><input size="25" maxlength="25" type="text" style="width:175px;" id="billingBankDob" name="billingBankDob" value="{$formValues.billingBankDob|safetyhtml}" /> {$invalid.billingBankDob}</td>
		</tr>
		</table>
		</fieldset>
	</td>
</tr>
<tr>
	<td valign="top" id="ddbp_account" style="display:none;">
		<fieldset>
		<legend>{"TRANS_DDBP_ACCOUNT_LEGEND"|lmsg}</legend>
		<table width="100%" border="0">
			<tr>
				<td class="title"><label>{"TRANS_SELECT_DDBP_ACCOUNT_TYPE_OPT"|lmsg}</label></td>
				<td>
				<table width="100%" border="0" cellpadding="2" cellspacing="0">
				{section name=ddbp_acc_i loop=$ddbp_accounts}
					{assign var="gatewayID" value=$ddbp_accounts[ddbp_acc_i].gateway_id}
					{assign var="gatewayName" value=$ddbp_accounts[ddbp_acc_i].gateway_name}
					{assign var="gatewayDesc" value=$ddbp_accounts[ddbp_acc_i].gateway_desc}
					{if $smarty.section.ddbp_acc_i.iteration == 1}
						{assign var="firstDDBPAccountID" value=$gatewayID}
					{/if}
					<tr><td><label for="ddbp_type_{$gatewayID}"><input type="radio" onclick="updateDDBPAccountState({$gatewayID})" id="ddbp_type_{$gatewayID}" name="selected_ddbp_gateway_id" value="{$gatewayID}" {if $selected_ddbp_gateway_id == $gatewayID OR (! $selected_ddbp_gateway_id AND $smarty.section.ddbp_acc_i.iteration == 1)}checked{/if}>&nbsp;{$gatewayName}{if $gatewayDesc}&nbsp;({$gatewayDesc}){/if}</label></td></tr>
				{/section}
				</table>
				</td>
			</tr>
		{section name=ddbp_acc_i loop=$ddbp_accounts}
			{assign var="thisDDBPAccount" value=$ddbp_accounts[ddbp_acc_i]}
			<tr id="ddbp_account_{$thisDDBPAccount.gateway_id}">
			<td colspan="2">
				<table width="100%" border="0">
				{section name=fields_i loop=$thisDDBPAccount.fields}
					{assign var="fieldName" value=$thisDDBPAccount.fields[fields_i].field_name}
					{assign var="fieldTitle" value=$thisDDBPAccount.fields[fields_i].field_title}
					{assign var="fieldDesc" value=$thisDDBPAccount.fields[fields_i].field_desc}
					<tr {if $invalid.$fieldName}class="highlight"{/if}>
						<td class="title"><label for="$fieldName">{$fieldTitle|lmsg}</label>:</td>
						<td>
							<input size="50" maxlength="50" type="text" style="width:175px;" id="{$fieldName}" name="{$fieldName}" value="{$formValues.$fieldName|safetyhtml}" /> {$invalid.$fieldName}
							<div class="hint">{$fieldDesc|lmsg}</div>
						</td>
					</tr>
				{/section}
				</table>
			</td></tr>
		{/section}
		</table>
	</td>
</tr>
<tr class="listButtons">
	<td noWrap=noWrap><div>
		{if $needKey>0}
			<strong>{"TRANS_ENCRYPTION_PASSPHRASE"|lmsg}</strong>
			&nbsp;
			<input size="15" type="password" style="width:175px;" id="encKey" name="encKey" value="{$formValues.billingCardStartDate}" />
			&nbsp;
		{else}
		&nbsp;
		{/if}
		<div>
			<input class="submit" type="submit" name="submit" value="{"TRANS_SAVE_BILLING_ACCOUNT"|lmsg}" />
		</div>
	</div>
	</td>
</tr>

</tbody>
</table>

</fieldset>

</form>

<br />

<script type="text/javascript">
	{literal}
	function showCCardAccount()
	{
		document.getElementById('ccard_account').style.display="";
		document.getElementById('ddbp_account').style.display="none";
		document.getElementById('bank_account').style.display="none";
	}
	function showBankAccount()
	{
		document.getElementById('ccard_account').style.display="none";
		document.getElementById('ddbp_account').style.display="none";
		document.getElementById('bank_account').style.display="";

		document.getElementById('row_billingBankName').style.display="";
		document.getElementById('row_billingBankAbaCode').style.display="";
		document.getElementById('row_billingBankAccountNum').style.display="";
		document.getElementById('row_billingBankState').style.display="";
		document.getElementById('row_billingBankType').style.display="";
		document.getElementById('row_billingBankLicenseNum').style.display="";
		document.getElementById('row_billingBankLicenseState').style.display="";
		document.getElementById('row_billingBankDob').style.display="";
	}
	function hideAccount()
	{
		document.getElementById('ccard_account').style.display="none";
		document.getElementById('bank_account').style.display="none";
		document.getElementById('ddbp_account').style.display="none";
	}

	function updateTypeEnableState() {
		if (document.getElementById('type_0') && document.getElementById('type_0').checked) {
			showCCardAccount();
			updateCardExtraEnableState();
		} else if ((document.getElementById('type_3') && document.getElementById('type_3').checked) || (document.getElementById('type_4') && document.getElementById('type_4').checked)) {
			hideAccount();
		} else if (document.getElementById('type_6') && document.getElementById('type_6').checked) {
			showDDBPAccount();
		} else {
			showBankAccount();
		}
	}
	updateTypeEnableState();

	function hideAllDDBPAccounts()
	{
		{/literal}{section name=ddbp_acc_i loop=$ddbp_accounts}
			{assign var="gatewayID" value=$ddbp_accounts[ddbp_acc_i].gateway_id}{literal}
			document.getElementById('ddbp_account_{/literal}{$gatewayID}{literal}').style.display="none";
		{/literal}{/section}{literal}
	}

	function showDDBPAccount(gateway_id)
	{
		if (!gateway_id) {
			document.getElementById('ccard_account').style.display="none";
			document.getElementById('ddbp_account').style.display="";
			document.getElementById('bank_account').style.display="none";
		} else {
			document.getElementById('ddbp_account_'+gateway_id).style.display="";
		}
	}

	function updateDDBPAccountState(gateway_id) {
		hideAllDDBPAccounts();
		showDDBPAccount(gateway_id);
	}

	{/literal}{if isset($selected_ddbp_gateway_id) || isset($firstDDBPAccountID)}{literal}
	updateDDBPAccountState({/literal}{if $selected_ddbp_gateway_id}{$selected_ddbp_gateway_id}{else}{$firstDDBPAccountID}{/if}{literal});
	{/literal}{/if}{literal}

	function updateCardExtraEnableState() {
		cardExtraTypes = Array({/literal}{strip}
			{assign var="comma" value=0}
			{section name=iter loop=$cardExtraTypes}
				{if $comma}, {/if}
				{$cardExtraTypes[iter]}
				{assign var="comma" value=1}
			{/section}
		{/strip}{literal})

		selected = document.getElementById('billingCardType').selectedIndex;
		c = cardExtraTypes.length;
		cardExtraTypeSelected = false;
		for(i = 0; i < c; i++) {
			cardExtraType = cardExtraTypes[i];
			if(cardExtraType == selected) {
				cardExtraTypeSelected = true;
			}
		}
		if(cardExtraTypeSelected) {
			document.getElementById('billingCardIssueNum').disabled=false;
			document.getElementById('billingCardStartDate').disabled=false;
		} else {
			document.getElementById('billingCardIssueNum').disabled=true;
			document.getElementById('billingCardStartDate').disabled=true;
		}
	}
	updateCardExtraEnableState();
	{/literal}
</script>

{include file="$tplDirectory/footer.tpl"}
