{* $Id: EditClientArchiveState.tpl 9367 2006-10-09 20:32:39Z mfountain $
 * --------------------------------------------------------------
 * This template displays a form to edit an existing client.
 *
 * Smarty Variables:
 *	$formValues (array of this clients data)
 *		clientID			A unique client ID
 *		clientFirstName		A client's first name
 *		clientLastName		A client's last name
 *		clientEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}


{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_CLIENTS', 'TRANS_CLIENTS', 'TRANS_EDIT_CLIENT_ARCHIVE_TITLE');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_CLIENTS"
	grandchildName="TRANS_EDIT_CLIENT_ARCHIVE_TITLE"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{include file="$tplDirectory/widgets/context/client.tpl" 
	client=$client suppressEditLink=1 suppressDeleteLink=1}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="{getFormAction controller="clients"}">
<input type="hidden" name="act" value="{getActionID action="EditClientArchiveStateResponse"}">
<input type="hidden" name="clientID" value="{$client.clientID}">
<input type="hidden" name="sid" value="{$sid}">

<fieldset>
<legend>{"TRANS_EDIT_CLIENT_ARCHIVE_SETTINGS"|lmsg}</legend>

<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">

{********* TRANS_CLIENT_DETAILS *********}
<tr {if $invalid.clientActive}class="highlight"{/if}>
	<td colspan="2">
		{if $numActivePackages}
			<strong style="color:red;">
			{"TRANS_WARNING_ACTIVE_PACKAGES"|lmsg}
			</strong>
		{else}
			<strong style="color:#444444;">
			{"TRANS_NOTICE_ACTIVE_PACKAGES"|lmsg}
			</strong>
		{/if}
	</td>
</tr>
<tr {if $invalid.clientActive}class="highlight"{/if}>
	<td class="title"><label for="clientActive">{"TRANS_IS_ARCHIVED_OPTION"|lmsg}</label>:</td>
	<td>
		{if $smarty.const.numClientsRemaining<1 AND $client.clientActive!="1"}
			<input type="radio" disabled="disabled" name="clientActive" value="0" checked="checked" /> 
			{"TRANS_YES"|lmsg}
			<br />
			<input type="radio" disabled="disabled" name="clientActive" value="1" /> 
			{"TRANS_NO"|lmsg}
			<br />
			<strong>{"TRANS_EXPLAIN_NO_CLIENTS_LEFT_NOTE"|lmsg}</strong>
		{else}
			<input type="radio" name="clientActive" value="0" {if $client.clientActive!="1"}checked="checked"{/if} /> 
			{"TRANS_YES"|lmsg}
			<br />
			<input type="radio" name="clientActive" value="1" {if $client.clientActive=="1"}checked="checked"{/if} /> 
			{"TRANS_NO"|lmsg}
		{/if}
	</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div>
		<input class="submit" type="submit" {if $smarty.const.numClientsRemaining<1 AND $client.clientActive!="1"}disabled="disabled"{/if} value="{"TRANS_SAVE"|lmsg}" />
	</div></td>
</tr>
</table>

</fieldset>

</form>

<br />

{include file="$tplDirectory/footer.tpl"}
