{* $Id: ShowNewOrders.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of client records.
 *
 * Smarty Variables:
 *	$clients (array of clients that match input criteria)
 *		clientID			A unique client ID
 *		contactFirstName		A client's first name
 *		contactLastName		A client's last name
 *		contactEmail			A client's email address
 *		clientCompany		A client's company name
 *		clientActive		The active state of a client
 *	$clientActive			The $_REQUEST value of clientActive filter option
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Michael Fountain
 * Author: Ben Woolley
 *}

{assign var="filterArgs" value="clientActive=$clientActive&clientStatus=$clientStatus"}
{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_CLIENTS', 'TRANS_NEW_CUSTOMERS', '');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_CLIENTS"
	childName="TRANS_NEW_CUSTOMERS"
	sideNavMajor="clients"
	sideNavMinor="clients"}

{literal}
<script language="JavaScript">
	function cbx_register_click(id,targetID) {
		setTimeout('cbx_process_event("'+id+'","'+targetID+'");',100);
	}
	function cbx_process_event(id,targetID) {
		if (document.getElementById(id).checked) {
			cbx_select(id,targetID);
		} else {
			cbx_deselect(id,targetID);
		}
	}
	function cbx_select(id,targetID) {
		document.getElementById(targetID).disabled = true;
		document.getElementById(targetID).checked = false;
	}
	function cbx_deselect(id,targetID) {
		document.getElementById(targetID).disabled = false;
	}
</script>
{/literal}

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="7" style="cursor: pointer;" onclick="{strip} {section name=iter loop=$clients}
		XKtoggle('row_{$clients[iter].clientID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {"TRANS_ADDITIONAL_DATA"|lmsg}
	</td>
</tr>

</thead>
<form method="post" action={getHREF page="clients.php" actionName="EditNewOrdersResponse"}>
	{section name=i loop="$clients"}
	{assign var="clientID" value=$clients[i].clientID}
	{assign var="trans_countriesISO2" value="TRANS_ISO_3166_`$clients[i].countriesISO2`"}
	{if $className=="alt1"}
		{assign var="className" value="alt2"}
	{else}
		{assign var="className" value="alt1"}
	{/if}
	<tbody>
	
	<tr class="{cycle values="alt1,alt2"}">
		<td class="listRowFirstTD" style="cursor: pointer;" onclick="return XKtoggle('row_{$clientID}');">
			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
			{$clientID}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<img src="{$imageDirectory}/flags/flag-{$clients[i].countriesISO2|safetyhtml}.gif" style="vertical-align:middle;border-style:none;" /> {$smarty.const.$trans_countriesISO2|mb_truncate:15}
			<br />
			{$clients[i].clientDateCreated|getDateTime}
			<br />
			{if $clients[i].invoices[0]}
				{"TRANS_INVOICE"|lmsg} {$clients[i].invoices[0].invoiceAmount|getAmount:$clients[i].invoices[0].currencyID}
				{if $clients[i].invoices[0].invoiceStatus|getAPIStatusName:"invoice" == "closed"}
					{assign var="color" value="green"}
				{else}
					{assign var="color" value="red"}
				{/if}
				<font color="{$color}">
					{$clients[i].invoices[0].invoiceStatus|getStatusName:"invoice"}
				</font>
			{else}			
				{"TRANS_INVOICE"|lmsg} <font color="red"><i>{"TRANS_UNKNOWN"|lmsg}</i></font>
			{/if}
		</td>
		<td style="font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{if $clients[i].clientCompany}
				{$clients[i].clientCompany|safetyhtml|mb_truncate:22}
				<br />
			{/if}	
			{$clients[i].contactLastName|safetyhtml|mb_truncate:12}, {$clients[i].contactFirstName|safetyhtml|mb_truncate:12}
			<br />
			{$clients[i].contactEmail|safetyhtml|mb_truncate:25}
		</td>
		<td style="width:40px; font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			{* COMING SOON
			<a href="javascript:void(0);" onclick="openwin('{getHREF page="clients.php" actionName="ShowNewOrderReview" args="clientID=$clientID"}',400,400,'clientID_{$clientID}');">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
			*}
			<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID&__print=1"}" target="_blank">{$smarty.const.TRANS_REVIEW|mb_truncate:10}</a>
		</td>
		<td style="width:55px; font-size: 9px; border-bottom: 1px solid #CFCDC7;">
			<input type="checkbox" name="activate[]" id="cbx_activate_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('cbx_activate_{$clientID}','cbx_cancel_{$clientID}');" />&nbsp;{"TRANS_ACTIVATE"|lmsg}
			<br />
			<input type="checkbox" name="cancel[]" id="cbx_cancel_{$clientID}" value="{$clientID}" 
				onmouseup="cbx_register_click('cbx_cancel_{$clientID}','cbx_activate_{$clientID}');" />&nbsp;{"TRANS_CANCEL"|lmsg}
		</td>
	</tr>
	</tbody>
	<tbody id="row_{$clientID}" class="off">
	<tr>
		<td colspan="5"  class="comments altinner">
			{strip}
			<a href="javascript:void(0);" onclick="return XKtoggle('row_{$clientID}');">
				<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
			</a>
			&nbsp;
			<b>{"TRANS_CLIENT_ID"|lmsg} {$clientID} ({"TRANS_ADDITIONAL_INFORMATION"|lmsg})</b>
			{/strip}
			<br clear="all" />
			<table width="100%" border="0" cellpadding="0" cellspacing="5">
			<tr>
				{************************** COLUMN 1 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{"TRANS_PRIMARY_CONTACT"|lmsg}</strong>
							&nbsp;
							{assign var="contactID" value=$clients[i].contacts.0.clientContactID}
							<a href="{getHREF page="clients.php" actionName="ShowClientContacts" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{"TRANS_DETAILS"|lmsg}" title="{"TRANS_DETAILS"|lmsg}" />
							</a>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="EditClientContact" args="clientContactID=$contactID"}">
								<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{"TRANS_EDIT"|lmsg}" title="{"TRANS_EDIT"|lmsg}" />
							</a>
						</th>
					</tr>
					<tr>
						<td><strong>{"TRANS_NAME"|lmsg}</strong></td>
						<td>{$clients[i].contactLastName|safetyhtml}, {$clients[i].contactFirstName|safetyhtml}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_EMAIL"|lmsg}</strong></td>
						<td>{mailto address=$clients[i].contactEmail}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_PHONE"|lmsg}</strong></td>
						<td>{$clients[i].contactPhone1|safetyhtml}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_USERNAME"|lmsg}</strong></td>
						<td>{$clients[i].contactUsername|safetyhtml}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_LAST_ACCESS"|lmsg}</strong></td>
						<td>{$clients[i].sessions.0.sessionDateAccessed|getDateTime} ({if $clients[i].sessions.0.sessionActive}{"TRANS_ONLINE"|lmsg}{else}{"TRANS_OFFLINE"|lmsg}{/if})</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_LAST_TICKET"|lmsg}</strong></td>
						{assign var="ticketID" value=$clients[i].helpdeskTicket.hdTicketID}
						<td><a href="{getHREF page="helpdesk.php" actionName="ShowHelpdeskTicketDetails" args="hdTicketID=$ticketID"}">{$clients[i].helpdeskTicket.hdTicketSubject}</a></td>
					</tr>
					</table>
				</td>
				{************************** COLUMN 2 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{"TRANS_CLIENT_DETAILS"|lmsg}</strong>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="ShowClientDetails" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{"TRANS_DETAILS"|lmsg}" title="{"TRANS_DETAILS"|lmsg}" />
							</a>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="EditClient" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{"TRANS_EDIT"|lmsg}" title="{"TRANS_EDIT"|lmsg}" />
							</a>
						</th>
					</tr>
					<tr>
						<td><strong>{"TRANS_DATE_CREATED"|lmsg}</strong></td>
						<td>{$clients[i].clientDateCreated|getDateTime}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_COUNTRY"|lmsg}</strong></td>
						<td>{$clients[i].countriesISO2|safetyhtml}</td>
					</tr>
					<tr>
						<td><strong>{"TRANS_TAX"|lmsg}</strong></td>
						<td>{if $clients[i].applyTax}{"TRANS_APPLIED"|lmsg}{else}{"TRANS_NOT_APPLIED"|lmsg}{/if}</td>
					</tr>
					{if $clients[i].taxIDNumber}
					<tr>
						<td><strong>{"TRANS_TAX_ID_NUMBER"|lmsg}</strong></td>
						<td>{$clients[i].taxIDNumber|safetyhtml}</td>
					</tr>
					{/if}
					</table>
				</td>
				{************************** COLUMN 3 **************************}
				<td width="33%" valign="top">
					<table width="100%" border="0" cellpadding="1" cellspacing="1" class="addData">
					<tr>
						<th colspan="2">
							<strong>{"TRANS_LAST_NOTE"|lmsg}</strong>
							&nbsp;
							<a href="{getHREF page="clients.php" actionName="ManageClientNotes" args="clientID=$clientID"}">
								<img src="{$imageDirectory}/ico/data_view.gif" width="16" height="16" border="0" alt="{"TRANS_SHOW_ALL_ADD_NEW"|lmsg}" title="{"TRANS_SHOW_ALL_ADD_NEW"|lmsg}" />
							</a>
							&nbsp;
							{include
								file="$tplDirectory/widgets/quickAddLink.tpl"
								useEditIcon=1
								addActionName="ManageClientNotesResponse"
								addName="TRANS_NOTE"
								addColumn="clientNoteText"
								addValue=""
								extraparam="clientID"
								extravalue=$clientID}
						</th>
					</tr>
					<tr>
						<td>
						{assign var="clientNotes" value=$noteList.$clientID}
						{section name="j" loop=$clientNotes}
							<div class="note">
								<div class="floatright">
									{assign var="noteAdminID" value=$clientNotes[j].adminID}
									<a href="{getHREF page="admins.php" actionName="ShowAdminDetails" args="adminID=$noteAdminID"}">
										{$clientNotes[j].adminUsername}
									</a>
								</div>
								{$clientNotes[j].clientNoteText|nl2br}
							</div>
						{sectionelse}
							{"TRANS_NONE"|lmsg}
						{/section}
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</tbody>
	{sectionelse}
	<tr class="alt1">
		<td colspan="5" style="text-align:center;"><i>{"TRANS_NO_NEW_ORDERS"|lmsg}</i></td>
	</tr>
	{/section}
	{if count($clients)>0}
		<tr class="listRowNoBorders">
			<td colspan="4" style="text-align:right;">
				<strong>{"TRANS_SET_CANCEL_ACTION"|lmsg}</strong>
				&nbsp;
				<select name="cancelAction" style="width:150px;">
					<option value="suspend">{"TRANS_SUSPEND_PACKAGE_IF_PROVISIONED"|lmsg}</option>
					<option value="delete">{"TRANS_DELETE_PACKAGE_IF_PROVISIONED"|lmsg}</option>
				</select>
			</td>
			<td>
				<input type="submit" name="submitActivateClients" value="{"TRANS_SUBMIT"|lmsg}">
			</td>
		</tr>
	{/if}
	</table>
</form>


{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
