{* $Id: ShowEmailDetails.tpl 12424 2008-01-03 21:25:24Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to remove an email from the email queue.
 *
 * Smarty Variables:
 *	$email (array of this email's data)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Brian Smith
 *}{strip}


{/strip}
{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_EMAILS', 'TRANS_SHOW_EMAILS', '');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EMAILS"
	childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"}

<fieldset>
<legend>{"TRANS_VIEW_EMAIL_DETAILS"|lmsg}</legend>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>

<tr>
	<td class="title">{"TRANS_EMAIL_ID"|lmsg}</td>
	<td>
		<strong>{$email.emailID}</strong>
		{* RESEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="ResendEmail"
			args="emailID=`$email.emailID`"
			icoImage="014.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_RESEND"
			titleText=""
			linkText="TRANS_RESEND"
			noSpace="1"}

		{* EDIT AND SEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="SendClientEmail"
			args="emailID=`$email.emailID`"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT_EMAIL"
			titleText=""
			linkText="TRANS_EDIT_EMAIL"
			noSpace="1"}

	</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_FROM_NAME"|lmsg}</td>
	<td>{$email.emailFromName}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_FROM_ADDRESS"|lmsg}</td>
	<td>{$email.emailFromAddress}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_DELIVERY_STATUS_OPTION"|lmsg}</td>
	<td>
		{if $email.emailSent == 1}
			<font color="green">{"TRANS_SUCCESS"|lmsg}</font>
		{/if}
		{if $email.emailFailed == 1}
			<font color="red">{"TRANS_FAILURE"|lmsg}</font>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_ENTERED_OPTION"|lmsg}</td>
	<td>{$email.emailDateCreated|getDateTime:long}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_SENT_ON_OPTION"|lmsg}</td>
	<td>{$email.emailDateSent|getDateTime:long}</td>
</tr>

<tr>
	<td class="title">{"TRANS_ACTIVE"|lmsg}</td>
	<td>{$email.emailActive|getArrayValueByID:$yesNo}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_ADDRESS_DESTINATIONS_OPTION"|lmsg}</td>
	<td>
		{if $email.emailToAddresses}
			<ul style="list-style:none;padding:0;">
				{foreach from=$email.emailToAddresses.0.emailToAddress item=to}
					{if $to.emailAddressName}
						<li>"{$to.emailAddressName}" &lt;{$to.emailAddress}&gt;</li>
					{else}
						<li>{$to.emailAddress}</li>
					{/if}
				{foreachelse}
					<li>{"TRANS_NORESULTS"|lmsg}</li>
				{/foreach}
			</ul>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_CC_ADDRESS"|lmsg}</td>
	<td>{if $email.emailCCAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailCCAddresses.0.emailCCAddress item=cc}
			{if $cc.emailAddressName}
				<li>"{$cc.emailAddressName}" &lt;{$cc.emailAddress}&gt;</li>
			{else}
				<li>{$cc.emailAddress}</li>
			{/if}
		{/foreach}
		</ul>
		{else}
			{"TRANS_NORESULTS"|lmsg}
		{/if}</td>
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_BCC_ADDRESS"|lmsg}</td>
	<td>{if $email.emailBCCAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailBCCAddresses.0.emailBCCAddress item=bcc}
			{if $bcc.emailAddressName}
				<li>"{$bcc.emailAddressName}" &lt;{$bcc.emailAddress}&gt;</li>
			{else}
				<li>{$bcc.emailAddress}</li>
			{/if}
		{/foreach}
		</ul>
		{else}
			{"TRANS_NORESULTS"|lmsg}
		{/if}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_REPLY_ADDRESS"|lmsg}</td>
	<td>{if $email.emailReplyToAddresses}
		<ul style="list-style:none;padding:0;">
		{foreach from=$email.emailReplyToAddresses.0.emailReplyToAddress item=reply}
			{if $reply.emailAddressName}
				<li>"{$reply.emailAddressName}" &lt;{$reply.emailAddress}&gt;</li>
			{else}
				<li>{$reply.emailAddress}</li>
			{/if}
		{foreachelse}
			<li>{"TRANS_NORESULTS"|lmsg}</li>
		{/foreach}
		</ul>
	{else}
		{"TRANS_NORESULTS"|lmsg}
	{/if}
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_ATTACHMENTS"|lmsg}</td>
	<td>
		{if $email.emailAttachments}
			<ul style="list-style:none;padding:0;">
				{foreach from=$email.emailAttachments.0.emailAttachment item=emailAttachment}
					<li>{$emailAttachment.emailAttachmentName}</li>
				{foreachelse}
					<li>{"TRANS_NORESULTS"|lmsg}</li>
				{/foreach}
			</ul>
		{else}
			{"TRANS_NORESULTS"|lmsg}
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_HEADERS"|lmsg}</td>
	<td>
		{if $email.emailHeaders}
			<ul style="list-style:none;padding:0;">
				{foreach from=$email.emailHeaders item=header}
					<li>{$header.emailHeader}</li>
				{foreachelse}
					<li>{"TRANS_NORESULTS"|lmsg}</li>
				{/foreach}
			</ul>
		{/if}
	</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_MESSAGE_SUBJECT"|lmsg}</td>
	<td>{$email.emailSubject}</td>
</tr>

<tr>
	<td class="title">{"TRANS_EMAIL_MESSAGE_BODY"|lmsg}</td>
	<td>{if "" != $email.emailBody}{$email.emailBody}{else}{$email.emailTextBody}{/if}</td>
</tr>

</tbody>
</table>
</fieldset>
{include file="$tplDirectory/footer.tpl"}


