{* $Id: ShowEmailQueue.tpl 10429 2007-01-08 17:38:25Z bwoolley $
 * --------------------------------------------------------------
 * This template displays a list of emails in the email queue. From this list, the user should be able to add, edit, or
 * remove items from the queue, and also run items in the queue. All of these actions can be accessed via events.php, and
 * their action names are as follows:
 *   AddEmail
 *   EditEmail
 *   RemoveEmail
 *   RunEmailQueue
 *
 * Smarty Variables:
 *	$emails (an array of all emails available to this display)
 *	  emailID  -  The ID of this email
 *	  emailSubject  -  The subject of this email
 *	  emailFromAddress  -  The address of the email's sender
 *	  emailFromName  -  The name of the sender (if this is empty, no name was given)
 *    emailTextBody  -  text body
 *    emailSent  -  1 if this email has been sent, or 0 if otherwise
 *    emailFailed  -  1 if this email failed to send, or 0 if otherwise
 *    emailActive  -  1 if this email is active, and waiting to be sent. 0 if otherwise.
 *    emailToAddresses  -  An array of recipients for this email
 *    emailCCAddresses  -  An array of carbon copied recipients for this email
 *    emailBCCAddresses  -  An array of blind carbon copied recipients for this email
 *    emailReplyToAddresses  -  An array of addresses to have the recipient reply to
 *    emailAttachments  -  An array of filenames that were attached to this email
 *    emailHeaders  -  An array of additional headers applied to this email
 *	  dateCreated  -  The timestamp representing when this queue item was created
 *	  dateSent  -  The timestamp representing when this queue item was sent, this is 0 if this item was never sent
 *
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *  $sid					The current sessionID
 *
 * Author: Vic Fryzel
 *}{strip}


{assign var="filterArgs" value="emailActive=$emailActive"}
{/strip}
{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_EMAILS', 'TRANS_SHOW_EMAILS', '');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EMAILS"
	childName="TRANS_SHOW_EMAILS"
	sideNavMajor="events"
	sideNavMinor="emails"}
{if $smarty.request.successRemove == 1}
	{include
		file="$tplDirectory/widgets/showInvalidCustom.tpl"
		message=$smarty.const.TRANS_EMAILS_SUCCESSFULLY_REMOVED}
{/if}
<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr>
	<td colspan="8" onmouseover="this.style.cursor='hand'" onclick="{strip} {section name=iter loop=$emails}
		XKtoggle('row_{$emails[iter].emailID}'); {/section} {/strip}return false;"> <a href="javascript:void(0);"><img src="{$imageDirectory}/ico/data_down.gif" width="16" height="16" alt="" title="" border="0" /></a> {"TRANS_ADDITIONAL_DATA"|lmsg}
	</td>
</tr>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderSelectAll.tpl" headerAlign="left" formName="document.captureForm" selectedName="emailIDs" headerClass="firstTD"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_ID" sortColumn="emailID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_FROM" sortColumn="emailFromAddress"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl" headerName="TRANS_SUBJECT" sortColumn="emailSubject"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_CREATED" sortColumn="emailDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl" headerName="TRANS_EMAIL_SENT_ON" sortColumn="emailDateSent"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl" filterName="TRANS_ACTIVE" filterColumn="emailActive" filterOptions="$activeInactive"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" headerName="TRANS_ACTIONS" headerClass="lastTD"}
</tr>
</thead>

<form name="captureForm" action="{getFormAction controller="events"}" method="post">

<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="act" value="{getActionID action="RemoveEmail"}" />

{section name=i loop="$emails"}
{assign var="emailID" value=$emails[i].emailID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>
		<input type="checkbox" name="emailIDs[]" value="{$emailID}" />
	</td>

	<td style="cursor:pointer;" onclick="return XKtoggle('row_{$emailID}');">
		<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
		&nbsp;
		{$emailID}
	</td>
	<td>
		{if ($emails[i].emailFromName)}
			{$emails[i].emailFromName} &lt;{$emails[i].emailFromAddress}&gt;
		{else}
			{$emails[i].emailFromAddress}
		{/if}
		{include file="$tplDirectory/widgets/quickEditLink.tpl"
			editID=$emailID
			editKey="emailID"
			editActionName="EditEmailResponse"
			editName="TRANS_EMAIL"
			editColumn="emailFromAddress"
			editValue=$emails[i].emailFromAddress}
	</td>
	<td>
		{$emails[i].emailSubject|html_entity_encode}
		{include file="$tplDirectory/widgets/quickEditLink.tpl"
			editID=$emailID
			editKey="emailID"
			editActionName="EditEmailResponse"
			editName="TRANS_EMAIL"
			editColumn="emailSubject"
			editValue=$emails[i].emailSubject}
	</td>
	<td>
		{$emails[i].emailDateCreated|getDateTime}
	</td>
	<td>
		{if ($emails[i].emailSent)}
			{$emails[i].emailDateSent|getDateTime}
		{else}
			{assign var="emailSent" value=$emails[i].emailSent}
			{$sentUnsent[$emailSent]}
		{/if}
	</td>
	<td>
		{assign var="emailActive" value=$emails[i].emailActive}
		{$activeInactive[$emailActive]}
	</td>
	<td align="center" nowrap="nowrap">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$emailID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" border="0" alt="{"TRANS_VIEW"|lmsg}" title="{"TRANS_VIEW"|lmsg}" />
		</a>
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$emailID}');">
			{"TRANS_VIEW"|lmsg}
		</a>
		{/strip}
	</td>
</tr>
</tbody>
<tbody id="row_{$emailID}" class="off">
<tr>
	<td colspan="8" class="solid">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$emailID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;
		<strong>{"TRANS_ADDITIONAL_ACTIONS"|lmsg}</strong>
		&nbsp;

		{* RESEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="ResendEmail"
			args="emailID=$emailID"
			icoImage="014.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_RESEND"
			titleText=""
			linkText="TRANS_RESEND"
			noSpace="1"}
		&nbsp;

		{* EDIT AND SEND *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="clients.php"
			actionName="SendClientEmail"
			args="emailID=$emailID"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT_EMAIL"
			titleText=""
			linkText="TRANS_EDIT_EMAIL"
			noSpace="1"}
		&nbsp;

		{* DETAILS *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="ShowEmailDetails"
			args="emailID=$emailID"
			icoImage="view"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_DETAILS"
			titleText=""
			linkText="TRANS_DETAILS"
			noSpace="1"}
		&nbsp;

		{* REMOVE *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="RemoveEmail"
			args="emailID=$emailID"
			icoImage="remove"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_REMOVE"
			titleText=""
			linkText="TRANS_REMOVE"
			noSpace="1"}
		{/strip}
	</td>
</tr>
<tr class="comments">
	<td colspan="8" class="comments altinner">
		<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td vAlign="top">
				<table width="100%" border="0" cellpadding="0" cellspacing="0" class="addData">
				<tr>
					<th colspan="2"><strong>{"TRANS_EMAIL_ADDRESS_DESTINATIONS"|lmsg}</strong></th>
				</tr>
				<tr>
					<td>{"TRANS_TO"|lmsg}</td>
					<td>
						{foreach from=$emails[i].emailToAddresses.0.emailToAddress item=address}
							<strong>{$address.emailAddressName}</strong> {$address.emailAddress}
							&nbsp;
							{include file="$tplDirectory/widgets/actionLink.tpl"
								page="clients.php"
								actionName="EditClientContact"
								args="clientContactID=`$emails[i].clientContactID`"
								icoImage="view"
								icoWidth=""
								icoHeight=""
								icoStyle=""
								altText="TRANS_DETAILS"
								titleText=""
								linkText="TRANS_DETAILS"
								noSpace="1"}
							<br />
						{/foreach}
					</td>
				</tr>
				<tr>
					<td>{"TRANS_CC"|lmsg}</td>
					<td>
						{if $emails[i].emailCCAddresses}
							{foreach from=$emails[i].emailCCAddresses.0.emailCCAddress item=address}
								<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
							{/foreach}
						{else}
							{"TRANS_NONE"|lmsg}
						{/if}
					</td>
				</tr>
				<tr>
					<td>{"TRANS_BCC"|lmsg}</td>
					<td>
						{if $emails[i].emailBCCAddresses}
							{foreach from=$emails[i].emailBCCAddresses.0.emailBCCAddress item=address}
								<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
							{/foreach}
						{else}
							{"TRANS_NONE"|lmsg}
						{/if}
					</td>
				</tr>
				<tr>
					<td>{"TRANS_REPLYTO"|lmsg}</td>
					<td>
						{if $emails[i].emailReplyToAddresses}
							{foreach from=$emails[i].emailReplyToAddresses.0.emailReplyToAddress item=address}
								<strong>{$address.emailAddressName}</strong> {$address.emailAddress}<br />
							{/foreach}
						{else}
							{"TRANS_NONE"|lmsg}
						{/if}
					</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</td>
</tr>

</tbody>
<script type="text/JavaScript">XKtoggleOff('row_{$emailID}');</script>
{sectionelse}
<tr class="alt1">
	<td colspan="8">{"TRANS_NORESULTS"|lmsg}</td>
</tr>
{/section}
<tbody>
<tr class="listButtons">
	<td colspan="8"><div>
		<input class="submit" type="submit" value="{"TRANS_PURGE_EMAILS"|lmsg}" />
	</div></td>
</tr>
</tbody>
</form>
</table>


{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
