{* $Id: ShowEvents.tpl 11979 2007-09-26 17:41:31Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of all events in the system queue. From this template, a user should be able to
 * display, edit, delete, and run or stop events in the system queue.
 *
 * Smarty Variables:
 *  $events  -  An array of events that match input criteria. Every item in this array is an array representing an event,
 *              structure as follows:
 *    systemQueueID  -  The ID of this system queue event.
 *    systemQueueCommand  -  The MBAPI command that this system queue event will be executing.
 *    systemQueueCommandInput  -  The full XML input for the MBAPI command to be run.
 *
 *    (The following parameters only affect recurring items in the queue.)
 *    systemQueueMinute  -  The frequency of minutes with which to run this event (5 would be every 5 minutes)
 *    systemQueueHour  -  The frequency of hours with which to run this event (7 would be every 7 hours)
 *    systemQueueDay  -  The frequency of days with which to run this event (170 would be every 170 days)
 *    systemQueueMonth  -  The frequency of months with which to run this event
 *    systemQueueYear  -  The frequency of years with which to run this event
 *
 *    isRecurring  -  1 if this event is recurring, or 0 if otherwise
 *    dateCreated  -  The UNIX timestamp for which this event was created
 *    dateStarted  -  The UNIX timestamp for which this event was started
 *    dateFinished  -  The UNIX timestamp for which this event was finished
 *
 *
 *  $actionID  -  The unique action ID for this page view
 *  $actionName  -  The action name for this action ID
 *  $imageDirectory  -  The image directory for this theme
 *  $tplDirectory  -  The template directory for this theme
 *  $sid  -  The current sessionID
 *
 *}

{assign var="showEventStatusBar" value="1"}
{assign var="filterArgs" value="isActive=$isActive&systemQueueStatus=`$smarty.request.systemQueueStatus`$systemQueueStatus$systemQueueIDsArgs"}

{php}$GLOBALS['__pagePath'] = array('TRANS_SHOW_EVENTS', '');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_EVENTS"
	childName="TRANS_SHOW_EVENTS"
	sideNavMajor="events"
	sideNavMinor="events"
	includeAjaxJS=1}

<script type="text/javascript" language="javascript" charset="utf-8">
// <![CDATA[
	var cp = new cpaint();
	var QID = "";
	cp.set_transfer_mode('get');
	cp.set_response_type('text');
	cp.set_use_cpaint_api(false);

	{literal}
	function parseSystemEventInput(id) {
		QID = id;
        document.getElementById("parseSystemEventOutput_"+QID).innerHTML = "<br /><br /><center><img src=\"{/literal}{$imageDirectory}{literal}/loading2.gif\" /></center>";
		cp.call('{/literal}{getBaseUrl page="events.php" actionName="ShowEventInputDetails"}&systemQueueID='+ id +'&ajax=1&sid={$sid}{literal}', 'parseSystemEventInput', parseSystemEventInputResponse);
		return false;
	}
	function parseSystemEventInputResponse(result) {
		if (result) {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = result;
		} else {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = {/literal}"unable to parse command"{literal};
		}
	}
	function parseSystemEventOutput(id) {
		QID = id;
        document.getElementById("parseSystemEventOutput_"+QID).innerHTML = "<br /><br /><center><img src=\"{/literal}{$imageDirectory}{literal}/loading2.gif\" /></center>";
		cp.call('{/literal}{getBaseUrl page="events.php" actionName="ShowEventOutputDetails"}&systemQueueID='+ id +'&ajax=1&sid={$sid}{literal}', 'parseSystemEventOutput', parseSystemEventOutputResponse);
		return false;
	}
	function parseSystemEventOutputResponse(result) {
		if (result) {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = result;
		} else {
			document.getElementById("parseSystemEventOutput_"+QID).innerHTML = {/literal}"unable to parse logs"{literal};
		}
	}


	function warnClear(url, encodedParameters){
		var targetUrl = url + (encodedParameters ? '&' + encodedParameters : '');
		{/literal}
		{if $systemQueue.systemQueueRunning && $systemQueue.systemQueueStop!=1}
		if (confirm("{"TRANS_WARN_SYSTEM_QUEUE_CLEAR"|lmsg|escape:javascript}")) document.location.href = targetUrl;
		{else}
		document.location.href = targetUrl;
		{/if}
		{literal}
	}

	{/literal}
// ]]>
</script>
<table class="list"><tbody>
<tr><td>{"TRANS_EVENTS_SHOW_DESC"|lmsg}</td></tr>
</tbody></table>

<div class="actions-box">
	<div class="objects-toolbar">
		<a href="{getHREF page='events.php' actionName='RunEvents'}" class="s-btn" id="bid-run-events">
			<i><i><i><span>{'TRANS_RUN_EVENTS'|lmsg}</span></i></i></i>
		</a>
	</div>
</div>

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="listRowNoBorders">
	<td colspan="4" style="text-align:left;">
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$events}
			XKtoggle('row_{$events[iter].systemQueueID}');
		{/section}
		{/strip}return false;">
			<img src="{$imageDirectory}/ico/up_down.gif" width="16" height="16" alt="" title="" border="0" />
		</a>
		<a href="javascript:void(0);" onclick="{strip}
		{section name=iter loop=$events}
			XKtoggle('row_{$events[iter].systemQueueID}');
		{/section}
		{/strip}return false;">
			{"TRANS_ADDITIONAL_DATA"|lmsg}
		</a>
	</td>
	<td colspan="4" style="text-align:right;color:#666666;">
		{include file="$tplDirectory/widgets/context/sortedBy.tpl"}
	</td>
</tr>
<tr class="headerRow">
	{include
		file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerClass="firstTD"
		headerName="TRANS_ID"
		sortColumn="systemQueueID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerName="TRANS_EVENTS_MODULE_HEADER"
		sortColumn="configGroupID"}
	{include file="$tplDirectory/widgets/table/listHeaderSort.tpl"
		headerName="TRANS_EVENTS_COMMAND_HEADER"
		sortColumn="systemQueueCommand"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_EVENTS_CREATED_HEADER"
		sortColumn="systemQueueDateCreated"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_EVENTS_NEXT_RUN_HEADER"
		sortColumn="systemQueueDateToRun"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_EVENTS_LAST_RUN_START_HEADER"
		sortColumn="systemQueueDateStarted"}
	{include file="$tplDirectory/widgets/table/listHeaderSortDate.tpl"
		headerName="TRANS_EVENTS_LAST_RUN_FINISH_HEADER"
		sortColumn="systemQueueDateFinished"}
	{include file="$tplDirectory/widgets/table/listHeaderFilter.tpl"
		filterName="TRANS_STATUS"
		filterColumn="systemQueueStatus"
		filterOptions="$statuses"
		suppressFilterName=1
		mergeFilterName=1}
<!--
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl"
		headerClass="lastTD"
		headerName="TRANS_ACTIONS"}
-->
</tr>
</thead>
{section name=i loop="$events"}
{assign var="systemQueueID" value=$events[i].systemQueueID}
{if $className=="alt1"}
    {assign var="className" value="alt2"}
{else}
    {assign var="className" value="alt1"}
{/if}
<tbody>
<tr class="{cycle values="alt1,alt2"}">
	<td>
		<table border="0" cellpadding="0" cellspacing="0">
		<tr class="listRowNoBorders">
			<td>
				<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
        			<img src="{$imageDirectory}/ico/arrow_down_blue.gif" width="16" height="16" alt="" title="" border="0" />
				</a>
			</td>
			<td>{$systemQueueID}</td>
		</tr>
		</table>
	</td>

	<td>
		{if $events[i].configGroupID}
			{assign var=configGroupID value=$events[i].configGroupID}
			{if $panels.$configGroupID}
				<a href="{getHREF page="modules.php" actionName="EditPanelConfig" args="configGroupID=$configGroupID"}">{$panels.$configGroupID}</a>
				{if $events[i].serverGroupID}
					{assign var=serverGroupID value=$events[i].serverGroupID}
					{"TRANS_IN_GROUP"|lmsg} <a href="{getHREF page="servergroups.php" actionName="EditServerGroup" args="serverGroupID=$serverGroupID"}">{$serverGroupList.$serverGroupID}</a>

				{/if}
			{elseif $registrars.$configGroupID}
				<a href="{getHREF page="modules.php" actionName="EditDomainRegistrar" args="configGroupID=$configGroupID"}">{$registrars.$configGroupID}</a>
			{/if}
			{elseif $events[i].serverGroupID}
				{assign var=serverGroupID value=$events[i].serverGroupID}
				{if $serverGroupList.$serverGroupID}
					{$serverGroupList.$serverGroupID}
				{/if}
		{/if}
	</td>
	<td>
		{$events[i].systemQueueCommand}
		{if $events[i].packageID}
			{assign var=packageID value=$events[i].packageID}
			{"TRANS_OF_PACKAGE"|lmsg} <a href="{getHREF page="packages.php" actionName="ShowPackageDetails" args="packageID=$packageID"}">{$packageID}</a>
		{/if}
	</td>
	<td>
		{$events[i].systemQueueDateCreated|getDateTime:full}
	</td>
	<td>
		{$events[i].systemQueueDateToRun|getDateTime:full}
		{include
			file="$tplDirectory/widgets/quickEditDateLink.tpl"
			editID=$systemQueueID
			editKey="systemQueueID"
			editActionName="EditEventResponse"
			editName="TRANS_RUN"
			editColumn="systemQueueDateToRun"
			editValue=$events[i].systemQueueDateToRun
			showHourMin=1
			icoFile="ico/quickedit.gif"}
	</td>
	<td>
		{if $events[i].systemQueueIsRecurring}
			--
		{else}
			{$events[i].systemQueueDateStarted|getDateTime:full}
		{/if}
	</td>
	<td>
		{if $events[i].systemQueueIsRecurring}
			--
		{else}
			{$events[i].systemQueueDateFinished|getDateTime:full}
		{/if}
		{if $events[i].systemQueueDateFinished}
		&nbsp;
		<a href="{getHREF page="events.php" actionName="EditEventResponse" args="systemQueueID=$systemQueueID&systemQueueDateFinished=0"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{"TRANS_RERUN"|lmsg}" title="{"TRANS_RERUN"|lmsg}" />
		</a>
		{/if}
	</td>
	<td>
		{$events[i].systemQueueStatus|getArrayValueByID:$statuses} {$events[i].systemQueueStatusReason}
	</td>
<!--
	<td align="center" nowrap="nowrap">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" border="0" alt="{"TRANS_VIEW"|lmsg}" title="{"TRANS_VIEW"|lmsg}" />
		</a>
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			{"TRANS_VIEW"|lmsg}
		</a>

		{/strip}
	</td>
-->
</tr>
</tbody>
<tbody id="row_{$systemQueueID}" class="off">
<tr>
	<td colspan="8" class="comments altinner">
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$systemQueueID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;

		<strong>{"TRANS_ACTIONS"|lmsg}</strong>
		&nbsp;

		{strip}
		{* RUN NOW *}
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1"}', '{$redirectArgs|urlencode}');">
			<img src="{$imageDirectory}/ico/run.gif" width="16" height="16" border="0" alt="{"TRANS_EVENT_RUN_NEXT_TIME"|lmsg}" title="{"TRANS_EVENT_RUN_NEXT_TIME"|lmsg}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1"}', '{$redirectArgs|urlencode}');">
			{"TRANS_EVENT_RUN_NEXT_TIME"|lmsg}
		</a>
		&nbsp;

		{* FORCE RUN NOW *}
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&forceRun=1"}', '{$redirectArgs|urlencode}');">
			<img src="{$imageDirectory}/ico/run.gif" width="16" height="16" border="0" alt="{"TRANS_EVENT_RUN_NOW"|lmsg}" title="{"TRANS_EVENT_RUN_NOW"|lmsg}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:warnClear('{getHREF page="events.php" actionName="RunEvents" args="systemQueueID=$systemQueueID&forceClear=1&forceRun=1"}', '{$redirectArgs|urlencode}');">
			{"TRANS_EVENT_RUN_NOW"|lmsg}
		</a>
		&nbsp;

		{* EDIT *}
	    {include file="$tplDirectory/widgets/actionLink.tpl"
			page="events.php"
			actionName="EditEvent"
			args="systemQueueID=$systemQueueID"
			icoImage="edit"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_EDIT"
			titleText=""
			linkText="TRANS_EDIT"
			noSpace="1"
		}
		&nbsp;

		{* DELETE *}
		{if !$events[i].systemQueueIsRecurring}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="events.php"
				actionName="RemoveEvent"
				args="systemQueueID=$systemQueueID"
				icoImage="remove"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_DELETE"
				titleText=""
				linkText="TRANS_DELETE"
				noSpace="1"
			}
			&nbsp;&nbsp;
		{/if}

		{* DEBUG VIEW COMMAND INPUT *}
		<a href="javascript:void(0);" onclick="parseSystemEventInput({$events[i].systemQueueID});">
			<img src="{$imageDirectory}/ico/debug_view.gif" width="16" height="16" border="0" alt="{"TRANS_RUN"|lmsg}" title="{"TRANS_RUN"|lmsg}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:void(0);" onclick="parseSystemEventInput({$events[i].systemQueueID});">
			{"TRANS_MBAPI_COMMAND_INPUT"|lmsg}
		</a>
		&nbsp;&nbsp;

		{* DEBUG VIEW COMMAND OUTPUT *}
		<a href="javascript:void(0);" onclick="parseSystemEventOutput({$events[i].systemQueueID});">
			<img src="{$imageDirectory}/ico/debug_view.gif" width="16" height="16" border="0" alt="{"TRANS_RUN"|lmsg}" title="{"TRANS_RUN"|lmsg}" style="margin-right: 4px;" />
		</a>
		<a href="javascript:void(0);" onclick="parseSystemEventOutput({$events[i].systemQueueID});">
			{"TRANS_MBAPI_COMMAND_OUTPUT"|lmsg}
		</a>
		&nbsp;&nbsp;

		{if $allowDebugLogging}
			{* RUN IN DEBUG MODE *}
			<a href="{getHREF page="events.php" actionName="RunDebugEvent" args="systemQueueID=$systemQueueID"}" target="_blank">
				<img src="{$imageDirectory}/ico/debug_run.gif" width="16" height="16" border="0" alt="{"TRANS_RUN"|lmsg}" title="{"TRANS_RUN"|lmsg}" style="margin-right: 4px;" />
			</a>
			<a href="{getHREF page="events.php" actionName="RunDebugEvent" args="systemQueueID=$systemQueueID"}" target="_blank">
				{"TRANS_RUN_EVENT_WITH_DEBUG"|lmsg}
			</a>
			&nbsp;
		{/if}

		{/strip}
	</td>
</tr>
<tr class="comments">
	<td colspan="8" class="comments altinner">
		<div id="parseSystemEventOutput_{$events[i].systemQueueID}"></div>
	</td>
</tr>
</tbody>
{sectionelse}
<tr class="alt1">
	<td colspan="8">{"TRANS_NORESULTS"|lmsg}</td>
</tr>
{/section}
</table>

{include file="$tplDirectory/widgets/paginationLinks.tpl"}
{include file="$tplDirectory/footer.tpl"}
