{* $Id: ShowTodoDetails.tpl 12148 2007-10-29 16:40:28Z kbailey $
 * --------------------------------------------------------------
 * This template displays a single to-do item's details in a readable manner. This template 
 * will eventually display more information about a to-do item than the ShowTodos action; but 
 * for now the same amount of data is shown in both templates.
 *
 * Smarty Variables:
 *	$todo -- an array data about the given to-do item
 *	         That information is structured as follows:
 *	           todoID --  The ID of the to-do item
 *	           todoTitle -- The title of the todo
 *	           todoDesc -- A longer description of the todo item. This may include links to other actions.
 *	           adminID -- The ID of the admin who created the to-do item, or was assigned to
 *	           adminData -- An array of data about the administrator who created this todo
 *	                        The array is of the form:
 *	                          adminID -- The ID of the admin
 *	                          adminUsername -- The username of the admin
 *	                          adminFirstName -- The first name of the admin
 *	                          adminLastName -- The last name of the admin
 *	           todoDateCreated -- The UNIX timestamp of when this to-do item was created
 *	           todoDue -- The UNIX timestamp of when this to-do item is due
 *	           todoStatusID -- The integer ID of the status that is associated with this to-do item
 *}


{php}$GLOBALS['__pagePath'] = array('TRANS_MANAGE_TODOS', 'TRANS_TODO_DETAILS', '');{/php}
{include
	file="$tplDirectory/header.tpl"
	parentName="TRANS_MANAGE_TODOS"
	childName="TRANS_TODO_DETAILS"
	sideNavMajor="events"
	sideNavMinor="todos"}

{assign var=todoID value=$todo.todoID}
<fieldset>
<legend>{"TRANS_TODOS"|lmsg}</legend>

<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tbody>
<tr>
	<td class="title"><label for="todoTitle">{"TRANS_TITLE"|lmsg}</label></td>
	<td>{$todo.todoTitle|constant}</td>
</tr>
<tr>
	<td class="title"><label for="todoDesc">{"TRANS_DESCRIPTION"|lmsg}</label></td>
	<td>{$todo.todoDesc|nl2br|constant}
	{if $todo.todoLinkFile}
		{assign var=todoLinkFile value=$todo.todoLinkFile}
		{assign var=todoLinkActionName value=$todo.todoLinkActionName}
		{assign var=todoLinkPk value=$todo.todoLinkPk}
		{assign var=todoLinkName value=$todo.todoLinkName}
		<a href="{getHREF page="$todoLinkFile" actionName="$todoLinkActionName" args="$todoLinkName=$todoLinkPk"}">
			<img src="{$imageDirectory}/ico/data_edit.gif" width="16" height="16" border="0" alt="{"TRANS_EDIT"|lmsg}" title="{"TRANS_EDIT"|lmsg}" />
		</a>
	{/if}
	</td>
</tr>
<tr>
	<td class="title"><label for="todoAdminID">{"TRANS_AUTHOR"|lmsg}</label></td>
	<td>{$todo.admins.0.adminFirstName} {$todo.admins.0.adminLastName}</td>
</tr>
<tr>
	<td class="title"><label for="todoAdmin">{"TRANS_ASSIGNED_ADMINS"|lmsg}</label></td>
	<td>{if $todo.assigned.0}{$todo.assigned.0.adminFirstName} {$todo.assigned.0.adminLastName} - {$todo.assigned.0.adminUsername}{/if}</td>
</tr>
<tr>
	<td class="title"><label for="todoStatusID">{"TRANS_STATUS"|lmsg}</label></td>
	<td>{$todo.todoStatusID|getArrayValueByID:$todostatus}</td>
</tr>
<tr>
	<td class="title"><label for="todoDateDue">{"TRANS_DATE_DUE"|lmsg}</label></td>
	<td>{$todo.todoDateDue|getDate:medium}</td>
</tr>
<tr>
	<td class="title"><label for="todoDateDue">{"TRANS_DATE_CREATED"|lmsg}</label></td>
	<td>{$todo.todoDateCreated|getDate:medium}</td>
</tr>
<tr class="listButtons">
	<td colspan="2"><div><input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="EditTodo" args="todoID=$todoID"}';" value="{"TRANS_EDIT"|lmsg}" />  <input class="submit" type="button" onClick="document.location.href='{getHREF page="todos.php" actionName="RemoveTodo" args="todoID=$todoID"}';" value="{"TRANS_DELETE"|lmsg}" /></span></div></td>
</tr>
</tbody>
</table>
</fieldset>
{include file="$tplDirectory/footer.tpl"}
