{* $Id: comboBox.tpl 9754 2006-10-23 14:31:34Z bsmith $
 * --------------------------------------------------------------
 * This widget template builds the combo select boxes which allows you to push/pull
 * select options from the left/right box to the right/left box.
 *
 * Smarty Variables:
 *	$comboTitleLeft		The title of the left combat box
 *	$comboNameLeft  	The name of the left select list
 *	$comboOptionsLeft	The left select option values
 *	$comboTitleRight	The title of the right combat box
 *	$comboNameRight  	The name of the right select list
 *	$comboOptionsRight	The right select option values
 *	$useOptionValues	Flag to use the option values instead of the option keys.
 *	$formName			The name of the combo form button
 *	$submitName			The name of the submit button
 *  $positionButtons    Flag to display position buttons or not.
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/comboBox.tpl" }
 *}
{if !$comboWidth}
	{assign var="comboWidth" value="150"}
{/if}

<table cellpadding="0" cellspacing="0">
<tr>
	<td valign="top" align="center">
		<strong>{strip}
			{if $smarty.const.$comboTitleRight}
				{translate key=$comboTitleRight}
			{else}
				{"TRANS_UNSELECTED"|lmsg}
			{/if}
		{/strip}</strong>
		<br />
		<select multiple="multiple" size="10" name="{$comboNameRight}[]" style="width:{$comboWidth}px;" ondblclick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);">
			{if $useOptionValues}
				{foreach from=$comboOptionsRight item=actionName}
					<option label="{$actionName}" value="{$actionName}">{$actionName}</option>
				{/foreach}
			{else}
				{html_options options=$comboOptionsRight}
			{/if}
		</select>
		<br />
		<input class="button" type="button" onclick="moveAllOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&gt;&gt;" id="{$comboNameRight}_moveAllButton"/>
		&nbsp;
		<input class="button" type="button" onclick="moveSelectedOptions(this.form.elements['{$comboNameRight}[]'],this.form.elements['{$comboNameLeft}[]']);" value="&gt;" id="{$comboNameRight}_moveSelectedButton"/>
	</td>
    {if $positionButtons=="yes"}
    <td valign="middle" align="center"><br /><br /><br /><br />
        <input class="button" type="button" onclick="XKmoveUp(this.form.elements['{$comboNameLeft}[]'])" value=" &uarr; " id="{$comboNameLeft}_moveUpButton"/><br />
        <input class="button" type="button" onclick="XKmoveDown(this.form.elements['{$comboNameLeft}[]'])" value=" &darr; " id="{$comboNameLeft}_moveDownButton"/><br />
    </td>
    {/if}
	<td valign="top" align="center">
		<strong>{strip}
			{if $smarty.const.$comboTitleLeft}
				{translate key=$comboTitleLeft}
			{else}
				{"TRANS_SELECTED"|lmsg}
			{/if}
		{/strip}</strong>
		<br />
	    <select multiple="multiple" size="10" name="{$comboNameLeft}[]" style="width:{$comboWidth}px;" ondblclick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);">
			{if $useOptionValues}
				{foreach from=$comboOptionsLeft item=actionName}
					<option label="{$actionName}" value="{$actionName}">{$actionName}</option>
				{/foreach}
			{else}
				{html_options options=$comboOptionsLeft}
			{/if}
		</select>
		<br />
		<input class="button" type="button" onclick="moveSelectedOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&lt;" id="{$comboNameLeft}_moveSelectedButton" />
		&nbsp;
		<input class="button" type="button" onclick="moveAllOptions(this.form.elements['{$comboNameLeft}[]'],this.form.elements['{$comboNameRight}[]']);" value="&lt;&lt;" id="{$comboNameLeft}_moveAllButton"/>
	</td>
</tr>
{if $submitName != "suppress"}
	<tr>
		<td colspan="2" align="center">
			<input class="submit" type="submit" name="submit" value="{$smarty.const.$submitName}" onclick="selectAllOptions(this.form.elements['{$comboNameLeft}[]']);" />
		</td>
	</tr>
{/if}
</table>
