{* $Id: package.tpl 12525 2008-01-18 23:27:22Z btyra $
 * --------------------------------------------------------------
 * This widget template is used to display the client context bar.
 *
 * Smarty Variables:
 *	$client		array of client information
 * $contact		array of contact information
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/context/package.tpl" package=$package types=$types activeInactive=$activeInactive}
 *}


{assign var="packageID" value=$package.packageID}
{assign var="thisType" value=$package.packageType}

{if "products"|getTypeID:"hosting" == $thisType}
	{assign var="showDomain" value=true}
{else}
	{assign var="showDomain" value=false}
{/if}

<table width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<thead>
<tr class="headerRow">
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="10%" headerClass="firstTD" headerName="TRANS_PACKAGE_ID"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PACKAGE"}
	{if $showDomain}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_ASSOCIATED_DOMAIN"}
	{else}
		{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PRODUCT_TYPE"}
	{/if}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="25%" headerName="TRANS_PACKAGE_STATUS"}
	{include file="$tplDirectory/widgets/table/listHeaderText.tpl" colWidth="15%" headerClass="lastTD" headerName="TRANS_ACTIONS"}
</tr>
<tr class="althover">
	<td class="listRowFirstTD">
		<strong>
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="ShowPackageDetails"
				args="packageID=$packageID"
				altText=$packageID
				linkText=$packageID
			}
		</strong>
	</td>
	<td>
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="products.php"
			actionName="ShowProductDetails"
			args="productID=`$package.productID`"
			productID=$package.productID
			altText=$package.packageName
			linkText=$package.packageName
		}
		{if $showDomain}
			<br />
			({$types.$thisType})
		{/if}
	</td>
	<td>
		{if $showDomain}
			{if count($package.domains)}
				{section name=i loop=$package.domains}
			 		{$package.domains[i].domainSLD}.{$package.domains[i].domainTLD}<br />
				{/section}
			{/if}
		{else}
			{$types.$thisType}
		{/if}
	</td>
	<td>{assign var="thisStatus" value=$package.packageStatus} {$thisStatus|getStatusName:"package"}</td>
	<td>
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			<img src="{$imageDirectory}/ico/more.gif" width="16" height="16" border="0" alt="{"TRANS_VIEW"|lmsg}" title="{"TRANS_VIEW"|lmsg}" />
		</a>
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			{"TRANS_VIEW"|lmsg}
		</a>
		{/strip}
	</td>
</tr>
<tbody id="row_{$packageID}"{if $showActions==1}{assign var="showAction" value=0}{else} class="off"{/if}>
<tr>
	<td colspan="5" class="comments altinner">
		{strip}
		<a href="javascript:void(0);" onclick="return XKtoggle('row_{$packageID}');">
			<img src="{$imageDirectory}/ico/arrow_up_blue.gif" width="16" height="16" alt="" title="" border="0" align="left" />
		</a>
		&nbsp;

		<strong>{"TRANS_ACTIONS"|lmsg}</strong>
		&nbsp;

		{* DETAILS *}
		{if !$suppressDetailsLink}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="ShowPackageDetails"
				args="packageID=$packageID"
				icoImage="view"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_DETAILS"
				titleText=""
				linkText="TRANS_DETAILS"
				noSpace="1"
				suppressActionMenu=1
			}
			&nbsp;
		{/if}
		
		{if !$suppressEditLink}
			{include file="$tplDirectory/widgets/actionLink.tpl"
				page="packages.php"
				actionName="EditPackage"
				args="packageID=$packageID"
				icoImage="edit"
				icoWidth=""
				icoHeight=""
				icoStyle=""
				altText="TRANS_EDIT"
				titleText=""
				linkText="TRANS_EDIT"
				noSpace="1"
			}
			&nbsp;
		{/if}

		{* UPGRADE *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="UpgradePackage"
			args="packageID=$packageID"
			icoImage="upgrade.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_UPGRADE"
			titleText=""
			linkText="TRANS_UPGRADE"
			noSpace="1"
		}
		&nbsp;

		{* DOWNGRADE *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="DowngradePackage"
			args="packageID=$packageID"
			icoImage="downgrade.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_DOWNGRADE"
			titleText=""
			linkText="TRANS_DOWNGRADE"
			noSpace="1"
		}
		&nbsp;

		{* ATTRIBUTES *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ShowPackageAttributes"
			args="packageID=$packageID"
			icoImage="cube_molecule.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_ATTRIBUTES"
			titleText=""
			linkText="TRANS_ATTRIBUTES"
			noSpace="1"
		}
		&nbsp;

		{* ADDONS *}
		{include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ShowPackageAddons"
			args="packageID=$packageID"
			icoImage="cubes_other.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_ADDONS"
			titleText=""
			linkText="TRANS_ADDONS"
			noSpace="1"
		}
		&nbsp;
		
		{* MOVE PACKAGE *}
		<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
			&lt;form method=\'post\' action=\'{getFormAction controller="packages"}\'&gt;
			&lt;input type=\'hidden\' name=\'act\' value=\'{getActionID action="ChangePackageClient"}\' /&gt;
			&lt;input type=\'hidden\' name=\'packageID\' value=\'{$packageID}\' /&gt;
			&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
			{"TRANS_CLIENT_ID"|lmsg}&nbsp;&lt;input type=\'text\' name=\'clientID\' value=\'\' onClick=\'javascript:this.form.editValue.focus();this.form.editValue.select();\' /&gt;
			&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_TRANSFER"|lmsg}\' /&gt;
			&lt;/form&gt;&lt;/div&gt;',
			BGCLASS, 'popupBG',
			FGCLASS, 'popupFG',
			CAPTIONFONTCLASS, 'popupCaption',
			CENTER, STICKY,
			CAPTION, '{"TRANS_TRANSFER_PACKAGE"|lmsg} {$packageID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
			<img src="{$imageDirectory}/ico/arrow_right_blue.gif" alt="{"TRANS_MOVE"|lmsg}" title="{"TRANS_MOVE"|lmsg}" />
		</a>
		&nbsp;
		<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
			&lt;form method=\'post\' action=\'{getFormAction controller="packages"}\'&gt;
			&lt;input type=\'hidden\' name=\'act\' value=\'{getActionID action="ChangePackageClient"}\' /&gt;
			&lt;input type=\'hidden\' name=\'packageID\' value=\'{$packageID}\' /&gt;
			&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
			{"TRANS_CLIENT_ID"|lmsg}&nbsp;&lt;input type=\'text\' name=\'clientID\' value=\'\' onClick=\'javascript:this.form.editValue.focus();this.form.editValue.select();\' /&gt;
			&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_TRANSFER"|lmsg}\' /&gt;
			&lt;/form&gt;&lt;/div&gt;',
			BGCLASS, 'popupBG',
			FGCLASS, 'popupFG',
			CAPTIONFONTCLASS, 'popupCaption',
			CENTER, STICKY,
			CAPTION, '{"TRANS_TRANSFER_PACKAGE"|lmsg} {$packageID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
			{"TRANS_TRANSFER"|lmsg}
		</a>
		

		&nbsp;

		{* CYCLE CHANGE *}
		{* include file="$tplDirectory/widgets/actionLink.tpl"
			page="packages.php"
			actionName="ChangePackageCycle"
			args="packageID=$packageID"
			icoImage="cubes_other.gif"
			icoWidth=""
			icoHeight=""
			icoStyle=""
			altText="TRANS_CHANGE_CYCLE"
			titleText=""
			linkText="TRANS_CHANGE_CYCLE"
			noSpace="1"
		*}
		&nbsp;

		

	{/strip}
	</td>
</tr>
</table>

<br />
