{* $Id: EditDetails.tpl 12446 2008-01-10 17:27:44Z kbailey $
 * --------------------------------------------------------------
 * This template displays a form to edit a Product.
 *
 * Smarty Variables:
 *	n/a
 *
 *}

{include file="$tplDirectory/widgets/products/header.tpl"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}

<form method="post" action="{getFormAction controller="products"}" onsubmit="XKselectAllOptionsInMultiSelects(this);">
<input type="hidden" name="sid" value="{$sid}" />
<input type="hidden" name="act" value="{getActionID action="EditProductResponse"}" />
<input type="hidden" name="productID" value="{$product.productID}">

<br />

{********* TRANS_PRODUCT_DISPLAY_INFORMATION *********}
<fieldset>
<legend><strong>{"TRANS_DISPLAY_INFORMATION"|lmsg}</strong></legend>
<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td class="title">{"TRANS_PRODUCT_NAME_OPTION"|lmsg}</td>
		<td>
			<input type="text" name="productName" style="width: 50%;" value="{$product.productName|escape:html}">
			<div class="hint">{"TRANS_PRODUCT_NAME_COMMENT"|lmsg}</div>
		</td>
	</tr>

	<tr>
		<td class="title">{"TRANS_PRODUCT_DESCRIPTION_OPTION"|lmsg}</td>
		<td>
			<input type="text" name="productComments" style="width: 50%;" value="{$product.productComments|escape:html}">
			<div class="hint">{"TRANS_PRODUCT_DESCRIPTION_COMMENT"|lmsg}</div>
		</td>
	</tr>

{if $product.productAddonGroupID<1}
	<tr>
		<td class="title">{"TRANS_ADDON_OPTION_OPTION"|lmsg}</td>
		<td>
		{if $product.productType|getAPITypeName:"products" != "ssl-cert"}
			<select name="productAddonRequired">
				{html_options options=$productdependencyrules selected=$product.productAddonRequired}
			</select>
			<div class="hint">{"TRANS_ADDON_OPTION_COMMENT"|lmsg}</div>
		{else}
			{assign var="key" value=$product.productAddonRequired}
			<input name="productAddonRequired" type="hidden" value="{$product.productAddonRequired}">{$productdependencyrules.$key}
		{/if}
		</td>
	</tr>
	<tr>
		<td class="title">{"TRANS_DOMAIN_OPTION"|lmsg}</td>
		<td>
		{if $product.productType|getAPITypeName:"products" != "ssl-cert"}
			<select name="productDomainRequired">
				{html_options options=$productdependencyrules selected=$product.productDomainRequired}
			</select>
			<div class="hint">{"TRANS_DOMAIN_OPTION_COMMENT"|lmsg}</div>
		{else}
			{assign var="key" value=$product.productDomainRequired}
			<input name="productDomainRequired" type="hidden" value="{$product.productDomainRequired}">{$productdependencyrules.$key}
		{/if}
		</td>
	</tr>
{/if}

{if 0 != $product.productAddonGroupID}
	<tr>
		<td class="title">{"TRANS_ADDON_QUESTIONOROPTION_OPTION"|lmsg}</td>
		<td>
			<select name="addonAttribute">
				<option value="-1"></option>
				{if $selectedAttribute!=""}
					<option value="0" selected="selected">{$chooseAttributes.$selectedAttribute}</option>
				{/if}
				{html_options options=$chooseAttributes}
			</select>
			<div class="hint">{"TRANS_ONLY_USED_FOR_ADDON_PURPOSES"|lmsg}</div>
		</td>
	</tr>
{/if}
</table>
</fieldset>
<br />
{********* TRANS_INTERNAL_VALUES *********}
<fieldset>
<legend><strong>{"TRANS_INTERNAL_SETTINGS"|lmsg}</strong></legend>
<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td class="title">{"TRANS_IS_ACTIVE_OPTION"|lmsg}</td>
		<td>
			<select name="productActive">{html_options options=$yesNo selected=$product.productActive}</select>
			<div class="hint">{"TRANS_IS_ACTIVE_OPTION_DESC"|lmsg}</div>
		</td>
	</tr>

	<tr class="nowrap">
		<td class="title">{"TRANS_PRODUCT_TYPE"|lmsg}</td>
		<td>
			{if 0 != $product.productAddonGroupID}
				<strong>{"TRANS_PRODUCT_ADDON_CHOICE"|lmsg}</strong><br/>
			{else}
				<strong>{$productTypes[$product.productType]}</strong>
			{/if}
		 </td>
	</tr>
		{if 0 != $product.productAddonGroupID || "ssl-cert" == $product.productType|getAPITypeName:"products"}
			<tr>
				<td class="title">{"TRANS_ADDON_NAME_OPTION"|lmsg}</td>
				<td>
					<select name="productAddonGroupID">{html_options options=$chooseGroups selected=$product.productAddonGroupID}</select>
				</td>
			</tr>
		{/if}
	<tr>
		<td class="title">{"TRANS_DATE_CREATED"|lmsg}</td>
		<td>{$product.productDateCreated|getDateTime:"long"}</td>
	</tr>
</table>
</fieldset>
<br />
{********* TRANS_BILLING_OPTIONS_AND_SETTINGS *********}
<fieldset>
<legend><strong>{"TRANS_BILLING_OPTIONS_AND_SETTINGS"|lmsg}</strong></legend>
<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	{if $product.productType|getAPITypeName:"products" != "domain" && $product.productType|getAPITypeName:"products" != "cert"}
		<tr>
			<td class="title">{"TRANS_PRODUCT_PRICE_GROUP_OPTION"|lmsg}</td>
			<td>
				<select name="productVariableID">
					<option value="0">{"TRANS_PRODUCT_PRICE_GROUP_DEFAULT"|lmsg}</option>
					{html_options options=$productVariables selected=$product.productVariableID}
				</select>
				<div class="hint">{"TRANS_PRICING_COMMENT"|lmsg}</div>
			</td>
		</tr>
	{/if}

{if $product.productType|getAPITypeName:"products" != "nonrecurring"}
		<tr>
			<td class="title">{"TRANS_BILLING_DURATION"|lmsg}</td>
			<td>
				<select name="billingPlan">{html_options options=$billingPlans selected=$billingPlan}</select>
				<div class="hint">{"TRANS_BILLING_DURATION_COMMENT"|lmsg}</div>
			</td>
		</tr>

	{if $billingPlan == 3}
		<tr>
			<td class="title">{"TRANS_NUM_CYCLES"|lmsg}</td>
			<td><input type="text" name="productStopNumCycles" size="5" value="{$product.productStopNumCycles}">
			<div class="hint">{"TRANS_NUMBER_OF_CYCLES_COMMENT"|lmsg}</div>
		</tr>
	{/if}
	<tr>
		<td class="title">{"TRANS_PRORATE_PRODUCT"|lmsg}</td>
		<td>
			<select name="productProratable">{html_options options=$yesNo selected=$product.productProratable}</select>
			<div class="hint">{"TRANS_PRORATE_PRODUCT_COMMENT"|lmsg}</div>
		</td>
	</tr>
	<tr>
		<td class="title">{"TRANS_PRODUCT_CANCELLATION_RULES"|lmsg}</td>
		<td>
			<select name="productCancellationType">{html_options options=$productCancellationRules selected=$product.productCancellationType}</select>
			<div class="hint">{"TRANS_CANCELLATION_RULES_COMMENT"|lmsg}</div>
		</td>
	</tr>
{else}
	<input type="hidden" name="billingPlan" value="2" />
	<input type="hidden" name="productProratable" value="0" />
	<input type="hidden" name="productCancellationType" value="0" />
{/if}
	<tr>
		<td class="title">{"TRANS_ALLOW_DISCOUNT"|lmsg}</td>
		<td>
			<select name="productDiscountable">{html_options options=$yesNo selected=$product.productDiscountable}</select>
			<div class="hint">{"TRANS_ALLOW_DISCOUNT_COMMENT"|lmsg}</div>
		</td>
	</tr>

	<tr>
		<td class="title">{"TRANS_PRODUCTGROUPS"|lmsg}</td>
		<td>
		{include file="$tplDirectory/widgets/comboBox.tpl"
			comboTitleLeft=TRANS_SELECTED
			comboNameLeft="productGroups"
			comboOptionsLeft=$selectedProductGroups

			comboTitleRight=TRANS_SELECTABLE
			comboNameRight="selectableProductGroups"
			comboOptionsRight=$selectableProductGroups
			submitName="suppress"
		}
		</td>
	</tr>
</table>
</fieldset>
<br />
{if $products.0.vendors.0.vendorID}
	{assign var="vendorInfo" value=$products.0.vendors.0}
<fieldset>
<legend><strong>{"TRANS_VENDOR_INFORMATION"|lmsg}</strong></legend>
<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	<tr>
		<td class="title">{"TRANS_VENDOR"|lmsg} </td>
		<td>{$vendorInfo.vendorName}</td>
	</tr>
	<tr>
		<td class="title">{"TRANS_VENDOR_PRODUCT_ID"|lmsg} </td>
		<td>{$vendorInfo.vendorProductID}</td>
	</tr>
	<tr>
		<td class="title">{"TRANS_VENDOR_ORDER_FORM_ID"|lmsg} </td>
		<td>{$vendorInfo.vendorOrderFormID}</td>
	</tr>
	<tr>
		<td class="title">{"TRANS_VENDOR_PRODUCT_VARIANT_ID"|lmsg} </td>
		<td>{$vendorInfo.vendorProductVariantID}</td>
	</tr>
</table>
</fieldset>
<br />
{/if}
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
	<tr class="listButtons">
		<td><div><input class="submit" type="submit" value="{"TRANS_SAVE"|lmsg}"></div></td>
	</tr>
</table>

</form>

{include file="$tplDirectory/widgets/products/footer.tpl"}
