{* $Id: quickEditSelectLink.tpl 8121 2006-07-22 00:50:20Z bwoolley $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$editActionName	The action name to get the action id for.
 *	$editID  		The id of the record to edit.
 *	$editKey		The primary key column name of the record to edit.
 *  $editColumn		The the column to edit.
 *  $useEditIcon    1 or 0
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $extraparam		Extra parameter, if necessary
 *  $extravalue		Extra param value, if necessary
 *  $sid			The current sessionID
 *
 * Example Usage:
 * {include file="$tplDirectory/widgets/quickEditSelectLink.tpl" useEditIcon=0 editID=$billingAccountID editKey="billingAccountID" editActionName="EditBillingAccountResponse" editName="TRANS_TYPE" editColumn="billingAccountType" editOptions=$billingAccountTypes editSelected=$contactBillingAccount.billingAccountType}
 *}

{strip}
<a href="javascript:void(0);" onclick="return overlib('&lt;div style=\'white-space: nowrap\'&gt;
&lt;form method=\'post\' action=\'{getFormAction controller="`$fileName`"}\'&gt;
&lt;input type=\'hidden\' name=\'act\' value=\'{getActionID action="$editActionName"}\' /&gt;
&lt;input type=\'hidden\' name=\'{$editKey}\' value=\'{$editID}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectURL\' value=\'{$fileName}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectAction\' value=\'{$actionName}\' /&gt;
&lt;input type=\'hidden\' name=\'redirectArgs\' value=\'{$bookmarkArgs}\' /&gt;
&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\' /&gt;
{if $extraparam}
&lt;input type=\'hidden\' name=\'{$extraparam}\' value=\'{$extravalue}\' /&gt;
{/if}
{translate key=$editName}:&nbsp;
{escape type="html"}
<select name="{$editColumn}">
{escape type="quotes" strip=1}
{if $allowNull}<option value="0">{"TRANS_NONE"|lmsg}</option>{/if}
{html_options options=$editOptions selected=$editSelected}
{/escape}
</select>
{/escape}
&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_EDIT"|lmsg}\' /&gt;
&lt;/form&gt;&lt;/div&gt;', BGCLASS, 'popupBG', FGCLASS, 'popupFG', CENTER, STICKY, CAPTION, '{"TRANS_QUICK_EDIT_ID"|lmsg} {$editID}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=16 height=16 border=0 /&gt;');" onmouseout="return nd();">
{if $useEditIcon}
<img src="{$imageDirectory}/ico/quickedit.gif" width="16" height="16" alt="{"TRANS_QUICK_EDIT"|lmsg}" title="{"TRANS_QUICK_EDIT"|lmsg}" />
{else}
<img src="{$imageDirectory}/spacer.gif" width="16" height="16" alt="{"TRANS_QUICK_EDIT"|lmsg}" title="{"TRANS_QUICK_EDIT"|lmsg}" />
{/if}
</a>
{/strip}
