{* $Id: listHeaderSortDate.tpl 10611 2007-01-31 23:58:12Z kbailey $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for date columns, that when you click on
 * the header name, will only search this column using dates!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name.
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortDateHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{assign var="newSort" value="asc"}
{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_ASC}
{if $smarty.request.sortDir == "asc"}
	{assign var="newSort" value="desc"}
	{assign var="newSortTitle" value=$smarty.const.TRANS_SORT_DESC}
{/if}
{if $smarty.const.$headerName == "" && $headerName != ""}
	{assign var="headerName" value=$headerName}
{else}
	{assign var="headerName" value=$smarty.const.$headerName}
{/if}
{if $headerAlign==""}
	{assign var="headerAlign" value="left"}
{/if}

{strip}

<td {if $colWidth>0}width="{$colWidth}"{/if} class="{$headerClass}" nowrap="nowrap" style="text-align:{$headerAlign};">
	<a href="javascript:void(0);" onclick="return overlib('&lt;center&gt;&lt;strong&gt;MM/DD/YYYY&lt;/strong&gt;&lt;/center&gt;
					&lt;br /&gt;
					&lt;form method=\'get\' action=\'{getFormAction}\' name=\'DateSort\'&gt;
						{if $smarty.request}
							{foreach from=$smarty.request key=keyID item=val}
								{if ereg( '.+ID', $keyID)}
									&lt;input type=\'hidden\' name=\'{$keyID}\' value=\'{$val}\' /&gt;
									{assign var=queryArgs value="$queryArgs&$keyID=$val"}
								{/if}
							{/foreach}
						{/if}
						&lt;input type=\'hidden\' name=\'ctr\' value=\'{$fileName}\' /&gt;
						&lt;input type=\'hidden\' name=\'act\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'dateColumn\' value=\'{$sortColumn}\' /&gt;
                        &lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{"TRANS_FIND_EXACT_MATCH"|lmsg}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{"TRANS_DATE"|lmsg}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'\' selected=\'selected\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;
									&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;
								&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_FIND_EXACT_MATCH"|lmsg}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;
					&lt;form method=\'get\' action=\'{getFormAction}\'&gt;
						&lt;input type=\'hidden\' name=\'ctr\' value=\'{$fileName}\' /&gt;
						&lt;input type=\'hidden\' name=\'act\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'dateColumn\' value=\'{$sortColumn}\' /&gt;
						&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{"TRANS_FIND_DATE_RANGE"|lmsg}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{"TRANS_DATE"|lmsg}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'Least\' selected=\'selected\'&gt;{"TRANS_GREATER_THAN"|lmsg}&lt;/option&gt;
										{* &lt;option value=\'\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt; *}
										{* &lt;option value=\'Greatest\'&gt;{"TRANS_LESS_THAN"|lmsg}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'dateBool[]\' style=\'width:100%\'&gt;
										&lt;option value=\'AND\' selected=\'selected\'&gt;{"TRANS_AND"|lmsg}&lt;/option&gt;
										{* &lt;option value=\'OR\'&gt;{"TRANS_OR"|lmsg}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;{"TRANS_DATE"|lmsg}&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'dateCompare[]\' style=\'width:100%\'&gt;
										{* &lt;option value=\'Least\'&gt;{"TRANS_GREATER_THAN"|lmsg}&lt;/option&gt; *}
										{* &lt;option value=\'equal\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt; *}
										&lt;option value=\'Greatest\' selected=\'selected\'&gt;{"TRANS_LESS_THAN"|lmsg}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&lt;input type=\'text\' name=\'dateQuery[]\' value=\'\' size=\'10\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_FIND_DATE_RANGE"|lmsg}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;',
				BGCLASS, 'popupBG',
				FGCLASS, 'popupFG',
				CENTER, STICKY,
				CAPTION, '&nbsp;{"TRANS_QUICK_FIND"|lmsg} {$headerName}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
		<img src="{$imageDirectory}/ico/quicksearch.gif" border="0" alt="{"TRANS_SEARCH"|lmsg}" title="{"TRANS_SEARCH"|lmsg}" />
	</a>
	&nbsp;
	<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=$newSort"}" title="{$newSortTitle}">
		<b>{$headerName}</b>
	</a>
</td>
{if $addEmptyTD}
<td>&nbsp;</td>
{/if}
{/strip}
