{*
 * --------------------------------------------------------------
 * This template displays the client dashboard.
 *
 * Smarty Variables:
 *  $invoices (array of invoice data)
 *  $packages (array of package data)
 *  $helpdeskTicketsOpen (array of open tickets)
 *  $helpdeskTicketsOpenSubject (array of open ticket's subjects)
 *  $helpdeskEnabled (1 or 0 to show the helpdesk section)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Michael Fountain
 *}

{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="overview"}

{if $showPPCOffer}
    {include file="$tplDirectory/widgets/google/showAcceptedOffer.tpl"}
    <br />
{/if}

{$messages}

<fieldset>
	<legend><img src="{$imageDirectory}/ico/invoice-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {"TRANS_INVOICES_DUE"|lmsg}</legend>
<table width="100%" border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
            {"TRANS_INVOICE_NUMBER"|lmsg}
        </td>
        <td style="text-align: center;">
            {"TRANS_AMOUNT"|lmsg}
        </td>
        <td style="text-align: center;">
            {"TRANS_AMOUNT_PAID"|lmsg}
        </td>
	    <td style="text-align: center;">
		    {"TRANS_DATE_GENERATED"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_DATE_DUE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_STATUS"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_ACTION"|lmsg}
	    </td>
    </tr>
    {section name=i loop=$invoices}
    	{if $invoices[i].invoiceAmount!=$invoices[i].invoiceAmountPaid}
    	{assign var="invoiceEchod" value=1}
        <tr class="{cycle values="alt1,alt2"}">
            <td style="text-align: center;">
				<a href="{getHREF page="invoices.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoices[i].invoiceID`"}">
					{$invoices[i].invoiceNumber}
				</a>
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmount|getAmount:$invoices[i].currencyID}
            </td>
            <td style="text-align: right;">
                {$invoices[i].invoiceAmountPaid|getAmount:$invoices[i].currencyID}
            </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateEntered|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceDateDue|getDate}
	        </td>
	        <td style="text-align: center;">
		        {$invoices[i].invoiceStatus|getStatusName:"invoice"}
	        </td>
	        <td style="text-align: center;">
			 	<div class="rm"><a class="sb-pay-now" href="{getHREF page="invoices.php" actionName="PayInvoices"}&amp;invoiceID={$invoices[i].invoiceID}"> {"TRANS_PAY_NOW"|lmsg}</a></div>
	        </td>
        </tr>
        {/if}
    {/section}
    {if $invoiceEchod!=1}
        <tr class="alt1">
            <td style="text-align: left;" colspan="7"><i>{"TRANS_NONE"|lmsg}</i></td>
        </tr>
    {else}
        <tr class="listButtons">
	        <td colspan="7"><div>
			 	<div class="rm"><a class="sb-pay-all" href="{getHREF page="invoices.php" actionName="PayInvoices"}">{"TRANS_PAY_ALL"|lmsg}</a><div>
	        </div></td>
        </tr>
    {/if}
	</table>
</fieldset>{* box07x *}
<br />

<fieldset>
	<legend><img src="{$imageDirectory}/ico/package-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {"TRANS_ACTIVE_BILLABLE_PACKAGES"|lmsg}</legend>
	<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
    <tr class="headerRow">
	    <td style="text-align: center;">
		    {"TRANS_ID"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_PACKAGE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_PRICE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_BILLING_CYCLE"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_NEXT_RENEWAL"|lmsg}
	    </td>
	    <td  style="text-align: center;">
		    {"TRANS_STATUS"|lmsg}
	    </td>
    </tr>
    {section name=i loop=$packages}
        <tr class="{cycle values="alt1,alt2"}">
	        <td style="text-align: left;">
		        {$packages[i].packageID}
	        </td>
	        <td style="text-align: left;">
	        <a href="{getHREF page="packages.php" actionName="ShowPackageDetails"}&amp;packageID={$packages[i].packageID}">
		        {$packages[i].packageName|stripslashes}
		    </a>
		        {if $packages[i].domains.0.domainID>0}
		        	{foreach item="domain" key="dk" from=$packages[i].domains}
		        		<br />
		        		<!-- <a href="{getHREF page="domains.php" actionName="ShowDomainDetails" args="domainID=`$domain.domainID`"}"> --><strong>{$domain.domainSLD}.{$domain.domainTLD}</strong><!-- </a> -->
		        	{/foreach}
		        {/if}
	        </td>
	        <td style="text-align: right;">
		        {$packages[i].packagePrice|getAmount:$packages[i].currencyID}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].cycleID|getArrayValueByID:$cycles}
	        </td>
	        <td style="text-align: center;">
		        {$packages[i].packageDateNextRenewal|getDate}
	        </td>
	        <td  style="text-align: center;">
		        {$packages[i].packageStatus|getStatusName:"package"}
	        </td>
        </tr>
    {sectionelse}
        <tr class="alt1">
            <td colspan="7"><i>{"TRANS_NONE"|lmsg}</i></td>
        </tr>
    {/section}
	</table>
</fieldset>{* box07x *}
<br />

{*
{if $helpdeskEnabled}
<fieldset>
	<legend><img src="{$imageDirectory}/ico/ticket-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {"TRANS_OPEN_TICKETS"|lmsg}</legend>
		<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
		<tr class="headerRow">
			<td width="25%" style="text-align: center;">{"TRANS_TICKET_ID"|lmsg}</td>
			<td width="35%" style="text-align: center;">{"TRANS_SUBJECT"|lmsg}</td>
			<td width="20%" style="text-align: center;">{"TRANS_DATE_CREATED"|lmsg}</td>
			<td width="20%" style="text-align: center;">{"TRANS_LAST_MODIFIED"|lmsg}</td>
		</tr>
		{foreach key=id item=ticket from=$helpdeskTickets}
			{if $ticket.hdTicketStatusID==2}
			<tr class="{cycle values="alt1,alt1"}">
				<td width="25%" style="text-align: left;"><a href="{getHREF page="helpdesk.php"
								actionName="ShowHelpdeskTicketDetails"
								args="hdTicketID=`$ticket.hdTicketID`"}">{$ticket.hdTicketKey}</a></td>
				<td width="35%" style="text-align: left;">{$ticket.hdTicketSubject|mb_truncate:25}</td>
				<td width="20%" style="text-align: left;">{$ticket.hdTicketDateCreated|getDateTime:short}</td>
				<td width="20%" style="text-align: left;"><div class="floatleft">{$ticket.hdTicketDateModified|getDateTime:short}</td>
			</tr>
			{/if}
		{/foreach}
		<tr class="alt1">
			<td colspan="4"><i><a href="{getHREF page="helpdesk.php" actionName="AddHelpdeskTicket"}">{"TRANS_NEW_TICKET"|lmsg}</a></i></td>
		</tr>
		</table>
</fieldset>{* box07 * }
<br />
{/if}
*}

{*
<fieldset>
	<legend><img src="{$imageDirectory}/ico/news-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {"TRANS_NEWS_AND_ANNOUNCMENTS"|lmsg}</legend>
	<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
	 <tr class="headerRow">
	    <td style="text-align: center;">
		    {"TRANS_SUBJECT"|lmsg}
	    </td>
	    <td style="text-align: center;">
		    {"TRANS_DESCRIPTION"|lmsg}
	    </td>
	</tr>
	{foreach from=$news item=n}
    		<tr style="cursor:pointer;" onClick="XKtoggle('row_{$n.newsGroupID}');">
    			<td>{$n.newsGroupName}</td>
    			<td>{$n.newsGroupDescription}</td>
    		</tr>
    		<tbody id="row_{$n.newsGroupID}">
    		<tr>
    			<td colspan="2">
    				<table width="100%" cellspacing="2" cellpadding="0" border="0" class="list">
    				<tr class="headerRow">
    					<td style="text-align:center;">
    						{"TRANS_SUBJECT"|lmsg}
    					</td>
    					<td style="text-align:center;">
    						{"TRANS_PRIORITY"|lmsg}
    					</td>
    				</tr>
    				{foreach from=$n.articles item=a}
					<tr style="cursor:pointer;" onClick="XKtoggle('article_{$a.newsID}');">
						<td>{$a.newsSubject}</td>
						<td>{$a.priorityID|getArrayValueByID:$priorities}</td>
					</tr>
					<tbody id="article_{$a.newsID}">
						<td colspan="2">
							{$a.newsBody|nl2br|html_entity_decode}
						</td>
					</tbody>
					<script type="text/javascript" language="javascript" charset="utf-8">
					//<[[CDATA][
					XKtoggle('article_{$a.newsID}');
					//]]>
					</script>
    				{foreachelse}
    					<tr bgcolor="#EEEDE9">
    						<td colspan="2"><i>{"TRANS_NORESULTS"|lmsg}</a></td>
    					</tr>
    				{/foreach}
    				</table>
    			</td>
    		</tr>
    		<script type="text/javascript" language="javascript" charset="utf-8">
		//<[[CDATA][
		XKtoggle('row_{$n.newsGroupID}');
		//]]>
		</script>
    	{foreachelse}
    		<tr class="alt1">
	        	<td colspan="2"><i>{"TRANS_NONEWS"|lmsg}</i></td>
	    	</tr>
	{/foreach}
	</table>
</fieldset>{* box07 * }
*}

{include file="$tplDirectory/footer.tpl"}
