{* $Id: EditDomainDNS.tpl 7317 2006-06-08 01:30:52Z kbailey $
 * --------------------------------------------------------------
 * This template edit's the domain's registrar lock setting.
 *
 * Smarty Variables:
 *	$domain (array of this domain's data in ModernBill)
 *	$listDNS (array of DNS records)
 *  $useDNS (1 if using the registrar as the name server)
 *  $dnsShowExtra (This is an experimental way to show 8 fields per domain.)
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Andy Christ
 *}

{include file="$tplDirectory/header.tpl" tabMajor="packages" tabMinor="domains"}

<script language="javascript" charset="UTF-8">
<!--
{literal}
function updateDNSformstate(x,y){
	for (i=0; i<document.EditDomainDNS.elements.length; i++){
		if (document.EditDomainDNS.elements[i].name) {
			if (document.EditDomainDNS.elements[i].name.substring(0,9)=="domainDNS"){
				document.EditDomainDNS.elements[i].disabled = x;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,15)=="hostDNSHostname"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,11)=="hostDNSType"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
			if (document.EditDomainDNS.elements[i].name.substring(0,14)=="hostDNSAddress"){
				document.EditDomainDNS.elements[i].disabled = y;
			}
		}
	}
}
{/literal}
//-->
</script>

<form method="post" action="{getFormAction controller="domains"}" name="EditDomainDNS">
	<input type="hidden" name="act" value="{getActionID action="EditDomainDNSResponse"}" />
	<input type="hidden" name="domainID" value="{$domain.domainID}" />
	<input type="hidden" name="sid" value="{$sid}" />
	<input type="hidden" name="useDNSOld" value="{$useDNS}" />

	<fieldset>
		<legend>{$domain.domainSLD}.{$domain.domainTLD}</legend>

		<div class="msgWarning">
			<span class="title" style="position: absolute;">{translate key='TRANS_NOTICE'}:&nbsp;</span>
			<div style="margin-left: 50px;">
				{translate key='TRANS_SOMETIMES_REGISTRAR_DNS_CHANGES_TAKE_TIME'}
			</div>
		</div>
		<br />

		<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
			<tr>
				<td colspan="2" class="headerRow">{"TRANS_DOMAIN_DNS"|lmsg}</td>
			</tr>

			{if $hostLoop && ! is_null($useDNS)}
			<tr>
				<td class="title">{"TRANS_DOMAIN_REGISTRAR_AS_DNS"|lmsg}</td>
				<td><input type="radio" value="0"{if $useDNS != 1} checked="checked"{/if} onclick="updateDNSformstate(false, true);" name="useDNS"> {"TRANS_NO"|lmsg} <input type="radio" value="1" onclick="updateDNSformstate(true, false);" name="useDNS"{if $useDNS} checked="checked"{/if}> {"TRANS_YES"|lmsg}</td>
			</tr>
			{/if}

			{section name="i" loop="$listDNS"}
			<tr {if $invalidDNS[i]}class="highlight"{/if}>
				<td class="title">{"TRANS_DOMAIN_SERVER"|lmsg} {$smarty.section.i.index+1}</td>
				<td>
					<input type="text"{if $useDNS} disabled="disabled"{/if} name="domainDNS[]" value="{$listDNS[i]}" size="40" />
					{$invalidDNS[i]}
				</td>
			</tr>
			{sectionelse}
			<!--List 8 input boxes but only enable them if the UseDNS is set to no meaning that Use the registrar as DNS server is no-->
			{/section}
			{if ! is_null($dnsOptions)}
				{section name="j" loop="$dnsShowExtra"}
					<tr>
						<td class="title">{"TRANS_DOMAIN_SERVER"|lmsg} {$smarty.section.j.index+$dnsCount+1}</td>
						<td><input type="text"{if $useDNS} disabled="disabled"{/if} name="domainDNS[]" value="" size="40" /></td>
					</tr>
				{/section}

				{if $hostLoop}
				<tr>
					<td colspan="2" class="headerRow">{"TRANS_DOMAIN_DNS_ADVANCED"|lmsg}</td>
				</tr>
				<tr>
					<td colspan="2">{"TRANS_DOMAIN_DNS_ADVANCED_DESC"|lmsg}</td>
				</tr>

				<tr>
					<td colspan="2">
						<table width="60%" border="0" align="center" class="list">
							<tr>
								<td>
								</td>

								<td>
									{"TRANS_DOMAIN_DNS_HOSTNAME"|lmsg}
								</td>

								<td>
									{"TRANS_DOMAIN_DNS_RECORD_TYPE"|lmsg}
								</td>

								<td>
									{"TRANS_DOMAIN_DNS_ADDRESS"|lmsg}
								</td>
							</tr>
							{section name="k" loop="$hostLoop"}
								{assign var="hostRecord" value=$host[k]}
								<tr>
									<td>{$smarty.section.k.index+1}</td>
									<td>{if $hostRecord.type}
											{$hostRecord.name}
											<input type="hidden" name="hostDNSHostname[]" value="{$hostRecord.name}">
										{else}
											<input type="text" {if !$useDNS} disabled="disabled"{/if} name="hostDNSHostname[]">
										{/if}
									</td>
									<td width="45%">
										{html_options name=hostDNSType[]
										options=$dnsOptions selected=$hostRecord.type}
									</td>
									<td><input type="text"{if !$useDNS} disabled="disabled"{/if} name="hostDNSAddress[]" value="{$hostRecord.address}" size="20" /></td>
								</tr>
							{/section}
						</table>
			 			{assign var="dnsOptionsDesc" value=$dnsOptionsDescKey|lmsg}
						{if $dnsOptionsDesc != $dnsOptionsDescKey}
							{$dnsOptionsDesc}
						{/if}
					</td>
				</tr>
			{/if}
			<tr>
				<td colspan="2">&nbsp;</td>
			</tr>

			<tr>
				<td colspan="2" align="center">
					<br /><br />
					{"TRANS_ACCESS_DNS_MSG"|lmsg}
					<br /><br />
				</td>
			</tr>
			{/if}

			<tr class="listButtons">
				<td colspan="2"><div>
					<input class="submit" type="submit" name="submit" value="{"TRANS_SAVE_CHANGES"|lmsg}" />
				</div></td>
			</tr>
		</table>
	</fieldset>
</form>

{include file="$tplDirectory/footer.tpl"}
