{* $Id: ShowDomainDetails.tpl 11162 2007-05-22 16:06:27Z bsmith $
 * --------------------------------------------------------------
 * This template displays the domains.
 *
 * Smarty Variables:
 *  $domain (array of domain data)
 *  $rules (array of domain management rules for this registrar)
 *  $capabilities (array of management options this domain's registrar is capable of)
 *       domainGetRenewDate
 *       domainContact
 *       domainRenewType
 *       domainLock
 *       domainPassword
 *       domainDNS
 *       domainLiveRenew
 *
 * 	$cssDirectory	The relative path to the theme's css directory
 *	$jsDirectory	The relative path to the theme's javascript directory
 *	$imageDirectory	The relative path to the theme's image directory
 *	$tplDirectory	The relative path to the theme's template directory
 *
 * Author: Andy Christ
 *}



{include file="$tplDirectory/header.tpl" tabMajor="packages" tabMinor="domains"}

		<fieldset>
			<legend><img src="{$imageDirectory}/ico/domain-icon.gif" width="30" height="30" border="0" alt="" /> {$domain.domainSLD}.{$domain.domainTLD}</legend>
			<table width="100%"  border="0" cellspacing="0" cellpadding="0" class="list">
            <tr class="headerRow">
	            <td>
		            {"TRANS_DOMAIN_NAME"|lmsg}
	            </td>
	            <td>
		            {"TRANS_DOMAIN_EXPIRES"|lmsg}
	            </td>
            </tr>
			<tr>
				<td>
					{$domain.domainSLD}.{$domain.domainTLD}

				</td>
				<td>
					{$domain.domainDateExpires|getDate}
				</td>
			</tr>
			{if $domain.packageStatus == ("none"|get_status_id:"package")}
			{assign var=domainID value=$domain.domainID}
			{if $rules.moduleAllowChangeContactInfo && $capabilities.domainContact}
				<tr>
					<td colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainContactData"
							args="domainID=$domainID"}">{"TRANS_DOMAIN_CHANGE_CONTACT_INFO"|lmsg}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeDNS && $capabilities.domainDNS}
				<tr>
					<td colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainDNS"
							args="domainID=$domainID"}">{"TRANS_DOMAIN_CHANGE_DNS"|lmsg}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeRegistrarLock && $capabilities.domainLock}
				<tr>
					<td colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainRegistrarLockOptions"
							args="domainID=$domainID"}">{"TRANS_DOMAIN_CHANGE_REGISTRAR_LOCK"|lmsg}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeAutorenew && $capabilities.domainRenewType}
				<tr>
					<td colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainRenewTypeOptions"
							args="domainID=$domainID"}">{"TRANS_DOMAIN_CHANGE_AUTORENEW"|lmsg}</a>
					</td>
				</tr>
			{/if}
			{if $rules.moduleAllowChangeUpdateDomainPassword && $capabilities.domainPassword}
				<tr>
					<td colspan="2">
						<a href="{getHREF page="domains.php"
							actionName="EditDomainAccessPassword"
							args="domainID=$domainID"}">{"TRANS_DOMAIN_CHANGE_DOMAIN_PASSWORD"|lmsg}</a>
					</td>
				</tr>
			{/if}
			{/if} {* end package status test *}
			{if $domain.packageStatus == ("work_in_progress"|get_status_id:"package")}
			    {assign var=domainID value=$domain.domainID}
				{if $rules.moduleAllowUploadDocuments && $capabilities.domainUploadDocuments}
					<tr>
						<td colspan="2">
							<a href="{getHREF page="domains.php"
								actionName="DomainUploadDocuments"
								args="domainID=$domainID"}">{"TRANS_REGISTRAR_RUCENTER_UPLOAD_DOCUMENTS"|lmsg}</a>
						</td>
					</tr>
				{/if}
			{/if}
			</table>
		</fieldset>{* box07 *}
        <br />

{include file="$tplDirectory/footer.tpl"}
