{* $Id: ShowInvoiceDetails.tpl 12256 2007-11-19 17:42:33Z kbailey $
 * --------------------------------------------------------------
 * This template displays a list of invoice records.
 *
 * Smarty Variables:
 *	$invoices (array of invoices that match input criteria)
 *		invoiceID			A unique invoice ID
 *		invoiceNumber		An invoice's number
 *		invoiceAmount		An invoice's amount
 *		invoiceDateEntered	An invoice's generation date
 *		invoiceDateDue		An invoice's due date
 *		invoiceStatus		The status of an invoice
 *	$actionID				The unique action ID for this page view
 *  $actionName				The action name for this action ID
 *	$imageDirectory			The image directory for this theme
 *	$tplDirectory			The template directory for this theme
 *
 * Author: Michael Fountain
 *}

{assign var="filterArgs" value="invoiceStatus=$invoiceStatus"}

{php}$GLOBALS['__pagePath'] = array('TRANS_MENU_CLIENT_OPERATIONS_INVOICES', 'TRANS_INVOICES_INVOICE_DETAILS', '');{/php}
{include file="$tplDirectory/header.tpl" tabMajor="dashboard"}

{assign var="lineItems" value=$invoice.lineItems}
<script language="javascript" type="text/javascript">
<!--
{literal}
function checkSure(url){
	if (confirm("{/literal}{"TRANS_ARE_YOU_SURE_FINALIZE"|lmsg|escape:javascript}{literal}")){
		document.location.href = url;
	}
}
function checkSure2(url){
	if (confirm("{/literal}{"TRANS_ARE_YOU_SURE_CANCEL"|lmsg|escape:javascript}{literal}")){
		document.location.href = url;
	}
}
{/literal}
//-->
</script>

<div style="text-align:right;">
{if $invoice.invoiceAmount-$invoice.invoiceAmountPaid>0}
<div class="rm"><a href="{getHREF page="invoices.php" actionName="PayInvoices"}&amp;invoiceID={$invoice.invoiceID}">{"TRANS_PAY_NOW"|lmsg}</a></div>
{/if}
<div class="rm"><a target="_blank" href="{getHREF page="invoice_pdf.php" actionName="ShowInvoiceDetails" args="invoiceID=`$invoice.invoiceID`&redirectArgs=$bookmarkArgs"}">{"TRANS_PRINT"|lmsg}</a></div>
</div>

<fieldset>
<legend><img src="{$imageDirectory}/ico/invoice-icon.gif" width="30" height="30" border="0" alt="" align="absmiddle" /> {"TRANS_INVOICE"|lmsg} {$invoice.invoiceNumber}</legend>
{assign var="currencyID" value=$invoice.currencyID}
<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
<tr>
	<td align="right" valign="top">
		<table width="100%" bgcolor="#ffffff">
            <tr>
                <td><strong>{"TRANS_TO"|lmsg}</strong></td>
            </tr>
        </table>
    </td>
    <td align="left" valign="top">
          <table width="80%" bgcolor="#FFFFFF">
		<tr>
			<td>
				{if $clientData.clientCompany && $invoice.clientContactID==0}
					{assign var="contactName" value=$clientData.clientCompany}
				{else}
					{assign var="contactName" value="`$contactData.contactFirstName` `$contactData.contactLastName`"}
				{/if}
                <strong>{$contactName|safetyhtml}</strong><br />
                {$contactData.contactAddress1|safetyhtml}<br />
                {if $contactData.contactAddress2!=""}
                    {$contactData.contactAddress2|safetyhtml}<br />
                {/if}
                {$contactData.contactCity|safetyhtml}, {$contactData.contactState|safetyhtml} {$contactData.contactZip|safetyhtml}<br />
                {$contactData.contactPhone1|safetyhtml} {if $contactData.contactPhone2!=''}- {$contactData.contactPhone2|safetyhtml}{/if}
                {if $clientData.taxIDNumber!=''}
                <br />{"TRANS_TAX_ID_NUMBER"|lmsg} {$clientData.taxIDNumber|safetyhtml}
                {/if}
			</td>
		</tr>
		</table>
	</td>
	<td align="right" valign="top">
		<table width="100%" bgcolor="#ffffff">
            <tr>
                <td><strong>{"TRANS_FROM"|lmsg}</strong></td>
            </tr>
        </table>
    </td>
	<td align="left" valign="top">
		<table width="80%" bgcolor="#FFFFFF">
		<tr>
			<td>
				<strong>{$companyData.companyName}</strong><br />
				{$companyData.companyAddress1}<br />
                {if $companyData.companyAddress2!=""}
                    {$companyData.companyAddress2}<br />
                {/if}
                {$companyData.companyCity}, {$companyData.companyState} {$companyData.companyZip}<br />
                {$companyData.companyPhone1} {if $companyData.companyPhone2!=''}- {$companyData.companyPhone2}{/if}
                {if $companyData.companyTaxIDNumber!=''}
                <br />{"TRANS_TAX_ID_NUMBER"|lmsg} {$companyData.companyTaxIDNumber}
                {/if}

			</td>
		</tr>
		</table>
	</td>
</tr>
<tr>
	<td colspan="4" align="center">
            <br />
		<table width="100%" class="list" cellspacing="0" cellpadding="0">
			<tr class="headerRow">
				<td>
					<strong>{"TRANS_INVOICE_NUMBER"|lmsg}</strong>
				</td>
				<td>
					<strong>{"TRANS_ENTERED"|lmsg}</strong>
				</td>
				<td>
					<strong>{"TRANS_DUE"|lmsg}</strong>
				</td>
				<td>
					<strong>{"TRANS_PAYMENT_TERMS"|lmsg}</strong>
				</td>
				<td align="right">
					<strong>{"TRANS_INVOICE_TOTAL"|lmsg}</strong>
				</td>
				<td align="right">
					<strong>{"TRANS_AMOUNT_PAID"|lmsg}</strong>
				</td>
			</tr>
			<tr class="alt1">
				<td>{$invoice.invoiceNumber}</td>
				<td>{$invoice.invoiceDateEntered|getDate:"short"}</td>
				<td>{$invoice.invoiceDateDue|getDate:"short"}</td>
				<td>Due By Due Date</td>
				<td align="right">{$invoice.invoiceAmount|getAmount:$invoice.currencyID}</td>
				<td align="right">{$invoice.invoiceAmountPaid|getAmount:$invoice.currencyID}</td>
			</tr>

		</table>
	</td>
</tr>

		{if $invoice.invoiceComments}
<tr>
	<td colspan="4" align="left">
		<table width="100%" bgcolor="#FFFFFF">
		<tr>
			<td>
				<strong>{"TRANS_INVOICE_COMMENTS"|lmsg}</strong>
			</td>
		</tr>

		<tr>
			<td>{$invoice.invoiceComments}</td>
		</tr>

		</table>
	</td>
</tr>
		{/if}

<tr>
	<td colspan="4" align="left">
            <br />
		<strong>{"TRANS_LINE_ITEMS"|lmsg}</strong>
		<table width="100%" class="list" cellspacing="0" cellpadding="0">
		<tr class="headerRow">
            <td style="white-space: nowrap; text-align: left;">{"TRANS_PACKAGE_ID"|lmsg}</td>
			<td style="white-space: nowrap; text-align: left;" colspan="2">{"TRANS_DESCRIPTION"|lmsg}</td>
			<td style="white-space: nowrap; text-align: left;">{"TRANS_BEGIN"|lmsg}</td>
			<td style="white-space: nowrap; text-align: left;">{"TRANS_CURRENT"|lmsg}</td>
			<td style="white-space: nowrap; text-align: left;">{"TRANS_NEXT_RENEWAL"|lmsg}</td>
            <td style="white-space: nowrap; text-align: left;">{"TRANS_QUANTITY_ABBR"|lmsg}</td>
            <td style="white-space: nowrap;" align="right">{"TRANS_PRICE"|lmsg}</td>
			<td style="white-space: nowrap;" align="right">{"TRANS_DISCOUNT"|lmsg}</td>
			<td style="white-space: nowrap;" align="right">{"TRANS_SETUP"|lmsg}</td>
            <td style="white-space: nowrap;" align="right">{"TRANS_SUB_TOTAL"|lmsg}</td>
			<td style="white-space: nowrap;" align="right">{"TRANS_TAX"|lmsg}</td>
			<td style="white-space: nowrap;" align="right">{"TRANS_TOTALS"|lmsg}</td>
		</tr>
        {assign var="inaddons" value="no"}
		{section name="j" loop=$lineItems}
			{assign var="tpid" value=$lineItems[j].packageID}
                {if $lineItems[j].packageAddonID>0}
                    {if $inaddons=="no"}
                        {assign var="inaddons" value="yes"}
                        <tr class="alt2">
                            <td align="right"><i>{"TRANS_ADDONS"|lmsg}</i></td>
                            <td style="text-align:left;" colspan="5"><i>{"TRANS_DESCRIPTION"|lmsg}</i></td>
                            <td style="text-align:left;"><i>{"TRANS_QUANTITY_ABBR"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_PRICE"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_DISCOUNT"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_SETUP"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_SUB_TOTAL"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_TAX"|lmsg}</i></td>
                            <td style="text-align:right;"><i>{"TRANS_TOTALS"|lmsg}</i></td>
                        </tr>
                    {/if}
                        <tr class="alt1">
                            <td align="right">{$lineItems[j].packageAddonID|highlightTerm}</td>
                            {assign var="addonID" value=$lineItems[j].packageAddonID}
                            <td style="text-align:left;" colspan="5">{$lineItems[j].lineItemDescription|highlightTerm}
                            </td>
                            <td style="text-align:left;">{$lineItems[j].lineItemQuantity}</td>
                            <td style="text-align:right;">{$lineItems[j].lineItemPriceAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td style="text-align:right;">{$lineItems[j].lineItemDiscountAmount|getAmount:$currencyID|highlightTerm}
                            	{if $lineItems[j].lineItemDiscountAmount>0}
                            	<br />
                            	{"TRANS_BASIS"|lmsg} {$lineItems[j].lineItemPriceAmount|getAmount:$currencyID}@
                            		{if $lineItems[j].lineItemDiscount>0 && $lineItems[j].prorationDiscount>0}
                            			{$lineItems[j].lineItemDiscount*100}% + {$lineItems[j].prorationDiscount*100}%
                            		{elseif $lineItems[j].lineItemDiscount>0}
                            			{$lineItems[j].lineItemDiscount*100}%
                            		{elseif $lineItems[j].prorationDiscount>0}
                            			{$lineItems[j].prorationDiscount*100}%
                            		{/if}
                            	{/if}
                            </td>
                            <td style="text-align:right;">{$lineItems[j].lineItemSetupAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td style="text-align:right;">{$lineItems[j].lineItemTotalAmount-$lineItems[j].lineItemTaxAmount|getAmount:$currencyID}</td>
                            <td style="text-align:right;">{$lineItems[j].lineItemTaxAmount|getAmount:$currencyID|highlightTerm}</td>
                            <td style="text-align:right;">{$lineItems[j].lineItemTotalAmount|getAmount:$currencyID|highlightTerm}</td>
                        </tr>


                {else}

                {if $lastLineItemID>0 && $inaddons=="yes" && $addonTotals.total.$lastLineItemID}

                <tr class="alt2">
                	<td colspan="9" align="right">[{$lastLineItemDescription|highlightTerm}] {"TRANS_PACKAGE_TOTALS"|lmsg} </td>
                    <td style="text-align:right;">{$addonTotals.setup.$lastLineItemID|getAmount:$currencyID}</td>
                    <td style="text-align:right;">{$addonTotals.total.$lastLineItemID-$addonTotals.tax.$lastLineItemID|getAmount:$currencyID}</td>
                    <td style="text-align:right;">{$addonTotals.tax.$lastLineItemID|getAmount:$currencyID}</td>
                    <td style="text-align:right;">{$addonTotals.total.$lastLineItemID|getAmount:$currencyID}</td>
                </tr>

                {/if}

                {if $lineItems[j].packageComments!=""}
                	{assign var="rowspan" value="2"}
                {else}
                	{assign var="rowspan" value="1"}
                {/if}
                {assign var="inaddons" value="no"}
                <tr>
                    <td rowspan="{$rowspan}" style="text-align:left;">
						{* make the line item id hidden *}
						<!--LineItemID:{$lineItems[j].lineItemID}-->
						<strong>{$tpid}</strong>
					</td>
                    <td style="text-align:left;" colspan="2">{$lineItems[j].lineItemDescription|highlightTerm}
						{if $domains.$tpid.0.domainID}
							{foreach item="domain" key="dkey" from=$domains.$tpid}
								<br />{"TRANS_DOMAIN"|lmsg} <strong>{$domain.domainSLD|highlightTerm}.{$domain.domainTLD|highlightTerm}</strong>
							{/foreach}
						{/if}
					</td>
                    <td style="text-align:left;">{$lineItems[j].lineItemDateBeginRenewal|getDate:"short"}</td>
                    <td style="text-align:left;">{$lineItems[j].lineItemDateCurrentRenewal|getDate:"short"}</td>
                    <td style="text-align:left;">{$lineItems[j].lineItemDateNextRenewal|getDate:"short"}</td>
                    <td style="text-align:left;">{$lineItems[j].lineItemQuantity}</td>
                    <td style="text-align:right;">{$lineItems[j].lineItemPriceAmount|getAmount:$currencyID|highlightTerm}</td>
                    <td style="text-align:right;">{$lineItems[j].lineItemDiscountAmount|getAmount:$currencyID|highlightTerm}
						{if $lineItems[j].lineItemDiscountAmount>0}
						<br />
						{"TRANS_BASIS"|lmsg} {$lineItems[j].lineItemPriceAmount|getAmount:$currencyID}@
							{if $lineItems[j].lineItemDiscount>0 && $lineItems[j].prorationDiscount>0}
								{$lineItems[j].lineItemDiscount*100}% + {$lineItems[j].prorationDiscount*100}%
							{elseif $lineItems[j].lineItemDiscount>0}
								{$lineItems[j].lineItemDiscount*100}%
							{elseif $lineItems[j].prorationDiscount>0}
								{$lineItems[j].prorationDiscount*100}%
							{/if}
						{/if}
                    </td>
                    <td style="text-align:right;">{$lineItems[j].lineItemSetupAmount|getAmount:$currencyID|highlightTerm}</td>
                    <td style="text-align:right;">{$lineItems[j].lineItemTotalAmount-$lineItems[j].lineItemTaxAmount|getAmount:$currencyID}</td>
                    <td style="text-align:right;">{$lineItems[j].lineItemTaxAmount|getAmount:$currencyID|highlightTerm}</td>
                    <td style="text-align:right;">{$lineItems[j].lineItemTotalAmount|getAmount:$currencyID|highlightTerm}</td>
                </tr>
					{if $lineItems[j].packageComments!=""}
						<tr class="alt2">
							<td colspan="12">{$lineItems[j].packageComments|highlightTerm}</td>
						</tr>
					{/if}
					{assign var="lastLineItemID" value=$lineItems[j].lineItemID}
					{assign var="lastLineItemDescription" value=$lineItems[j].lineItemDescription}
                {/if}


		{/section}
				{if $lastLineItemID>0 && $inaddons=="yes" && $addonTotals.total.$lastLineItemID}

					<tr class="alt2">
						<td colspan="9" align="right">[{$lastLineItemDescription|highlightTerm}]  {"TRANS_PACKAGE_TOTALS"|lmsg} </td>
						<td style="text-align:right;">{$addonTotals.setup.$lastLineItemID|getAmount:$currencyID}</td>
						<td style="text-align:right;">{$addonTotals.total.$lastLineItemID-$addonTotals.tax.$lastLineItemID|getAmount:$currencyID}</td>
						<td style="text-align:right;">{$addonTotals.tax.$lastLineItemID|getAmount:$currencyID}</td>
						<td style="text-align:right;">{$addonTotals.total.$lastLineItemID|getAmount:$currencyID}</td>
					</tr>

                {/if}
		</table>
	</td>
</tr>

<tr>
    <td colspan="4" align="center">

{if $taxZones.0.taxZoneID}
        <div align="left">
		<strong>{"TRANS_TAX_ZONES"|lmsg}</strong>
		<table width="100%" cellpadding="0" cellspacing="0" class="list">
			<tr class="headerRow">
				<td>{"TRANS_TAX_ZONE_ID"|lmsg}</td>
				<td>{"TRANS_TAX_ZONE_NAME"|lmsg}</td>
				<td>{"TRANS_TAX_ZONE_DESCRIPTION"|lmsg}</td>
				<td>{"TRANS_TAX_ZONE_TYPE"|lmsg}</td>
				<td>{"TRANS_TAX_ZONE_RATE"|lmsg}</td>
				<td>{"TRANS_TAX_ZONE_TOTAL"|lmsg}</td>
			</tr>
			{section name="j" loop=$taxZones}
				{if $className=="alt1"}
					{assign var="className" value="alt2"}
				{else}
					{assign var="className" value="alt1"}
				{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td>{$taxZones[j].taxZoneID}</td>
				<td>{$taxZones[j].taxZoneName}</td>
				<td>{$taxZones[j].taxZoneDescription}</td>
				<td>{if $taxZones[j].lineItemTaxAmountType==0}
					{"TRANS_PERCENTAGE"|lmsg}
				{else}
					{"TRANS_SET_AMOUNT"|lmsg}
				{/if}</td>
				<td align="right">{if $taxZones[j].lineItemTaxAmountType==0}
					{$taxZones[j].lineItemTaxAmount}%
				{else}
					{$taxZones[j].lineItemTaxAmount|getAmount:$currencyID}
				{/if}</td>
				<td align="right">{$taxZones[j].taxTotal|getAmount:$currencyID}</td>
			</tr>
			{/section}
		</table>
	</div>
{/if}


        {if $transactions}
	<div align="left">
		<strong>{"TRANS_TRANSACTIONS"|lmsg}</strong>
		<table width="100%" cellpadding="0" cellspacing="0" class="list">
			<tr class="headerRow">
				<td>{"TRANS_ID"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_PAYMENT_METHOD"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_STATUS"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_CODE"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_NOTES"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_DATE"|lmsg}</td>
				<td>{"TRANS_TRANSACTION_AMOUNT"|lmsg}</td>
			</tr>
			{section name="j" loop=$transactions}
				{if $className=="alt1"}
					{assign var="className" value="alt2"}
				{else}
					{assign var="className" value="alt1"}
				{/if}
			<tr class="{cycle values="alt1,alt2"}">
				<td>{$transactions[j].transactionID}</td>
				{assign var="tkey" value=$transactions[j].transactionPaymentMethod|getArrayValueByID:$paymentMethods}
				<td>{translate key=$tkey}</td>
				{assign var="tkey" value=$transactions[j].authReturn|getArrayValueByID:$transactionStatuses}
				<td>{translate key=$tkey}</td>
				<td>{$transactions[j].transactionCode}</td>
				<td>{$transactions[j].transactionNotes}</td>
				<td>{$transactions[j].transactionDateCreated|getDate:short}</td>
				<td align="right">{$transactions[j].transactionAmount|getAmount:$transactions[j].currencyID}</td>
			</tr>
			{/section}
		</table>
	</div>
        {/if}

    </td>
</tr>
</table>

</fieldset>

{include file="$tplDirectory/footer.tpl"}
