{* $Id: AddTodo.tpl 10514 2007-01-19 15:19:10Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to add a new to-do. The form must post to todos.php, 
 * with the action ID for the AddTodoResponse action, so that the POST data can 
 * be handled by the server. This template takes the $todostatus smarty variable, used to display
 * the options for the status of the to-do.
 *
 * Smarty Variables:
 *	$todostatus -- Array of possible statuses for the To Do item.
 *
 *}


{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

		<fieldset>
			<legend>{"TRANS_ADD_TODO"|lmsg}</legend>
			<form method="post" action="{getFormAction controller="todos"}">
			<input type="hidden" name="act" value="{getActionID action="AddTodoResponse"}" />
			<input type="hidden" name="sid" value="{$sid}" />
			
			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
			<tr class="headerRow">
				<td colspan="2">{"TRANS_TODOS"|lmsg}</td>
			</tr>
			<tbody>
			<tr class="{if $invalid.todoTitle}highlight{/if}">
				<td class="title"><label for="todoTitle">{"TRANS_TITLE"|lmsg}</label></td>
				<td><input size="20" maxlength="255" type="text" id="todoTitle" name="todoTitle" value="{$formValues.todoTitle}" /> {$invalid.todoTitle}</td>
			</tr>
			<tr class="{if $invalid.todoDesc}highlight{/if}">
				<td class="title"><label for="todoDesc">{"TRANS_DESCRIPTION"|lmsg}</label></td>
				<td><textarea cols="40" rows="5" id="todoDesc" name="todoDesc">{$formValues.todoDesc}</textarea> {$invalid.todoDesc}</td>
			</tr>
			<tr class="{if $invalid.todoStatusID}highlight{/if}">
				<td class="title"><label for="todoStatusID">{"TRANS_STATUS"|lmsg}</label></td>
				<td><select id="todoStatusID" name="todoStatusID"> {html_options options=$todostatus selected=$formValue.todoStatusID} </select> {$invalid.todoStatusID}</td>
			</tr>
			<tr class="{cycle values="alt1,alt2"}">
				<td class="title"><label for="todoIsPublic">{"TRANS_IS_PUBLIC"|lmsg}</label></td>
				<td><input type="checkbox" id="todoIsPublic" name="todoIsPublic" value="1" {if $todoIsPublic}checked="checked"{/if} /></td>
			</tr>
			<tr class="{if $invalid.todoDateDue}highlight{/if}">
				<td class="title"><label for="todoDateDue">{"TRANS_DATE_DUE"|lmsg}</label></td>
				<td>{include file="$tplDirectory/widgets/dateSelector.tpl" param="todoDateDue"}{$invalid.todoDateDue}</td>
			</tr>
			<tr class="listButtons">
				<td colspan="2"><div>
					<input class="submit" type="submit" name="submit" value="{"TRANS_ADD_TODO"|lmsg}" />
				</div></td>
			</tr>
			</tbody>
			</table>
			</form>
		</fieldset>
{include file="$tplDirectory/footer.tpl"}
