{* $Id: EditTodo.tpl 10514 2007-01-19 15:19:10Z bsmith $
 * --------------------------------------------------------------
 * This template displays a form to edit a To-Do item. Using the given smarty variable 
 * $todo, the form is prepopulated with the to-do's current information. The 
 * form should post to todos.php, with the action ID for the EditTodoResponse action.
 *
 * Smarty Variables:
 *	$todo  An array of this to-do data. Every element in this array can be considered
 *		   to be one to-do, and as such, every element is an array. Every to-do
 *		   has the following keys:
 *			todoID  -- The ID of the to-do item.
 *			todoTitle  -- The title of the to-do item.
 *			todoDesc -- A short description of the to-do item.
 *			adminID -- The ID of the admin who generated this to-do item.
 *			todoStatusID -- The status of the to-do item.
 *			todoDateDue -- The date and time that this item should be finished before.
 *  $todostatus -- Array of possible statuses for the To Do item. The current status is selected.
 *  $adminlist -- Array of all active admins on the system so that a To-Do can be
 * 				  assigned to any of them. The current admin is selected.
 *}


{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

{include file="$tplDirectory/widgets/showInvalid.tpl" inputInvalid=$inputInvalid}
		<fieldset>
			<legend>{"TRANS_MY_TODO_ITEMS"|lmsg}</legend>
			<form method="post" action="{getFormAction controller="todos"}">
			<input type="hidden" name="act" value="{getActionID action="EditTodoResponse"}" />
			<input type="hidden" name="todoID" value="{$todo.todoID}" />
			<input type="hidden" name="sid" value="{$sid}" />
			
			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
			<tbody>
			<tr class="headerRow">
				<td colspan="2">{"TRANS_TODOS"|lmsg}</td>
			</tr>
			<tr class="{if $invalid.todoTitle}highlight{/if}">
				<td class="title"><label for="todoTitle">{"TRANS_TITLE"|lmsg}</label></td>
				<td><input size="20" maxlength="255" type="text" id="todoTitle" name="todoTitle" value="{$todo.todoTitle}" /> {$invalid.todoTitle}</td>
			</tr>
			<tr class="{if $invalid.todoDesc}highlight{/if}">
				<td class="title"><label for="todoDesc">{"TRANS_DESCRIPTION"|lmsg}</label></td>
				<td><textarea cols="40" rows="5" id="todoDesc" name="todoDesc">{$todo.todoDesc}</textarea> {$invalid.todoDesc}</td>
			</tr>
			<tr class="{if $invalid.todoIsPublic}highlight {/if}">
				<th class="nowrap" scop="row"><label for="todoIsPublic">{"TRANS_ISPUBLIC"|lmsg}</label></td>
				<td><input type="checkbox" id="todoIsPublic" name="todoIsPublic" value="1" {if $todo.todoIsPublic}checked="checked"{/if} /> {$invalid.todoIsPublic}</td>
			</tr>
			<tr class="{if $invalid.todoStatusID}highlight{/if}">
				<td class="title"><label for="todoStatusID">{"TRANS_STATUS"|lmsg}</label></td>
				<td><select id="todoStatusID" name="todoStatusID"> {html_options options=$todostatus selected=$todo.todoStatusID} </select> {$invalid.todoStatusID}</td>
			</tr>
			<tr class="{if $invalid.todoDateDue}highlight{/if}">
				<td class="title"><label for="todoDateDue">{"TRANS_DATE_DUE"|lmsg}</label></td>
				<td>{include file="$tplDirectory/widgets/dateSelector.tpl" param="todoDateDue"}{$invalid.todoDateDue}</td>
			</tr>
			<tr class="listButtons">
				<td colspan="2"><div>
					<input class="submit" type="submit" name="submit" value="{"TRANS_SAVE"|lmsg}" />
			{*		<input class="reset" type="reset" value="{"TRANS_RESET"|lmsg}" /> *}
				</div></td>
			</tr>
			</tbody>
			</table>
			</form>
		</fieldset>
{include file="$tplDirectory/footer.tpl"}
