{* $Id: RemoveTodo.tpl 7627 2006-06-19 21:48:58Z mgarrett $
 * --------------------------------------------------------------
 * This template displays a form to verify the removal of a to-do. This template 
 * is provided an array of information about the to-do about to be removed, and 
 * can display that information to the user. This template should contain a form that 
 * posts the todoID to the RemoveTodoResponse action of todos.php, and also 
 * a cancel option, that returns to the ShowTodos action.
 *
 * Smarty Variables:
 *	$todo  An array of this to-do data. Every element in this array can be considered
 *		   to be one to-do, and as such, every element is an array. Every to-do
 *		   has the following keys:
 *			todoID  -- The ID of the to-do item.
 *			todoTitle  -- The title of the to-do item.
 *			todoDesc -- A short description of the to-do item.
 *			adminID -- The ID of the admin who generated this to-do item.
 *			todoStatusID -- The status of the to-do item.
 *			todoDue -- The date and time that this item should be finished before.
 *}



{include file="$tplDirectory/header.tpl" tabMajor="dashboard" tabMinor="todos"}

		<fieldset>
			<legend>{"TRANS_REMOVE_TODO"|lmsg}</legend>

			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list">
			<thead>
				<tr class="headerRow">
					<td>
						{"TRANS_SUBJECT"|lmsg}
					</td>
					<td>
						{"TRANS_AUTHOR"|lmsg}
					</td>
					<td>
						{"TRANS_ASSIGNED_ADMINS"|lmsg}
					</td>
					<td>
						{"TRANS_STATUS"|lmsg}
					</td>
					<td>
						{"TRANS_DATE_DUE"|lmsg}
					</td>
				</tr>
			</thead>
			<tbody>
				<tr class="alt1">
					<td>{$todo.todoTitle}</td>
					<td>{$todo.admins.0.adminFirstName} {$todo.admins.0.adminLastName} - {$todo.admins.0.adminUsername}</td>
					<td>{$todo.assigned.0.adminFirstName} {$todo.assigned.0.adminLastName} - {$todo.assigned.0.adminUsername}</td>
					<td>{$todo.todoStatusID|getArrayValueByID:$todostatus}</td>
					<td>{$todo.todoDateDue|getDate:medium}</td>
				</tr>
			</tbody>
			</table>
				
			
			<table  width="100%" border="0" cellpadding="0" cellspacing="0" class="list" >
			<tbody>
			<tr>
				<td colspan="5" align="center">
					{"TRANS_REMOVE_TODO_MESG"|lmsg}
				</td>
			</tr>
			<tr class="listButtons">
				<td colspan="5"><div>
					<form style="display: inline;" method="post" action="{getFormAction controller="todos"}">
						<input type="hidden" name="act" value="{getActionID action="RemoveTodoResponse"}" />
						<input type="hidden" name="sid" value="{$sid}" />
						<input type="hidden" name="todoID" value="{$todo.todoID}" />
						<input class="submit" type="submit" name="submit" value="{"TRANS_YES"|lmsg}" />
					</form>
					<form style="display: inline;" method="get" action="{getFormAction}">
						<input type="hidden" name="ctr" value="todos"/>
						<input type="hidden" name="act" value="{getActionID action="ShowTodoDetails"}" />
						<input type="hidden" name="sid" value="{$sid}" />
						<input type="hidden" name="todoID" value="{$todo.todoID}" />
						<input class="submit" type="submit" name="submit" value="{"TRANS_NO"|lmsg}" /><br />
					</form>		
				</div></td>
			</tr>
			</tbody>
			</table>
		</fieldset>

{include file="$tplDirectory/footer.tpl"}
