{* $Id: tableSortAmountHeader.tpl 7027 2006-05-23 22:26:18Z bsmith $
 * --------------------------------------------------------------
 * This widget template is used to display each <th></th> that allows sorting of that column.
 * We only want to allow sort options if the column has infinite values.
 *
 * This widget also builds a special search box for amount columns, that when you click on
 * the header name, will only search this column using amounts!
 *
 * Smarty Variables:
 *	$headerName  	The constant representation of that column name.
 *	$fileName		The file name to submit to
 *	$actionID		The current actionID
 *  $sortColumn		The sort column to pass to the sortLinks widget.
 *	$sortArgs		The sort arguments to pass to the sortLinks widget.
 *	$recordOffset	The current record offset value
 *	$imageDirectory	The image directory for this theme.
 *  $sid			The current sessionID
 *
 * Example Usage:
 *	{include file="$tplDirectory/widgets/table/tableSortHeader.tpl" headerName="TRANS_X" sortColumn="someColumnName"}
 *}

{if $fileName==""}
	{assign var="thisFile" value=$smarty.server.PHP_SELF}
{/if}

{strip}
{if $smarty.request.sortColumn == $sortColumn}
<th class="sortcol"{if $colWidth>0} width="{$colWidth}"{/if}>
{else}
<th{if $colWidth>0} width="{$colWidth}"{/if}>
{/if}
	<table width="100%" cellspacing="0" cellpadding="0" border="0">
	<tr>
		<td align="left" nowrap="nowrap">
			<a href="javascript:void(0);" onclick="return overlib('&lt;form method=\'get\' action=\'{getFormAction}\'&gt;
						&lt;input type=\'hidden\' name=\'ctr\' value=\'{$fileName}\' /&gt;
						&lt;input type=\'hidden\' name=\'act\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'amountColumn\' value=\'{$sortColumn}\' /&gt;
						&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{"TRANS_FIND_EXACT_MATCH"|lmsg}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{"TRANS_AMOUNT"|lmsg}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'amountCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'\' selected=\'selected\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;&lt;input type=\'text\' name=\'amountQuery[]\' value=\'\' size=\'5\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_FIND_EXACT_MATCH"|lmsg}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;
					&lt;form method=\'get\' action=\'{getFormAction}\'&gt;
						&lt;input type=\'hidden\' name=\'ctr\' value=\'{$fileName}\' /&gt;
						&lt;input type=\'hidden\' name=\'act\' value=\'{$actionID}\' /&gt;
						{if $sortColumn}&lt;input type=\'hidden\' name=\'sortColumn\' value=\'{$sortColumn}\' /&gt;{/if}
						{if $sortDir}&lt;input type=\'hidden\' name=\'sortDir\' value=\'{$sortDir}\' /&gt;{/if}
						&lt;input type=\'hidden\' name=\'amountColumn\' value=\'{$sortColumn}\' /&gt;
						&lt;input type=\'hidden\' name=\'sid\' value=\'{$sid}\'&gt;
                        {if $queryArgCol}&lt;input type=\'hidden\' name=\'{$queryArgCol}\' value=\'{$queryArgValue}\'&gt;{/if}
		                &lt;fieldset&gt;
			                &lt;legend&gt;{"TRANS_FIND_AMOUNT_RANGE"|lmsg}&lt;/legend&gt;
							&lt;table width=\'230\'&gt;
							&lt;tr&gt;
								&lt;td width=\'20%\'&gt;{"TRANS_AMOUNT"|lmsg}&lt;/td&gt;
								&lt;td width=\'60%\'&gt;
									&lt;select name=\'amountCompare[]\' style=\'width:100%\'&gt;
										&lt;option value=\'Least\' selected=\'selected\'&gt;{"TRANS_GREATER_THAN"|lmsg}&lt;/option&gt;
										{* &lt;option value=\'\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt; *}
										{* &lt;option value=\'Greatest\'&gt;{"TRANS_LESS_THAN"|lmsg}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td width=\'20%\'&gt;&lt;input type=\'text\' name=\'amountQuery[]\' value=\'\' size=\'5\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'amountBool[]\' style=\'width:100%\'&gt;
										&lt;option value=\'AND\' selected=\'selected\'&gt;{"TRANS_AND"|lmsg}&lt;/option&gt;
										{* &lt;option value=\'OR\'&gt;{"TRANS_OR"|lmsg}&lt;/option&gt; *}
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;{"TRANS_AMOUNT"|lmsg}&lt;/td&gt;
								&lt;td&gt;
									&lt;select name=\'amountCompare[]\' style=\'width:100%\'&gt;
										{* &lt;option value=\'Least\'&gt;{"TRANS_GREATER_THAN"|lmsg}&lt;/option&gt; *}
										{* &lt;option value=\'equal\'&gt;{"TRANS_EQUAL_TO"|lmsg}&lt;/option&gt; *}
										&lt;option value=\'Greatest\' selected=\'selected\'&gt;{"TRANS_LESS_THAN"|lmsg}&lt;/option&gt;
									&lt;/select&gt;
								&lt;/td&gt;
								&lt;td&gt;&lt;input type=\'text\' name=\'amountQuery[]\' value=\'\' size=\'5\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;tr&gt;
								&lt;td&gt;&nbsp;&lt;/td&gt;
								&lt;td colspan=\'2\' align=\'right\'&gt;&lt;input type=\'submit\' name=\'submit\' value=\'{"TRANS_FIND_AMOUNT_RANGE"|lmsg}\' /&gt;&lt;/td&gt;
							&lt;/tr&gt;
							&lt;/table&gt;
						&lt;/fieldset&gt;
					&lt;/form&gt;',
				BGCLASS, 'popupBG',
				FGCLASS, 'popupFG',
				CENTER, STICKY,
				CAPTION, '&nbsp;{"TRANS_QUICK_FIND"|lmsg} {$headerName|lmsg}', CLOSECLICK, CLOSETEXT, '&lt;img src={$imageDirectory}/ico/remove.gif width=13 height=13 border=0 /&gt;');" onmouseout="return nd();">
				<b>{$headerName|lmsg}</b>
			</a>
		</td>
		<td align="right" nowrap="nowrap">
			<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=asc"}">
				<img src="{$imageDirectory}/ico/asc.gif" width="9" height="9" border="0" alt="{"TRANS_SORT_ASC"|lmsg}" title="{"TRANS_SORT_ASC"|lmsg}" />
			</a>
			<a href="{getHREF page=$fileName actionID=$actionID args="$queryArgs&$filterArgs&sortColumn=$sortColumn&sortDir=desc"}">
				<img src="{$imageDirectory}/ico/desc.gif" width="9" height="9" border="0" alt="{"TRANS_SORT_DESC"|lmsg}" title="{"TRANS_SORT_DESC"|lmsg}" />
			</a>
		</td>
	</tr>
	</table>
</th>
{/strip}
