<?php

require_once(dirname(__FILE__)."/../../../../lib-tk/shield.php");

/**
 * This file maintains a list of all states for use in registrar select lists and it is only
 * available for use when the registrar module is called or we are using the domains.php action file.
 *
 * This data should not be used for any other purpose at this time.
 */
global $CONF;
$CONF["states"]["us"] = array(
	"AL" => "Alabama",
	"AK" => "Alaska",
	"AS" => "American Samoa",
	"AZ" => "Arizona",
	"AR" => "Arkansas",
	"CA" => "California",
	"CO" => "Colorado",
	"CT" => "Connecticut",
	"DE" => "Delaware",
	"DC" => "District of Columbia",
	"FM" => "Fed. States of Micronesia",
	"FL" => "Florida",
	"GA" => "Georgia",
	"GU" => "Guam",
	"HI" => "Hawaii",
	"ID" => "Idaho",
	"IL" => "Illinois",
	"IN" => "Indiana",
	"IA" => "Iowa",
	"KS" => "Kansas",
	"KY" => "Kentucky",
	"LA" => "Louisiana",
	"ME" => "Maine",
	"MH" => "Marshall Islands",
	"MD" => "Maryland",
	"MA" => "Massachusetts",
	"MI" => "Michigan",
	"MN" => "Minnesota",
	"MS" => "Mississippi",
	"MO" => "Missouri",
	"MT" => "Montana",
	"NE" => "Nebraska",
	"NV" => "Nevada",
	"NH" => "New Hampshire",
	"NJ" => "New Jersey",
	"NM" => "New Mexico",
	"NY" => "New York",
	"NC" => "North Carolina",
	"ND" => "North Dakota",
	"MP" => "Northern Mariana Is.",
	"OH" => "Ohio",
	"OK" => "Oklahoma",
	"OR" => "Oregon",
	"PW" => "Palau",
	"PA" => "Pennsylvania",
	"PR" => "Puerto Rico",
	"RI" => "Rhode Island",
	"SC" => "South Carolina",
	"SD" => "South Dakota",
	"TN" => "Tennessee",
	"TX" => "Texas",
	"UT" => "Utah",
	"VT" => "Vermont",
	"VA" => "Virginia",
	"VI" => "Virgin Islands",
	"WA" => "Washington",
	"WV" => "West Virginia",
	"WI" => "Wisconsin",
	"WY" => "Wyoming",
	"AA" => "Armed Forces the Americas",
	"AE" => "Armed Forces Europe",
	"AP" => "Armed Forces Pacific",
);

/**
 * Get the string name of the state associated with the given state ID and type. If the given ID
 * is not found, then this function returns false.
 *
 * @param  string  The type of state to lookup
 * @param  string  The id of the state to lookup
 * @return  string  The string name associated with the given ID, or false if the ID was not found
 */
function getStateName($type, $id)
{
	global $CONF;
	$id = strval($id);
	$type = strval($type);
	$retval = false;
	if(is_array($CONF["states"][$type]) && count($CONF["states"][$type])) {
		$retval = $CONF["states"][$type][$id];
	}
	return $retval;
}

/**
 * Returns an array of states of a certain type.
 *
 * @param  string  The type of states to return.
 * @return  array  An array of states of the given type, or literal false if the type was not found.
 */
function getStates($type)
{
	global $CONF;
	$type = strval($type);
	$retval = false;
	if(isset($CONF["states"][$type])) {
		$retval = $CONF["states"][$type];
	}
	return $retval;
}
