<?php

class StoreExceptionCatcherFilter extends sfFilter
{
	
	const MODULE_WIDGET = 'widget';
	
	public function execute($filterChain)
	{
		try {
			$filterChain->execute();
		} catch (StoreException $exception) {
			$user = sfContext::getInstance()->getUser();
			$container = $user->getAttribute('container');
			if (sfContext::getInstance()->getRequest()->isXmlHttpRequest() || sfContext::getInstance()->getRequest()->getParameter('ajax')) {
				sfContext::getInstance()->getController()->redirect('@service-temporary-unavailable?callback='. sfContext::getInstance()->getRequest()->getParameter('callback') . ($container ? '&container=' . $container : ''));
			} else {
				$user->getAttributeHolder()->clear();
				$module = sfContext::getInstance()->getModuleName();
				switch (sfContext::getInstance()->getModuleName()) {
					case self::MODULE_WIDGET:
						$action = sfContext::getInstance()->getActionName();
						sfContext::getInstance()->getController()->redirect('@widget-temporary-unavailable' . (substr($action, -2) == 'JS' ? '-js' : '') . ($container ? '?container=' . $container : ''));
						break;
					default:
						sfContext::getInstance()->getController()->redirect('@store-temporary-unavailable' . ($container ? '?container=' . $container : ''));
				}
			}
			throw new sfStopException();
		}
	}
		
}
