<?php

abstract class CartAction extends sfAction {
	
	const ACTIVITY_BACK = '__back';
	
	protected $_router;
	
	protected $_store;
	
	protected $_container;
	
	protected $_cart;
	
	public function preExecute() {
		try {
			if (!$this->_router = ResourceLocator::getInstance()->routersStack->current()) {
				throw new StoreException('Router is not defined');
			}
			$this->_router->checkByAction($this->getActionName());
			
			$request = sfContext::getInstance()->getRequest();

			if (!$this->_container = sfContext::getInstance()->getUser()->getAttribute('container')) {
				throw new StoreException('Container is not defined');
			}
			
			if ($request->isMethod('post')) {
				switch ($request->getParameter('__activity')) {
					case self::ACTIVITY_BACK:
						if("catalog" == $this->_router->getPreviousPage()->getCode()) {
							sfContext::getInstance()->getConfiguration()->loadHelpers('BillingFormat');
							$this->redirect(formatContinueShoppingUrl($this->_container));
						} else {
							$this->_router->previous();
						}
						return;
						break;
				}
			}
			
			if (!$this->_store = sfContext::getInstance()->getUser()->getAttribute('store')) {
				throw new StoreException('Store is not defined');
			}
			
			$this->_cart = ResourceLocator::getInstance()->cart;
			
			if (isset($this->_store->locale)) {
				$this->getUser()->setCulture($this->_store->locale);
			}
			
			$previewTheme = $this->getUser()->getAttribute('theme');
			$theme = $previewTheme ? $previewTheme : $this->_store->theme;
			sfConfig::set('sf_web_css_dir_name', 'themes/' . $theme . '/css');
			sfConfig::set('sf_web_images_dir_name', 'themes/' . $theme . '/images');
			
			$this->router = $this->_router;
			$this->container = $this->_container;
			$this->currencyId = $this->_store->currencyID;
			
			$this->getResponse()->setTitle($this->_store->orderFormName);
			
		} catch (StoreException $exception) {
			throw new sfError404Exception();
		}
	}
	
}