<?php

class CheckDomainAction extends sfAction {
	
	public function execute($request) {
		$this->setLayout(false);
		sfConfig::set('sf_web_debug', false);
		
		$containerCode = sfContext::getInstance()->getUser()->getAttribute('container');
		$store = sfContext::getInstance()->getUser()->getAttribute('store');
		
		$domainPlanId = $request->getParameter('domainPlanId');
		$domainPlan = $store->getPlan($domainPlanId, true);
		
		$SLD = $request->getParameter('SLD');
		$TLD = $request->getParameter('TLD');
		$masterTLD = $request->getParameter('masterTLD');
		
		$targetDomain = null;
		foreach ($domainPlan->getDomains($store->getId()) as $domain) {
			if ($domain->tldExtension == $TLD) {
				$targetDomain = $domain;
				break;
			}
		}
		
		$parameters = array(
			'currencyId' => $store->currencyID,
			'domain' => $targetDomain,
			'cycles' => $domainPlan->getCycles(),
			'register' => $request->getParameter('operation') == 'register' ? true : false,
			'status' => ResourceLocator::getInstance()->billingDomainService->checkWhois($SLD, array($TLD)),
			'SLD' => $SLD,
			'TLD' => $TLD,
			'masterTLD' => $masterTLD,
			'allowRegister' => in_array('dom_reg', $store->domainOptions),
			'allowTransfer' => in_array('dom_transfer', $store->domainOptions)
		);
		
		sfContext::getInstance()->getConfiguration()->loadHelpers('Partial');
		$content = json_encode(array('content' => get_partial('cart/checkDomain', $parameters)));
		
		$callback = $request->getParameter('callback');
		
		return $this->renderText($callback . '(' . $content . ');');
	}
	
}