<?php

class SignInAction extends CartAction {

	const OPERATION_FORGOT_PASSWORD = 'forgot-password';

	public function execute($request) {
		
		$this->form = new BillingSignInForm(array(
			array(
				'inputs' => array(
					array(
						'id' => 'login',
						'type' => 'text',
						'title' => 'TRANS_USERNAME',
						'required' => true
					),
					array(
						'id' => 'password',
						'type' => 'password',
						'title' => 'TRANS_PASSWORD',
						'required' => true
					)
				)
			)
		));
		if (!is_null($infoMessage = sfContext::getInstance()->getUser()->getAttribute('infoMessage'))) {
			$this->info = $infoMessage;
			sfContext::getInstance()->getUser()->setAttribute('infoMessage', NULL);
		}
		if ($request->isMethod('post')) {
			try {
				$operation = $request->getParameter('operation');
				switch ($operation) {
					case self::OPERATION_FORGOT_PASSWORD:
						$router = new Router();
						$router->init(
							array(
								new RouterPage(self::OPERATION_FORGOT_PASSWORD),
								new RouterPage('sign-in')
							),
							new RouterPage('sign-in')
						);
						ResourceLocator::getInstance()->routersStack->push($router);
						$router->next();
						break;
					default:
						$this->form->bind($request->getParameter($this->form->getName()));
						if (!$this->form->isValid()) {
							throw new BillingFormException();
						}
						$this->form->save();
						$this->_router->next();
				}
			} catch (StoreException $exception) {
				$this->error = 'TRANS_LOGIN_INCORRECT';
			}
		} else {
			
		}
		
	}
	
}