<?php use_helper('BillingFormat'); ?>
<div id="main" class="">

	<div class="p-store-order">

		<?php include_partial('navigationBar', array('router' => $router)); ?>

		<div class="p-box">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>

			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
				<div class="p-box-title p-box-title-1">
					<div class="p-box-title-area">
						<h1><span><?php echo __('TRANS_SELECTED_PLANS_SUMMARY'); ?></span></h1>
					</div>
				</div>
				<div class="p-box-content">
					<div class="b-description"><p><?php echo __('TRANS_SELECTED_PLANS_SUMMARY_DESCR'); ?></p></div>
					
					<?php if (isset($couponSuccessMessage)): ?>
					<div class="p-box p-box-info-msg">
						<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
						<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
							<div class="p-box-content">
								<span class="msg-title"><?php echo __('TRANS_INFO'); ?>:</span> <?php echo __($couponSuccessMessage, array('%NAMES%' => $couponSuccessNames)); ?>
							</div>
						</div></div></div>
						<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
					</div>
					<?php endif; ?>
					
					<?php if (isset($errorMessage)): ?>
					<?php include_partial('errorMessage', array('message' => $errorMessage)); ?>
					<?php endif; ?>
					
					<form id="actionForm" action="<?php echo url_for('@summary'); ?>" method="post">
						<input type="hidden" name="cartItemId" value=""/>
						<input type="hidden" name="purchaseId" value=""/>
						<input type="hidden" name="domainName" value=""/>
						<input type="hidden" name="addonId" value=""/>
						<input type="hidden" name="operation" value=""/>
					</form>
					
					<script type="text/javascript">
					
						function addDomain(cartItemId, purchaseId) {
							$('#actionForm > input[name="cartItemId"]').val(cartItemId);
							$('#actionForm > input[name="purchaseId"]').val(purchaseId);
							$('#actionForm > input[name="operation"]').val('add-domain');
							$('#actionForm').submit();
						}
						
						function removePurchase(id) {
							$('#actionForm > input[name="purchaseId"]').val(id);
							$('#actionForm > input[name="operation"]').val('remove-purchase');
							$('#actionForm').submit();
						}

						function removeOwnDomain(id, domainName) {
							$('#actionForm > input[name="purchaseId"]').val(id);
							$('#actionForm > input[name="domainName"]').val(domainName);
							$('#actionForm > input[name="operation"]').val('remove-own-domain');
							$('#actionForm').submit();
						}

						function removeAddon(purchaseId, addonId) {
							$('#actionForm > input[name="purchaseId"]').val(purchaseId);
							$('#actionForm > input[name="addonId"]').val(addonId);
							$('#actionForm > input[name="operation"]').val('remove-addon');
							$('#actionForm').submit();
						}

						function addAddons(cartItemId) {
							$('#actionForm > input[name="cartItemId"]').val(cartItemId);
							$('#actionForm > input[name="operation"]').val('add-addons');
							$('#actionForm').submit();
						}

						function continueOrder() {
							$('#actionForm > input[name="operation"]').val('continue-order');
							$('#actionForm').submit();
						}
						
					</script>
					
					<?php if ($cartItemsData->getRawValue()): ?>
					
					<?php foreach ($cartItemsData as $cartItemId => $purchasesData): ?>
					
					<div class="b-summary">
						
						<?php foreach ($purchasesData as $purchaseId => $purchaseData): ?>
						
						<table class="t-summary">
							<tbody>
								<tr>
									<td class="t-summary-item-name"><?php echo $purchaseData['type']; ?></td>
									<td class="t-summary-item-value">
										<div class="item-name"><b><?php echo formatProductName($purchaseData['name']); ?></b></div>
										<div class="item-links">
											<?php if ($purchaseData['hasAddDomainAbility']): ?>
											<a href="#" onclick="addDomain('<?php echo $cartItemId; ?>', '<?php echo $purchaseData['id']; ?>'); return false;">Add domain</a>
											<?php endif; ?>
											<a href="#" onclick="removePurchase('<?php echo $purchaseData['id']; ?>'); return false;">Remove</a>
										</div>
									</td>
									<td class="t-summary-item-price">
										<?php if ($purchaseData['useTransferFee']): ?>
										<span><b><?php echo formatPrice($purchaseData['price']->getTransferFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($purchaseData['cycle']->cycleDisplayName); ?></span>
										<?php include_partial('catalog/priceAdditionalData', array('price' => $purchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true, 'useTransferFee' => true)); ?>
										<?php else: ?>
										<span><b><?php echo formatPrice($purchaseData['price']->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($purchaseData['cycle']->cycleDisplayName); ?></span>
										<?php include_partial('catalog/priceAdditionalData', array('price' => $purchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true)); ?>
										<?php endif; ?>
									</td>
								</tr>
							</tbody>
						</table>
						
						<?php if ($purchaseData['purchases'] || $purchaseData['addons'] || $purchaseData['hasAddAddonAbility']): ?>
						<div class="b-summary-inner">
							<table class="t-summary">
								<tbody>
									<?php foreach ($purchaseData['purchases'] as $subPurchaseData): ?>
											<tr>
												<td class="t-summary-item-name"><?php echo $subPurchaseData['type']; ?></td>
												<td class="t-summary-item-value">
													<div class="item-name"><b><?php echo formatProductName($subPurchaseData['name']); ?></b></div>
													<div class="item-links">
														<?php if ($subPurchaseData['hasAddDomainAbility']): ?>
														<a href="#" onclick="addDomain('<?php echo $cartItemId; ?>', '<?php echo $subPurchaseData['id']; ?>'); return false;">Add domain</a>
														<?php endif; ?>
														<a href="#" onclick="removePurchase('<?php echo $subPurchaseData['id']; ?>'); return false;">Remove</a>
													</div>
												</td>
												<td class="t-summary-item-price">
													<?php if ($subPurchaseData['price']): ?>
													<?php if ($subPurchaseData['useTransferFee']): ?>
													<span><b><?php echo formatPrice($subPurchaseData['price']->getTransferFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($subPurchaseData['cycle']->cycleDisplayName); ?></span>
													<?php include_partial('catalog/priceAdditionalData', array('price' => $subPurchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true, 'useTransferFee' => true)); ?>
													<?php else: ?>
													<span><b><?php echo formatPrice($subPurchaseData['price']->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($subPurchaseData['cycle']->cycleDisplayName); ?></span>
													<?php include_partial('catalog/priceAdditionalData', array('price' => $subPurchaseData['price'], 'currencyId' => $currencyId, 'displayTaxes' => true)); ?>
													<?php endif; ?>
													<?php else: ?>
													&nbsp;
													<?php endif; ?>
												</td>
											</tr>
									<?php endforeach; ?>
									<?php foreach ($purchaseData['ownDomains'] as $ownDomains): ?>
										<?php foreach ($ownDomains as $ownDomain): ?>
											<tr>
												<td class="t-summary-item-name"><?php echo $ownDomain['type']; ?></td>
												<td class="t-summary-item-value">
													<div class="item-name"><b><?php echo formatProductName($ownDomain['name']); ?></b></div>
													<div class="item-links">
														<?php if ($ownDomain['hasAddDomainAbility']): ?>
														<a href="#" onclick="addDomain('<?php echo $cartItemId; ?>', '<?php echo $ownDomain['id']; ?>'); return false;">Add domain</a>
														<?php endif; ?>
														<?php if ($ownDomain['fake']): ?>
														<a href="#" onclick="removeOwnDomain('<?php echo $purchaseId; ?>', '<?php echo $ownDomain['name']; ?>'); return false;">Remove</a>
														<?php endif; ?>
													</div>
												</td>
												<td class="t-summary-item-price">
													<?php if ($ownDomain['price']): ?>
													<?php if ($ownDomain['useTransferFee']): ?>
													<span><b><?php echo formatPrice($ownDomain['price']->getTransferFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($ownDomain['cycle']->cycleDisplayName); ?></span>
													<?php include_partial('catalog/priceAdditionalData', array('price' => $ownDomain['price'], 'currencyId' => $currencyId, 'displayTaxes' => true, 'useTransferFee' => true)); ?>
													<?php else: ?>
													<span><b><?php echo formatPrice($ownDomain['price']->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($ownDomain['cycle']->cycleDisplayName); ?></span>
													<?php include_partial('catalog/priceAdditionalData', array('price' => $ownDomain['price'], 'currencyId' => $currencyId, 'displayTaxes' => true)); ?>
													<?php endif; ?>
													<?php else: ?>
													&nbsp;
													<?php endif; ?>
												</td>
											</tr>
										<?php endforeach; ?>
									<?php endforeach; ?>
									<?php if (sizeof($purchaseData['addons'])): ?>
									<?php for ($i = 0; $i < sizeof($purchaseData['addons']); $i++): ?>
									<tr>
										<td class="<?php if ($i == 0): ?>t-summary-item-name<?php else: ?>t-summary-item-name-empty<?php endif; ?>"><?php if ($i == 0): ?>Additional Features<?php else: ?>&nbsp;<?php endif; ?></td>
										<td class="t-summary-item-value">
											<div class="item-name"><b><?php echo $purchaseData['addons'][$i]['name']; ?></b></div>
											<div class="item-links"><a href="#" onclick="removeAddon('<?php echo $purchaseData['id']; ?>', '<?php echo $purchaseData['addons'][$i]['id']; ?>'); return false;">Remove</a></div>
											<?php if ($i == sizeof($purchaseData['addons']) - 1): ?>
											<div class="item-btns"><a class="btn" href="#" onclick="addAddons('<?php echo $cartItemId; ?>'); return false;"><span><i><?php echo __('TRANS_ADD_MORE_FEATURES');?></i></span></a></div>
											<?php endif; ?>
										</td>
										<td class="t-summary-item-price">
											<span><b><?php echo formatPrice($purchaseData['addons'][$i]['price']->getCycleFee(), $currencyId); ?></b> <?php echo __('TRANS_STORE_FOR_CYCLE'); ?> <?php echo __($purchaseData['addons'][$i]['cycle']->cycleDisplayName); ?></span>
											<?php include_partial('catalog/priceAdditionalData', array('price' => $purchaseData['addons'][$i]['price'], 'currencyId' => $currencyId, 'displayTaxes' => true)); ?>
										</td>
									</tr>
									<?php endfor; ?>
									<?php elseif ($purchaseData['hasAddAddonAbility']): ?>
									<tr>
										<td class="t-summary-item-name"><?php echo __('TRANS_ADDITIONAL_FEATURES');?></td>
										<td class="t-summary-item-value">
											<div class="description"><?php echo __('TRANS_ADDITIONAL_FEATURES_DESCR');?></div>
											<div class="item-btns"><a class="btn" href="#" onclick="addAddons('<?php echo $cartItemId; ?>'); return false;"><span><i><?php echo __('TRANS_ADD_MORE_FEATURES');?></i></span></a></div>
										</td>
										<td class="t-summary-item-price"><span>&nbsp;</span></td>
									</tr>
									<?php endif; ?>
								</tbody>
							</table>
						</div>
						<?php endif; ?>
						
						<?php endforeach; ?>
						
					</div>
					
					<?php endforeach; ?>
					
					<div class="b-summary">
						<div class="b-summary-price-total">
							<table class="t-price-total">
								<tr>
									<td class="name"><?php echo __('TRANS_ORDERFORM_SUBTOTAL');?>:</td>
									<td class="t-summary-item-price"><b><?php echo formatPrice($amount, $currencyId); ?></b></td>
								</tr>
								<tr>
									<td class="name"><?php echo __('TRANS_TAX_ZONE_AMOUNT');?>:</td>
									<td class="t-summary-item-price"><b><?php echo formatPrice($totalAmount - $amount, $currencyId); ?></b></td>
								</tr>
								<tr class="t-summary-item-total">
									<td class="name"><b><?php echo __('TRANS_TOTAL');?>:</b></td>
									<td class="t-summary-item-price"><b><?php echo formatPrice($totalAmount, $currencyId); ?></b></td>
								</tr>
								<?php if ($minimalCycle): ?>
								<tr>
									<td class="name"><?php echo __('TRANS_MINIMAL_CONTRACT_TERM');?>:</td>
									<td class="t-summary-item-price"><b><?php echo __($minimalCycle->cycleDisplayName); ?></b></td>
								</tr>
								<?php endif; ?>
							</table>
						</div>
					</div>
					
					<?php else: ?>
					
					<div class="b-description"><p><?php echo __('TRANS_NO_PRODUCTS_IN_CART'); ?> <a href="<?php echo formatContinueShoppingUrl($container); ?>"><?php echo __('TRANS_BUY_SOMETHING_NOW'); ?></a></p></div>
					
					<?php endif; ?>

				</div>

			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>
		
		<?php if ($cartItemsData->getRawValue()): ?>
		<div class="p-box">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
				<div class="p-box-title p-box-title-1">
					<div class="p-box-title-area">
						<h1><span><?php echo __('TRANS_ORDERFORM_COUPON_APPLY'); ?></span></h1>
					</div>
				</div>
				<div class="p-box-content">
					<p><?php echo __('TRANS_COUPONS_DESCR'); ?></p>
					<div class="b-form">
						<form id="couponForm" action="<?php url_for('@summary'); ?>" method="post" autocomplete="off">
							<input type="hidden" name="operation" value="apply-coupon"/>
							<table class="t-form">
								<tbody>
									<tr>
										<td class="field-name"><?php echo __('TRANS_ORDERFORM_ENTER_COUPON'); ?></td>
										<td class="field-value">
											<input type="text" class="input-text domain-name" onblur="this.value=this.value.toLowerCase();" name="coupon"/>
											<a class="btn" href="#" onclick="$('#couponForm').submit(); return false;"><span><i><?php echo __('TRANS_APPLY'); ?></i></span></a>
										</td>
									</tr>
								</tbody>
							</table>
						</form>
					</div>
				</div>
			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>
		<?php endif; ?>
		
		<div class="p-box p-box-note">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
				<div class="p-box-content">
					<a class="btn btn-note" href="<?php echo formatContinueShoppingUrl($container); ?>"><span><i><?php echo __('TRANS_CONTINUE_SHOPPING'); ?></i></span></a>
					<div class="note note-buy"><i class="b-icon"><i></i></i><?php echo __('TRANS_CONTINUE_SHOPPING_DESCR'); ?></div>
				</div>
			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>
		
		<div class="p-store-actions">
			<div class="p-store-actions-area">
				<a class="back-link" href="<?php echo formatContinueShoppingUrl($container); ?>"><span><?php echo __('TRANS_BACK_TO'); ?>&nbsp;<?php echo __('TRANS_PAGE_PLANS_OVERVIEW'); ?></span></a>
				<?php if ($cartItemsData->getRawValue()): ?>
				<a id="checkout" class="btn btn-action" href="#" onclick="continueOrder(); return false;"><span><i><?php echo __('TRANS_CHECKOUT'); ?></i></span></a>
				<?php endif; ?>
			</div>
		</div>

		<?php if (isset($taxZone)): ?>
		<div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
		<?php endif; ?>

	</div> <!--/p-store-order-->

</div> <!--/#main-->