<?php

class BuyDomainAction extends CatalogAction {
	
	public function execute($request) {
		
		$planId = $request->getParameter('plan');
		$plan = $this->_store->getPlan($planId);
		
		$cart = ResourceLocator::getInstance()->cart;
		$cartItem = new CartItem($planId);
		
		$cart->setCurrentItem($cartItem);
		
		if(!PurchaseManager::purchaseDomains($request, $this->_store, $cart, $plan, $duplicatedDomains, $registeredDomains)) {
			sfContext::getInstance()->getConfiguration()->loadHelpers('I18N');
			if ($duplicatedDomains) {
				$errorMessage = __('TRANS_DUPLICATE_DOMAINS', array('%DOMAINS%' => implode(', ', $duplicatedDomains)));
			} else if($registeredDomains) {
				$errorMessage = __('TRANS_DUPLICATE_REGISTERED_DOMAINS', array('%DOMAINS%' => implode(', ', $registeredDomains)));
			} else {
				$errorMessage = 'TRANS_YOU_MUST_SELECT_AT_LEAST_ONE_DOMAIN';
			}
			sfContext::getInstance()->getUser()->setAttribute('errorMessage', $errorMessage);
		}

		$initialPage = new RouterPage('catalog', array('container' => $this->_container));

		$steps = array(
			new RouterPage('select-addons'),
			new RouterPage('add-purchase'),
			new RouterPage('summary'),
			new RouterPage('contact-information'),
			new RouterPage('order-details'),
			new RouterPage('confirmation'),
			new RouterPage('thank-you')
		);

		$router = new Router();
		$router->init($steps, $initialPage);

		ResourceLocator::getInstance()->routersStack->push($router);
		$router->next();

		return sfView::NONE;

	}
}