<?php

class Page404Action extends sfAction {
	public function execute($request) {
		
		$store = null;
		
		// Try to get store for display 404 page in more appropriate form
		try {
			$container = $this->getRequest()->getParameter('container', false);
			if (!$container) {
				$store = ResourceLocator::getInstance()->billingStoreService->getDefault();
			} else {
				if ($widget = ResourceLocator::getInstance()->billingWidgetService->getByCode($container)) {
					$store = $this->_widget->getStore();
				} else {
					$store = ResourceLocator::getInstance()->billingStoreService->getByCode($container);
				}
			}
		} catch (StoreException $exception) {
		}
		
		if ($store) {
			if (isset($store->locale)) {
				$this->getUser()->setCulture($store->locale);
			}
			$theme = $store->theme;
			sfConfig::set('sf_web_css_dir_name', 'themes/' . $theme . '/css');
			sfConfig::set('sf_web_images_dir_name', 'themes/' . $theme . '/images');
			$this->getResponse()->setTitle($store->orderFormName);
		} else {
			sfConfig::set('sf_web_css_dir_name', 'themes/default/css');
			sfConfig::set('sf_web_images_dir_name', 'themes/default/images');
		}
		
		$this->store = $store;
		
	}
}