<?php use_helper('BillingPlan'); ?>
<div id="main" class="l-type-2">
	<div class="p-store">
		<div class="heading">
			<div class="heading-area">
				<div class="heading-actions">
					<a href="<?php echo url_for('@comparison?container=' . $container, isset($absoluteUrls) ? $absoluteUrls : false); ?>"><span><?php echo __('TRANS_SEE_HOSTING_PLAN_COMP_CHART'); ?></span></a>
				</div>
				<h1><span><?php echo __('TRANS_WELCOME_TO_OUR_STORE'); ?></span></h1>
			</div>
		</div>
		<?php include_partial('catalog/goToCheckoutBox', array('purchasesCount' => $purchasesCount)); ?>
		<?php foreach ($plans as $planId => $plan): ?>
		<div class="p-box">
			<div class="p-box-tl"><div class="p-box-tr"><div class="p-box-tc"><!----></div></div></div>
			<div class="p-box-ml"><div class="p-box-mr"><div class="p-box-mc">
				<div class="p-box-title p-box-title-2">
					<div class="p-box-title-area clearfix">
						<div class="b-plan-actions">
							<?php include_partial('catalog/planActionsRow', array('container' => $container, 'store' => $store, 'plan' => $plan, 'currencyId' => $currencyId, 'absoluteUrls' => isset($absoluteUrls) ? $absoluteUrls : false)); ?>
						</div>
						<h2><span><?php echo $plan->productName; ?></span></h2>
					</div>
				</div>
				<div class="p-box-content">
					<div class="b-plan">
						<div class="b-plan-description"><p><?php echo $plan->productComments; ?></p></div>
						<div class="b-plan-details">
						<?php $plan->getRawValue() instanceof BillingDomainPlan ? 'dom' : 'no'; ?>
							<?php if($plan->getRawValue() instanceof BillingDomainPlan) : ?>
								<?php $TLDs = $plan->getTLDsForCatalog($store->getId()); ?>
								<?php if(count($TLDs)) : ?>
									<ul class="b-plan-items">
										<?php foreach($plan->getTLDsForCatalog($store->getId()) as $TLD) : ?>
											<li><span><?php echo $TLD; ?></span></li>
										<?php endforeach; ?>
									</ul>
									<?php if(count($TLDs) < count($plan->getDomains($store->getId()))) : ?>
										<div class="b-plan-description"><p>
											<?php echo __('TRANS_TLDS_MORE', array('%COUNT%' => count($plan->getDomains($store->getId())) - count($TLDs))); ?>
										</p></div>
									<?php endif; ?>
								<?php endif; ?>
							<?php else : ?>
								<ul class="b-plan-items">
									<?php foreach (preparePlanAttributes($plan->getRawValue()) as $value): ?>
										<li><span><?php echo $value; ?></span></li>
									<?php endforeach; ?>
								</ul>
							<?php endif; ?>
						</div>
					</div>
				</div>
			</div></div></div>
			<div class="p-box-bl"><div class="p-box-br"><div class="p-box-bc"><!----></div></div></div>
		</div>
		<?php endforeach; ?>
		<?php if (isset($taxZone)): ?>
		<div class="b-note-tax"><?php echo __('TRANS_INCLUDE_TAX_TO_PRODUCT_PRICES', array('%NAME%' => $taxZone->taxZoneDescription, '%AMOUNT%' => formatTax($taxZone->getRawValue(), $currencyId))); ?></div>
		<?php endif; ?>
	</div>
</div>