<?php

class AvailableThemesAction extends sfAction {

	public function execute($request) {
		$this->setLayout(false);
		sfConfig::set('sf_web_debug', false);
		sfContext::getInstance()->getConfiguration()->loadHelpers('Asset');

		$themes = array();

		$themesDir = sfConfig::get('sf_web_dir') . "themes";
		foreach ( new DirectoryIterator($themesDir) as $themeDir ) {
			if(!$themeDir->isDir()) {
				continue;
			}
			$configFile = $themeDir->getPathname()."/config.ini";
			if(!file_exists($configFile)) {
				continue;
			}

			$themeInfo = parse_ini_file($configFile);
			if(!isset($themeInfo["name"]) || !isset($themeInfo["code"])) {
				continue;
			}
			if(isset($themes["code"])) {
				continue;
			}

			$themeInfo["description"] = isset($themeInfo["description"]) ? $themeInfo["description"] : "";

			if(isset($themeInfo["preview_icon"]) && file_exists($themeDir->getPathname()."/".$themeInfo["preview_icon"])) {
				sfConfig::set("sf_web_images_dir_name", "themes/{$themeDir->getFilename()}");
				$themeInfo["preview_icon"] =  image_path($themeInfo["preview_icon"], array("absolute" => true));
			} else {
				unset($themeInfo["preview_icon"]);
			}

			$themes[$themeInfo["code"]] = $themeInfo;
		}
		return $this->renderText(json_encode($themes));
	}
}