<?php

abstract class BillingObject {
	
	protected $_data;
	
	public function getId() {
		return $this->_extractId();
	}
	
	public function __construct($data) {
		$this->_data = $data;
	}
	
	public function __get($name) {
		if (isset($this->_data[$name])) {
			return $this->_data[$name];
		} else {
			return null;
		}
	}
	
	public function __isset($name) {
		return isset($this->_data[$name]) ? true : false;
	}
	
	public function getData() {
		return $this->_data;
	}
	
	abstract protected function _extractId();
	
}