<?php

class BillingServiceResponse {
	
	private $_data;
	
	private $_errors;
	
	private $_violations;
	
	public function __construct(stdClass $object) {
		$this->_data = $object->data;
		$this->_errors = $object->errors;
		$this->_violations = isset($object->constraintValidation) ? $object->constraintValidation : array();
	}
	
	public function getData() {
		return $this->_data;
	}
	
	public function hasErrors() {
		return !empty($this->_errors);
	}
	
	public function getErrors() {
		return $this->_errors;
	}
	
	public function getViolations() {
		return $this->_violations;
	}
	
	public function hasViolations() {
		return $this->_violations;
	}
	
	public function __get($name) {
        
        if (!is_array($this->_data) || isset($this->_data[$name])) {
            throw new BillingServiceException('Requested field "'. $name .'" does not exist in responce data');
        }

		return $this->_data[$name];
	}
	
}