<?php

class BillingAddon extends BillingProduct {
	
	private $_variants = null;
	
	private $_cycles = null;
	
	public function getVariants() {
		if (is_null($this->_variants)) {
			if (!isset($this->productVariants)) {
				throw new BillingObjectException('Variants section does not exist in plan data');
			}
			$this->_variants = array();
			foreach ($this->productVariants as $data) {
				$variant = new BillingVariant($data);
				$this->_variants[$variant->getId()] = $variant;
			}
		}
		return $this->_variants;
	}
	
	public function getCycles() {
		if (is_null($this->_cycles)) {
			if (!isset($this->cycles)) {
				throw new BillingObjectException('Cycles section does not exist in plan data');
			}
			$this->_cycles = array();
			foreach ($this->cycles as $data) {
				$cycle = new BillingCycle($data);
				$this->_cycles[$cycle->getId()] = $cycle;
			}
		}
		return $this->_cycles;
	}
	
public function getCycle($id) {
		$cycles = $this->getCycles();
		return isset($cycles[$id]) ? $cycles[$id] : null;
	}
	
	public function getPrice() {
		$result = null;
		if ($variants = $this->getVariants()) {
			$variant = array_shift($variants);
			if ($prices = $variant->getPrices()) {
				$result = array_shift($prices);
			}
		}
		return $result;
	}
	
	protected function _extractId() {
		return $this->productID;
	}
	
}