<?php

class BillingAddonGroup extends BillingObject {
	
	const CHOICE_TYPE_RADIO = 'r';
	
	private $_addons = null;
	
	public function getAddons() {
		if (is_null($this->_addons)) {
			if (!isset($this->addons)) {
				throw new BillingObjectException('Addons section does not exist in plan data');
			}
			$this->_addons = array();
			foreach ($this->addons as $data) {
				$addon = new BillingAddon($data);
				$this->_addons[$addon->getId()] = $addon;
			}
		}
		return $this->_addons;
	}
	
	public function getAddon($id) {
		$addons = $this->getAddons();
		if (!isset($addons[$id])) {
			throw new BillingObjectException('Can not retrieve addon [' . $id . ']');
		}
		return $addons[$id];
	}
	
	public function hasAddon($id) {
		$addons = $this->getAddons();
		return isset($addons[$id]) ? true : false;
	}
	
	public function hasAddons() {
		return $this->getAddons() ? true : false;
	}
	
	public function multichoice() {
		return $this->productAddonGroupInputType == self::CHOICE_TYPE_RADIO ? false : true;
	}
	
	protected function _extractId() {
		return $this->productAddonGroupID;
	}
	
}