<?php

class BillingDomain extends BillingObject {
	
	private $_prices = null;
	
	public function getPrices() {
		if (is_null($this->_prices)) {
			if (!isset($this->prices)) {
				throw new BillingObjectException('Prices section does not exist in domain data');
			}
			$this->_prices = array();
			foreach ($this->prices as $data) {
				$price = new BillingPrice($data);
				$this->_prices[$price->getId()] = $price;
			}
		}
		return $this->_prices;
	}
	
	public function getTransferPrices() {
		$result = array();
		foreach ($this->getPrices() as $price) {
			if ($price->hasTransferFee()) {
				$result[$price->getId()] = $price;
			}
		}
		return $result;
	}
	
	public function hasTransferPrices() {
		$result = false;
		foreach ($this->getPrices() as $price) {
			if ($result = $price->hasTransferFee()) {
				break;
			}
		}
		return $result;
	}
	
	protected function _extractId() {
		return $this->tldID;
	}
	
}