<?php

class BillingVariant extends BillingObject {
	
	private $_prices = null;
	
	public function getPrices() {
		if (is_null($this->_prices)) {
			$this->_prices = array();
			if (isset($this->prices)) {
				foreach ($this->prices as $data) {
					$price = new BillingPrice($data);
					if ($price->hasCycleFee()) {
						$this->_prices[$price->getId()] = $price;
					}
				}
			}
		}
		return $this->_prices;
	}
	
	public function getPricesByCurrency($currencyId) {
		$result = array();
		foreach ($this->getPrices() as $price) {
			if ($price->currencyID == $currencyId) {
				$result[] = $price;
			}
		}
		return $result;
	}
	
	public function getPrice($cycleId, $currencyId) {
		$result = null;
		foreach ($this->getPrices() as $price) {
			if ($price->cycleID == $cycleId && $price->currencyID == $currencyId) {
				$result = $price;
				break;
			}
		}
		return $result;
	}
	
	public function getPriceById($id) {
		$result = null;
		foreach ($this->getPrices() as $price) {
			if ($price->getId() == $id) {
				$result = $price;
				break;
			}
		}
		return $result;
	}
	
	public function hasPrices($currencyId) {
		$result = false;
		foreach ($this->getPrices() as $price) {
			if ($result = $price->currencyID == $currencyId) {
				break;
			}
		}
		return $result;
	}
	
	public function getPricesCount($currencyId) {
		$count = 0;
		foreach ($this->getPrices() as $price) {
			if ($price->currencyID == $currencyId) {
				$count++;
			}
		}
		return $count;
	}
	
	protected function _extractId() {
		return $this->productVariantID;
	}
	
}