<?php

class BillingAccountService extends BillingService {
	
	protected static $instance = null;
	
	public function getCreateAccountForm($storeId) {
		$response = $this->executeGetAccountParams($storeId, ResourceLocator::getInstance()->customer->getContactID());
		if ($response->hasErrors()) {
			throw new BillingServiceException('Can not retrieve account form for Store with id "' . $storeId . '"');
		} else {
			return new BillingAccountForm($response->getData());
		}
		
	}
	
	public function collectAccountForm($storeId, $values) {
		
		$response = $this->executeCollectAccountParams($storeId, ResourceLocator::getInstance()->customer->getContactID(), $values);
		return new CollectFormResult($response->getErrors(), $response->getViolations(), $response->getData());

	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('account'));
		}
		return self::$instance;
	}
	
}