<?php

class BillingAddonGroupService extends BillingService{
	
	protected static $instance = null;
	
	private $_addonGroups = array();
	
	public function getByPlan($planId, $storeId, $cycleId, $ids = array(), $anonymously = false) {
		$key = $planId . ':' . $storeId . ':' . $cycleId;
		$result = array();
		if (!$ids) {
			if (!isset($this->_addonGroups[$key])) {
				$this->_addonGroups[$key] = $this->_getByPlan($planId, $storeId, $cycleId, array(), $anonymously);
			}
			$result = $this->_addonGroups[$key];
		} else {
			if (!isset($this->_addonGroups[$key])) {
				$result = $this->_getByPlan($planId, $storeId, $cycleId, $ids, $anonymously);
			} else {
				foreach ($ids as $id) {
					if (isset($this->_addonGroups[$key][$id])) {
						$result[$id] = $this->_addonGroups[$key][$id];
					}
				}
			}
		}
		return $result;
	}
	
	private function _getByPlan($planId, $storeId, $cycleId, $ids = array(), $anonymously = false) {
		if (!$anonymously && ($customer = sfContext::getInstance()->getUser()->getAttribute('customer'))) {
			$clientId = $customer->getId();
		} else {
			$clientId = null;
		}
		
		$addonGroups = array();
		$responce = $this->executeGetAddons($storeId, $planId, $cycleId, $clientId, array(), $ids);
		if (!$responce->hasErrors()) {
			foreach ($responce->getData() as $data) {
				$addonGroups[] = new BillingAddonGroup($data);
			}
		}
		
		return $addonGroups;
	}
	
	public function getCountByPlan($planId, $storeId, $cycleId) {
		$count = 0;
		
		$responce = $this->executeGetAddons($storeId, $planId, $cycleId, null);
		if (!$responce->hasErrors()) {
			foreach ($responce->getData() as $data) {
				$count++;
			}
		}
		
		return $count;
	}
	
	public function hasByPlan($planId, $storeId, $cycleId) {
		return $this->executeGetAddons($storeId, $planId, $cycleId, null)->hasErrors() ? false : true;
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('product'));
		}
		return self::$instance;
	}
	
}