<?php

class BillingAddonService extends BillingService{
	
	protected static $instance = null;
	
	public function getById($addonId, $planId, $storeId, $cycleId, $couponId = false, $anonymously = false) {
		$clientId = (!$anonymously && ($customer = sfContext::getInstance()->getUser()->getAttribute('customer'))) ? $customer->getId() : null;
		$customerData = sfContext::getInstance()->getUser()->getAttribute('customerData', array());
		$addon = null;
		$responce = $this->executeGetAddons($storeId, $planId, $cycleId, $clientId, $customerData, array(), $couponId ? array($couponId) : array());
		if (!$responce->hasErrors()) {
			foreach ($responce->getData() as $data) {
				$addonGroup = new BillingAddonGroup($data);
				if ($addonGroup->hasAddon($addonId)) {
					$addon = $addonGroup->getAddon($addonId);
					break;
				}
			}
		}
		if (!$addon) {
			throw new BillingObjectException('Addon with id "' . $addonId . '" not found');
		}
		return $addon;
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('product'));
		}
		return self::$instance;
	}
	
}