<?php

class BillingCertificateService extends BillingService {
	
	protected static $instance = null;
	
	public function getCertificateDetailsForm($storeId, $planId) {

		$response = $this->executeGetCertParams($storeId, $planId, ResourceLocator::getInstance()->customer->getContactID(), ResourceLocator::getInstance()->customer->getCustomerData());
		if ($response->hasErrors()) {
			throw new BillingServiceException('Can not retrieve certificate details form for Store with id "' . $storeId . '"');
		}

		return new BillingCertificateDetailsForm($response->getData());
		
	}
	
	public function collectCertificateDetailsForm($storeId, $planId, $values) {
		$response = $this->executeGenerateCSR($storeId, $planId, $values);
		return new CollectFormResult($response->getErrors(), $response->getViolations(), $response->getData());
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('certificate'));
		}
		return self::$instance;
	}
	
}