<?php

class BillingCouponService extends BillingService {
	
	protected static $instance = null;
	
	public function applyCoupon($storeId, $planIds, $couponCode, &$ids) {
		$clientId = ($customer = sfContext::getInstance()->getUser()->getAttribute('customer')) ? $customer->getId() : null;
		$responce = $this->executeIsValidCoupon($storeId, $planIds, $couponCode, $clientId);
		if ($responce->hasErrors()) {
			throw new BillingObjectException('This coupon can not be applied to order');
		}
		$data = $responce->getData();
		$coupon = new BillingCoupon($data['coupon']);
		$ids = $data['planIDs'];
		return $coupon;
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('coupon'));
		}
		return self::$instance;
	}
	
}