<?php

class BillingStoreService extends BillingService {
	
	protected static $instance = null;
	
	public function getById($id) {
		$responce = $this->executeGetStoreById($id);
		if ($responce->hasErrors()) {
			throw new BillingObjectException('Store with id "' . $id . '" not found');
		} else {
			return new BillingStore($responce->getData());
		}
	}
	
	public function getByCode($code) {
		$responce = $this->executeGetStoreByCode($code);
		if ($responce->hasErrors()) {
			return null;
		} else {
			return new BillingStore($responce->getData());
		}
	}
	
	public function getDefault() {
		$responce = $this->executeGetDefaultStore();
		if ($responce->hasErrors()) {
			return null;
		} else {
			return new BillingStore($responce->getData());
		}
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('store'));
		}
		return self::$instance;
	}
	
}