<?php

class BillingWidgetService extends BillingService {
	
	protected static $instance = null;
	
	public function getPlanIds($id) {
		$response = $this->executeGetPlanIDs($id);
		$ids = array();
		foreach ($response->getData() as $id) {
			$ids[] = (int)$id;
		}
		return $ids;
	}
	
	public function getByCode($code) {
		$response = $this->executeGetByCode($code);
		return ($response->hasErrors()) ? null : new BillingWidget($response->getData());
	}
	
	public function getById($id) {
		$response = $this->executeGetById($id);
		return ($response->hasErrors()) ? null : new BillingWidget($response->getData());
	}
	
	public static function getInstance() {
		if (self::$instance == null) {
			self::$instance = new self(self::prepareSoapClient('widget'));
		}
		return self::$instance;
	}
	
}