<?php

class RouterPage {
	private $_code;
	private $_parameters;
	
	public function __construct($code, $parameters = array()) {
		$this->_code = $code;
		$this->_parameters = $parameters;
	}
	
	public function getCode() {
		return $this->_code;
	}
	
	public function getParameters() {
		return $this->_parameters;
	}
	
	public function getUrl() {
		$tmp = array();
		foreach ($this->_parameters as $name => $value) {
			$tmp[] = $name . '=' . $value;
		}
		$parameters = implode('&', $tmp);
		return '@' . $this->_code . ($parameters ? '?' . $parameters : '');
	}
	
	public function getName() {
		$pagesDescriptor = sfConfig::get('mod_cart_page_descriptors');
		if (isset($pagesDescriptor[$this->_code]) && isset($pagesDescriptor[$this->_code]['label'])) {
			return $pagesDescriptor[$this->_code]['label'];
		} else {
			return false;
		}
	}
	
	public function getStep() {
		$pagesDescriptor = sfConfig::get('mod_cart_page_descriptors');
		if (isset($pagesDescriptor[$this->_code]) && isset($pagesDescriptor[$this->_code]['step'])) {
			return $pagesDescriptor[$this->_code]['step'];
		} else {
			return false;
		}
	}
	
	public function getAction() {
		$pagesDescriptor = sfConfig::get('mod_cart_page_descriptors');
		if (isset($pagesDescriptor[$this->_code]) && isset($pagesDescriptor[$this->_code]['action'])) {
			return $pagesDescriptor[$this->_code]['action'];
		} else {
			return false;
		}
	}
	
}