<?php

class RoutersStack implements Resource {
	
	private $_stack;
	
	public function __construct() {
		$this->_stack = array();
	}
	
	public static function getInstance() {
		$container = sfContext::getInstance()->getUser()->getAttribute('container');
		$routersStack = sfContext::getInstance()->getUser()->getAttribute('routersStack');
		if (!isset($routersStack[$container])) {
			$routersStack[$container] = new RoutersStack();
			sfContext::getInstance()->getUser()->setAttribute('routersStack', $routersStack);
		}
		return $routersStack[$container];
	}
	
	public function push(Router $router) {
		array_push($this->_stack, $router);
	}
	
	public function pop() {
		return array_pop($this->_stack);
	}
	
	public function current() {
		$size = sizeof($this->_stack);
		return $size ? $this->_stack[$size - 1] : null;
	}
	
	public function length() {
		return sizeof($this->_stack);
	}
	
}