<?php

class FormGroup {
	
	private $_name;
	
	private $_title;
	
	private $_description;
	
	private $_fields;
	
	public function __construct($name, $title = false, $description = false) {
		$this->_name = $name;
		$this->_title = $title;
		$this->_description = $description;
		$this->_fields = array();
	}
	
	public function getName() {
		return $this->_name;
	}
	
	public function getTitle() {
		return $this->_title;
	}
	
	public function hasTitle() {
		return $this->_title ? true : false;
	}
	
	public function getDescription() {
		return $this->_description;
	}
	
	public function hasDescription() {
		return $this->_description ? true : false;
	}
	
	public function addField(FormField $field) {
		$this->_fields[$field->getName()] = $field;
	}
	
	public function getFields() {
		return $this->_fields;
	}
	
	public function getField($name) {
		return isset($this->_fields[$name]) ? $this->_fields[$name] : null;
	}
	
	public function hasFields() {
		return $this->_fields ? true : false;
	}
	
}