<?php

class FormSection {
	
	private $_name;
	
	private $_title;
	
	private $_description;
	
	private $_groups;
	
	public function __construct($name, $title = false, $description = false) {
		$this->_name = $name;
		$this->_title = $title;
		$this->_description = $description;
		$this->_groups = array();
	}
	
	public function getName() {
		return $this->_name;
	}
	
	public function getTitle() {
		return $this->_title;
	}
	
	public function hasTitle() {
		return $this->_title ? true : false;
	}
	
	public function getDescription() {
		return $this->_description;
	}
	
	public function hasDescription() {
		return $this->_description ? true : false;
	}
	
	public function addGroup(FormGroup $group) {
		$this->_groups[$group->getName()] = $group;
	}
	
	public function getGroups() {
		return $this->_groups;
	}
	
	public function getGroup($name) {
		return isset($this->_groups[$name]) ? $this->_groups[$name] : null;
	}
	
	public function hasGroup($name) {
		return isset($this->_groups[$name]) ? true : false;
	}
	
	public function getFields() {
		$result = array();
		foreach ($this->getGroups() as $group) {
			$result = array_merge($result, $group->getFields());
		}
		return $result;
	}
	
	public function getField($name) {
		$result = null;
		foreach ($this->getGroups() as $group) {
			if ($result = $group->getField($name)) {
				break;
			}
		}
		return $result;
	}
	
}