<?php

class BillingAccountForm extends BillingForm {
	
	public function __construct($data, $defaults = array(), $options = array(), $CSRFSecret = null) {
		parent::__construct($data, $defaults, $options, $CSRFSecret);
	}
	
	public function save() {
		$values = $this->getValues();
		$group = $values['paymentType'];
		$groupPrefix = $group . '__';
		$output = array('paymentType' => $group);
		foreach ($values as $name => $value) {
			if (strpos($name, $groupPrefix) === 0) {
				$tmp = substr($name, strlen($groupPrefix));
				$output[$tmp] = $value;
			}
		}
		$store = sfContext::getInstance()->getUser()->getAttribute('store');
		$result = ResourceLocator::getInstance()->billingAccountService->collectAccountForm($store->getId(), $output);
		if (!$this->validate($result, $group)) {
			throw new BillingFormException('TRANS_STORE_INVALID_ACCOUNT_DATA');
		}
		return $result->getData();

	}
	
	protected function addCustomWidgets($widgets) {
		
		$choices = array();
		foreach ($this->getGroups() as $group) {
			$choices[$group->getName()] = $group->getTitle();
		}
		$widget = new sfWidgetFormSelect(
			array(
				'label' => 'TRANS_BILLING_ACCOUNT_TYPE_OPTION',
				'choices' => $choices
			),
			array(
				'id' => 'paymentType'
			)
		);
		
		$widgets['paymentType'] = $widget;
		return $widgets;
	}
	
	protected function addCustomValidators($validators) {
		$validators['paymentType'] = new sfValidatorPass();
		return $validators;
	}
	
}