<?php

class BillingDomainDetailsForm extends BillingForm {
	
	public function __construct($data, $defaults = array(), $options = array(), $CSRFSecret = null) {
		parent::__construct($data, $defaults, $options, $CSRFSecret);
	}
	
	public function save() {
		$values = $this->getValues();
		// check, if form contains HTML fields, merge form values with request
		if ($this->hasHTMLFields()) {
			foreach ($this->getHTMLFields() as $field) {
				unset($values[$field->getName()]);
			}
			$extra = $_REQUEST;
			unset($extra['symfony']);
			unset($extra[$this->getName()]);
			$values = array_merge($values, $extra);
		}
		$store = sfContext::getInstance()->getUser()->getAttribute('store');
		$variantId = $this->getAttribute('variantId');
		$SLD = $this->getAttribute('SLD');
		$action = $this->getAttribute('action');
		$purchase = $this->getAttribute('purchase');
		$result = ResourceLocator::getInstance()->billingDomainService->collectDomainDetailsForm($store->getId(), $values, $variantId, $SLD, $action);
		if ($result->hasErrors() || $result->hasViolations()) {
			if ($result->hasErrors()) {
				$this->setErrors($result->getErrors());
			}
			if ($result->hasViolations()) {
				// create temporary form, containing processed data
				$processedForm = new BillingDomainDetailsForm($result->getData());
				foreach ($result->getViolations() as $name => $description) {
					if ($field = $this->getField($name)) {
						// check, if field has HTML type, get it value from processed data
						if ($field->getType() == FormField::TYPE_HTML) {
							$field->setValue($processedForm->getField($name)->getValue());
						}
						$field->setViolation($description);
					}
				}
			}
			return false;
		} else {
			$purchase->addParameter('data', $result->getData());
			return true;
		}
	}
	
}