<?php

function preparePrices($plan, $currencyId) {
	$prices = array();
	
	foreach ($plan->getVariants() as $variant) {
		foreach ($plan->getCycles() as $cycle) {
			if (!$price = $variant->getPrice($cycle->cycleID, $currencyId)) {
				continue;
			}
			
			if ($plan->mustHaveAddons() && !$plan->hasAddAddonAvailability($cycle->cycleID)) {
				continue;
			}
			
			$prices[] = array(
				'id' => $price->getId(),
				'price' => $price,
				'variantName' => $variant->productVariantDisplayName,
				'cycleName' => $cycle->cycleDisplayName,
                'cycleLenght' => $price->cycleLenght,
			);
		}
	}

	usort($prices, 'comparePrices');
	return $prices;
}

function comparePrices($v1, $v2)
{
   $name = 'cycleLenght';
   if ($v1[$name] == $v2[$name]) {
       return 0;
   }
   return ($v1[$name] < $v2[$name])? -1 : 1;
}