-- MySQL dump 10.11
--
-- Host: localhost    Database: pleskbilling
-- ------------------------------------------------------
-- Server version	5.0.51a-3ubuntu5.4

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `accounting_control_rel`
--
DROP TABLE IF EXISTS `accounting_control_rel`;
CREATE TABLE `accounting_control_rel` (
  `general_ledger_id` int(10) unsigned NOT NULL default '0',
  `control_type` smallint(5) unsigned NOT NULL default '0',
  `control_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`general_ledger_id`,`control_type`,`control_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `accounting_general_journal`
--
DROP TABLE IF EXISTS `accounting_general_journal`;
CREATE TABLE `accounting_general_journal` (
  `general_journal_id` int(10) unsigned NOT NULL auto_increment,
  `general_date_created` int(10) unsigned default NULL,
  `general_description` varchar(255) default NULL,
  `general_debit_amount` decimal(10,2) unsigned default '0.00',
  `general_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`general_journal_id`),
  KEY `purchase_date_created` (`general_date_created`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `accounting_general_ledger`
--
DROP TABLE IF EXISTS `accounting_general_ledger`;
CREATE TABLE `accounting_general_ledger` (
  `general_ledger_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `journal_table_id` int(10) unsigned default NULL,
  `journal_table_name` varchar(100) default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `general_ledger_date_created` int(10) unsigned default NULL,
  `general_ledger_description` varchar(255) default NULL,
  `general_ledger_debit_amount` decimal(10,2) unsigned default '0.00',
  `general_ledger_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`general_ledger_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `journal_table_id` (`journal_table_id`),
  KEY `journal_table_name` (`journal_table_name`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `general_ledger_date_created` (`general_ledger_date_created`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `accounting_ledger_accounts`
--
DROP TABLE IF EXISTS `accounting_ledger_accounts`;
CREATE TABLE `accounting_ledger_accounts` (
  `ledger_account_id` smallint(5) unsigned NOT NULL auto_increment,
  `parent_ledger_account_id` smallint(5) unsigned default '0',
  `ledger_account_number` int(10) unsigned default NULL,
  `ledger_account_type` tinyint(3) default NULL,
  `ledger_account_name` varchar(50) default NULL,
  `ledger_account_trans_key` varchar(255) default NULL,
  PRIMARY KEY  (`ledger_account_id`),
  KEY `ledger_account_number` (`ledger_account_number`),
  KEY `ledger_account_type` (`ledger_account_type`),
  KEY `parent_ledger_account_id` (`parent_ledger_account_id`)
) ENGINE=MyISAM AUTO_INCREMENT=41 ;

--
-- Dumping data for table `accounting_ledger_accounts`
--
LOCK TABLES `accounting_ledger_accounts` WRITE;
/*!40000 ALTER TABLE `accounting_ledger_accounts` DISABLE KEYS */;
INSERT INTO `accounting_ledger_accounts` VALUES (1,0,10000,1,'cash','TRANS_CASH');
INSERT INTO `accounting_ledger_accounts` VALUES (2,0,10010,1,'cash_1','TRANS_CASH_1');
INSERT INTO `accounting_ledger_accounts` VALUES (3,0,10020,1,'cash_2','TRANS_CASH_2');
INSERT INTO `accounting_ledger_accounts` VALUES (4,0,11000,1,'accounts_receivable','TRANS_ACCOUNTS_RECEIVABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (5,0,11500,1,'authorized_payments','TRANS_AUTHORIZED_PAYMENTS');
INSERT INTO `accounting_ledger_accounts` VALUES (6,0,12000,1,'hardware_assets','TRANS_HARDWARE_ASSETS');
INSERT INTO `accounting_ledger_accounts` VALUES (7,0,13001,1,'deferred_charge','TRANS_DEFERRED_CHARGES');
INSERT INTO `accounting_ledger_accounts` VALUES (8,0,20000,2,'accounts_payable','TRANS_ACCOUNTS_PAYABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (9,0,20001,2,'deferred_revenue','TRANS_DEFERRED_REVENUE');
INSERT INTO `accounting_ledger_accounts` VALUES (10,0,21000,2,'domains_payable','TRANS_DOMAINS_PAYABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (11,0,22000,2,'certs_payable','TRANS_CERTS_PAYABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (12,0,25000,2,'customer_credits','TRANS_CUSTOMER_CREDITS');
INSERT INTO `accounting_ledger_accounts` VALUES (13,0,27000,2,'affiliate_commissions_payable','TRANS_AFFILIATE_COMMISSIONS_PAYABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (14,0,29000,2,'taxes_payable','TRANS_TAXES_PAYABLE');
INSERT INTO `accounting_ledger_accounts` VALUES (15,0,30000,3,'equity','TRANS_EQUITY');
INSERT INTO `accounting_ledger_accounts` VALUES (16,0,40000,4,'revenue','TRANS_REVENUE');
INSERT INTO `accounting_ledger_accounts` VALUES (17,0,40099,4,'coupon_revenue','TRANS_COUPON_REVENUE');
INSERT INTO `accounting_ledger_accounts` VALUES (18,0,49000,4,'currency_income','TRANS_CURRENCY_CONVERSION_INCOME');
INSERT INTO `accounting_ledger_accounts` VALUES (19,0,50000,5,'cogs','TRANS_COGS');
INSERT INTO `accounting_ledger_accounts` VALUES (20,0,51000,5,'domain_cogs','TRANS_DOMAIN_COGS');
INSERT INTO `accounting_ledger_accounts` VALUES (21,0,52000,5,'certs_cogs','TRANS_CERTS_COGS');
INSERT INTO `accounting_ledger_accounts` VALUES (22,0,53000,5,'setup_cogs','TRANS_SETUP_COGS');
INSERT INTO `accounting_ledger_accounts` VALUES (23,0,54000,5,'usage_cogs','TRANS_USAGE_COGS');
INSERT INTO `accounting_ledger_accounts` VALUES (24,0,60000,6,'expense','TRANS_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (25,0,60200,6,'gateway_fees','TRANS_GATEWAY_FEES');
INSERT INTO `accounting_ledger_accounts` VALUES (26,0,60300,6,'paypal_fees','TRANS_PAYPAL_FEES');
INSERT INTO `accounting_ledger_accounts` VALUES (27,0,60500,6,'coupon_expense','TRANS_COUPON_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (28,0,61000,6,'refund_expense','TRANS_REFUND_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (29,0,62000,6,'customer_expense','TRANS_CUSTOMER_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (30,0,65000,6,'wages_expense','TRANS_WAGES_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (31,0,65010,6,'entertainment_expense','TRANS_ENTERTAINMENT_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (32,0,65020,6,'rent_expense','TRANS_RENT_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (33,0,65030,6,'travel_expense','TRANS_TRAVEL_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (34,0,65040,6,'commissions_expense','TRANS_COMMISSIONS_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (35,0,65050,6,'income_tax_expense','TRANS_INCOME_TAX_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (36,0,66000,6,'depreciation_expense','TRANS_DEPRECIATION_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (37,0,66010,6,'colocation_expense','TRANS_COLOCATION_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (38,0,66020,6,'hardware_lease_expense','TRANS_HARDWARE_LEASE_EXPENSE');
INSERT INTO `accounting_ledger_accounts` VALUES (39,0,67000,6,'affiliate_commissions_expense','TRANS_AFFILIATE_COMMISSIONS');
INSERT INTO `accounting_ledger_accounts` VALUES (40,0,69000,6,'currency_expense','TRANS_CURRENCY_CONVERSION_EXPENSE');
/*!40000 ALTER TABLE `accounting_ledger_accounts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `accounting_ledger_groups`
--
DROP TABLE IF EXISTS `accounting_ledger_groups`;
CREATE TABLE `accounting_ledger_groups` (
  `ledger_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `ledger_group_name` varchar(255) default NULL,
  PRIMARY KEY  (`ledger_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `accounting_purchases_journal`
--
DROP TABLE IF EXISTS `accounting_purchases_journal`;
CREATE TABLE `accounting_purchases_journal` (
  `purchase_journal_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `purchase_date_created` int(10) unsigned default NULL,
  `purchase_description` varchar(255) default NULL,
  `purchase_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_credit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_acc_pay_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_acc_pay_credit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_cash_debit_amount` decimal(10,2) unsigned default '0.00',
  `purchase_cash_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`purchase_journal_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `purchase_date_created` (`purchase_date_created`),
  KEY `currency_id` (`currency_id`),
  KEY `line_item_id` (`line_item_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `accounting_receipts_journal`
--
DROP TABLE IF EXISTS `accounting_receipts_journal`;
CREATE TABLE `accounting_receipts_journal` (
  `receipt_journal_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `invoice_id` int(10) unsigned default NULL,
  `transaction_id` int(10) unsigned default NULL,
  `receipt_date_created` int(10) unsigned default NULL,
  `receipt_description` varchar(255) default NULL,
  `receipt_cash_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_cash_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_acc_rec_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_acc_rec_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_sales_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_sales_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_tax_pay_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_tax_pay_credit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_coupon_debit_amount` decimal(10,2) unsigned default '0.00',
  `receipt_coupon_credit_amount` decimal(10,2) unsigned default '0.00',
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`receipt_journal_id`),
  KEY `client_id` (`client_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `transaction_id` (`transaction_id`),
  KEY `receipt_date_created` (`receipt_date_created`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `action_log`
--
DROP TABLE IF EXISTS `action_log`;
CREATE TABLE `action_log` (
  `action_log_id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT,
  `user_type` ENUM('admin', 'client') NOT NULL,
  `user_id` INT(10) UNSIGNED NOT NULL,
  `user_name` VARCHAR(255) NOT NULL,
  `user_ip` VARCHAR(39) NOT NULL,
  `action_date` INT(10) UNSIGNED NOT NULL,
  `action_type` ENUM('action', 'api', 'command') NOT NULL,
  `action_id` INT(10) UNSIGNED NULL,
  `action_name` VARCHAR(255) NOT NULL,
  `action_url` VARCHAR(2048) NULL,
  `affected_user_type` ENUM('admin', 'client') NULL,
  `affected_user_id` INT(10) UNSIGNED NULL,
  `affected_user_name` VARCHAR(255) NULL,
  `reason` VARCHAR(255) NOT NULL,
  `comment` VARCHAR(255) NULL,
  PRIMARY KEY (`action_log_id`),
  KEY (`user_type`),
  KEY (`user_id`),
  KEY (`user_name`),
  KEY (`user_ip`),
  KEY (`action_date`),
  KEY (`action_type`),
  KEY (`action_id`),
  KEY (`action_name`),
  KEY (`affected_user_type`),
  KEY (`affected_user_id`),
  KEY (`affected_user_name`),
  KEY (`reason`),
  KEY (`comment`)
) ENGINE=InnoDB ;

--
-- Table structure for table `admin_group_action_rel`
--
DROP TABLE IF EXISTS `admin_group_action_rel`;
CREATE TABLE `admin_group_action_rel` (
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  `action_name` varchar(90) NOT NULL default '',
  PRIMARY KEY  (`admin_group_id`,`action_name`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `admin_group_action_rel`
--
LOCK TABLES `admin_group_action_rel` WRITE;
/*!40000 ALTER TABLE `admin_group_action_rel` DISABLE KEYS */;
INSERT INTO `admin_group_action_rel` VALUES (2,'RunEvents');
/*!40000 ALTER TABLE `admin_group_action_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_group_rel`
--
DROP TABLE IF EXISTS `admin_group_rel`;
CREATE TABLE `admin_group_rel` (
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`admin_group_id`,`admin_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `admin_group_rel`
--
LOCK TABLES `admin_group_rel` WRITE;
/*!40000 ALTER TABLE `admin_group_rel` DISABLE KEYS */;
INSERT INTO `admin_group_rel` VALUES (1,1);
INSERT INTO `admin_group_rel` VALUES (2,4);
/*!40000 ALTER TABLE `admin_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_groups`
--
DROP TABLE IF EXISTS `admin_groups`;
CREATE TABLE `admin_groups` (
  `admin_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`admin_group_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 ;

--
-- Dumping data for table `admin_groups`
--
LOCK TABLES `admin_groups` WRITE;
/*!40000 ALTER TABLE `admin_groups` DISABLE KEYS */;
INSERT INTO `admin_groups` VALUES (1,'root');
INSERT INTO `admin_groups` VALUES (2,'cronadmin');
/*!40000 ALTER TABLE `admin_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `admin_login_attempts`
--
DROP TABLE IF EXISTS `admin_login_attempts`;
CREATE TABLE `admin_login_attempts` (
  `admin_id` INT(10) UNSIGNED NOT NULL,
  `ip` VARCHAR(39) NOT NULL,
  `attempt_date` INT(10) UNSIGNED NOT NULL,
  `attempt_number` INT(10) UNSIGNED NOT NULL,
  PRIMARY KEY (`admin_id`, `ip`)
) ENGINE=InnoDB;

--
-- Table structure for table `admin_server_params`
--
DROP TABLE IF EXISTS `admin_server_params`;
CREATE TABLE `admin_server_params` (
  `admin_id` INT(10) UNSIGNED NOT NULL,
  `server_id` INT(10) UNSIGNED NOT NULL,
  `param_name` VARCHAR(255) NOT NULL,
  `param_value` TEXT,
  PRIMARY KEY (`admin_id`, `server_id`, `param_name`)
) ENGINE=InnoDB;

--
-- Table structure for table `admins`
--
DROP TABLE IF EXISTS `admins`;
CREATE TABLE `admins` (
  `admin_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_first_name` varchar(50) default NULL,
  `admin_last_name` varchar(50) default NULL,
  `admin_email` varchar(100) default NULL,
  `admin_username` varchar(75) default NULL,
  `admin_password` varchar(255) default NULL,
  `admin_password_date_changed` int(10) unsigned NOT NULL default 0,
  `admin_temp_password` varchar(255) default NULL,
  `admin_remote_access_hash` varchar(255) default NULL,
  `admin_active` tinyint(3) unsigned default NULL,
  `theme_id` smallint(5) unsigned default NULL,
  `skin_id` varchar(255) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `guid` char(36) NOT NULL,
  `sso_fi_id` varchar(50) default NULL,
  `sso_sp_user_id` varchar(50) default NULL,
  `sync_status` ENUM('synced', 'syncing', 'error', 'non-syncable') NOT NULL DEFAULT 'synced',
  `sync_tasks` int(10) unsigned NOT NULL default 0,
  `sync_error` text NULL default NULL,
  `sync_last_time` datetime NULL default NULL,
  PRIMARY KEY  (`admin_id`),
  KEY `admin_username` (`admin_username`),
  KEY `admin_password` (`admin_password`),
  KEY `admin_active` (`admin_active`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`),
  UNIQUE KEY `guid` (`guid`),
  KEY `sync_status` (`sync_status`),
  KEY `sync_tasks` (`sync_tasks`)
) ENGINE=MyISAM AUTO_INCREMENT=5 ;

--
-- Dumping data for table `admins`
--
LOCK TABLES `admins` WRITE;
/*!40000 ALTER TABLE `admins` DISABLE KEYS */;
INSERT INTO `admins` VALUES (1,'FIRSTNAME','LASTNAME','','admin','UNKNOWN',0,NULL,'bdf2f164541abbab07c0f68b6be6e375662ff613',1,2,"winxp.new",21,225,'dc489f4e-72d5-4d89-962d-b23c49a72a04',NULL,NULL,'synced',0,NULL,NULL);
INSERT INTO `admins` VALUES (2,'OrderForm','User','','admin_ezorder','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',0,NULL,'e3dcc4e331741e58a6ff6366e3798bfcb12c2955',1,2,"winxp.new",21,225,'0bf42ac3-2697-4e93-a253-0713fcb7b6b2',NULL,NULL,'synced',0,NULL,NULL);
INSERT INTO `admins` VALUES (3,'API','User','','admin_api','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',0,NULL,'e22aaf18b2823d47d230f76a916f3cc7d3cba961',1,2,"winxp.new",21,225,'2892aa9c-9f8e-4098-adf4-9768627c1e03',NULL,NULL,'synced',0,NULL,NULL);
INSERT INTO `admins` VALUES (4,'Cron','User','','cronadmin','7b2e9f54cdff413fcde01f330af6896c3cd7e6cd',0,NULL,'339f331c8183edd04fc25568699a9dec2219c1c0',1,2,"winxp.new",21,225,'5324db36-07c6-49d8-8f85-3ae813b1f8d5',NULL,NULL,'synced',0,NULL,NULL);
/*!40000 ALTER TABLE `admins` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `attribute_groups`
--
DROP TABLE IF EXISTS `attribute_groups`;
CREATE TABLE `attribute_groups` (
  `group_id` int(10) unsigned NOT NULL auto_increment,
  `group_name` varchar(100) default NULL,
  `group_active` tinyint(1) default '1',
  PRIMARY KEY  (`group_id`)
) ENGINE=MyISAM AUTO_INCREMENT=2 ;

LOCK TABLES `attribute_groups` WRITE;
/*!40000 ALTER TABLE `attribute_groups` DISABLE KEYS */;
INSERT INTO `attribute_groups` VALUES (1,'Default customer', 1);
/*!40000 ALTER TABLE `attribute_groups` ENABLE KEYS */;
UNLOCK TABLES;
--
-- Table structure for table `attribute_map_mapping_rel`
--
DROP TABLE IF EXISTS `attribute_map_mapping_rel`;
CREATE TABLE `attribute_map_mapping_rel` (
  `attribute_map_id` int(10) unsigned NOT NULL default '0',
  `attribute_mapping_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`attribute_map_id`,`attribute_mapping_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `attribute_mappings`
--
DROP TABLE IF EXISTS `attribute_mappings`;
CREATE TABLE `attribute_mappings` (
  `attribute_mapping_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_id` int(10) unsigned default NULL,
  `attribute_match_value` varchar(100) default NULL,
  `attribute_nomatch_value` varchar(100) default NULL,
  PRIMARY KEY  (`attribute_mapping_id`),
  KEY `attribute_id` (`attribute_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `attribute_maps`
--
DROP TABLE IF EXISTS `attribute_maps`;
CREATE TABLE `attribute_maps` (
  `attribute_map_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_map_name` varchar(100) default NULL,
  PRIMARY KEY  (`attribute_map_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `attributes`
--
DROP TABLE IF EXISTS `attributes`;
CREATE TABLE `attributes` (
  `attribute_id` int(10) unsigned NOT NULL auto_increment,
  `attribute_name` varchar(100) default NULL,
  `attribute_type` tinyint(3) unsigned default NULL,
  `attribute_subtype` tinyint(3) unsigned default NULL,
  `attribute_input_restrictions` bigint(20) default NULL,
  `question_id` int(8) unsigned default NULL,
  `value_map_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`attribute_id`),
  KEY `attribute_type` (`attribute_type`),
  KEY `attribute_subtype` (`attribute_subtype`),
  KEY `question_id` (`question_id`),
  KEY `product_id` (`product_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `value_map_id` (`value_map_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `bans`
--
DROP TABLE IF EXISTS `bans`;
CREATE TABLE `bans` (
  `ban_id` int(10) unsigned NOT NULL auto_increment,
  `ban_type` tinyint(3) unsigned default NULL,
  `ban_string` varchar(255) default NULL,
  `ban_message` longtext,
  `ban_count` smallint(5) unsigned default NULL,
  `ban_active` tinyint(3) unsigned default NULL,
  `ban_date_last_used` int(10) unsigned default NULL,
  PRIMARY KEY  (`ban_id`),
  KEY `ban_string` (`ban_string`),
  KEY `ban_type` (`ban_type`),
  KEY `ban_active` (`ban_active`)
) ENGINE=MyISAM AUTO_INCREMENT=1347 ;

--
-- Dumping data for table `bans`
--
LOCK TABLES `bans` WRITE;
/*!40000 ALTER TABLE `bans` DISABLE KEYS */;
INSERT INTO `bans` VALUES (1,0,'123email.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (2,0,'123india.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (3,0,'163.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (4,0,'2akron.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (5,0,'2asheville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (6,0,'2athens.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (7,0,'2batonrouge.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (8,0,'2bmail.co.uk','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (9,0,'2concord.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (10,0,'2conventions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (11,0,'2costamesa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (12,0,'2houston.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (13,0,'2louisville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (14,0,'2milwaukee.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (15,0,'2roanoke.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (16,0,'2santabarbara.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (17,0,'2sarasota.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (18,0,'2wheeling.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (19,0,'2yakima.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (20,0,'4800numbers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (21,0,'4abilene.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (22,0,'4accessories.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (23,0,'4acne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (24,0,'4actionfigures.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (25,0,'4addictions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (26,0,'4adirondacks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (27,0,'4adoptions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (28,0,'4adventurevacations.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (29,0,'4advertising.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (30,0,'4advice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (31,0,'4aerobics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (32,0,'4aids.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (33,0,'4airconditioners.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (34,0,'4aircraft.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (35,0,'4airinfo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (36,0,'4airline.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (37,0,'4alarms.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (38,0,'4albany.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (39,0,'4albuquerque.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (40,0,'4alcoholism.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (41,0,'4alexandria.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (42,0,'4aliens.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (43,0,'4allentown.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (44,0,'4allergies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (45,0,'4alternative.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (46,0,'4altmedicine.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (47,0,'4altoona.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (48,0,'4alzheimers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (49,0,'4amarillo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (50,0,'4anaheim.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (51,0,'4anchorage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (52,0,'4anderson.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (53,0,'4animals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (54,0,'4anime.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (55,0,'4annarbor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (56,0,'4anniston.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (57,0,'4anniversary.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (58,0,'4annuities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (59,0,'4antiques.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (60,0,'4anything.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (61,0,'4apartmenthunting.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (62,0,'4appetizers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (63,0,'4appleton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (64,0,'4appliances.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (65,0,'4aquariums.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (66,0,'4architects.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (67,0,'4arlington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (68,0,'4aromatherapy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (69,0,'4art.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (70,0,'4arthritis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (71,0,'4artsales.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (72,0,'4arubatravel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (73,0,'4aspen.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (74,0,'4assistivetechnology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (75,0,'4asthma.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (76,0,'4atlanta.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (77,0,'4atlanticcity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (78,0,'4attentiondeficit.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (79,0,'4auction.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (80,0,'4audiobooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (81,0,'4audiocassettes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (82,0,'4augusta.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (83,0,'4aurora.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (84,0,'4austin.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (85,0,'4authors.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (86,0,'4autoglass.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (87,0,'4autoinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (88,0,'4autoparts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (89,0,'4autoracing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (90,0,'4autorepair.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (91,0,'4autos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (92,0,'4autumn.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (93,0,'4b2b.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (94,0,'4babies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (95,0,'4babyboomers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (96,0,'4babynames.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (97,0,'4babyshowers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (98,0,'4backpacks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (99,0,'4backpain.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (100,0,'4backup.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (101,0,'4bagels.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (102,0,'4bailbonds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (103,0,'4bakeries.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (104,0,'4bakersfield.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (105,0,'4ballooning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (106,0,'4ballparks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (107,0,'4baltimore.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (108,0,'4bangor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (109,0,'4banking.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (110,0,'4barbecue.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (111,0,'4barcelonaspain.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (112,0,'4barharbor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (113,0,'4bars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (114,0,'4baseball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (115,0,'4baseballcards.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (116,0,'4basketball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (117,0,'4baskets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (118,0,'4battlecreek.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (119,0,'4beaches.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (120,0,'4beaumont.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (121,0,'4beauty.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (122,0,'4bedandbath.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (123,0,'4bedandbreakfast.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (124,0,'4beer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (125,0,'4bellingham.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (126,0,'4bentonharbor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (127,0,'4berkeley.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (128,0,'4berlin.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (129,0,'4bermudatravel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (130,0,'4bestsellers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (131,0,'4bikes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (132,0,'4billiards.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (133,0,'4billings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (134,0,'4bills.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (135,0,'4biloxi.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (136,0,'4binghamton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (137,0,'4bioengineering.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (138,0,'4biology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (139,0,'4biotech.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (140,0,'4birds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (141,0,'4birmingham.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (142,0,'4birthday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (143,0,'4bismarck.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (144,0,'4bizops.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (145,0,'4bloomington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (146,0,'4blues.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (147,0,'4boats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (148,0,'4boise.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (149,0,'4bonds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (150,0,'4bookkeeping.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (151,0,'4bookstores.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (152,0,'4boston.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (153,0,'4boulder.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (154,0,'4bowling.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (155,0,'4boxing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (156,0,'4bradenton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (157,0,'4brakes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (158,0,'4bread.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (159,0,'4breastcancer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (160,0,'4bremerton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (161,0,'4bridalshowers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (162,0,'4brides.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (163,0,'4bridge.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (164,0,'4bridgeport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (165,0,'4brownsville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (166,0,'4bryan.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (167,0,'4buddhism.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (168,0,'4buffalo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (169,0,'4building.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (170,0,'4buildingsupplies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (171,0,'4burlington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (172,0,'4buses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (173,0,'4businessinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (174,0,'4businesstravel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (175,0,'4businessupdates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (176,0,'4cable.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (177,0,'4cabletv.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (178,0,'4cake.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (179,0,'4calendars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (180,0,'4californiacoast.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (181,0,'4cameras.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (182,0,'4camping.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (183,0,'4camps.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (184,0,'4cancer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (185,0,'4candles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (186,0,'4candy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (187,0,'4canton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (188,0,'4capecod.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (189,0,'4capital.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (190,0,'4carcare.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (191,0,'4careers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (192,0,'4caribbeantravel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (193,0,'4carloans.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (194,0,'4cartoons.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (195,0,'4casper.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (196,0,'4catalogs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (197,0,'4caterers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (198,0,'4catholicism.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (199,0,'4cats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (200,0,'4cd.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (201,0,'4cdrom.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (202,0,'4cedarrapids.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (203,0,'4cellphones.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (204,0,'4censorship.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (205,0,'4cerebralpalsy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (206,0,'4champagne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (207,0,'4champaign.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (208,0,'4chandler.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (209,0,'4charities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (210,0,'4charleston.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (211,0,'4charlotte.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (212,0,'4charlottesville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (213,0,'4charters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (214,0,'4chatroom.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (215,0,'4chattanooga.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (216,0,'4cheerleading.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (217,0,'4cheese.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (218,0,'4chesapeake.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (219,0,'4cheyenne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (220,0,'4chicago.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (221,0,'4chico.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (222,0,'4children.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (223,0,'4childrensbooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (224,0,'4chocolates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (225,0,'4christmas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (226,0,'4chulavista.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (227,0,'4cigars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (228,0,'4cincinnati.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (229,0,'4cities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (230,0,'4civilrights.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (231,0,'4civilwar.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (232,0,'4clarksville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (233,0,'4classical.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (234,0,'4classiccars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (235,0,'4classicmovies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (236,0,'4classicrock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (237,0,'4classifieds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (238,0,'4cleaning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (239,0,'4clearwater.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (240,0,'4cleveland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (241,0,'4clipart.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (242,0,'4clocks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (243,0,'4clothes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (244,0,'4coats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (245,0,'4coffee.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (246,0,'4coins.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (247,0,'4colds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (248,0,'4collectibles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (249,0,'4collectors.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (250,0,'4collegebasketball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (251,0,'4collegefootball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (252,0,'4collegelife.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (253,0,'4colleges.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (254,0,'4cologne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (255,0,'4coloradosprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (256,0,'4columbia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (257,0,'4columbus.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (258,0,'4comedy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (259,0,'4comics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (260,0,'4commercials.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (261,0,'4commodities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (262,0,'4companies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (263,0,'4computerbasics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (264,0,'4computerhardware.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (265,0,'4computerrental.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (266,0,'4computersecurity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (267,0,'4computersoftware.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (268,0,'4computertraining.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (269,0,'4computerwallpaper.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (270,0,'4computing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (271,0,'4concerts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (272,0,'4congress.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (273,0,'4conservation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (274,0,'4conspiracytheories.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (275,0,'4construction.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (276,0,'4consultants.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (277,0,'4contactlenses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (278,0,'4contests.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (279,0,'4contraception.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (280,0,'4controversies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (281,0,'4cookbooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (282,0,'4cookies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (283,0,'4cooking.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (284,0,'4cooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (285,0,'4cookware.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (286,0,'4coolsite.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (287,0,'4copiers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (288,0,'4coralsprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (289,0,'4corona.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (290,0,'4corpuschristi.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (291,0,'4cosmetics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (292,0,'4cosmeticsurgery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (293,0,'4costumes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (294,0,'4costuming.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (295,0,'4cottages.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (296,0,'4coughs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (297,0,'4country.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (298,0,'4coupons.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (299,0,'4couriers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (300,0,'4courses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (301,0,'4cpas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (302,0,'4crafts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (303,0,'4credit4.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (304,0,'4creditcards.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (305,0,'4crime.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (306,0,'4crosswords.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (307,0,'4cruise.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (308,0,'4cumberland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (309,0,'4currencytrading.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (310,0,'4currentevents.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (311,0,'4cyberculture.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (312,0,'4cycling.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (313,0,'4dad.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (314,0,'4dallas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (315,0,'4dance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (316,0,'4danville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (317,0,'4databases.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (318,0,'4datarecovery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (319,0,'4davenport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (320,0,'4daycare.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (321,0,'4dayton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (322,0,'4daytonabeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (323,0,'4daytrading.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (324,0,'4deafcommunity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (325,0,'4debtconsolidation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (326,0,'4debtmanagement.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (327,0,'4decatur.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (328,0,'4delis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (329,0,'4delivery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (330,0,'4democracy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (331,0,'4democrats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (332,0,'4dentists.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (333,0,'4denver.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (334,0,'4departmentstores.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (335,0,'4designers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (336,0,'4desktoppublishing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (337,0,'4desktopthemes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (338,0,'4desmoines.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (339,0,'4desserts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (340,0,'4detroit.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (341,0,'4diabetes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (342,0,'4diet.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (343,0,'4digitalcameras.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (344,0,'4dinner.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (345,0,'4dinosaurs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (346,0,'4directions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (347,0,'4directories.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (348,0,'4disability.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (349,0,'4disco.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (350,0,'4discountstores.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (351,0,'4divorce.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (352,0,'4dolls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (353,0,'4domesticviolence.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (354,0,'4dothan.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (355,0,'4dresses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (356,0,'4drips.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (357,0,'4drugstores.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (358,0,'4dublin.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (359,0,'4dubuque.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (360,0,'4duluth.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (361,0,'4durham.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (362,0,'4dvdvideo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (363,0,'4earrings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (364,0,'4earthquakes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (365,0,'4easter.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (366,0,'4eauclaire.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (367,0,'4economics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (368,0,'4edinburgh.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (369,0,'4editorials.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (370,0,'4education.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (371,0,'4educationaltoys.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (372,0,'4elections.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (373,0,'4electricians.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (374,0,'4electroniccommerce.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (375,0,'4electronics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (376,0,'4elizabeth.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (377,0,'4elkhart.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (378,0,'4elmonte.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (379,0,'4elpaso.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (380,0,'4elvis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (381,0,'4email.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (382,0,'4employment.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (383,0,'4employmentagencies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (384,0,'4encryption.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (385,0,'4endangeredspecies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (386,0,'4engineers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (387,0,'4enid.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (388,0,'4entertainment.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (389,0,'4entertainmentupdates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (390,0,'4environment.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (391,0,'4equipmentleasing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (392,0,'4erie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (393,0,'4escondido.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (394,0,'4estateplanning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (395,0,'4ethics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (396,0,'4eugene.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (397,0,'4europe.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (398,0,'4evansville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (399,0,'4exchangerates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (400,0,'4executivesearch.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (401,0,'4exercise.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (402,0,'4extreme.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (403,0,'4factoryoutlets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (404,0,'4fairytales.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (405,0,'4families.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (406,0,'4family.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (407,0,'4fanclubs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (408,0,'4fargo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (409,0,'4farming.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (410,0,'4farminsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (411,0,'4fashiondolls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (412,0,'4fatfree.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (413,0,'4fathersday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (414,0,'4faxes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (415,0,'4fayetteville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (416,0,'4feet.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (417,0,'4fertility.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (418,0,'4fiction.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (419,0,'4figureskating.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (420,0,'4finance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (421,0,'4financial.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (422,0,'4financialaid.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (423,0,'4financialnews.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (424,0,'4financialplanning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (425,0,'4firewalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (426,0,'4fitchburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (427,0,'4fitness.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (428,0,'4flags.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (429,0,'4flint.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (430,0,'4floodinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (431,0,'4florence.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (432,0,'4flowers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (433,0,'4flu.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (434,0,'4flyfishing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (435,0,'4folk.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (436,0,'4fontana.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (437,0,'4fonts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (438,0,'4foods.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (439,0,'4fools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (440,0,'4football.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (441,0,'4fortcollins.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (442,0,'4fortlauderdale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (443,0,'4fortmyers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (444,0,'4fortpierce.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (445,0,'4fortsmith.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (446,0,'4fortwaltonbeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (447,0,'4fortwayne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (448,0,'4fortworth.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (449,0,'4franchises.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (450,0,'4freestuff.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (451,0,'4fremont.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (452,0,'4fresno.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (453,0,'4frontpage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (454,0,'4fruit.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (455,0,'4fullerton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (456,0,'4furnishings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (457,0,'4gadgets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (458,0,'4gadsden.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (459,0,'4gainesville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (460,0,'4games.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (461,0,'4gameshows.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (462,0,'4gardengrove.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (463,0,'4gardening.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (464,0,'4gardens.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (465,0,'4garland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (466,0,'4gary.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (467,0,'4gear.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (468,0,'4gems.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (469,0,'4genealogy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (470,0,'4genx.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (471,0,'4gifs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (472,0,'4giftcertificates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (473,0,'4gifts4.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (474,0,'4gizmos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (475,0,'4glasses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (476,0,'4glendale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (477,0,'4glensfalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (478,0,'4golf.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (479,0,'4golfing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (480,0,'4golfresorts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (481,0,'4gossip.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (482,0,'4gourmets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (483,0,'4government.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (484,0,'4graduateschools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (485,0,'4graduation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (486,0,'4grandcanyon.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (487,0,'4grandfather.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (488,0,'4grandforks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (489,0,'4grandmother.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (490,0,'4grandrapids.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (491,0,'4gre.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (492,0,'4greatfalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (493,0,'4greeley.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (494,0,'4greenbay.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (495,0,'4greensboro.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (496,0,'4greenville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (497,0,'4greetingcards.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (498,0,'4groceries.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (499,0,'4grooms.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (500,0,'4guitars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (501,0,'4gulfcoast.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (502,0,'4gulfport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (503,0,'4gymnastics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (504,0,'4hagerstown.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (505,0,'4hair.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (506,0,'4hairloss.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (507,0,'4halloween.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (508,0,'4hampton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (509,0,'4handbags.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (510,0,'4hanukkah.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (511,0,'4hardware.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (512,0,'4harrisburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (513,0,'4hartford.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (514,0,'4hats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (515,0,'4hayward.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (516,0,'4headaches.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (517,0,'4headhunters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (518,0,'4healthandfitness.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (519,0,'4healthfood.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (520,0,'4healthinfo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (521,0,'4healthinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (522,0,'4healthymen.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (523,0,'4healthywomen.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (524,0,'4heartburn.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (525,0,'4heavymetal.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (526,0,'4henderson.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (527,0,'4her.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (528,0,'4herbs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (529,0,'4heroes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (530,0,'4hickory.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (531,0,'4highschools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (532,0,'4hiking.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (533,0,'4hiphop.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (534,0,'4history.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (535,0,'4hmos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (536,0,'4hobbies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (537,0,'4hockey.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (538,0,'4holidays.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (539,0,'4holocaust.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (540,0,'4home.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (541,0,'4homebrew.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (542,0,'4homebusiness.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (543,0,'4homeequity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (544,0,'4homeimprovement.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (545,0,'4homeoffice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (546,0,'4homeopathy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (547,0,'4homeowners.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (548,0,'4homepages.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (549,0,'4homeschooling.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (550,0,'4homesick.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (551,0,'4honeymoons.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (552,0,'4honolulu.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (553,0,'4horoscopes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (554,0,'4horror.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (555,0,'4horses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (556,0,'4hospitals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (557,0,'4hostels.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (558,0,'4hotel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (559,0,'4hotlines.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (560,0,'4hotrods.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (561,0,'4hotsprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (562,0,'4hottubs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (563,0,'4houses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (564,0,'4how2.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (565,0,'4howardstern.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (566,0,'4humanrights.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (567,0,'4huntington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (568,0,'4huntingtonbeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (569,0,'4huntsville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (570,0,'4hurricanes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (571,0,'4icecream.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (572,0,'4independence.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (573,0,'4independenceday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (574,0,'4indianapolis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (575,0,'4indierock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (576,0,'4indigestion.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (577,0,'4industrialmusic.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (578,0,'4industrialsupplies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (579,0,'4industry.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (580,0,'4information.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (581,0,'4inglewood.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (582,0,'4inns.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (583,0,'4insects.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (584,0,'4insomnia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (585,0,'4inspiration.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (586,0,'4instantmessaging.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (587,0,'4instruments.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (588,0,'4interest.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (589,0,'4interiordesign.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (590,0,'4internet.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (591,0,'4internetservice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (592,0,'4internships.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (593,0,'4intranet.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (594,0,'4investing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (595,0,'4investmentadvice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (596,0,'4invitations.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (597,0,'4iowacity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (598,0,'4ipo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (599,0,'4irvine.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (600,0,'4irving.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (601,0,'4islands.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (602,0,'4italianfood.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (603,0,'4jackson.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (604,0,'4jacksonville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (605,0,'4jamestown.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (606,0,'4janesville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (607,0,'4javascript.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (608,0,'4jazz.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (609,0,'4jeans.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (610,0,'4jerseycity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (611,0,'4jewelry.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (612,0,'4johnstown.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (613,0,'4jokes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (614,0,'4joplin.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (615,0,'4journalism.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (616,0,'4journals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (617,0,'4jpegs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (618,0,'4judaism.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (619,0,'4kalamazoo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (620,0,'4kankakee.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (621,0,'4kansascity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (622,0,'4keywest.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (623,0,'4kidshealth.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (624,0,'4kidstuff.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (625,0,'4killeen.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (626,0,'4kingofprussia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (627,0,'4kingsport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (628,0,'4kites.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (629,0,'4knoxville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (630,0,'4kokomo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (631,0,'4kosher.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (632,0,'4lacrosse.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (633,0,'4lafayette.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (634,0,'4lakecharles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (635,0,'4lakeland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (636,0,'4lakeplacid.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (637,0,'4lakewood.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (638,0,'4lancaster.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (639,0,'4landscaping.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (640,0,'4lansing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (641,0,'4laredo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (642,0,'4lascruces.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (643,0,'4laserprinters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (644,0,'4lasvegas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (645,0,'4lateshoppers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (646,0,'4lawns.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (647,0,'4lawrence.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (648,0,'4lawschools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (649,0,'4lawton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (650,0,'4learning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (651,0,'4leasing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (652,0,'4leather.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (653,0,'4legal.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (654,0,'4legalinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (655,0,'4lewiston.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (656,0,'4lexington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (657,0,'4libraries.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (658,0,'4lifeinsurance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (659,0,'4lima.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (660,0,'4limos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (661,0,'4lincoln.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (662,0,'4linedancing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (663,0,'4lingerie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (664,0,'4liquor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (665,0,'4littlerock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (666,0,'4liveevents.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (667,0,'4livonia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (668,0,'4loans4.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (669,0,'4london.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (670,0,'4longbeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (671,0,'4longdistance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (672,0,'4longisland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (673,0,'4longview.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (674,0,'4losangeles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (675,0,'4lottery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (676,0,'4lowell.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (677,0,'4lubbock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (678,0,'4luggage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (679,0,'4lunchtime.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (680,0,'4lynchburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (681,0,'4macon.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (682,0,'4macs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (683,0,'4madison.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (684,0,'4magazines.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (685,0,'4malls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (686,0,'4malpractice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (687,0,'4management.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (688,0,'4manchester.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (689,0,'4mansfield.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (690,0,'4maps.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (691,0,'4markets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (692,0,'4marriage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (693,0,'4martialarts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (694,0,'4massage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (695,0,'4maui.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (696,0,'4mba.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (697,0,'4mcallen.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (698,0,'4meat.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (699,0,'4medford.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (700,0,'4mediation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (701,0,'4medicalbooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (702,0,'4medicine.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (703,0,'4medschools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (704,0,'4meetings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (705,0,'4melbourne.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (706,0,'4memorialday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (707,0,'4memphis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (708,0,'4merced.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (709,0,'4mesa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (710,0,'4mesquite.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (711,0,'4miami.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (712,0,'4microbrew.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (713,0,'4middleages.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (714,0,'4midi.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (715,0,'4midland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (716,0,'4milan.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (717,0,'4military.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (718,0,'4minneapolis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (719,0,'4missoula.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (720,0,'4mobile.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (721,0,'4mobsters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (722,0,'4modelbuilders.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (723,0,'4models.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (724,0,'4modems.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (725,0,'4modernart.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (726,0,'4modesto.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (727,0,'4mom.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (728,0,'4monaco.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (729,0,'4monitors.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (730,0,'4monroe.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (731,0,'4monterey.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (732,0,'4montgomery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (733,0,'4montreal.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (734,0,'4morenovalley.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (735,0,'4mortgage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (736,0,'4motels.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (737,0,'4motherboards.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (738,0,'4mothersday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (739,0,'4motivation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (740,0,'4motorcycles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (741,0,'4motorhomes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (742,0,'4mountainbikes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (743,0,'4mountains.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (744,0,'4movie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (745,0,'4moviestars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (746,0,'4moving.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (747,0,'4mp3audio.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (748,0,'4muncie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (749,0,'4museums.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (750,0,'4musicals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (751,0,'4musicians.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (752,0,'4muskegon.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (753,0,'4mutualfunds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (754,0,'4mythology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (755,0,'4nantucket.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (756,0,'4napavalley.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (757,0,'4naperville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (758,0,'4nashville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (759,0,'4nationalparks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (760,0,'4naturalfoods.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (761,0,'4naturalproducts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (762,0,'4netbanks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (763,0,'4netnames.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (764,0,'4newage.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (765,0,'4newagemusic.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (766,0,'4newark.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (767,0,'4newbedford.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (768,0,'4newcars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (769,0,'4newengland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (770,0,'4newhaven.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (771,0,'4newhomes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (772,0,'4newlondon.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (773,0,'4neworleans.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (774,0,'4newport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (775,0,'4newportnews.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (776,0,'4news.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (777,0,'4newsgroups.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (778,0,'4newsletters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (779,0,'4newspapers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (780,0,'4newsupdates.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (781,0,'4newyear.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (782,0,'4newyork.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (783,0,'4nonfiction.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (784,0,'4nonprofits.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (785,0,'4norfolk.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (786,0,'4norwalk.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (787,0,'4notebooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (788,0,'4novelties.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (789,0,'4nurses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (790,0,'4nuts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (791,0,'4oakland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (792,0,'4obituaries.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (793,0,'4ocala.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (794,0,'4oceanside.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (795,0,'4oddities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (796,0,'4odds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (797,0,'4odessa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (798,0,'4officesupplies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (799,0,'4oklahomacity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (800,0,'4oliveoil.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (801,0,'4olympia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (802,0,'4omaha.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (803,0,'4onlineinvestment.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (804,0,'4ontario.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (805,0,'4opera.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (806,0,'4opportunities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (807,0,'4options.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (808,0,'4orange.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (809,0,'4orangecounty.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (810,0,'4organizers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (811,0,'4orlando.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (812,0,'4outdoors.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (813,0,'4outerbanks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (814,0,'4overlandpark.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (815,0,'4overnight.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (816,0,'4owensboro.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (817,0,'4oxnard.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (818,0,'4packaging.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (819,0,'4pager.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (820,0,'4palmdale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (821,0,'4palmsprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (822,0,'4panamacity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (823,0,'4paper.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (824,0,'4paris.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (825,0,'4parkcity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (826,0,'4parkersburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (827,0,'4parks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (828,0,'4party.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (829,0,'4pasadena.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (830,0,'4pascagoula.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (831,0,'4pasta.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (832,0,'4patentinfo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (833,0,'4paterson.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (834,0,'4patios.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (835,0,'4payroll.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (836,0,'4pcs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (837,0,'4pdas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (838,0,'4pembrokepines.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (839,0,'4penpals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (840,0,'4pens.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (841,0,'4pensacola.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (842,0,'4pensions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (843,0,'4people.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (844,0,'4peoria.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (845,0,'4perfume.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (846,0,'4personalinjury.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (847,0,'4petcare.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (848,0,'4petites.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (849,0,'4pharmaceutical.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (850,0,'4philadelphia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (851,0,'4phoenix.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (852,0,'4phonenumbers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (853,0,'4photography.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (854,0,'4physicians.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (855,0,'4pilots.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (856,0,'4pinebluff.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (857,0,'4pittsburgh.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (858,0,'4pittsfield.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (859,0,'4pizzas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (860,0,'4plano.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (861,0,'4plants.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (862,0,'4pms.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (863,0,'4poetry.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (864,0,'4politicalparties.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (865,0,'4politics.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (866,0,'4pomona.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (867,0,'4ponds.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (868,0,'4pools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (869,0,'4pop.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (870,0,'4portland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (871,0,'4portsmouth.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (872,0,'4poster.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (873,0,'4poughkeepsie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (874,0,'4powertools.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (875,0,'4prague.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (876,0,'4pregnancy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (877,0,'4president.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (878,0,'4press.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (879,0,'4printers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (880,0,'4programming.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (881,0,'4proms.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (882,0,'4providence.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (883,0,'4provo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (884,0,'4prowrestling.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (885,0,'4psychology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (886,0,'4publicrelations.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (887,0,'4pueblo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (888,0,'4punkrock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (889,0,'4puzzles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (890,0,'4quitsmoking.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (891,0,'4quotes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (892,0,'4racetracks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (893,0,'4radio.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (894,0,'4raleigh.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (895,0,'4raleighdurham.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (896,0,'4ram.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (897,0,'4ramadan.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (898,0,'4ranchocucamonga.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (899,0,'4randb.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (900,0,'4rapidcity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (901,0,'4reading.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (902,0,'4realestate.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (903,0,'4recipes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (904,0,'4records.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (905,0,'4redding.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (906,0,'4redrocks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (907,0,'4reference.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (908,0,'4refinancing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (909,0,'4reggae.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (910,0,'4religion.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (911,0,'4reminders.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (912,0,'4reno.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (913,0,'4rental.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (914,0,'4republicans.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (915,0,'4resorts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (916,0,'4resumes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (917,0,'4retail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (918,0,'4retirement.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (919,0,'4retirementplanning.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (920,0,'4richland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (921,0,'4richmond.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (922,0,'4rings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (923,0,'4riotravel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (924,0,'4riverside.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (925,0,'4roadtrips.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (926,0,'4rochester.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (927,0,'4rock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (928,0,'4rockclimbing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (929,0,'4rockford.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (930,0,'4rockvillecentre.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (931,0,'4rodeo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (932,0,'4rollerblading.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (933,0,'4rollercoasters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (934,0,'4romance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (935,0,'4rome.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (936,0,'4runners.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (937,0,'4sacramento.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (938,0,'4safari.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (939,0,'4safety.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (940,0,'4saginaw.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (941,0,'4sailing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (942,0,'4salem.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (943,0,'4salinas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (944,0,'4salsa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (945,0,'4saltlakecity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (946,0,'4sanangelo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (947,0,'4sanantonio.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (948,0,'4sanbernardino.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (949,0,'4sanbuenaventura.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (950,0,'4sandiego.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (951,0,'4sanfrancisco.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (952,0,'4sanjose.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (953,0,'4santa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (954,0,'4santaana.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (955,0,'4santaclarita.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (956,0,'4santafe.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (957,0,'4santarosa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (958,0,'4saratogasprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (959,0,'4sats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (960,0,'4savannah.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (961,0,'4savings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (962,0,'4scanners.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (963,0,'4scarves.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (964,0,'4scholarships.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (965,0,'4school.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (966,0,'4scifi.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (967,0,'4scores.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (968,0,'4scottsdale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (969,0,'4scranton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (970,0,'4screensavers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (971,0,'4scuba.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (972,0,'4seafood.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (973,0,'4search.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (974,0,'4seashore.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (975,0,'4seattle.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (976,0,'4securities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (977,0,'4sedona.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (978,0,'4selfhelp.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (979,0,'4seniors.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (980,0,'4shakespeare.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (981,0,'4shareware.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (982,0,'4sharon.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (983,0,'4sheboygan.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (984,0,'4sherman.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (985,0,'4shirts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (986,0,'4shoes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (987,0,'4shopping.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (988,0,'4shreveport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (989,0,'4signs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (990,0,'4silkflowers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (991,0,'4silver.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (992,0,'4simivalley.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (993,0,'4singing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (994,0,'4siouxcity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (995,0,'4siouxfalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (996,0,'4skateboarding.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (997,0,'4skiing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (998,0,'4skincare.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (999,0,'4skis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1000,0,'4snacks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1001,0,'4sneakers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1002,0,'4snowboarding.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1003,0,'4soapoperas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1004,0,'4soccer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1005,0,'4socialstudies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1006,0,'4sociology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1007,0,'4softball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1008,0,'4songs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1009,0,'4southbend.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1010,0,'4spas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1011,0,'4specialtyfoods.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1012,0,'4spices.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1013,0,'4spokane.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1014,0,'4sportfishing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1015,0,'4sportinggoods.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1016,0,'4sportsnews.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1017,0,'4sportsschedules.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1018,0,'4sportswear.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1019,0,'4spring.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1020,0,'4springbreak.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1021,0,'4springfield.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1022,0,'4springwater.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1023,0,'4stadiums.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1024,0,'4stamford.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1025,0,'4stamps.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1026,0,'4stargazing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1027,0,'4stars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1028,0,'4statecollege.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1029,0,'4stationery.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1030,0,'4stcloud.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1031,0,'4steak.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1032,0,'4steamboatsprings.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1033,0,'4stereos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1034,0,'4sterlingheights.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1035,0,'4steubenville.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1036,0,'4stjoseph.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1037,0,'4stlouis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1038,0,'4stock.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1039,0,'4stockmarket.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1040,0,'4stockquotes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1041,0,'4stockton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1042,0,'4stpatricksday.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1043,0,'4stpaul.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1044,0,'4stpetersburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1045,0,'4stress.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1046,0,'4studyabroad.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1047,0,'4substanceabuse.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1048,0,'4subways.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1049,0,'4summer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1050,0,'4summervacation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1051,0,'4sunglasses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1052,0,'4sunnyvale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1053,0,'4superbowl.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1054,0,'4surfing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1055,0,'4sweepstakes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1056,0,'4swimming.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1057,0,'4swing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1058,0,'4switzerland.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1059,0,'4syracuse.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1060,0,'4tabloids.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1061,0,'4tacoma.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1062,0,'4talentagencies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1063,0,'4talkradio.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1064,0,'4talkshows.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1065,0,'4tallahassee.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1066,0,'4tampa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1067,0,'4tattoos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1068,0,'4taxes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1069,0,'4tea.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1070,0,'4teams.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1071,0,'4technology.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1072,0,'4teenagers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1073,0,'4telecommuting.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1074,0,'4teleconference.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1075,0,'4telemarketing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1076,0,'4tempe.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1077,0,'4temps.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1078,0,'4tennis.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1079,0,'4terrehaute.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1080,0,'4texarkana.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1081,0,'4thanksgiving.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1082,0,'4the50s.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1083,0,'4the60s.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1084,0,'4the70s.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1085,0,'4the80s.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1086,0,'4the90s.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1087,0,'4theater.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1088,0,'4thecoldwar.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1089,0,'4themeparks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1090,0,'4themillennium.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1091,0,'4thepersonals.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1092,0,'4thousandoaks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1093,0,'4tickets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1094,0,'4ties.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1095,0,'4time.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1096,0,'4timeshares.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1097,0,'4tires.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1098,0,'4toledo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1099,0,'4top40.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1100,0,'4topeka.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1101,0,'4toronto.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1102,0,'4torrance.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1103,0,'4toys.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1104,0,'4trade.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1105,0,'4traffic.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1106,0,'4training.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1107,0,'4trains.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1108,0,'4travel2.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1109,0,'4travelagencies.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1110,0,'4travelbooks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1111,0,'4travelers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1112,0,'4trenton.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1113,0,'4trivia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1114,0,'4tropicalvacations.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1115,0,'4trucks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1116,0,'4tshirts.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1117,0,'4tucson.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1118,0,'4tulsa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1119,0,'4tuscaloosa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1120,0,'4tuxedos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1121,0,'4tv.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1122,0,'4tvshows.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1123,0,'4twins.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1124,0,'4tyler.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1125,0,'4umbrellas.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1126,0,'4unions.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1127,0,'4universities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1128,0,'4urbanlegends.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1129,0,'4usedcars.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1130,0,'4utica.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1131,0,'4vacation.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1132,0,'4vacationhomes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1133,0,'4vail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1134,0,'4valentine.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1135,0,'4vallejo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1136,0,'4vancouver.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1137,0,'4vcrs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1138,0,'4vegetarians.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1139,0,'4venice.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1140,0,'4venturecapital.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1141,0,'4veterans.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1142,0,'4vets.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1143,0,'4victoria.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1144,0,'4videocassettes.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1145,0,'4videogames.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1146,0,'4vietnamwar.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1147,0,'4vinegar.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1148,0,'4virginiabeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1149,0,'4virtual.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1150,0,'4virus.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1151,0,'4visalia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1152,0,'4visualbasic.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1153,0,'4vitamins.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1154,0,'4volleyball.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1155,0,'4volunteer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1156,0,'4waco.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1157,0,'4wallstreet.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1158,0,'4warren.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1159,0,'4washingtondc.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1160,0,'4watches.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1161,0,'4waterbury.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1162,0,'4watercraft.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1163,0,'4waterfront.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1164,0,'4waterloo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1165,0,'4waterskiing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1166,0,'4watersports.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1167,0,'4wausau.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1168,0,'4wavfiles.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1169,0,'4weather.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1170,0,'4webcams.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1171,0,'4webdesign.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1172,0,'4webhosting.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1173,0,'4webmalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1174,0,'4wedding.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1175,0,'4weightloss.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1176,0,'4westcovina.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1177,0,'4westpalmbeach.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1178,0,'4whitepages.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1179,0,'4wholesale.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1180,0,'4wichita.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1181,0,'4wichitafalls.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1182,0,'4williamsburg.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1183,0,'4williamsport.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1184,0,'4wilmington.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1185,0,'4windows.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1186,0,'4windsurfing.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1187,0,'4wine.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1188,0,'4winecountry.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1189,0,'4winston-salem.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1190,0,'4winter.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1191,0,'4wirelessdevices.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1192,0,'4woodworking.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1193,0,'4worcester.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1194,0,'4workingmothers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1195,0,'4worldrecords.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1196,0,'4worldwarii.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1197,0,'4worstofweb.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1198,0,'4writers.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1199,0,'4y2kbug.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1200,0,'4yellowpages.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1201,0,'4yellowstone.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1202,0,'4yoga.comYoga','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1203,0,'4york.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1204,0,'4youngstown.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1205,0,'4yuma.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1206,0,'4yuma.comn2.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1207,0,'4zoos.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1208,0,'909mail.dk','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1209,0,'abcflash.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1210,0,'accountant.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1211,0,'adexec.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1212,0,'aggies.org','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1213,0,'allergist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1214,0,'alumidirector.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1215,0,'AmExMail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1216,0,'apexmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1217,0,'archeologist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1218,0,'arrl.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1219,0,'asia.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1220,0,'AWSearch.zzn.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1221,0,'basemail.com.br','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1222,0,'beer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1223,0,'berkscounty.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1224,0,'bigfoot.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1225,0,'bimamail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1226,0,'bstar.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1227,0,'caramail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1228,0,'cheerful.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1229,0,'chemist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1230,0,'clerk.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1231,0,'collectiblesuperstore.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1232,0,'columnist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1233,0,'comic.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1234,0,'compaqsucks.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1235,0,'coolmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1236,0,'coolmail.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1237,0,'counselor.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1238,0,'crosswinds.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1239,0,'cruddybuddy.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1240,0,'deliveryman.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1241,0,'diplomats.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1242,0,'dot.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1243,0,'dr.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1244,0,'dragoncon.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1245,0,'eastmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1246,0,'email.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1247,0,'email.ro','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1248,0,'emumail.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1249,0,'engineer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1250,0,'europe.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1251,0,'execs.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1252,0,'financier.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1253,0,'flashmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1254,0,'fnmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1255,0,'francemel.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1256,0,'freemail.c3.hu','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1257,0,'freemail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1258,0,'freemail.nl','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1259,0,'freeweb.essenet.it','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1260,0,'gardener.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1261,0,'geocities.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1262,0,'geologist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1263,0,'gmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1264,0,'gmx.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1265,0,'gnwmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1266,0,'go.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1267,0,'goplay.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1268,0,'gotoworld.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1269,0,'grabmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1270,0,'graphicdesigner.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1271,0,'hello.net.au','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1272,0,'hotmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1273,0,'hotpop.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1274,0,'india.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1275,0,'insurer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1276,0,'joinme.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1277,0,'journalist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1278,0,'joymail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1279,0,'juno.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1280,0,'kitty.cc','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1281,0,'lawyer.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1282,0,'legislator.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1283,0,'liquidinformation.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1284,0,'lobbyist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1285,0,'loja.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1286,0,'lycosmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1287,0,'mad.scientist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1288,0,'mail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1289,0,'mail.forum.dk','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1290,0,'mail.kitty.cc','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1291,0,'mailandnews.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1292,0,'mailbr.com.br','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1293,0,'mailcity.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1294,0,'mailexcite.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1295,0,'mailgo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1296,0,'mailroom.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1297,0,'mailstart.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1298,0,'mauimail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1299,0,'milmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1300,0,'minister.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1301,0,'mixmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1302,0,'mygale.org','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1303,0,'mymail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1304,0,'n2.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1305,0,'n2mail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1306,0,'netscape.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1307,0,'optician.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1308,0,'pediatrician.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1309,0,'pinoymail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1310,0,'podox.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1311,0,'podox.sk','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1312,0,'politician.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1313,0,'post.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1314,0,'post.cz','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1315,0,'postmark.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1316,0,'postmaster.co.uk','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1317,0,'pplmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1318,0,'presidency.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1319,0,'priest.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1320,0,'publicist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1321,0,'realtyagent.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1322,0,'registerednurses.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1323,0,'representative.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1324,0,'rescueteam.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1325,0,'rocketmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1326,0,'sagra.lu','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1327,0,'scientist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1328,0,'sociologist.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1329,0,'start.com.au','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1330,0,'supernews.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1331,0,'talk21.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1332,0,'techie.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1333,0,'thefreesite.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1334,0,'themail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1335,0,'tripod.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1336,0,'umpire.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1337,0,'underwriters.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1338,0,'usa.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1339,0,'usa.net','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1340,0,'uymail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1341,0,'writeme.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1342,0,'xoom.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1343,0,'yahoo.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1344,0,'zdnetmail.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1345,0,'zensearch.com','banned e-mail',NULL,NULL,NULL);
INSERT INTO `bans` VALUES (1346,0,'zipmail.com.br','banned e-mail',NULL,NULL,NULL);
/*!40000 ALTER TABLE `bans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `batch_log`
--
DROP TABLE IF EXISTS `batch_files`;
CREATE TABLE `batch_files` (
  `batch_file_id` int(10) unsigned NOT NULL auto_increment,
  `payment_gateway_id` int(10) unsigned NOT NULL,
  `batch_file_name` varchar(255) NULL,
  `batch_file_content` text NULL,
  `batch_file_date_create` DATETIME NOT NULL,
  `batch_file_date_end` DATETIME NULL,
  `batch_file_status` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`batch_file_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`),
  KEY `batch_file_status` (`batch_file_status`),
  CONSTRAINT `bf_payment_gateway_id_fk` FOREIGN KEY (`payment_gateway_id`) REFERENCES `payment_gateways`(`payment_gateway_id`) ON DELETE RESTRICT ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `batch_file_transactions`;
CREATE TABLE `batch_file_transactions` (
  `batch_file_transaction_id` int(10) unsigned NOT NULL auto_increment,
  `batch_file_id` int(10) unsigned NULL,
  `transaction_id` int(10) unsigned NOT NULL,
  `batch_file_transaction_date_create` DATETIME NOT NULL,
  `batch_file_transaction_date_end` DATETIME NULL,
  `batch_file_transaction_status` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`batch_file_transaction_id`),
  KEY `transaction_id` (`transaction_id`),
  KEY `batch_file_id` (`batch_file_id`),
  KEY `batch_file_transaction_status` (`batch_file_transaction_status`),
  CONSTRAINT `batch_file_id_fk` FOREIGN KEY (`batch_file_id`) REFERENCES `batch_files`(`batch_file_id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `batch_log`;
CREATE TABLE `batch_log` (
  `batch_log_id` int(10) unsigned NOT NULL auto_increment,
  `batch_date_created` int(10) unsigned default NULL,
  `batch_sum_approved` decimal(10,2) default '0.00',
  `batch_sum_declined` decimal(10,2) default '0.00',
  `batch_sum_error` decimal(10,2) default '0.00',
  `batch_num_approved` smallint(5) unsigned default NULL,
  `batch_num_declined` smallint(5) unsigned default NULL,
  `batch_num_error` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`batch_log_id`),
  KEY `batch_date_created` (`batch_date_created`)
) ENGINE=MyISAM ;

--
-- Table structure for table `bookmarks`
--
DROP TABLE IF EXISTS `bookmarks`;
CREATE TABLE `bookmarks` (
  `bookmark_id` int(8) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `client_id` int(8) unsigned default NULL,
  `bookmark_url` text,
  `bookmark_action` varchar(60) default NULL,
  `bookmark_args` varchar(255) default NULL,
  `bookmark_name` varchar(50) default NULL,
  `bookmark_target` varchar(20) default NULL,
  `bookmark_window_width` smallint(5) unsigned default NULL,
  `bookmark_window_height` smallint(5) unsigned default NULL,
  `bookmark_count` int(8) unsigned default NULL,
  PRIMARY KEY  (`bookmark_id`),
  KEY `client_id` (`client_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `callback_log`
--
DROP TABLE IF EXISTS `callback_log`;
CREATE TABLE `callback_log` (
  `callback_log_id` int(10) unsigned NOT NULL auto_increment,
  `callback_log_type` tinyint(3) unsigned default NULL,
  `callback_log_transaction_id` varchar(255) default NULL,
  `callback_log_parent_transaction_id` varchar(255) default NULL,
  `callback_log_action` varchar(100) default NULL,
  `callback_log_action_status` varchar(100) default NULL,
  `client_id` int(8) unsigned default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `transaction_id` int(10) unsigned default NULL,
  `subscription_id` int(8) unsigned default NULL,
  `payment_gateway_id` int(10) unsigned,
  `callback_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`callback_log_id`),
  KEY `callback_log_type` (`callback_log_type`),
  KEY `callback_log_transaction_id` (`callback_log_transaction_id`),
  KEY `callback_log_parent_transaction_id` (`callback_log_parent_transaction_id`),
  KEY `callback_log_action` (`callback_log_action`),
  KEY `callback_log_action_status` (`callback_log_action_status`),
  KEY `client_id` (`client_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `transaction_id` (`transaction_id`),
  KEY `subscription_id` (`subscription_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`),
  KEY `callback_log_date_created` (`callback_log_date_created`)
) ENGINE=MyISAM ;

--
-- Table structure for table `callback_log_attributes`
--
DROP TABLE IF EXISTS `callback_log_attributes`;
CREATE TABLE `callback_log_attributes` (
  `callback_log_attribute_id` int(15) unsigned NOT NULL auto_increment,
  `callback_log_id` int(10) unsigned default NULL,
  `callback_log_attribute_name` varchar(255) default NULL,
  `callback_log_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`callback_log_attribute_id`),
  KEY `callback_log_id` (`callback_log_id`),
  KEY `callback_log_attribute_name` (`callback_log_attribute_name`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_attributes`
--
DROP TABLE IF EXISTS `client_attributes`;
CREATE TABLE `client_attributes` (
  `client_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `attribute_id` int(10) unsigned default NULL,
  `client_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`client_attribute_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `attribute_id` (`attribute_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_billing_account_shares`
--
DROP TABLE IF EXISTS `client_billing_account_shares`;
CREATE TABLE `client_billing_account_shares` (
  `billing_account_share_id` int(10) unsigned NOT NULL auto_increment,
  `billing_account_id` int(10) unsigned default NULL,
  `package_id` int(10) unsigned default NULL,
  `billing_account_fallback_group` tinyint(3) unsigned default NULL,
  `billing_account_share_group` tinyint(3) unsigned default NULL,
  `billing_account_share_value` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`billing_account_share_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `package_id` (`package_id`),
  KEY `billing_account_share_value` (`billing_account_share_value`),
  KEY `billing_account_fallback_group` (`billing_account_fallback_group`),
  KEY `billing_account_share_group` (`billing_account_share_group`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_billing_accounts`
--
DROP TABLE IF EXISTS `client_billing_accounts`;
CREATE TABLE `client_billing_accounts` (
  `billing_account_id` int(10) unsigned NOT NULL auto_increment,
  `prior_billing_account_id` int(10) unsigned default NULL,
  `billing_account_date_failed` int(10) unsigned default '0',
  `billing_account_historical` smallint(3) unsigned default '0',
  `client_contact_id` int(10) unsigned default NULL,
  `billing_card_name_on_card` varchar(255) default NULL,
  `billing_card_type` tinyint(3) unsigned default NULL,
  `billing_card_num` text,
  `billing_card_exp_month` tinyint(3) unsigned default NULL,
  `billing_card_exp_year` smallint(5) unsigned default NULL,
  `billing_card_issue_num` char(3) default NULL,
  `billing_card_start_date` varchar(255) default NULL,
  `protx_security_key` varchar(255) default NULL,
  `protx_transaction_code` varchar(255) default NULL,
  `protx_transaction_id` varchar(255) default NULL,
  `protx_authorization_code` varchar(255) default NULL,
  `velocitypay_cross_reference` varchar(50) default NULL,
  `velocitypay_auth_amount` decimal(10,2) unsigned default NULL,
  `billing_bank_type` varchar(25) default NULL,
  `billing_bank_name` varchar(50) default NULL,
  `billing_bank_aba_code` varchar(20) default NULL,
  `billing_bank_account_num` varchar(255) default NULL,
  `billing_bank_license_num` varchar(25) default NULL,
  `billing_bank_license_state` varchar(50) default NULL,
  `billing_bank_dob` varchar(25) default NULL,
  `billing_bank_state` varchar(50) default NULL,
  `billing_account_num_last_four` varchar(4) default NULL,
  `billing_account_active` tinyint(1) unsigned default '1',
  `billing_account_type` tinyint(3) unsigned default NULL,
  `billing_account_status` tinyint(3) unsigned default '0',
  `payment_gateway_id` int(10) unsigned,
  PRIMARY KEY  (`billing_account_id`),
  KEY `client_contact_id` (`client_contact_id`),
  KEY `billing_account_type` (`billing_account_type`),
  KEY `billing_account_date_failed` (`billing_account_date_failed`),
  KEY `protx_security_key` (`protx_security_key`),
  KEY `protx_transaction_code` (`protx_transaction_code`),
  KEY `protx_transaction_id` (`protx_transaction_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`),
  KEY `velocitypay_cross_reference` (`velocitypay_cross_reference`),
  KEY `billing_account_status` (`billing_account_status`),
  KEY `prior_billing_account_id` (`prior_billing_account_id`),
  KEY `billing_account_historical` (`billing_account_historical`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `client_billing_account_params`;
CREATE TABLE `client_billing_account_params` (
  `billing_account_id` INT(10) UNSIGNED NOT NULL,
  `param_name` VARCHAR(255) NOT NULL,
  `param_value` TEXT NOT NULL,
  PRIMARY KEY (`billing_account_id`, `param_name`)
) ENGINE=InnoDB ;

--
-- Table structure for table `client_change_log`
--
DROP TABLE IF EXISTS `client_change_log`;
CREATE TABLE `client_change_log` (
  `change_log_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `change_log_db_table_name` varchar(100) default NULL,
  `change_log_db_table_pk` varchar(50) default NULL,
  `change_log_db_table_pkvalue` varchar(50) default NULL,
  `change_log_column_name` varchar(100) default NULL,
  `change_log_old_value` longtext,
  `change_log_new_value` longtext,
  `change_log_action_by` tinyint(3) unsigned default NULL,
  `change_log_action_who` int(10) unsigned default NULL,
  `parent_change_log_id` int(10) unsigned default NULL,
  `change_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`change_log_id`),
  KEY `client_id` (`client_id`),
  KEY `change_log_date_created` (`change_log_date_created`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_children_rel`
--
DROP TABLE IF EXISTS `client_children_rel`;
CREATE TABLE `client_children_rel` (
  `client_id` int(8) unsigned NOT NULL default '0',
  `child_client_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_id`,`child_client_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_contact_session_rel`
--
DROP TABLE IF EXISTS `client_contact_session_rel`;
CREATE TABLE `client_contact_session_rel` (
  `client_contact_id` int(10) unsigned NOT NULL default '0',
  `session_id` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`client_contact_id`,`session_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_contacts`
--
DROP TABLE IF EXISTS `client_contacts`;
CREATE TABLE `client_contacts` (
  `client_contact_id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `contact_username` varchar(75) default NULL,
  `contact_password` varchar(255) default NULL,
  `contact_password_date_changed` int(10) unsigned NOT NULL default 0,
  `contact_temp_password` varchar(255) default NULL,
  `contact_first_name` varchar(100) default NULL,
  `contact_last_name` varchar(100) default NULL,
  `contact_email` varchar(100) default NULL,
  `contact_email_format` tinyint(3) unsigned default NULL,
  `contact_email_invoice_pdf` tinyint(3) unsigned default NULL,
  `contact_company` varchar(100) default NULL,
  `contact_address_1` varchar(100) default NULL,
  `contact_address_2` varchar(100) default NULL,
  `contact_city` varchar(100) default NULL,
  `contact_county` varchar(100) default '',
  `contact_state` varchar(100) default NULL,
  `contact_zip` varchar(100) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `contact_phone1` varchar(25) default NULL,
  `contact_phone2` varchar(25) default NULL,
  `contact_fax` varchar(25) default NULL,
  `contact_mobile_phone` varchar(25) default NULL,
  `contact_date_created` int(10) unsigned default NULL,
  `contact_primary` tinyint(3) unsigned default NULL,
  `contact_active` tinyint(1) unsigned default '1',
  `contact_external_id_1` varchar(50) default NULL,
  `contact_external_id_2` varchar(50) default NULL,
  `contact_external_id_3` varchar(50) default NULL,
  `contact_use_specified_email_rules_only` tinyint(1) NOT NULL default '0',
  `guid` char(36) NOT NULL,
  `sso_fi_id` varchar(50) default NULL,
  `sso_sp_user_id` varchar(50) default NULL,
  `sync_status` ENUM('synced', 'syncing', 'error', 'non-syncable') NOT NULL DEFAULT 'synced',
  `sync_tasks` int(10) unsigned NOT NULL default 0,
  `sync_error` text NULL default NULL,
  `sync_last_time` datetime NULL default NULL,
  `shopping_session_id` varchar(40) NULL,
  `shopping_session_expiration_date` int(10) unsigned default NULL,
  PRIMARY KEY  (`client_contact_id`),
  UNIQUE KEY `contact_username` (`contact_username`),
  KEY `client_id` (`client_id`),
  KEY `contact_password` (`contact_password`),
  KEY `contact_first_name` (`contact_first_name`),
  KEY `contact_last_name` (`contact_last_name`),
  KEY `contact_email` (`contact_email`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`),
  KEY `contact_primary` (`contact_primary`),
  KEY `contact_active` (`contact_active`),
  UNIQUE KEY `guid` (`guid`),
  UNIQUE KEY `shopping_session_id` (`shopping_session_id`),
  KEY `sync_status` (`sync_status`),
  KEY `sync_tasks` (`sync_tasks`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_group_rel`
--
DROP TABLE IF EXISTS `client_group_rel`;
CREATE TABLE `client_group_rel` (
  `client_id` int(8) unsigned NOT NULL default '0',
  `client_group_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_id`,`client_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_groups`
--
DROP TABLE IF EXISTS `client_groups`;
CREATE TABLE `client_groups` (
  `client_group_id` int(8) unsigned NOT NULL auto_increment,
  `client_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`client_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_notes`
--
DROP TABLE IF EXISTS `client_notes`;
CREATE TABLE `client_notes` (
  `client_note_id` int(8) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `client_note_date_created` int(10) unsigned default NULL,
  `client_note_date_modified` int(10) unsigned default NULL,
  `client_note_text` longtext,
  PRIMARY KEY  (`client_note_id`),
  KEY `client_id` (`client_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `client_contact_server_params`
--
DROP TABLE IF EXISTS `client_contact_server_params`;
CREATE TABLE `client_contact_server_params` (
  `client_contact_id` INT(10) UNSIGNED NOT NULL,
  `server_id` INT(10) UNSIGNED NOT NULL,
  `param_name` VARCHAR(255) NOT NULL,
  `param_value` TEXT,
  PRIMARY KEY (`client_contact_id`, `server_id`, `param_name`)
) ENGINE=InnoDB;

--
-- Table structure for table `clients`
--
DROP TABLE IF EXISTS `clients`;
CREATE TABLE `clients` (
  `client_id` int(8) unsigned NOT NULL auto_increment,
  `company_id` smallint(5) unsigned default NULL,
  `client_company` varchar(100) default NULL,
  `client_status` smallint(5) unsigned default NULL,
  `client_status_reason` varchar(255) default NULL,
  `apply_tax` tinyint(3) unsigned default NULL,
  `tax_id_number` varchar(50) default NULL,
  `theme_id` smallint(5) unsigned default NULL,
  `skin_id` varchar(255) default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `client_active` tinyint(1) unsigned default '1',
  `client_mail_invoices` tinyint(1) unsigned default '0',
  `group_id` int(10) unsigned default NULL,
  `client_billing_day` tinyint(2) unsigned default '0',
  `default_billing_account_id` int(10) unsigned default '0',
  `client_date_created` decimal(17,7) unsigned default NULL,
  `client_date_cancelled` int(10) unsigned default NULL,
  `client_signup_ip` VARCHAR(39) default '',
  `client_last_ip` VARCHAR(39) default '',
  `guid` char(36) NOT NULL,
  `client_type` tinyint(1) unsigned NOT NULL default '0',
  `sync_status` ENUM('synced', 'syncing', 'error', 'non-syncable') NOT NULL DEFAULT 'synced',
  `sync_tasks` int(10) unsigned NOT NULL default 0,
  `sync_error` text NULL default NULL,
  `sync_last_time` datetime NULL default NULL,
  PRIMARY KEY  (`client_id`),
  KEY `client_status` (`client_status`),
  KEY `client_active` (`client_active`),
  KEY `company_id` (`company_id`),
  KEY `countries_id` (`countries_id`),
  KEY `client_date_cancelled` (`client_date_cancelled`),
  UNIQUE KEY `guid` (`guid`),
  KEY `client_type` (`client_type`),
  KEY `sync_status` (`sync_status`),
  KEY `sync_tasks` (`sync_tasks`)
) ENGINE=MyISAM ;

--
-- Table structure for table `companies`
--
DROP TABLE IF EXISTS `companies`;
CREATE TABLE `companies` (
  `company_id` smallint(5) unsigned NOT NULL auto_increment,
  `company_name` varchar(50) default NULL,
  `company_short_description` text,
  `company_description` text,
  `company_url` varchar(255) default NULL,
  `company_client_url` varchar(255) default NULL,
  `company_order_url` varchar(255) default NULL,
  `company_email` varchar(100) default NULL,
  `company_address_1` varchar(100) default NULL,
  `company_address_2` varchar(100) default NULL,
  `company_city` varchar(100) default NULL,
  `company_state` varchar(100) default NULL,
  `company_zip` varchar(100) default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `company_phone1` varchar(25) default NULL,
  `company_phone2` varchar(25) default NULL,
  `company_fax` varchar(25) default NULL,
  `company_tax_id_number` varchar(50) default NULL,
  PRIMARY KEY  (`company_id`),
  KEY `company_name` (`company_name`),
  KEY `company_tax_id_number` (`company_tax_id_number`)
) ENGINE=MyISAM AUTO_INCREMENT=2 ;

--
-- Dumping data for table `companies`
--
LOCK TABLES `companies` WRITE;
/*!40000 ALTER TABLE `companies` DISABLE KEYS */;
INSERT INTO `companies` VALUES (1,'COMPANYNAME','COMPANYDESCRIPTION','','COMPANYURL','http://localhost/cvs/app-modernbill-client/','http://localhost/cvs/app-modernbill-order/','','','','','','',225,'','','',NULL);
/*!40000 ALTER TABLE `companies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company_admin_group_rel`
--
DROP TABLE IF EXISTS `company_admin_group_rel`;
CREATE TABLE `company_admin_group_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `admin_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`admin_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `company_admin_rel`
--
DROP TABLE IF EXISTS `company_admin_rel`;
CREATE TABLE `company_admin_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `company_client_group_rel`
--
DROP TABLE IF EXISTS `company_client_group_rel`;
CREATE TABLE `company_client_group_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `client_group_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`client_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `company_news_rel`
--
DROP TABLE IF EXISTS `company_news_rel`;
CREATE TABLE `company_news_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `news_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`news_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `company_product_rel`
--
DROP TABLE IF EXISTS `company_product_rel`;
CREATE TABLE `company_product_rel` (
  `company_id` smallint(5) unsigned NOT NULL default '0',
  `product_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`company_id`,`product_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `config_groups`
--
DROP TABLE IF EXISTS `config_groups`;
CREATE TABLE `config_groups` (
  `config_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `parent_config_group_id` smallint(5) unsigned default NULL,
  `config_group_name` varchar(100) default NULL,
  `config_group_icon` varchar(25) default NULL,
  `config_group_trans_key` varchar(80) default NULL,
  `config_group_order` smallint(5) unsigned default NULL,
  `config_group_locked` tinyint(3) unsigned default NULL,
  `config_group_action_file` varchar(25) default NULL,
  `config_group_action_name` varchar(50) default NULL,
  `config_group_description` varchar(75) default NULL,
  PRIMARY KEY  (`config_group_id`),
  KEY `parent_config_group_id` (`parent_config_group_id`),
  KEY `config_group_name` (`config_group_name`),
  KEY `config_group_locked` (`config_group_locked`)
) ENGINE=MyISAM AUTO_INCREMENT=93;

--
-- Dumping data for table `config_groups`
--
LOCK TABLES `config_groups` WRITE;
/*!40000 ALTER TABLE `config_groups` DISABLE KEYS */;
INSERT INTO `config_groups` VALUES (1,0,'system','040.gif','TRANS_SYSTEM_SETTINGS',0,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (2,1,'internal','','',0,1,'','',NULL);
INSERT INTO `config_groups` VALUES (5,1,'admin','','TRANS_ADMIN_SETTINGS',3,1,'admins.php','ShowAdmins',NULL);
INSERT INTO `config_groups` VALUES (7,1,'company','','TRANS_COMPANY_SETTINGS',5,1,'companies.php','EditCompany',NULL);
INSERT INTO `config_groups` VALUES (8,1,'versions','','TRANS_SETTINGS_VERSION_TITLE',6,1,'','',NULL);
INSERT INTO `config_groups` VALUES (9,0,'payment','041.gif','TRANS_PAYMENT_SETTINGS',2,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (12,9,'paymentQueue','','TRANS_PAYMENT_QUEUE',3,1,'paymentqueue.php','EditPaymentQueueSettings',NULL);
INSERT INTO `config_groups` VALUES (13,9,'clientSidePaymentOptions','','TRANS_CLIENT_SIDE_PAYMENT_OPTIONS',4,1,'','','TRANS_CLIENT_PAYMENT_OPTIONS_TEXT');
INSERT INTO `config_groups` VALUES (14,9,'virtualTerminal','','TRANS_VIRTUAL_TERMINALS',2,1,'paymentgroups.php','ShowVirtualTerminals',NULL);
INSERT INTO `config_groups` VALUES (15,0,'order','045.gif','TRANS_ORDER_SETTINGS',6,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (16,15,'orderforms','','TRANS_ONLINE_STORES_HEADER',1,1,'orderforms.php','ShowOrderForms',NULL);
INSERT INTO `config_groups` VALUES (17,16,'0','','TRANS_ORDER_FORM',1,1,'orderforms.php','ShowOrderForms',NULL);
INSERT INTO `config_groups` VALUES (18,15,'fraudsets','','TRANS_MANAGE_FRAUD_SETTINGS',2,1,'fraudsets.php','ShowFraudSets',NULL);
INSERT INTO `config_groups` VALUES (20,15,'attributes','','TRANS_CUSTOM_ATTRIBUTES',3,1,'orderforms.php','ShowAttributes',NULL);
INSERT INTO `config_groups` VALUES (21,0,'server','043.gif','TRANS_SERVER_SETTINGS',4,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (22,21,'serverGroups','','TRANS_SERVER_GROUP_SETTINGS',2,1,'servergroups.php','ShowServerGroups',NULL);
INSERT INTO `config_groups` VALUES (23,22,'panel','','TRANS_SERVER_MODULES',2,1,'','',NULL);
INSERT INTO `config_groups` VALUES (24,23,'generic','','TRANS_PANEL_GENERIC',1,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (25,23,'directadmin','','TRANS_PANEL_DIRECTADMIN',2,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (26,23,'pleskunix','','TRANS_PANEL_PLESKUNIX',3,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (27,23,'cpanel','','TRANS_PANEL_CPANEL',4,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (28,23,'helm','','TRANS_PANEL_HELM',5,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (29,23,'ensim','','TRANS_PANEL_ENSIM',6,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (30,23,'tcadmin','','TRANS_PANEL_TCADMIN',7,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (31,23,'freeradius','','TRANS_PANEL_FREERADIUS',8,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (32,23,'hostopia','','TRANS_PANEL_HOSTOPIA',9,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (33,23,'interworx','','TRANS_PANEL_INTERWORX',10,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (34,21,'modules','','TRANS_MODERNBILL_MODULE_INFO',2,1,'modules.php','ShowSystemModuleInfo',NULL);
INSERT INTO `config_groups` VALUES (35,0,'product','047.gif','TRANS_PRODUCT_SETTINGS_CONFIGURATION',8,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (36,35,'generic','','TRANS_SETTINGS_PRODUCTS_TITLE',1,1,'products.php','ShowProducts',NULL);
INSERT INTO `config_groups` VALUES (37,35,'managementrules','','TRANS_PRODUCT_MANAGEMENT_SETTINGS',1,1,'','',NULL);
INSERT INTO `config_groups` VALUES (38,35,'cycles','','TRANS_CYCLE_SETTINGS',1,1,'products.php','ShowCycles',NULL);
INSERT INTO `config_groups` VALUES (39,0,'domain','042.gif','TRANS_DOMAIN_SETTINGS',3,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (40,39,'tlds','','TRANS_DOMAIN_TLD_SETTINGS',1,1,'products.php','ShowTLDs',NULL);
INSERT INTO `config_groups` VALUES (41,39,'sync','','TRANS_DOMAIN_SYNC_SETTINGS',2,1,'','',NULL);
INSERT INTO `config_groups` VALUES (42,39,'registrar','','TRANS_REGISTRAR_MODULES',3,1,'registrars.php','ShowRegistrars',NULL);
INSERT INTO `config_groups` VALUES (47,0,'billing','044.gif','TRANS_BILLING_SETTINGS',5,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (48,47,'invoice','','TRANS_INVOICE_SETTINGS',1,1,'','','TRANS_CHANGE_INVOICE_SETTINGS_WARNING');
INSERT INTO `config_groups` VALUES (50,47,'prepaydiscounts','','TRANS_PREPAY_DISCOUNT_TIERS',4,1,'configs.php','ShowPrepayDiscounts',NULL);
INSERT INTO `config_groups` VALUES (51,0,'email','046.gif','TRANS_EMAIL_SETTINGS_HEADER',7,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (52,51,'emailSettings','','TRANS_EMAIL_SETTINGS',4,1,'modules.php','EditEmailConfig',NULL);
INSERT INTO `config_groups` VALUES (53,51,'templates','','TRANS_EMAIL_TEMPLATE_GROUPS',2,1,'emails.php','ShowEmailTemplateGroups',NULL);
INSERT INTO `config_groups` VALUES (54,0,'automation','048.gif','TRANS_AUTOMATION_SETTINGS',9,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (55,54,'systemQueue','','TRANS_SYSTEM_QUEUE_SETTINGS',1,1,'','',NULL);
INSERT INTO `config_groups` VALUES (56,54,'ipqueue','','TRANS_IP_QUEUE_SETTINGS',2,1,'servers.php','ShowIPLog',NULL);
INSERT INTO `config_groups` VALUES (57,54,'autoSuspension','','TRANS_AUTOSUSPEND_SETTINGS',4,1,'','',NULL);
INSERT INTO `config_groups` VALUES (58,0,'userSettings','049.gif','TRANS_USER_SETTINGS_HEADER',10,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (59,58,'display','','TRANS_USER_SETTINGS',1,1,'','','TRANS_CHANGE_USER_SETTINGS_WARNING');
INSERT INTO `config_groups` VALUES (60,58,'forums','','TRANS_FORUMS_SETTINGS',3,1,'','',NULL);
INSERT INTO `config_groups` VALUES (61,58,'themes','','TRANS_THEME_SETTINGS',4,1,'themes.php','ShowThemes',NULL);
INSERT INTO `config_groups` VALUES (62,0,'securitySettings','','TRANS_SECURITY_SETTINGS',1,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (63,62,'encryption','','TRANS_ENCRYPTION_SETTINGS',1,1,'configs.php','EditEncryptionConfigs',NULL);
INSERT INTO `config_groups` VALUES (64,62,'authentication','','TRANS_SECURITY_AUTH_SETTINGS',2,1,'security.php','EditAuthSettings',NULL);
INSERT INTO `config_groups` VALUES (65,62,'audit','','TRANS_SECURITY_AUDIT',3,1,'security.php','ShowActionLog',NULL);
INSERT INTO `config_groups` VALUES (67,62,'fraudguardian','','TRANS_FRAUD_MODULES',3,1,'modules.php','EditFraudGuardianConfig',NULL);
INSERT INTO `config_groups` VALUES (68,67,'0','','FraudGuardian',1,0,'modules.php','EditFraudCallConfig',NULL);
INSERT INTO `config_groups` VALUES (72,0,'ssl','','TRANS_SSL_SETTINGS',6,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (73,72,'sslfactory','','TRANS_SSL_MODULES_SSLFACTORY',1,1,'modules.php','EditSSLFactoryConfig',NULL);
INSERT INTO `config_groups` VALUES (74,26,'0',NULL,'PleskUnix',1,0,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (77,23,'pleskwin','','TRANS_PANEL_PLESKWIN',3,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (78,77,'0',NULL,'PleskWin',1,0,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (79,1,'sso','','',1,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (80,9,'paymentGateways','','TRANS_PAYMENT_GATEWAYS',1,1,'paymentgateways.php','ShowPaymentGateways',NULL);
INSERT INTO `config_groups` VALUES (81,72,'sslmodule','','TRANS_SSL_PLUGINS',1,1,'modules.php','ShowSSLPlugins',NULL);
INSERT INTO `config_groups` VALUES (82,0,'clientGroups','','TRANS_CLIENT_GROUPS',11,1,NULL,NULL,NULL);
INSERT INTO `config_groups` VALUES (83,82,'showClientGroups','','TRANS_SHOW_CLIENT_GROUPS',1,1,'clients.php','ShowAttributeGroups',NULL);
INSERT INTO `config_groups` VALUES (84,82,'newClientGroup','','TRANS_ADD_NEW_CLIENT_GROUPS',2,1,'clients.php','AddAttributeGroup',NULL);
INSERT INTO `config_groups` VALUES (85,82,'manageGroupAttributes','','TRANS_MANAGE_GROUPS_ATTRIBUTE',3,1,'clients.php','ShowGroupAttributes',NULL);
INSERT INTO `config_groups` VALUES (88,15,'bans','','TRANS_SHOW_BANS',6,1,'orderforms.php','ShowBans',NULL);
INSERT INTO `config_groups` VALUES (89,15,'addBan','','TRANS_ADD_BAN',7,1,'orderforms.php','AddBan',NULL);
INSERT INTO `config_groups` VALUES (90,47,'taxZoneGroups','','TRANS_TAX_ZONE_GROUPS',4,1,'taxes.php','ShowTaxZoneGroups',NULL);
INSERT INTO `config_groups` VALUES (91,47,'pdfInvoice','','TRANS_INVOICE_PDF_CONFIG_GROUP_TITLE',5,1,NULL,NULL,'TRANS_INVOICE_PDF_CONFIG_GROUP_DESC');
INSERT INTO `config_groups` VALUES (93,47,'invoiceFactura','','TRANS_INVOICE_FACTURA_SETTINGS',2,1,'invoices.php','EditInvoiceFacturaSettings',NULL);

/*!40000 ALTER TABLE `config_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_param_values`
--
DROP TABLE IF EXISTS `config_param_values`;
CREATE TABLE `config_param_values` (
  `config_param_value_id` int(10) unsigned NOT NULL auto_increment,
  `config_param_id` int(10) unsigned default NULL,
  `config_param_value_name` varchar(75) default NULL,
  `config_param_value_trans_key` varchar(80) default NULL,
  `config_param_value_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`config_param_value_id`),
  KEY `config_param_id` (`config_param_id`),
  KEY `config_param_value_order` (`config_param_value_order`)
) ENGINE=MyISAM AUTO_INCREMENT=289 ;

--
-- Dumping data for table `config_param_values`
--
LOCK TABLES `config_param_values` WRITE;
/*!40000 ALTER TABLE `config_param_values` DISABLE KEYS */;
INSERT INTO `config_param_values` VALUES (1,3,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (2,3,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (3,8,'charge','TRANS_CHARGE',1);
INSERT INTO `config_param_values` VALUES (4,8,'auth','TRANS_AUTH_ONLY',2);
INSERT INTO `config_param_values` VALUES (5,9,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (6,9,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (7,10,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (8,10,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (9,11,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (10,11,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (11,12,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (12,12,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (13,13,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (14,13,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (15,14,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (16,14,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (17,15,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (18,15,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (33,25,'0','TRANS_DOWNGRADE_NOW',1);
INSERT INTO `config_param_values` VALUES (34,25,'1','TRANS_END_OF_CYCLE',2);
INSERT INTO `config_param_values` VALUES (43,30,'0','TRANS_UPGRADE_NOW',1);
INSERT INTO `config_param_values` VALUES (44,30,'1','TRANS_END_OF_CYCLE',2);
INSERT INTO `config_param_values` VALUES (146,211,'anniversary','TRANS_ANNIVERSARY',1);
INSERT INTO `config_param_values` VALUES (147,211,'monthly','TRANS_MONTHLY',2);
INSERT INTO `config_param_values` VALUES (148,212,'1','1',1);
INSERT INTO `config_param_values` VALUES (149,212,'2','2',2);
INSERT INTO `config_param_values` VALUES (150,212,'3','3',3);
INSERT INTO `config_param_values` VALUES (151,212,'4','4',4);
INSERT INTO `config_param_values` VALUES (152,212,'5','5',5);
INSERT INTO `config_param_values` VALUES (153,212,'6','6',6);
INSERT INTO `config_param_values` VALUES (154,212,'7','7',7);
INSERT INTO `config_param_values` VALUES (155,212,'8','8',8);
INSERT INTO `config_param_values` VALUES (156,212,'9','9',9);
INSERT INTO `config_param_values` VALUES (157,212,'10','10',10);
INSERT INTO `config_param_values` VALUES (158,212,'11','11',11);
INSERT INTO `config_param_values` VALUES (159,212,'12','12',12);
INSERT INTO `config_param_values` VALUES (160,212,'13','13',13);
INSERT INTO `config_param_values` VALUES (161,212,'14','14',14);
INSERT INTO `config_param_values` VALUES (162,212,'15','15',15);
INSERT INTO `config_param_values` VALUES (163,212,'16','16',16);
INSERT INTO `config_param_values` VALUES (164,212,'17','17',17);
INSERT INTO `config_param_values` VALUES (165,212,'18','18',18);
INSERT INTO `config_param_values` VALUES (166,212,'19','19',19);
INSERT INTO `config_param_values` VALUES (167,212,'20','20',20);
INSERT INTO `config_param_values` VALUES (168,212,'21','21',21);
INSERT INTO `config_param_values` VALUES (169,212,'22','22',22);
INSERT INTO `config_param_values` VALUES (170,212,'23','23',23);
INSERT INTO `config_param_values` VALUES (171,212,'24','24',24);
INSERT INTO `config_param_values` VALUES (172,212,'25','25',25);
INSERT INTO `config_param_values` VALUES (173,212,'26','26',26);
INSERT INTO `config_param_values` VALUES (174,212,'27','27',27);
INSERT INTO `config_param_values` VALUES (175,212,'28','28',28);
INSERT INTO `config_param_values` VALUES (176,213,'1','1',1);
INSERT INTO `config_param_values` VALUES (177,213,'2','2',2);
INSERT INTO `config_param_values` VALUES (178,213,'3','3',3);
INSERT INTO `config_param_values` VALUES (179,213,'4','4',4);
INSERT INTO `config_param_values` VALUES (180,213,'5','5',5);
INSERT INTO `config_param_values` VALUES (181,213,'6','6',6);
INSERT INTO `config_param_values` VALUES (182,213,'7','7',7);
INSERT INTO `config_param_values` VALUES (183,213,'8','8',8);
INSERT INTO `config_param_values` VALUES (184,213,'9','9',9);
INSERT INTO `config_param_values` VALUES (185,213,'10','10',10);
INSERT INTO `config_param_values` VALUES (186,213,'11','11',11);
INSERT INTO `config_param_values` VALUES (187,213,'12','12',12);
INSERT INTO `config_param_values` VALUES (188,213,'13','13',13);
INSERT INTO `config_param_values` VALUES (189,213,'14','14',14);
INSERT INTO `config_param_values` VALUES (190,213,'15','15',15);
INSERT INTO `config_param_values` VALUES (191,213,'16','16',16);
INSERT INTO `config_param_values` VALUES (192,213,'17','17',17);
INSERT INTO `config_param_values` VALUES (193,213,'18','18',18);
INSERT INTO `config_param_values` VALUES (194,213,'19','19',19);
INSERT INTO `config_param_values` VALUES (195,213,'20','20',20);
INSERT INTO `config_param_values` VALUES (196,213,'21','21',21);
INSERT INTO `config_param_values` VALUES (197,213,'22','22',22);
INSERT INTO `config_param_values` VALUES (198,213,'23','23',23);
INSERT INTO `config_param_values` VALUES (199,213,'24','24',24);
INSERT INTO `config_param_values` VALUES (200,213,'25','25',25);
INSERT INTO `config_param_values` VALUES (201,213,'26','26',26);
INSERT INTO `config_param_values` VALUES (202,213,'27','27',27);
INSERT INTO `config_param_values` VALUES (203,213,'28','28',28);
INSERT INTO `config_param_values` VALUES (204,214,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (205,214,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (206,215,'0','TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (207,215,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (214,219,'%%ID%%','ID',1);
INSERT INTO `config_param_values` VALUES (215,219,'%%SEQ%%','SEQ, example: 123',2);
INSERT INTO `config_param_values` VALUES (216,219,'%%CURYEAR%%-%%ID%%','YEAR-ID, example: 01-2006-12345',3);
INSERT INTO `config_param_values` VALUES (217,219,'%%CURMONTH%%-%%CURYEAR%%-%%ID%%','MONTH-YEAR-ID, example: 01-2006-12345',4);
INSERT INTO `config_param_values` VALUES (218,219,'%%VATYEAR%%-%%ID%%','VATYEAR-ID, example: 10-2006-12345',5);
INSERT INTO `config_param_values` VALUES (219,219,'%%VATMONTH%%-%%VATYEAR%%-%%ID%%','VATMONTH-VATYEAR-ID, , example: 10-2006-12345',6);
INSERT INTO `config_param_values` VALUES (220,219,'%%CURYEAR%%-%%SEQ%%','YEAR-SEQ, example: 2006-1',7);
INSERT INTO `config_param_values` VALUES (221,219,'%%CURMONTH%%-%%CURYEAR%%-%%SEQ%%','MONTH-YEAR-SEQ, example: 01-2006-1',8);
INSERT INTO `config_param_values` VALUES (222,219,'%%VATYEAR%%-%%SEQ%%','VATYEAR-SEQ, example: 2006-1',9);
INSERT INTO `config_param_values` VALUES (223,219,'%%VATMONTH%%-%%VATYEAR%%-%%SEQ%%','VATMONTH-VATYEAR-SEQ, example: 10-2006-1',10);
INSERT INTO `config_param_values` VALUES (224,232,'0','TRANS_RUN_NO',1);
INSERT INTO `config_param_values` VALUES (225,232,'1','TRANS_RUN_NO_BALANCE',2);
INSERT INTO `config_param_values` VALUES (226,232,'2','TRANS_RUN_PAID',3);
INSERT INTO `config_param_values` VALUES (227,232,'3','TRANS_RUN_NOT_PAID',4);
INSERT INTO `config_param_values` VALUES (228,233,'0','TRANS_RUN_NO',1);
INSERT INTO `config_param_values` VALUES (229,233,'1','TRANS_RUN_NO_BALANCE',2);
INSERT INTO `config_param_values` VALUES (230,233,'2','TRANS_RUN_PAID',3);
INSERT INTO `config_param_values` VALUES (231,233,'3','TRANS_RUN_NOT_PAID',4);
INSERT INTO `config_param_values` VALUES (232,234,'0','TRANS_RUN_NO',1);
INSERT INTO `config_param_values` VALUES (233,234,'1','TRANS_RUN_NO_BALANCE',2);
INSERT INTO `config_param_values` VALUES (234,234,'2','TRANS_RUN_PAID',3);
INSERT INTO `config_param_values` VALUES (235,234,'3','TRANS_RUN_NOT_PAID',4);
INSERT INTO `config_param_values` VALUES (236,235,'0','TRANS_RUN_NO',1);
INSERT INTO `config_param_values` VALUES (237,235,'1','TRANS_RUN_NO_BALANCE',2);
INSERT INTO `config_param_values` VALUES (238,235,'2','TRANS_RUN_PAID',3);
INSERT INTO `config_param_values` VALUES (239,235,'3','TRANS_RUN_NOT_PAID',4);
INSERT INTO `config_param_values` VALUES (240,236,'0','TRANS_RUN_NO',1);
INSERT INTO `config_param_values` VALUES (241,236,'1','TRANS_RUN_NO_BALANCE',2);
INSERT INTO `config_param_values` VALUES (242,236,'2','TRANS_RUN_PAID',3);
INSERT INTO `config_param_values` VALUES (243,236,'3','TRANS_RUN_NOT_PAID',4);
INSERT INTO `config_param_values` VALUES (244,237,'0','TRANS_RUN_AFTER_PANEL',1);
INSERT INTO `config_param_values` VALUES (245,237,'1','TRANS_RUN_AFTER_PANEL_FAILURE',2);
INSERT INTO `config_param_values` VALUES (246,237,'2','TRANS_RUN_IGNORE_PANEL',3);
INSERT INTO `config_param_values` VALUES (277,295,NULL,'TRANS_NO',1);
INSERT INTO `config_param_values` VALUES (278,295,'1','TRANS_YES',2);
INSERT INTO `config_param_values` VALUES (279,298,'0','TRANS_STACKING_PER_SERVER',1);
INSERT INTO `config_param_values` VALUES (280,298,'1','TRANS_DISABLE_STACKING',2);
INSERT INTO `config_param_values` VALUES (281,303,'inches','INCHES',1);
INSERT INTO `config_param_values` VALUES (282,303,'mm','MM',2);
INSERT INTO `config_param_values` VALUES (283,309,'left','LEFT',1);
INSERT INTO `config_param_values` VALUES (284,309,'right','RIGHT',2);
/*!40000 ALTER TABLE `config_param_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `config_params`
--
DROP TABLE IF EXISTS `config_params`;
CREATE TABLE `config_params` (
  `config_param_id` int(10) unsigned NOT NULL auto_increment,
  `config_group_id` smallint(5) unsigned default NULL,
  `config_param_name` varchar(100) default NULL,
  `config_param_value` text,
  `config_param_group_trans_key` varchar(80) default NULL,
  `config_param_trans_key` varchar(80) default NULL,
  `config_param_description` varchar(75) default NULL,
  `config_param_input_type` char(1) default NULL,
  `config_param_required` tinyint(3) unsigned default NULL,
  `config_param_order` smallint(5) unsigned default NULL,
  `config_param_locked` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`config_param_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `config_param_name` (`config_param_name`),
  KEY `config_param_required` (`config_param_required`)
) ENGINE=MyISAM AUTO_INCREMENT=314 ;

--
-- Dumping data for table `config_params`
--
LOCK TABLES `config_params` WRITE;
/*!40000 ALTER TABLE `config_params` DISABLE KEYS */;
INSERT INTO `config_params` VALUES (1,2,'license','plesk',NULL,NULL,NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (2,2,'registry_0000','',NULL,NULL,NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (7,8,'installVersion','10.3.0-1','','TRANS_INSTALL_VERSION','TRANS_INSTALL_VERSION_DESC','t',2,1,0);
INSERT INTO `config_params` VALUES (8,12,'transactionAction','charge','','TRANS_PAYMENT_QUEUE_ACTION','TRANS_PAYMENT_QUEUE_ACTION_DESC','s',1,1,0);
INSERT INTO `config_params` VALUES (9,12,'generateNew','1','','TRANS_PAYMENT_QUEUE_NEW','','r',1,1,0);
INSERT INTO `config_params` VALUES (10,12,'generateDeclined','1','','TRANS_PAYMENT_QUEUE_DECLINED','','r',1,2,0);
INSERT INTO `config_params` VALUES (11,12,'generateError','1','','TRANS_PAYMENT_QUEUE_ERROR','','r',1,3,0);
INSERT INTO `config_params` VALUES (12,12,'generateDueDateOnly','1','','TRANS_PAYMENT_QUEUE_DUE_DATE_ONLY','','r',1,4,0);
INSERT INTO `config_params` VALUES (13,12,'clearPaymentQueue','1','','TRANS_PAYMENT_QUEUE_CLEAR','TRANS_PAYMENT_QUEUE_CLEAR_DESC','r',1,5,0);
INSERT INTO `config_params` VALUES (14,12,'try_lesser_amounts','0','','TRANS_PAYMENT_QUEUE_TRY_LESSER_AMOUNTS','TRANS_PAYMENT_QUEUE_TRY_LESSER_AMOUNTS_DESC','r',1,6,0);
INSERT INTO `config_params` VALUES (15,12,'enable_advanced_share_editing','0','','TRANS_ENABLE_ADVANCED_PAYMENT_SHARE_EDITING','TRANS_ENABLE_ADVANCED_PAYMENT_SHARE_EDITING_DESC','r',1,6,0);
INSERT INTO `config_params` VALUES (16,12,'batch_run_offset','1','','TRANS_PAYMENT_QUEUE_BATCH_DAYS_BEFORE_DUE','TRANS_PAYMENT_QUEUE_BATCH_DAYS_BEFORE_DUE_DESC','t',1,7,0);
INSERT INTO `config_params` VALUES (17,12,'payment_queue_line_item_threshold','50','','TRANS_PAYMENT_QUEUE_LINE_ITEM_THRESHOLD','TRANS_PAYMENT_QUEUE_LINE_ITEM_THRESHOLD_DESC','t',1,8,0);
INSERT INTO `config_params` VALUES (18,13,'card','1','','TRANS_CREDIT_CARD_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (19,13,'echeck','1','','TRANS_ECHECK_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (20,13,'bank','1','','TRANS_BANK_DRAFT_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (21,13,'manual','1','','TRANS_MANUAL_PAYMENT_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (22,13,'secondary','1','','TRANS_THIRD_PARTY_GATEWAY_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (23,13,'wire','1','','TRANS_WIRE_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (24,37,'allowClientUpgrade','1','','TRANS_ALLOW_CLIENT_INITIATED_UPGRADES','','b',1,1,0);
INSERT INTO `config_params` VALUES (25,37,'whenUpgrade','1','','TRANS_WHEN_SHOULD_CLIENT_INITIATED_UPGRADES_OCCUR','','r',1,2,0);
INSERT INTO `config_params` VALUES (26,37,'applyUpgradeCredits','1','','TRANS_APPLY_CREDITS_FOR_IMMEDIATE_UPGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (27,37,'provisionUpgrades','1','','TRANS_PROVISION_UPGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (28,37,'generateUpgradeInvoice','1','','TRANS_GENERATE_INVOICE_FOR_IMMEDIATE_UPGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (29,37,'allowClientDowngrade','1','','TRANS_ALLOW_CLIENT_INITIATED_DOWNGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (30,37,'whenDowngrade','1','','TRANS_WHEN_SHOULD_CLIENT_INITIATED_DOWNGRADES_OCCUR','','r',1,2,0);
INSERT INTO `config_params` VALUES (31,37,'applyDowngradeCredits','1','','TRANS_APPLY_CREDITS_FOR_IMMEDIATE_DOWNGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (32,37,'provisionDowngrades','1','','TRANS_PROVISION_DOWNGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (33,37,'generateDowngradeInvoice','1','','TRANS_GENERATE_INVOICE_FOR_IMMEDIATE_DOWNGRADES','','b',1,2,0);
INSERT INTO `config_params` VALUES (34,37,'allowClientAddonManagement','1','','TRANS_ALLOW_CLIENT_INITIATED_ADDON_MANAGEMENT','','b',1,3,0);
INSERT INTO `config_params` VALUES (35,41,'count','100','','TRANS_DOMAIN_SYNC_COUNT','TRANS_DOMAIN_SYNC_COUNT_DESC','t',NULL,0,0);
INSERT INTO `config_params` VALUES (211,48,'billingMode','anniversary','','TRANS_BILLING_MODE','','r',1,1,0);
INSERT INTO `config_params` VALUES (212,48,'billingDayOfMonth','1','','TRANS_MONTHLY_BILLING_DAY','TRANS_MONTHLY_BILLING_DAY_DESC','s',1,2,0);
INSERT INTO `config_params` VALUES (213,48,'billingProrationThreshold','15','','TRANS_MONTHLY_PRORATION_THRESHOLD','TRANS_MONTHLY_PRORATION_THRESHOLD_DESC','s',1,2,0);
INSERT INTO `config_params` VALUES (214,48,'getActiveClients','1','','TRANS_INVOICE_ACTIVE_CLIENTS','TRANS_INVOICE_ACTIVE_CLIENTS_DESC','r',1,2,0);
INSERT INTO `config_params` VALUES (215,48,'getSuspendedClients','0','','TRANS_INVOICE_SUSPENDED_CLIENTS','TRANS_INVOICE_SUSPENDED_CLIENTS_DESC','r',1,2,0);
INSERT INTO `config_params` VALUES (216,48,'getActivePackages','1','','TRANS_INVOICE_ACTIVE_PACKAGES','','b',1,3,0);
INSERT INTO `config_params` VALUES (217,48,'getSuspendedPackages','0','','TRANS_INVOICE_SUSPENDED_PACKAGES','','b',1,4,0);
INSERT INTO `config_params` VALUES (218,48,'sendInvoiceEmail','1','','TRANS_INVOICE_SEND_EMAIL','','b',1,6,0);
INSERT INTO `config_params` VALUES (219,48,'invoice_number_template','%%CURMONTH%%-%%CURYEAR%%-%%SEQ%%','','TRANS_INVOICE_NUMBER_TEMPLATE','','s',1,7,0);
INSERT INTO `config_params` VALUES (220,48,'invoice_sequence','100000','','TRANS_INVOICE_SEQUENCE','TRANS_INVOICE_SEQUENCE_DESC','t',1,8,0);
INSERT INTO `config_params` VALUES (221,48,'invoice_generate_offset','10','','TRANS_INVOICE_GENERATE_DAYS_BEFORE_RENEW_DATE','TRANS_INVOICE_GENERATE_DAYS_BEFORE_RENEW_DATE_DESC','t',1,9,0);
INSERT INTO `config_params` VALUES (222,48,'invoice_domain_generate_offset','30','','TRANS_INVOICE_DOMAIN_AND_CERT_GENERATE_DAYS_BEFORE_RENEW_DATE','TRANS_INVOICE_DOMAIN_AND_CERT_GENERATE_DAYS_BEFORE_RENEW_DATE_DESC','t',1,9,0);
INSERT INTO `config_params` VALUES (223,48,'invoice_due_offset','9','','TRANS_INVOICE_DUE_DAYS_AFTER_GENERATION','TRANS_INVOICE_DUE_DAYS_AFTER_GENERATION_DESC','t',1,10,0);
INSERT INTO `config_params` VALUES (225,52,'emailMethod','php','','TRANS_EMAIL_METHOD',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (226,52,'emailSendmailLocation','/usr/sbin/sendmail','','TRANS_EMAIL_SENDMAIL_LOCATION',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (227,52,'emailSMTPServer','','','TRANS_EMAIL_SMTP_SERVER_LOCATION',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (228,52,'emailSMTPAuth','','','TRANS_EMAIL_SMTP_REQUIRE_AUTHENTICATION',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (229,52,'emailSMTPUsername','','','TRANS_EMAIL_SMTP_USERNAME',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (230,52,'emailSMTPPassword','','','TRANS_EMAIL_SMTP_PASSWORD',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (231,55,'max_system_queue_events','3','','TRANS_MAX_SYSTEM_QUEUE_EVENTS','TRANS_MAX_SYSTEM_QUEUE_DESC','t',1,1,0);
INSERT INTO `config_params` VALUES (232,55,'run_queue_active_client_type','2','','TRANS_RUN_SYSTEM_QUEUE_ACTIVE_CLIENT_TYPE','TRANS_RUN_SYSTEM_QUEUE_ACTIVE_CLIENT_TYPE_DESC','s',1,2,0);
INSERT INTO `config_params` VALUES (233,55,'run_queue_new_client_type','2','','TRANS_RUN_SYSTEM_QUEUE_NEW_CLIENT_TYPE','TRANS_RUN_SYSTEM_QUEUE_NEW_CLIENT_TYPE_DESC','s',1,3,0);
INSERT INTO `config_params` VALUES (234,55,'run_queue_domain_new_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_TYPE_DESC','s',1,4,0);
INSERT INTO `config_params` VALUES (235,55,'run_queue_domain_active_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_ACTIVE_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_ACTIVE_TYPE_DESC','s',1,5,0);
INSERT INTO `config_params` VALUES (236,55,'run_queue_domain_renewal_type','2','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_RENEWAL_TYPE','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_RENEWAL_TYPE_DESC','s',1,6,0);
INSERT INTO `config_params` VALUES (237,55,'run_queue_domain_new_sync','0','','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_SYNC','TRANS_RUN_SYSTEM_QUEUE_DOMAIN_NEW_SYNC_DESC','s',1,7,0);
INSERT INTO `config_params` VALUES (238,55,'system_queue_push_time','15','','TRANS_SYSTEM_QUEUE_PUSH_MINUTES','TRANS_SYSTEM_QUEUE_PUSH_MINUTES_DESC','t',1,8,0);
INSERT INTO `config_params` VALUES (239,57,'enableAutoSuspend','1','','TRANS_AUTOMATION_AUTOSUSPEND_ENABLED','TRANS_AUTOMATION_AUTOSUSPEND_ENABLED_DESC','b',1,1,0);
INSERT INTO `config_params` VALUES (240,57,'autoSuspendFirstNotice','5','','TRANS_AUTOMATION_AUTOSUSPEND_FIRST_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_FIRST_NOTICE_DESC','t',1,2,0);
INSERT INTO `config_params` VALUES (241,57,'autoSuspendSecondNotice','10','','TRANS_AUTOMATION_AUTOSUSPEND_SECOND_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_SECOND_NOTICE_DESC','t',1,3,0);
INSERT INTO `config_params` VALUES (242,57,'autoSuspendThirdNotice','15','','TRANS_AUTOMATION_AUTOSUSPEND_THIRD_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_THIRD_NOTICE_DESC','t',1,4,0);
INSERT INTO `config_params` VALUES (243,57,'autoSuspendClean','90','','TRANS_AUTOMATION_AUTOSUSPEND_CLEAN_NOTICE','TRANS_AUTOMATION_AUTOSUSPEND_CLEAN_NOTICE_DESC','t',1,4,0);
INSERT INTO `config_params` VALUES (244,57,'sendSuspensionEmails','1','','TRANS_AUTOMATION_AUTOSUSPEND_SEND_EMAIL','TRANS_AUTOMATION_AUTOSUSPEND_SEND_EMAIL_DESC','b',1,6,0);
INSERT INTO `config_params` VALUES (245,59,'editUserName','0','','TRANS_USER_EDIT_USER_NAME','TRANS_USER_EDIT_USER_NAME_DESC','b',1,1,0);
INSERT INTO `config_params` VALUES (246,59,'editFirstName','1','','TRANS_USER_EDIT_FIRST_NAME','TRANS_USER_EDIT_FIRST_NAME_DESC','b',1,2,0);
INSERT INTO `config_params` VALUES (247,59,'editLastName','1','','TRANS_USER_EDIT_LAST_NAME','TRANS_USER_EDIT_LAST_NAME_DESC','b',1,3,0);
INSERT INTO `config_params` VALUES (248,59,'editEmail','1','','TRANS_USER_EDIT_EMAIL','TRANS_USER_EDIT_EMAIL_DESC','b',1,4,0);
INSERT INTO `config_params` VALUES (249,59,'editCompanyName','1','','TRANS_USER_EDIT_COMPANY_NAME','TRANS_USER_EDIT_COMPANY_NAME_DESC','b',1,5,0);
INSERT INTO `config_params` VALUES (250,59,'editCountry','1','','TRANS_USER_EDIT_COUNTRY','TRANS_USER_EDIT_COUNTRY_DESC','b',1,6,0);
INSERT INTO `config_params` VALUES (251,59,'editEmailActions','1','','TRANS_USER_EDIT_EMAILACTIONS','TRANS_USER_EDIT_EMAILACTIONS_DESC','b',1,7,0);
INSERT INTO `config_params` VALUES (252,68,'enableFraudGuardian','','','TRANS_FRAUD_MODULES_ENABLEFRAUDGUARDIAN',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (253,68,'usernameFraudGuardian','','','TRANS_FRAUD_MODULES_USERNAMEFRAUDGUARDIAN',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (254,68,'passwordFraudGuardian','','','TRANS_FRAUD_MODULES_PASSWORDFRAUDGUARDIAN',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (259,73,'enableSSLFactory','','','TRANS_SSL_MODULES_ENABLESSLFACTORY',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (260,73,'usernameSSLFactory','','','TRANS_SSL_MODULES_USERNAMESSLFACTORY',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (261,73,'accessCodeSSLFactory','','','TRANS_SSL_MODULES_ACCESSCODESSLFACTORY',NULL,NULL,NULL,0,0);
INSERT INTO `config_params` VALUES (298,55,'system_account_stacking','0','','TRANS_ACCOUNT_STACKING','TRANS_ACCOUNT_STACKING_DESC','s',1,9,0);
INSERT INTO `config_params` VALUES (299,91,'invoice_title','','','TRANS_INVOICE_PDF_INVOICE_TITLE_OPTION','TRANS_INVOICE_PDF_INVOICE_TITLE_OPTION_DESC','t',0,13,0);
INSERT INTO `config_params` VALUES (300,91,'tax_id_title','','','TRANS_INVOICE_PDF_TAX_ID_TITLE_OPTION','TRANS_INVOICE_PDF_TAX_ID_TITLE_OPTION_DESC','t',0,14,0);
INSERT INTO `config_params` VALUES (301,91,'tax_included_title','','','TRANS_INVOICE_PDF_TAX_INCLUDED_TITLE_OPTION','TRANS_INVOICE_PDF_TAX_INCLUDED_TITLE_OPTION_DESC','t',0,15,0);
INSERT INTO `config_params` VALUES (302,91,'sale_terms','','','TRANS_INVOICE_PDF_SALE_TERMS_OPTION','TRANS_INVOICE_PDF_SALE_TERMS_OPTION_DESC','a',0,16,0);
INSERT INTO `config_params` VALUES (303,91,'measurement_unit','mm','','TRANS_INVOICE_PDF_MEASUREMENT_UNIT_OPTION','TRANS_INVOICE_PDF_MEASUREMENT_UNIT_OPTION_DESC','s',0,17,0);
INSERT INTO `config_params` VALUES (304,91,'horizontal_indent','','','TRANS_INVOICE_PDF_HORIZONTAL_INDENT_OPTION','TRANS_INVOICE_PDF_HORIZONTAL_INDENT_OPTION_DESC','t',0,18,0);
INSERT INTO `config_params` VALUES (305,91,'vertical_indent','','','TRANS_INVOICE_PDF_VERTICAL_INDENT_OPTION','TRANS_INVOICE_PDF_VERTICAL_INDENT_OPTION_DESC','t',0,19,0);
INSERT INTO `config_params` VALUES (306,91,'horizontal_size','','','TRANS_INVOICE_PDF_HORIZONTAL_SIZE_OPTION','TRANS_INVOICE_PDF_HORIZONTAL_SIZE_OPTION_DESC','t',0,20,0);
INSERT INTO `config_params` VALUES (307,91,'vertical_size','','','TRANS_INVOICE_PDF_VERTICAL_SIZE_OPTION','TRANS_INVOICE_PDF_VERTICAL_SIZE_OPTION_DESC','t',0,21,0);
INSERT INTO `config_params` VALUES (308,91,'font_size','','','TRANS_INVOICE_PDF_FONT_SIZE_OPTION','TRANS_INVOICE_PDF_FONT_SIZE_OPTION_DESC','t',0,22,0);
INSERT INTO `config_params` VALUES (309,91,'header_align','right','','TRANS_INVOICE_PDF_INVOICE_HEADER_ALIGN_OPTION','TRANS_INVOICE_PDF_INVOICE_HEADER_ALIGN_OPTION_DESC','r',1,23,0);
INSERT INTO `config_params` VALUES (310,13,'hspcbanktransfer','1','','TRANS_HSPC_BANK_TRANSFER_ACCOUNT','','b',1,1,0);
INSERT INTO `config_params` VALUES (311,91,'custom_footer','','','TRANS_INVOICE_PDF_CUSTOM_FOOTER_OPTION','TRANS_INVOICE_PDF_CUSTOM_FOOTER_DESC','a',0,24,0);
INSERT INTO `config_params` VALUES (312,91,'invoice_show_logo','1','','TRANS_INVOICE_PDF_SHOW_LOGO_OPTION','TRANS_INVOICE_PDF_SHOW_LOGO_DESC','b',0,25,0);
INSERT INTO `config_params` VALUES (313,91,'invoice_logo','default-logo.png','','TRANS_INVOICE_PDF_LOGO_OPTION','TRANS_INVOICE_PDF_LOGO_DESC','f',0,26,0);
/*!40000 ALTER TABLE `config_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact_email_action_rel`
--
DROP TABLE IF EXISTS `contact_email_action_rel`;
CREATE TABLE `contact_email_action_rel` (
  `client_contact_id` int(10) unsigned NOT NULL default '0',
  `email_action_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_contact_id`,`email_action_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `countries`
--
DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` smallint(5) unsigned NOT NULL auto_increment,
  `countries_iso_2` char(2) default NULL,
  `countries_iso_num` char(3) default NULL,
  `countries_region` char(3) default NULL,
  `countries_phone_code` smallint(5) unsigned default NULL,
  `default_gross_price_display` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`countries_id`),
  KEY `countries_iso_2` (`countries_iso_2`),
  KEY `countries_region` (`countries_region`),
  KEY `countries_iso_num` (`countries_iso_num`),
  KEY `countries_phone_code` (`countries_phone_code`)
) ENGINE=InnoDB ;

--
-- Dumping data for table `countries`
--
LOCK TABLES `countries` WRITE;
/*!40000 ALTER TABLE `countries` DISABLE KEYS */;
INSERT INTO `countries` VALUES (1,'AD','020','039',376,0);
INSERT INTO `countries` VALUES (2,'AE','784','145',971,0);
INSERT INTO `countries` VALUES (3,'AF','004','062',93,0);
INSERT INTO `countries` VALUES (4,'AG','028','029',1,0);
INSERT INTO `countries` VALUES (5,'AI','660','029',1,0);
INSERT INTO `countries` VALUES (6,'AL','008','039',355,0);
INSERT INTO `countries` VALUES (7,'AM','051','145',374,0);
INSERT INTO `countries` VALUES (8,'AN','530','029',599,0);
INSERT INTO `countries` VALUES (9,'AO','024','017',244,0);
INSERT INTO `countries` VALUES (10,'AQ','010','QO',672,0);
INSERT INTO `countries` VALUES (11,'AR','032','005',54,0);
INSERT INTO `countries` VALUES (12,'AS','016','061',684,0);
INSERT INTO `countries` VALUES (13,'AT','040','155',43,0);
INSERT INTO `countries` VALUES (14,'AU','036','053',61,0);
INSERT INTO `countries` VALUES (15,'AW','533','029',297,0);
INSERT INTO `countries` VALUES (16,'AX','248','154',358,0);
INSERT INTO `countries` VALUES (17,'AZ','031','145',994,0);
INSERT INTO `countries` VALUES (18,'BA','070','039',387,0);
INSERT INTO `countries` VALUES (19,'BB','052','029',1,0);
INSERT INTO `countries` VALUES (20,'BD','050','062',880,0);
INSERT INTO `countries` VALUES (21,'BE','056','155',32,0);
INSERT INTO `countries` VALUES (22,'BF','854','011',226,0);
INSERT INTO `countries` VALUES (23,'BG','100','151',359,0);
INSERT INTO `countries` VALUES (24,'BH','048','145',973,0);
INSERT INTO `countries` VALUES (25,'BI','108','014',257,0);
INSERT INTO `countries` VALUES (26,'BJ','204','011',229,0);
INSERT INTO `countries` VALUES (27,'BM','060','021',1,0);
INSERT INTO `countries` VALUES (28,'BN','096','035',673,0);
INSERT INTO `countries` VALUES (29,'BO','068','005',591,0);
INSERT INTO `countries` VALUES (30,'BR','076','005',55,0);
INSERT INTO `countries` VALUES (31,'BS','044','029',1,0);
INSERT INTO `countries` VALUES (32,'BT','064','062',975,0);
INSERT INTO `countries` VALUES (33,'BV','074','QO',47,0);
INSERT INTO `countries` VALUES (34,'BW','072','018',267,0);
INSERT INTO `countries` VALUES (35,'BY','112','151',375,0);
INSERT INTO `countries` VALUES (36,'BZ','084','013',501,0);
INSERT INTO `countries` VALUES (37,'CA','124','021',1,0);
INSERT INTO `countries` VALUES (38,'CC','166','QO',61,0);
INSERT INTO `countries` VALUES (39,'CD','180','017',243,0);
INSERT INTO `countries` VALUES (40,'CF','140','017',236,0);
INSERT INTO `countries` VALUES (41,'CG','178','017',242,0);
INSERT INTO `countries` VALUES (42,'CH','756','155',41,0);
INSERT INTO `countries` VALUES (43,'CI','384','011',225,0);
INSERT INTO `countries` VALUES (44,'CK','184','061',682,0);
INSERT INTO `countries` VALUES (45,'CL','152','005',56,0);
INSERT INTO `countries` VALUES (46,'CM','120','017',237,0);
INSERT INTO `countries` VALUES (47,'CN','156','030',86,0);
INSERT INTO `countries` VALUES (48,'CO','170','005',57,0);
INSERT INTO `countries` VALUES (49,'CR','188','013',506,0);
INSERT INTO `countries` VALUES (50,'RS','688','039',381,0);
INSERT INTO `countries` VALUES (51,'ME','499','039',382,0);
INSERT INTO `countries` VALUES (52,'CU','192','029',53,0);
INSERT INTO `countries` VALUES (53,'CV','132','011',238,0);
INSERT INTO `countries` VALUES (54,'CX','162','QO',618,0);
INSERT INTO `countries` VALUES (55,'CY','196','145',357,0);
INSERT INTO `countries` VALUES (56,'CZ','203','151',420,0);
INSERT INTO `countries` VALUES (57,'DE','276','155',49,1);
INSERT INTO `countries` VALUES (58,'DJ','262','014',253,0);
INSERT INTO `countries` VALUES (59,'DK','208','154',45,0);
INSERT INTO `countries` VALUES (60,'DM','212','029',1,0);
INSERT INTO `countries` VALUES (61,'DO','214','029',1,0);
INSERT INTO `countries` VALUES (62,'DZ','012','015',213,0);
INSERT INTO `countries` VALUES (63,'EC','218','005',593,0);
INSERT INTO `countries` VALUES (64,'EE','233','154',372,0);
INSERT INTO `countries` VALUES (65,'EG','818','015',20,0);
INSERT INTO `countries` VALUES (66,'EH','732','015',212,0);
INSERT INTO `countries` VALUES (67,'ER','232','014',291,0);
INSERT INTO `countries` VALUES (68,'ES','724','039',34,0);
INSERT INTO `countries` VALUES (69,'ET','231','014',251,0);
INSERT INTO `countries` VALUES (70,'FI','246','154',358,0);
INSERT INTO `countries` VALUES (71,'FJ','242','054',679,0);
INSERT INTO `countries` VALUES (72,'FK','238','005',500,0);
INSERT INTO `countries` VALUES (73,'FM','583','057',691,0);
INSERT INTO `countries` VALUES (74,'FO','234','154',298,0);
INSERT INTO `countries` VALUES (75,'FR','250','155',33,1);
INSERT INTO `countries` VALUES (76,'GA','266','017',241,0);
INSERT INTO `countries` VALUES (77,'GB','826','154',44,0);
INSERT INTO `countries` VALUES (78,'GD','308','029',1,0);
INSERT INTO `countries` VALUES (79,'GE','268','145',995,0);
INSERT INTO `countries` VALUES (80,'GF','254','005',594,0);
INSERT INTO `countries` VALUES (81,'GH','288','011',233,0);
INSERT INTO `countries` VALUES (82,'GI','292','039',350,0);
INSERT INTO `countries` VALUES (83,'GL','304','021',299,0);
INSERT INTO `countries` VALUES (84,'GM','270','011',220,0);
INSERT INTO `countries` VALUES (85,'GN','324','011',224,0);
INSERT INTO `countries` VALUES (86,'GP','312','029',590,0);
INSERT INTO `countries` VALUES (87,'GQ','226','017',240,0);
INSERT INTO `countries` VALUES (88,'GR','300','039',30,0);
INSERT INTO `countries` VALUES (89,'GS','239','QO',995,0);
INSERT INTO `countries` VALUES (90,'GT','320','013',502,0);
INSERT INTO `countries` VALUES (91,'GU','316','057',1,0);
INSERT INTO `countries` VALUES (92,'GW','624','011',245,0);
INSERT INTO `countries` VALUES (93,'GY','328','005',592,0);
INSERT INTO `countries` VALUES (94,'HK','344','030',852,0);
INSERT INTO `countries` VALUES (95,'HM','334','QO',61,0);
INSERT INTO `countries` VALUES (96,'HN','340','013',504,0);
INSERT INTO `countries` VALUES (97,'HR','191','039',385,0);
INSERT INTO `countries` VALUES (98,'HT','332','029',509,0);
INSERT INTO `countries` VALUES (99,'HU','348','151',36,0);
INSERT INTO `countries` VALUES (100,'ID','360','035',62,0);
INSERT INTO `countries` VALUES (101,'IE','372','154',353,0);
INSERT INTO `countries` VALUES (102,'IL','376','145',972,0);
INSERT INTO `countries` VALUES (103,'IN','356','062',91,0);
INSERT INTO `countries` VALUES (104,'IO','086','QO',246,0);
INSERT INTO `countries` VALUES (105,'IQ','368','145',964,0);
INSERT INTO `countries` VALUES (106,'IR','364','062',98,0);
INSERT INTO `countries` VALUES (107,'IS','352','154',354,0);
INSERT INTO `countries` VALUES (108,'IT','380','039',39,0);
INSERT INTO `countries` VALUES (109,'JM','388','029',1,0);
INSERT INTO `countries` VALUES (110,'JO','400','145',962,0);
INSERT INTO `countries` VALUES (111,'JP','392','030',81,0);
INSERT INTO `countries` VALUES (112,'KE','404','014',254,0);
INSERT INTO `countries` VALUES (113,'KG','417','062',996,0);
INSERT INTO `countries` VALUES (114,'KH','116','035',855,0);
INSERT INTO `countries` VALUES (115,'KI','296','057',686,0);
INSERT INTO `countries` VALUES (116,'KM','174','014',269,0);
INSERT INTO `countries` VALUES (117,'KN','659','029',1,0);
INSERT INTO `countries` VALUES (118,'KP','408','030',850,0);
INSERT INTO `countries` VALUES (119,'KR','410','030',82,0);
INSERT INTO `countries` VALUES (120,'KW','414','145',965,0);
INSERT INTO `countries` VALUES (121,'KY','136','029',1,0);
INSERT INTO `countries` VALUES (122,'KZ','398','062',7,0);
INSERT INTO `countries` VALUES (123,'LA','418','035',856,0);
INSERT INTO `countries` VALUES (124,'LB','422','145',961,0);
INSERT INTO `countries` VALUES (125,'LC','662','029',1,0);
INSERT INTO `countries` VALUES (126,'LI','438','155',423,0);
INSERT INTO `countries` VALUES (127,'LK','144','062',94,0);
INSERT INTO `countries` VALUES (128,'LR','430','011',231,0);
INSERT INTO `countries` VALUES (129,'LS','426','018',266,0);
INSERT INTO `countries` VALUES (130,'LT','440','154',370,0);
INSERT INTO `countries` VALUES (131,'LU','442','155',352,0);
INSERT INTO `countries` VALUES (132,'LV','428','154',371,0);
INSERT INTO `countries` VALUES (133,'LY','434','015',218,0);
INSERT INTO `countries` VALUES (134,'MA','504','015',212,0);
INSERT INTO `countries` VALUES (135,'MC','492','155',377,0);
INSERT INTO `countries` VALUES (136,'MD','498','151',373,0);
INSERT INTO `countries` VALUES (137,'MG','450','014',261,0);
INSERT INTO `countries` VALUES (138,'MH','584','057',692,0);
INSERT INTO `countries` VALUES (139,'MK','807','039',389,0);
INSERT INTO `countries` VALUES (140,'ML','466','011',269,0);
INSERT INTO `countries` VALUES (141,'MM','104','035',95,0);
INSERT INTO `countries` VALUES (142,'MN','496','030',976,0);
INSERT INTO `countries` VALUES (143,'MO','446','030',853,0);
INSERT INTO `countries` VALUES (144,'MP','580','057',1,0);
INSERT INTO `countries` VALUES (145,'MQ','474','029',596,0);
INSERT INTO `countries` VALUES (146,'MR','478','011',222,0);
INSERT INTO `countries` VALUES (147,'MS','500','029',1,0);
INSERT INTO `countries` VALUES (148,'MT','470','039',356,0);
INSERT INTO `countries` VALUES (149,'MU','480','014',230,0);
INSERT INTO `countries` VALUES (150,'MV','462','062',960,0);
INSERT INTO `countries` VALUES (151,'MW','454','014',265,0);
INSERT INTO `countries` VALUES (152,'MX','484','013',52,0);
INSERT INTO `countries` VALUES (153,'MY','458','035',60,0);
INSERT INTO `countries` VALUES (154,'MZ','508','014',258,0);
INSERT INTO `countries` VALUES (155,'NA','516','018',264,0);
INSERT INTO `countries` VALUES (156,'NC','540','054',687,0);
INSERT INTO `countries` VALUES (157,'NE','562','011',227,0);
INSERT INTO `countries` VALUES (158,'NF','574','053',672,0);
INSERT INTO `countries` VALUES (159,'NG','566','011',234,0);
INSERT INTO `countries` VALUES (160,'NI','558','013',505,0);
INSERT INTO `countries` VALUES (161,'NL','528','155',31,0);
INSERT INTO `countries` VALUES (162,'NO','578','154',47,0);
INSERT INTO `countries` VALUES (163,'NP','524','062',977,0);
INSERT INTO `countries` VALUES (164,'NR','520','057',674,0);
INSERT INTO `countries` VALUES (165,'NU','570','061',683,0);
INSERT INTO `countries` VALUES (166,'NZ','554','053',64,0);
INSERT INTO `countries` VALUES (167,'OM','512','145',968,0);
INSERT INTO `countries` VALUES (168,'PA','591','013',507,0);
INSERT INTO `countries` VALUES (169,'PE','604','005',51,0);
INSERT INTO `countries` VALUES (170,'PF','258','061',689,0);
INSERT INTO `countries` VALUES (171,'PG','598','054',675,0);
INSERT INTO `countries` VALUES (172,'PH','608','035',63,0);
INSERT INTO `countries` VALUES (173,'PK','586','062',92,0);
INSERT INTO `countries` VALUES (174,'PL','616','151',48,0);
INSERT INTO `countries` VALUES (175,'PM','666','021',508,0);
INSERT INTO `countries` VALUES (176,'PN','612','061',872,0);
INSERT INTO `countries` VALUES (177,'PR','630','029',1,0);
INSERT INTO `countries` VALUES (178,'PS','275','145',970,0);
INSERT INTO `countries` VALUES (179,'PT','620','039',351,0);
INSERT INTO `countries` VALUES (180,'PW','585','057',680,0);
INSERT INTO `countries` VALUES (181,'PY','600','005',595,0);
INSERT INTO `countries` VALUES (182,'QA','634','145',97,0);
INSERT INTO `countries` VALUES (183,'RE','638','014',262,0);
INSERT INTO `countries` VALUES (184,'RO','642','151',40,0);
INSERT INTO `countries` VALUES (185,'RU','643','151',7,0);
INSERT INTO `countries` VALUES (186,'RW','646','014',250,0);
INSERT INTO `countries` VALUES (187,'SA','682','145',966,0);
INSERT INTO `countries` VALUES (188,'SB','090','054',677,0);
INSERT INTO `countries` VALUES (189,'SC','690','014',248,0);
INSERT INTO `countries` VALUES (190,'SD','736','015',249,0);
INSERT INTO `countries` VALUES (191,'SE','752','154',46,0);
INSERT INTO `countries` VALUES (192,'SG','702','035',65,0);
INSERT INTO `countries` VALUES (193,'SH','654','011',290,0);
INSERT INTO `countries` VALUES (194,'SI','705','039',386,0);
INSERT INTO `countries` VALUES (195,'SJ','744','154',47,0);
INSERT INTO `countries` VALUES (196,'SK','703','151',421,0);
INSERT INTO `countries` VALUES (197,'SL','694','011',232,0);
INSERT INTO `countries` VALUES (198,'SM','674','039',378,0);
INSERT INTO `countries` VALUES (199,'SN','686','011',221,0);
INSERT INTO `countries` VALUES (200,'SO','706','014',252,0);
INSERT INTO `countries` VALUES (201,'SR','740','005',597,0);
INSERT INTO `countries` VALUES (202,'ST','678','017',239,0);
INSERT INTO `countries` VALUES (203,'SV','222','013',503,0);
INSERT INTO `countries` VALUES (204,'SY','760','145',963,0);
INSERT INTO `countries` VALUES (205,'SZ','748','018',268,0);
INSERT INTO `countries` VALUES (206,'TC','796','029',1,0);
INSERT INTO `countries` VALUES (207,'TD','148','017',235,0);
INSERT INTO `countries` VALUES (208,'TF','260','QO',596,0);
INSERT INTO `countries` VALUES (209,'TG','768','011',228,0);
INSERT INTO `countries` VALUES (210,'TH','764','035',66,0);
INSERT INTO `countries` VALUES (211,'TJ','762','062',992,0);
INSERT INTO `countries` VALUES (212,'TK','772','061',690,0);
INSERT INTO `countries` VALUES (213,'TL','626','035',670,0);
INSERT INTO `countries` VALUES (214,'TM','795','062',993,0);
INSERT INTO `countries` VALUES (215,'TN','788','015',216,0);
INSERT INTO `countries` VALUES (216,'TO','776','061',676,0);
INSERT INTO `countries` VALUES (217,'TR','792','145',90,0);
INSERT INTO `countries` VALUES (218,'TT','780','029',1,0);
INSERT INTO `countries` VALUES (219,'TV','798','061',688,0);
INSERT INTO `countries` VALUES (220,'TW','158','030',886,0);
INSERT INTO `countries` VALUES (221,'TZ','834','014',255,0);
INSERT INTO `countries` VALUES (222,'UA','804','151',380,0);
INSERT INTO `countries` VALUES (223,'UG','800','014',256,0);
INSERT INTO `countries` VALUES (224,'UM','581','QO',1,0);
INSERT INTO `countries` VALUES (225,'US','840','021',1,0);
INSERT INTO `countries` VALUES (226,'UY','858','005',598,0);
INSERT INTO `countries` VALUES (227,'UZ','860','062',998,0);
INSERT INTO `countries` VALUES (228,'VA','336','039',39,0);
INSERT INTO `countries` VALUES (229,'VC','670','029',1,0);
INSERT INTO `countries` VALUES (230,'VE','862','005',58,0);
INSERT INTO `countries` VALUES (231,'VG','092','029',1,0);
INSERT INTO `countries` VALUES (232,'VI','850','029',340,0);
INSERT INTO `countries` VALUES (233,'VN','704','035',84,0);
INSERT INTO `countries` VALUES (234,'VU','548','054',678,0);
INSERT INTO `countries` VALUES (235,'WF','876','061',681,0);
INSERT INTO `countries` VALUES (236,'WS','882','061',684,0);
INSERT INTO `countries` VALUES (237,'YE','887','145',967,0);
INSERT INTO `countries` VALUES (238,'YT','175','014',269,0);
INSERT INTO `countries` VALUES (239,'ZA','710','018',27,0);
INSERT INTO `countries` VALUES (240,'ZM','894','014',260,0);
INSERT INTO `countries` VALUES (241,'ZW','716','014',263,0);
INSERT INTO `countries` VALUES (242,'GG','831','154',44,0);
INSERT INTO `countries` VALUES (243,'JE','832','154',44,0);
INSERT INTO `countries` VALUES (244,'IM','833','154',44,0);
INSERT INTO `countries` VALUES (245,'MF','663','154',1599,0);
INSERT INTO `countries` VALUES (246,'BL','652','154',590,0);
/*!40000 ALTER TABLE `countries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `coupon_condition_groups`
--
DROP TABLE IF EXISTS `coupon_condition_groups`;
CREATE TABLE `coupon_condition_groups` (
  `coupon_condition_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_condition_group_name` varchar(255) default NULL,
  `coupon_id` smallint(5) unsigned default NULL,
  `coupon_condition_group_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`coupon_condition_group_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `coupon_condition_group_active` (`coupon_condition_group_active`)
) ENGINE=MyISAM ;

--
-- Table structure for table `coupon_conditions`
--
DROP TABLE IF EXISTS `coupon_conditions`;
CREATE TABLE `coupon_conditions` (
  `coupon_condition_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_condition_group_id` smallint(5) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`coupon_condition_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `cycle_id` (`cycle_id`),
  KEY `coupon_condition_group_id` (`coupon_condition_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `coupons`
--
DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` smallint(5) unsigned NOT NULL auto_increment,
  `coupon_code` varchar(255) default NULL,
  `coupon_discount` decimal(10,2) default '0.00',
  `coupon_type` tinyint(3) unsigned default NULL,
  `coupon_comments` longtext,
  `coupon_active` tinyint(3) unsigned default NULL,
  `coupon_date_created` int(10) unsigned default '0',
  `coupon_date_started` int(10) unsigned default '0',
  `coupon_date_ended` int(10) unsigned default '0',
  `coupon_count` int(11) unsigned default '0',
  `coupon_max_count` int(10) unsigned default '0',
  `coupon_new_only` tinyint(3) unsigned default NULL,
  `coupon_num_cycles` smallint(5) unsigned default NULL,
  `coupon_apply_number` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`coupon_id`),
  KEY `coupon_active` (`coupon_active`),
  KEY `coupon_date_ended` (`coupon_date_ended`),
  KEY `coupon_date_started` (`coupon_date_started`),
  KEY `coupon_max_count` (`coupon_max_count`),
  KEY `coupon_new_only` (`coupon_new_only`),
  KEY `coupon_num_cycles` (`coupon_num_cycles`),
  KEY `coupon_code` (`coupon_code`)
) ENGINE=InnoDB ;

--
-- Table structure for table `crash_report`
--
DROP TABLE IF EXISTS `crash_report`;
CREATE TABLE `crash_report` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `number` varchar(32) NOT NULL,
  `action_name` varchar(255) NOT NULL,
  `message` text null,
  `content` longtext default NULL,
  `created` int(10) default NULL,
   PRIMARY KEY  (`id`),
   KEY `number` (`number`)
) ENGINE=InnoDB;

--
-- Table structure for table `currencies`
--
DROP TABLE IF EXISTS `currencies`;
CREATE TABLE `currencies` (
  `currency_id` char(3) NOT NULL,
  `currency_code` char(3) NOT NULL,
  `currency_name` varchar(255) NOT NULL,
   PRIMARY KEY  (`currency_id`),
  UNIQUE KEY `currency_code` (`currency_code`)
) ENGINE=InnoDB;

--
-- Dumping data for table `currencies`
--
LOCK TABLES `currencies` WRITE;
/*!40000 ALTER TABLE `currencies` DISABLE KEYS */;
INSERT INTO `currencies` VALUES ('AUD','036','TRANS_CURRENCY_AUD');
INSERT INTO `currencies` VALUES ('CAD','124','TRANS_CURRENCY_CAD');
INSERT INTO `currencies` VALUES ('EGP','818','TRANS_CURRENCY_EGP');
INSERT INTO `currencies` VALUES ('EUR','978','TRANS_CURRENCY_EUR');
INSERT INTO `currencies` VALUES ('GBP','826','TRANS_CURRENCY_GBP');
INSERT INTO `currencies` VALUES ('HKD','344','TRANS_CURRENCY_HKD');
INSERT INTO `currencies` VALUES ('JPY','392','TRANS_CURRENCY_JPY');
INSERT INTO `currencies` VALUES ('MXN','484','TRANS_CURRENCY_MXN');
INSERT INTO `currencies` VALUES ('PHP','608','TRANS_CURRENCY_PHP');
INSERT INTO `currencies` VALUES ('RUB','643','TRANS_CURRENCY_RUB');
INSERT INTO `currencies` VALUES ('SEK','752','TRANS_CURRENCY_SEK');
INSERT INTO `currencies` VALUES ('SGD','702','TRANS_CURRENCY_SGD');
INSERT INTO `currencies` VALUES ('USD','840','TRANS_CURRENCY_USD');
/*!40000 ALTER TABLE `currencies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_discount_groups`
--
DROP TABLE IF EXISTS `cycle_discount_groups`;
CREATE TABLE `cycle_discount_groups` (
  `cycle_discount_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_discount_group_name` varchar(50) default NULL,
  `cycle_discount_group_active` tinyint(1) unsigned default '1',
  PRIMARY KEY  (`cycle_discount_group_id`),
  KEY `cycle_discount_group_active` (`cycle_discount_group_active`)
) ENGINE=InnoDB ;

--
-- Table structure for table `cycle_discounts`
--
DROP TABLE IF EXISTS `cycle_discounts`;
CREATE TABLE `cycle_discounts` (
  `cycle_discount_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_active` tinyint(1) unsigned default '1',
  `cycle_id` smallint(5) unsigned default NULL,
  `cycle_discount_amount` decimal(5,2) unsigned default '0.00',
  PRIMARY KEY  (`cycle_discount_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`),
  KEY `cycle_discount_active` (`cycle_discount_active`),
  KEY `cycle_id` (`cycle_id`)
) ENGINE=InnoDB ;

--
-- Table structure for table `cycle_group_rel`
--
DROP TABLE IF EXISTS `cycle_group_rel`;
CREATE TABLE `cycle_group_rel` (
  `cycle_id` int(8) unsigned NOT NULL default '0',
  `cycle_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`cycle_id`,`cycle_group_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `cycle_group_rel`
--
LOCK TABLES `cycle_group_rel` WRITE;
/*!40000 ALTER TABLE `cycle_group_rel` DISABLE KEYS */;
INSERT INTO `cycle_group_rel` VALUES (1,1);
INSERT INTO `cycle_group_rel` VALUES (2,2);
INSERT INTO `cycle_group_rel` VALUES (3,3);
INSERT INTO `cycle_group_rel` VALUES (4,3);
INSERT INTO `cycle_group_rel` VALUES (5,3);
INSERT INTO `cycle_group_rel` VALUES (6,4);
INSERT INTO `cycle_group_rel` VALUES (7,4);
INSERT INTO `cycle_group_rel` VALUES (8,4);
INSERT INTO `cycle_group_rel` VALUES (9,4);
INSERT INTO `cycle_group_rel` VALUES (10,4);
INSERT INTO `cycle_group_rel` VALUES (11,4);
INSERT INTO `cycle_group_rel` VALUES (12,4);
INSERT INTO `cycle_group_rel` VALUES (13,4);
INSERT INTO `cycle_group_rel` VALUES (14,4);
INSERT INTO `cycle_group_rel` VALUES (15,4);
INSERT INTO `cycle_group_rel` VALUES (16,5);
/*!40000 ALTER TABLE `cycle_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycle_groups`
--
DROP TABLE IF EXISTS `cycle_groups`;
CREATE TABLE `cycle_groups` (
  `cycle_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_group_display_name` varchar(75) default NULL,
  `cycle_group_internal_name` varchar(75) default NULL,
  PRIMARY KEY  (`cycle_group_id`),
  KEY `cycle_group_internal_name` (`cycle_group_internal_name`)
) ENGINE=MyISAM AUTO_INCREMENT=6 ;

--
-- Dumping data for table `cycle_groups`
--
LOCK TABLES `cycle_groups` WRITE;
/*!40000 ALTER TABLE `cycle_groups` DISABLE KEYS */;
INSERT INTO `cycle_groups` VALUES (1,'TRANS_DAILY','daily');
INSERT INTO `cycle_groups` VALUES (2,'TRANS_WEEKLY','weekly');
INSERT INTO `cycle_groups` VALUES (3,'TRANS_MONTHLY','monthly');
INSERT INTO `cycle_groups` VALUES (4,'TRANS_YEARLY','yearly');
INSERT INTO `cycle_groups` VALUES (5,'TRANS_ONE_TIME','onetime');
/*!40000 ALTER TABLE `cycle_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cycles`
--
DROP TABLE IF EXISTS `cycles`;
CREATE TABLE `cycles` (
  `cycle_id` smallint(5) unsigned NOT NULL auto_increment,
  `cycle_display_name` varchar(50) default NULL,
  `cycle_num_seconds` tinyint(3) unsigned default '0',
  `cycle_num_minutes` tinyint(3) unsigned default '0',
  `cycle_num_hours` tinyint(3) unsigned default '0',
  `cycle_num_days` smallint(5) unsigned default '0',
  `cycle_num_months` tinyint(3) unsigned default '0',
  `cycle_num_years` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`cycle_id`),
  KEY `cycle_display_name` (`cycle_display_name`)
) ENGINE=MyISAM AUTO_INCREMENT=17 ;

--
-- Dumping data for table `cycles`
--
LOCK TABLES `cycles` WRITE;
/*!40000 ALTER TABLE `cycles` DISABLE KEYS */;
INSERT INTO `cycles` VALUES (1,'TRANS_1DAY',0,0,0,1,0,0);
INSERT INTO `cycles` VALUES (2,'TRANS_1WEEK',0,0,0,7,0,0);
INSERT INTO `cycles` VALUES (3,'TRANS_1MONTH',0,0,0,0,1,0);
INSERT INTO `cycles` VALUES (4,'TRANS_3MONTHS',0,0,0,0,3,0);
INSERT INTO `cycles` VALUES (5,'TRANS_6MONTHS',0,0,0,0,6,0);
INSERT INTO `cycles` VALUES (6,'TRANS_1YEAR',0,0,0,0,0,1);
INSERT INTO `cycles` VALUES (7,'TRANS_2YEARS',0,0,0,0,0,2);
INSERT INTO `cycles` VALUES (8,'TRANS_3YEARS',0,0,0,0,0,3);
INSERT INTO `cycles` VALUES (9,'TRANS_4YEARS',0,0,0,0,0,4);
INSERT INTO `cycles` VALUES (10,'TRANS_5YEARS',0,0,0,0,0,5);
INSERT INTO `cycles` VALUES (11,'TRANS_6YEARS',0,0,0,0,0,6);
INSERT INTO `cycles` VALUES (12,'TRANS_7YEARS',0,0,0,0,0,7);
INSERT INTO `cycles` VALUES (13,'TRANS_8YEARS',0,0,0,0,0,8);
INSERT INTO `cycles` VALUES (14,'TRANS_9YEARS',0,0,0,0,0,9);
INSERT INTO `cycles` VALUES (15,'TRANS_10YEARS',0,0,0,0,0,10);
INSERT INTO `cycles` VALUES (16,'TRANS_ONE_TIME',0,0,0,1,0,0);
/*!40000 ALTER TABLE `cycles` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_change_log`
--
DROP TABLE IF EXISTS `data_change_log`;
CREATE TABLE `data_change_log` (
  `change_log_id` int(10) unsigned NOT NULL auto_increment,
  `user_type` tinyint(3) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `change_log_date_created` int(10) unsigned default NULL,
  `change_log_table_name` varchar(40) default NULL,
  `change_log_column_name` varchar(32) default NULL,
  `change_log_column_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`change_log_id`),
  KEY `change_log_table_name` (`change_log_table_name`),
  KEY `change_log_column_name` (`change_log_column_name`),
  KEY `change_log_column_id` (`change_log_column_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`)
) ENGINE=MyISAM ;

--
-- Table structure for table `dbg_entries`
--
DROP TABLE IF EXISTS `dbg_entries`;
CREATE TABLE `dbg_entries` (
  `dbg_entry_id` bigint(20) unsigned NOT NULL auto_increment,
  `dbg_pageload_id` bigint(20) unsigned default NULL,
  `dbg_entry_date_created` int(10) unsigned default NULL,
  `dbg_entry_file` varchar(255) default NULL,
  `dbg_entry_line` smallint(5) unsigned default NULL,
  `dbg_entry_message` longtext,
  PRIMARY KEY  (`dbg_entry_id`),
  KEY `dbg_pageload_id` (`dbg_pageload_id`),
  KEY `dbg_entry_file` (`dbg_entry_file`),
  KEY `dbg_entry_line` (`dbg_entry_line`)
) ENGINE=MyISAM ;

--
-- Table structure for table `dbg_pageloads`
--
DROP TABLE IF EXISTS `dbg_pageloads`;
CREATE TABLE `dbg_pageloads` (
  `dbg_pageload_id` bigint(20) unsigned NOT NULL auto_increment,
  `dbg_pageload_date_created` int(10) unsigned default NULL,
  `dbg_pageload_page` varchar(255) default NULL,
  `dbg_pageload_action` varchar(255) default NULL,
  `dbg_pageload_pid` int(10) default NULL,
  `user_type` tinyint(4) default NULL,
  `user_id` int(11) default NULL,
  PRIMARY KEY  (`dbg_pageload_id`),
  KEY `dbg_pageload_page` (`dbg_pageload_page`),
  KEY `dbg_pageload_action` (`dbg_pageload_action`),
  KEY `dbg_pageload_pid` (`dbg_pageload_pid`),
  KEY `user_type` (`user_type`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `email_addresses`
--
DROP TABLE IF EXISTS `email_addresses`;
CREATE TABLE `email_addresses` (
  `email_address_id` int(10) unsigned NOT NULL auto_increment,
  `email_address_name` varchar(100) default NULL,
  `email_address` varchar(255) default NULL,
  `email_address_type` tinyint(3) unsigned default NULL,
  `email_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`email_address_id`),
  KEY `email_id` (`email_id`),
  KEY `email_address` (`email_address`),
  KEY `email_address_type` (`email_address_type`)
) ENGINE=MyISAM ;

--
-- Table structure for table `email_attachments`
--
DROP TABLE IF EXISTS `email_attachments`;
CREATE TABLE `email_attachments` (
  `email_attachment_id` int(10) unsigned NOT NULL auto_increment,
  `email_id` int(10) unsigned default NULL,
  `email_attachment_path` longtext,
  `email_attachment_name` varchar(255) NOT NULL,
  `email_attachment_mime_type` varchar(255) NOT NULL,
  PRIMARY KEY  (`email_attachment_id`),
  KEY `email_id` (`email_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `email_headers`
--
DROP TABLE IF EXISTS `email_headers`;
CREATE TABLE `email_headers` (
  `email_header_id` int(10) unsigned NOT NULL auto_increment,
  `email_id` int(10) unsigned default NULL,
  `email_header` longtext,
  PRIMARY KEY  (`email_header_id`),
  KEY `email_id` (`email_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `email_queue`
--
DROP TABLE IF EXISTS `email_queue`;
CREATE TABLE `email_queue` (
  `email_id` int(10) unsigned NOT NULL auto_increment,
  `client_contact_id` int(10) unsigned default '0',
  `admin_id` smallint(5) unsigned default '0',
  `email_subject` varchar(255) default NULL,
  `email_body` text,
  `email_text_body` text,
  `email_from_address` varchar(60) default NULL,
  `email_from_name` varchar(50) default NULL,
  `email_sent` tinyint(3) unsigned default NULL,
  `email_sent_type` tinyint(3) unsigned default NULL,
  `email_failed` tinyint(3) unsigned default NULL,
  `email_date_created` int(10) unsigned default NULL,
  `email_date_sent` int(10) unsigned default NULL,
  `email_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`email_id`),
  KEY `email_date_created` (`email_date_created`),
  KEY `email_sent` (`email_sent`),
  KEY `email_failed` (`email_failed`),
  KEY `email_active` (`email_active`),
  KEY `client_contact_id` (`client_contact_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `encryption_access_attempts`
--
DROP TABLE IF EXISTS `encryption_access_attempts`;
CREATE TABLE `encryption_access_attempts` (
  `attempt_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `admin_id` INT(10) UNSIGNED NOT NULL,
  `attempt_date` INT(10) UNSIGNED NOT NULL,
  `attempt_number` INT(10) UNSIGNED NOT NULL,
  PRIMARY KEY (`attempt_id`, `admin_id`)
) ENGINE=InnoDB;

--
-- Table structure for table `email_tpl_groups`
--
DROP TABLE IF EXISTS `email_tpl_groups`;
CREATE TABLE `email_tpl_groups` (
  `email_tpl_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `email_tpl_group_name` varchar(255) default NULL,
  `email_action_id` tinyint(3) unsigned default NULL,
  `email_tpl_group_priority` tinyint(3) unsigned default NULL,
  `email_tpl_group_from_name` varchar(255) default NULL,
  `email_tpl_group_from_address` varchar(255) default NULL,
  `email_tpl_group_reply_name` varchar(255) default NULL,
  `email_tpl_group_reply_address` varchar(255) default NULL,
  `email_tpl_group_cc_address` varchar(255) default NULL,
  `email_tpl_group_bcc_address` varchar(255) default NULL,
  PRIMARY KEY  (`email_tpl_group_id`),
  KEY `email_action_id` (`email_action_id`)
) ENGINE=MyISAM AUTO_INCREMENT=28 ;

--
-- Dumping data for table `email_tpl_groups`
--
LOCK TABLES `email_tpl_groups` WRITE;
/*!40000 ALTER TABLE `email_tpl_groups` DISABLE KEYS */;
INSERT INTO `email_tpl_groups` VALUES (1,'packageInfo - Hosting Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (2,'packageInfo - Non-Hosting Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (3,'packageInfo - Domain Registration Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (4,'packageInfo - Usage Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (5,'cc Payment Email',3,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (6,'eCheck Payment Email',4,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (7,'packageInfo - Contract Product',1,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (8,'Invoice Email',2,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (9,'Bank Draft Email',5,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (10,'Manual Payment Email',6,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (11,'CC Expire Notice',13,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (12,'Secondary Gateway Email',7,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (13,'Declined Charge',8,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (14,'Error Payment Email',9,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (15,'Domain Renewal Email',10,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (16,'Successful Domain Transfer',11,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (17,'Failed Domain Transfer Email',12,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (18,'[1] 1st Notice',14,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (19,'[2] 2nd Notice',14,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (20,'[3] 3rd Notice - Suspension Email',14,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (21,'[X] Account Deletion',14,2,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (22,'Package Enable Email',15,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (23,'Password Notification Emails',16,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (24,'User Defined Emails',17,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (25,'New Order Emails',20,1,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (26,'Domain Registration Success Email',21,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (27,'SSL Certificate User Input Require Email',23,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
INSERT INTO `email_tpl_groups` VALUES (28,'Schet - factura Email',24,3,'COMPANYNAME','','COMPANYNAME','',NULL,NULL);
/*!40000 ALTER TABLE `email_tpl_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `email_tpls`
--
DROP TABLE IF EXISTS `email_tpls`;
CREATE TABLE `email_tpls` (
  `email_tpl_id` smallint(5) unsigned NOT NULL auto_increment,
  `email_tpl_group_id` smallint(5) unsigned default NULL,
  `email_tpl_subject` varchar(255) default NULL,
  `email_tpl_primary` tinyint(3) unsigned default NULL,
  `email_tpl_body` text,
  `email_tpl_text_body` text,
  `language_id` smallint(5) unsigned default NULL,
  `country_type` tinyint(3) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `regions_id` char(3) default NULL,
  PRIMARY KEY  (`email_tpl_id`),
  KEY `email_tpl_group_id` (`email_tpl_group_id`),
  KEY `language_id` (`language_id`),
  KEY `country_type` (`country_type`),
  KEY `countries_id` (`countries_id`),
  KEY `regions_id` (`regions_id`),
  KEY `email_tpl_primary` (`email_tpl_primary`)
) ENGINE=MyISAM AUTO_INCREMENT=28 ;

--
-- Dumping data for table `email_tpls`
--
LOCK TABLES `email_tpls` WRITE;
/*!40000 ALTER TABLE `email_tpls` DISABLE KEYS */;
INSERT INTO `email_tpls` VALUES (1,1,'Welcome {$contactFirstName} {$contactLastName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Welcome to {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Welcome {$contactFirstName} {$contactLastName}!&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for signing up with {$companyName}. Your new account information is provided below.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;ACCOUNT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Plan:&lt;/span&gt; {$packageName}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Price:&lt;/span&gt; {$packagePrice|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Domain:&lt;/span&gt; {$domainSLD}.{$domainTLD}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;IP Address:&lt;/span&gt; {$packageIP}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;LOGIN INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Plan:&lt;/span&gt; {$packageName}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Domain:&lt;/span&gt; {$domainSLD}.{$domainTLD}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Username:&lt;/span&gt; {$contactUsername}&lt;br/&gt;\n						&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;FTP INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;FTP:&lt;/span&gt; {$packageIP}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Username:&lt;/span&gt; {if $ftpUsername}{$ftpUsername}{else}{$packageUsername}{/if}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Password:&lt;/span&gt; {if $ftpPassword}{$ftpPassword}{else}{$packagePassword}{/if}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;TELNET/SSH INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;SSH:&lt;/span&gt; {$packageIP}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Username:&lt;/span&gt; {if $ftpUsername}{$ftpUsername}{else}{$packageUsername}{/if}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Password:&lt;/span&gt; {if $ftpPassword}{$ftpPassword}{else}{$packagePassword}{/if}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;NAMESERVER INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						{if $nameserver1}&lt;span class=&quot;title&quot;&gt;{$nameserver1}:&lt;/span&gt; {$nameserver1IP}&lt;br/&gt;{/if}\n						{if $nameserver2}&lt;span class=&quot;title&quot;&gt;{$nameserver2}:&lt;/span&gt; {$nameserver2IP}&lt;br/&gt;{/if}\n						{if $nameserver3}&lt;span class=&quot;title&quot;&gt;{$nameserver3}:&lt;/span&gt; {$nameserver3IP}&lt;br/&gt;{/if}\n						{if $nameserver4}&lt;span class=&quot;title&quot;&gt;{$nameserver4}:&lt;/span&gt; {$nameserver4IP}&lt;br/&gt;{/if}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;\n					You may access your control panel at\n					&lt;a href=&quot;https://{$packageIP}:8443&quot; target=&quot;_blank&quot;&gt;https://{$packageIP}:8443&lt;/a&gt; or\n					&lt;a href=&quot;https://{$domainSLD}.{$domainTLD}:8443&quot; target=&quot;_blank&quot;&gt;https://{$domainSLD}.{$domainTLD}:8443&lt;/a&gt;\n					if your domain has been transferred to our nameservers.\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to view and pay your invoices,\n						change your payment type or billing details, update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the Forgot your password?\n						link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Welcome {$contactFirstName} {$contactLastName}!\n  \nThank you for signing up with {$companyName}. Your new account information is provided below.\n\nACCOUNT INFORMATION:\n\nPlan: {$packageName}\nPrice: {$packagePrice|getAmount:$currencyID}\nDomain: {$domainSLD}.{$domainTLD}\nIP Address: {$packageIP}\n\nLOGIN INFORMATION:\n\nDomain: {$domainSLD}.{$domainTLD}\nUsername: {$contactUsername}\n\nFTP INFORMATION:\n\nFTP: {$packageIP}\nUsername: {if $ftpUsername}{$ftpUsername}{else}{$packageUsername}{/if}\nPassword: {if $ftpPassword}{$ftpPassword}{else}{$packagePassword}{/if}\n\nTELNET/SSH INFORMATION:\n\nSSH: {$packageIP}\nUsername: {if $ftpUsername}{$ftpUsername}{else}{$packageUsername}{/if}\nPassword: {if $ftpPassword}{$ftpPassword}{else}{$packagePassword}{/if}\n\nNAMESERVER INFORMATION:\n\n{if $nameserver1}{$nameserver1}: {$nameserver1IP}\n{/if}{if $nameserver2}{$nameserver2}: {$nameserver2IP}\n{/if}{if $nameserver3}{$nameserver3}: {$nameserver3IP}\n{/if}{if $nameserver4}{$nameserver4}: {$nameserver4IP}\n{/if}\nYou may access your control panel at https://{$packageIP}:8443 or https://{$domainSLD}.{$domainTLD}:8443 if your domain has been transferred to our nameservers.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL}\n\n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (2,2,'Welcome {$contactFirstName} {$contactLastName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Welcome to {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Welcome {$contactFirstName} {$contactLastName}!&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for purchasing {$packageName} with {$companyName}.&lt;/p&gt;\n\n				&lt;p&gt;This email contains important information regarding your order.&lt;/p&gt;\n\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to view\n						and pay your invoices, change your payment type or billing details,\n						update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the\n						&amp;quot;Forgot your password?&amp;quot; link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact\n						us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Welcome {$contactFirstName} {$contactLastName}! \n\nThank you for purchasing {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (3,3,'Thank You for Registering with {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Thank you for Registering with {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for registering/transferring {$domainSLD}.{$domainTLD}\n				to {$companyName}. If you are registering a new domain name, this\n				will occur shortly. If you are transferring a domain, an email will\n				be sent to you when the transfer occurs.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;DOMAIN INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Domain&lt;/span&gt; {$domainSLD}.{$domainTLD}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Term:&lt;/span&gt; {$packageCycleName}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;NAMESERVER INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Remember to update your DNS entries in order for your domain\n						to propagate to your new hosting account.&lt;/p&gt;\n\n						&lt;p&gt;\n							The DNS entries are listed below:&lt;br/&gt;\n							{if $nameserver1}&lt;span class=&quot;title&quot;&gt;{$nameserver1}:&lt;/span&gt; {$nameserver1IP}&lt;br/&gt;{/if}\n							{if $nameserver2}&lt;span class=&quot;title&quot;&gt;{$nameserver2}:&lt;/span&gt; {$nameserver2IP}&lt;br/&gt;{/if}\n							{if $nameserver3}&lt;span class=&quot;title&quot;&gt;{$nameserver3}:&lt;/span&gt; {$nameserver3IP}&lt;br/&gt;{/if}\n							{if $nameserver4}&lt;span class=&quot;title&quot;&gt;{$nameserver4}:&lt;/span&gt; {$nameserver4IP}&lt;br/&gt;{/if}\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to view and\n						pay your invoices, change your payment type or billing details,\n						update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the\n						&amp;quot;Forgot your password?&amp;quot; link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us\n						at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName}, \n  \nThank you for registering/transferring {$domainSLD}.{$domainTLD} to {$companyName}. If you are registering a new domain name, this will occur shortly. If you are transferring a domain, an email will be sent to you when the transfer occurs.\n\nDOMAIN INFORMATION:\n\nDomain {$domainSLD}.{$domainTLD}\nTerm: {$packageCycleName}\n\nNAMESERVER INFORMATION:\n\nRemember to update your DNS entries in order for your domain to propagate to your new hosting account. The DNS entries are listed below:\n\n{$nameserver1}: {$nameserver1IP}\n{$nameserver2}: {$nameserver2IP}\n{$nameserver3}: {$nameserver3IP}\n{$nameserver4}: {$nameserver4IP}\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (4,4,'Welcome {$contactFirstName} {$contactLastName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Welcome {$contactFirstName} {$contactLastName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for ordering your {$packageName} with {$companyName}.&lt;/p&gt;\n\n				&lt;p&gt;This email contains important information regarding your order.&lt;/p&gt;\n\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to\n						view and pay your invoices, change your payment type or billing\n						details, update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the\n						&amp;quot;Forgot your password?&amp;quot; link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nThank you for ordering your {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (5,5,'Credit Card Receipt: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Credit Card Receipt: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Your Invoice {$invoiceNumber} in the amount of\n				{$invoiceAmount|getAmount:$currencyID} has been processed\n				and approved.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Type:&lt;/span&gt; {$billingCardType}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Number:&lt;/span&gt; {$billingAccountNumLastFour}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Return:&lt;/span&gt; {$authReturn}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Code:&lt;/span&gt; {$authCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;AVS Code:&lt;/span&gt; {$avsCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;You will see a charge from {$companyName} for this transaction.&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nCredit Card Type: {$billingCardType}\nCredit Card Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (6,6,'eCheck Payment Receipt: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	eCheck Payment Receipt: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Your Invoice {$invoiceNumber} in the amount of\n				{$invoiceAmount|getAmount:$currencyID} has been processed\n				and approved.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank Name:&lt;/span&gt; {$billingBankName}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank ABA Code:&lt;/span&gt; {$billingBankAbaCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank Account Number:&lt;/span&gt; {$billingAccountNumLastFour}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Return:&lt;/span&gt; {$authReturn}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Code:&lt;/span&gt; {$authCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;AVS Code:&lt;/span&gt; {$avsCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;You will see a charge from {$companyName} for this transaction.&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please\n						contact us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nBank Name: {$billingBankName}\nBank ABA Code: {$billingBankAbaCode}\nBank Account Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (7,7,'Welcome {$contactFirstName} {$contactLastName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Welcome {$contactFirstName} {$contactLastName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for ordering your {$packageName} with {$companyName}.&lt;/p&gt;\n\n				&lt;p&gt;This email contains important information regarding your order.&lt;/p&gt;\n\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to view\n						and pay your invoices, change your payment type or billing\n						details, update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the\n						Forgot your password? link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact\n						us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nThank you for ordering your {$packageName} with {$companyName}. This email contains important information regarding your order.\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (8,8,'Invoice ({$invoiceNumber}): {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Invoice {$invoiceNumber}: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice that Invoice {$invoiceNumber} has been generated\n				for services by {$companyName} on {$invoiceDateEntered|getDate}.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;\n						&lt;td class=&quot;header&quot;&gt;Description&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Period&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Qty&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Price&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Disc.&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Tax&lt;/td&gt;\n						&lt;td class=&quot;header&quot;&gt;Total&lt;/td&gt;\n					&lt;/tr&gt;\n					{foreach key=&quot;i&quot; item=&quot;lineItem&quot; from=$lineItems}\n					&lt;tr&gt;\n						&lt;td class=&quot;data&quot;&gt;\n							{$lineItem.lineItemDescription}\n							{if $lineItem.domains.0}\n								{foreach key=&quot;xd&quot; item=&quot;domain&quot; from=$lineItem.domains}\n									&lt;br/&gt;&lt;b&gt;{$domain.domainSLD}.{$domain.domainTLD}&lt;/b&gt;\n								{/foreach}\n							{elseif $lineItem.domainName}\n								&lt;br/&gt;{$lineItem.domainName}\n							{/if}\n						&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemDateCurrentRenewal|getDate:short} - {$lineItem.lineItemDateNextRenewal|getDate:short}&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemQuantity}&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemPriceAmount|getAmount:$currencyID}&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemDiscountAmount|getAmount:$currencyID}&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemTaxAmount|getAmount:$currencyID}&lt;/td&gt;\n						&lt;td class=&quot;data&quot;&gt;{$lineItem.lineItemTotalAmount|getAmount:$currencyID}&lt;/td&gt;\n					&lt;/tr&gt;\n					{/foreach}\n				&lt;/table&gt;\n\n				&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Subtotal:&lt;/span&gt; {$invoiceSubTotal|getAmount:$currencyID}&lt;/p&gt;\n				&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Tax:&lt;/span&gt; {$invoiceTaxAmount|getAmount:$currencyID}&lt;/p&gt;\n				&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Total:&lt;/span&gt; {$invoiceAmount|getAmount:$currencyID}&lt;/p&gt;\n				&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Due Date:&lt;/span&gt; {$invoiceDateDue|getDate}&lt;/p&gt;\n\n				&lt;hr/&gt;\n\n				{if $invoiceComments}\n					&lt;p&gt;{$invoiceComments}&lt;/p&gt;\n				{/if}\n\n				&lt;p&gt;\n				{if $paymentType==$billingTypeCard}\n					Our records show that you pay with credit card.\n					We will charge your card automatically for the balance of this invoice\n					automatically if necessary.\n				{elseif $paymentType==$billingTypeBank}\n					Our records show that you pay through bank drafts. Please remit payment\n					for your outstanding balance.\n				{elseif $paymentType==$billingTypeEcheck}\n					Our records show that you pay through eCheck. We will charge your\n					account automatically for the balance of this invoice.\n				{elseif $paymentType==$billingTypeSecondary}\n					Our records show that you pay through PayPal.\n					If you have a subscription set up, then your payment will be made\n					automatically. If not, please remit payment for your outstanding\n					balance to XXX@XXX.com through PayPal.\n				{elseif $paymentType==$billingTypeWire}\n					Our records show that you pay through wire transfer.\n					Please remit payment for your outstanding balance.\n				{else}\n					Our records show that you pay manually.\n					Please remit payment for your outstanding balance.\n				{/if}\n				&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					{$companyAddress1}&lt;br/&gt;\n					{$companyAddress2}&lt;br/&gt;\n					{$companyCity}, {$companyState}&lt;br/&gt;\n					{$companyZip}\n				&lt;/p&gt;\n\n				&lt;p&gt;You may login to view your invoice online here:&lt;/p&gt;\n\n				&lt;p&gt;&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n\n				&lt;p&gt;Date: {$currentTime|getDateTime:full}&lt;/p&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\r\n\r\nThis is a notice that Invoice {$invoiceNumber} has been generated for services by {$companyName} on {$invoiceDateEntered|getDate}.\r\n\r\n{foreach key=&quot;i&quot; item=&quot;lineItem&quot; from=$lineItems}\r\nDescription: {$lineItem.lineItemDescription} {if $lineItem.domains.0}\r\n({foreach key=&quot;xd&quot; item=&quot;domain&quot; from=$lineItem.domains}{$domain.domainSLD}.{$domain.domainTLD} {/foreach})\r\n{elseif $lineItem.domainName}\r\n({$lineItem.domainName})\r\n{/if}Period: {$lineItem.lineItemDateCurrentRenewal|getDate:short} - {$lineItem.lineItemDateNextRenewal|getDate:short}\r\nQuantity: {$lineItem.lineItemQuantity}\r\nPrice: {$lineItem.lineItemPriceAmount|getAmount:$currencyID}\r\nDiscount: {$lineItem.lineItemDiscountAmount|getAmount:$currencyID}\r\nTax: {$lineItem.lineItemTaxAmount|getAmount:$currencyID}\r\nItem Total: {$lineItem.lineItemTotalAmount|getAmount:$currencyID}\r\n\r\n{/foreach}\r\n\r\n------------------------------------------\r\nSubtotal: {$invoiceSubTotal|getAmount:$currencyID}\r\nTax: {$invoiceTaxAmount|getAmount:$currencyID}\r\nTotal: {$invoiceAmount|getAmount:$currencyID}\r\nDue Date: {$invoiceDateDue|getDate}\r\n\r\n{$invoiceComments}\r\n{if $paymentType==$billingTypeCard} Our records show that you pay with credit card. We will charge your card automatically for the balance of this invoice automatically if necessary. {elseif $paymentType==$billingTypeBank} Our records show that you pay through bank drafts. Please remit payment for your outstanding balance. {elseif $paymentType==$billingTypeEcheck} Our records show that you pay through eCheck. We will charge your account automatically for the balance of this invoice. {elseif $paymentType==$billingTypeSecondary} Our records show that you pay through PayPal. If you have a subscription set up, then your payment will be made automatically. If not, please remit payment for your outstanding balance to XXX@XXX.com through PayPal. {elseif $paymentType==$billingTypeWire} Our records show that you pay through wire transfer. Please remit payment for your outstanding balance. {else} Our records show that you pay manually. Please remit payment for your outstanding balance.{/if}\r\n\r\n\r\n{$companyName}\r\n{$companyAddress1}\r\n{$companyAddress2}\r\n{$companyCity}, {$companyState}\r\n{$companyZip}\r\n\r\nYou may login to view your invoice online here:\r\n{$companyClientURL}\r\n\r\nThank you,\r\n\r\n{$companyName}\r\n{$companyURL}\r\n\r\nDate: {$currentTime|getDateTime:full}\r\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (9,9,'Bank Draft Payment Receipt: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Bank Draft Payment Receipt: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}\n				has been processed and approved.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank Name:&lt;/span&gt; {$billingBankName}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank ABA Code:&lt;/span&gt; {$billingBankAbaCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Bank Account Number:&lt;/span&gt; {$billingAccountNumLastFour}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Return:&lt;/span&gt; {$authReturn}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Code:&lt;/span&gt; {$authCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;AVS Code:&lt;/span&gt; {$avsCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;You will see a charge from {$companyName} for this transaction.&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;\n','Hello {$contactFirstName} {$contactLastName},\n\nYour Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID} has been processed and approved.\n\nPAYMENT INFORMATION:\n\nBank Name: {$billingBankName}\nBank ABA Code: {$billingBankAbaCode}\nBank Account Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nYou will see a charge from {$companyName} for this transaction.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (10,10,'Payment Receipt: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Payment Receipt: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n				&lt;p&gt;A payment has been applied to Invoice {$invoiceNumber}.&lt;/p&gt;\n\n				&lt;table class=&quot;box details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;Thank you for your payment.&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;box information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us at your convenience.&lt;/p&gt;\n						&lt;p&gt;Thank you,&lt;/p&gt;\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nA payment has been applied to Invoice {$invoiceNumber}.\n\nPAYMENT INFORMATION:\n\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nThank you for your payment.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (11,11,'Credit Card Expiration Notice: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Credit Card Expiration Notice: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice to inform you that your credit card on file with\n				{$companyName} has expired or will be expiring soon.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;CREDIT CARD INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card:&lt;/span&gt; {$billingCardType} - {$billingAccountNumLastFour}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Expire Month:&lt;/span&gt; {$billingCardExpMonth}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Expire Year:&lt;/span&gt; {$billingCardExpYear}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;Please login to your account and update your credit card as soon as\n				possible in order to avoid an interruption in your service.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your credit card on file with {$companyName} has expired or will be expiring soon: \n\nCREDIT CARD INFORMATION:\n\nCredit Card: {$billingCardType} - {$billingAccountNumLastFour}\nExpire Month: {$billingCardExpMonth}\nExpire Year: {$billingCardExpYear}\n\nPlease login to your account and update your credit card as soon as possible in order to avoid an interruption in your service:\n\n{$companyClientURL}\n  \n  Thank you,\n  \n  {$companyName}\n  {$companyURL} \n  \n  {$companyAddress1}\n  {$companyAddress2}\n  {$companyCity}, {$companyState}\n  {$companyZip}\n  \n  Date: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (12,12,'Payment Receipt: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Payment Receipt: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;A payment has been applied to your account at {$companyName}.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Gateway Name:&lt;/span&gt; {$gatewayName}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;Thank you for your payment.&lt;/p&gt;\n\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact\n						us at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nA payment has been applied to your account at {$companyName}.\n\nPAYMENT INFORMATION:\n\nGateway Name: {$gatewayName}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes}\n\nThank you for your payment.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (13,13,'Declined Charge: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Declined Charge: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;We have attempted to process your Invoice {$invoiceNumber} in the\n				amount of {$invoiceAmount|getAmount:$currencyID}. However, your\n				transaction was declined. Details are provided below:&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Type:&lt;/span&gt; {$billingCardType}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Number:&lt;/span&gt; {$billingAccountNumLastFour}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Return:&lt;/span&gt; {$authReturn}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Code:&lt;/span&gt; {$authCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;AVS Code:&lt;/span&gt; {$avsCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;NOTE: We will attempt to process your invoice again soon.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\r\n\r\nWe have attempted to process your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:\r\n\r\nPAYMENT INFORMATION:\r\n\r\nCredit Card Type: {$billingCardType}\r\nCredit Card Number: {$billingAccountNumLastFour}\r\n------------------------------------------\r\nTransaction Date/Time: {$transactionDateCreated|getDate}\r\nTransaction ID: {$transactionCode}\r\nAuth Return: {$authReturn}\r\nAuth Code: {$authCode}\r\nAVS Code: {$avsCode}\r\n------------------------------------------\r\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\r\nNotes: {$transactionNotes}\r\n\r\nNOTE: We will attempt to process your invoice again soon.\r\n\r\nQUESTIONS?\r\n\r\nIf you have any questions regarding your account, please contact us at your convenience.\r\n\r\nThank you,\r\n\r\n{$companyName}\r\n{$companyURL} \r\n\r\n{$companyAddress1}\r\n{$companyAddress2}\r\n{$companyCity}, {$companyState}\r\n{$companyZip}\r\n\r\nDate: {$currentTime|getDateTime:full}',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (14,14,'Payment Error: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Payment Error: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;We have attempted to process your invoice {$invoiceNumber} in the\n				amount of {$invoiceAmount|getAmount:$currencyID}. However, your\n				transaction was declined. Details are provided below:&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;PAYMENT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Type:&lt;/span&gt; {$billingCardType}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Credit Card Number:&lt;/span&gt; {$billingAccountNumLastFour}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Date/Time:&lt;/span&gt; {$transactionDateCreated|getDate}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Transaction ID:&lt;/span&gt; {$transactionCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Return:&lt;/span&gt; {$authReturn}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Auth Code:&lt;/span&gt; {$authCode}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;AVS Code:&lt;/span&gt; {$avsCode}&lt;br/&gt;\n\n						&lt;hr/&gt;\n\n						&lt;span class=&quot;title&quot;&gt;Transaction Amount:&lt;/span&gt; {$transactionAmount|getAmount:$currencyID}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Notes:&lt;/span&gt; {$transactionNotes}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;NOTE: We will attempt to process your invoice again soon. Please log\n				into the billing system to correct this error:&lt;/p&gt;\n\n				&lt;p&gt;&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nWe have attempted to process your Invoice {$invoiceNumber} in the amount of {$invoiceAmount|getAmount:$currencyID}. However, your transaction was declined. Details are provided below:\n\nPAYMENT INFORMATION:\n\nCredit Card Type: {$billingCardType}\nCredit Card Number: {$billingAccountNumLastFour}\n------------------------------------------\nTransaction Date/Time: {$transactionDateCreated|getDate}\nTransaction ID: {$transactionCode}\nAuth Return: {$authReturn}\nAuth Code: {$authCode}\nAVS Code: {$avsCode}\n------------------------------------------\nTransaction Amount: {$transactionAmount|getAmount:$currencyID}\nNotes: {$transactionNotes} {include file=&amp;quot;$tplDirectory/widgets/boxFooter.tpl&amp;quot;}\n\nNOTE: We will attempt to process your invoice again soon. Please log into the billing system to correct this error:\n\n{$companyClientURL}\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (15,15,'Domain Renewal Notice: {$domainSLD}.{$domainTLD}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Domain Renewal Notice: {$domainSLD}.{$domainTLD}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice to inform you that your domain {$domainSLD}.{$domainTLD}\n				has been invoiced in the amount of {$invoiceAmount|getAmount:$currencyID} on\n				{$invoiceDateEntered|getDate}. Your domain will be renewed once payment has\n				been made on the invoice.&lt;/p&gt;\n\n				&lt;p&gt;&lt;strong&gt;Domain Expiry Date:&lt;/strong&gt; {$domainDateExpires|getDate}&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\r\n\r\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been invoiced in the amount of {$invoiceAmount|getAmount:$currencyID} on {$invoiceDateEntered|getDate}. Your domain will be renewed once payment has been made on the invoice.\r\n\r\nDomain Expiry Date: {$domainDateExpires|getDate}\r\n\r\nThank you,\r\n\r\nThank you,\r\n\r\n{$companyName}\r\n{$companyURL} \r\n\r\n{$companyAddress1}\r\n{$companyAddress2}\r\n{$companyCity}, {$companyState}\r\n{$companyZip}\r\n\r\nDate: {$currentTime|getDateTime:full}\r\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (16,16,'Domain Transfer Success: {$domainSLD}.{$domainTLD}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Domain Transfer Success: {$domainSLD}.{$domainTLD}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice to inform you that your domain {$domainSLD}.{$domainTLD}\n				has been transferred to {$companyName} successfully.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} has been transferred to {$companyName} successfully.\n\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (17,17,'Failed Domain Transfer: {$domainSLD}.{$domainTLD}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Failed Domain Transfer: {$domainSLD}.{$domainTLD}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice to inform you that your domain {$domainSLD}.{$domainTLD}\n				failed to transfer to {$companyName} successfully.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your domain {$domainSLD}.{$domainTLD} failed to transfer to {$companyName} successfully.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (18,18,'1st Notice: Invoice Overdue',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Reminder: {$companyName} Invoice Overdue\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n				&lt;p&gt;This is a reminder that your Invoice {$invoiceNumber} with {$companyName} is now past due.&lt;/p&gt;\n				&lt;p&gt;Please login to your account using the following information and make immediate payment on\n				your outstanding invoice. If the invoice is not paid in full, your account will be subject\n				to suspension.&lt;/p&gt;\n\n				&lt;span class=&quot;title&quot;&gt;Login URL:&lt;/span&gt; &lt;a href=&quot;{$companyClientURL}&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n				&lt;span class=&quot;title&quot;&gt;Login Username:&lt;/span&gt; {$contactUsername}\n\n				&lt;p&gt;If you have forgotten your password, the above URL has a Forgot Password link.&lt;/p&gt;\n\n				&lt;p&gt;If you have already submitted payment, please disregard this message as your payment is\n				currently being processed and your account will be updated to reflect your new balance\n				shortly. We appreciate your business. If there is anything we can do for you, please\n				let us know.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nThis is a reminder that your Invoice {$invoiceNumber} with {$companyName} is now past due.\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension.\n\nLogin URL: {$companyClientURL}\nLogin Username: {$contactUsername}\n\nIf you have forgotten your password, the above URL has a Forgot Password link.\n\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly. We appreciate your business. If there is anything we can do for you, please let us know.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (19,19,'2nd Notice: Invoice Overdue',1,'&lt;style&gt;&lt;!--\r\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\r\n--&gt;&lt;/style&gt;\r\n&lt;center&gt; \r\n&lt;table class=&quot;emailBody&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;\r\n&lt;tbody&gt;\r\n&lt;tr&gt;\r\n&lt;td class=&quot;emailTitle&quot;&gt;2nd Notice: {$companyName} Invoice Overdue&lt;/td&gt;\r\n&lt;/tr&gt;\r\n&lt;tr&gt;\r\n&lt;td&gt;\r\n&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\r\n&lt;tbody&gt;\r\n&lt;tr&gt;\r\n&lt;td class=&quot;leftColumn&quot;&gt;\r\n&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\r\n&lt;p&gt;This is the second notice that your invoice {$invoiceNumber} with {$companyName} 				is past due.&lt;/p&gt;\r\n&lt;p&gt;Please login to your account using the following information and make immediate 				payment on your outstanding invoice. If the invoice is not paid in full, your account 				will be subject to suspension as stated in our Terms and Conditions that you agreed 				to at the time of purchase.&lt;/p&gt;\r\n&lt;span class=&quot;title&quot;&gt;Login URL:&lt;/span&gt; &lt;a href=&quot;{$companyClientURL}&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br /&gt; &lt;span class=&quot;title&quot;&gt;Login Username:&lt;/span&gt; {$contactUsername}\r\n&lt;p&gt;If you have forgotten your password, the above URL has a Forgot Password link.&lt;/p&gt;\r\n&lt;p&gt;We appreciate your prompt attention in this matter.&lt;/p&gt;\r\n&lt;p&gt;If you have already submitted payment, please disregard this message as your payment 				is currently being processed and your account will be updated to reflect your new 				balance shortly.&lt;/p&gt;\r\n&lt;p&gt;Thank you,&lt;/p&gt;\r\n&lt;p&gt;{$companyName}&lt;br /&gt; &lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/p&gt;\r\n&lt;/td&gt;\r\n&lt;td class=&quot;rightColumn&quot;&gt;{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}&lt;/td&gt;\r\n&lt;/tr&gt;\r\n&lt;/tbody&gt;\r\n&lt;/table&gt;\r\n&lt;/td&gt;\r\n&lt;/tr&gt;\r\n&lt;/tbody&gt;\r\n&lt;/table&gt;\r\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\r\n\r\nThis is the second notice that your invoice {$invoiceNumber} with {$companyName} is past due.\r\n\r\nPlease login to your account using the following information and make immediate payment on your outstanding invoice. If the invoice is not paid in full, your account will be subject to suspension as stated in our Terms and Conditions that you agreed to at the time of purchase.\r\n\r\nLogin URL: {$companyClientURL}\r\nLogin Username: {$contactUsername}\r\n\r\nIf you have forgotten your password, the above URL has a Forgot Password link.\r\n\r\nWe appreciate your prompt attention in this matter.\r\n\r\nIf you have already submitted payment, please disregard this message as your payment is currently being processed and your account will be updated to reflect your new balance shortly. \r\n\r\nThank you,\r\n\r\n{$companyName}\r\n{$companyURL} \r\n\r\n{$companyAddress1}\r\n{$companyAddress2}\r\n{$companyCity}, {$companyState}\r\n{$companyZip}\r\n\r\nDate: {$currentTime|getDateTime:full}\r\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (20,20,'Final Notice: Package Suspension',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Final Notice: {$companyName} Package Suspended\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is the 3rd and FINAL notice that your invoice {$invoiceNumber} with\n				{$companyName} is past due. Your account has been suspended until payment\n				is made in full on your invoice.&lt;/p&gt;\n\n				&lt;p&gt;Please login to your account using the following information and make\n				immediate payment on your outstanding invoice to re-activate service.\n				If the invoice is not paid in full, your account will be subject to termination\n				in accordance with our Terms and Conditions that you agreed to at the time\n				of purchase.&lt;/p&gt;\n\n				&lt;span class=&quot;title&quot;&gt;Login URL:&lt;/span&gt; &lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n				&lt;span class=&quot;title&quot;&gt;Login Username:&lt;/span&gt; {$contactUsername}&lt;br /&gt;&lt;br/&gt;\n\n				&lt;p&gt;If you have forgotten your password, the above URL has a Forgot Password link.&lt;/p&gt;\n\n				&lt;p&gt;If you believe this message to be in error, please provide either the last\n				four digits of the credit card you made payment with, a check number, or\n				third party gateway receipt so that we can correct any discrepancies.&lt;/p&gt;\n\n				&lt;p&gt;If you have already submitted payment, please contact us immediately so that\n				we can determine the current status of your account.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/div&gt;\n&lt;/center&gt;\n','Dear {$contactFirstName} {$contactLastName},\n\nThis is the 3rd and FINAL notice that your invoice {$invoiceNumber} with {$companyName} is past due. Your account has been suspended until payment is made in full on your invoice.\n\nPlease login to your account using the following information and make immediate payment on your outstanding invoice to re-activate service. If the invoice is not paid in full, your account will be subject to termination in accordance with our Terms and Conditions that you agreed to at the time of purchase.\n\nLogin URL: {$companyClientURL}\nLogin Username: {$contactUsername}\n\nIf you have forgotten your password, the above URL has a Forgot Password link.\n\nIf you believe this message to be in error, please provide either the last four digits of the credit card you made payment with, a check number, or third party gateway receipt so that we can correct any discrepancies.\n\nIf you have already submitted payment, please contact us immediately so that we can determine the current status of your account. \n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (21,21,'Account Deleted: {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Account Terminated: {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;This is a notice to inform you that your account with {$companyName}\n				has been terminated in accordance with our Terms and Conditions, due\n				to the fact that there is currently an outstanding invoice on your\n				account.&lt;/p&gt;\n\n				&lt;p&gt;We have made a number of attempts to make contact prior to taking this\n				action, but we have not received any response up to this point.&lt;/p&gt;\n\n				&lt;p&gt;If you wish to re-establish service, please contact support.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nThis is a notice to inform you that your account with {$companyName} has been terminated in accordance with our Terms and Conditions, due to the fact that there is currently an outstanding invoice on your account.\n\n\nWe have made a number of attempts to make contact prior to taking this action, but we have not received any response up to this point.\n\nIf you wish to re-establish service, please contact support.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (22,22,'Package Re-Enabled Notice',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Package Re-Activation Notice\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;We have received your payment to your Invoice {$invoiceNumber} in\n				the amount of {$invoiceAmountPaid|getAmount:$currencyID} on\n				{$invoiceDatePaid|getDate}. Your account is now up to date and\n				in good standing.&lt;/p&gt;\n\n				&lt;p&gt;Your package {$packageName} has been re-activated and you can\n				continue using your account as normal.&lt;/p&gt;\n\n				&lt;p&gt;We appreciate your cooperation and apologize for any surprise this\n				may have caused.&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nWe have received your payment to your  Invoice {$invoiceNumber} in the amount of  {$invoiceAmountPaid|getAmount:$currencyID} on  {$invoiceDatePaid|getDate}. Your account is now up to date and in good  standing.\n\nYour package {$packageName} has been re-activated and you can continue using your account as normal.\n\nWe appreciate your cooperation and apologize for any surprise this may have caused.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (23,23,'Password Reset',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Password Reset\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Your password has been reset. Your new password is: &apos;{$newPassword}&apos;&lt;/p&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nYour password has been reset. Your new password is: \'{$newPassword}\'\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (24,24,'Insert Subject Here',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Insert Subject Here\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Insert body here.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;ANY DETAILS&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;DETAIL TITLE 1:&lt;/span&gt; Details&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;DETAIL TITLE 2:&lt;/span&gt; Details&lt;br/&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;ANY INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;INFO TITLE 1:&lt;/span&gt; Details&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;INFO TITLE 2:&lt;/span&gt; Details&lt;br/&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;Thank you,&lt;/p&gt;\n\n				&lt;p&gt;\n					{$companyName}&lt;br/&gt;\n					&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n				&lt;/p&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;ANY ADDITIONAL  INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;INFO TITLE 1:&lt;/span&gt; Details&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;INFO TITLE 2:&lt;/span&gt; Details&lt;br/&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nInsert body here.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (25,25,'Welcome to {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Welcome to {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you very much for choosing {$companyName} as your Web and\n				E-Commerce Hosting Provider. This is your order confirmation email\n				for your Web hosting account with {$companyName}. Please note that\n				this is not your account information. An email with your username,\n				password, and IP address will be emailed to you later once your\n				account is setup at {$companyName}.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;CONTACT INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Email:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;{$contactEmail}&lt;/p&gt;\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Company:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;\n							{if $contactCompany}\n								{$contactCompany}\n							{elseif $clientCompany}\n								{$clientCompany}\n							{/if}\n						&lt;/p&gt;\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Address:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;\n							{$contactAddress1}&gt;\n							{strip}\n								{if $contactAddress2}\n									{$contactAddress2}&lt;br/&gt;\n								{/if}\n							{/strip}\n							{$contactCity}, {$contactState} {$contactZip}\n						&lt;/p&gt;\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Phone:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;{$contactPhone1}&lt;/p&gt;\n\n						{if $contactFax}\n							&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Fax:&lt;/span&gt;&lt;/p&gt;\n							&lt;p&gt;{$contactFax}&lt;/p&gt;\n						{/if}\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Username:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;{$contactUsername}&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;ORDER INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						{foreach from=$lineItems item=&quot;lineItem&quot; key=&quot;xk&quot;}\n							&lt;p&gt;&lt;strong&gt;\n								{$lineItem.lineItemDescription}:\n								{strip}\n									{if $lineItem.domainName}\n										{$lineItem.domainName}&lt;br/&gt;\n									{elseif $lineItem.domains.0}\n										{$lineItem.domains.0.domainSLD}.{$lineItem.domains.0.domainTLD}&lt;br/&gt;\n									{/if}\n								{/strip}\n							&lt;/strong&gt;&lt;/p&gt;\n\n							&lt;p&gt;{$cycles[$lineItem.cycleID]} @ {$lineItem.lineItemPriceAmount|getAmount:$currencyID}&lt;/p&gt;\n						{foreachelse}\n							&lt;p&gt;- Empty -&lt;/p&gt;\n						{/foreach}\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Sub Total:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;{$invoiceSubTotal|getAmount:$currencyID}&lt;/p&gt;\n\n						&lt;p&gt;&lt;span class=&quot;title&quot;&gt;Total Due:&lt;/span&gt;&lt;/p&gt;\n						&lt;p&gt;{$invoiceAmount|getAmount:$currencyID}&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n\n				&lt;p&gt;Thank you for signing up!&lt;/p&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\n Thank you very much for choosing {$companyName} as your Web and E-Commerce\nHosting Provider. This is your order confirmation email for your Web hosting\naccount with {$companyName}. Please note that this is not your account\ninformation. An email with your username, password, and IP address will be\nemailed to you later once your account is setup at {$companyName}.\n\nContact Information:\nEmail: {$contactEmail}\n{if $contactCompany}\nCompany: {$contactCompany}\n{elseif $clientCompany}\nCompany: {$clientCompany}\n{/if}\nAddress: {$contactAddress1} {strip}\n{if $contactAddress2}\n{$contactAddress2}\n{/if}\n{/strip}\n{$contactCity}, {$contactState} {$contactZip}\nPhone: {$contactPhone1}\n{if $contactFax}Fax: {$contactFax}\n{/if}\nUsername: {$contactUsername}\n\nOrder Information:\n\n{foreach from=$lineItems item=lineItem}\n{assign var=&quot;name&quot; value=$lineItem.lineItemDescription}{$smarty.const.$name|default:$name}\n{strip}\n{if $lineItem.domainName}\n{assign var=&quot;name&quot; value=$lineItem.domainName}\n{$smarty.const.$name|default:$name}\n{elseif $lineItem.domains.0}\n{$lineItem.domains.0.domainSLD}.{$lineItem.domains.0.domainTLD}\n{/if}\n{/strip}\n{$cycles[$lineItem.cycleID]} @ {$lineItem.lineItemTotalAmount|getAmount:$currencyID}\n{foreachelse}\n- Empty - \n{/foreach}\n\nSub Total: {$invoiceSubTotal|getAmount:$currencyID}\nTotal Due: {$invoiceAmount|getAmount:$currencyID}\n\n\nThank You for Signing Up!\n{$companyName}',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (26,26,'Thank You for Registering with {$companyName}',1,'&lt;style&gt;&lt;!--\n	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}\n--&gt;&lt;/style&gt;\n\n&lt;center&gt;\n\n&lt;table class=&quot;emailBody&quot; cellpadding=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n&lt;tr&gt;&lt;td class=&quot;emailTitle&quot;&gt;\n	Thank you for Registering with {$companyName}\n&lt;/td&gt;&lt;/tr&gt;\n&lt;tr&gt;&lt;td&gt;\n	&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n		&lt;tr&gt;\n			&lt;td class=&quot;leftColumn&quot;&gt;\n				&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;\n\n				&lt;p&gt;Thank you for registering/transferring {$domainSLD}.{$domainTLD}\n				to {$companyName}. If you are registering a new domain name, this\n				will occur shortly. If you are transferring a domain, an email will\n				be sent to you when the transfer occurs.&lt;/p&gt;\n\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;DOMAIN INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;span class=&quot;title&quot;&gt;Domain&lt;/span&gt; {$domainSLD}.{$domainTLD}&lt;br/&gt;\n						&lt;span class=&quot;title&quot;&gt;Term:&lt;/span&gt; {$packageCycleName}\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;details&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;NAMESERVER INFORMATION&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Remember to update your DNS entries in order for your domain\n						to propagate to your new hosting account.&lt;/p&gt;\n\n						&lt;p&gt;\n							The DNS entries are listed below:&lt;br/&gt;\n							{if $nameserver1}&lt;span class=&quot;title&quot;&gt;{$nameserver1}:&lt;/span&gt; {$nameserver1IP}&lt;br/&gt;{/if}\n							{if $nameserver2}&lt;span class=&quot;title&quot;&gt;{$nameserver2}:&lt;/span&gt; {$nameserver2IP}&lt;br/&gt;{/if}\n							{if $nameserver3}&lt;span class=&quot;title&quot;&gt;{$nameserver3}:&lt;/span&gt; {$nameserver3IP}&lt;br/&gt;{/if}\n							{if $nameserver4}&lt;span class=&quot;title&quot;&gt;{$nameserver4}:&lt;/span&gt; {$nameserver4IP}&lt;br/&gt;{/if}\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n			&lt;td class=&quot;rightColumn&quot;&gt;\n				{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}\n			&lt;/td&gt;\n		&lt;/tr&gt;\n		&lt;tr&gt;\n			&lt;td colspan=&quot;2&quot;&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;BILLING&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;Login to our client billing system at the following URL to view and\n						pay your invoices, change your payment type or billing details,\n						update contact information, and more!&lt;/p&gt;\n\n						&lt;p&gt;\n							&lt;a href=&quot;{$companyClientURL}&quot; target=&quot;_blank&quot;&gt;{$companyClientURL}&lt;/a&gt;&lt;br/&gt;\n							&lt;strong&gt;Username:&lt;/strong&gt; {$contactUsername}\n						&lt;/p&gt;\n\n						&lt;p&gt;Need help with your password? Visit the URL above and click the\n						&amp;quot;Forgot your password?&amp;quot; link to retrieve your password.&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n				&lt;table class=&quot;information&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;\n					&lt;tr&gt;&lt;td class=&quot;header&quot;&gt;QUESTIONS?&lt;/td&gt;&lt;/tr&gt;\n					&lt;tr&gt;&lt;td class=&quot;data&quot;&gt;\n						&lt;p&gt;If you have any questions regarding your account, please contact us\n						at your convenience.&lt;/p&gt;\n\n						&lt;p&gt;Thank you,&lt;/p&gt;\n\n						&lt;p&gt;\n							{$companyName}&lt;br/&gt;\n							&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;\n						&lt;/p&gt;\n					&lt;/td&gt;&lt;/tr&gt;\n				&lt;/table&gt;\n			&lt;/td&gt;\n		&lt;/tr&gt;\n	&lt;/table&gt;\n&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;\n\n&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName}, \n  \nThank you for registering/transferring {$domainSLD}.{$domainTLD} to {$companyName}. If you are registering a new domain name, this will occur shortly. If you are transferring a domain, an email will be sent to you when the transfer occurs.\n\nDOMAIN INFORMATION:\n\nDomain {$domainSLD}.{$domainTLD}\nTerm: {$packageCycleName}\n\nNAMESERVER INFORMATION:\n\nRemember to update your DNS entries in order for your domain to propagate to your new hosting account. The DNS entries are listed below:\n\n{$nameserver1}: {$nameserver1IP}\n{$nameserver2}: {$nameserver2IP}\n{$nameserver3}: {$nameserver3IP}\n{$nameserver4}: {$nameserver4IP}\n\nBILLING:\n\nLogin to our client billing system at the following URL to view and pay your invoices, change your payment type or billing details, update contact information, and more!\n\n{$companyClientURL}\nUsername: {$contactUsername}\n\nNeed help with your password? Visit the URL above and click the Forgot your password? link to retrieve your password.\n\nQUESTIONS?\n\nIf you have any questions regarding your account, please contact us at your convenience.\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (27,27,'Please, input required data',1,'&lt;style&gt;&lt;!--
	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}
--&gt;&lt;/style&gt;
&lt;center&gt;
&lt;table class=&quot;emailBody&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;
&lt;tbody&gt;
&lt;tr&gt;
&lt;td class=&quot;emailTitle&quot;&gt;Please, input required data&lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
&lt;td&gt;
&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;
&lt;tbody&gt;
&lt;tr&gt;
&lt;td class=&quot;leftColumn&quot;&gt;
&lt;p&gt;&lt;strong&gt;Dear {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;
&lt;p&gt;You have subscriptions that require the input of additional data for the successful completion: &amp;nbsp;&lt;/p&gt;
&lt;p&gt;&lt;a href=&quot;{$controlPanelUrl}&quot; target=&quot;_blank&quot;&gt;{$controlPanelUrlText}&lt;/a&gt;&lt;/p&gt;
&lt;p&gt;&lt;br /&gt;{$companyName}&amp;nbsp;Thank you,&lt;/p&gt;
&lt;p&gt;&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/p&gt;
&lt;/td&gt;
&lt;td class=&quot;rightColumn&quot;&gt;&lt;br /&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
&lt;td colspan=&quot;2&quot;&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;/tbody&gt;
&lt;/table&gt;
&lt;/td&gt;
&lt;td class=&quot;rightColumn&quot;&gt;
	{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}
&lt;/td&gt;
&lt;/tr&gt;
&lt;/tbody&gt;
&lt;/table&gt;
&lt;/center&gt;','Dear {$contactFirstName} {$contactLastName},\n\nYou have subscriptions that require the input of additional data for the successful completion:\n\n{$controlPanelUrl}\n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
INSERT INTO `email_tpls` VALUES (28,28,'Schet-factura notice',1,'&lt;style&gt;&lt;!--
	{include file=&quot;$tplDirectory/widgets/cssbased/styles.css&quot;}
--&gt;&lt;/style&gt;
&lt;center&gt;
&lt;table class=&quot;emailBody&quot; border=&quot;0&quot; cellspacing=&quot;0&quot; cellpadding=&quot;0&quot;&gt;
&lt;tbody&gt;
&lt;tr&gt;
&lt;td class=&quot;emailTitle&quot;&gt;Schet-factura {\$facturaID}: {\$companyName} &lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
&lt;td&gt;
&lt;table class=&quot;content&quot; border=&quot;0&quot; cellspacing=&quot;0&quot;&gt;
&lt;tbody&gt;
&lt;tr&gt;
&lt;td class=&quot;leftColumn&quot;&gt;
&lt;p&gt;&lt;strong&gt;Hello {$contactFirstName} {$contactLastName},&lt;/strong&gt;&lt;/p&gt;
&lt;p&gt;Please find the schet-factura {\$facturaID} from {\$companyName} attached to this e-mail. &amp;nbsp;&lt;/p&gt;
&lt;p&gt; Thank you, &amp;nbsp;&lt;/p&gt
&lt;p&gt;&lt;br /&gt;{$companyName}&amp;&lt;/p&gt;
&lt;p&gt;&lt;a href=&quot;{$companyURL}&quot; target=&quot;_blank&quot;&gt;{$companyURL}&lt;/a&gt;&lt;/p&gt;
&lt;/td&gt;
&lt;td class=&quot;rightColumn&quot;&gt;&lt;br /&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;tr&gt;
&lt;td colspan=&quot;2&quot;&gt;&lt;/td&gt;
&lt;/tr&gt;
&lt;/tbody&gt;
&lt;/table&gt;
&lt;/td&gt;
&lt;td class=&quot;rightColumn&quot;&gt;
	{include file=&quot;$tplDirectory/widgets/cssbased/rightColumnContent.tpl&quot;}
&lt;/td&gt;
&lt;/tr&gt;
&lt;/tbody&gt;
&lt;/table&gt;
&lt;/center&gt;','Hello {$contactFirstName} {$contactLastName},\n\nPlease find the schet-factura {$facturaID} from {$companyName} attached to this e-mail. \n\nThank you,\n\n{$companyName}\n{$companyURL} \n\n{$companyAddress1}\n{$companyAddress2}\n{$companyCity}, {$companyState}\n{$companyZip}\n\nDate: {$currentTime|getDateTime:full}\n',21,0,225,'002');
/*!40000 ALTER TABLE `email_tpls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `faq_categories`
--
DROP TABLE IF EXISTS `faq_categories`;
CREATE TABLE `faq_categories` (
  `faq_category_id` tinyint(3) unsigned NOT NULL auto_increment,
  `faq_category_name` varchar(50) default NULL,
  `faq_category_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`faq_category_id`),
  KEY `faq_category_type` (`faq_category_type`)
) ENGINE=MyISAM ;

--
-- Table structure for table `faqs`
--
DROP TABLE IF EXISTS `faqs`;
CREATE TABLE `faqs` (
  `faq_id` smallint(5) unsigned NOT NULL auto_increment,
  `faq_category_id` tinyint(3) unsigned default NULL,
  `faq_question` text,
  `faq_answer` longtext,
  `faq_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`faq_id`),
  KEY `faq_category_id` (`faq_category_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `fraud_country_thresholds`
--
DROP TABLE IF EXISTS `fraud_country_thresholds`;
CREATE TABLE `fraud_country_thresholds` (
  `threshold_id` int(10) unsigned NOT NULL auto_increment,
  `threshold_name` varchar(100) default NULL,
  `country_type` tinyint(3) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `regions_id` char(3) default NULL,
  `level_one_score` decimal(3,1) unsigned default NULL,
  `level_two_score` decimal(3,1) unsigned default NULL,
  `level_three_score` decimal(3,1) unsigned default NULL,
  `level_one_action` tinyint(3) unsigned default NULL,
  `level_two_action` tinyint(3) unsigned default NULL,
  `level_three_action` tinyint(3) unsigned default NULL,
  `catch_all_action` tinyint(3) unsigned default NULL,
  `override_one_amount` decimal(10,2) unsigned default NULL,
  `override_two_amount` decimal(10,2) unsigned default NULL,
  `override_three_amount` decimal(10,2) unsigned default NULL,
  `override_one_action` tinyint(3) unsigned default NULL,
  `override_two_action` tinyint(3) unsigned default NULL,
  `override_three_action` tinyint(3) unsigned default NULL,
  `primary_score_to_use` tinyint(3) unsigned default NULL,
  `free_email_weight` decimal(3,1) unsigned default NULL,
  `country_match_weight` decimal(3,1) unsigned default NULL,
  `anon_proxy_weight` decimal(3,1) unsigned default NULL,
  `country_risk_weight` decimal(3,1) unsigned default NULL,
  `ip_distance_weight` decimal(3,1) unsigned default NULL,
  `bin_match_weight` decimal(3,1) unsigned default NULL,
  `bin_bank_match_weight` decimal(3,1) unsigned default NULL,
  `high_risk_email_weight` decimal(3,1) unsigned default NULL,
  `high_risk_shipping_weight` decimal(3,1) unsigned default NULL,
  `open_proxy_weight` decimal(3,1) unsigned default NULL,
  `fraud_soft_reject_message` text,
  `fraud_hard_reject_message` text,
  PRIMARY KEY  (`threshold_id`),
  KEY `country_type` (`country_type`),
  KEY `countries_id` (`countries_id`),
  KEY `regions_id` (`regions_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `fraud_results_log`
--
DROP TABLE IF EXISTS `fraud_results_log`;
CREATE TABLE `fraud_results_log` (
  `fraud_result_log_id` int(10) unsigned NOT NULL auto_increment,
  `threshold_id` int(10) unsigned default NULL,
  `client_id` int(8) unsigned default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `fraud_result_order_email` varchar(100) default NULL,
  `fraud_result_order_amount` decimal(10,2) unsigned default NULL,
  `fraud_result_o_amount` decimal(10,2) unsigned default NULL,
  `fraud_result_o_amount_action` tinyint(3) unsigned default NULL,
  `fraud_result_default_score` decimal(3,1) unsigned default NULL,
  `fraud_result_adjusted_score` decimal(3,1) unsigned default NULL,
  `fraud_result_score_action` tinyint(3) unsigned default NULL,
  `fraud_result_final_action_used` tinyint(3) unsigned default NULL,
  `fraud_result_ip` bigint(20) default NULL,
  `fraud_result_ip_lon` decimal(10,6) default NULL,
  `fraud_result_ip_lat` decimal(10,6) default NULL,
  `fraud_result_ip_city` varchar(255) default NULL,
  `fraud_result_ip_region` varchar(255) default NULL,
  `fraud_result_ip_country` char(2) default NULL,
  `fraud_result_ip_isp` varchar(255) default NULL,
  `fraud_result_ip_org` varchar(255) default NULL,
  `fraud_result_ip_country_match` tinyint(3) unsigned default NULL,
  `fraud_result_ip_distance` smallint(5) unsigned default NULL,
  `fraud_result_bin` smallint(5) unsigned default NULL,
  `fraud_result_bin_country` char(2) default NULL,
  `fraud_result_bin_match` tinyint(3) unsigned default NULL,
  `fraud_result_bin_bank_match` tinyint(3) unsigned default NULL,
  `fraud_result_bin_name` varchar(255) default NULL,
  `fraud_result_bin_phone` varchar(255) default NULL,
  `fraud_result_bin_phone_match` tinyint(3) unsigned default NULL,
  `fraud_result_risky_email` tinyint(3) unsigned default NULL,
  `fraud_result_risky_country` tinyint(3) unsigned default NULL,
  `fraud_result_risky_shipping` tinyint(3) unsigned default NULL,
  `fraud_result_is_free_email` tinyint(3) unsigned default NULL,
  `fraud_result_is_anon_proxy` tinyint(3) unsigned default NULL,
  `fraud_result_is_open_proxy` tinyint(3) unsigned default NULL,
  `fraud_result_date_created` int(10) unsigned default NULL,
  `fraud_result_spam_score` decimal(3,1) unsigned default NULL,
  `fraud_result_phone_match` tinyint(3) unsigned default NULL,
  `fraud_result_billing_match` tinyint(3) unsigned default NULL,
  `fraud_result_ship_match` tinyint(3) unsigned default NULL,
  `fraud_result_error` varchar(255) default NULL,
  PRIMARY KEY  (`fraud_result_log_id`),
  KEY `threshold_id` (`threshold_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `fraud_result_date_created` (`fraud_result_date_created`),
  KEY `fraud_result_ip_country` (`fraud_result_ip_country`),
  KEY `fraud_result_default_score` (`fraud_result_default_score`),
  KEY `fraud_result_adjusted_score` (`fraud_result_adjusted_score`)
) ENGINE=MyISAM ;

--
-- Table structure for table `fraud_set_order_form_rel`
--
DROP TABLE IF EXISTS `fraud_set_order_form_rel`;
CREATE TABLE `fraud_set_order_form_rel` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL default '0',
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fraud_set_id`,`order_form_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `fraud_set_threshold_rel`
--
DROP TABLE IF EXISTS `fraud_set_threshold_rel`;
CREATE TABLE `fraud_set_threshold_rel` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL default '0',
  `threshold_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`fraud_set_id`,`threshold_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `fraud_sets`
--
DROP TABLE IF EXISTS `fraud_sets`;
CREATE TABLE `fraud_sets` (
  `fraud_set_id` tinyint(3) unsigned NOT NULL auto_increment,
  `config_group_id` smallint(5) unsigned default NULL,
  `fraud_set_name` varchar(75) default NULL,
  `fraud_set_email` varchar(100) default NULL,
  PRIMARY KEY  (`fraud_set_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `fraud_set_name` (`fraud_set_name`)
) ENGINE=MyISAM ;

--
-- Table structure for table `gateway_transaction`
--
DROP TABLE IF EXISTS `gateway_transaction`;
CREATE TABLE `gateway_transaction` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `prev_id` int(10) unsigned,
  `next_id` int(10) unsigned,
  `transaction_id` int(10) unsigned NOT NULL,
  `payment_gateway_id` int(10) unsigned NOT NULL,
  `billing_account_id` int(10) unsigned NOT NULL,
  `transaction_ref` varchar(255),
  `type` ENUM('refund', 'preauth', 'preauth_reversal', 'capture', 'capture_reversal', 'sale', 'credit', 'check_status', 'callback') NOT NULL,
  `status` ENUM('approved', 'declined', 'fraudulent', 'errored', 'refunded', 'authcall', 'deleted', 'pending', '3dsecure', 'unknown') NOT NULL,
  `is_initial` tinyint(1) unsigned,
  `notes` varchar(255),
  `data` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `prev_id` (`prev_id`),
  UNIQUE KEY `next_id` (`next_id`),
  UNIQUE KEY `is_initial` (`payment_gateway_id`, `billing_account_id`, `is_initial`),
  KEY `transaction_id` (`transaction_id`),
  KEY `transaction_ref` (`transaction_ref`),
  CONSTRAINT `prev_id_fk` FOREIGN KEY (`prev_id`) REFERENCES `gateway_transaction` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `next_id_fk` FOREIGN KEY (`next_id`) REFERENCES `gateway_transaction` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `gt_payment_gateway_id_fk` FOREIGN KEY (`payment_gateway_id`) REFERENCES `payment_gateways` (`payment_gateway_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Table structure for table `graph_cache`
--
DROP TABLE IF EXISTS `graph_cache`;
CREATE TABLE `graph_cache` (
  `graph_cache_id` int(10) unsigned NOT NULL auto_increment,
  `graph_cache_ref` int(10) unsigned default NULL,
  `graph_cache_op` varchar(255) default NULL,
  `graph_cache_type` varchar(255) default NULL,
  `graph_cache_date_created` int(10) unsigned default NULL,
  `graph_cache_count` int(10) unsigned default NULL,
  `graph_cache_src` longblob,
  PRIMARY KEY  (`graph_cache_id`),
  KEY `cache_ref` (`graph_cache_ref`)
) ENGINE=MyISAM ;

--
-- Table structure for table `group_attributes`
--
DROP TABLE IF EXISTS `group_attributes`;
CREATE TABLE `group_attributes` (
  `group_attribute_id` int(10) NOT NULL auto_increment,
  `group_id` int(10) default NULL,
  `group_attribute_name` varchar(100) default NULL,
  `group_attribute_value` varchar(255) default NULL,
  PRIMARY KEY  (`group_attribute_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `gw_transaction_attrs`
--
DROP TABLE IF EXISTS `gw_transaction_attrs`;
CREATE TABLE `gw_transaction_attrs` (
  `gw_transaction_attr_id` int(10) unsigned NOT NULL auto_increment,
  `gw_transaction_id` int(10) unsigned default NULL,
  `gw_transaction_attr_name` varchar(255) default NULL,
  `gw_transaction_attr_value` varchar(255) default NULL,
  PRIMARY KEY  (`gw_transaction_attr_id`),
  KEY `gw_transaction_id` (`gw_transaction_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `gw_transactions`
--
DROP TABLE IF EXISTS `gw_transactions`;
CREATE TABLE `gw_transactions` (
  `gw_transaction_id` int(10) unsigned NOT NULL auto_increment,
  `gw_transaction_type` tinyint(3) unsigned default NULL,
  `gw_transaction_ref` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `payment_gateway_id` int(10) unsigned,
  PRIMARY KEY  (`gw_transaction_id`),
  KEY `gw_transaction_ref` (`gw_transaction_ref`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_assignment_rel`
--
DROP TABLE IF EXISTS `hd_assignment_rel`;
CREATE TABLE `hd_assignment_rel` (
  `hd_ticket_id` int(10) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `source_admin_id` smallint(5) unsigned default NULL,
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `admin_id` (`admin_id`),
  KEY `source_admin_id` (`source_admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_bucket_admin_rel`
--
DROP TABLE IF EXISTS `hd_bucket_admin_rel`;
CREATE TABLE `hd_bucket_admin_rel` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  `may_view_tickets` tinyint(3) unsigned default NULL,
  `may_respond_tickets` tinyint(3) unsigned default NULL,
  `may_note_tickets` tinyint(3) unsigned default NULL,
  `may_modify_tickets` tinyint(3) unsigned default NULL,
  `may_delete_tickets` tinyint(3) unsigned default NULL,
  `may_assign_tickets` tinyint(3) unsigned default NULL,
  `may_merge_tickets` tinyint(3) unsigned default NULL,
  `may_notify_user` tinyint(3) unsigned default NULL,
  `may_respond_all` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`hd_bucket_id`,`admin_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `hd_bucket_admin_rel`
--
LOCK TABLES `hd_bucket_admin_rel` WRITE;
/*!40000 ALTER TABLE `hd_bucket_admin_rel` DISABLE KEYS */;
INSERT INTO `hd_bucket_admin_rel` VALUES (1,1,1,1,1,1,1,1,1,1,1);
INSERT INTO `hd_bucket_admin_rel` VALUES (2,1,1,1,1,1,1,1,1,1,1);
/*!40000 ALTER TABLE `hd_bucket_admin_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_bucket_department_rel`
--
DROP TABLE IF EXISTS `hd_bucket_department_rel`;
CREATE TABLE `hd_bucket_department_rel` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_bucket_id`,`hd_department_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `hd_bucket_department_rel`
--
LOCK TABLES `hd_bucket_department_rel` WRITE;
/*!40000 ALTER TABLE `hd_bucket_department_rel` DISABLE KEYS */;
INSERT INTO `hd_bucket_department_rel` VALUES (1,1);
INSERT INTO `hd_bucket_department_rel` VALUES (2,2);
/*!40000 ALTER TABLE `hd_bucket_department_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_buckets`
--
DROP TABLE IF EXISTS `hd_buckets`;
CREATE TABLE `hd_buckets` (
  `hd_bucket_id` smallint(5) unsigned NOT NULL auto_increment,
  `hd_bucket_name` varchar(50) default NULL,
  PRIMARY KEY  (`hd_bucket_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 ;

--
-- Dumping data for table `hd_buckets`
--
LOCK TABLES `hd_buckets` WRITE;
/*!40000 ALTER TABLE `hd_buckets` DISABLE KEYS */;
INSERT INTO `hd_buckets` VALUES (1,'main sales bucket');
INSERT INTO `hd_buckets` VALUES (2,'main tech support bucket');
/*!40000 ALTER TABLE `hd_buckets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_department_admin_rel`
--
DROP TABLE IF EXISTS `hd_department_admin_rel`;
CREATE TABLE `hd_department_admin_rel` (
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  `admin_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_department_id`,`admin_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `hd_department_admin_rel`
--
LOCK TABLES `hd_department_admin_rel` WRITE;
/*!40000 ALTER TABLE `hd_department_admin_rel` DISABLE KEYS */;
INSERT INTO `hd_department_admin_rel` VALUES (1,1);
INSERT INTO `hd_department_admin_rel` VALUES (2,1);
/*!40000 ALTER TABLE `hd_department_admin_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_departments`
--
DROP TABLE IF EXISTS `hd_departments`;
CREATE TABLE `hd_departments` (
  `hd_department_id` tinyint(3) unsigned NOT NULL auto_increment,
  `hd_department_name` varchar(50) default NULL,
  `hd_department_description` text,
  PRIMARY KEY  (`hd_department_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 ;

--
-- Dumping data for table `hd_departments`
--
LOCK TABLES `hd_departments` WRITE;
/*!40000 ALTER TABLE `hd_departments` DISABLE KEYS */;
INSERT INTO `hd_departments` VALUES (1,'Sales Department','Sales Department bucket');
INSERT INTO `hd_departments` VALUES (2,'Tech Support Department','Tech Support Department bucket');
/*!40000 ALTER TABLE `hd_departments` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hd_email_tpl_department_rel`
--
DROP TABLE IF EXISTS `hd_email_tpl_department_rel`;
CREATE TABLE `hd_email_tpl_department_rel` (
  `hd_email_tpl_id` smallint(5) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_email_tpl_id`,`hd_department_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_email_tpls`
--
DROP TABLE IF EXISTS `hd_email_tpls`;
CREATE TABLE `hd_email_tpls` (
  `hd_email_tpl_id` smallint(5) unsigned NOT NULL auto_increment,
  `hd_email_tpl_name` varchar(50) default NULL,
  `hd_email_tpl_subject` varchar(200) default NULL,
  `hd_email_tpl_body` text,
  PRIMARY KEY  (`hd_email_tpl_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_resp_tpl_department_rel`
--
DROP TABLE IF EXISTS `hd_resp_tpl_department_rel`;
CREATE TABLE `hd_resp_tpl_department_rel` (
  `hd_resp_tpl_id` int(8) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_resp_tpl_id`,`hd_department_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_resp_tpls`
--
DROP TABLE IF EXISTS `hd_resp_tpls`;
CREATE TABLE `hd_resp_tpls` (
  `hd_resp_tpl_id` int(8) unsigned NOT NULL auto_increment,
  `hd_resp_tpl_name` varchar(50) default NULL,
  `hd_resp_tpl_body` text,
  `admin_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`hd_resp_tpl_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_attachments`
--
DROP TABLE IF EXISTS `hd_ticket_attachments`;
CREATE TABLE `hd_ticket_attachments` (
  `hd_ticket_id` int(10) unsigned default NULL,
  `hd_ticket_attachment_filename` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`hd_ticket_attachment_filename`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_bucket_rel`
--
DROP TABLE IF EXISTS `hd_ticket_bucket_rel`;
CREATE TABLE `hd_ticket_bucket_rel` (
  `hd_ticket_id` int(10) unsigned NOT NULL default '0',
  `hd_bucket_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_ticket_id`,`hd_bucket_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_contacts`
--
DROP TABLE IF EXISTS `hd_ticket_contacts`;
CREATE TABLE `hd_ticket_contacts` (
  `hd_ticket_contact_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `hd_contact_first_name` varchar(100) default NULL,
  `hd_contact_last_name` varchar(100) default NULL,
  `hd_contact_email` varchar(100) default NULL,
  `hd_contact_company` varchar(100) default NULL,
  `hd_contact_address_1` varchar(100) default NULL,
  `hd_contact_address_2` varchar(100) default NULL,
  `hd_contact_city` varchar(100) default NULL,
  `hd_contact_state` varchar(100) default NULL,
  `hd_contact_zip` varchar(100) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  `hd_contact_phone1` varchar(25) default NULL,
  `hd_contact_phone2` varchar(25) default NULL,
  `hd_contact_fax` varchar(25) default NULL,
  `hd_contact_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_contact_id`),
  KEY `hd_contact_first_name` (`hd_contact_first_name`),
  KEY `hd_contact_last_name` (`hd_contact_last_name`),
  KEY `hd_contact_email` (`hd_contact_email`),
  KEY `language_id` (`language_id`),
  KEY `countries_id` (`countries_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_department_rel`
--
DROP TABLE IF EXISTS `hd_ticket_department_rel`;
CREATE TABLE `hd_ticket_department_rel` (
  `hd_ticket_id` int(10) unsigned NOT NULL default '0',
  `hd_department_id` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`hd_ticket_id`,`hd_department_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_events`
--
DROP TABLE IF EXISTS `hd_ticket_events`;
CREATE TABLE `hd_ticket_events` (
  `hd_ticket_event_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_priority_id` tinyint(3) unsigned default NULL,
  `hd_ticket_status_id` tinyint(3) unsigned default NULL,
  `hd_ticket_event_comment` text,
  PRIMARY KEY  (`hd_ticket_event_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `hd_ticket_priority_id` (`hd_ticket_priority_id`),
  KEY `hd_ticket_status_id` (`hd_ticket_status_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_notes`
--
DROP TABLE IF EXISTS `hd_ticket_notes`;
CREATE TABLE `hd_ticket_notes` (
  `hd_ticket_note_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `admin_id` smallint(5) unsigned default NULL,
  `hd_ticket_note_body` text,
  PRIMARY KEY  (`hd_ticket_note_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_ticket_resps`
--
DROP TABLE IF EXISTS `hd_ticket_resps`;
CREATE TABLE `hd_ticket_resps` (
  `hd_ticket_resp_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_id` int(10) unsigned default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_resp_body` text,
  `hd_ticket_resp_date_created` int(10) unsigned default NULL,
  `hd_ticket_resp_date_modified` int(10) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_resp_id`),
  KEY `hd_ticket_id` (`hd_ticket_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`)
) ENGINE=MyISAM ;

--
-- Table structure for table `hd_tickets`
--
DROP TABLE IF EXISTS `hd_tickets`;
CREATE TABLE `hd_tickets` (
  `hd_ticket_id` int(10) unsigned NOT NULL auto_increment,
  `hd_ticket_key` varchar(11) default NULL,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `hd_ticket_subject` varchar(100) default NULL,
  `hd_ticket_body` text,
  `hd_ticket_date_created` int(10) unsigned default NULL,
  `hd_ticket_date_modified` int(10) unsigned default NULL,
  `hd_ticket_priority_id` tinyint(3) unsigned default NULL,
  `hd_ticket_status_id` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`hd_ticket_id`),
  KEY `hd_ticket_key` (`hd_ticket_key`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `hd_ticket_date_created` (`hd_ticket_date_created`),
  KEY `hd_ticket_priority_id` (`hd_ticket_priority_id`),
  KEY `hd_ticket_status_id` (`hd_ticket_status_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `invalid_ipn_log`
--
DROP TABLE IF EXISTS `invalid_ipn_log`;
CREATE TABLE `invalid_ipn_log` (
  `ipn_id` int(10) NOT NULL auto_increment,
  `ipn_status` int(1) default '0',
  `ipn_reason` varchar(255) default NULL,
  `ipn_module` varchar(30) default NULL,
  `ipn_server` text,
  `ipn_get` text,
  `ipn_post` text,
  `ipn_date_created` int(10) default NULL,
  PRIMARY KEY  (`ipn_id`)
) ENGINE=MyISAM ;


--
-- Table structure for table `invoice_factura`
--
DROP TABLE IF EXISTS `invoice_factura`;
CREATE TABLE `invoice_factura` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `customer_id` int(10) unsigned NOT NULL,
  `date_create` date NOT NULL,
  `monthly` tinyint(1) NOT NULL default '0',
  `currency_id` char(3) NOT NULL,
  `month` int(10) unsigned NULL,
  `year` int(10) unsigned NULL,
	PRIMARY KEY  (`id`),
	KEY `monthly` (`monthly`),
	KEY `customer_id` (`customer_id`),
	CONSTRAINT `invoice_factura_currency_id_fk` FOREIGN KEY (`currency_id`)	REFERENCES `currencies`(`currency_id`) ON DELETE RESTRICT ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Table structure for table `invoice_factura_item`
--
DROP TABLE IF EXISTS `invoice_factura_item`;
CREATE TABLE `invoice_factura_item` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `invoice_factura_id` int(10) unsigned NOT NULL,
  `subscription_id` int(10) unsigned NOT NULL,
  `subscription_addon_id` int(10) unsigned NOT NULL,
  `total_amount` decimal(10,2) NOT NULL default '0.00',
  `tax_rate` decimal(10,2) NOT NULL default '0.00',
	PRIMARY KEY  (`id`),
	KEY `subscription_id` (`subscription_id`),
	CONSTRAINT `invoice_factura_id_fk` FOREIGN KEY (`invoice_factura_id`) REFERENCES `invoice_factura`(`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Table structure for table `invoice_line_items`
--
DROP TABLE IF EXISTS `invoice_line_items`;
CREATE TABLE `invoice_line_items` (
  `line_item_id` int(10) unsigned NOT NULL auto_increment,
  `invoice_id` int(10) unsigned default NULL,
  `package_id` int(10) unsigned default NULL,
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned default NULL,
  `line_item_quantity` smallint(5) unsigned default NULL,
  `line_item_description` varchar(255) default NULL,
  `line_item_date_begin_renewal` int(10) unsigned default NULL,
  `line_item_date_current_renewal` int(10) unsigned default NULL,
  `line_item_date_next_renewal` int(10) unsigned default NULL,
  `line_item_price_amount` decimal(10,2) default '0.00',
  `line_item_discount_amount` decimal(10,2) default '0.00',
  `line_item_discount` decimal(10,2) default '0.00',
  `line_item_setup_amount` decimal(10,2) default '0.00',
  `line_item_tax_amount` decimal(10,2) default '0.00',
  `line_item_taxable_tax_amount` decimal(10,2) default '0.00',
  `line_item_total_amount` decimal(10,2) default '0.00',
  `proration_discount_amount` decimal(10,2) default '0.00',
  `proration_discount` decimal(10,2) default '0.00',
  `proration_duration` int(10) unsigned default NULL,
  `line_item_is_usage` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`line_item_id`),
  KEY `invoice_id` (`invoice_id`),
  KEY `package_id` (`package_id`),
  KEY `cycle_id` (`cycle_id`),
  KEY `line_item_date_begin_renewal` (`line_item_date_begin_renewal`),
  KEY `line_item_date_current_renewal` (`line_item_date_current_renewal`),
  KEY `line_item_date_next_renewal` (`line_item_date_next_renewal`),
  KEY `line_item_price_amount` (`line_item_price_amount`),
  KEY `line_item_setup_amount` (`line_item_setup_amount`),
  KEY `line_item_tax_amount` (`line_item_tax_amount`),
  KEY `line_item_taxable_tax_amount` (`line_item_taxable_tax_amount`),
  KEY `line_item_total_amount` (`line_item_total_amount`),
  KEY `line_item_is_usage` (`line_item_is_usage`)
) ENGINE=MyISAM ;

--
-- Table structure for table `invoice_tax_zone_rel`
--
DROP TABLE IF EXISTS `invoice_tax_zone_rel`;
CREATE TABLE `invoice_tax_zone_rel` (
  `invoice_id` int(10) unsigned NOT NULL default '0',
  `tax_zone_id` smallint(5) unsigned NOT NULL default '0',
  `invoice_tax_amount_type` tinyint(3) unsigned default NULL,
  `invoice_tax_amount` decimal(10,2) default '0.00',
  `invoice_tax_total` decimal(10,2) default '0.00',
  PRIMARY KEY  (`invoice_id`,`tax_zone_id`),
  KEY `invoice_tax_amount_type` (`invoice_tax_amount_type`)
) ENGINE=MyISAM ;

--
-- Table structure for table `invoice_transaction_rel`
--
DROP TABLE IF EXISTS `invoice_transaction_rel`;
CREATE TABLE `invoice_transaction_rel` (
  `invoice_id` int(10) unsigned NOT NULL default '0',
  `transaction_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`invoice_id`,`transaction_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `invoices`
--
DROP TABLE IF EXISTS `invoices`;
CREATE TABLE `invoices` (
  `invoice_id` int(10) unsigned NOT NULL auto_increment,
  `invoice_process_id` varchar(40) default '',
  `invoice_process_date` int(10) unsigned default '0',
  `invoice_number` varchar(15) default NULL,
  `credit_note_for_invoice_id` int(10) unsigned default NULL,
  `client_id` int(10) unsigned default '0',
  `client_contact_id` int(10) unsigned default '0',
  `currency_id` char(3) default NULL,
  `invoice_amount` decimal(10,2) default '0.00',
  `invoice_amount_paid` decimal(10,2) default '0.00',
  `invoice_date_entered` int(10) unsigned default NULL,
  `invoice_date_due` int(10) unsigned default NULL,
  `invoice_date_paid` int(10) unsigned default NULL,
  `invoice_date_pushed` int(10) unsigned default '0',
  `invoice_payment_method` varchar(50) default NULL,
  `invoice_snapshot` longtext,
  `invoice_comments` longtext,
  `invoice_batch_timestamp` int(10) unsigned default NULL,
  `invoice_sub_total` decimal(10,2) default '0.00',
  `invoice_discount` decimal(10,2) default '0.00',
  `invoice_status` tinyint(3) unsigned default NULL,
  `order_form_id` smallint(5) unsigned,
  PRIMARY KEY  (`invoice_id`),
  KEY `invoice_process_id` (`invoice_process_id`),
  KEY `invoice_process_date` (`invoice_process_date`),
  KEY `order_form_id` (`order_form_id`),
  KEY `invoice_status` (`invoice_status`),
  KEY `invoice_date_due` (`invoice_date_due`),
  KEY `invoice_date_pushed` (`invoice_date_pushed`),
  KEY `invoice_amount` (`invoice_amount`),
  KEY `invoice_amount_paid` (`invoice_amount_paid`),
  KEY `invoice_date_entered` (`invoice_date_entered`),
  KEY `invoice_payment_method` (`invoice_payment_method`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `invoicing_groups`
--
DROP TABLE IF EXISTS `invoicing_groups`;
CREATE TABLE `invoicing_groups` (
  `invoicing_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `invoicing_group_name` varchar(50) default NULL,
  PRIMARY KEY  (`invoicing_group_id`),
  KEY `invoicing_group_name` (`invoicing_group_name`)
) ENGINE=MyISAM ;

--
-- Table structure for table `ip_log`
--
DROP TABLE IF EXISTS `ip_log`;
CREATE TABLE `ip_log` (
  `ip_log_id` int(10) unsigned NOT NULL auto_increment,
  `ip` VARCHAR(39) NOT NULL,
  `external_id` varchar(50) default NULL,
  `config_group_id` int(8) unsigned default NULL,
  `ip_version` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`ip_log_id`),
  KEY `external_id` (`external_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `ip_version` (`ip_version`)
) ENGINE=MyISAM ;

--
-- Table structure for table `languages`
--
DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `language_id` smallint(5) unsigned NOT NULL auto_increment,
  `language_iso2` varchar(7) default NULL,
  `language_iso3` varchar(6) default NULL,
  `language_name` varchar(120) default NULL,
  `language_c1` tinyint(3) unsigned default NULL,
  `language_c2` varchar(25) default NULL,
  PRIMARY KEY  (`language_id`),
  KEY `language_iso2` (`language_iso2`),
  KEY `language_iso3` (`language_iso3`)
) ENGINE=MyISAM AUTO_INCREMENT=132 ;

--
-- Dumping data for table `languages`
--
LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
INSERT INTO `languages` VALUES (1,'aa','aar','Qafar',NULL,NULL);
INSERT INTO `languages` VALUES (2,'af','afr','Afrikaans',1,NULL);
INSERT INTO `languages` VALUES (3,'am','amh','áŠ áˆ›áˆ­áŠ›',NULL,NULL);
INSERT INTO `languages` VALUES (4,'ar','ara','â€ŽØ§Ù„Ø¹Ø±Ø¨ÙŠØ©â€Ž',1,NULL);
INSERT INTO `languages` VALUES (5,'as','asm','à¦…à¦¸à¦®à¦¿à§Ÿà¦¾',1,NULL);
INSERT INTO `languages` VALUES (6,'az_Cyrl','aze','ÐÐ·Ó™Ñ€Ð±Ð°Ñ˜Ò¹Ð°Ð½ - Cyrl',1,NULL);
INSERT INTO `languages` VALUES (7,'az_Latn','aze','azÉ™rbaycanca - Latn',1,NULL);
INSERT INTO `languages` VALUES (8,'be','bel','Ð‘ÐµÐ»Ð°Ñ€ÑƒÑÐºÑ–',1,NULL);
INSERT INTO `languages` VALUES (9,'bg','bul','Ð‘ÑŠÐ»Ð³Ð°Ñ€ÑÐºÐ¸',1,NULL);
INSERT INTO `languages` VALUES (10,'bn','ben','à¦¬à¦¾à¦‚à¦²à¦¾',1,NULL);
INSERT INTO `languages` VALUES (11,'bs','bos','Bosanski',1,NULL);
INSERT INTO `languages` VALUES (12,'byn','byn','á‰¥áˆŠáŠ•',NULL,NULL);
INSERT INTO `languages` VALUES (13,'ca','cat','catalÃ ',1,NULL);
INSERT INTO `languages` VALUES (14,'cs','cze','ÄŒeÅ¡tina',NULL,NULL);
INSERT INTO `languages` VALUES (15,'cy','wel','Cymraeg',1,NULL);
INSERT INTO `languages` VALUES (16,'da','dan','Dansk',1,NULL);
INSERT INTO `languages` VALUES (17,'de','ger','Deutsch',1,NULL);
INSERT INTO `languages` VALUES (18,'dv','div','â€ŽÞ‹Þ¨ÞˆÞ¬Þ€Þ¨Þ„Þ¦ÞÞ°â€Ž',1,NULL);
INSERT INTO `languages` VALUES (19,'dz','dzo','à½¢à¾«à½¼à½„à¼‹à½',NULL,NULL);
INSERT INTO `languages` VALUES (20,'el','gre','Î•Î»Î»Î·Î½Î¹ÎºÎ¬',1,NULL);
INSERT INTO `languages` VALUES (21,'en','eng','English',1,NULL);
INSERT INTO `languages` VALUES (22,'eo','epo','Esperanto',NULL,NULL);
INSERT INTO `languages` VALUES (23,'es','spa','espaÃ±ol',1,NULL);
INSERT INTO `languages` VALUES (24,'et','est','Eesti',1,NULL);
INSERT INTO `languages` VALUES (25,'eu','baq','euskara',1,NULL);
INSERT INTO `languages` VALUES (26,'fa','per','â€ŽÙØ§Ø±Ø³ÛŒâ€Ž',1,NULL);
INSERT INTO `languages` VALUES (27,'fi','fin','suomi',1,NULL);
INSERT INTO `languages` VALUES (28,'fo','fao','fÃ¸royskt',1,NULL);
INSERT INTO `languages` VALUES (29,'fr','fre','franÃ§ais',1,NULL);
INSERT INTO `languages` VALUES (30,'ga','gla','Gaeilge',1,NULL);
INSERT INTO `languages` VALUES (31,'gez','gez','áŒá‹•á‹áŠ›',NULL,NULL);
INSERT INTO `languages` VALUES (32,'gl','glg','galego',NULL,NULL);
INSERT INTO `languages` VALUES (33,'gu','guj','àª—à«àªœàª°àª¾àª¤à«€',1,NULL);
INSERT INTO `languages` VALUES (34,'gv','glv','Gaelg',NULL,NULL);
INSERT INTO `languages` VALUES (35,'haw','haw','Ê»Ålelo HawaiÊ»i',NULL,NULL);
INSERT INTO `languages` VALUES (36,'he','heb','â€Ž×¢×‘×¨×™×ªâ€Ž',1,NULL);
INSERT INTO `languages` VALUES (37,'hi','hin','à¤¹à¤¿à¤‚à¤¦à¥€',1,NULL);
INSERT INTO `languages` VALUES (38,'hr','scr','hrvatski',1,NULL);
INSERT INTO `languages` VALUES (39,'hu','hun','magyar',1,NULL);
INSERT INTO `languages` VALUES (40,'hy','arm','Õ€Õ¡ÕµÕ¥Ö€Õ§Õ¶',1,NULL);
INSERT INTO `languages` VALUES (41,'id','ind','Bahasa Indonesia',1,NULL);
INSERT INTO `languages` VALUES (42,'is','ice','Ãslenska',1,NULL);
INSERT INTO `languages` VALUES (43,'it','ita','italiano',1,NULL);
INSERT INTO `languages` VALUES (44,'iu','ike','áƒá“„á’ƒá‘Žá‘á‘¦ á‘Žá‘Žá•‹á…á“¯á–…',NULL,NULL);
INSERT INTO `languages` VALUES (45,'ja','jpn','æ—¥æœ¬èªž',1,NULL);
INSERT INTO `languages` VALUES (46,'ka','geo','áƒ¥áƒáƒ áƒ—áƒ£áƒšáƒ˜',1,NULL);
INSERT INTO `languages` VALUES (47,'kk','kaz','ÒšÐ°Ð·Ð°Ò›',1,NULL);
INSERT INTO `languages` VALUES (48,'kl','kal','Kalaallisut',NULL,NULL);
INSERT INTO `languages` VALUES (49,'km','khm','áž—áž¶ážŸáž¶ážáŸ’áž˜áŸ‚ážš',1,NULL);
INSERT INTO `languages` VALUES (50,'kn','kan','à²•à²¨à³à²¨à²¡',NULL,NULL);
INSERT INTO `languages` VALUES (51,'ko','kor','í•œêµ­ì–´',1,NULL);
INSERT INTO `languages` VALUES (52,'kok','knn','à¤•à¥‹à¤‚à¤•à¤£à¥€',NULL,NULL);
INSERT INTO `languages` VALUES (53,'kw','cor','kernewek',NULL,NULL);
INSERT INTO `languages` VALUES (54,'ky','kir','ÐšÑ‹Ñ€Ð³Ñ‹Ð·',1,NULL);
INSERT INTO `languages` VALUES (55,'lo','lao','àº¥àº²àº§',1,NULL);
INSERT INTO `languages` VALUES (56,'lt','lit','LietuviÅ³',1,NULL);
INSERT INTO `languages` VALUES (57,'lv','lav','latvieÅ¡u',1,NULL);
INSERT INTO `languages` VALUES (58,'mk','mac','Ð¼Ð°ÐºÐµÐ´Ð¾Ð½ÑÐºÐ¸',1,NULL);
INSERT INTO `languages` VALUES (59,'ml','mal','à´®à´²à´¯à´¾à´³à´‚',1,NULL);
INSERT INTO `languages` VALUES (60,'mn','mon','ÐœÐ¾Ð½Ð³Ð¾Ð» Ñ…ÑÐ»',1,NULL);
INSERT INTO `languages` VALUES (61,'mr','mar','à¤®à¤°à¤¾à¤ à¥€',NULL,NULL);
INSERT INTO `languages` VALUES (62,'ms','may','Bahasa Melayu',1,NULL);
INSERT INTO `languages` VALUES (63,'mt','mlt','Malti',1,NULL);
INSERT INTO `languages` VALUES (64,'nb','nor','norsk bokmÃ¥l',1,NULL);
INSERT INTO `languages` VALUES (65,'nl','dut','Nederlands',1,NULL);
INSERT INTO `languages` VALUES (66,'nn','nor','norsk nynorsk',1,NULL);
INSERT INTO `languages` VALUES (67,'om','orm','Oromoo',NULL,NULL);
INSERT INTO `languages` VALUES (68,'or','ori','à¬“à­œà¬¿à¬†',1,NULL);
INSERT INTO `languages` VALUES (69,'pa','pan','à¨ªà©°à¨œà¨¾à¨¬à©€',1,NULL);
INSERT INTO `languages` VALUES (70,'pl','pol','polski',1,NULL);
INSERT INTO `languages` VALUES (71,'ps','pus','â€ŽÙ¾ÚšØªÙˆâ€Ž',NULL,NULL);
INSERT INTO `languages` VALUES (72,'pt','por','portuguÃªs',1,NULL);
INSERT INTO `languages` VALUES (73,'ro','rum','RomÃ¢nÄƒ',1,NULL);
INSERT INTO `languages` VALUES (74,'ru','rus','Ñ€ÑƒÑÑÐºÐ¸Ð¹',1,NULL);
INSERT INTO `languages` VALUES (75,'sa','san','à¤¸à¤‚à¤¸à¥à¤•à¥ƒà¤¤',1,NULL);
INSERT INTO `languages` VALUES (76,'sid','sid','Sidaamu Afo',NULL,NULL);
INSERT INTO `languages` VALUES (77,'sk','slo','slovenskÃ½',1,NULL);
INSERT INTO `languages` VALUES (78,'sl','slv','SlovenÅ¡Äina',1,NULL);
INSERT INTO `languages` VALUES (79,'so','som','Soomaali',1,NULL);
INSERT INTO `languages` VALUES (80,'sq','alb','shqipe',1,NULL);
INSERT INTO `languages` VALUES (81,'sr_Cyrl','scc','Ð¡Ñ€Ð¿ÑÐºÐ¸ - Ð‹Ð¸Ñ€Ð¸Ð»Ð¸Ñ†Ð°',1,NULL);
INSERT INTO `languages` VALUES (82,'sr_Latn','scc','Srpski - Latinica',1,NULL);
INSERT INTO `languages` VALUES (83,'sv','swe','svenska',1,NULL);
INSERT INTO `languages` VALUES (84,'sw','swa','Kiswahili',1,NULL);
INSERT INTO `languages` VALUES (85,'syr','syr','â€ŽÜ£Ü˜ÜªÜÜÜâ€Ž',1,NULL);
INSERT INTO `languages` VALUES (86,'ta','tam','à®¤à®®à®¿à®´à¯',1,NULL);
INSERT INTO `languages` VALUES (87,'te','tel','à°¤à±†à°²à±à°—à±',1,NULL);
INSERT INTO `languages` VALUES (88,'th','tha','à¹„à¸—à¸¢',1,NULL);
INSERT INTO `languages` VALUES (89,'ti','tir','á‰µáŒáˆ­áŠ›',NULL,NULL);
INSERT INTO `languages` VALUES (90,'tig','tig','á‰µáŒáˆ¨',NULL,NULL);
INSERT INTO `languages` VALUES (91,'tr','tur','TÃ¼rkÃ§e',1,NULL);
INSERT INTO `languages` VALUES (92,'tt','tat','Ð¢Ð°Ñ‚Ð°Ñ€',NULL,NULL);
INSERT INTO `languages` VALUES (93,'uk','ukr','Ð£ÐºÑ€Ð°Ñ—Ð½ÑÑŒÐºÐ°',1,NULL);
INSERT INTO `languages` VALUES (94,'ur','urd','â€ŽØ§Ø±Ø¯Ùˆâ€Ž',1,NULL);
INSERT INTO `languages` VALUES (95,'uz_Arab','uzb','â€ŽØ§Û‰Ø²Ø¨ÛÚ© - ÐÑ€Ð°Ð±â€Ž',1,NULL);
INSERT INTO `languages` VALUES (96,'uz_Cyrl','uzb','ÐŽÐ·Ð±ÐµÐº - ÐšÐ¸Ñ€Ð¸Ð»',1,NULL);
INSERT INTO `languages` VALUES (97,'uz_Latn','uzb','oÊ¿zbek - Lotin',1,NULL);
INSERT INTO `languages` VALUES (98,'vi','vie','Tiáº¿ng Viá»‡t',1,NULL);
INSERT INTO `languages` VALUES (99,'wal','wal','á‹ˆáˆ‹á‹­á‰³á‰±',NULL,NULL);
INSERT INTO `languages` VALUES (100,'zh_Hans','chi','ä¸­æ–‡ - ç®€ä½“æ±‰è¯­',1,NULL);
INSERT INTO `languages` VALUES (101,'zh_Hant','chi','ä¸­æ–‡ - ç¹é«”æ¼¢èªž',1,NULL);
INSERT INTO `languages` VALUES (102,'ak','aka','Akan',NULL,NULL);
INSERT INTO `languages` VALUES (103,'ee','ewe','Ewe',NULL,NULL);
INSERT INTO `languages` VALUES (104,'fur','fur','furlan',NULL,NULL);
INSERT INTO `languages` VALUES (105,'gaa','gaa','Ga',NULL,NULL);
INSERT INTO `languages` VALUES (106,'ha_Arab','hau','Ù‡ÙŽÙˆÙØ³ÙŽ - Arab',NULL,NULL);
INSERT INTO `languages` VALUES (107,'ha_Latn','hau','Hausa - Latn',NULL,NULL);
INSERT INTO `languages` VALUES (108,'ig','ibo','Igbo',NULL,NULL);
INSERT INTO `languages` VALUES (109,'ia','ina','Interlingua',NULL,NULL);
INSERT INTO `languages` VALUES (110,'kam','kam','Kamba',NULL,NULL);
INSERT INTO `languages` VALUES (111,'rw','kin','Kinyarwanda',NULL,NULL);
INSERT INTO `languages` VALUES (112,'ku_Arab','kur','Ú©ÙˆØ±Ø¯ÛŒ - Arab',NULL,NULL);
INSERT INTO `languages` VALUES (113,'ku_Latn','kur','kurdÃ® - Latn',NULL,NULL);
INSERT INTO `languages` VALUES (114,'ln','lin','lingÃ¡la',NULL,NULL);
INSERT INTO `languages` VALUES (115,'ne','nep','à¤¨à¥‡à¤ªà¤¾à¤²à¥€',NULL,NULL);
INSERT INTO `languages` VALUES (116,'se','sme','davvisÃ¡megiella',NULL,NULL);
INSERT INTO `languages` VALUES (117,'nso','nso','Sesotho sa Leboa',NULL,NULL);
INSERT INTO `languages` VALUES (118,'ny','nya','Nyanja',NULL,NULL);
INSERT INTO `languages` VALUES (119,'pa_Arab','pan','Ù¾Ù†Ø¬Ø§Ø¨ÛŒ - Ú¯ÙØ±Ù…ÙÚ©Ú¾ÛŒ',NULL,NULL);
INSERT INTO `languages` VALUES (120,'pa_Guru','pan','à¨ªà©°à¨œà¨¾à¨¬à©€ - à¨—à©à¨°à¨®à©à¨–à©€',NULL,NULL);
INSERT INTO `languages` VALUES (121,'nr','nbl','Nrebele',NULL,NULL);
INSERT INTO `languages` VALUES (122,'st','sot','Sesotho',NULL,NULL);
INSERT INTO `languages` VALUES (123,'ss','ssw','Swati',NULL,NULL);
INSERT INTO `languages` VALUES (124,'tg','tgk','Ñ‚Ð¾Ò·Ð¸ÐºÓ£',NULL,NULL);
INSERT INTO `languages` VALUES (125,'ts','tso','XiTsonga',NULL,NULL);
INSERT INTO `languages` VALUES (126,'tn','tsn','Setswana',NULL,NULL);
INSERT INTO `languages` VALUES (127,'ve','ven','Tshivenda',NULL,NULL);
INSERT INTO `languages` VALUES (128,'xh','xho','isiXhosa',NULL,NULL);
INSERT INTO `languages` VALUES (129,'yo','yor','ede YorÃ¹bÃ¡',NULL,NULL);
INSERT INTO `languages` VALUES (130,'zu','zul','isiZulu',NULL,NULL);
INSERT INTO `languages` VALUES (131,'pt_BR','por','português do Brasil',1,NULL);
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `line_items_tax_zone_rel`
--
DROP TABLE IF EXISTS `line_items_tax_zone_rel`;
CREATE TABLE `line_items_tax_zone_rel` (
  `line_item_id` int(10) unsigned NOT NULL default '0',
  `tax_zone_id` smallint(5) unsigned NOT NULL default '0',
  `line_item_tax_amount_type` tinyint(3) unsigned default NULL,
  `line_item_tax_amount` decimal(10,2) default '0.00',
  `line_item_tax_total` decimal(10,2) default '0.00',
  PRIMARY KEY  (`line_item_id`,`tax_zone_id`),
  KEY `line_item_tax_amount_type` (`line_item_tax_amount_type`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `list_params`;
CREATE TABLE `list_params` (
	`id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`user_id` INT(10) UNSIGNED NOT NULL,
	`user_type` INT(10) UNSIGNED NOT NULL,
	`list_name` VARCHAR(255) NOT NULL,
	`filter` TEXT,
	`sort` VARCHAR(255),
	`reverse` TINYINT(1) NOT NULL DEFAULT 0,
	`page_num` INT,
	`page_size` INT,
	UNIQUE KEY (`user_id`, `user_type`, `list_name`)
) ENGINE=InnoDB ;

--
-- Table structure for table `locales`
--
DROP TABLE IF EXISTS `locales`;
CREATE TABLE `locales` (
  `locale_id` smallint(5) unsigned NOT NULL auto_increment,
  `locale_language` varchar(7) default NULL,
  `locale_country_iso_2` varchar(2) default NULL,
  `locale_currency_code` varchar(3) default NULL,
  `locale_currency_symbol` varchar(36) default NULL,
  `locale_currency_rounding` varchar(2) default NULL,
  `locale_currency_digits` varchar(2) default NULL,
  `locale_separator_decimal` varchar(6) default NULL,
  `locale_separator_grouping` varchar(10) default NULL,
  `locale_pattern_decimal` varchar(50) default NULL,
  `locale_pattern_currency` varchar(75) default NULL,
  `locale_sign_percent` varchar(75) default NULL,
  `locale_sign_minus` varchar(10) default NULL,
  `locale_time_full` varchar(200) default NULL,
  `locale_time_long` varchar(200) default NULL,
  `locale_time_medium` varchar(100) default NULL,
  `locale_time_short` varchar(125) default NULL,
  `locale_date_full` varchar(200) default NULL,
  `locale_date_long` varchar(200) default NULL,
  `locale_date_medium` varchar(200) default NULL,
  `locale_date_short` varchar(150) default NULL,
  `locale_datetime_pattern` varchar(30) default NULL,
  `locale_datetime_am` varchar(125) default NULL,
  `locale_datetime_pm` varchar(125) default NULL,
  `locale_week_firstday` varchar(3) default NULL,
  `locale_week_weekend_start` varchar(3) default NULL,
  `locale_week_weekend_end` varchar(3) default NULL,
  `locale_month_abbreviated_1` varchar(100) default NULL,
  `locale_month_abbreviated_2` varchar(100) default NULL,
  `locale_month_abbreviated_3` varchar(100) default NULL,
  `locale_month_abbreviated_4` varchar(100) default NULL,
  `locale_month_abbreviated_5` varchar(100) default NULL,
  `locale_month_abbreviated_6` varchar(100) default NULL,
  `locale_month_abbreviated_7` varchar(100) default NULL,
  `locale_month_abbreviated_8` varchar(100) default NULL,
  `locale_month_abbreviated_9` varchar(100) default NULL,
  `locale_month_abbreviated_10` varchar(100) default NULL,
  `locale_month_abbreviated_11` varchar(100) default NULL,
  `locale_month_abbreviated_12` varchar(100) default NULL,
  `locale_month_narrow_1` varchar(20) default NULL,
  `locale_month_narrow_2` varchar(20) default NULL,
  `locale_month_narrow_3` varchar(20) default NULL,
  `locale_month_narrow_4` varchar(20) default NULL,
  `locale_month_narrow_5` varchar(20) default NULL,
  `locale_month_narrow_6` varchar(20) default NULL,
  `locale_month_narrow_7` varchar(20) default NULL,
  `locale_month_narrow_8` varchar(20) default NULL,
  `locale_month_narrow_9` varchar(20) default NULL,
  `locale_month_narrow_10` varchar(20) default NULL,
  `locale_month_narrow_11` varchar(20) default NULL,
  `locale_month_narrow_12` varchar(20) default NULL,
  `locale_month_wide_1` varchar(150) default NULL,
  `locale_month_wide_2` varchar(150) default NULL,
  `locale_month_wide_3` varchar(150) default NULL,
  `locale_month_wide_4` varchar(150) default NULL,
  `locale_month_wide_5` varchar(150) default NULL,
  `locale_month_wide_6` varchar(150) default NULL,
  `locale_month_wide_7` varchar(150) default NULL,
  `locale_month_wide_8` varchar(153) default NULL,
  `locale_month_wide_9` varchar(150) default NULL,
  `locale_month_wide_10` varchar(150) default NULL,
  `locale_month_wide_11` varchar(180) default NULL,
  `locale_month_wide_12` varchar(180) default NULL,
  `locale_day_abbreviated_sun` varchar(110) default NULL,
  `locale_day_abbreviated_mon` varchar(110) default NULL,
  `locale_day_abbreviated_tue` varchar(110) default NULL,
  `locale_day_abbreviated_wed` varchar(110) default NULL,
  `locale_day_abbreviated_thu` varchar(110) default NULL,
  `locale_day_abbreviated_fri` varchar(110) default NULL,
  `locale_day_abbreviated_sat` varchar(110) default NULL,
  `locale_day_wide_sun` varchar(150) default NULL,
  `locale_day_wide_mon` varchar(150) default NULL,
  `locale_day_wide_tue` varchar(150) default NULL,
  `locale_day_wide_wed` varchar(150) default NULL,
  `locale_day_wide_thu` varchar(150) default NULL,
  `locale_day_wide_fri` varchar(150) default NULL,
  `locale_day_wide_sat` varchar(150) default NULL,
  PRIMARY KEY  (`locale_id`),
  KEY `locale_country_iso_2` (`locale_country_iso_2`),
  KEY `locale_language` (`locale_language`),
  KEY `locale_currency_code` (`locale_currency_code`)
) ENGINE=MyISAM AUTO_INCREMENT=382 ;

--
-- Dumping data for table `locales`
--
LOCK TABLES `locales` WRITE;
/*!40000 ALTER TABLE `locales` DISABLE KEYS */;
INSERT INTO `locales` VALUES (1,'aa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'saaku','carra',NULL,NULL,NULL,'Qun','Nah','Cig','Agd','Cax','Qas','Qad','Leq','Way','Dit','Xim','Kax',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Qunxa Garablu','Naharsi Kudo','Ciggilta Kudo','Agda Baxisso','Caxah Alsa','Qasa Dirri','Qado Dirri','Leqeeni','Waysu','Diteli','Ximoli','Kaxxa Garablu','Aca','Etl','Tal','Arb','Kam','Gum','Sab','Acaada','Etleeni','Talaata','Arbaqa','Kamiisi','Gumqata','Sabti');
INSERT INTO `locales` VALUES (2,'aa','DJ','DJF','FD','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (3,'aa','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Kudo',NULL,'Agda Baxis',NULL,NULL,NULL,'Liiqen',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (4,'aa','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Kudo',NULL,'Agda Baxis',NULL,NULL,NULL,'Liiqen',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (5,'af',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','yyyy-MM-dd',NULL,'vm.','nm.',NULL,NULL,NULL,'Jan.','Feb.','Mrt.','Apr.','Mei','Jun.','Jul.','Aug.','Sep.','Okt.','Nov.','Des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januarie','Februarie','Maart','April','Mei','Junie','Julie','Augustus','September','Oktober','November','Desember','So.','Ma.','Di.','Wo.','Do.','Vr.','Sa.','Sondag','Maandag','Dinsdag','Woensdag','Donderdag','Vrydag','Saterdag');
INSERT INTO `locales` VALUES (6,'af','NA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (7,'af','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','yyyy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (8,'ak',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'AN','EW',NULL,NULL,NULL,'S-Æ†','K-Æ†','E-Æ†','E-O','E-K','O-A','A-K','D-Æ†','F-Æ','Æ†-A','Æ†-O','M-Æ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sanda-Æ†pÉ›pÉ”n','Kwakwar-Æ†gyefuo','EbÉ”w-Æ†benem','EbÉ”bira-Oforisuo','Esusow Aketseaba-KÉ”tÉ”nimba','Obirade-AyÉ›wohomumu','AyÉ›woho-Kitawonsa','Difuu-Æ†sandaa','Fankwa-ÆbÉ”','Æ†bÉ›sÉ›-Ahinime','Æ†berÉ›fÉ›w-Obubuo','Mumu-Æ†pÉ›nimba','Kwe','Dwo','Ben','Wuk','Yaw','Fia','Mem','Kwesida','Dwowda','Benada','Wukuda','Yawda','Fida','Memeneda');
INSERT INTO `locales` VALUES (9,'ak','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (10,'am',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'hh:mm:ss a','hh:mm:ss a','h:mm:ss a','h:mm a','EEEEá£ MMMM dd á‰€áŠ• yyyy G','MMMM d yyyy','MMM d yyyy','dd/MM/yy',NULL,'áŒ¡á‹‹á‰µ','áŠ¨áˆ°á‹“á‰µ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áŠ¥áˆ‘á‹µ','áˆ°áŠž','áˆ›áŠ­áˆ°','áˆ¨á‰¡á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰¥','á‰…á‹³áˆœ','áŠ¥áˆ‘á‹µ','áˆ°áŠž','áˆ›áŠ­áˆ°áŠž','áˆ¨á‰¡á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰¥','á‰…á‹³áˆœ');
INSERT INTO `locales` VALUES (11,'am','ET','ETB','á‰¥áˆ­',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEEá£ dd MMMM á‰€áŠ• yyyy G','dd MMMM yyyy','dd-MMM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (12,'ar',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬','#,##0.###;#,##0.###-','Â¤ #,##0.00;Â¤ #,##0.00-','Ùª',NULL,'z h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, d MMMM, yyyy','d MMMM, yyyy','dd/MM/yyyy','d/M/yyyy',NULL,'Øµ','Ù…',NULL,NULL,NULL,'ÙŠÙ†Ø§ÙŠØ±','ÙØ¨Ø±Ø§ÙŠØ±','Ù…Ø§Ø±Ø³','Ø£Ø¨Ø±ÙŠÙ„','Ù…Ø§ÙŠÙˆ','ÙŠÙˆÙ†ÙŠÙˆ','ÙŠÙˆÙ„ÙŠÙˆ','Ø£ØºØ³Ø·Ø³','Ø³Ø¨ØªÙ…Ø¨Ø±','Ø£ÙƒØªÙˆØ¨Ø±','Ù†ÙˆÙÙ…Ø¨Ø±','Ø¯ÙŠØ³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙŠÙ†Ø§ÙŠØ±','ÙØ¨Ø±Ø§ÙŠØ±','Ù…Ø§Ø±Ø³','Ø£Ø¨Ø±ÙŠÙ„','Ù…Ø§ÙŠÙˆ','ÙŠÙˆÙ†ÙŠÙˆ','ÙŠÙˆÙ„ÙŠÙˆ','Ø£ØºØ³Ø·Ø³','Ø³Ø¨ØªÙ…Ø¨Ø±','Ø£ÙƒØªÙˆØ¨Ø±','Ù†ÙˆÙÙ…Ø¨Ø±','Ø¯ÙŠØ³Ù…Ø¨Ø±','Ø­','Ù†','Ø«','Ø±','Ø®','Ø¬','Ø³','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª');
INSERT INTO `locales` VALUES (13,'ar','AE','AED','Ø¯.Ø¥.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (14,'ar','BH','BHD','Ø¯.Ø¨.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (15,'ar','DZ','DZD','Ø¯.Ø¬.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (16,'ar','EG','EGP','Ø¬.Ù….â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (17,'ar','IQ','IQD','Ø¯.Ø¹.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (18,'ar','JO','JOD','Ø¯.Ø£.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ø£ÙŠØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ø£ÙŠØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (19,'ar','KW','KWD','Ø¯.Ùƒ.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (20,'ar','LB','LBP','Ù„.Ù„.â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (21,'ar','LY','LYD','Ø¯.Ù„.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (22,'ar','MA','MAD','Ø¯.Ù….â€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (23,'ar','OM','OMR','Ø±.Ø¹.â€','0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (24,'ar','QA','QAR','Ø±.Ù‚.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (25,'ar','SA','SAR','Ø±.Ø³.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (26,'ar','SD','SDD','.â€Ø¯.Ø³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (27,'ar','SY','SYP','Ù„.Ø³.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','Ø´Ø¨Ø§Ø·','Ø¢Ø°Ø§Ø±','Ù†ÙŠØ³Ø§Ù†','Ù†ÙˆØ§Ø±','Ø­Ø²ÙŠØ±Ø§Ù†','ØªÙ…ÙˆØ²','Ø¢Ø¨','Ø£ÙŠÙ„ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø£ÙˆÙ„','ØªØ´Ø±ÙŠÙ† Ø§Ù„Ø«Ø§Ù†ÙŠ','ÙƒØ§Ù†ÙˆÙ† Ø§Ù„Ø£ÙˆÙ„','Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (28,'ar','TN','TND','Ø¯.Øª.â€','0','3',NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (29,'ar','YE','YER','Ø±.ÙŠ.â€',NULL,NULL,NULL,NULL,'#0.###;#0.###-','Â¤#0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§Ù„Ø£Ø­Ø¯','Ø§Ù„Ø§Ø«Ù†ÙŠÙ†','Ø§Ù„Ø«Ù„Ø§Ø«Ø§Ø¡','Ø§Ù„Ø£Ø±Ø¨Ø¹Ø§Ø¡','Ø§Ù„Ø®Ù…ÙŠØ³','Ø§Ù„Ø¬Ù…Ø¹Ø©','Ø§Ù„Ø³Ø¨Øª',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (30,'as',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦ªà§‚à§°à§à¦¬à¦¾','à¦…à¦ª',NULL,NULL,NULL,'à¦œà¦¾à¦¨à§','à¦«à§‡à¦¬à§à§°à§','à¦®à¦¾à§°à§à¦š','à¦à¦ªà§à§°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—','à¦¸à§‡à¦ªà§à¦Ÿ','à¦…à¦•à§à¦Ÿà§‹','à¦¨à¦­à§‡','à¦¡à¦¿à¦¸à§‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à§°à§€','à¦«à§‡à¦¬à§à§°à§à¦¯à¦¼à¦¾à§°à§€','à¦®à¦¾à§°à§à¦š','à¦à¦ªà§à§°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦·à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à§°','à¦…à¦•à§à¦Ÿà§‹à¦¬à§°','à¦¨à¦­à§‡à¦®à§à¦¬à§°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à§°','à§°à¦¬à¦¿','à¦¸à§‹à¦®','à¦®à¦™à§à¦—à¦²','à¦¬à§à¦§','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿','à¦¶à§à¦•à§à§°','à¦¶à¦¨à¦¿','à¦¦à§‡à¦“à¦¬à¦¾à§°','à¦¸à§‹à¦®à¦¬à¦¾à§°','à¦®à¦™à§à¦—à¦²à¦¬à¦¾à§°','à¦¬à§à¦§à¦¬à¦¾à§°','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿à¦¬à¦¾à§°','à¦¶à§à¦•à§à§°à¦¬à¦¾à§°','à¦¶à¦¨à¦¿à¦¬à¦¾à§°');
INSERT INTO `locales` VALUES (31,'as','IN','INR','à¦Ÿà¦•à¦¾',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h.mm.ss a z','h.mm.ss a z','h.mm.ss a','h.mm. a','EEEE, d MMMM, yyyy','d MMMM, yyyy','dd-MM-yyyy','d-M-yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (32,'az',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yan','fev','mar','apr','may','iyn','iyl','avq','sen','okt','noy','dek',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Yanvar','Fevral','Mart','Aprel','May','Ä°yun','Ä°yul','Avqust','Sentyabr','Oktyabr','Noyabr','Dekabr','B.','B.e.','Ã‡.a.','Ã‡.','C.a.','C.','Åž.','bazar','bazar ertÉ™si','Ã§É™rÅŸÉ™nbÉ™ axÅŸam','Ã§É™rÅŸÉ™nbÉ™','cÃ¼mÉ™ axÅŸamÄ±','cÃ¼mÉ™ axÅŸamÄ±','ÅŸÉ™nbÉ™');
INSERT INTO `locales` VALUES (33,'az_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½Ð²Ð°Ñ€','Ñ„ÐµÐ²Ñ€Ð°Ð»','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€ÐµÐ»','Ð¼Ð°Ð¹','Ð¸Ñ˜ÑƒÐ½','Ð¸Ñ˜ÑƒÐ»','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ½Ñ‚Ñ˜Ð°Ð±Ñ€','Ð¾ÐºÑ‚Ñ˜Ð°Ð±Ñ€','Ð½Ð¾Ñ˜Ð°Ð±Ñ€','Ð´ÐµÐºÐ°Ð±Ñ€',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð±Ð°Ð·Ð°Ñ€','Ð±Ð°Ð·Ð°Ñ€ ÐµÑ€Ñ‚Ó™ÑÐ¸','Ñ‡Ó™Ñ€ÑˆÓ™Ð½Ð±Ó™ Ð°Ñ…ÑˆÐ°Ð¼Ñ‹','Ñ‡Ó™Ñ€ÑˆÓ™Ð½Ð±Ó™','Ò¹Ò¯Ð¼Ó™ Ð°Ñ…ÑˆÐ°Ð¼Ñ‹','Ò¹Ò¯Ð¼Ó™','ÑˆÓ™Ð½Ð±Ó™');
INSERT INTO `locales` VALUES (34,'az_Cyrl','AZ','AZN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (35,'az_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (36,'az_Latn','AZ','AZN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (37,'be',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE, d MMMM yyyy','d MMMM yyyy','d.M.yyyy','d.M.yy',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ‚Ñƒ','Ð»ÑŽÑ‚','ÑÐ°Ðº','ÐºÑ€Ð°','Ð¼Ð°Ð¹','Ñ‡ÑÑ€','Ð»Ñ–Ð¿','Ð¶Ð½Ñ–','Ð²ÐµÑ€','ÐºÐ°Ñ','Ð»Ñ–Ñ','ÑÐ½Ðµ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ‚ÑƒÐ´Ð·ÐµÐ½ÑŒ','Ð»ÑŽÑ‚Ñ‹','ÑÐ°ÐºÐ°Ð²Ñ–Ðº','ÐºÑ€Ð°ÑÐ°Ð²Ñ–Ðº','Ð¼Ð°Ð¹','Ñ‡ÑÑ€Ð²ÐµÐ½ÑŒ','Ð»Ñ–Ð¿ÐµÐ½ÑŒ','Ð¶Ð½Ñ–Ð²ÐµÐ½ÑŒ','Ð²ÐµÑ€Ð°ÑÐµÐ½ÑŒ','ÐºÐ°ÑÑ‚Ñ€Ñ‹Ñ‡Ð½Ñ–Ðº','Ð»Ñ–ÑÑ‚Ð°Ð¿Ð°Ð´','ÑÐ½ÐµÐ¶Ð°Ð½ÑŒ','Ð½Ð´','Ð¿Ð½','Ð°Ñž','ÑÑ€','Ñ‡Ñ†','Ð¿Ñ‚','ÑÐ±','Ð½ÑÐ´Ð·ÐµÐ»Ñ','Ð¿Ð°Ð½ÑÐ´Ð·ÐµÐ»Ð°Ðº','Ð°ÑžÑ‚Ð¾Ñ€Ð°Ðº','ÑÐµÑ€Ð°Ð´Ð°','Ñ‡Ð°Ñ†Ð²ÐµÑ€','Ð¿ÑÑ‚Ð½Ñ–Ñ†Ð°','ÑÑƒÐ±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (38,'be','BY','BYR','','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (39,'bg',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'dd MMMM yyyy, EEEE','dd MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,'Ð¿Ñ€. Ð¾Ð±.','ÑÐ». Ð¾Ð±.',NULL,NULL,NULL,'ÑÐ½.','Ñ„ÐµÐ²Ñ€.','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€.','Ð¼Ð°Ð¹','ÑŽÐ½Ð¸','ÑŽÐ»Ð¸','Ð°Ð²Ð³.','ÑÐµÐ¿Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÐµÐ¼.','Ð´ÐµÐº.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÐ½ÑƒÐ°Ñ€Ð¸','Ñ„ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ð¹','ÑŽÐ½Ð¸','ÑŽÐ»Ð¸','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸','Ð¾ÐºÑ‚Ð¾Ð¼Ð²Ñ€Ð¸','Ð½Ð¾ÐµÐ¼Ð²Ñ€Ð¸','Ð´ÐµÐºÐµÐ¼Ð²Ñ€Ð¸','Ð½Ð´','Ð¿Ð½','Ð²Ñ‚','ÑÑ€','Ñ‡Ñ‚','Ð¿Ñ‚','ÑÐ±','Ð½ÐµÐ´ÐµÐ»Ñ','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»Ð½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÑÐ´Ð°','Ñ‡ÐµÑ‚Ð²ÑŠÑ€Ñ‚ÑŠÐº','Ð¿ÐµÑ‚ÑŠÐº','ÑÑŠÐ±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (40,'bg','BG','BGN','Ð»Ð².',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (41,'bn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦ªà§‚à¦°à§à¦¬à¦¾à¦¹à§à¦£','à¦…à¦ªà¦°à¦¾à¦¹à§à¦£',NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à¦°à§€','à¦«à§‡à¦¬à§à¦°à§à¦¯à¦¼à¦¾à¦°à§€','à¦®à¦¾à¦°à§à¦š','à¦à¦ªà§à¦°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦¸à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à¦°','à¦…à¦•à§à¦Ÿà§‹à¦¬à¦°','à¦¨à¦­à§‡à¦®à§à¦¬à¦°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à¦°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¦œà¦¾à¦¨à§à¦¯à¦¼à¦¾à¦°à§€','à¦«à§‡à¦¬à§à¦°à§à¦¯à¦¼à¦¾à¦°à§€','à¦®à¦¾à¦°à§à¦š','à¦à¦ªà§à¦°à¦¿à¦²','à¦®à§‡','à¦œà§à¦¨','à¦œà§à¦²à¦¾à¦‡','à¦†à¦—à¦¸à§à¦Ÿ','à¦¸à§‡à¦ªà§à¦Ÿà§‡à¦®à§à¦¬à¦°','à¦…à¦•à§à¦Ÿà§‹à¦¬à¦°','à¦¨à¦­à§‡à¦®à§à¦¬à¦°','à¦¡à¦¿à¦¸à§‡à¦®à§à¦¬à¦°','à¦°à¦¬à¦¿','à¦¸à§‹à¦®','à¦®à¦™à§à¦—à¦²','à¦¬à§à¦§','à¦¬à§ƒà¦¹à¦¸à§à¦ªà¦¤à¦¿','à¦¶à§à¦•à§à¦°','à¦¶à¦¨à¦¿','à¦°à¦¬à¦¿à¦¬à¦¾à¦°','à¦¸à§‹à¦®à¦¬à¦¾à¦°','à¦®à¦™à§à¦—à¦²à¦¬à¦¾à¦°','à¦¬à§à¦§à¦¬à¦¾à¦°','à¦¬à§ƒà¦¹à¦·à§à¦ªà¦¤à¦¿à¦¬à¦¾à¦°','à¦¶à§à¦•à§à¦°à¦¬à¦¾à¦°','à¦¶à¦¨à¦¿à¦¬à¦¾à¦°');
INSERT INTO `locales` VALUES (42,'bn','BD','BDT','à§³',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (43,'bn','IN','INR','à¦Ÿà¦¾à¦•à¦¾',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (44,'bs',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Maj','Jun','Jul','Avg','Sep','Okt','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januar','Februar','Mart','April','Maj','Juni','Juli','Avgust','Septembar','Oktobar','Novembar','Decembar','Ned','Pon','Uto','Sri','ÄŒet','Pet','Sub','Nedjelja','Ponedjeljak','Utorak','Srijeda','ÄŒetvrtak','Petak','Subota');
INSERT INTO `locales` VALUES (45,'bs','BA','BAM','KM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (46,'byn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á‹á‹±áˆµ áŒƒá‰¥','á‹á‹±áˆµ á‹°áˆá‰¢',NULL,NULL,NULL,'áˆá‹°á‰µ','áŠ«á‰¥áŠ½','áŠ­á‰¥áˆ‹','á‹áŒ…áŠº','áŠ­á‰¢á‰…','áˆ/á‰µ','áŠ°áˆ­','áˆ›áˆ­á‹«','á‹«áŠ¸áŠ’','áˆ˜á‰°áˆ‰','áˆ/áˆ','á‰°áˆ•áˆ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áˆá‹°á‰µáˆª','áŠ«á‰¥áŠ½á‰¥á‰²','áŠ­á‰¥áˆ‹','á‹áŒ…áŠºáˆª','áŠ­á‰¢á‰…áˆª','áˆáŠªáŠ¤áˆ á‰µáŒ“Ì…áŠ’áˆª','áŠ°áˆ­áŠ©','áˆ›áˆ­á‹«áˆ á‰µáˆª','á‹«áŠ¸áŠ’ áˆ˜áˆ³á‰…áˆˆáˆª','áˆ˜á‰°áˆ‰','áˆáŠªáŠ¤áˆ áˆ˜áˆ½á‹ˆáˆª','á‰°áˆ•áˆ³áˆµáˆª','áˆ°/á‰…','áˆ°áŠ‘','áˆ°áˆŠáŒ','áˆˆáŒ“','áŠ£áˆá‹µ','áŠ£áˆ­á‰¥','áˆ°/áˆ½','áˆ°áŠ•á‰ áˆ­ á‰…á‹³á‹…','áˆ°áŠ‘','áˆ°áˆŠáŒ','áˆˆáŒ“ á‹ˆáˆª áˆˆá‰¥á‹‹','áŠ£áˆá‹µ','áŠ£áˆ­á‰¥','áˆ°áŠ•á‰ áˆ­ áˆ½áŒ“á‹…');
INSERT INTO `locales` VALUES (47,'byn','ER','ERN',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM áŒáˆ­áŒ‹ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (48,'ca',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE d \'de\' MMMM \'de\' yyyy','d \'de\' MMMM \'de\' yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'gen.','febr.','marÃ§','abr.','maig','juny','jul.','ag.','set.','oct.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'gener','febrer','marÃ§','abril','maig','juny','juliol','agost','setembre','octubre','novembre','desembre','dg.','dl.','dt.','dc.','dj.','dv.','ds.','diumenge','dilluns','dimarts','dimecres','dijous','divendres','dissabte');
INSERT INTO `locales` VALUES (49,'ca','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (50,'cch',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Dyon','Baa','Atat','Anas','Atyo','Achi','Atar','Awur','Shad','Shak','Naba','Nata',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Pen Dyon','Pen Ba\'a','Pen Atat','Pen Anas','Pen Atyon','Pen Achirim','Pen Atariba','Pen Awurr','Pen Shadon','Pen Shakur','Pen Kur Naba','Pen Kur Natat','Yok','Tung','T. Tung','Tsan','Nas','Nat','Chir','Wai Yoka Bawai','Wai Tunga','Toki Gitung','Tsam Kasuwa','Wai Na Nas','Wai Na Tiyon','Wai Na Chirim');
INSERT INTO `locales` VALUES (51,'cch','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (52,'cs',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yy',NULL,'dop.','odp.',NULL,NULL,NULL,'led','Ãºno','bÅ™e','dub','kvÄ›','Ärn','Ärc','srp','zÃ¡Å™','Å™Ã­j','lis','pro','l','Ãº','b','d','k','Ä','Ä','s','z','Å™','l','p','ledna','Ãºnora','bÅ™ezna','dubna','kvÄ›tna','Äervna','Äervence','srpna','zÃ¡Å™Ã­','Å™Ã­jna','listopadu','prosince','ne','po','Ãºt','st','Ät','pÃ¡','so','nedÄ›le','pondÄ›lÃ­','ÃºterÃ½','stÅ™eda','Ätvrtek','pÃ¡tek','sobota');
INSERT INTO `locales` VALUES (53,'cs','CZ','CZK','KÄ',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (54,'cy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ion','Chwef','Mawrth','Ebrill','Mai','Meh','Gorff','Awst','Medi','Hyd','Tach','Rhag',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ionawr','Chwefror','Mawrth','Ebrill','Mai','Mehefin','Gorffenaf','Awst','Medi','Hydref','Tachwedd','Rhagfyr','Sul','Llun','Maw','Mer','Iau','Gwen','Sad','Dydd Sul','Dydd Llun','Dydd Mawrth','Dydd Mercher','Dydd Iau','Dydd Gwener','Dydd Sadwrn');
INSERT INTO `locales` VALUES (55,'cy','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd MMMM yyyy','dd MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (56,'da',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,'âˆ’','HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE \'den\' d. MMMM yyyy','d. MMM yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','marts','april','maj','juni','juli','august','september','oktober','november','december','sÃ¸n','man','tir','ons','tor','fre','lÃ¸r','sÃ¸ndag','mandag','tirsdag','onsdag','torsdag','fredag','lÃ¸rdag');
INSERT INTO `locales` VALUES (57,'da','DK','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ -#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (58,'de',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm\' Uhr \'z',NULL,NULL,NULL,'EEEE, d. MMMM yyyy','d. MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,'vorm.','nachm.',NULL,NULL,NULL,'Jan','Feb','MÃ¤r','Apr','Mai','Jun','Jul','Aug','Sep','Okt','Nov','Dez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januar','Februar','MÃ¤rz','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember','So','Mo','Di','Mi','Do','Fr','Sa','Sonntag','Montag','Dienstag','Mittwoch','Donnerstag','Freitag','Samstag');
INSERT INTO `locales` VALUES (59,'de','AT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm\' Uhr \'z',NULL,NULL,NULL,'EEEE, dd. MMMM yyyy','dd. MMMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'JÃ¤n',NULL,'MÃ¤r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'JÃ¤nner',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (60,'de','BE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'HH \'h\' mm \'min\' ss \'s\' z',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'MÃ¤r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Son','Mon','Die','Mit','Don','Fre','Sam',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (61,'de','CH','CHF','SFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (62,'de','DE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (63,'de','LI','CHF','SFr.','5','2','.','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (64,'de','LU','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (65,'dv',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (66,'dv','MV','MVR','Þƒ.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (67,'dz',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤#,##,##0.00',NULL,NULL,'à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm à½¦à¾à½¢à¼‹à½†à½±à¼‹ ss a zzzz','à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm à½¦à¾à½¢à¼‹à½†à½±à¼‹ ss a zzz','à½†à½´à¼‹à½šà½¼à½‘à¼‹h:mm:ss a','à½†à½´à¼‹à½šà½¼à½‘à¼‹ h à½¦à¾à½¢à¼‹à½˜à¼‹ mm a','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹yyyy à½Ÿà¾³à¼‹ MMM à½šà½ºà½¦à¼‹ dd','à½¦à¾¤à¾±à½²à¼‹à½£à½¼à¼‹ yyyy à½Ÿà¾³à¼‹ MMM à½šà½ºà½¦à¼‹ dd','{1} {0}','à½¦à¾”à¼‹à½†à¼‹','à½•à¾±à½²à¼‹à½†à¼‹',NULL,NULL,NULL,'à½Ÿà¾³à¼‹ à¼¡','à½Ÿà¾³à¼‹ à¼¢','à½Ÿà¾³à¼‹ à¼£','à½Ÿà¾³à¼‹ à¼¤','à½Ÿà¾³à¼‹ à¼¥','à½Ÿà¾³à¼‹ à¼¦','à½Ÿà¾³à¼‹ à¼§','à½Ÿà¾³à¼‹ à¼¨','à½Ÿà¾³à¼‹ à¼©','à½Ÿà¾³à¼‹ à¼¡à¼ ','à½Ÿà¾³à¼‹ à¼¡à¼¡','à½Ÿà¾³à¼‹ à¼¡à¼¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à½„à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‚à½‰à½²à½¦à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‚à½¦à½´à½˜à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½žà½²à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½£à¾”à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à¾²à½´à½‚à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½‘à½´à½“à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½¢à¾’à¾±à½‘à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½‘à½‚à½´à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½‚à½…à½²à½‚à¼‹à½”à¼‹','à½¦à¾¤à¾±à½²à¼‹à½Ÿà¾³à½à¼‹à½–à½…à½´à¼‹à½‚à½‰à½²à½¦à¼‹à½”à¼‹','à½Ÿà¾³à¼‹','à½˜à½²à½¢à¼‹','à½£à¾·à½‚à¼‹','à½•à½´à½¢à¼‹','à½¦à½„à½¦à¼‹','à½¦à¾¤à½ºà½“à¼‹','à½‰à½²à¼‹','à½‚à½Ÿà½ à¼‹à½Ÿà¾³à¼‹à½–à¼‹','à½‚à½Ÿà½ à¼‹à½˜à½²à½‚à¼‹à½‘à½˜à½¢à¼‹','à½‚à½Ÿà½ à¼‹à½£à¾·à½‚à¼‹à½”à¼‹','à½‚à½Ÿà½ à¼‹à½•à½´à½¢à¼‹à½–à½´à¼‹','à½‚à½Ÿà½ à¼‹à½”à¼‹à½¦à½„à½¦à¼‹','à½‚à½Ÿà½ à¼‹à½¦à¾¤à½ºà½“à¼‹à½”à¼‹','à½‚à½Ÿà½ à¼‹à½‰à½²à¼‹à½˜à¼‹');
INSERT INTO `locales` VALUES (68,'dz','BT','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,'à½–à½¢à¾’à¼‹à½†à½±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (69,'ee',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'AN','EW',NULL,NULL,NULL,'Dzv','Dzd','Ted','AfÉ”','Dam','Mas','Sia','Dea','Any','Kel','Ade','Dzm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Dzove','Dzodze','Tedoxe','AfÉ”fiÉ›','Dama','Masa','SiamlÉ”m','Deasiamime','AnyÉ”nyÉ”','Kele','AdeÉ›mekpÉ”xe','Dzome','KÉ”s Kwe','Dzo','Bra','KuÉ–','Yaw','FiÉ–','Mem','KÉ”siÉ–a','DzoÉ–a','BraÉ–a','KuÉ–a','YawoÉ–a','FiÉ–a','MemleÉ–a');
INSERT INTO `locales` VALUES (70,'ee','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (71,'ee','TG','XOF','CFA','0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (72,'el',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,'Î Îœ','ÎœÎœ',NULL,NULL,NULL,'Î™Î±Î½','Î¦ÎµÎ²','ÎœÎ±Ï','Î‘Ï€Ï','ÎœÎ±ÏŠ','Î™Î¿Ï…Î½','Î™Î¿Ï…Î»','Î‘Ï…Î³','Î£ÎµÏ€','ÎŸÎºÏ„','ÎÎ¿Îµ','Î”ÎµÎº','Î™','Î¦','Îœ','Î‘','Îœ','Î™','Î™','Î‘','Î£','ÎŸ','Î','Î”','Î™Î±Î½Î¿Ï…Î±ÏÎ¯Î¿Ï…','Î¦ÎµÎ²ÏÎ¿Ï…Î±ÏÎ¯Î¿Ï…','ÎœÎ±ÏÏ„Î¯Î¿Ï…','Î‘Ï€ÏÎ¹Î»Î¯Î¿Ï…','ÎœÎ±ÎÎ¿Ï…','Î™Î¿Ï…Î½Î¯Î¿Ï…','Î™Î¿Ï…Î»Î¯Î¿Ï…','Î‘Ï…Î³Î¿ÏÏƒÏ„Î¿Ï…','Î£ÎµÏ€Ï„ÎµÎ¼Î²ÏÎ¯Î¿Ï…','ÎŸÎºÏ„Ï‰Î²ÏÎ¯Î¿Ï…','ÎÎ¿ÎµÎ¼Î²ÏÎ¯Î¿Ï…','Î”ÎµÎºÎµÎ¼Î²ÏÎ¯Î¿Ï…','ÎšÏ…Ï','Î”ÎµÏ…','Î¤ÏÎ¹','Î¤ÎµÏ„','Î ÎµÎ¼','Î Î±Ï','Î£Î±Î²','ÎšÏ…ÏÎ¹Î±ÎºÎ®','Î”ÎµÏ…Ï„Î­ÏÎ±','Î¤ÏÎ¯Ï„Î·','Î¤ÎµÏ„Î¬ÏÏ„Î·','Î Î­Î¼Ï€Ï„Î·','Î Î±ÏÎ±ÏƒÎºÎµÏ…Î®','Î£Î¬Î²Î²Î±Ï„Î¿');
INSERT INTO `locales` VALUES (73,'el','CY','CYP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (74,'el','GR','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤;-Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (75,'en',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a v','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','MMMM d, yyyy','MMM d, yyyy','M/d/yy',NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'January','February','March','April','May','June','July','August','September','October','November','December','Sun','Mon','Tue','Wed','Thu','Fri','Sat','Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
INSERT INTO `locales` VALUES (76,'en','AS','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (77,'en','AU','AUD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a',NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','dd/MM/yyyy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (78,'en','BE','EUR','â‚¬',NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,'HH\' h \'mm\' min \'ss\' s \'z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE d MMMM yyyy','EEE d MMM yyyy','dd MMM yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (79,'en','BW','BWP','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (80,'en','BZ','BZD','BZ$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','dd MMMM yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (81,'en','CA','CAD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (82,'en','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (83,'en','GU','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (84,'en','HK','HKD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (85,'en','IE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,'a.m.','p.m.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (86,'en','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (87,'en','JM','JMD','J$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (88,'en','MH','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (89,'en','MP','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (90,'en','MT','MTL','Lm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (91,'en','NA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (92,'en','NZ','NZD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a',NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d/MM/yyyy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (93,'en','PH','PHP','Php',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'MM d, yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (94,'en','PK','PKR','Pra',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (95,'en','SG','SGD','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a hh:mm:ss','a hh:mm:ss','a hh:mm','a hh:mm','dd MMMM yyyy','dd MMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (96,'en','TT','TTD','TT$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (97,'en','UM','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (98,'en','US','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (99,'en','VI','USD','US$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (100,'en','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yyyy','yyyy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (101,'en','ZW','ZWD','Z$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM,yy','d/M/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (102,'eo',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H\'-a horo kaj \'m z',NULL,NULL,NULL,'EEEE, d\'-a de \'MMMM yyyy','yyyy-MMMM-dd','yyyy-MMM-dd','yy-MM-dd',NULL,'atm','ptm',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aÅ­g','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januaro','februaro','marto','aprilo','majo','junio','julio','aÅ­gusto','septembro','oktobro','novembro','decembro','di','lu','ma','me','Äµa','ve','sa','dimanÄ‰o','lundo','mardo','merkredo','ÄµaÅ­do','vendredo','sabato');
INSERT INTO `locales` VALUES (103,'es',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'HH\'H\'mm\'\'ss&quot; z',NULL,NULL,NULL,'EEEE d\' de \'MMMM\' de \'yyyy','d\' de \'MMMM\' de \'yyyy','dd-MMM-yy','d/MM/yy',NULL,'a.m.','p.m.',NULL,NULL,NULL,'ene','feb','mar','abr','may','jun','jul','ago','sep','oct','nov','dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'enero','febrero','marzo','abril','mayo','junio','julio','agosto','septiembre','octubre','noviembre','diciembre','dom','lun','mar','miÃ©','jue','vie','sÃ¡b','domingo','lunes','martes','miÃ©rcoles','jueves','viernes','sÃ¡bado');
INSERT INTO `locales` VALUES (104,'es','AR','ARS','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH\'h\'\'\'mm z','H:mm:ss z',NULL,NULL,NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (105,'es','BO','BOB','Bs',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (106,'es','CL','CLP','$','0','-1',NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (107,'es','CO','COP','$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'d/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (108,'es','CR','CRC','C',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (109,'es','DO','DOP','RD$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (110,'es','EC','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,'HH:mm:ss z','H:mm:ss z','H:mm:ss','H:mm',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (111,'es','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,'H:mm:ss','H:mm',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (112,'es','GT','GTQ','Q',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'d/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (113,'es','HN','HNL','L',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE dd\' de \'MMMM\' de \'yyyy','dd\' de \'MMMM\' de \'yyyy','dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (114,'es','MX','MXN','$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (115,'es','NI','NIO','C$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (116,'es','PA','PAB','B',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'MM/dd/yyyy','MM/dd/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (117,'es','PE','PEN','S/',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (118,'es','PR','USD','$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'MM/dd/yyyy','MM/dd/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (119,'es','PY','PYG','G','0','-1',NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ -#,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (120,'es','SV','SVC','',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (121,'es','US','USD','US$',NULL,NULL,'.',',',NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a',NULL,NULL,'MMM d, yyyy','M/d/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (122,'es','UY','UYU','',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;(Â¤#,##0.00)',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (123,'es','VE','VEB','Bs',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a',NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (124,'et',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d, MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'jaan','veebr','mÃ¤rts','apr','mai','juuni','juuli','aug','sept','okt','nov','dets',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jaanuar','veebruar','mÃ¤rts','aprill','mai','juuni','juuli','august','september','oktoober','november','detsember','P','E','T','K','N','R','L','pÃ¼hapÃ¤ev','esmaspÃ¤ev','teisipÃ¤ev','kolmapÃ¤ev','neljapÃ¤ev','reede','laupÃ¤ev');
INSERT INTO `locales` VALUES (125,'et','EE','EEK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (126,'eu',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'urt','ots','mar','api','mai','eka','uzt','abu','ira','urr','aza','abe',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'urtarrila','otsaila','martxoa','apirila','maiatza','ekaina','uztaila','abuztua','iraila','urria','azaroa','abendua','ig','al','as','az','og','or','lr','igandea','astelehena','asteartea','asteazkena','osteguna','ostirala','larunbata');
INSERT INTO `locales` VALUES (127,'eu','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, yyyy\'eko\' MMMM\'ren\' dd\'a\'','EEE, yyyy\'eko\' MMM\'ren\' dd\'a\'','yy\'-\'MMM\'-\'dd','yy\'-\'MM\'-\'dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (128,'fa',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬','#,##0.###;\'â€ª\'-#,##0.###\'â€¬\'','#,##0.00 Â¤;\'â€ª\'-#,##0.00\'â€¬\' Â¤','Ùª','âˆ’','H:mm:ss (vvvv)','H:mm:ss (zzzz)','H:mm:ss','H:mm','EEEE d MMMM yyyy GGGG','d MMMM yyyy','yyyy/M/d','yy/M/d G','{0}ØŒ Ø³Ø§','Ù‚Ø¨Ù„ Ø§Ø² Ø¸Ù‡Ø±','Ø¨Ø¹Ø¯ Ø§Ø² Ø¸Ù‡Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ú˜Ø§Ù†ÙˆÛŒÙ‡Ù”','ÙÙˆØ±ÛŒÙ‡Ù”','Ù…Ø§Ø±Ø³','Ø¢ÙˆØ±ÛŒÙ„','Ù…Ù‡Ù”','Ú˜ÙˆØ¦Ù†','Ú˜ÙˆØ¦ÛŒÙ‡Ù”','Ø§ÙˆØª','Ø³Ù¾ØªØ§Ù…Ø¨Ø±','Ø§Ú©ØªØ¨Ø±','Ù†ÙˆØ§Ù…Ø¨Ø±','Ø¯Ø³Ø§Ù…Ø¨Ø±','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡');
INSERT INTO `locales` VALUES (129,'fa','AF','AFN','Ø‹',NULL,NULL,'Ù«','Ù¬',NULL,NULL,'Ùª','âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†Ùˆ',NULL,NULL,NULL,'Ù…Ù€ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„',NULL,NULL,NULL,NULL,'Ø¯Ø³Ù…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ¨Ø±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú¯Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (130,'fa','IR','IRR','ï·¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (131,'fi',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00Â Â¤',NULL,NULL,'H.mm.ss v','\'klo \'H.mm.ss','H.mm.ss','H.mm','EEEE\'na \'d. MMMM\'ta \'yyyy','d. MMMM\'ta \'yyyy','d.M.yyyy','d.M.yyyy',NULL,'ap.','ip.',NULL,NULL,NULL,'tammi','helmi','maalis','huhti','touko','kesÃ¤','heinÃ¤','elo','syys','loka','marras','joulu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'tammikuu','helmikuu','maaliskuu','huhtikuu','toukokuu','kesÃ¤kuu','heinÃ¤kuu','elokuu','syyskuu','lokakuu','marraskuu','joulukuu','su','ma','ti','ke','to','pe','la','sunnuntai','maanantai','tiistai','keskiviikko','torstai','perjantai','lauantai');
INSERT INTO `locales` VALUES (132,'fi','FI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (133,'fo',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE dd MMMM yyyy','d. MMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','mai','jun','jul','aug','sep','okt','nov','des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','aprÃ­l','mai','juni','juli','august','september','oktober','november','desember','sun','mÃ¡n','tÃ½s','mik','hÃ³s','frÃ­','ley','sunnudagur','mÃ¡nadagur','tÃ½sdagur','mikudagur','hÃ³sdagur','frÃ­ggjadagur','leygardagur');
INSERT INTO `locales` VALUES (134,'fo','FO','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (135,'fr',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00 Â¤',NULL,NULL,'HH\' h \'mm z',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'janv.','fÃ©vr.','mars','avr.','mai','juin','juil.','aoÃ»t','sept.','oct.','nov.','dÃ©c.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janvier','fÃ©vrier','mars','avril','mai','juin','juillet','aoÃ»t','septembre','octobre','novembre','dÃ©cembre','dim.','lun.','mar.','mer.','jeu.','ven.','sam.','dimanche','lundi','mardi','mercredi','jeudi','vendredi','samedi');
INSERT INTO `locales` VALUES (136,'fr','BE','EUR','â‚¬',NULL,NULL,NULL,'.',NULL,NULL,NULL,NULL,'H\' h \'mm\' min \'ss\' s \'z',NULL,NULL,NULL,NULL,NULL,'dd-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (137,'fr','CA','CAD','$',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤;(#,##0.00Â¤)',NULL,NULL,'HH\' h \'mm\' min \'ss\' s \'z',NULL,NULL,NULL,NULL,NULL,'yy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (138,'fr','CH','CHF','sFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,'HH.mm:ss\' h\' z',NULL,NULL,NULL,'EEEE, d MMMM yyyy',NULL,NULL,'dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (139,'fr','FR','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (140,'fr','LU','EUR','â‚¬',NULL,NULL,NULL,'.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (141,'fr','MC','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (142,'fur',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'d MMMM yyyy EEEE','d MMMM yyyy','d MMM yyyy','d/MM/yy',NULL,'a.','p.',NULL,NULL,NULL,'Zen','Fev','Mar','Avr','Mai','Jug','Lui','Avo','Set','Otu','Nov','Dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ZenÃ¢r','FevrÃ¢r','MarÃ§','AvrÃ®l','Mai','Jugn','Lui','Avost','Setembar','Otubar','Novembar','Dicembar','dom','lun','mar','mie','joi','vin','sab','domenie','lunis','martars','miercus','joibe','vinars','sabide');
INSERT INTO `locales` VALUES (143,'fur','IT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (144,'ga',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'Ean','Feabh','MÃ¡rta','Aib','Beal','Meith','IÃºil','LÃºn','MFÃ³mh','DFÃ³mh','Samh','Noll',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EanÃ¡ir','Feabhra','MÃ¡rta','AibreÃ¡n','Bealtaine','Meitheamh','IÃºil','LÃºnasa','MeÃ¡n FÃ³mhair','Deireadh FÃ³mhair','Samhain','Nollaig','Domh','Luan','MÃ¡irt','CÃ©ad','DÃ©ar','Aoine','Sath','DÃ© Domhnaigh','DÃ© Luain','DÃ© MÃ¡irt','DÃ© CÃ©adaoin','DÃ©ardaoin','DÃ© hAoine','DÃ© Sathairn');
INSERT INTO `locales` VALUES (145,'ga','IE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (146,'gaa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'LB','SN',NULL,NULL,NULL,'Aha','Ofl','Och','Abe','Agb','Otu','Maa','Man','Gbo','Ant','Ale','Afu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Aharabata','Oflo','Ochokrikri','Abeibee','Agbeinaa','Otukwadan','Maawe','Manyawale','Gbo','Anton','Alemle','Afuabee','Ho','Dzu','Dzf','Sho','Soo','Soh','Ho','Hogbaa','Dzu','Dzufo','Sho','Soo','Sohaa','Ho');
INSERT INTO `locales` VALUES (147,'gaa','GH','GHC','Â¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (148,'gez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ½á‰£áˆ•','áˆáˆ´á‰µ',NULL,NULL,NULL,'áŒ áˆáˆ¨','áŠ¨á‰°á‰°','áˆ˜áŒˆá‰ ','áŠ áŠ€á‹˜','áŒáŠ•á‰£','áˆ áŠ•á‹¨','áˆáˆ˜áˆˆ','áŠáˆáˆ°','áŠ¨áˆ¨áˆ˜','áŒ á‰€áˆ˜','áŠ€á‹°áˆ¨','áŠ€áˆ áˆ ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ áˆáˆ¨','áŠ¨á‰°á‰°','áˆ˜áŒˆá‰ ','áŠ áŠ€á‹˜','áŒáŠ•á‰£á‰µ','áˆ áŠ•á‹¨','áˆáˆ˜áˆˆ','áŠáˆáˆ°','áŠ¨áˆ¨áˆ˜','áŒ á‰€áˆ˜','áŠ€á‹°áˆ¨','áŠ€áˆ áˆ ','áŠ¥áŠá‹µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ«á‰¥á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰ ','á‰€á‹³áˆš','áŠ¥áŠá‹µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ«á‰¥á‹•','áˆáˆ™áˆµ','á‹“áˆ­á‰ ','á‰€á‹³áˆšá‰µ');
INSERT INTO `locales` VALUES (149,'gez','ER','ERN','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áˆ˜á‹“áˆá‰µ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (150,'gez','ET','ETB','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áˆ˜á‹“áˆá‰µ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (151,'gl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Xan','Feb','Mar','Abr','Mai','XuÃ±','Xul','Ago','Set','Out','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Xaneiro','Febreiro','Marzo','Abril','Maio','XuÃ±o','Xullo','Agosto','Setembro','Outubro','Novembro','Decembro','Dom','Lun','Mar','MÃ©r','Xov','Ven','SÃ¡b','Domingo','Luns','Martes','MÃ©rcores','Xoves','Venres','SÃ¡bado');
INSERT INTO `locales` VALUES (152,'gl','ES','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (153,'gu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àªªà«‚àª°à«àªµÂ àª®àª§à«àª¯àª¾àª¹à«àª¨','àª‰àª¤à«àª¤àª°Â àª®àª§à«àª¯àª¾àª¹à«àª¨',NULL,NULL,NULL,'àªœàª¾àª¨à«àª¯à«','àª«à«‡àª¬à«àª°à«','àª®àª¾àª°à«àªš','àªàªªà«àª°àª¿àª²','àª®à«‡','àªœà«‚àª¨','àªœà«àª²àª¾àªˆ','àª‘àª—àª¸à«àªŸ','àª¸àªªà«àªŸà«‡','àª‘àª•à«àªŸà«‹','àª¨àªµà«‡','àª¡àª¿àª¸à«‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àªœàª¾àª¨à«àª¯à«àª†àª°à«€','àª«à«‡àª¬à«àª°à«àª†àª°à«€','àª®àª¾àª°à«àªš','àªàªªà«àª°àª¿àª²','àª®à«‡','àªœà«‚àª¨','àªœà«àª²àª¾àªˆ','àª‘àª—àª¸à«àªŸ','àª¸àªªà«àªŸà«‡àª®à«àª¬àª°','àª‘àª•à«àªŸà«àª¬àª°','àª¨àªµà«‡àª®à«àª¬àª°','àª¡àª¿àª¸à«‡àª®à«àª¬àª°','àª°àªµàª¿','àª¸à«‹àª®','àª®àª‚àª—àª³','àª¬à«àª§','àª—à«àª°à«','àª¶à«àª•à«àª°','àª¶àª¨àª¿','àª°àªµàª¿àªµàª¾àª°','àª¸à«‹àª®àªµàª¾àª°','àª®àª‚àª—àª³àªµàª¾àª°','àª¬à«àª§àªµàª¾àª°','àª—à«àª°à«àªµàª¾àª°','àª¶à«àª•à«àª°àªµàª¾àª°','àª¶àª¨àª¿àªµàª¾àª°');
INSERT INTO `locales` VALUES (154,'gu','IN','INR','àª°à«',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (155,'gv',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'J-guer','T-arree','Mayrnt','Avrril','Boaldyn','M-souree','J-souree','Luanistyn','M-fouyir','J-fouyir','M.Houney','M.Nollick',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jerrey-geuree','Toshiaght-arree','Mayrnt','Averil','Boaldyn','Mean-souree','Jerrey-souree','Luanistyn','Mean-fouyir','Jerrey-fouyir','Mee Houney','Mee ny Nollick','Jed','Jel','Jem','Jerc','Jerd','Jeh','Jes','Jedoonee','Jelhein','Jemayrt','Jercean','Jerdein','Jeheiney','Jesarn');
INSERT INTO `locales` VALUES (156,'gv','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (157,'ha',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Fab','Mar','Afr','May','Yun','Yul','Agu','Sat','Okt','Nuw','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janairu','Fabrairu','Maris','Afrilu','Mayu','Yuni','Yuli','Agusta','Satumba','Oktoba','Nuwamba','Disamba','Lah','Lit','Tal','Lar','Alh','Jum','Asa','Lahadi','Littinin','Talata','Laraba','Alhamis','Jumma\'a','Asabar');
INSERT INTO `locales` VALUES (158,'ha_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'Ø¬ÙŽÙ†','Ú¢ÙŽØ¨','Ù…ÙŽØ±','Ø£ÙŽÚ¢Ù’Ø±','Ù…ÙŽÙŠ','ÙŠÙÙˆÙ†','ÙŠÙÙˆÙ„','Ø£ÙŽØºÙ','Ø³ÙŽØª','Ø£ÙÙƒÙ’Øª','Ù†ÙÙˆ','Ø¯ÙØ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬ÙŽÙ†ÙŽÙŠÙ’Ø±Ù','Ú¢ÙŽØ¨Ù’Ø±ÙŽÙŠÙ’Ø±Ù','Ù…ÙŽØ±ÙØ³Ù’','Ø£ÙŽÚ¢Ù’Ø±ÙÙ„Ù','Ù…ÙŽÙŠÙ','ÙŠÙÙˆÙ†Ù','ÙŠÙÙˆÙ„Ù','Ø£ÙŽØºÙØ³Ù’ØªÙŽ','Ø³ÙŽØªÙÙ…Ù’Ø¨ÙŽ','Ø£ÙÙƒÙ’ØªÙˆÙØ¨ÙŽ','Ù†ÙÙˆÙŽÙ…Ù’Ø¨ÙŽ','Ø¯ÙØ³ÙŽÙ…Ù’Ø¨ÙŽ','Ù„ÙŽØ­','Ù„ÙØª','ØªÙŽÙ„','Ù„ÙŽØ±','Ø£ÙŽÙ„Ù’Ø­','Ø¬ÙÙ…','Ø£ÙŽØ³ÙŽ','Ù„ÙŽØ­ÙŽØ¯Ù','Ù„ÙØªÙÙ†ÙÙ†Ù’','ØªÙŽÙ„ÙŽØªÙŽ','Ù„ÙŽØ±ÙŽØ¨ÙŽ','Ø£ÙŽÙ„Ù’Ø­ÙŽÙ…ÙØ³Ù’','Ø¬ÙÙ…ÙŽØ¹ÙŽ','Ø£ÙŽØ³ÙŽØ¨ÙŽØ±Ù’');
INSERT INTO `locales` VALUES (159,'ha_Arab','NG','NGN','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (160,'ha_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (161,'ha_Latn','GH','GHC',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (162,'ha_Latn','NE','XOF',NULL,'0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (163,'ha_Latn','NG','NGN',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (164,'haw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ian.','Pep.','Mal.','Ê»Ap.','Mei','Iun.','Iul.','Ê»Au.','Kep.','Ê»Ok.','Now.','Kek.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ianuali','Pepeluali','Malaki','Ê»Apelila','Mei','Iune','Iulai','Ê»Aukake','Kepakemapa','Ê»Okakopa','Nowemapa','Kekemapa','LP','P1','P2','P3','P4','P5','P6','LÄpule','PoÊ»akahi','PoÊ»alua','PoÊ»akolu','PoÊ»ahÄ','PoÊ»alima','PoÊ»aono');
INSERT INTO `locales` VALUES (165,'haw','US','USD','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE, d MMMM yyyy','d MMMM yyyy','d MMM yyyy','d/M/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (166,'he',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','dd/MM/yyyy','dd/MM/yy','{0} {1}',NULL,NULL,NULL,NULL,NULL,'×™× ×•','×¤×‘×¨','×ž×¨×¥','××¤×¨','×ž××™','×™×•× ','×™×•×œ','××•×’','×¡×¤×˜','××•×§','× ×•×‘','×“×¦×ž',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'×™× ×•××¨','×¤×‘×¨×•××¨','×ž×¨×¥','××¤×¨×™×œ','×ž××™','×™×•× ×™','×™×•×œ×™','××•×’×•×¡×˜','×¡×¤×˜×ž×‘×¨','××•×§×˜×•×‘×¨','× ×•×‘×ž×‘×¨','×“×¦×ž×‘×¨','×','×‘','×’','×“','×”','×•','×©','×™×•× ×¨××©×•×Ÿ','×™×•× ×©× ×™','×™×•× ×©×œ×™×©×™','×™×•× ×¨×‘×™×¢×™','×™×•× ×—×ž×™×©×™','×™×•× ×©×™×©×™','×©×‘×ª');
INSERT INTO `locales` VALUES (167,'he','IL','ILS','â‚ª',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (168,'hi',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¹à¥à¤¨','à¤…à¤ªà¤°à¤¾à¤¹à¥à¤¨',NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¤°à¤µà¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¥ˆà¤²','à¤®à¤ˆ','à¤œà¥‚à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¤¿à¤¤à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤¤à¥‚à¤¬à¤°','à¤¨à¤µà¤®à¥à¤¬à¤°','à¤¦à¤¿à¤¸à¤®à¥à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¤°à¤µà¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¥ˆà¤²','à¤®à¤ˆ','à¤œà¥‚à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¤¿à¤¤à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤¤à¥‚à¤¬à¤°','à¤¨à¤µà¤®à¥à¤¬à¤°','à¤¦à¤¿à¤¸à¤®à¥à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤²','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤°à¤µà¤¿à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤²à¤µà¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°');
INSERT INTO `locales` VALUES (169,'hi','IN','INR','à¤°à¥.',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (170,'hr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy. MMMM dd','yyyy. MMMM dd','yyyy.MM.dd','yyyy.MM.dd',NULL,NULL,NULL,NULL,NULL,NULL,'sij','vel','oÅ¾u','tra','svi','lip','srp','kol','ruj','lis','stu','pro','s','v','o','t','s','l','s','k','r','l','s','p','sijeÄnja','veljaÄe','oÅ¾ujka','travnja','svibnja','lipnja','srpnja','kolovoza','rujna','listopada','studenoga','prosinca','ned','pon','uto','sri','Äet','pet','sub','nedjelja','ponedjeljak','utorak','srijeda','Äetvrtak','petak','subota');
INSERT INTO `locales` VALUES (171,'hr','HR','HRK','Kn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (172,'hu',NULL,NULL,NULL,NULL,NULL,',','Â ','#,##0.###','#,##0.00 Â¤',NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','yyyy. MMMM d.','yyyy. MMMM d.','yyyy.MM.dd.','yyyy.MM.dd.',NULL,'DE','DU',NULL,NULL,NULL,'jan.','febr.','mÃ¡rc.','Ã¡pr.','mÃ¡j.','jÃºn.','jÃºl.','aug.','szept.','okt.','nov.','dec.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januÃ¡r','februÃ¡r','mÃ¡rcius','Ã¡prilis','mÃ¡jus','jÃºnius','jÃºlius','augusztus','szeptember','oktÃ³ber','november','december','V','H','K','Sze','Cs','P','Szo','vasÃ¡rnap','hÃ©tfÅ‘','kedd','szerda','csÃ¼tÃ¶rtÃ¶k','pÃ©ntek','szombat');
INSERT INTO `locales` VALUES (173,'hu','HU','HUF','Ft',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (174,'hy',NULL,NULL,NULL,NULL,NULL,',','.','#0.###','#0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, MMMM d, yyyy','MMMM dd, yyyy','MMM d, yyyy','MM/dd/yy',NULL,'Ô±Õ¼â€¤','ÔµÖ€â€¤',NULL,NULL,NULL,'Õ…Õ¶Ö€','Õ“Õ¿Ö€','Õ„Ö€Õ¿','Ô±ÕºÖ€','Õ„ÕµÕ½','Õ…Õ¶Õ½','Õ…Õ¬Õ½','Õ•Õ£Õ½','ÕÕ¥Õº','Õ€Õ¸Õ¯','Õ†Õ¸Õµ','Ô´Õ¥Õ¯',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ…Õ¸Ö‚Õ¶Õ¸Ö‚Õ¡Ö€','Õ“Õ¥Õ¿Ö€Õ¸Ö‚Õ¡Ö€','Õ„Õ¡Ö€Õ¿','Ô±ÕºÖ€Õ«Õ¬','Õ„Õ¡ÕµÕ«Õ½','Õ…Õ¸Ö‚Õ¶Õ«Õ½','Õ…Õ¸Ö‚Õ¬Õ«Õ½','Õ•Õ£Õ¸Õ½Õ¿Õ¸Õ½','ÕÕ¥ÕºÕ¿Õ¥Õ´Õ¢Õ¥Ö€','Õ€Õ¸Õ¯Õ¿Õ¥Õ´Õ¢Õ¥Ö€','Õ†Õ¸ÕµÕ¥Õ´Õ¢Õ¥Ö€','Ô´Õ¥Õ¯Õ¿Õ¥Õ´Õ¢Õ¥Ö€','Ô¿Õ«Ö€','ÔµÖ€Õ¯','ÔµÖ€Ö„','Õ‰Õ¸Ö€','Õ€Õ¶Õ£','ÕˆÖ‚Ö€','Õ‡Õ¡Õ¢','Ô¿Õ«Ö€Õ¡Õ¯Õ«','ÔµÖ€Õ¯Õ¸Ö‚Õ·Õ¡Õ¢Õ©Õ«','ÔµÖ€Õ¥Ö„Õ·Õ¡Õ¢Õ©Õ«','Õ‰Õ¸Ö€Õ¥Ö„Õ·Õ¡Õ¢Õ©Õ«','Õ€Õ«Õ¶Õ£Õ·Õ¡Õ¢Õ©Õ«','ÕˆÖ‚Ö€Õ¢Õ¡Õ©','Õ‡Õ¡Õ¢Õ¡Õ©');
INSERT INTO `locales` VALUES (175,'hy','AM','AMD',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ€Õ¶Õ¾','Õ“Õ¿Õ¾',NULL,NULL,NULL,'Õ€Õ¶Õ½','Õ€Õ¬Õ½',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Õ€Õ¸Ö‚Õ¶Õ¾Õ¡Ö€','Õ“Õ¥Õ¿Ö€Õ¾Õ¡Ö€',NULL,NULL,NULL,'Õ€Õ¸Ö‚Õ¶Õ«Õ½','Õ€Õ¸Ö‚Õ¬Õ«Õ½',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (176,'ia',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'jan','feb','mar','apr','mai','jun','jul','aug','sep','oct','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januario','februario','martio','april','maio','junio','julio','augusto','septembre','octobre','novembre','decembre','dom','lun','mar','mer','jov','ven','sab','dominica','lunedi','martedi','mercuridi','jovedi','venerdi','sabbato');
INSERT INTO `locales` VALUES (177,'id',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mei','Jun','Jul','Agu','Sep','Okt','Nov','Des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Maret','April','Mei','Juni','Juli','Agustus','September','Oktober','November','Desember','Min','Sen','Sel','Rab','Kam','Jum','Sab','Minggu','Senin','Selasa','Rabu','Kamis','Jumat','Sabtu');
INSERT INTO `locales` VALUES (178,'id','ID','IDR','Rp',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss','H:mm:ss','H:mm:ss','H:mm','EEEE dd MMMM yyyy','dd MMMM yyyy','dd MMM yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (179,'ig',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'Jen','Feb','Maa','Epr','Mee','Juu','Jul','á»Œgá»','Sep','á»Œkt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jená»¥wará»‹','Febrá»¥wará»‹','Maachá»‹','Eprel','Mee','Juun','Julaá»‹','á»Œgá»á»st','Septemba','á»Œktoba','Novemba','Disemba','á»¤ka','Má»n','Tiu','Wen','Tá»á»','Fraá»‹','Sat','Mbá»sá»‹ á»¤ka','Má»nde','Tiuzdee','Wenezdee','Tá»á»zdee','Fraá»‹dee','Satá»dee');
INSERT INTO `locales` VALUES (180,'ig','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (181,'is',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maÃ­','jÃºn','jÃºl','Ã¡gÃº','sep','okt','nÃ³v','des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janÃºar','febrÃºar','mars','aprÃ­l','maÃ­','jÃºnÃ­','jÃºlÃ­','Ã¡gÃºst','september','oktÃ³ber','nÃ³vember','desember','sun','mÃ¡n','Ã¾ri','miÃ°','fim','fÃ¶s','lau','sunnudagur','mÃ¡nudagur','Ã¾riÃ°judagur','miÃ°vikudagur','fimmtudagur','fÃ¶studagur','laugardagur');
INSERT INTO `locales` VALUES (182,'is','IS','ISK','kr.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (183,'it',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE d MMMM yyyy','dd MMMM yyyy','dd/MMM/yy','dd/MM/yy',NULL,'m.','p.',NULL,NULL,NULL,'gen','feb','mar','apr','mag','giu','lug','ago','set','ott','nov','dic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'gennaio','febbraio','marzo','aprile','maggio','giugno','luglio','agosto','settembre','ottobre','novembre','dicembre','dom','lun','mar','mer','gio','ven','sab','domenica','lunedÃ¬','martedÃ¬','mercoledÃ¬','giovedÃ¬','venerdÃ¬','sabato');
INSERT INTO `locales` VALUES (184,'it','CH','CHF','SFr.','5','2','.','',NULL,'Â¤ #,##0.00;Â¤-#,##0.00',NULL,NULL,'HH.mm:ss\' h\' z',NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','d-MMM-yy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (185,'it','IT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss z',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (186,'iu',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á”­á“á“„áŠá“•','á••á•á•—áŠá“•','á’«á‘¦á“¯','áŠáƒá‘‰á³á“—','á’ªáƒ','á”«á“‚','á”ªá“šáƒ','áŠá…á’¡á’á“¯','á“°á‘¦á‘á•á•™','á†á‘¦á‘‘á•á•™','á“…á•™áƒá•á•™','á‘á“°á•á•™',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á”­á“á“„áŠá“•','á••á•á•—áŠá“•','á’«á‘¦á“¯','áŠáƒá‘‰á³á“—','á’ªáƒ','á”«á“‚','á”ªá“šáƒ','áŠá…á’¡á’á“¯','á“°á‘¦á‘á•á•™','á†á‘¦á‘‘á•á•™','á“…á•™áƒá•á•™','á‘á“°á•á•™','á“ˆá‘¦á“°á–‘á”­','á“‡á’¡á’á”¾á”­á…','á“‡á’¡á’á”¾á”­á…á“•á–…á‘­','á±á–“á‘¦á“¯á–…','á“¯á‘•á’»á’¥á–…','á‘•á“ªá“•á•á’¥á–…','á“ˆá‘¦á“°á–‘á”­á“•á–…á•¿','á“ˆá‘¦á“°á–‘á”­','á“‡á’¡á’á”¾á”­á…','á“‡á’¡á’á”¾á”­á…á“•á–…á‘­','á±á–“á‘¦á“¯á–…','á“¯á‘•á’»á’¥á–…','á‘•á“ªá“•á•á’¥á–…','á“ˆá‘¦á“°á–‘á”­á“•á–…á•¿');
INSERT INTO `locales` VALUES (187,'ja',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\'æ™‚\'mm\'åˆ†\'ss\'ç§’\'z','H:mm:ss:z','H:mm:ss','H:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy/MM/dd',NULL,NULL,'åˆå‰','åˆå¾Œ',NULL,NULL,NULL,'1 æœˆ','2 æœˆ','3 æœˆ','4 æœˆ','5 æœˆ','6 æœˆ','7 æœˆ','8 æœˆ','9 æœˆ','10 æœˆ','11 æœˆ','12 æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1 æœˆ','2 æœˆ','3 æœˆ','4 æœˆ','5 æœˆ','6 æœˆ','7 æœˆ','8 æœˆ','9 æœˆ','10 æœˆ','11 æœˆ','12 æœˆ','æ—¥','æœˆ','ç«','æ°´','æœ¨','é‡‘','åœŸ','æ—¥æ›œæ—¥','æœˆæ›œæ—¥','ç«æ›œæ—¥','æ°´æ›œæ—¥','æœ¨æ›œæ—¥','é‡‘æ›œæ—¥','åœŸæ›œæ—¥');
INSERT INTO `locales` VALUES (188,'ja','JP','JPY','ï¿¥','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (189,'ka',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—:áƒ¬áƒ›','áƒ¡áƒ—:áƒ¬áƒ—',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áƒ˜áƒáƒœ','áƒ—áƒ”áƒ‘','áƒ›áƒáƒ ','áƒáƒžáƒ ','áƒ›áƒáƒ˜','áƒ˜áƒ•áƒœ','áƒ˜áƒ•áƒš','áƒáƒ’áƒ•','áƒ¡áƒ”áƒ¥','áƒáƒ¥áƒ¢','áƒœáƒáƒ”','áƒ“áƒ”áƒ™',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áƒ˜áƒáƒœáƒ•áƒáƒ áƒ˜','áƒ—áƒ”áƒ‘áƒ”áƒ áƒ•áƒáƒšáƒ˜','áƒ›áƒáƒ áƒ¢áƒ˜','áƒáƒžáƒ áƒ˜áƒšáƒ˜','áƒ›áƒáƒ˜áƒ¡áƒ˜','áƒ˜áƒ•áƒœáƒ˜áƒ¡áƒ˜','áƒ˜áƒ•áƒšáƒ˜áƒ¡áƒ˜','áƒáƒ’áƒ•áƒ˜áƒ¡áƒ¢áƒ','áƒ¡áƒ”áƒ¥áƒ¢áƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒáƒ¥áƒ¢áƒáƒ›áƒ‘áƒ”áƒ áƒ˜','áƒœáƒáƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒ“áƒ”áƒ™áƒ”áƒ›áƒ‘áƒ”áƒ áƒ˜','áƒ™áƒ•áƒ˜','áƒáƒ áƒ¨','áƒ¡áƒáƒ›','áƒáƒ—áƒ®','áƒ®áƒ£áƒ—','áƒžáƒáƒ ','áƒ¨áƒáƒ‘','áƒ™áƒ•áƒ˜áƒ áƒ','áƒáƒ áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒ¡áƒáƒ›áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒáƒ—áƒ®áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒ®áƒ£áƒ—áƒ¨áƒáƒ‘áƒáƒ—áƒ˜','áƒžáƒáƒ áƒáƒ¡áƒ™áƒ”áƒ•áƒ˜','áƒ¨áƒáƒ‘áƒáƒ—áƒ˜');
INSERT INTO `locales` VALUES (190,'ka','GE','GEL','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (191,'kaj',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'A.M.','P.M.',NULL,NULL,NULL,'AÌ±yr','AÌ±hw','AÌ±ta','AÌ±na','AÌ±pf','AÌ±ki','AÌ±ty','AÌ±ni','AÌ±ku','Swa','Sby','Sbh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Hywan AÌ±yrnig','Hywan AÌ±hwa','Hywan AÌ±tat','Hywan AÌ±naai','Hywan AÌ±pfwon','Hywan AÌ±kitat','Hywan AÌ±tyirin','Hywan AÌ±ninai','Hywan AÌ±kumviriyin','Hywan Swak','Hywan Swak B\'aÌ±yrnig','Hywan Swak B\'aÌ±hwa','Lad','Lin','Tal','Lar','Lam','Jum','Asa','Ladi','Lintani','Talata','Larba','Lamit','Juma','Asabar');
INSERT INTO `locales` VALUES (192,'kaj','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (193,'kam',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mwei wa mbee','Mwei wa keli','Mwei wa katatu','Mwei wa kanne','Mwei wa katano','Mwei wa thanthatu','Mwei wa muonza','Mwei wa nyanya','Mwei wa kenda','Mwei wa ikumi','Mwei wa ikumi na imwe','Mwei wa ikumi na ili',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mwei wa mbee','Mwei wa keli','Mwei wa katatu','Mwei wa kanne','Mwei wa katano','Mwei wa thanthatu','Mwei wa muonza','Mwei wa nyanya','Mwei wa kenda','Mwei wa ikumi','Mwei wa ikumi na imwe','Mwei wa ikumi na ili','Jpl','Jtt','Jnn','Jtn','Alh','Ijm','Jms','Jumapili','Jumatatu','Jumanne','Jumatano','Alamisi','Ijumaa','Jumamosi');
INSERT INTO `locales` VALUES (194,'kam','KE','KES','KSh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (195,'kcg',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Juw','Swi','Tsa','Nya','Tsw','Ata','Ana','Ari','Aku','Swa','Man','Mas',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Zwat Juwung','Zwat Swiyang','Zwat Tsat','Zwat Nyai','Zwat Tswon','Zwat Ataah','Zwat Anatat','Zwat Arinai','Zwat Akubunyung','Zwat Swag','Zwat Mangjuwang','Zwat Swag-Ma-Suyang','Lad','Tan','Tal','Lar','Lam','Jum','Asa','Ladi','Tanii','Talata','Larba','Lamit','Juma','Asabat');
INSERT INTO `locales` VALUES (196,'kcg','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (197,'kfo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Wey','Fan','Tat','Nan','Tuy','Tso','Taf','War','Kun','Ban','Kom','Sau',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Fai Weyene','Fai Fani','Fai Tataka','Fai Nangra','Fai Tuyo','Fai Tsoyi','Fai Tafaka','Fai Warachi','Fai Kunobok','Fai Bansok','Fai Kom','Fai Sauk','Lah','Kub','Gba','Tan','Yei','Koy','Sat','Lahadi','Je-Kubacha','Je-Gbai','Tansati','Je-Yei','Je-Koye','Sati');
INSERT INTO `locales` VALUES (198,'kfo','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (199,'kk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy \'Ð¶.\'','d MMMM yyyy \'Ð¶.\'','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'Ò›Ð°Ò£.','Ð°Ò›Ð¿.','Ð½Ð°Ñƒ.','ÑÓ™Ñƒ.','Ð¼Ð°Ð¼.','Ð¼Ð°Ñƒ.','ÑˆÑ–Ð».','Ñ‚Ð°Ð¼.','Ò›Ñ‹Ñ€.','Ò›Ð°Ð·.','Ò›Ð°Ñ€.','Ð¶ÐµÐ»Ñ‚.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ò›Ð°Ò£Ñ‚Ð°Ñ€','Ð°Ò›Ð¿Ð°Ð½','Ð½Ð°ÑƒÑ€Ñ‹Ð·','ÑÓ™ÑƒÑ–Ñ€','Ð¼Ð°Ð¼Ñ‹Ñ€','Ð¼Ð°ÑƒÑÑ‹Ð¼','ÑˆÑ–Ð»Ð´Ðµ','Ñ‚Ð°Ð¼Ñ‹Ð·','Ò›Ñ‹Ñ€ÐºÒ¯Ð¹ÐµÐº','Ò›Ð°Ð·Ð°Ð½','Ò›Ð°Ñ€Ð°ÑˆÐ°','Ð¶ÐµÐ»Ñ‚Ð¾Ò›ÑÐ°Ð½','Ð¶Ñ.','Ð´Ñ.','ÑÑ.','ÑÑ€.','Ð±Ñ.','Ð¶Ð¼.','ÑÒ».','Ð¶ÐµÐºÑÐµÐ½Ñ–','Ð´ÑƒÐ¹ÑÐµÐ½Ð±Ñ–','ÑÐµÐ¹ÑÐµÐ½Ð±Ñ–','ÑÓ™Ñ€ÐµÐ½Ð±Ñ–','Ð±ÐµÐ¹ÑÐµÐ½Ð±Ñ–','Ð¶Ò±Ð¼Ð°','ÑÐµÐ½Ð±Ñ–');
INSERT INTO `locales` VALUES (200,'kk','KZ','KZT','Ñ‚Ò£Ð³.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤;-Â¤ #,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (201,'kl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','martsi','aprili','maji','juni','juli','augustusi','septemberi','oktoberi','novemberi','decemberi','sab','ata','mar','pin','sis','tal','arf','sabaat','ataasinngorneq','marlunngorneq','pingasunngorneq','sisamanngorneq','tallimanngorneq','arfininngorneq');
INSERT INTO `locales` VALUES (202,'kl','GL','DKK','kr',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤ -#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE dd MMMM yyyy','dd MMMM yyyy','MMM dd,yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (203,'km',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H\' áž˜áŸ‰áŸ„áž„ \'m\' áž“áž¶áž‘áž¸ \'ss\' ážœáž·áž“áž¶áž‘áž¸â€‹\' z','H\' áž˜áŸ‰áŸ„áž„ \'m\' áž“áž¶áž‘áž¸ \'ss\' ážœáž·áž“áž¶áž‘áž¸â€‹\'','H:mm:ss','H:mm','EEEE\' ážáŸ’áž„áŸƒ \'d\' ážáŸ‚ \'MMMM\' áž†áŸ’áž“áž¶áŸ† \' yyyy','EEEE\' ážáŸ’áž„áŸƒ \'d\' ážáŸ‚ \'MMMM\' áž†áŸ’áž“áž¶áŸ† \' yyyy','d MMMM yyyy','d/M/yyyy','{1}, {0}','áž–áŸ’ážšáž¹áž€','áž›áŸ’áž„áž¶áž…',NULL,NULL,NULL,'áŸ¡','áŸ¢','áŸ£','áŸ¤','áŸ¥','áŸ¦','áŸ§','áŸ¨','áŸ©','áŸ¡áŸ ','áŸ¡áŸ¡','áŸ¡áŸ¢',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áž˜áž€ážšáž¶','áž€áž»áž˜áŸ’áž—áŸˆ','áž˜áž·áž“áž¶','áž˜áŸážŸáž¶','áž§ážŸáž—áž¶','áž˜áž·ážáž»áž“áž¶','áž€áž€áŸ’áž€ážŠáž¶','ážŸáž¸áž áž¶','áž€áž‰áŸ’áž‰áž¶','ážáž»áž›áž¶','ážœáž·áž…áŸ’áž†áž·áž€áž¶','áž’áŸ’áž“áž¼','áž¢áž¶','áž…','áž¢','áž–áž»','áž–áŸ’ážš','ážŸáž»','ážŸ','ážáŸ’áž„áŸƒáž¢áž¶áž‘áž·ážáŸ’áž™','â€‹ážáŸ’áž„áŸƒáž…áŸáž“áŸ’áž‘','ážáŸ’áž„áŸƒáž¢áž„áŸ’áž‚áž¶ážš','ážáŸ’áž„áŸƒáž–áž»áž’','ážáŸ’áž„áŸƒáž–áŸ’ážšáž ážŸáŸ’áž”ážáž·áŸ','ážáŸ’áž„áŸƒážŸáž»áž€áŸ’ážš','ážáŸ’áž„áŸƒážŸáŸ…ážšáŸ');
INSERT INTO `locales` VALUES (204,'km','KH','KHR','áŸ›',NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (205,'kn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à²ªà³‚à²°à³à²µà²¾à²¹à³à²¨','à²…à²ªà²°à²¾à²¹à³à²¨',NULL,NULL,NULL,'à²œà²¨à²µà²°à³€','à²«à³†à²¬à³à²°à²µà²°à³€','à²®à²¾à²°à³à²šà³','à²Žà²ªà³à²°à²¿à²²à³','à²®à³†','à²œà³‚à²¨à³','à²œà³à²²à³ˆ','à²†à²—à²¸à³à²Ÿà³','à²¸à²ªà³à²Ÿà³†à²‚à²¬à²°à³','à²…à²•à³à²Ÿà³‹à²¬à²°à³','à²¨à²µà³†à²‚à²¬à²°à³','à²¡à²¿à²¸à³†à²‚à²¬à²°à³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à²œà²¨à²µà²°à³€','à²«à³†à²¬à³à²°à²µà²°à³€','à²®à²¾à²°à³à²šà³','à²Žà²ªà³à²°à²¿à²²à³','à²®à³†','à²œà³‚à²¨à³','à²œà³à²²à³ˆ','à²†à²—à²¸à³à²Ÿà³','à²¸à²ªà³à²Ÿà³†à²‚à²¬à²°à³','à²…à²•à³à²Ÿà³‹à²¬à²°à³','à²¨à²µà³†à²‚à²¬à²°à³','à²¡à²¿à²¸à³†à²‚à²¬à²°à³','à²°.','à²¸à³‹.','à²®à²‚.','à²¬à³.','à²—à³.','à²¶à³.','à²¶à²¨à²¿.','à²°à²µà²¿à²µà²¾à²°','à²¸à³‹à²®à²µà²¾à²°','à²®à²‚à²—à²³à²µà²¾à²°','à²¬à³à²§à²µà²¾à²°','à²—à³à²°à³à²µà²¾à²°','à²¶à³à²•à³à²°à²µà²¾à²°','à²¶à²¨à²¿à²µà²¾à²°');
INSERT INTO `locales` VALUES (206,'kn','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (207,'ko',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a hh\'ì‹œ\' mm\'ë¶„\' ss\'ì´ˆ\' z','a hh\'ì‹œ\' mm\'ë¶„\' ss\'ì´ˆ\'','a hh\'ì‹œ\' mm\'ë¶„\'','a hh\'ì‹œ\' mm\'ë¶„\'','yyyy\'ë…„\' M\'ì›”\' d\'ì¼\' EEEE','yyyy\'ë…„\' M\'ì›”\' d\'ì¼\'','yyyy. MM. dd','yy. MM. dd',NULL,'ì˜¤ì „','ì˜¤í›„',NULL,NULL,NULL,'1ì›”','2ì›”','3ì›”','4ì›”','5ì›”','6ì›”','7ì›”','8ì›”','9ì›”','10ì›”','11ì›”','12ì›”',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1ì›”','2ì›”','3ì›”','4ì›”','5ì›”','6ì›”','7ì›”','8ì›”','9ì›”','10ì›”','11ì›”','12ì›”','ì¼','ì›”','í™”','ìˆ˜','ëª©','ê¸ˆ','í† ','ì¼ìš”ì¼','ì›”ìš”ì¼','í™”ìš”ì¼','ìˆ˜ìš”ì¼','ëª©ìš”ì¼','ê¸ˆìš”ì¼','í† ìš”ì¼');
INSERT INTO `locales` VALUES (208,'ko','KR','KRW','ï¿¦','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,'a h:mm:ss','a h:mm',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (209,'kok',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤®.à¤ªà¥‚.','à¤®.à¤¨à¤‚.',NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥à¤°à¥à¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤³','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤†à¤¦à¤¿à¤¤à¥à¤¯à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤³à¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°');
INSERT INTO `locales` VALUES (210,'kok','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (211,'ku',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'BN','PN',NULL,NULL,NULL,'Ã§il','sib','adr','nÃ®s','gul','hez','tÃ®r',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ã§ile','sibat','adar','nÃ®san','gulan','hezÃ®ran',NULL,NULL,NULL,NULL,NULL,NULL,'yÅŸ','dÅŸ','sÅŸ','Ã§ÅŸ','pÅŸ','Ã®n','ÅŸ','yekÅŸem','duÅŸem','ÅŸÃª','Ã§arÅŸem','pÃªncÅŸem','Ã®n','ÅŸemÃ®');
INSERT INTO `locales` VALUES (212,'ku_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (213,'ku_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (214,'ku_Latn','IQ','IQD',NULL,'0','3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (215,'ku_Latn','IR','IRR',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (216,'ku_Latn','SY','SYP',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (217,'ku_Latn','TR','TRY',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (218,'kw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'a.m.','p.m.',NULL,NULL,NULL,'Gen','Whe','Mer','Ebr','Me','Efn','Gor','Est','Gwn','Hed','Du','Kev',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mys Genver','Mys Whevrel','Mys Merth','Mys Ebrel','Mys Me','Mys Efan','Mys Gortheren','Mye Est','Mys Gwyngala','Mys Hedra','Mys Du','Mys Kevardhu','Sul','Lun','Mth','Mhr','Yow','Gwe','Sad','De Sul','De Lun','De Merth','De Merher','De Yow','De Gwener','De Sadorn');
INSERT INTO `locales` VALUES (219,'kw','GB','GBP','Â£',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,'HH:mm:ss',NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (220,'ky',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (221,'ky','KG','KGS','ÑÐ¾Ð¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (222,'ln',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'s1','s2','s3','s4','s5','s6','s7','s8','s9','s10','s11','s12',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sÃ¡nzÃ¡ ya yambo','sÃ¡nzÃ¡ ya mÃ­balÃ©','sÃ¡nzÃ¡ ya mÃ­sÃ¡to','sÃ¡nzÃ¡ ya mÃ­nÃ©i','sÃ¡nzÃ¡ ya mÃ­tÃ¡no','sÃ¡nzÃ¡ ya motÃ³bÃ¡','sÃ¡nzÃ¡ ya nsambo','sÃ¡nzÃ¡ ya mwambe','sÃ¡nzÃ¡ ya libwa','sÃ¡nzÃ¡ ya zÃ³mÃ­','sÃ¡nzÃ¡ ya zÃ³mÃ­ na mÉ”ÌŒkÉ”Ì','sÃ¡nzÃ¡ ya zÃ³mÃ­ na mÃ­balÃ©','eye','m1','m2','m3','m4','m5','mps','eyenga','mokÉ”lÉ” ya libosÃ³','mokÉ”lÉ” ya mÃ­balÃ©','mokÉ”lÉ” ya mÃ­sÃ¡to','mokÉ”lÉ” ya mÃ­nÃ©i','mokÉ”lÉ” ya mÃ­tÃ¡no','mpÉ”ÌsÉ”');
INSERT INTO `locales` VALUES (223,'ln','CD','CDF','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (224,'ln','CG','XAF',NULL,'0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (225,'lo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\'à»‚àº¡àº‡ \'m\'àº™àº²àº—àºµ \'ss\' àº§àº´àº™àº²àº—àºµ','H\' à»‚àº¡àº‡ \'m\'àº™àº²àº—àºµ\'','H:mm:ss','H:mm','EEEE\'àº—àºµ  \'d MMMM G yyyy','d MMMM yyyy','d MMM yyyy','d/M/yyyy','{1}, {0}','àºà»ˆàº­àº™àº—à»ˆàº½àº‡','àº«àº¥àº±àº‡àº—à»ˆàº½àº‡',NULL,NULL,NULL,'àº¡.àº.','àº.àºž.','àº¡àºµ.àº™.','àº¡.àºª..','àºž.àºž.','àº¡àº´.àº–.','àº.àº¥.','àºª.àº«.','àº.àº.','àº•.àº¥.','àºž.àºˆ.','àº—.àº§.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'àº¡àº±àº‡àºàº­àº™','àºàº¸àº¡àºžàº²','àº¡àºµàº™àº²','à»€àº¡àºªàº²','àºžàº¶àº”àºªàº°àºžàº²','àº¡àº´àº–àº¸àº™àº²','àºà»àº¥àº°àºàº»àº”','àºªàº´àº‡àº«àº²','àºàº±àº™àºàº²','àº•àº¸àº¥àº²','àºžàº°àºˆàº´àº','àº—àº±àº™àº§àº²','àº­àº².','àºˆ.','àº­.','àºž.','àºžàº«.','àºªàº.','àºª.','àº§àº±àº™àº­àº²àº—àº´àº”','àº§àº±àº™àºˆàº±àº™','àº§àº±àº™àº­àº±àº‡àº„àº²àº™','àº§àº±àº™àºžàº¸àº”','àº§àº±àº™àºžàº°àº«àº±àº”','àº§àº±àº™àºªàº¸àº','àº§àº±àº™à»€àºªàº»àº²');
INSERT INTO `locales` VALUES (226,'lo','LA','LAK','â‚­',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (227,'lt',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy \'m.\' MMMM d \'d.\',EEEE','yyyy \'m.\' MMMM d \'d.\'','yyyy.MM.dd','yyyy-MM-dd',NULL,'prieÅ¡piet','popiet',NULL,NULL,NULL,'Sau','Vas','Kov','Bal','Geg','Bir','Lie','Rgp','Rgs','Spl','Lap','Grd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sausio','vasario','kovo','balandÅ¾io','geguÅ¾Ä—s','birÅ¾elio','liepos','rugpjÅ«Äio','rugsÄ—jo','spalio','lapkriÄio','gruodÅ¾io','Sk','Pr','An','Tr','Kt','Pn','Å t','sekmadienis','pirmadienis','antradienis','treÄiadienis','ketvirtadienis','penktadienis','Å¡eÅ¡tadienis');
INSERT INTO `locales` VALUES (228,'lt','LT','LTL','Lt',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (229,'lv',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, yyyy\'. gada \'d. MMMM','yyyy\'. gada \'d. MMMM','yyyy.d.M','yy.d.M',NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mai','JÅ«n','JÅ«l','Aug','Sep','Okt','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janvÄris','februÄris','marts','aprÄ«lis','maijs','jÅ«nijs','jÅ«lijs','augusts','septembris','oktobris','novembris','decembris','Sv','P','O','T','C','Pk','S','svÄ“tdiena','pirmdiena','otrdiena','treÅ¡diena','ceturtdiena','piektdiena','sestdiena');
INSERT INTO `locales` VALUES (230,'lv','LV','LVL','Ls',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (231,'mk',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd MMMM yyyy','dd MMMM yyyy','dd.M.yyyy','dd.M.yy',NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½.','Ñ„ÐµÐ².','Ð¼Ð°Ñ€.','Ð°Ð¿Ñ€.','Ð¼Ð°Ñ˜.','Ñ˜ÑƒÐ½.','Ñ˜ÑƒÐ».','Ð°Ð²Ð³.','ÑÐµÐ¿Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÐµÐ¼.','Ð´ÐµÐºÐµÐ¼.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½ÑƒÐ°Ñ€Ð¸','Ñ„ÐµÐ²Ñ€ÑƒÐ°Ñ€Ð¸','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½Ð¸','Ñ˜ÑƒÐ»Ð¸','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð²Ñ€Ð¸','Ð¾ÐºÑ‚Ð¾Ð¼Ð²Ñ€Ð¸','Ð½Ð¾ÐµÐ¼Ð²Ñ€Ð¸','Ð´ÐµÐºÐµÐ¼Ð²Ñ€Ð¸','Ð½ÐµÐ´.','Ð¿Ð¾Ð½.','Ð²Ñ‚.','ÑÑ€Ðµ.','Ñ‡ÐµÑ‚.','Ð¿ÐµÑ‚.','ÑÐ°Ð±.','Ð½ÐµÐ´ÐµÐ»Ð°','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»Ð½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²Ñ€Ñ‚Ð¾Ðº','Ð¿ÐµÑ‚Ð¾Ðº','ÑÐ°Ð±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (232,'mk','MK','MKD','MDen',NULL,NULL,NULL,NULL,'#,##0.###;(#,##0.###)',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (233,'ml',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à´°à´¾à´µà´¿à´²àµ†','à´µàµˆà´•àµ',NULL,NULL,NULL,'à´œà´¨àµ','à´«à´¿à´¬àµ','à´®à´¾à´±àµà´…','à´à´ªàµà´±à´¿à´²àµà´…','à´®àµ†à´¯àµ','à´œàµ‚à´£àµà´…','à´œàµ‚àµˆà´²','à´†à´—','à´¸àµ†à´ªàµà´¤à´‚','à´’à´•àµà´Ÿ','à´¨à´µà´‚','à´¡à´¿à´¸à´‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à´œà´¨àµà´µà´°à´¿','à´«à´¿à´¬àµà´±à´µà´°à´¿','à´®à´¾à´±àµà´…à´šàµà´…à´šàµ','à´à´ªàµà´±à´¿à´²àµà´…','à´®àµ†à´¯àµ','à´œàµ‚à´£àµà´…','à´œàµ‚àµˆà´²','à´†à´—à´¸àµà´¤àµà´…','à´¸àµ†à´ªàµà´¤à´‚à´¬à´±àµà´…','à´’à´•àµà´Ÿàµˆà´¬à´±àµà´…','à´¨à´µà´‚à´¬à´±àµà´…','à´¡à´¿à´¸à´‚à´¬à´±àµà´…','à´žà´¾','à´¤à´¿','à´šàµŠ','à´¬àµ','à´µàµà´¯','à´µàµ†','à´¶','à´žà´¾à´¯à´±àµà´…','à´¤à´¿à´™àµà´•à´³àµà´…','à´šàµŠà´µàµà´µ','à´¬àµà´¨à´­àµà´…','à´µàµà´¯à´¾à´´à´‚','à´µàµ†à´³àµà´³à´¿','à´¶à´¨à´¿');
INSERT INTO `locales` VALUES (234,'ml','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (235,'mn',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ…ÑƒÐ»','Ò¯Ñ…Ñ','Ð±Ð°Ñ€','Ñ‚ÑƒÑƒ','Ð»ÑƒÑƒ','Ð¼Ð¾Ð³','Ð¼Ð¾Ñ€','Ñ…Ð¾Ð½','Ð±Ð¸Ñ‡','Ñ‚Ð°Ñ…','Ð½Ð¾Ñ…','Ð³Ð°Ñ…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¥ÑƒÐ»Ð³Ð°Ð½Ð°','Ò®Ñ…ÑÑ€','Ð‘Ð°Ñ€','Ð¢ÑƒÑƒÐ»Ð°Ð¹','Ð›ÑƒÑƒ','ÐœÐ¾Ð³Ð¾Ð¹','ÐœÐ¾Ñ€ÑŒ','Ð¥Ð¾Ð½ÑŒ','Ð‘Ð¸Ñ‡','Ð¢Ð°Ñ…Ð¸Ð°','ÐÐ¾Ñ…Ð¾Ð¹','Ð“Ð°Ñ…Ð°Ð¹','ÐÑ','Ð”Ð°','ÐœÑ','Ð›Ñ…','ÐŸÒ¯','Ð‘Ð°','Ð‘Ñ','Ð½ÑÐ¼','Ð´Ð°Ð²Ð°Ð°','Ð¼ÑÐ³Ð¼Ð°Ñ€','Ð»Ñ…Ð°Ð³Ð²Ð°','Ð¿Ò¯Ñ€ÑÐ²','Ð±Ð°Ð°ÑÐ°Ð½','Ð±ÑÐ¼Ð±Ð°');
INSERT INTO `locales` VALUES (236,'mn','MN','MNT','â‚®',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (237,'mr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤®.à¤ªà¥‚.','à¤®.à¤¨à¤‚.',NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¾à¤¨à¥‡à¤µà¤¾à¤°à¥€','à¤«à¥‡à¤¬à¥ƒà¤µà¤¾à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥‚à¤¨','à¤œà¥à¤²à¥ˆ','à¤“à¤—à¤¸à¥à¤Ÿ','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤‚à¤¬à¤°','à¤“à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤µà¥à¤¹à¥‡à¤‚à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤‚à¤¬à¤°','à¤°à¤µà¤¿','à¤¸à¥‹à¤®','à¤®à¤‚à¤—à¤³','à¤¬à¥à¤§','à¤—à¥à¤°à¥','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤°à¤µà¤¿à¤µà¤¾à¤°','à¤¸à¥‹à¤®à¤µà¤¾à¤°','à¤®à¤‚à¤—à¤³à¤µà¤¾à¤°','à¤¬à¥à¤§à¤µà¤¾à¤°','à¤—à¥à¤°à¥à¤µà¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤µà¤¾à¤°','à¤¶à¤¨à¤¿à¤µà¤¾à¤°');
INSERT INTO `locales` VALUES (238,'mr','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (239,'ms',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mac','Apr','Mei','Jun','Jul','Ogos','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Mac','April','Mei','Jun','Julai','Ogos','September','Oktober','November','Disember','Ahd','Isn','Sel','Rab','Kha','Jum','Sab','Ahad','Isnin','Selasa','Rabu','Khamis','Jumaat','Sabtu');
INSERT INTO `locales` VALUES (240,'ms','BN','BND','$',NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h:mm:ss aa','H:mm:ss','H:mm:ss','H:mm:ss','dd MMMM yyyy','dd MMMM yyyy','dd/MM/yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (241,'ms','MY','MYR','RM',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm','EEEE dd MMM yyyy','dd MMMM yyyy','dd MMMM yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (242,'mt',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d \'taâ€™\' MMMM yyyy','d \'taâ€™\' MMMM yyyy','dd MMM yyyy','dd/MM/yyyy',NULL,'QN','WN',NULL,NULL,NULL,'Jan','Fra','Mar','Apr','Mej','Ä un','Lul','Awi','Set','Ott','Nov','DiÄ‹',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jannar','Frar','Marzu','April','Mejju','Ä unju','Lulju','Awissu','Settembru','Ottubru','Novembru','DiÄ‹embru','Ä¦ad','Tne','Tli','Erb','Ä¦am','Ä im','Sib','Il-Ä¦add','It-Tnejn','It-Tlieta','L-ErbgÄ§a','Il-Ä¦amis','Il-Ä imgÄ§a','Is-Sibt');
INSERT INTO `locales` VALUES (243,'mt','MT','MTL','Lm',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (244,'nb',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE d. MMMM yyyy','d. MMMM yyyy','d. MMM. yyyy','dd.MM.yy',NULL,'formiddag','ettermiddag',NULL,NULL,NULL,'jan.','feb.','mars','april','mai','juni','juli','aug.','sep.','okt.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','april','mai','juni','juli','august','september','oktober','november','desember','sÃ¸.','ma.','ti.','on.','to.','fr.','lÃ¸.','sÃ¸ndag','mandag','tirsdag','onsdag','torsdag','fredag','lÃ¸rdag');
INSERT INTO `locales` VALUES (245,'nb','NO','NOK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (246,'ne',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤ªà¥‚à¤°à¥à¤µà¤¾à¤¨à¥à¤¹','à¤…à¤ªà¤°à¤¾à¤¨à¥à¤¹',NULL,NULL,NULL,'à¤œà¤¨','à¤«à¥‡à¤¬','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¤¿','à¤®à¥‡','à¤œà¥à¤¨','à¤œà¥à¤²à¤¾','à¤…à¤—','à¤¸à¥‡à¤ªà¥à¤Ÿ','à¤…à¤•à¥à¤Ÿà¥‹','à¤¨à¥‹à¤­à¥‡','à¤¡à¤¿à¤¸à¥‡',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¤œà¤¨à¤µà¤°à¥€','à¤«à¥‡à¤¬à¥à¤°à¥à¤…à¤°à¥€','à¤®à¤¾à¤°à¥à¤š','à¤…à¤ªà¥à¤°à¤¿à¤²','à¤®à¥‡','à¤œà¥à¤¨','à¤œà¥à¤²à¤¾à¤ˆ','à¤…à¤—à¤¸à¥à¤¤','à¤¸à¥‡à¤ªà¥à¤Ÿà¥‡à¤®à¥à¤¬à¤°','à¤…à¤•à¥à¤Ÿà¥‹à¤¬à¤°','à¤¨à¥‹à¤­à¥‡à¤®à¥à¤¬à¤°','à¤¡à¤¿à¤¸à¥‡à¤®à¥à¤¬à¤°','à¤†à¤‡à¤¤','à¤¸à¥‹à¤®','à¤®à¤™à¥à¤—à¤²','à¤¬à¥à¤§','à¤¬à¤¿à¤¹à¥€','à¤¶à¥à¤•à¥à¤°','à¤¶à¤¨à¤¿','à¤†à¤‡à¤¤à¤¬à¤¾à¤°','à¤¸à¥‹à¤®à¤¬à¤¾à¤°','à¤®à¤™à¥à¤—à¤²à¤¬à¤¾à¤°','à¤¬à¥à¤§à¤¬à¤¾à¤°','à¤¬à¤¿à¤¹à¥€à¤¬à¤¾à¤°','à¤¶à¥à¤•à¥à¤°à¤¬à¤¾à¤°','à¤¶à¤¨à¤¿à¤¬à¤¾à¤°');
INSERT INTO `locales` VALUES (247,'ne','NP','NPR','à¤°à¥‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (248,'nl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH:mm:ss v',NULL,NULL,NULL,'EEEE d MMMM yyyy','d MMMM yyyy','d MMM yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mrt','apr','mei','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','maart','april','mei','juni','juli','augustus','september','oktober','november','december','zo','ma','di','wo','do','vr','za','zondag','maandag','dinsdag','woensdag','donderdag','vrijdag','zaterdag');
INSERT INTO `locales` VALUES (249,'nl','BE','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d-MMM-yy','d/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (250,'nl','NL','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'Â¤ #,##0.00;Â¤ #,##0.00-',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (251,'nn',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE d. MMMM yyyy','d. MMMM yyyy','d. MMM. yyyy','dd.MM.yy',NULL,'formiddag','ettermiddag',NULL,NULL,NULL,'jan.','feb.','mars','april','mai','juni','juli','aug.','sep.','okt.','nov.','des.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mars','april','mai','juni','juli','august','september','oktober','november','desember','sÃ¸.','mÃ¥.','ty.','on.','to.','fr.','la.','sÃ¸ndag','mÃ¥ndag','tysdag','onsdag','torsdag','fredag','laurdag');
INSERT INTO `locales` VALUES (252,'nn','NO','NOK','kr',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (253,'nr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Apr','Mey','Jun','Jul','Arh','Sep','Okt','Usi','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janabari','uFeberbari','uMatjhi','u-Apreli','Meyi','Juni','Julayi','Arhostosi','Septemba','Oktoba','Usinyikhaba','Disemba','Son','Mvu','Bil','Tha','Ne','Hla','Gqi','uSonto','uMvulo','uLesibili','Lesithathu','uLesine','ngoLesihlanu','umGqibelo');
INSERT INTO `locales` VALUES (254,'nr','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (255,'nso',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Apo','Mei','Jun','Jul','Ago','Set','Okt','Nof','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janaware','Feberware','MatÅ¡he','Aporele','Mei','June','Julae','Agostose','Setemere','Oktobore','Nofemere','Disemere','Son','Mos','Bed','Rar','Ne','Hla','Mok','Sontaga','Mosupalogo','Labobedi','Laboraro','Labone','Labohlano','Mokibelo');
INSERT INTO `locales` VALUES (256,'nso','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (257,'ny',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mal','Epu','Mei','Jun','Jul','Oga','Sep','Oku','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januwale','Febuluwale','Malichi','Epulo','Mei','Juni','Julai','Ogasiti','Seputemba','Okutoba','Novemba','Disemba','Mul','Lem','Wir','Tat','Nai','San','Wer','Lamulungu','Lolemba','Lachiwiri','Lachitatu','Lachinayi','Lachisanu','Loweruka');
INSERT INTO `locales` VALUES (258,'ny','MW','MWK','K',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (259,'om',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ama','Gur','Bit','Elb','Cam','Wax','Ado','Hag','Ful','Onk','Sad','Mud',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Amajjii','Guraandhala','Bitooteessa','Elba','Caamsa','Waxabajjii','Adooleessa','Hagayya','Fuulbana','Onkololeessa','Sadaasa','Muddee','Dil','Wix','Qib','Rob','Kam','Jim','San','Dilbata','Wiixata','Qibxata','Roobii','Kamiisa','Jimaata','Sanbata');
INSERT INTO `locales` VALUES (260,'om','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,'WD','WB',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (261,'om','KE','KES','Ksh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM d, yyyy','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,'WD','WB',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (262,'or',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¬œà¬¾à¬¨à­à¬†à¬°à­€','à¬«à­‡à¬¬à­à¬°à­à­Ÿà¬¾à¬°à­€','à¬®à¬¾à¬°à­à¬šà­à¬š','à¬…à¬ªà­à¬°à­‡à¬²','à¬®à­‡','à¬œà­à¬¨','à¬œà­à¬²à¬¾à¬‡','à¬…à¬—à¬·à­à¬Ÿ','à¬¸à­‡à¬ªà­à¬Ÿà­‡à¬®à­à¬¬à¬°','à¬…à¬•à­à¬Ÿà­‹à¬¬à¬°','à¬¨à¬­à­‡à¬®à­à¬¬à¬°','à¬¡à¬¿à¬¸à­‡à¬®à­à¬¬à¬°','à¬°à¬¬à¬¿','à¬¸à­‹à¬®','à¬®à¬™à­à¬—à¬³','à¬¬à­à¬§','à¬—à­à¬°à­','à¬¶à­à¬•à­à¬°','à¬¶à¬¨à¬¿','à¬°à¬¬à¬¿à¬¬à¬¾à¬°','à¬¸à­‹à¬®à¬¬à¬¾à¬°','à¬®à¬™à­à¬—à¬³à¬¬à¬¾à¬°','à¬¬à­à¬§à¬¬à¬¾à¬°','à¬—à­à¬°à­à¬¬à¬¾à¬°','à¬¶à­à¬•à­à¬°à¬¬à¬¾à¬°','à¬¶à¬¨à¬¿à¬¬à¬¾à¬°');
INSERT INTO `locales` VALUES (263,'or','IN','INR','â‚¨',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (264,'pa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¨¸à¨µà©‡à¨°à©‡','à¨¸à¨¼à¨¾à¨®',NULL,NULL,NULL,'à¨œà¨¨à¨µà¨°à©€','à¨«à¨¼à¨°à¨µà¨°à©€','à¨®à¨¾à¨°à¨š','à¨…à¨ªà©à¨°à©ˆà¨²','à¨®à¨ˆ','à¨œà©‚à¨¨','à¨œà©à¨²à¨¾à¨ˆ','à¨…à¨—à¨¸à¨¤','à¨¸à¨¤à©°à¨¬à¨°','à¨…à¨•à¨¤à©‚à¨¬à¨°','à¨¨à¨µà©°à¨¬à¨°','à¨¦à¨¸à©°à¨¬à¨°',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¨œà¨¨à¨µà¨°à©€','à¨«à¨¼à¨°à¨µà¨°à©€','à¨®à¨¾à¨°à¨š','à¨…à¨ªà©à¨°à©ˆà¨²','à¨®à¨ˆ','à¨œà©‚à¨¨','à¨œà©à¨²à¨¾à¨ˆ','à¨…à¨—à¨¸à¨¤','à¨¸à¨¤à©°à¨¬à¨°','à¨…à¨•à¨¤à©‚à¨¬à¨°','à¨¨à¨µà©°à¨¬à¨°','à¨¦à¨¸à©°à¨¬à¨°','à¨à¨¤.','à¨¸à©‹à¨®.','à¨®à©°à¨—à¨².','à¨¬à©à©±à¨§.','à¨µà©€à¨°.','à¨¸à¨¼à©à©±à¨•à¨°.','à¨¸à¨¼à¨¨à¨¿à©±à¨šà¨°.','à¨à¨¤à¨µà¨¾à¨°','à¨¸à©‹à¨®à¨µà¨¾à¨°','à¨®à©°à¨—à¨²à¨µà¨¾à¨°','à¨¬à©à©±à¨§à¨µà¨¾à¨°','à¨µà©€à¨°à¨µà¨¾à¨°','à¨¸à¨¼à©à©±à¨•à¨°à¨µà¨¾à¨°','à¨¸à¨¼à¨¨à¨¿à©±à¨šà¨°à¨µà¨¾à¨°');
INSERT INTO `locales` VALUES (265,'pa_Arab',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…Ø¦','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§Ø¦ÛŒ','Ø§Ú¯Ø³Øª','Ø³ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø§ØªÙˆØ§Ø±','Ù¾ÛŒØ±','Ù…Ù†Ú¯Ù„','Ø¨ÙØ¯Ú¾','Ø¬Ù…Ø¹Ø±Ø§Øª','Ø¬Ù…Ø¹Û','ÛÙØªÛ');
INSERT INTO `locales` VALUES (266,'pa_Arab','PK','PKR','Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (267,'pa_Guru',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (268,'pa_Guru','IN','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (269,'pl',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy','d MMMM yyyy','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,'st','lut','mrz','kw','maj','cz','lip','sier','wrz','paÅº','lis','gr','s','l','m','k','m','c','l','s','w','p','l','g','stycznia','lutego','marca','kwietnia','maja','czerwca','lipca','sierpnia','wrzeÅ›nia','paÅºdziernika','listopada','grudnia','niedz.','pon.','wt.','Å›r.','czw.','pt.','sob.','niedziela','poniedziaÅ‚ek','wtorek','Å›roda','czwartek','piÄ…tek','sobota');
INSERT INTO `locales` VALUES (270,'pl','PL','PLN','zÅ‚',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sty',NULL,'mar','kwi',NULL,'cze',NULL,'sie',NULL,NULL,NULL,'gru',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (271,'ps',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H:mm:ss (z)','H:mm:ss (z)','H:mm:ss','H:mm','EEEE Ø¯ yyyy Ø¯ MMMM d','Ø¯ yyyy Ø¯ MMMM d','d MMMM yyyy','yyyy/M/d',NULL,'Øº.Ù….','Øº.Ùˆ.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ù…Ù€ÛŒ','Ø¬ÙˆÙ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÙŠ','ÙØ¨Ø±ÙˆØ±ÙŠ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú«Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡');
INSERT INTO `locales` VALUES (272,'ps','AF','AFN','Ø‹',NULL,NULL,'Ù«','Ù¬',NULL,'#,##0.00 Â¤','Ùª','âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (273,'pt',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH\'H\'mm\'m\'ss\'s\' z',NULL,NULL,NULL,'EEEE, d\' de \'MMMM\' de \'yyyy','d\' de \'MMMM\' de \'yyyy','d/MMM/yyyy','dd-MM-yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janeiro','fevereiro','marÃ§o','abril','maio','junho','julho','agosto','setembro','outubro','novembro','dezembro','dom','seg','ter','qua','qui','sex','sÃ¡b','domingo','segunda-feira','terÃ§a-feira','quarta-feira','quinta-feira','sexta-feira','sÃ¡bado');
INSERT INTO `locales` VALUES (274,'pt','BR','BRL','R$',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'HH\'h\'mm\'min\'ss\'s\' z','H\'h\'m\'min\'s\'s\' z',NULL,NULL,NULL,NULL,'dd/MM/yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (275,'pt','PT','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'yyyy/MM/dd','yy/MM/dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (276,'ro',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'d MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'Ian','Feb','Mar','Apr','Mai','Iun','Iul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ianuarie','februarie','martie','aprilie','mai','iunie','iulie','august','septembrie','octombrie','noiembrie','decembrie','D','L','Ma','Mi','J','V','S','duminicÄƒ','luni','marÈ›i','miercuri','joi','vineri','sÃ®mbÄƒtÄƒ');
INSERT INTO `locales` VALUES (277,'ro','RO','RON',NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (278,'root',NULL,NULL,NULL,NULL,NULL,'.',',','#,##0.###','Â¤ #,##0.00','%','-','HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, yyyy MMMM dd','yyyy MMMM d','yyyy MMM d','yy/MM/dd','{1} {0}','AM','PM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1','2','3','4','5','6','7','8','9','10','11','12','1','2','3','4','5','6','7','1','2','3','4','5','6','7');
INSERT INTO `locales` VALUES (279,'ru',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00Â¤',NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','d MMMM yyyy\\u00a0\'Ð³.\'','d MMMM yyyy\\u00a0\'Ð³.\'','dd.MM.yyyy','dd.MM.yy',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÐ½Ð².','Ñ„ÐµÐ²Ñ€.','Ð¼Ð°Ñ€Ñ‚Ð°','Ð°Ð¿Ñ€.','Ð¼Ð°Ñ','Ð¸ÑŽÐ½Ñ','Ð¸ÑŽÐ»Ñ','Ð°Ð²Ð³.','ÑÐµÐ½Ñ‚.','Ð¾ÐºÑ‚.','Ð½Ð¾ÑÐ±.','Ð´ÐµÐº.','Ð¯','Ð¤','Ðœ','Ð','Ðœ','Ð˜','Ð˜','Ð','Ð¡','Ðž','Ð','Ð”','ÑÐ½Ð²Ð°Ñ€Ñ','Ñ„ÐµÐ²Ñ€Ð°Ð»Ñ','Ð¼Ð°Ñ€Ñ‚Ð°','Ð°Ð¿Ñ€ÐµÐ»Ñ','Ð¼Ð°Ñ','Ð¸ÑŽÐ½Ñ','Ð¸ÑŽÐ»Ñ','Ð°Ð²Ð³ÑƒÑÑ‚Ð°','ÑÐµÐ½Ñ‚ÑÐ±Ñ€Ñ','Ð¾ÐºÑ‚ÑÐ±Ñ€Ñ','Ð½Ð¾ÑÐ±Ñ€Ñ','Ð´ÐµÐºÐ°Ð±Ñ€Ñ','Ð’Ñ','ÐŸÐ½','Ð’Ñ‚','Ð¡Ñ€','Ð§Ñ‚','ÐŸÑ‚','Ð¡Ð±','Ð²Ð¾ÑÐºÑ€ÐµÑÐµÐ½ÑŒÐµ','Ð¿Ð¾Ð½ÐµÐ´ÐµÐ»ÑŒÐ½Ð¸Ðº','Ð²Ñ‚Ð¾Ñ€Ð½Ð¸Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²ÐµÑ€Ð³','Ð¿ÑÑ‚Ð½Ð¸Ñ†Ð°','ÑÑƒÐ±Ð±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (280,'ru','RU','RUB','Ñ€ÑƒÐ±.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (281,'ru','UA','UAH','Ð³Ñ€Ð½.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,'HH:mm:ss z','HH:mm:ss z','HH:mm:ss','HH:mm','EEEE, d MMMM yyyy \'Ð³.\'','d MMMM yyyy','d MMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (282,'rw',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'mut.','gas.','wer.','mat.','gic.','kam.','nya.','kan.','nze.','ukw.','ugu.','uku.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Mutarama','Gashyantare','Werurwe','Mata','Gicuransi','Kamena','Nyakanga','Kanama','Nzeli','Ukwakira','Ugushyingo','Ukuboza','cyu.','mbe.','kab.','gtu.','kan.','gnu.','gnd.','Ku cyumweru','Kuwa mbere','Kuwa kabiri','Kuwa gatatu','Kuwa kane','Kuwa gatanu','Kuwa gatandatu');
INSERT INTO `locales` VALUES (283,'rw','RW','RWF','F','0','-1',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (284,'sa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤#,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (285,'sa','IN','INR','à¤°à¥',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'hh:mm:ss a z','hh:mm:ss a z','hh:mm:ss a','hh:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (286,'se',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,'#,##0.00Â Â¤',NULL,'âˆ’',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'tsiengele','goevte','njoktje','voerhtje','suehpede','ruffie','snaltje','mietske','skierede','rihkede','rahka','goeve',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'aejlege','mÃ¥anta','dÃ¤jsta','gaskevahkoe','dÃ¥arsta','bearjadahke','laavadahke');
INSERT INTO `locales` VALUES (287,'se','NO','NOK','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'oÄ‘Ä‘j','guov','njuk','cuo','mies','geas','suoi','borg','ÄakÄ','golg','skÃ¡b','juov',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'oÄ‘Ä‘ajagemÃ¡nnu','guovvamÃ¡nnu','njukÄamÃ¡nnu','cuoÅ‹omÃ¡nnu','miessemÃ¡nnu','geassemÃ¡nnu','suoidnemÃ¡nnu','borgemÃ¡nnu','ÄakÄamÃ¡nnu','golggotmÃ¡nnu','skÃ¡bmamÃ¡nnu','juovlamÃ¡nnu','sotn','vuos','maÅ‹','gask','duor','bear','lÃ¡v','sotnabeaivi','vuossÃ¡rga','maÅ‹Å‹ebÃ¡rga','gaskavahkku','duorasdat','bearjadat','lÃ¡vvardat');
INSERT INTO `locales` VALUES (288,'sh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (289,'sh','BA','BAM',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (290,'sh','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (291,'sh','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (292,'sid',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'soodo','hawwaro',NULL,NULL,NULL,'Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'January','February','March','April','May','June','July','August','September','October','November','December','Sam','San','Mak','Row','Ham','Arb','Qid','Sambata','Sanyo','Maakisanyo','Roowe','Hamuse','Arbe','Qidaame');
INSERT INTO `locales` VALUES (293,'sid','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (294,'sk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, d. MMMM yyyy','d. MMMM yyyy','d.M.yyyy','d.M.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','mÃ¡j','jÃºn','jÃºl','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januÃ¡r','februÃ¡r','marec','aprÃ­l','mÃ¡j','jÃºn','jÃºl','august','september','oktÃ³ber','november','december','Ne','Po','Ut','St','Å t','Pi','So','NedeÄ¾a','Pondelok','Utorok','Streda','Å tvrtok','Piatok','Sobota');
INSERT INTO `locales` VALUES (295,'sk','SK','SKK','Sk',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (296,'sl',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'H:mm:ss z','H:mm:ss z','H:mm:ss','H:mm','EEEE, dd. MMMM yyyy','dd. MMMM yyyy','d.M.yyyy','d.M.yy',NULL,'dop.','pop.',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','avg','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','marec','april','maj','junij','julij','avgust','september','oktober','november','december','ned','pon','tor','sre','Äet','pet','sob','nedelja','ponedeljek','torek','sreda','Äetrtek','petek','sobota');
INSERT INTO `locales` VALUES (297,'sl','SI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (298,'so',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEE, MMMM dd, yyyy','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,'sn','gn',NULL,NULL,NULL,'Kob','Lab','Sad','Afr','Sha','Lix','Tod','Sid','Sag','Tob','KIT','LIT',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bisha Koobaad','Bisha Labaad','Bisha Saddexaad','Bisha Afraad','Bisha Shanaad','Bisha Lixaad','Bisha Todobaad','Bisha Sideedaad','Bisha Sagaalaad','Bisha Tobnaad','Bisha Kow iyo Tobnaad','Bisha Laba iyo Tobnaad','Axa','Isn','Sal','Arb','Kha','Jim','Sab','Axad','Isniin','Salaaso','Arbaco','Khamiis','Jimco','Sabti');
INSERT INTO `locales` VALUES (299,'so','DJ','DJF','$','0','-1',NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (300,'so','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (301,'so','KE','KES','Ksh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (302,'so','SO','SOS','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (303,'sq',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'h.mm.ss.a z','h.mm.ss.a z','h:mm:ss.a','h.mm.a','EEEE, dd MMMM yyyy','dd MMMM yyyy','yyyy-MM-dd','yy-MM-dd',NULL,'PD','MD',NULL,NULL,NULL,'Jan','Shk','Mar','Pri','Maj','Qer','Kor','Gsh','Sht','Tet','NÃ«n','Dhj',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'janar','shkurt','mars','prill','maj','qershor','korrik','gusht','shtator','tetor','nÃ«ntor','dhjetor','Die','HÃ«n','Mar','MÃ«r','Enj','Pre','Sht','e diel','e hÃ«nÃ«','e martÃ«','e mÃ«rkurÃ«','e enjte','e premte','e shtunÃ«');
INSERT INTO `locales` VALUES (304,'sq','AL','ALL','Lek',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (305,'sr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,NULL,NULL,NULL,'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE, dd.MMMM.yyyy.','dd.MM.yyyy.','dd.MM.yyyy.','d.M.yy.',NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½','Ñ„ÐµÐ±','Ð¼Ð°Ñ€','Ð°Ð¿Ñ€','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½','Ñ˜ÑƒÐ»','Ð°Ð²Ð³','ÑÐµÐ¿','Ð¾ÐºÑ‚','Ð½Ð¾Ð²','Ð´ÐµÑ†',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜Ð°Ð½ÑƒÐ°Ñ€','Ñ„ÐµÐ±Ñ€ÑƒÐ°Ñ€','Ð¼Ð°Ñ€Ñ‚','Ð°Ð¿Ñ€Ð¸Ð»','Ð¼Ð°Ñ˜','Ñ˜ÑƒÐ½','Ñ˜ÑƒÐ»','Ð°Ð²Ð³ÑƒÑÑ‚','ÑÐµÐ¿Ñ‚ÐµÐ¼Ð±Ð°Ñ€','Ð¾ÐºÑ‚Ð¾Ð±Ð°Ñ€','Ð½Ð¾Ð²ÐµÐ¼Ð±Ð°Ñ€','Ð´ÐµÑ†ÐµÐ¼Ð±Ð°Ñ€','Ð½ÐµÐ´','Ð¿Ð¾Ð½','ÑƒÑ‚Ð¾','ÑÑ€Ðµ','Ñ‡ÐµÑ‚','Ð¿ÐµÑ‚','ÑÑƒÐ±','Ð½ÐµÐ´ÐµÑ™Ð°','Ð¿Ð¾Ð½ÐµÐ´ÐµÑ™Ð°Ðº','ÑƒÑ‚Ð¾Ñ€Ð°Ðº','ÑÑ€ÐµÐ´Ð°','Ñ‡ÐµÑ‚Ð²Ñ€Ñ‚Ð°Ðº','Ð¿ÐµÑ‚Ð°Ðº','ÑÑƒÐ±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (306,'sr_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (307,'sr_Cyrl','BA','BAM','ÐšÐœ.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 ÐºÐ¼',NULL,NULL,'HH \'Ñ‡Ð°ÑÐ¾Ð²Ð°\', mm \'Ð¼Ð¸Ð½ÑƒÑ‚Ð°\', ss\' ÑÐµÐºÑƒÐ½Ð´Ð¸\'',NULL,'HH:mm:ss','HH:mm','EEEE, dd. MMMM yyyy.','dd. MMMM yyyy.','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ñ˜ÑƒÐ½Ð¸','Ñ˜ÑƒÐ»Ð¸',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ€Ð¸',NULL,NULL,NULL,NULL,NULL,NULL,'ÑÑ€Ð¸Ñ˜ÐµÐ´Ð°',NULL,NULL,NULL);
INSERT INTO `locales` VALUES (308,'sr_Cyrl','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (309,'sr_Cyrl','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (310,'sr_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, dd. MMMM yyyy.','EEEE, d.MM.yyyy.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','avg','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januar','februar','mart','april','maj','jun','jul','avgust','septembar','oktobar','novembar','decembar','ned','pon','uto','sre','Äet','pet','sub','nedelja','ponedeljak','utorak','sreda','Äetvrtak','petak','subota');
INSERT INTO `locales` VALUES (311,'sr_Latn','BA','BAM','KM.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 km',NULL,NULL,'HH \'Äasova\', mm \'minuta\', ss \'sekundi\'',NULL,'HH:mm:ss','HH:mm',NULL,'dd. MMMM yyyy.','yyyy-MM-dd','yy-MM-dd',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'juni','juli',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'sri',NULL,NULL,NULL,NULL,NULL,NULL,'srijeda',NULL,NULL,NULL);
INSERT INTO `locales` VALUES (312,'sr_Latn','CS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (313,'sr_Latn','RS','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (314,'sr_Latn','ME','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (315,'sr_Latn','YU',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (316,'ss',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bhi','Van','Vol','Mab','Nkh','Nhl','Kho','Ngc','Nyo','Mph','Lwe','Ngo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Bhimbidvwane','iNdlovana','iNdlovu-lenkhulu','Mabasa','iNkhwekhweti','iNhlaba','Kholwane','iNgci','iNyoni','iMphala','Lweti','iNgongoni','Son','Mso','Bil','Tsa','Ne','Hla','Mgc','Lisontfo','uMsombuluko','Lesibili','Lesitsatfu','Lesine','Lesihlanu','uMgcibelo');
INSERT INTO `locales` VALUES (317,'ss','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (318,'st',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phe','Kol','Ube','Mme','Mot','Jan','Upu','Pha','Leo','Mph','Pun','Tsh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phesekgong','Hlakola','Hlakubele','Mmese','Motsheanong','Phupjane','Phupu','Phata','Leotshe','Mphalane','Pundungwane','Tshitwe','Son','Mma','Bed','Rar','Ne','Hla','Moq','Sontaha','Mmantaha','Labobedi','Laboraru','Labone','Labohlane','Moqebelo');
INSERT INTO `locales` VALUES (319,'st','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (320,'sv',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,'#,##0.00 Â¤',NULL,'âˆ’','\'kl. \'HH.mm.ss z','HH.mm.ss z','HH.mm.ss','HH.mm','EEEE\'en den\' d MMMM yyyy','EEEE d MMM yyyy','d MMM yyyy','yyyy-MM-dd',NULL,'fm','em',NULL,NULL,NULL,'jan','feb','mar','apr','maj','jun','jul','aug','sep','okt','nov','dec',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'januari','februari','mars','april','maj','juni','juli','augusti','september','oktober','november','december','sÃ¶n','mÃ¥n','tis','ons','tors','fre','lÃ¶r','sÃ¶ndag','mÃ¥ndag','tisdag','onsdag','torsdag','fredag','lÃ¶rdag');
INSERT INTO `locales` VALUES (321,'sv','FI','EUR','â‚¬',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (322,'sv','SE','SEK','kr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEE d MMM yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (323,'sw',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mar','Apr','Mei','Jun','Jul','Ago','Sep','Okt','Nov','Des',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januari','Februari','Machi','Aprili','Mei','Juni','Julai','Agosti','Septemba','Oktoba','Novemba','Desemba','Jpi','Jtt','Jnn','Jtn','Alh','Iju','Jmo','Jumapili','Jumatatu','Jumanne','Jumatano','Alhamisi','Ijumaa','Jumamosi');
INSERT INTO `locales` VALUES (324,'sw','KE','KES','KSh',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (325,'sw','TZ','TZS','TSh',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (326,'syr',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÜÜŸÜ¢Â ÜÜ’','Ü«Ü’Ü›','ÜÜ•Üª','Ü¢ÜÜ£Ü¢','ÜÜÜª','ÜšÜ™ÜÜªÜ¢','Ü¬Ü¡Ü˜Ü™','ÜÜ’','ÜÜÜ Ü˜Ü ','ÜÜ¬Ü«Â ÜÜ','ÜÜ¬Ü«Â ÜÜ’','ÜÜŸÜ¢Â ÜÜ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (327,'syr','SY','SYP','Ù„.Ø³.â€',NULL,NULL,NULL,NULL,'#,##0.###;#,##0.###-','Â¤ #,##0.00;Â¤ #,##0.00-',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss','h:mm','dd MMMM, yyyy','dd MMMM, yyyy','dd/MM/yyyy','dd/MM/yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (328,'ta',NULL,NULL,NULL,NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à®•à®¾à®²à¯ˆ','à®®à®¾à®²à¯ˆ',NULL,NULL,NULL,'à®œà®©.','à®ªà®¿à®ªà¯.','à®®à®¾à®°à¯.','à®à®ªà¯.','à®®à¯‡','à®œà¯‚à®©à¯','à®œà¯‚à®²à¯ˆ','à®†à®•.','à®šà¯†à®ªà¯.','à®…à®•à¯.','à®¨à®µ.','à®Ÿà®¿à®š.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à®œà®©à®µà®°à®¿','à®ªà®¿à®ªà¯à®°à®µà®°à®¿','à®®à®¾à®°à¯à®šà¯','à®à®ªà¯à®°à®²à¯','à®®à¯‡','à®œà¯‚à®©à¯','à®œà¯‚à®²à¯ˆ','à®†à®•à®¸à¯à®Ÿà¯','à®šà¯†à®ªà¯à®Ÿà®®à¯à®ªà®°à¯','à®…à®•à¯à®Ÿà¯‹à®ªà®°à¯','à®¨à®µà®®à¯à®ªà®°à¯','à®Ÿà®¿à®šà®®à¯à®ªà®°à¯','à®žà®¾','à®¤à®¿','à®šà¯†','à®ªà¯','à®µà®¿','à®µà¯†','à®š','à®žà®¾à®¯à®¿à®±à¯','à®¤à®¿à®™à¯à®•à®³à¯','à®šà¯†à®µà¯à®µà®¾à®¯à¯','à®ªà¯à®¤à®©à¯','à®µà®¿à®¯à®¾à®´à®©à¯','à®µà¯†à®³à¯à®³à®¿','à®šà®©à®¿');
INSERT INTO `locales` VALUES (329,'ta','IN','INR','à®°à¯‚',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','d-M-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (330,'te',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à°ªà±‚à°°à±à°µà°¾à°¹à±à°¨à°‚','à°…à°ªà°°à°¾à°¹à±à°¨à°‚',NULL,NULL,NULL,'à°œà°¨à°µà°°à°¿','à°«à°¿à°¬à±à°°à°µà°°à°¿','à°®à°¾à°°à±à°šà°¿','à°à°ªà±à°°à°¿à°²à±','à°®à±‡','à°œà±‚à°¨à±','à°œà±‚à°²à±ˆ','à°†à°—à°¸à±à°Ÿà±','à°¸à±†à°ªà±à°Ÿà±†à°‚à°¬à°°à±','à°…à°•à±à°Ÿà±‹à°¬à°°à±','à°¨à°µà°‚à°¬à°°à±','à°¡à°¿à°¸à±†à°‚à°¬à°°à±',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à°œà°¨à°µà°°à°¿','à°«à°¿à°¬à±à°°à°µà°°à°¿','à°®à°¾à°°à±à°šà°¿','à°à°ªà±à°°à°¿à°²à±','à°®à±‡','à°œà±‚à°¨à±','à°œà±‚à°²à±ˆ','à°†à°—à°¸à±à°Ÿà±','à°¸à±†à°ªà±à°Ÿà±†à°‚à°¬à°°à±','à°…à°•à±à°Ÿà±‹à°¬à°°à±','à°¨à°µà°‚à°¬à°°à±','à°¡à°¿à°¸à±†à°‚à°¬à°°à±','à°†à°¦à°¿','à°¸à±‹à°®','à°®à°‚à°—à°³','à°¬à±à°§','à°—à±à°°à±','à°¶à±à°•à±à°°','à°¶à°¨à°¿','à°†à°¦à°¿à°µà°¾à°°à°‚','à°¸à±‹à°®à°µà°¾à°°à°‚','à°®à°‚à°—à°³à°µà°¾à°°à°‚','à°¬à±à°§à°µà°¾à°°à°‚','à°—à±à°°à±à°µà°¾à°°à°‚','à°¶à±à°•à±à°°à°µà°¾à°°à°‚','à°¶à°¨à°¿à°µà°¾à°°à°‚');
INSERT INTO `locales` VALUES (331,'te','IN','INR','à°°à±‚.',NULL,NULL,NULL,NULL,'#,##,##0.###','Â¤ #,##,##0.00',NULL,NULL,'h:mm:ss a z','h:mm:ss a z','h:mm:ss a','h:mm a','EEEE d MMMM yyyy','d MMMM yyyy','dd-MM-yyyy','dd-MM-yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (332,'tg',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¿Ðµ. Ñ‡Ð¾.','Ð¿Ð°. Ñ‡Ð¾.',NULL,NULL,NULL,'Ð¯Ð½Ð²','Ð¤ÐµÐ²','ÐœÐ°Ñ€','ÐÐ¿Ñ€','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³','Ð¡ÐµÐ½','ÐžÐºÑ‚','ÐÐ¾Ñ','Ð”ÐµÐº',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¯Ð½Ð²Ð°Ñ€','Ð¤ÐµÐ²Ñ€Ð°Ð»','ÐœÐ°Ñ€Ñ‚','ÐÐ¿Ñ€ÐµÐ»','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³ÑƒÑÑ‚','Ð¡ÐµÐ½Ñ‚ÑÐ±Ñ€','ÐžÐºÑ‚ÑÐ±Ñ€','ÐÐ¾ÑÐ±Ñ€','Ð”ÐµÐºÐ°Ð±Ñ€','Ð¯ÑˆÐ±','Ð”ÑˆÐ±','Ð¡ÑˆÐ±','Ð§ÑˆÐ±','ÐŸÑˆÐ±','Ò¶Ð¼ÑŠ','Ð¨Ð½Ð±','Ð¯ÐºÑˆÐ°Ð½Ð±Ðµ','Ð”ÑƒÑˆÐ°Ð½Ð±Ðµ','Ð¡ÐµÑˆÐ°Ð½Ð±Ðµ','Ð§Ð¾Ñ€ÑˆÐ°Ð½Ð±Ðµ','ÐŸÐ°Ð½Ò·ÑˆÐ°Ð½Ð±Ðµ','Ò¶ÑƒÐ¼ÑŠÐ°','Ð¨Ð°Ð½Ð±Ðµ');
INSERT INTO `locales` VALUES (333,'tg','TJ','TJS','ÑÐ¾Ð¼',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (334,'th',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'H\' à¸™à¸²à¸¬à¸´à¸à¸² \'m\' à¸™à¸²à¸—à¸µ \'ss\' à¸§à¸´à¸™à¸²à¸—à¸µ\'','H\' à¸™à¸²à¸¬à¸´à¸à¸² \'m\' à¸™à¸²à¸—à¸µ\'','H:mm:ss','H:mm','EEEE\'à¸—à¸µà¹ˆ \'d MMMM G yyyy','d MMMM yyyy','d MMM yyyy','d/M/yyyy','{1}, {0}',NULL,NULL,NULL,NULL,NULL,'à¸¡.à¸„.','à¸.à¸ž.','à¸¡à¸µ.à¸„.','à¹€à¸¡.à¸¢.','à¸ž.à¸„.','à¸¡à¸´.à¸¢.','à¸.à¸„.','à¸ª.à¸„.','à¸.à¸¢.','à¸•.à¸„.','à¸ž.à¸¢.','à¸˜.à¸„.',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'à¸¡à¸à¸£à¸²à¸„à¸¡','à¸à¸¸à¸¡à¸ à¸²à¸žà¸±à¸™à¸˜à¹Œ','à¸¡à¸µà¸™à¸²à¸„à¸¡','à¹€à¸¡à¸©à¸²à¸¢à¸™','à¸žà¸¤à¸©à¸ à¸²à¸„à¸¡','à¸¡à¸´à¸–à¸¸à¸™à¸²à¸¢à¸™','à¸à¸£à¸à¸Žà¸²à¸„à¸¡','à¸ªà¸´à¸‡à¸«à¸²à¸„à¸¡','à¸à¸±à¸™à¸¢à¸²à¸¢à¸™','à¸•à¸¸à¸¥à¸²à¸„à¸¡','à¸žà¸¤à¸¨à¸ˆà¸´à¸à¸²à¸¢à¸™','à¸˜à¸±à¸™à¸§à¸²à¸„à¸¡','à¸­à¸².','à¸ˆ.','à¸­.','à¸ž.','à¸žà¸¤.','à¸¨.','à¸ª.','à¸­à¸²à¸—à¸´à¸•à¸¢à¹Œ','à¸ˆà¸±à¸™à¸—à¸£à¹Œ','à¸­à¸±à¸‡à¸„à¸²à¸£','à¸žà¸¸à¸˜','à¸žà¸¤à¸«à¸±à¸ªà¸šà¸”à¸µ','à¸¨à¸¸à¸à¸£à¹Œ','à¹€à¸ªà¸²à¸£à¹Œ');
INSERT INTO `locales` VALUES (335,'th','TH','THB','à¸¿',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;Â¤-#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (336,'ti',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŠ•áŒ‰áˆ† áˆ°á‹“á‰°','á‹µáˆ•áˆ­ áˆ°á‹“á‰µ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áˆ°áŠ•á‰ ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ¨á‰¡á‹•','áŠƒáˆ™áˆµ','á‹“áˆ­á‰¢','á‰€á‹³áˆ','áˆ°áŠ•á‰ á‰µ','áˆ°áŠ‘á‹­','áˆ áˆ‰áˆµ','áˆ¨á‰¡á‹•','áŠƒáˆ™áˆµ','á‹“áˆ­á‰¢','á‰€á‹³áˆ');
INSERT INTO `locales` VALUES (337,'ti','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM áˆ˜á‹“áˆá‰² yyyy G','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,'áŒ¥áˆª','áˆˆáŠ«á‰²','áˆ˜áŒ‹á‰¢','áˆšá‹«á‹','áŒáŠ•á‰¦','áˆ°áŠ','áˆ“áˆáˆˆ','áŠáˆ“áˆ°','áˆ˜áˆµáŠ¨','áŒ¥á‰…áˆ','áˆ•á‹³áˆ­','á‰³áˆ•áˆ³',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒ¥áˆª','áˆˆáŠ«á‰²á‰µ','áˆ˜áŒ‹á‰¢á‰µ','áˆšá‹«á‹á‹«','áŒáŠ•á‰¦á‰µ','áˆ°áŠ','áˆ“áˆáˆˆ','áŠáˆ“áˆ°','áˆ˜áˆµáŠ¨áˆ¨áˆ','áŒ¥á‰…áˆá‰²','áˆ•á‹³áˆ­','á‰³áˆ•áˆ³áˆµ',NULL,NULL,'áˆ°áˆ‰áˆµ',NULL,'áˆ“áˆ™áˆµ',NULL,NULL,NULL,NULL,'áˆ°áˆ‰áˆµ',NULL,'áˆ“áˆ™áˆµ',NULL,NULL);
INSERT INTO `locales` VALUES (338,'ti','ET','ETB','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá£ dd MMMM áˆ˜á‹“áˆá‰² yyyy G','dd MMMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (339,'tig',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'á‰€á‹°áˆ áˆ°áˆ­áˆá‹•áˆ','áˆ“á‰† áˆµáˆ­áˆá‹•áˆ',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','áˆ°/á‹“','áˆ°áŠ–','á‰³áˆ‹áˆ¸','áŠ£áˆ¨áˆ­','áŠ¨áˆšáˆ½','áŒ…áˆá‹“','áˆ°/áŠ•','áˆ°áŠ•á‰ á‰µ á‹“á‰£á‹­','áˆ°áŠ–','á‰³áˆ‹áˆ¸áŠ–','áŠ£áˆ¨áˆ­á‰£á‹“','áŠ¨áˆšáˆ½','áŒ…áˆá‹“á‰µ','áˆ°áŠ•á‰ á‰µ áŠ•áŠ¢áˆ½');
INSERT INTO `locales` VALUES (340,'tig','ER','ERN','$',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¡ dd MMMM á‹®áˆ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (341,'tn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Fer','Tlh','Mop','Mor','Mot','See','Phu','Pha','Lwe','Dip','Ngw','Sed',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ferikgong','Tlhakole','Mopitlo','Moranang','Motsheganang','Seetebosigo','Phukwi','Phatwe','Lwetse','Diphalane','Ngwanatsele','Sedimonthole','Tsh','Mos','Bed','Rar','Ne','Tla','Mat','Tshipi','Mosopulogo','Labobedi','Laboraro','Labone','Labotlhano','Matlhatso');
INSERT INTO `locales` VALUES (342,'tn','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (343,'tr',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'dd MMMM yyyy EEEE','dd MMMM yyyy EEEE','dd.MMM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,'Oca','Åžub','Mar','Nis','May','Haz','Tem','AÄŸu','Eyl','Eki','Kas','Ara',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ocak','Åžubat','Mart','Nisan','MayÄ±s','Haziran','Temmuz','AÄŸustos','EylÃ¼l','Ekim','KasÄ±m','AralÄ±k','Paz','Pzt','Sal','Ã‡ar','Per','Cum','Cmt','Pazar','Pazartesi','SalÄ±','Ã‡arÅŸamba','PerÅŸembe','Cuma','Cumartesi');
INSERT INTO `locales` VALUES (344,'tr','TR','TRY','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (345,'ts',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sun','Yan','Kul','Dzi','Mud','Kho','Maw','Mha','Ndz','Nhl','Huk','N\'w',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Sunguti','Nyenyenyani','Nyenyankulu','Dzivamisoko','Mudyaxihi','Khotavuxika','Mawuwani','Mhawuri','Ndzhati','Nhlangula','Hukuri','N\'wendzamhala','Son','Mus','Bir','Har','Ne','Tlh','Mug','Sonto','Musumbhunuku','Ravumbirhi','Ravunharhu','Ravumune','Ravuntlhanu','Mugqivela');
INSERT INTO `locales` VALUES (346,'ts','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (347,'tt',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (348,'tt','RU','RUB',NULL,NULL,NULL,NULL,NULL,NULL,'#,##0.00Â¤',NULL,NULL,'h:mm:ss a','H:mm:ss','H:mm:ss','H:mm:ss','d MMMM yyyy','d MMMM yyyy','dd.MM.yyyy','dd.MM.yyyy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (349,'uk',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, d MMMM yyyy \'Ñ€.\'','d MMMM yyyy','d MMM yyyy','dd.MM.yy',NULL,'Ð´Ð¿','Ð¿Ð¿',NULL,NULL,NULL,'ÑÑ–Ñ‡.','Ð»ÑŽÑ‚.','Ð±ÐµÑ€.','ÐºÐ²Ñ–Ñ‚.','Ñ‚Ñ€Ð°Ð².','Ñ‡ÐµÑ€Ð².','Ð»Ð¸Ð¿.','ÑÐµÑ€Ð¿.','Ð²ÐµÑ€.','Ð¶Ð¾Ð²Ñ‚.','Ð»Ð¸ÑÑ‚.','Ð³Ñ€ÑƒÐ´.','Ð¡','Ð›','Ð‘','Ðš','Ð¢','Ð§','Ð›','Ð¡','Ð’','Ð–','Ð›','Ð“','ÑÑ–Ñ‡Ð½Ñ','Ð»ÑŽÑ‚Ð¾Ð³Ð¾','Ð±ÐµÑ€ÐµÐ·Ð½Ñ','ÐºÐ²Ñ–Ñ‚Ð½Ñ','Ñ‚Ñ€Ð°Ð²Ð½Ñ','Ñ‡ÐµÑ€Ð²Ð½Ñ','Ð»Ð¸Ð¿Ð½Ñ','ÑÐµÑ€Ð¿Ð½Ñ','Ð²ÐµÑ€ÐµÑÐ½Ñ','Ð¶Ð¾Ð²Ñ‚Ð½Ñ','Ð»Ð¸ÑÑ‚Ð¾Ð¿Ð°Ð´Ð°','Ð³Ñ€ÑƒÐ´Ð½Ñ','ÐÐ´','ÐŸÐ½','Ð’Ñ‚','Ð¡Ñ€','Ð§Ñ‚','ÐŸÑ‚','Ð¡Ð±','ÐÐµÐ´Ñ–Ð»Ñ','ÐŸÐ¾Ð½ÐµÐ´Ñ–Ð»Ð¾Ðº','Ð’Ñ–Ð²Ñ‚Ð¾Ñ€Ð¾Ðº','Ð¡ÐµÑ€ÐµÐ´Ð°','Ð§ÐµÑ‚Ð²ÐµÑ€','ÐŸÊ¼ÑÑ‚Ð½Ð¸Ñ†Ñ','Ð¡ÑƒÐ±Ð¾Ñ‚Ð°');
INSERT INTO `locales` VALUES (350,'uk','UA','UAH','Ð³Ñ€Ð½.',NULL,NULL,NULL,NULL,NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (351,'ur',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (352,'ur','IN','INR','â‚¨',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (353,'ur','PK','PKR','Rs',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (354,'uz',NULL,NULL,NULL,NULL,NULL,',','Â ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ð¯Ð½Ð²','Ð¤ÐµÐ²','ÐœÐ°Ñ€','ÐÐ¿Ñ€','ÐœÐ°Ð¹','Ð˜ÑŽÐ½','Ð˜ÑŽÐ»','ÐÐ²Ð³','Ð¡ÐµÐ½','ÐžÐºÑ‚','ÐÐ¾Ñ','Ð”ÐµÐº',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ÐœÑƒÒ³Ð°Ñ€Ñ€Ð°Ð¼','Ð¡Ð°Ñ„Ð°Ñ€','Ð Ð°Ð±Ð¸ÑƒÐ»-Ð°Ð²Ð²Ð°Ð»','Ð Ð°Ð±Ð¸ÑƒÐ»-Ð¾Ñ…Ð¸Ñ€','Ð–ÑƒÐ¼Ð¾Ð´Ð¸ÑƒÐ»-ÑƒÐ»Ð¾','Ð–ÑƒÐ¼Ð¾Ð´Ð¸ÑƒÐ»-ÑƒÑ…Ñ€Ð¾','Ð Ð°Ð¶Ð°Ð±','Ð¨Ð°ÑŠÐ±Ð¾Ð½','Ð Ð°Ð¼Ð°Ð·Ð¾Ð½','Ð¨Ð°Ð²Ð²Ð¾Ð»','Ð—Ð¸Ð»-Ò›Ð°ÑŠÐ´Ð°','Ð—Ð¸Ð»-Ò³Ð¸Ð¶Ð¶Ð°','Ð¯ÐºÑˆ','Ð”ÑƒÑˆ','Ð¡ÐµÑˆ','Ð§Ð¾Ñ€','ÐŸÐ°Ð¹','Ð–ÑƒÐ¼','Ð¨Ð°Ð½','ÑÐºÑˆÐ°Ð½Ð±Ð°','Ð´ÑƒÑˆÐ°Ð½Ð±Ð°','ÑÐµÑˆÐ°Ð½Ð±Ð°','Ñ‡Ð¾Ñ€ÑˆÐ°Ð½Ð±Ð°','Ð¿Ð°Ð¹ÑˆÐ°Ð½Ð±Ð°','Ð¶ÑƒÐ¼Ð°','ÑˆÐ°Ð½Ð±Ð°');
INSERT INTO `locales` VALUES (355,'uz_Arab',NULL,NULL,NULL,NULL,NULL,'Ù«','Ù¬',NULL,'#,##0.00 Â¤','Ùª','âˆ’','H:mm:ss (z)','H:mm:ss (z)','H:mm:ss','H:mm','yyyy Ù†Ú†ÛŒ ÛŒÛŒÙ„ d Ù†Ú†ÛŒ MMMM EEEE Ú©ÙˆÙ†ÛŒ','d Ù†Ú†ÛŒ MMMM yyyy','d MMMM yyyy','yyyy/M/d',NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†Ùˆ','ÙØ¨Ø±','Ù…Ø§Ø±','Ø§Ù¾Ø±','Ù…Ù€ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„','Ø§Ú¯Ø³','Ø³Ù¾Øª','Ø§Ú©Øª','Ù†ÙˆÙ…','Ø¯Ø³Ù…',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Ø¬Ù†ÙˆØ±ÛŒ','ÙØ¨Ø±ÙˆØ±ÛŒ','Ù…Ø§Ø±Ú†','Ø§Ù¾Ø±ÛŒÙ„','Ù…ÛŒ','Ø¬ÙˆÙ†','Ø¬ÙˆÙ„Ø§ÛŒ','Ø§Ú¯Ø³Øª','Ø³Ù¾ØªÙ…Ø¨Ø±','Ø§Ú©ØªÙˆØ¨Ø±','Ù†ÙˆÙ…Ø¨Ø±','Ø¯Ø³Ù…Ø¨Ø±','ÛŒ.','Ø¯.','Ø³.','Ú†.','Ù¾.','Ø¬.','Ø´.','ÛŒÚ©Ø´Ù†Ø¨Ù‡','Ø¯ÙˆØ´Ù†Ø¨Ù‡','Ø³Ù‡â€ŒØ´Ù†Ø¨Ù‡','Ú†Ù‡Ø§Ø±Ø´Ù†Ø¨Ù‡','Ù¾Ù†Ø¬Ø´Ù†Ø¨Ù‡','Ø¬Ù…Ø¹Ù‡','Ø´Ù†Ø¨Ù‡');
INSERT INTO `locales` VALUES (356,'uz_Arab','AF','AFN','',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (357,'uz_Cyrl',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (358,'uz_Cyrl','UZ','UZS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (359,'uz_Latn',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Yanv','Fev','Mar','Apr','May','Iyun','Iyul','Avg','Sen','Okt','Noya','Dek',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Muharram','Safar','Rabiul-avval','Rabiul-oxir','Jumodiul-ulo','Jumodiul-uxro','Rajab','ShaÊ¿bon','Ramazon','Shavvol','Zil-qaÊ¿da','Zil-hijja','Yaksh','Dush','Sesh','Chor','Pay','Jum','Shan','yakshanba','dushanba','seshanba','chorshanba','payshanba','juma','shanba');
INSERT INTO `locales` VALUES (360,'uz_Latn','UZ','UZS','soÊ¿m',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (361,'ve',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Pha','Luh','á¹°ha','Lam','Shu','Lwi','Lwa','á¹°ha','Khu','Tsh','á¸¼ar','Nye',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Phando','Luhuhi','á¹°hafamuhwe','Lambamai','Shundunthule','Fulwi','Fulwana','á¹°hangule','Khubvumedzi','Tshimedzi','á¸¼ara','Nyendavhusiku','Swo','Mus','Vhi','Rar','á¹Ša','á¹°an','Mug','Swondaha','Musumbuluwo','á¸¼avhuvhili','á¸¼avhuraru','á¸¼avhuá¹‹a','á¸¼avhuá¹±anu','Mugivhela');
INSERT INTO `locales` VALUES (362,'ve','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (363,'vi',NULL,NULL,NULL,NULL,NULL,',','.',NULL,'#,##0.00 Â¤',NULL,NULL,NULL,NULL,NULL,NULL,'EEEE, \'ngÃ y\' dd MMMM \'nÄƒm\' yyyy','\'NgÃ y\' dd \'thÃ¡ng\' M \'nÄƒm\' yyyy','dd-MM-yyyy','dd/MM/yyyy','{0} {1}','SA','CH',NULL,NULL,NULL,'thg 1','thg 2','thg 3','thg 4','thg 5','thg 6','thg 7','thg 8','thg 9','thg 10','thg 11','thg 12',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'thÃ¡ng má»™t','thÃ¡ng hai','thÃ¡ng ba','thÃ¡ng tÆ°','thÃ¡ng nÄƒm','thÃ¡ng sÃ¡u','thÃ¡ng báº£y','thÃ¡ng tÃ¡m','thÃ¡ng chÃ­n','thÃ¡ng mÆ°á»i','thÃ¡ng mÆ°á»i má»™t','thÃ¡ng mÆ°á»i hai','CN','Th 2','Th 3','Th 4','Th 5','Th 6','Th 7','Chá»§ nháº­t','Thá»© hai','Thá»© ba','Thá»© tÆ°','Thá»© nÄƒm','Thá»© sÃ¡u','Thá»© báº£y');
INSERT INTO `locales` VALUES (364,'vi','VN','VND','Ä‘',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (365,'wal',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áˆ›áˆˆá‹¶','á‰ƒáˆ›',NULL,NULL,NULL,'áŒƒáŠ•á‹©','áŒá‰¥áˆ©','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµ','áˆ´á•á‰´','áŠ¦áŠ­á‰°','áŠ–á‰¬áˆ','á‹²áˆ´áˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'áŒƒáŠ•á‹©á‹ˆáˆª','áŒá‰¥áˆ©á‹ˆáˆª','áˆ›áˆ­á‰½','áŠ¤á•áˆ¨áˆ','áˆœá‹­','áŒáŠ•','áŒáˆ‹á‹­','áŠ¦áŒˆáˆµá‰µ','áˆ´á•á‰´áˆá‰ áˆ­','áŠ¦áŠ­á‰°á‹á‰ áˆ­','áŠ–á‰¬áˆá‰ áˆ­','á‹²áˆ´áˆá‰ áˆ­','á‹ˆáŒ‹','áˆ³á‹­áŠ–','áˆ›á‰†áˆ³','áŠ áˆ©á‹‹','áˆƒáˆ™áˆ³','áŠ áˆ­á‰£','á‰„áˆ«','á‹ˆáŒ‹','áˆ³á‹­áŠ–','áˆ›á‰†áˆ³áŠ›','áŠ áˆ©á‹‹','áˆƒáˆ™áˆ³','áŠ áˆ­á‰£','á‰„áˆ«');
INSERT INTO `locales` VALUES (366,'wal','ET','ETB','$',NULL,NULL,NULL,'á‹ˆ',NULL,'Â¤#,##0.00',NULL,NULL,'h:mm:ss a','h:mm:ss a','h:mm:ss a','h:mm a','EEEEá¥ dd MMMM áŒ‹áˆ‹áˆ³ yyyy G','dd MMMM yyyy','dd-MMM-yyyy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (367,'xh',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mat','Epr','Mey','Jun','Jul','Aga','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Janyuwari','Februwari','Matshi','Epreli','Meyi','Juni','Julayi','Agasti','Septemba','Okthoba','Novemba','Disemba','Caw','Mvu','Bin','Tha','Sin','Hla','Mgq','Cawe','Mvulo','Lwesibini','Lwesithathu','Lwesine','Lwesihlanu','Mgqibelo');
INSERT INTO `locales` VALUES (368,'xh','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (369,'yo',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ARO','ALE',NULL,NULL,NULL,'Sere','Erele','Erena','Igbe','Ebibi','Okudu','Agemo','Ogun','Owewe','Owara','Belu','Ope',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Osukini','Osukeji','Osuketa','Osukerin','Osukarun','Osukefa','Osukeje','Osukejo','Osukesan','Osukewa','Osukokanla','Osukejila','Aiku','Aje','Isegun','Ojoru','Ojobo','Eti','Abameta','Ojoaiku','Ojoaje','Ojoisegun','Ojoru','Ojobo','Ojoeti','Ojoabameta');
INSERT INTO `locales` VALUES (370,'yo','NG','NGN','â‚¦',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (371,'zh',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ä¸Šåˆ','ä¸‹åˆ',NULL,NULL,NULL,'ä¸€æœˆ','äºŒæœˆ','ä¸‰æœˆ','å››æœˆ','äº”æœˆ','å…­æœˆ','ä¸ƒæœˆ','å…«æœˆ','ä¹æœˆ','åæœˆ','åä¸€æœˆ','åäºŒæœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ä¸€æœˆ','äºŒæœˆ','ä¸‰æœˆ','å››æœˆ','äº”æœˆ','å…­æœˆ','ä¸ƒæœˆ','å…«æœˆ','ä¹æœˆ','åæœˆ','åä¸€æœˆ','åäºŒæœˆ','å‘¨æ—¥','å‘¨ä¸€','å‘¨äºŒ','å‘¨ä¸‰','å‘¨å››','å‘¨äº”','å‘¨å…­','æ˜ŸæœŸæ—¥','æ˜ŸæœŸä¸€','æ˜ŸæœŸäºŒ','æ˜ŸæœŸä¸‰','æ˜ŸæœŸå››','æ˜ŸæœŸäº”','æ˜ŸæœŸå…­');
INSERT INTO `locales` VALUES (372,'zh','CN','CNY','ï¿¥',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (373,'zh_Hans',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (374,'zh_Hans','CN','CNY',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'ahh\'æ—¶\'mm\'åˆ†\'ss\'ç§’\' z','ahh\'æ—¶\'mm\'åˆ†\'ss\'ç§’\'','ahh:mm:ss','ah:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy-M-d','yy-M-d',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (375,'zh_Hans','SG','SGD',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,'a hh:mm:ss','a hh:mm:ss','a hh:mm','a hh:mm','dd MMMM yyyy','dd MMM yyyy','dd-MMM-yy','dd/MM/yy',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (376,'zh_Hant',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'ahh\'æ™‚\'mm\'åˆ†\'ss\'ç§’\' z','ahh\'æ™‚\'mm\'åˆ†\'ss\'ç§’\'','a h:mm:ss','a h:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy/M/d','yyyy/M/d',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (377,'zh_Hant','HK','HKD',NULL,NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,'ahh:mm:ss','ah:mm','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\' EEEE','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yy\'å¹´\'M\'æœˆ\'d\'æ—¥\'',NULL,NULL,NULL,NULL,NULL,NULL,'1æœˆ','2æœˆ','3æœˆ','4æœˆ','5æœˆ','6æœˆ','7æœˆ','8æœˆ','9æœˆ','10æœˆ','11æœˆ','12æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (378,'zh_Hant','MO','MOP','MOP',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00;(Â¤#,##0.00)',NULL,NULL,NULL,NULL,'ahh:mm:ss','ah:mm','yyyy\'å¹´\'MM\'æœˆ\'dd\'æ—¥\' EEEE','yyyy\'å¹´\'MM\'æœˆ\'dd\'æ—¥\'','yyyy\'å¹´\'M\'æœˆ\'d\'æ—¥\'','yy\'å¹´\'M\'æœˆ\'d\'æ—¥\'',NULL,NULL,NULL,NULL,NULL,NULL,'1æœˆ','2æœˆ','3æœˆ','4æœˆ','5æœˆ','6æœˆ','7æœˆ','8æœˆ','9æœˆ','10æœˆ','11æœˆ','12æœˆ',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (379,'zh_Hant','TW','TWD','',NULL,NULL,NULL,NULL,NULL,'Â¤#,##0.00',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'é€±æ—¥','é€±ä¸€',NULL,'é€±ä¸‰','é€±å››','é€±äº”','é€±å…­',NULL,NULL,NULL,NULL,NULL,NULL,NULL);
INSERT INTO `locales` VALUES (380,'zu',NULL,NULL,NULL,NULL,NULL,',',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Jan','Feb','Mas','Apr','Mey','Jun','Jul','Aga','Sep','Okt','Nov','Dis',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'Januwari','Februwari','Mashi','Apreli','Meyi','Juni','Julayi','Agasti','Septemba','Okthoba','Novemba','Disemba','Son','Mso','Bil','Tha','Sin','Hla','Mgq','Sonto','Msombuluko','Lwesibili','Lwesithathu','Lwesine','Lwesihlanu','Mgqibelo');
INSERT INTO `locales` VALUES (381,'zu','ZA','ZAR','R',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `locales` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `marketplace_sellers`
--
DROP TABLE IF EXISTS `marketplace_sellers`;
CREATE TABLE `marketplace_sellers` (
  `seller_id` smallint(5) unsigned NOT NULL auto_increment,
  `seller_date_registered` int(10) unsigned default NULL,
  `seller_active` tinyint(1) unsigned default '1',
  `seller_api_url` varchar(100) default NULL,
  `seller_api_status` tinyint(3) unsigned default '1',
  `seller_username` varchar(75) default NULL,
  `seller_password` varchar(255) default NULL,
  `client_id` int(8) unsigned default NULL,
  PRIMARY KEY  (`seller_id`),
  KEY `seller_date_registered` (`seller_date_registered`),
  KEY `seller_active` (`seller_active`),
  KEY `seller_api_status` (`seller_api_status`),
  KEY `client_id` (`client_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `mbapi_log`
--
DROP TABLE IF EXISTS `mbapi_log`;
CREATE TABLE `mbapi_log` (
  `mbapi_log_id` int(10) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `session_id` varchar(40) default NULL,
  `mbapi_input` longtext,
  `mbapi_response` longtext,
  `ip` bigint(20) default NULL,
  `mbapi_status` tinyint(3) unsigned default NULL,
  `mbapi_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`mbapi_log_id`),
  KEY `admin_id` (`admin_id`),
  KEY `session_id` (`session_id`),
  KEY `ip` (`ip`),
  KEY `mbapi_status` (`mbapi_status`)
) ENGINE=MyISAM ;

--
-- Table structure for table `migration_configs`
--
DROP TABLE IF EXISTS `migration_configs`;
CREATE TABLE `migration_configs` (
  `migration_config_id` tinyint(3) unsigned NOT NULL auto_increment,
  `migration_name` varchar(255) default NULL,
  `migration_comment` varchar(255) default NULL,
  `migration_payment_group_id` tinyint(3) unsigned default NULL,
  `migration_order_form_id` smallint(5) unsigned default NULL,
  `migration_product_id` int(10) unsigned default NULL,
  `migration_orphan_product_id` int(10) unsigned default NULL,
  `migration_type` tinyint(3) unsigned default NULL,
  `migration_dbdriver_type` tinyint(3) unsigned default NULL,
  `migration_dbhost` varchar(255) default NULL,
  `migration_dbname` varchar(255) default NULL,
  `migration_dbusername` varchar(255) default NULL,
  `migration_dbpassword` varchar(255) default NULL,
  PRIMARY KEY  (`migration_config_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `migration_mappings`
--
DROP TABLE IF EXISTS `migration_mappings`;
CREATE TABLE `migration_mappings` (
  `migration_mapping_id` int(10) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_obj_id` int(10) unsigned default NULL,
  `migration_ext_id` int(10) unsigned default NULL,
  `migration_int_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`migration_mapping_id`),
  KEY `migration_config_id` (`migration_config_id`),
  KEY `migration_obj_id` (`migration_obj_id`),
  KEY `migration_ext_id` (`migration_ext_id`),
  KEY `migration_int_id` (`migration_int_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `migration_objs`
--
DROP TABLE IF EXISTS `migration_objs`;
CREATE TABLE `migration_objs` (
  `migration_obj_id` int(10) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_obj_name` varchar(255) default NULL,
  `migration_ext_seq_id` int(10) unsigned default NULL,
  `migration_ext_obj_name` varchar(100) default NULL,
  `migration_ext_obj_key` varchar(100) default NULL,
  `migration_int_seq_id` int(10) unsigned default NULL,
  `migration_int_obj_name` varchar(100) default NULL,
  `migration_int_obj_key` varchar(100) default NULL,
  PRIMARY KEY  (`migration_obj_id`),
  KEY `migration_obj_name` (`migration_obj_name`),
  KEY `migration_ext_seq_id` (`migration_ext_seq_id`),
  KEY `migration_int_seq_id` (`migration_int_seq_id`),
  KEY `migration_config_id` (`migration_config_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `migration_options`
--
DROP TABLE IF EXISTS `migration_options`;
CREATE TABLE `migration_options` (
  `migration_option_id` smallint(5) unsigned NOT NULL auto_increment,
  `migration_config_id` tinyint(3) unsigned default NULL,
  `migration_option_name` varchar(255) default NULL,
  `migration_option_value` varchar(255) default NULL,
  PRIMARY KEY  (`migration_option_id`),
  KEY `migration_option_name` (`migration_option_name`),
  KEY `migration_option_value` (`migration_option_value`)
) ENGINE=MyISAM ;
--
-- Table structure for table `migration_reservations`
--
DROP TABLE IF EXISTS `migration_reservations`;
CREATE TABLE `migration_reservations` (
  `migration_obj_id` int(10) unsigned NOT NULL default '0',
  `migration_ext_id` varchar(255) NOT NULL default '',
  `admin_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`migration_obj_id`,`migration_ext_id`),
  KEY `admin_id` (`admin_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `news`
--
DROP TABLE IF EXISTS `news`;
CREATE TABLE `news` (
  `news_id` int(8) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `news_subject` varchar(100) default NULL,
  `news_short_body` text,
  `news_body` text,
  `news_date_created` int(10) unsigned default NULL,
  `priority_id` tinyint(3) unsigned default NULL,
  `news_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`news_id`),
  KEY `admin_id` (`admin_id`),
  KEY `priority_id` (`priority_id`),
  KEY `news_active` (`news_active`)
) ENGINE=MyISAM ;

--
-- Table structure for table `news_client_group_rel`
--
DROP TABLE IF EXISTS `news_client_group_rel`;
CREATE TABLE `news_client_group_rel` (
  `client_group_id` int(8) unsigned NOT NULL default '0',
  `news_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`client_group_id`,`news_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `news_group_rel`
--
DROP TABLE IF EXISTS `news_group_rel`;
CREATE TABLE `news_group_rel` (
  `news_id` int(8) unsigned NOT NULL default '0',
  `news_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`news_id`,`news_group_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `news_groups`
--
DROP TABLE IF EXISTS `news_groups`;
CREATE TABLE `news_groups` (
  `news_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `news_group_name` varchar(100) default NULL,
  `news_group_description` varchar(255) default NULL,
  `news_group_active` tinyint(3) unsigned default NULL,
  `news_group_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`news_group_id`),
  KEY `news_group_active` (`news_group_active`),
  KEY `news_group_order` (`news_group_order`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `news_groups`
--

LOCK TABLES `news_groups` WRITE;
/*!40000 ALTER TABLE `news_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `news_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_coupon_rel`
--

DROP TABLE IF EXISTS `order_form_coupon_rel`;


CREATE TABLE `order_form_coupon_rel` (
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`order_form_id`,`coupon_id`)
) ENGINE=InnoDB ;


--
-- Dumping data for table `order_form_coupon_rel`
--

LOCK TABLES `order_form_coupon_rel` WRITE;
/*!40000 ALTER TABLE `order_form_coupon_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `order_form_coupon_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_items`
--

DROP TABLE IF EXISTS `order_form_items`;


CREATE TABLE `order_form_items` (
  `order_form_item_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `order_form_item_order` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`order_form_item_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `order_form_item_order` (`order_form_item_order`),
  KEY `product_id` (`product_id`)
) ENGINE=MyISAM;


--
-- Table structure for table `order_form_params`
--

DROP TABLE IF EXISTS `order_form_params`;


CREATE TABLE `order_form_params` (
  `order_form_param_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_id` smallint(5) unsigned default NULL,
  `order_form_param_name` varchar(100) default NULL,
  `order_form_param_value` text,
  `order_form_param_trans_key` varchar(80) default NULL,
  `order_form_param_description` varchar(75) default NULL,
  `order_form_param_input_type` char(1) default NULL,
  `order_form_param_required` tinyint(3) unsigned default NULL,
  `order_form_param_order` smallint(5) unsigned default NULL,
  `order_form_param_locked` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`order_form_param_id`),
  KEY `order_form_id` (`order_form_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 ;


--
-- Dumping data for table `order_form_params`
--

LOCK TABLES `order_form_params` WRITE;
/*!40000 ALTER TABLE `order_form_params` DISABLE KEYS */;
INSERT INTO `order_form_params` VALUES (1,1,'dom_options','a:4:{i:0;s:9:\"dom_whois\";i:1;s:7:\"dom_reg\";i:2;s:12:\"dom_transfer\";i:3;s:12:\"dom_existing\";}','TRANS_ORDER_DOMAIN_OPTIONS','TRANS_ORDER_DOMAIN_OPTIONS_DESC','c',0,2,0);
INSERT INTO `order_form_params` VALUES (2,1,'email_banning','1','TRANS_ORDER_EMAIL_BANNING','TRANS_ORDER_EMAIL_BANNING_DESC','r',0,3,0);
INSERT INTO `order_form_params` VALUES (3,1,'email_banning_text','TRANS_ORDER_EMAIL_BANNING_MESSAGE','TRANS_ORDER_EMAIL_BANNING_TEXT','TRANS_ORDER_EMAIL_BANNING_TEXT_DESC','a',0,4,0);
INSERT INTO `order_form_params` VALUES (4,1,'ip_banning_text','TRANS_ORDER_IP_BANNING_MESSAGE','TRANS_ORDER_IP_BANNING_TEXT','TRANS_ORDER_IP_BANNING_TEXT_DESC','a',0,4,0);
INSERT INTO `order_form_params` VALUES (5,1,'payment_type_check','1','TRANS_ORDER_ENABLE_CHECK','TRANS_ORDER_ENABLE_CHECK_DESC','r',0,5,0);
INSERT INTO `order_form_params` VALUES (6,1,'payment_type_invoice','1','TRANS_ORDER_ENABLE_INVOICE','TRANS_ORDER_ENABLE_INVOICE_DESC','r',0,6,0);
INSERT INTO `order_form_params` VALUES (7,1,'payment_type_draft','1','TRANS_ORDER_ENABLE_BANK_DRAFT','TRANS_ORDER_ENABLE_BANK_DRAFT_DESC','r',0,7,0);
INSERT INTO `order_form_params` VALUES (8,1,'username_min_length','6','TRANS_ORDERFORM_MIN_USERNAME','TRANS_ORDERFORM_MIN_USERNAME_DESC','t',0,8,0);
INSERT INTO `order_form_params` VALUES (9,1,'username_max_length','15','TRANS_ORDERFORM_MAX_USERNAME','TRANS_ORDERFORM_MAX_USERNAME_DESC','t',0,9,0);
INSERT INTO `order_form_params` VALUES (10,1,'password_min_length','6','TRANS_ORDERFORM_MIN_PASSWORD','TRANS_ORDERFORM_MIN_PASSWORD_DESC','t',0,10,0);
INSERT INTO `order_form_params` VALUES (11,1,'password_max_length','15','TRANS_ORDERFORM_MAX_PASSWORD','TRANS_ORDERFORM_MAX_PASSWORD_DESC','t',0,11,0);
INSERT INTO `order_form_params` VALUES (12,1,'terms_url','','TRANS_ORDERFORM_TERMS_URL','TRANS_ORDERFORM_TERMS_URL','t',0,12,0);
INSERT INTO `order_form_params` VALUES (13,1,'theme','default','TRANS_ONLINE_STORE_COMMON_COLOR_THEME','','w',0,13,0);
/*!40000 ALTER TABLE `order_form_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_values`
--

DROP TABLE IF EXISTS `order_form_values`;


CREATE TABLE `order_form_values` (
  `order_form_value_id` int(10) unsigned NOT NULL auto_increment,
  `order_form_param_id` int(10) unsigned default NULL,
  `order_form_value_name` varchar(25) default NULL,
  `order_form_value_trans_key` varchar(80) default NULL,
  `order_form_value_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`order_form_value_id`),
  KEY `order_form_param_id` (`order_form_param_id`),
  KEY `order_form_value_order` (`order_form_value_order`)
) ENGINE=MyISAM AUTO_INCREMENT=14 ;


--
-- Dumping data for table `order_form_values`
--

LOCK TABLES `order_form_values` WRITE;
/*!40000 ALTER TABLE `order_form_values` DISABLE KEYS */;
INSERT INTO `order_form_values` VALUES (1,1,'dom_whois','TRANS_ORDER_WHOIS_LOOKUP',0);
INSERT INTO `order_form_values` VALUES (2,1,'dom_reg','TRANS_ORDER_DOMAIN_REGISTRATION',1);
INSERT INTO `order_form_values` VALUES (3,1,'dom_transfer','TRANS_ORDER_TRANSFER_DOMAIN',2);
INSERT INTO `order_form_values` VALUES (4,1,'dom_existing','TRANS_ORDER_EXISTING_DOMAIN',3);
INSERT INTO `order_form_values` VALUES (5,1,'dom_skip','TRANS_ORDER_SKIP_DOMAIN',4);
INSERT INTO `order_form_values` VALUES (6,2,'1','TRANS_YES',0);
INSERT INTO `order_form_values` VALUES (7,2,'0','TRANS_NO',1);
INSERT INTO `order_form_values` VALUES (8,5,'1','TRANS_YES',0);
INSERT INTO `order_form_values` VALUES (9,5,'0','TRANS_NO',1);
INSERT INTO `order_form_values` VALUES (10,6,'1','TRANS_YES',0);
INSERT INTO `order_form_values` VALUES (11,6,'0','TRANS_NO',1);
INSERT INTO `order_form_values` VALUES (12,7,'1','TRANS_YES',0);
INSERT INTO `order_form_values` VALUES (13,7,'0','TRANS_NO',1);
/*!40000 ALTER TABLE `order_form_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_forms`
--

DROP TABLE IF EXISTS `order_forms`;

CREATE TABLE `order_forms` (
	`order_form_id` smallint(5) unsigned NOT NULL auto_increment,
	`order_form_name` varchar(50) NOT NULL,
	`order_form_code` varchar(20) NOT NULL,
	`currency_id` char(3) NOT NULL,
	`payment_gateway_id` int(10) unsigned,
	`hspc_bank_transfer_gateway_id` int(10) unsigned,
	`company_id` smallint(5) unsigned NOT NULL,
	`language_id` smallint(5) unsigned NOT NULL,
	`countries_id` smallint(5) unsigned NOT NULL,
	`order_form_verify_vat` tinyint(1) NOT NULL default '0',
	`order_form_disable_charging` tinyint(1) NOT NULL default '0',
	`default_widget_template` varchar(255) NOT NULL,
	`is_default` tinyint(1) unsigned NOT NULL default '0',
	`request_tax_vat_id` tinyint(1) unsigned NOT NULL default '0',
	`default_tax_zone_id` int(10) unsigned default NULL,
	`enable_individual_enterpreneur_type` tinyint(1) unsigned NOT NULL default '0',
	`use_terms_url` tinyint(1) unsigned NOT NULL default '0',
	`terms_text` text NULL,
	PRIMARY KEY  (`order_form_id`),
	UNIQUE KEY `order_form_name` (`order_form_name`),
	UNIQUE KEY `order_form_code` (`order_form_code`),
	KEY `currency_id` (`currency_id`),
	KEY `payment_gateway_id` (`payment_gateway_id`),
	KEY `hspc_bank_transfer_gateway_id` (`hspc_bank_transfer_gateway_id`),
	KEY `company_id` (`company_id`),
	KEY `language_id` (`language_id`),
	KEY `countries_id` (`countries_id`),
	KEY `is_default` (`is_default`),
	CONSTRAINT `currency_id_fk` FOREIGN KEY (`currency_id`)
		REFERENCES `currencies`(`currency_id`) ON DELETE RESTRICT ON UPDATE CASCADE,
	CONSTRAINT `payment_gateway_id_fk` FOREIGN KEY (`payment_gateway_id`)
		REFERENCES `payment_gateways`(`payment_gateway_id`) ON DELETE SET NULL ON UPDATE CASCADE,
	CONSTRAINT `hspc_bank_transfer_gateway_id_fk` FOREIGN KEY (`hspc_bank_transfer_gateway_id`)
		REFERENCES `payment_gateways`(`payment_gateway_id`) ON DELETE SET NULL ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Dumping data for table `order_forms`
--

LOCK TABLES `order_forms` WRITE;
/*!40000 ALTER TABLE `order_forms` DISABLE KEYS */;
INSERT INTO `order_forms` VALUES (1,'Default Store','default','USD',NULL,NULL,1,21,225,0,0, 'column', 1, 0, NULL, 0, 0, NULL);
/*!40000 ALTER TABLE `order_forms` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `order_form_payment_gateway_rel`
--

DROP TABLE IF EXISTS `order_form_payment_gateway_rel`;

CREATE TABLE `order_form_payment_gateway_rel` (
	`order_form_id` smallint(5) unsigned NOT NULL,
	`payment_gateway_id` int(10) unsigned NOT NULL,
	PRIMARY KEY (`order_form_id`, `payment_gateway_id`),
	KEY `payment_gateway_id` (`payment_gateway_id`),
	CONSTRAINT `order_form_id_rel_fk` FOREIGN KEY (`order_form_id`)
		REFERENCES `order_forms` (`order_form_id`) ON DELETE CASCADE ON UPDATE CASCADE,
	CONSTRAINT `payment_gateway_id_rel_fk` FOREIGN KEY (`payment_gateway_id`)
		REFERENCES `payment_gateways` (`payment_gateway_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Table structure for table `package_addon_attributes`
--

DROP TABLE IF EXISTS `package_addon_attributes`;


CREATE TABLE `package_addon_attributes` (
  `package_addon_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `package_addon_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `package_attribute_name` varchar(100) default NULL,
  `package_attribute_value` longtext,
  `package_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_addon_attribute_id`),
  KEY `package_addon_id` (`package_addon_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `package_attribute_name` (`package_attribute_name`),
  KEY `package_attribute_date_created` (`package_attribute_date_created`),
  KEY `server_group_id` (`server_group_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_addon_attributes`
--

LOCK TABLES `package_addon_attributes` WRITE;
/*!40000 ALTER TABLE `package_addon_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addon_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_addon_ledger_entries`
--

DROP TABLE IF EXISTS `package_addon_ledger_entries`;


CREATE TABLE `package_addon_ledger_entries` (
  `package_addon_ledger_id` int(10) unsigned NOT NULL auto_increment,
  `package_addon_id` int(10) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `package_addon_ledger_debit` decimal(10,2) unsigned default NULL,
  `package_addon_ledger_credit` decimal(10,2) unsigned default NULL,
  `package_addon_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`package_addon_ledger_id`),
  KEY `package_addon_id` (`package_addon_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `journal_type` (`journal_type`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_addon_ledger_entries`
--

LOCK TABLES `package_addon_ledger_entries` WRITE;
/*!40000 ALTER TABLE `package_addon_ledger_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addon_ledger_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_addons`
--

DROP TABLE IF EXISTS `package_addons`;


CREATE TABLE `package_addons` (
  `package_addon_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `package_addon_display_name` varchar(255) default NULL,
  `package_addon_original_price` decimal(10,2) unsigned default '0.00',
  `package_addon_price` decimal(10,2) unsigned default NULL,
  `package_addon_setup` decimal(10,2) unsigned default NULL,
  `package_addon_discount` decimal(10,2) unsigned default NULL,
  `package_addon_price_lock` tinyint(3) unsigned default NULL,
  `package_addon_discountable` tinyint(1) unsigned default NULL,
  `package_addon_active` tinyint(1) unsigned default NULL,
  `package_addon_cycle_discount_group_id` int(10) unsigned default NULL,
  `package_addon_product_id` int(10) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  `coupon_num_cycles` smallint(5) unsigned NOT NULL default '0',
  `coupon_price` decimal(10,2) NOT NULL default '0.00',
  `package_addon_expiration_date` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_addon_id`),
  KEY `package_id` (`package_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `package_addon_active` (`package_addon_active`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `package_addon_product_id` (`package_addon_product_id`),
  KEY `package_addon_expiration_date` (`package_addon_expiration_date`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_addons`
--

LOCK TABLES `package_addons` WRITE;
/*!40000 ALTER TABLE `package_addons` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_addons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_attributes`
--

DROP TABLE IF EXISTS `package_attributes`;


CREATE TABLE `package_attributes` (
  `package_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default '0',
  `config_group_id` int(8) unsigned default NULL,
  `package_attribute_name` varchar(100) default NULL,
  `package_attribute_value` longtext,
  `package_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_attribute_id`),
  KEY `package_id` (`package_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `package_attribute_name` (`package_attribute_name`),
  KEY `package_attribute_date_created` (`package_attribute_date_created`),
  KEY `server_group_id` (`server_group_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_attributes`
--

LOCK TABLES `package_attributes` WRITE;
/*!40000 ALTER TABLE `package_attributes` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_attributes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_cert_rel`
--

DROP TABLE IF EXISTS `package_cert_rel`;


CREATE TABLE `package_cert_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `cert_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`cert_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_cert_rel`
--

LOCK TABLES `package_cert_rel` WRITE;
/*!40000 ALTER TABLE `package_cert_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_cert_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_certs`
--

DROP TABLE IF EXISTS `package_certs`;


CREATE TABLE `package_certs` (
  `cert_id` int(10) unsigned NOT NULL auto_increment,
  `cert_timestamp` int(10) unsigned default NULL,
  `or_id` varchar(25) default NULL,
  `r_id` int(10) unsigned default NULL,
  `ct_code` varchar(25) default NULL,
  `af_id` varchar(25) default NULL,
  `or_status` tinyint(3) unsigned default NULL,
  `or_startstamp` int(10) unsigned default NULL,
  `or_submitstamp` int(10) unsigned default NULL,
  `or_syncstamp` int(10) unsigned default NULL,
  `or_successcode` char(3) default NULL,
  `or_errorcode` varchar(20) default NULL,
  `or_errormsg` varchar(255) default NULL,
  `or_techSameAsAdmin` varchar(5) default NULL,
  `or_billSameAsPrevious` varchar(5) default NULL,
  `OD_Method` varchar(8) default NULL,
  `OD_ProductCode` varchar(20) default NULL,
  `OD_ValidityPeriod` tinyint(3) unsigned default NULL,
  `OD_ServerCount` tinyint(3) unsigned default NULL,
  `OD_Price` decimal(10,2) default NULL,
  `OD_RenewalBehavior` varchar(8) default NULL,
  `OD_SpecialInstructions` longtext,
  `OD_PartnerOrderID` varchar(50) default NULL,
  `OD_GeoTrustOrderID` int(10) unsigned default NULL,
  `OD_OrderDate` int(10) unsigned default NULL,
  `OD_OrderCompleteDate` int(10) unsigned default NULL,
  `OD_OrderDeactivatedDate` int(10) unsigned default NULL,
  `OD_OrderStatusMajor` varchar(20) default NULL,
  `OD_OrderStatusMinorCode` varchar(20) default NULL,
  `OD_OrderStatusMinorName` varchar(20) default NULL,
  `OD_ApproverNotifiedDate` int(10) unsigned default NULL,
  `OD_ApproverConfirmDate` int(10) unsigned default NULL,
  `OD_ApproverEmailAddress` varchar(255) default NULL,
  `ORG_OrganizationName` varchar(255) default NULL,
  `ORG_DUNS` varchar(50) default NULL,
  `ORG_AddressLine1` varchar(100) default NULL,
  `ORG_AddressLine2` varchar(100) default NULL,
  `ORG_AddressLine3` varchar(100) default NULL,
  `ORG_City` varchar(50) default NULL,
  `ORG_Region` varchar(255) default NULL,
  `ORG_PostalCode` varchar(20) default NULL,
  `ORG_Country` char(2) default NULL,
  `ORG_Phone` varchar(30) default NULL,
  `ORG_Fax` varchar(30) default NULL,
  `AC_FirstName` varchar(100) default NULL,
  `AC_LastName` varchar(100) default NULL,
  `AC_Phone` varchar(30) default NULL,
  `AC_Email` varchar(255) default NULL,
  `TC_FirstName` varchar(100) default NULL,
  `TC_LastName` varchar(100) default NULL,
  `TC_Phone` varchar(30) default NULL,
  `TC_Email` varchar(255) default NULL,
  `BC_FirstName` varchar(100) default NULL,
  `BC_LastName` varchar(100) default NULL,
  `BC_Phone` varchar(30) default NULL,
  `BC_Email` varchar(255) default NULL,
  `CSR_CSR` longtext,
  `CSR_WildCard` varchar(5) default NULL,
  `CSR_Subject` varchar(255) default NULL,
  `CSR_DomainName` varchar(255) default NULL,
  `CSR_Country` char(2) default NULL,
  `CSR_Email` varchar(255) default NULL,
  `CSR_Locality` varchar(255) default NULL,
  `CSR_Organization` varchar(255) default NULL,
  `CSR_OrganizationUnit` varchar(255) default NULL,
  `CSR_State` varchar(100) default NULL,
  `CSR_IsValidDomainName` varchar(5) default NULL,
  `CSR_HasBadExtensions` varchar(5) default NULL,
  `CSR_CommonName` varchar(255) default NULL,
  `CSR_WebServerType` varchar(20) default NULL,
  `CSR_DNSNames` text,
  `CSR_CertificateStatus` varchar(50) default NULL,
  `CSR_StartDate` int(10) unsigned default NULL,
  `CSR_EndDate` int(10) unsigned default NULL,
  `CSR_SerialNumber` varchar(25) default NULL,
  `UPG_CUIndicator` varchar(5) default NULL,
  `UPG_CUCertificate` longtext,
  `UPG_CUmonths` tinyint(3) unsigned default NULL,
  `UPG_CUSerialNumber` varchar(25) default NULL,
  `UPG_CUExpirationDate` int(10) unsigned default NULL,
  `UPG_CUIssuer` varchar(100) default NULL,
  `RI_RenewalIndicator` varchar(5) default NULL,
  `RI_RenewalMonths` tinyint(3) unsigned default NULL,
  `RI_RenewalSerialNumber` varchar(100) default NULL,
  `RI_RenewalExpirationDate` int(10) unsigned default NULL,
  `RI_RenewalOrderID` varchar(50) default NULL,
  `RI_RenewalProductCode` varchar(50) default NULL,
  `FF_CACertType` varchar(10) default NULL,
  `FF_CACert` longtext,
  `FF_ServerCertificate` longtext,
  `FF_IconScript` longtext,
  `FF_ChoicePointURL` varchar(255) default NULL,
  `FF_CpsURL` varchar(255) default NULL,
  `get_approverlist` longtext,
  `get_useragreement` longtext,
  PRIMARY KEY  (`cert_id`),
  KEY `ct_code` (`ct_code`),
  KEY `OD_GeoTrustOrderID` (`OD_GeoTrustOrderID`),
  KEY `OD_PartnerOrderID` (`OD_PartnerOrderID`),
  KEY `or_id` (`or_id`),
  KEY `r_id` (`r_id`),
  KEY `af_id` (`af_id`),
  KEY `or_status` (`or_status`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_certs`
--

LOCK TABLES `package_certs` WRITE;
/*!40000 ALTER TABLE `package_certs` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_certs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_config_group_rel`
--

DROP TABLE IF EXISTS `package_config_group_rel`;


CREATE TABLE `package_config_group_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `config_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`config_group_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_config_group_rel`
--

LOCK TABLES `package_config_group_rel` WRITE;
/*!40000 ALTER TABLE `package_config_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_config_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_database_rel`
--

DROP TABLE IF EXISTS `package_database_rel`;


CREATE TABLE `package_database_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_database_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_database_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_database_rel`
--

LOCK TABLES `package_database_rel` WRITE;
/*!40000 ALTER TABLE `package_database_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_database_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_databases`
--

DROP TABLE IF EXISTS `package_databases`;


CREATE TABLE `package_databases` (
  `package_database_id` int(10) unsigned NOT NULL auto_increment,
  `package_database_type` tinyint(3) unsigned default NULL,
  `package_database_name` varchar(75) default NULL,
  `package_database_username` varchar(75) default NULL,
  `package_database_password` varchar(255) default NULL,
  `package_database_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_database_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_databases`
--

LOCK TABLES `package_databases` WRITE;
/*!40000 ALTER TABLE `package_databases` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_databases` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_domain_rel`
--

DROP TABLE IF EXISTS `package_domain_rel`;


CREATE TABLE `package_domain_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `domain_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`domain_id`),
  KEY `domain_id` (`domain_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_domain_rel`
--

LOCK TABLES `package_domain_rel` WRITE;
/*!40000 ALTER TABLE `package_domain_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_domain_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_domains`
--

DROP TABLE IF EXISTS `package_domains`;


CREATE TABLE `package_domains` (
  `domain_id` int(10) unsigned NOT NULL auto_increment,
  `domain_sld` varchar(255) default NULL,
  `domain_tld` varchar(255) default NULL,
  `domain_idn_language` char(3) default NULL,
  `domain_active` tinyint(1) unsigned default '1',
  `domain_date_created` int(10) unsigned default NULL,
  `domain_remote_purchase_id` varchar(255) default NULL,
  `domain_remote_domain_id` varchar(255) default NULL,
  `domain_date_expires` int(10) unsigned default NULL,
  `domain_date_last_sync` int(10) unsigned default NULL,
  `registrar_id` smallint(5) unsigned default NULL,
  `domain_renew_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`domain_id`),
  KEY `domain_sld` (`domain_sld`),
  KEY `domain_tld` (`domain_tld`),
  KEY `domain_date_expires` (`domain_date_expires`),
  KEY `registrar_id` (`registrar_id`),
  KEY `domain_remote_purchase_id` (`domain_remote_purchase_id`),
  KEY `domain_remote_domain_id` (`domain_remote_domain_id`),
  KEY `domain_date_last_sync` (`domain_date_last_sync`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_domains`
--

LOCK TABLES `package_domains` WRITE;
/*!40000 ALTER TABLE `package_domains` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_domains` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_fee_rel`
--

DROP TABLE IF EXISTS `package_fee_rel`;


CREATE TABLE `package_fee_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  `package_fee_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_addon_id`,`package_fee_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_fee_rel`
--

LOCK TABLES `package_fee_rel` WRITE;
/*!40000 ALTER TABLE `package_fee_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_fee_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_ledger_entries`
--

DROP TABLE IF EXISTS `package_ledger_entries`;


CREATE TABLE `package_ledger_entries` (
  `package_ledger_id` int(10) NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `package_ledger_num_cycles` smallint(5) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `package_ledger_debit` decimal(10,2) unsigned default NULL,
  `package_ledger_credit` decimal(10,2) unsigned default NULL,
  `package_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`package_ledger_id`),
  KEY `package_id` (`package_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `journal_type` (`journal_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_ledger_entries`
--

LOCK TABLES `package_ledger_entries` WRITE;
/*!40000 ALTER TABLE `package_ledger_entries` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_ledger_entries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_license_rel`
--

DROP TABLE IF EXISTS `package_license_rel`;


CREATE TABLE `package_license_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `license_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`license_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_license_rel`
--

LOCK TABLES `package_license_rel` WRITE;
/*!40000 ALTER TABLE `package_license_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_license_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_licenses`
--

DROP TABLE IF EXISTS `package_licenses`;


CREATE TABLE `package_licenses` (
  `license_id` int(10) unsigned NOT NULL auto_increment,
  `license_locked` varchar(255) default NULL,
  `license_data` longtext,
  `license_cipher` text,
  `license_key` text,
  `license_date_created` int(10) unsigned default NULL,
  `license_date_last_renewal` int(10) unsigned default NULL,
  `license_date_next_renewal` int(10) unsigned default NULL,
  `license_date_stop_renewal` int(10) unsigned default NULL,
  `license_status` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`license_id`),
  KEY `license_locked` (`license_locked`),
  KEY `license_date_created` (`license_date_created`),
  KEY `license_date_last_renewal` (`license_date_last_renewal`),
  KEY `license_date_next_renewal` (`license_date_next_renewal`),
  KEY `license_date_stop_renewal` (`license_date_stop_renewal`),
  KEY `license_status` (`license_status`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_licenses`
--

LOCK TABLES `package_licenses` WRITE;
/*!40000 ALTER TABLE `package_licenses` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_licenses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_pop_rel`
--

DROP TABLE IF EXISTS `package_pop_rel`;


CREATE TABLE `package_pop_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `package_pop_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`package_pop_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_pop_rel`
--

LOCK TABLES `package_pop_rel` WRITE;
/*!40000 ALTER TABLE `package_pop_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_pop_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_pops`
--

DROP TABLE IF EXISTS `package_pops`;


CREATE TABLE `package_pops` (
  `package_pop_id` int(10) unsigned NOT NULL auto_increment,
  `package_pop_real_name` varchar(255) default NULL,
  `package_pop_username` varchar(255) default NULL,
  `package_pop_password` varchar(255) default NULL,
  `package_pop_quota` varchar(25) default NULL,
  `package_pop_ftp` tinyint(3) unsigned default NULL,
  `package_pop_telnet` tinyint(3) unsigned default NULL,
  `package_pop_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_pop_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_pops`
--

LOCK TABLES `package_pops` WRITE;
/*!40000 ALTER TABLE `package_pops` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_pops` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_usage_log`
--

DROP TABLE IF EXISTS `package_usage_log`;


CREATE TABLE `package_usage_log` (
  `usage_log_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `package_usage` decimal(20,10) unsigned default NULL,
  `usage_log_date_created` int(10) unsigned default NULL,
  `external_id` varchar(255) default NULL,
  `usage_log_date_billed` int(10) unsigned default NULL,
  `interface_id` smallint(5) unsigned default '0',
  `package_usage_type` smallint(5) unsigned default '0',
  `package_usage_record_type` smallint(5) unsigned default '0',
  `package_usage_com_type` smallint(5) unsigned default '0',
  `package_usage_com_brand` smallint(5) unsigned default '0',
  `package_usage_link_date` int(10) unsigned default NULL,
  `package_usage_link_status` smallint(5) unsigned default '0',
  `package_usage_message_duration` int(10) default '-1',
  `package_usage_data_size` int(20) default '-1',
  `package_usage_message_date` int(10) NOT NULL default '-1',
  `package_usage_date_session` int(10) default '-1',
  `package_usage_date_created` int(10) unsigned default NULL,
  `package_usage_date_billed` int(10) unsigned default NULL,
  `groupby_invoice_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `package_usage_serial_number` int(10) unsigned default NULL,
  `package_usage_vendor` varchar(10) default '0',
  `package_usage_username` varchar(255) default NULL,
  `package_usage_vessel` varchar(32) default NULL,
  `package_usage_rate` varchar(64) default NULL,
  `package_usage_external_status` char(1) default 'N',
  `package_usage_external_status_error` smallint(1) default '0',
  `package_usage_extra_info_1` varchar(255) default NULL,
  `package_usage_extra_info_2` varchar(255) default NULL,
  `package_usage_extra_info_3` varchar(255) default NULL,
  `package_usage_extra_info_f1` decimal(20,10) default NULL,
  `package_usage_extra_info_f2` decimal(20,10) default NULL,
  `package_usage_extra_info_f3` decimal(20,10) default NULL,
  `package_usage_extra_info_f4` decimal(20,10) default NULL,
  `package_usage_extra_info_f5` decimal(20,10) default NULL,
  `package_usage_extra_info_f6` decimal(20,10) default NULL,
  `package_usage_price` decimal(10,2) unsigned default NULL,
  `package_usage_cost` decimal(10,2) unsigned default NULL,
  PRIMARY KEY  (`usage_log_id`),
  KEY `package_id` (`package_id`),
  KEY `usage_log_date_created` (`usage_log_date_created`),
  KEY `usage_log_date_billed` (`usage_log_date_billed`),
  KEY `config_group_id` (`config_group_id`),
  KEY `groupby_invoice_id` (`groupby_invoice_id`),
  KEY `line_item_id` (`line_item_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `package_usage_log`
--

LOCK TABLES `package_usage_log` WRITE;
/*!40000 ALTER TABLE `package_usage_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `package_usage_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `package_vendor_rel`
--
DROP TABLE IF EXISTS `package_vendor_rel`;
CREATE TABLE `package_vendor_rel` (
  `package_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_package_id` int(10) unsigned NOT NULL default '0',
  `vendor_product_id` int(10) unsigned NOT NULL default '0',
  `vendor_order_form_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_variant_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`package_id`,`vendor_id`,`vendor_package_id`,`vendor_product_id`,`vendor_order_form_id`,`vendor_product_variant_id`)
) ENGINE=MyISAM ;


--
-- Table structure for table `packages`
--
DROP TABLE IF EXISTS `packages`;
CREATE TABLE `packages` (
  `package_id` int(10) unsigned NOT NULL auto_increment,
  `parent_package_id` int(10) unsigned default NULL,
  `invoice_process_id` varchar(40) default '',
  `invoice_process_date` int(10) unsigned default '0',
  `client_id` int(8) unsigned default '0',
  `client_contact_id` int(8) unsigned default '0',
  `product_id` int(10) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `primary_domain_id` int(10) unsigned default NULL,
  `package_group_id` smallint(5) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `invoicing_group_id` smallint(5) unsigned default NULL,
  `package_name` varchar(255) default NULL,
  `package_quantity` int(10) unsigned default '1',
  `package_proratable` tinyint(1) unsigned default NULL,
  `package_invoice_separately` tinyint(1) unsigned default '0',
  `package_discountable` tinyint(1) unsigned default '1',
  `package_date_created` int(10) unsigned default NULL,
  `package_date_begin_renewal` int(10) unsigned default NULL,
  `package_date_last_renewal` int(10) unsigned default NULL,
  `package_date_next_renewal` int(10) unsigned default NULL,
  `package_date_stop_renewal` int(10) unsigned default NULL,
  `package_date_cancelled` int(10) unsigned default NULL,
  `package_pending_cancellation` tinyint(3) unsigned NOT NULL default '0',
  `package_active` tinyint(1) default NULL,
  `package_status` tinyint(3) unsigned default NULL,
  `package_status_reason` varchar(255) default NULL,
  `package_comments` longtext,
  `package_type` tinyint(3) unsigned default NULL,
  `package_original_price` decimal(10,2) unsigned default '0.00',
  `package_price` decimal(10,2) unsigned default '0.00',
  `package_discount` decimal(10,2) unsigned default '0.00',
  `package_setup` decimal(10,2) unsigned default '0.00',
  `package_cost_currency_id` char(3) default NULL,
  `package_cost_amount` decimal(10,2) unsigned default '0.00',
  `package_setup_cost_currency_id` char(3) default NULL,
  `package_setup_cost_amount` decimal(10,2) unsigned default '0.00',
  `package_price_lock` tinyint(3) unsigned default NULL,
  `package_prior_id` int(10) unsigned default NULL,
  `cycle_id` int(8) unsigned default NULL,
  `usage_date_last_renewal` int(10) unsigned default NULL,
  `usage_date_next_renewal` int(10) unsigned default NULL,
  `usage_cycle_id` int(8) unsigned default NULL,
  `usage_calculate_only` tinyint(3) unsigned default NULL,
  `external_id` varchar(255) default NULL,
  `external_id_1` varchar(255) default NULL,
  `external_id_2` varchar(255) default NULL,
  `external_id_3` varchar(255) default NULL,
  `order_form_id` smallint(5) unsigned,
  `coupon_id` int(10) unsigned default NULL,
  `coupon_num_cycles` smallint(5) unsigned default NULL,
  `coupon_price` decimal(10,2) unsigned default '0.00',
  `package_cancellation_type` tinyint(3) unsigned NOT NULL default '0',
  `package_client_permissions` tinyint(3) unsigned default NULL,
  `package_disable_account_stacking` int(1) unsigned NOT NULL default '0',
  `guid` char(36) default NULL,
  `sync_status` ENUM('synced', 'syncing', 'error', 'non-syncable') NOT NULL DEFAULT 'synced',
  `sync_tasks` int(10) unsigned NOT NULL default 0,
  `sync_error` text NULL default NULL,
  `sync_last_time` datetime NULL default NULL,
  `package_expiration_date` int(10) unsigned default NULL,
  PRIMARY KEY  (`package_id`),
  KEY `invoice_process_id` (`invoice_process_id`),
  KEY `invoice_process_date` (`invoice_process_date`),
  KEY `client_id` (`client_id`),
  KEY `product_id` (`product_id`),
  KEY `package_group_id` (`package_group_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `invoicing_group_id` (`invoicing_group_id`),
  KEY `package_invoice_separately` (`package_invoice_separately`),
  KEY `package_date_created` (`package_date_created`),
  KEY `package_date_begin_renewal` (`package_date_begin_renewal`),
  KEY `package_date_last_renewal` (`package_date_last_renewal`),
  KEY `package_date_next_renewal` (`package_date_next_renewal`),
  KEY `package_date_stop_renewal` (`package_date_stop_renewal`),
  KEY `package_date_cancelled` (`package_date_cancelled`),
  KEY `package_active` (`package_active`),
  KEY `package_status` (`package_status`),
  KEY `package_type` (`package_type`),
  KEY `cycle_id` (`cycle_id`),
  KEY `usage_date_last_renewal` (`usage_date_last_renewal`),
  KEY `usage_date_next_renewal` (`usage_date_next_renewal`),
  KEY `usage_cycle_id` (`usage_cycle_id`),
  KEY `usage_calculate_only` (`usage_calculate_only`),
  KEY `order_form_id` (`order_form_id`),
  KEY `coupon_id` (`coupon_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`),
  KEY `parent_package_id` (`parent_package_id`),
  UNIQUE KEY `guid` (`guid`),
  KEY `sync_status` (`sync_status`),
  KEY `sync_tasks` (`sync_tasks`),
  KEY `package_expiration_date` (`package_expiration_date`)
) ENGINE=MyISAM;

--
-- Table structure for table `payment_gateways`
--
DROP TABLE IF EXISTS `payment_gateways`;
CREATE TABLE `payment_gateways` (
  `payment_gateway_id` int(10) unsigned NOT NULL auto_increment,
  `payment_gateway_name` varchar(255) NOT NULL,
  `payment_gateway_description` TEXT,
  `payment_gateway_module` varchar(255) NOT NULL,
  `payment_gateway_type` tinyint(3) unsigned NOT NULL default '1',
   PRIMARY KEY  (`payment_gateway_id`),
   UNIQUE KEY `payment_gateway_name` (`payment_gateway_name`)
) ENGINE=InnoDB;

--
-- Table structure for table `payment_gateway_params`
--
DROP TABLE IF EXISTS `payment_gateway_params`;
CREATE TABLE `payment_gateway_params` (
  `payment_gateway_id` int(10) unsigned NOT NULL,
  `payment_gateway_param_name` varchar(255) NOT NULL,
  `payment_gateway_param_value` text NOT NULL,
   PRIMARY KEY (`payment_gateway_id`, `payment_gateway_param_name`),
   CONSTRAINT `payment_gateway_id` FOREIGN KEY (`payment_gateway_id`) REFERENCES `payment_gateways`(`payment_gateway_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;


--
-- Table structure for table `payment_queue`
--
DROP TABLE IF EXISTS `payment_queue`;
CREATE TABLE `payment_queue` (
  `payment_id` int(10) unsigned NOT NULL auto_increment,
  `payment_process_id` varchar(40) default '',
  `payment_process_date` int(10) unsigned default '0',
  `line_item_id` int(10) unsigned default NULL,
  `groupby_invoice_id` int(10) NOT NULL default '0',
  `payment_description` varchar(100) default NULL,
  `payment_amount` decimal(10,2) default '0.00',
  `billing_account_share_id` int(10) unsigned default NULL,
  `payment_date_created` int(10) unsigned default NULL,
  `payment_date_charged` int(10) NOT NULL default '0',
  PRIMARY KEY  (`payment_id`),
  KEY `payment_process_id` (`payment_process_id`),
  KEY `payment_process_date` (`payment_process_date`),
  KEY `billing_account_share_id` (`billing_account_share_id`),
  KEY `payment_date_charged` (`payment_date_charged`),
  KEY `line_item_id` (`line_item_id`),
  KEY `groupby_invoice_id` (`groupby_invoice_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `prepay_discounts`
--
DROP TABLE IF EXISTS `prepay_discounts`;
CREATE TABLE `prepay_discounts` (
  `prepay_discount_id` int(10) unsigned NOT NULL auto_increment,
  `prepay_discount_name` varchar(100) default NULL,
  `prepay_discount_active` tinyint(1) default NULL,
  `cycle_id` int(10) default NULL,
  `prepay_discount_num_cycles` int(5) default NULL,
  `prepay_discount_amount` decimal(10,2) default NULL,
  `prepay_discount_percentage` decimal(10,2) default NULL,
  PRIMARY KEY  (`prepay_discount_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `product_addon_group_rel`
--
DROP TABLE IF EXISTS `product_addon_group_rel`;
CREATE TABLE `product_addon_group_rel` (
  `product_addon_group_rel_id` smallint(10) unsigned NOT NULL auto_increment,
  `product_addon_group_id` smallint(5) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `default_selected_product_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_addon_group_rel_id`)
) ENGINE=InnoDB;

--
-- Table structure for table `product_addon_groups`
--
DROP TABLE IF EXISTS `product_addon_groups`;
CREATE TABLE `product_addon_groups` (
  `product_addon_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_addon_group_active` tinyint(3) unsigned default NULL,
  `product_addon_group_name` varchar(75) default NULL,
  `product_addon_group_input_type` char(1) default NULL,
  `product_addon_group_none_choice` tinyint(1) default '1',
  PRIMARY KEY  (`product_addon_group_id`),
  KEY `product_addon_group_active` (`product_addon_group_active`)
) ENGINE=InnoDB;

--
-- Table structure for table `product_applications`
--
DROP TABLE IF EXISTS `product_applications`;
CREATE TABLE `product_applications` (
  `product_id` int(10) unsigned NOT NULL,
  `server_group_id` smallint(5) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`product_id`, `server_group_id`, `name`),
  KEY `server_group_id` (`server_group_id`),
  CONSTRAINT `product_application_product_id_fk` FOREIGN KEY (`product_id`) REFERENCES `products`(`product_id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `product_application_server_group_id_fk` FOREIGN KEY (`server_group_id`) REFERENCES `server_groups`(`server_group_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB;

--
-- Table structure for table `product_attributes`
--
DROP TABLE IF EXISTS `product_attributes`;
CREATE TABLE `product_attributes` (
  `product_attribute_id` int(10) unsigned NOT NULL auto_increment,
  `product_id` int(10) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `product_attribute_name` varchar(100) default NULL,
  `product_attribute_value` longtext,
  `product_attribute_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_attribute_id`),
  KEY `product_id` (`product_id`),
  KEY `product_attribute_name` (`product_attribute_name`),
  KEY `server_group_id` (`server_group_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `product_children_rel`
--
DROP TABLE IF EXISTS `product_children_rel`;
CREATE TABLE `product_children_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `child_product_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`child_product_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `product_coupon_pre_rel`
--
DROP TABLE IF EXISTS `product_coupon_pre_rel`;
CREATE TABLE `product_coupon_pre_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`coupon_id`)
) ENGINE=InnoDB;

--
-- Table structure for table `product_coupon_rel`
--
DROP TABLE IF EXISTS `product_coupon_rel`;
CREATE TABLE `product_coupon_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `coupon_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`coupon_id`)
) ENGINE=InnoDB ;

--
-- Table structure for table `product_cycle_ghost_rel`
--
DROP TABLE IF EXISTS `product_cycle_ghost_rel`;
CREATE TABLE `product_cycle_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`cycle_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `product_file_rel`
--
DROP TABLE IF EXISTS `product_file_rel`;
CREATE TABLE `product_file_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `file_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`file_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `product_files`
--
DROP TABLE IF EXISTS `product_files`;
CREATE TABLE `product_files` (
  `file_id` smallint(5) unsigned NOT NULL auto_increment,
  `file_name` varchar(255) default NULL,
  `file_path` text,
  `file_data` longblob,
  PRIMARY KEY  (`file_id`),
  KEY `file_name` (`file_name`)
) ENGINE=MyISAM ;


--
-- Table structure for table `product_group_rel`
--

DROP TABLE IF EXISTS `product_group_rel`;


CREATE TABLE `product_group_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `product_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`product_group_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_group_rel`
--

LOCK TABLES `product_group_rel` WRITE;
/*!40000 ALTER TABLE `product_group_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_groups`
--

DROP TABLE IF EXISTS `product_groups`;


CREATE TABLE `product_groups` (
  `product_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_group_name` varchar(50) default NULL,
  `product_group_api_name` varchar(50) default NULL,
  PRIMARY KEY  (`product_group_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_groups`
--

LOCK TABLES `product_groups` WRITE;
/*!40000 ALTER TABLE `product_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_curr_rel`
--

DROP TABLE IF EXISTS `product_ledger_curr_rel`;


CREATE TABLE `product_ledger_curr_rel` (
  `product_ledger_id` int(10) unsigned NOT NULL default '0',
  `currency_id` char(3) NOT NULL default '',
  PRIMARY KEY  (`product_ledger_id`,`currency_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_ledger_curr_rel`
--

LOCK TABLES `product_ledger_curr_rel` WRITE;
/*!40000 ALTER TABLE `product_ledger_curr_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_ledger_curr_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_cycle_rel`
--

DROP TABLE IF EXISTS `product_ledger_cycle_rel`;


CREATE TABLE `product_ledger_cycle_rel` (
  `product_ledger_id` int(10) unsigned NOT NULL default '0',
  `cycle_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_ledger_id`,`cycle_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_ledger_cycle_rel`
--

LOCK TABLES `product_ledger_cycle_rel` WRITE;
/*!40000 ALTER TABLE `product_ledger_cycle_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_ledger_cycle_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_ledger_entries`
--
DROP TABLE IF EXISTS `product_ledger_entries`;
CREATE TABLE `product_ledger_entries` (
  `product_ledger_id` int(10) NOT NULL auto_increment,
  `ledger_group_id` smallint(5) unsigned default NULL,
  `product_variant_id` int(8) default NULL,
  `product_ledger_num_cycles` smallint(5) unsigned default NULL,
  `general_ledger_type` tinyint(3) unsigned default NULL,
  `journal_type` varchar(20) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `product_ledger_debit` decimal(10,2) unsigned default NULL,
  `product_ledger_credit` decimal(10,2) unsigned default NULL,
  `product_ledger_comment` varchar(255) default NULL,
  `currency_id` char(3) default NULL,
  PRIMARY KEY  (`product_ledger_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `general_ledger_type` (`general_ledger_type`),
  KEY `journal_type` (`journal_type`),
  KEY `ledger_account_id` (`ledger_account_id`),
  KEY `currency_id` (`currency_id`),
  KEY `ledger_group_id` (`ledger_group_id`)
) ENGINE=MyISAM ;


--
-- Table structure for table `product_order_form_ghost_rel`
--

DROP TABLE IF EXISTS `product_order_form_ghost_rel`;


CREATE TABLE `product_order_form_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `order_form_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`order_form_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_order_form_ghost_rel`
--

LOCK TABLES `product_order_form_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_order_form_ghost_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_order_form_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_relations`
--

DROP TABLE IF EXISTS `product_relations`;


CREATE TABLE `product_relations` (
  `product_relation_id` int(8) unsigned NOT NULL auto_increment,
  `subject_product_id` int(10) unsigned default NULL,
  `related_product_id` int(10) unsigned default NULL,
  `product_relation_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`product_relation_id`),
  KEY `subject_product_id` (`subject_product_id`),
  KEY `related_product_id` (`related_product_id`)
) ENGINE=MyISAM;


--
-- Table structure for table `product_server_group_ghost_rel`
--

DROP TABLE IF EXISTS `product_server_group_ghost_rel`;


CREATE TABLE `product_server_group_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `server_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`server_group_id`)
) ENGINE=MyISAM;


--
-- Table structure for table `product_tld_ghost_rel`
--

DROP TABLE IF EXISTS `product_tld_ghost_rel`;


CREATE TABLE `product_tld_ghost_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `tld_id` int(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`tld_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_tld_ghost_rel`
--

LOCK TABLES `product_tld_ghost_rel` WRITE;
/*!40000 ALTER TABLE `product_tld_ghost_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_tld_ghost_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_usage_prices`
--

DROP TABLE IF EXISTS `product_usage_prices`;


CREATE TABLE `product_usage_prices` (
  `product_usage_price_id` int(10) unsigned NOT NULL auto_increment,
  `product_id` int(10) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `product_usage_price_amount` decimal(10,2) unsigned default NULL,
  PRIMARY KEY  (`product_usage_price_id`),
  KEY `product_id` (`product_id`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM;


--
-- Table structure for table `product_variable_values`
--

DROP TABLE IF EXISTS `product_variable_values`;


CREATE TABLE `product_variable_values` (
  `product_variable_value_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_variable_id` smallint(5) unsigned default NULL,
  `product_variable_value` varchar(100) default NULL,
  PRIMARY KEY  (`product_variable_value_id`),
  KEY `product_variable_id` (`product_variable_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_variable_values`
--

LOCK TABLES `product_variable_values` WRITE;
/*!40000 ALTER TABLE `product_variable_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_variable_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variables`
--

DROP TABLE IF EXISTS `product_variables`;


CREATE TABLE `product_variables` (
  `product_variable_id` smallint(5) unsigned NOT NULL auto_increment,
  `product_variable_name` varchar(100) default NULL,
  PRIMARY KEY  (`product_variable_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_variables`
--

LOCK TABLES `product_variables` WRITE;
/*!40000 ALTER TABLE `product_variables` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_variables` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_variant_prices`
--
DROP TABLE IF EXISTS `product_variant_prices`;
CREATE TABLE `product_variant_prices` (
  `product_variant_price_id` int(10) unsigned NOT NULL auto_increment,
  `product_variant_id` int(8) unsigned default NULL,
  `product_variant_price_type` tinyint(3) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `product_variant_price_amount` decimal(10,2) unsigned default '0.00',
  `cost_currency_id` char(3) default NULL,
  `cost_amount` decimal(10,2) unsigned default '0.00',
  PRIMARY KEY  (`product_variant_price_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `product_variant_price_type` (`product_variant_price_type`),
  KEY `cycle_id` (`cycle_id`),
  KEY `currency_id` (`currency_id`)
) ENGINE=MyISAM;

--
-- Table structure for table `product_variants`
--
DROP TABLE IF EXISTS `product_variants`;
CREATE TABLE `product_variants` (
  `product_variant_id` int(8) unsigned NOT NULL auto_increment,
  `product_variant_display_name` varchar(100) default NULL,
  `product_variant_active` tinyint(3) unsigned default NULL,
  `product_id` int(10) unsigned default NULL,
  `product_variable_value_id` smallint(5) unsigned default NULL,
  `tld_id` int(8) unsigned default NULL,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `cycle_discount_group_id` smallint(5) unsigned default NULL,
  `invoicing_group_id` smallint(5) unsigned default '0',
  PRIMARY KEY  (`product_variant_id`),
  KEY `product_id` (`product_id`),
  KEY `product_variable_value_id` (`product_variable_value_id`),
  KEY `tld_id` (`tld_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `cycle_discount_group_id` (`cycle_discount_group_id`),
  KEY `invoicing_group_id` (`invoicing_group_id`)
) ENGINE=InnoDB;


--
-- Table structure for table `product_vendor_qties`
--

DROP TABLE IF EXISTS `product_vendor_qties`;


CREATE TABLE `product_vendor_qties` (
  `product_vendor_qty_id` int(10) unsigned NOT NULL auto_increment,
  `quantity_available` int(10) default NULL,
  `quantity_unavailable` int(10) default NULL,
  PRIMARY KEY  (`product_vendor_qty_id`),
  KEY `quantity_available` (`quantity_available`),
  KEY `quantity_unavailable` (`quantity_unavailable`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `product_vendor_qties`
--

LOCK TABLES `product_vendor_qties` WRITE;
/*!40000 ALTER TABLE `product_vendor_qties` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_vendor_qties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_vendor_qty_rel`
--
DROP TABLE IF EXISTS `product_vendor_qty_rel`;
CREATE TABLE `product_vendor_qty_rel` (
  `product_variant_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `product_vendor_qty_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`product_variant_id`,`vendor_id`),
  KEY `product_vendor_qty_id` (`product_vendor_qty_id`)
) ENGINE=MyISAM ;


--
-- Table structure for table `product_vendor_rel`
--
DROP TABLE IF EXISTS `product_vendor_rel`;
CREATE TABLE `product_vendor_rel` (
  `product_id` int(10) unsigned NOT NULL default '0',
  `vendor_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_id` int(10) unsigned NOT NULL default '0',
  `vendor_order_form_id` smallint(5) unsigned NOT NULL default '0',
  `vendor_product_variant_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`product_id`,`vendor_id`,`vendor_product_id`,`vendor_order_form_id`,`vendor_product_variant_id`)
) ENGINE=MyISAM ;

--
-- Table structure for table `products`
--
DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `product_id` int(10) unsigned NOT NULL auto_increment,
  `product_type` tinyint(3) unsigned default NULL,
  `product_variable_id` smallint(5) unsigned default NULL,
  `product_is_lockable` tinyint(3) unsigned default '0',
  `product_is_addon` tinyint(1) unsigned default '0',
  `product_invoice_separately` tinyint(1) unsigned default '0',
  `product_addon_group_id` smallint(5) unsigned default '0',
  `product_addon_attribute_name` varchar(255) default NULL,
  `product_name` varchar(100) default NULL,
  `product_comments` longtext,
  `product_stop_num_cycles` int(10) unsigned default NULL,
  `product_active` tinyint(1) unsigned default NULL,
  `product_proratable` tinyint(1) unsigned default NULL,
  `product_discountable` tinyint(1) unsigned default '1',
  `product_date_created` int(10) unsigned default NULL,
  `product_domain_required` tinyint(3) unsigned default NULL,
  `product_addon_required` tinyint(3) unsigned default NULL,
  `product_intro_cycle_id` smallint(5) unsigned default NULL,
  `product_intro_num_cycles` smallint(5) unsigned default NULL,
  `email_tpl_group_id` smallint(5) unsigned default NULL,
  `notify_admin_group_id` smallint(5) unsigned default NULL,
  `product_cancellation_type` tinyint(3) unsigned NOT NULL default '0',
  `guid` char(36) NOT NULL,
  `sync_status` ENUM('synced', 'syncing', 'error', 'non-syncable') NOT NULL DEFAULT 'synced',
  `sync_tasks` int(10) unsigned NOT NULL default 0,
  `sync_error` text NULL default NULL,
  `sync_last_time` datetime NULL default NULL,
  PRIMARY KEY  (`product_id`),
  KEY `product_type` (`product_type`),
  KEY `product_variable_id` (`product_variable_id`),
  KEY `product_active` (`product_active`),
  KEY `product_proratable` (`product_proratable`),
  KEY `product_is_lockable` (`product_is_lockable`),
  KEY `product_invoice_separately` (`product_invoice_separately`),
  KEY `product_addon_group_id` (`product_addon_group_id`),
  UNIQUE KEY `guid` (`guid`),
  KEY `sync_status` (`sync_status`),
  KEY `sync_tasks` (`sync_tasks`)
) ENGINE=InnoDB;

--
-- Table structure for table `question_value_map_mapping_rel`
--

DROP TABLE IF EXISTS `question_value_map_mapping_rel`;


CREATE TABLE `question_value_map_mapping_rel` (
  `value_map_id` smallint(5) unsigned NOT NULL default '0',
  `value_mapping_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`value_map_id`,`value_mapping_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `question_value_map_mapping_rel`
--

LOCK TABLES `question_value_map_mapping_rel` WRITE;
/*!40000 ALTER TABLE `question_value_map_mapping_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_map_mapping_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value_mappings`
--

DROP TABLE IF EXISTS `question_value_mappings`;


CREATE TABLE `question_value_mappings` (
  `value_mapping_id` smallint(5) unsigned NOT NULL auto_increment,
  `value_mapping_value` varchar(255) default NULL,
  `attribute_map_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`value_mapping_id`),
  KEY `attribute_map_id` (`attribute_map_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `question_value_mappings`
--

LOCK TABLES `question_value_mappings` WRITE;
/*!40000 ALTER TABLE `question_value_mappings` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_mappings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value_maps`
--

DROP TABLE IF EXISTS `question_value_maps`;


CREATE TABLE `question_value_maps` (
  `value_map_id` smallint(5) unsigned NOT NULL auto_increment,
  `value_map_name` varchar(100) default NULL,
  PRIMARY KEY  (`value_map_id`),
  KEY `value_map_name` (`value_map_name`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `question_value_maps`
--

LOCK TABLES `question_value_maps` WRITE;
/*!40000 ALTER TABLE `question_value_maps` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value_maps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `report_totals`
--

DROP TABLE IF EXISTS `report_totals`;


CREATE TABLE `report_totals` (
  `report_date_created` int(10) unsigned NOT NULL default '0',
  `client_total_count` int(8) unsigned default NULL,
  `client_active_count` int(8) unsigned default NULL,
  `client_inactive_count` int(8) unsigned default NULL,
  `client_pending_count` int(8) unsigned default NULL,
  `client_canceled_count` int(8) unsigned default NULL,
  `client_fraud_count` int(8) unsigned default NULL,
  `package_new_count` int(8) unsigned default NULL,
  `package_new_sum` decimal(10,2) unsigned default NULL,
  `package_renew_count` int(8) unsigned default NULL,
  `package_renew_sum` decimal(10,2) unsigned default NULL,
  `invoice_total_count` int(8) unsigned default NULL,
  `invoice_total_sum` decimal(10,2) unsigned default NULL,
  `invoice_due_count` int(8) unsigned default NULL,
  `invoice_due_sum` decimal(10,2) unsigned default NULL,
  `invoice_paid_count` int(8) unsigned default NULL,
  `invoice_paid_sum` decimal(10,2) unsigned default NULL,
  `invoice_batch_count` int(8) unsigned default NULL,
  `invoice_batch_sum` decimal(10,2) unsigned default NULL,
  `invoice_declined_count` int(8) unsigned default NULL,
  `invoice_declined_sum` decimal(10,2) unsigned default NULL,
  `invoice_error_count` int(8) unsigned default NULL,
  `invoice_error_sum` decimal(10,2) unsigned default NULL,
  `registrar_debits` decimal(10,2) unsigned default NULL,
  `registrar_credits` decimal(10,2) unsigned default NULL,
  `domain_count` int(8) unsigned default NULL,
  `domain_exp_this` smallint(5) unsigned default NULL,
  `domain_exp_next` smallint(5) unsigned default NULL,
  `update_by` int(8) unsigned default NULL,
  `update_timestamp` int(10) unsigned default NULL,
  `report_saved` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`report_date_created`),
  KEY `update_by` (`update_by`),
  KEY `report_saved` (`report_saved`),
  KEY `update_timestamp` (`update_timestamp`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `report_totals`
--

LOCK TABLES `report_totals` WRITE;
/*!40000 ALTER TABLE `report_totals` DISABLE KEYS */;
/*!40000 ALTER TABLE `report_totals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `saved_orders`
--

DROP TABLE IF EXISTS `saved_orders`;


CREATE TABLE `saved_orders` (
  `saved_order_code` varchar(50) NOT NULL default '',
  `client_id` int(8) unsigned default NULL,
  `saved_order_date_modified` int(10) unsigned default NULL,
  PRIMARY KEY  (`saved_order_code`),
  KEY `client_id` (`client_id`),
  KEY `saved_order_date_modified` (`saved_order_date_modified`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `saved_orders`
--

LOCK TABLES `saved_orders` WRITE;
/*!40000 ALTER TABLE `saved_orders` DISABLE KEYS */;
/*!40000 ALTER TABLE `saved_orders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `secret_answers`
--

DROP TABLE IF EXISTS `secret_answers`;


CREATE TABLE `secret_answers` (
  `secret_answer_id` int(10) unsigned NOT NULL auto_increment,
  `client_contact_id` int(10) unsigned default NULL,
  `question_type` tinyint(3) unsigned default NULL,
  `secret_answer` varchar(150) default NULL,
  PRIMARY KEY  (`secret_answer_id`),
  KEY `client_contact_id` (`client_contact_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `secret_answers`
--

LOCK TABLES `secret_answers` WRITE;
/*!40000 ALTER TABLE `secret_answers` DISABLE KEYS */;
/*!40000 ALTER TABLE `secret_answers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_group_rel`
--
DROP TABLE IF EXISTS `server_group_rel`;
CREATE TABLE `server_group_rel` (
  `server_id` int(8) unsigned NOT NULL default '0',
  `server_group_id` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`server_id`,`server_group_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `server_group_rel`
--
LOCK TABLES `server_group_rel` WRITE;
/*!40000 ALTER TABLE `server_group_rel` DISABLE KEYS */;
INSERT INTO `server_group_rel` VALUES (74,1);
INSERT INTO `server_group_rel` VALUES (78,2);
/*!40000 ALTER TABLE `server_group_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `server_groups`
--
DROP TABLE IF EXISTS `server_groups`;
CREATE TABLE `server_groups` (
  `server_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `server_group_name` varchar(75) default NULL,
  `server_group_fill_type` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`server_group_id`),
  KEY `server_group_fill_type` (`server_group_fill_type`)
) ENGINE=InnoDB AUTO_INCREMENT=3 ;

--
-- Dumping data for table `server_groups`
--
LOCK TABLES `server_groups` WRITE;
/*!40000 ALTER TABLE `server_groups` DISABLE KEYS */;
INSERT INTO `server_groups` VALUES (1,'PleskUnix',0);
INSERT INTO `server_groups` VALUES (2,'PleskWin',0);
/*!40000 ALTER TABLE `server_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sessions`
--

DROP TABLE IF EXISTS `sessions`;


CREATE TABLE `sessions` (
  `session_id` varchar(40) NOT NULL default '',
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `real_user_id` int(10) unsigned,
  `real_user_type` tinyint(3) unsigned,
  `session_date_created` int(10) unsigned default NULL,
  `session_date_accessed` int(10) unsigned default NULL,
  `session_date_expired` int(10) unsigned default NULL,
  `session_ip` VARCHAR(39) default NULL,
  `session_headers` text,
  `session_active` tinyint(3) unsigned default '1',
  `session_storage` longtext,
  PRIMARY KEY  (`session_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `session_ip` (`session_ip`),
  KEY `session_active` (`session_active`),
  KEY `session_date_expired` (`session_date_expired`),
  KEY `session_date_accessed` (`session_date_accessed`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `sessions`
--

LOCK TABLES `sessions` WRITE;
/*!40000 ALTER TABLE `sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `sessions` ENABLE KEYS */;
UNLOCK TABLES;


DROP TABLE IF EXISTS `settings`;


CREATE TABLE `settings` (
    `name` varchar(255) NOT NULL,
    `value` TEXT,
    PRIMARY KEY (`name`)
) ENGINE=InnoDB;

--
-- Dumping data for table `server_groups`
--
LOCK TABLES `settings` WRITE;
/*!40000 ALTER TABLE `settings` DISABLE KEYS */;
INSERT INTO `settings` VALUES ('defaultCustomerGroupID','1');
/*!40000 ALTER TABLE `settings` ENABLE KEYS */;
UNLOCK TABLES;
--
-- Table structure for table `shopping_coupons`
--

DROP TABLE IF EXISTS `shopping_coupons`;


CREATE TABLE `shopping_coupons` (
  `shopping_session_id` varchar(255) default NULL,
  `coupon_id` smallint(5) unsigned default NULL,
  `shopping_coupon_type` tinyint(1) unsigned default '0',
  KEY `shopping_session_id` (`shopping_session_id`),
  KEY `coupon_id` (`coupon_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `shopping_coupons`
--

LOCK TABLES `shopping_coupons` WRITE;
/*!40000 ALTER TABLE `shopping_coupons` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_coupons` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_items`
--
DROP TABLE IF EXISTS `shopping_items`;
CREATE TABLE `shopping_items` (
  `shopping_item_id` int(10) unsigned NOT NULL auto_increment,
  `shopping_session_id` varchar(255) default NULL,
  `product_id` int(10) unsigned default NULL,
  `product_variant_id` int(8) unsigned default NULL,
  `parent_shopping_item_id` int(10) unsigned default NULL,
  `shopping_item_primary_domain_id` int(10) unsigned default NULL,
  `cycle_id` smallint(5) unsigned default NULL,
  `currency_id` char(3) default NULL,
  `shopping_item_quantity` smallint(5) unsigned default NULL,
  `shopping_item_sld` varchar(255) default NULL,
  `shopping_item_tld` varchar(20) default NULL,
  `shopping_item_domain_type` tinyint(3) unsigned default NULL,
  `shopping_item_domain_language` char(3) default NULL,
  `shopping_item_transfer_key` varchar(255) default NULL,
  `shopping_item_price` decimal(10,2) unsigned default NULL,
  `shopping_item_setup_price` decimal(10,2) unsigned default NULL,
  `shopping_item_date_added` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_item_id`),
  KEY `shopping_session_id` (`shopping_session_id`),
  KEY `product_id` (`product_id`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `parent_shopping_item_id` (`parent_shopping_item_id`),
  KEY `shopping_item_date_added` (`shopping_item_date_added`)
) ENGINE=MyISAM AUTO_INCREMENT=10 ;

--
-- Table structure for table `shopping_items_domains_rel`
--

DROP TABLE IF EXISTS `shopping_items_domains_rel`;


CREATE TABLE `shopping_items_domains_rel` (
  `shopping_items_domains_rel_id` int(10) unsigned NOT NULL auto_increment,
  `shopping_item_id` int(10) unsigned default NULL,
  `shopping_items_domains_type` tinyint(1) unsigned default NULL,
  `domain_id` int(10) unsigned default NULL,
  `domain_sld` varchar(255) default NULL,
  `domain_tld` varchar(25) default NULL,
  `domain_shopping_item_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_items_domains_rel_id`),
  KEY `domain_id` (`domain_id`),
  KEY `domain_shopping_item_id` (`domain_shopping_item_id`),
  KEY `shopping_item_id` (`shopping_item_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 ;


--
-- Dumping data for table `shopping_items_domains_rel`
--

LOCK TABLES `shopping_items_domains_rel` WRITE;
/*!40000 ALTER TABLE `shopping_items_domains_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_items_domains_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `shopping_item_params`
--

DROP TABLE IF EXISTS `shopping_item_params`;


CREATE TABLE `shopping_item_params` (
  `shopping_item_id` int(10) unsigned NOT NULL,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`shopping_item_id`, `name`)
) ENGINE=InnoDB;

--
-- Table structure for table `shopping_sessions`
--

DROP TABLE IF EXISTS `shopping_sessions`;


CREATE TABLE `shopping_sessions` (
  `shopping_session_id` varchar(255) NOT NULL default '',
  `client_id` int(8) unsigned default NULL,
  `client_contact_id` int(10) unsigned default NULL,
  `shopping_session_timestamp` int(10) unsigned default NULL,
  `shopping_session_ip` bigint(20) default NULL,
  `shopping_session_url` varchar(255) default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `widget_template` varchar(255),
  `website_widget_id` int(10) unsigned,
  `invoice_id` int(10) unsigned default NULL,
  `fraud_level_action` tinyint(3) unsigned default NULL,
  `fraud_level_action_status` tinyint(3) unsigned default NULL,
  `shopping_session_fingerprint` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  PRIMARY KEY  (`shopping_session_id`),
  KEY `client_id` (`client_id`),
  KEY `order_form_id` (`order_form_id`),
  KEY `shopping_session_ip` (`shopping_session_ip`),
  KEY `invoice_id` (`invoice_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `client_contact_id` (`client_contact_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `shopping_sessions`
--

LOCK TABLES `shopping_sessions` WRITE;
/*!40000 ALTER TABLE `shopping_sessions` DISABLE KEYS */;
/*!40000 ALTER TABLE `shopping_sessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log`
--

DROP TABLE IF EXISTS `source_log`;


CREATE TABLE `source_log` (
  `source_log_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_source_type` tinyint(4) default NULL,
  `source_log_user_type` tinyint(4) default NULL,
  `source_log_user_id` int(11) default NULL,
  `source_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`source_log_id`),
  KEY `source_log_source_type` (`source_log_source_type`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `source_log`
--

LOCK TABLES `source_log` WRITE;
/*!40000 ALTER TABLE `source_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log_col`
--

DROP TABLE IF EXISTS `source_log_col`;


CREATE TABLE `source_log_col` (
  `source_log_col_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_row_id` bigint(20) unsigned default NULL,
  `source_log_col_name` varchar(32) default NULL,
  `source_log_col_old_val` varchar(255) default NULL,
  `source_log_col_new_val` varchar(255) default NULL,
  PRIMARY KEY  (`source_log_col_id`),
  KEY `source_log_col_id` (`source_log_col_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `source_log_col`
--

LOCK TABLES `source_log_col` WRITE;
/*!40000 ALTER TABLE `source_log_col` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log_col` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `source_log_row`
--

DROP TABLE IF EXISTS `source_log_row`;


CREATE TABLE `source_log_row` (
  `source_log_row_id` bigint(20) unsigned NOT NULL auto_increment,
  `source_log_id` bigint(20) unsigned default NULL,
  `source_log_row_pri_key` int(10) unsigned default NULL,
  PRIMARY KEY  (`source_log_row_id`),
  KEY `source_log_id` (`source_log_id`),
  KEY `source_log_row_pri_key` (`source_log_row_pri_key`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `source_log_row`
--

LOCK TABLES `source_log_row` WRITE;
/*!40000 ALTER TABLE `source_log_row` DISABLE KEYS */;
/*!40000 ALTER TABLE `source_log_row` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ssl_plugins`
--

DROP TABLE IF EXISTS `ssl_plugins`;

CREATE TABLE `ssl_plugins` (
  `ssl_plugin_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
  `ssl_plugin_name` VARCHAR(255) NOT NULL,
  `ssl_plugin_module` VARCHAR(255) NOT NULL,
  `ssl_plugin_enabled` TINYINT(1) NOT NULL DEFAULT 1,
  PRIMARY KEY  (`ssl_plugin_id`),
  UNIQUE KEY `ssl_plugin_name` (`ssl_plugin_name`)
) ENGINE=InnoDB ;

--
-- Table structure for table `ssl_plugin_params`
--

DROP TABLE IF EXISTS `ssl_plugin_params`;

CREATE TABLE `ssl_plugin_params` (
  `ssl_plugin_id` INT(10) UNSIGNED NOT NULL,
  `ssl_plugin_param_name` VARCHAR(255) NOT NULL,
  `ssl_plugin_param_value` TEXT,
  PRIMARY KEY (`ssl_plugin_id`, `ssl_plugin_param_name`),
  CONSTRAINT `ssl_plugin_id` FOREIGN KEY (`ssl_plugin_id`) REFERENCES `ssl_plugins`(`ssl_plugin_id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=InnoDB ;

--
-- Table structure for table `subscription_package_addon_rel`
--

DROP TABLE IF EXISTS `subscription_package_addon_rel`;


CREATE TABLE `subscription_package_addon_rel` (
  `subscription_id` int(10) unsigned NOT NULL default '0',
  `package_addon_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`package_addon_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `subscription_package_addon_rel`
--

LOCK TABLES `subscription_package_addon_rel` WRITE;
/*!40000 ALTER TABLE `subscription_package_addon_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscription_package_addon_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subscription_package_rel`
--

DROP TABLE IF EXISTS `subscription_package_rel`;


CREATE TABLE `subscription_package_rel` (
  `subscription_id` int(8) unsigned NOT NULL default '0',
  `package_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`package_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `subscription_package_rel`
--

LOCK TABLES `subscription_package_rel` WRITE;
/*!40000 ALTER TABLE `subscription_package_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscription_package_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subscriptions`
--

DROP TABLE IF EXISTS `subscriptions`;


CREATE TABLE `subscriptions` (
  `subscription_id` int(8) unsigned NOT NULL auto_increment,
  `client_id` int(8) unsigned default NULL,
  `subscription_external_id` varchar(255) default NULL,
  `billing_account_id` int(10) unsigned default NULL,
  `subscription_status` tinyint(3) unsigned default NULL,
  `subscription_date_created` int(10) unsigned default NULL,
  `subscription_date_modified` int(10) unsigned default NULL,
  `payment_gateway_id` int(10) unsigned,
  `subscription_account_identifier` varchar(255) default NULL,
  PRIMARY KEY  (`subscription_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`),
  KEY `subscription_status` (`subscription_status`),
  KEY `client_id` (`client_id`),
  KEY `billing_account_id` (`billing_account_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `subscriptions`
--

LOCK TABLES `subscriptions` WRITE;
/*!40000 ALTER TABLE `subscriptions` DISABLE KEYS */;
/*!40000 ALTER TABLE `subscriptions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `suspend_log`
--

DROP TABLE IF EXISTS `suspend_log`;


CREATE TABLE `suspend_log` (
  `suspend_id` int(8) unsigned NOT NULL auto_increment,
  `invoice_id` int(10) unsigned default NULL,
  `lite_stamp` int(10) unsigned default NULL,
  `medium_stamp` int(10) unsigned default NULL,
  `harsh_stamp` int(10) unsigned default NULL,
  `suspend_stamp` int(10) unsigned default NULL,
  `enable_stamp` int(10) unsigned default NULL,
  PRIMARY KEY  (`suspend_id`),
  KEY `invoice_id` (`invoice_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `suspend_log`
--

LOCK TABLES `suspend_log` WRITE;
/*!40000 ALTER TABLE `suspend_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `suspend_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_queue`
--
DROP TABLE IF EXISTS `system_queue`;
CREATE TABLE `system_queue` (
  `system_queue_id` int(10) unsigned NOT NULL auto_increment,
  `package_id` int(10) unsigned default NULL,
  `config_group_id` smallint(5) unsigned default NULL,
  `server_group_id` smallint(5) unsigned default NULL,
  `system_queue_parent_id` int(10) unsigned default NULL,
  `system_queue_status` tinyint(3) default '0',
  `system_queue_status_reason` varchar(255),
  `system_queue_command` varchar(30) default NULL,
  `system_queue_command_input` longtext,
  `system_queue_minute` tinyint(3) unsigned default NULL,
  `system_queue_hour` tinyint(3) unsigned default NULL,
  `system_queue_day` tinyint(3) unsigned default NULL,
  `system_queue_month` tinyint(3) unsigned default NULL,
  `system_queue_year` int(10) unsigned default NULL,
  `system_queue_is_recurring` tinyint(3) unsigned default NULL,
  `system_queue_date_created` int(10) unsigned default '0',
  `system_queue_date_to_run` int(10) unsigned default '0',
  `system_queue_date_started` int(10) unsigned default '0',
  `system_queue_date_finished` int(10) unsigned default '0',
  PRIMARY KEY  (`system_queue_id`),
  KEY `system_queue_command` (`system_queue_command`),
  KEY `system_queue_date_to_run` (`system_queue_date_to_run`),
  KEY `system_queue_is_recurring` (`system_queue_is_recurring`),
  KEY `system_queue_date_created` (`system_queue_date_created`),
  KEY `system_queue_date_started` (`system_queue_date_started`),
  KEY `system_queue_date_finished` (`system_queue_date_finished`),
  KEY `system_queue_parent_id` (`system_queue_parent_id`),
  KEY `system_queue_status` (`system_queue_status`),
  KEY `package_id` (`package_id`),
  KEY `config_group_id` (`config_group_id`),
  KEY `server_group_id` (`server_group_id`)
) ENGINE=MyISAM AUTO_INCREMENT=15;

--
-- Dumping data for table `system_queue`
--
LOCK TABLES `system_queue` WRITE;
/*!40000 ALTER TABLE `system_queue` DISABLE KEYS */;
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessInvoices','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessInvoices&lt;/command&gt;\n	&lt;params&gt;\n		&lt;numInvoicesToGenerate&gt;25&lt;/numInvoicesToGenerate&gt;\n		&lt;setBillingMode&gt;-1&lt;/setBillingMode&gt; \n		&lt;setSendInvoiceEmails&gt;-1&lt;/setSendInvoiceEmails&gt;\n		&lt;packageDateNextRenewalLessThan&gt;-1&lt;/packageDateNextRenewalLessThan&gt;\n		&lt;domainDateNextRenewalLessThan&gt;-1&lt;/domainDateNextRenewalLessThan&gt;\n		&lt;getActiveClients&gt;-1&lt;/getActiveClients&gt;\n		&lt;getSuspendedClients&gt;-1&lt;/getSuspendedClients&gt;\n		&lt;getActivePackages&gt;-1&lt;/getActivePackages&gt;\n		&lt;getSuspendedPackages&gt;-1&lt;/getSuspendedPackages&gt;\n		&lt;getActiveDomains&gt;-1&lt;/getActiveDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessPaymentQueue','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessPaymentQueue&lt;/command&gt;\n	&lt;params&gt;\n		&lt;automated&gt;1&lt;/automated&gt;\n		&lt;generateNew&gt;-1&lt;/generateNew&gt;\n		&lt;generateDeclined&gt;-1&lt;/generateDeclined&gt;\n		&lt;generateError&gt;-1&lt;/generateError&gt;\n		&lt;generateDueDateOnly&gt;-1&lt;/generateDueDateOnly&gt;\n		&lt;dueDateTimestamp&gt;-1&lt;/dueDateTimestamp&gt;\n		&lt;numInvoicesToQueue&gt;25&lt;/numInvoicesToQueue&gt;\n		&lt;numInvoicesToCharge&gt;25&lt;/numInvoicesToCharge&gt;\n		&lt;chargeLesserAmounts&gt;-1&lt;/chargeLesserAmounts&gt;\n		&lt;runPaymentQueue&gt;1&lt;/runPaymentQueue&gt;\n		&lt;clearPaymentQueue&gt;-1&lt;/clearPaymentQueue&gt;\n&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessSuspensions','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessSuspensions&lt;/command&gt;\n	&lt;params&gt;\n		&lt;setSendSuspensionEmails&gt;&lt;/setSendSuspensionEmails&gt;\n		&lt;suspensionLevel1Day&gt;-1&lt;/suspensionLevel1Day&gt;\n		&lt;suspensionLevel2Day&gt;-1&lt;/suspensionLevel2Day&gt;\n		&lt;suspensionLevel3Day&gt;-1&lt;/suspensionLevel3Day&gt;\n		&lt;suspensionCleanDay&gt;-1&lt;/suspensionCleanDay&gt;\n		&lt;limitClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/limitClientGroups&gt;\n		&lt;excludeClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/excludeClientGroups&gt;\n		&lt;limitClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/limitClients&gt;\n		&lt;excludeClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/excludeClients&gt;\n		&lt;limitPackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/limitPackages&gt;\n		&lt;excludePackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/excludePackages&gt;\n		&lt;limitDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/limitDomains&gt;\n		&lt;excludeDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/excludeDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessUnsuspensions','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessUnsuspensions&lt;/command&gt;\n	&lt;params&gt;\n		&lt;setSendSuspensionEmails&gt;&lt;/setSendSuspensionEmails&gt;\n		&lt;suspensionLevel1Day&gt;-1&lt;/suspensionLevel1Day&gt;\n		&lt;suspensionLevel2Day&gt;-1&lt;/suspensionLevel2Day&gt;\n		&lt;suspensionLevel3Day&gt;-1&lt;/suspensionLevel3Day&gt;\n		&lt;suspensionCleanDay&gt;-1&lt;/suspensionCleanDay&gt;\n		&lt;limitClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/limitClientGroups&gt;\n		&lt;excludeClientGroups&gt;\n			&lt;clientGroupID&gt;&lt;/clientGroupID&gt;\n		&lt;/excludeClientGroups&gt;\n		&lt;limitClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/limitClients&gt;\n		&lt;excludeClients&gt;\n			&lt;clientID&gt;&lt;/clientID&gt;\n		&lt;/excludeClients&gt;\n		&lt;limitPackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/limitPackages&gt;\n		&lt;excludePackages&gt;\n			&lt;packageID&gt;&lt;/packageID&gt;\n		&lt;/excludePackages&gt;\n		&lt;limitDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/limitDomains&gt;\n		&lt;excludeDomains&gt;\n			&lt;domainPackageID&gt;&lt;/domainPackageID&gt;\n		&lt;/excludeDomains&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',20,0,0,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessUsage','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessUsage&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessCancellation','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessCancellation&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessExpiredCreditCards','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessExpiredCreditCards&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,7,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessDomainSynchronization','\n&lt;mbapi&gt;\n	&lt;command&gt;ProcessDomainSynchronization&lt;/command&gt;\n	&lt;params&gt;\n	&lt;/params&gt;\n&lt;/mbapi&gt;',0,0,7,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessBatchFiles','&lt;mbapi&gt; &lt;command&gt;ProcessBatchFiles&lt;/command&gt; &lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessActionLog','&lt;mbapi&gt;&lt;command&gt;ProcessActionLog&lt;/command&gt;&lt;subCommand&gt;rotate&lt;/subCommand&gt;&lt;/mbapi&gt;',0,0,0,3,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessSync','&lt;mbapi&gt;&lt;command&gt;ProcessSync&lt;/command&gt;&lt;/mbapi&gt;',5,0,0,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*5,0,0);
INSERT INTO `system_queue` VALUES (NULL,NULL,NULL,NULL,NULL,0,NULL,'ProcessSchetFacturas','&lt;mbapi&gt; &lt;command&gt;ProcessSchetFacturas&lt;/command&gt; &lt;/mbapi&gt;',0,0,1,0,0,1,UNIX_TIMESTAMP(),UNIX_TIMESTAMP() + 60*60*24,0,0);
/*!40000 ALTER TABLE `system_queue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_queue_log`
--

DROP TABLE IF EXISTS `system_queue_log`;


CREATE TABLE `system_queue_log` (
  `system_queue_log_id` int(10) unsigned NOT NULL auto_increment,
  `system_queue_id` int(10) unsigned default NULL,
  `system_queue_log_message` text,
  `system_queue_num_errors` tinyint(3) unsigned default NULL,
  `system_queue_crash_report_id` int(10) unsigned default NULL,
  `system_queue_log_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`system_queue_log_id`),
  KEY `system_queue_id` (`system_queue_id`),
  KEY `system_queue_log_date_created` (`system_queue_log_date_created`),
  KEY `system_queue_num_errors` (`system_queue_num_errors`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `system_queue_log`
--

LOCK TABLES `system_queue_log` WRITE;
/*!40000 ALTER TABLE `system_queue_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `system_queue_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zone_group_zone_rel`
--

DROP TABLE IF EXISTS `tax_zone_group_zone_rel`;


CREATE TABLE `tax_zone_group_zone_rel` (
  `tax_zone_group_zone_rel_id` smallint(5) unsigned NOT NULL auto_increment,
  `tax_zone_group_id` smallint(5) unsigned default NULL,
  `tax_zone_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`tax_zone_group_zone_rel_id`),
  KEY `tax_zone_group_id` (`tax_zone_group_id`),
  KEY `tax_zone_id` (`tax_zone_id`)
) ENGINE=InnoDB ;


--
-- Dumping data for table `tax_zone_group_zone_rel`
--

LOCK TABLES `tax_zone_group_zone_rel` WRITE;
/*!40000 ALTER TABLE `tax_zone_group_zone_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zone_group_zone_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zone_groups`
--

DROP TABLE IF EXISTS `tax_zone_groups`;


CREATE TABLE `tax_zone_groups` (
  `tax_zone_group_id` smallint(5) unsigned NOT NULL auto_increment,
  `tax_zone_group_name` varchar(100) default NULL,
  `tax_zone_group_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`tax_zone_group_id`),
  KEY `tax_zone_group_active` (`tax_zone_group_active`)
) ENGINE=InnoDB ;


--
-- Dumping data for table `tax_zone_groups`
--

LOCK TABLES `tax_zone_groups` WRITE;
/*!40000 ALTER TABLE `tax_zone_groups` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zone_groups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_zones`
--

DROP TABLE IF EXISTS `tax_zones`;


CREATE TABLE `tax_zones` (
  `tax_zone_id` smallint(5) unsigned NOT NULL auto_increment,
  `countries_iso_2` char(2) default NULL,
  `tax_zone_name` varchar(255) default NULL,
  `tax_zone_amount_type` tinyint(3) default '0',
  `tax_zone_amount` decimal(6,2) unsigned default NULL,
  `tax_zone_description` varchar(255) default NULL,
  `ledger_account_id` smallint(5) unsigned default NULL,
  `tax_zone_active` tinyint(3) unsigned default NULL,
  `tax_zone_stackable` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`tax_zone_id`),
  KEY `countries_iso_2` (`countries_iso_2`),
  KEY `tax_zone_active` (`tax_zone_active`),
  KEY `tax_zone_stackable` (`tax_zone_stackable`),
  KEY `ledger_account_id` (`ledger_account_id`)
) ENGINE=InnoDB ;


--
-- Dumping data for table `tax_zones`
--

LOCK TABLES `tax_zones` WRITE;
/*!40000 ALTER TABLE `tax_zones` DISABLE KEYS */;
/*!40000 ALTER TABLE `tax_zones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `themes`
--

DROP TABLE IF EXISTS `themes`;


CREATE TABLE `themes` (
  `theme_id` smallint(5) unsigned NOT NULL auto_increment,
  `theme_name` varchar(50) default NULL,
  `theme_display_name` varchar(255) default NULL,
  `theme_active` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`theme_id`),
  KEY `theme_name` (`theme_name`),
  KEY `theme_active` (`theme_active`)
) ENGINE=MyISAM AUTO_INCREMENT=3 ;


--
-- Dumping data for table `themes`
--

LOCK TABLES `themes` WRITE;
/*!40000 ALTER TABLE `themes` DISABLE KEYS */;
INSERT INTO `themes` VALUES (2,'default','Default',1);
/*!40000 ALTER TABLE `themes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tlds`
--
DROP TABLE IF EXISTS `tlds`;
CREATE TABLE `tlds` (
  `tld_id` int(8) unsigned NOT NULL auto_increment,
  `registrar_id` smallint(5) unsigned default NULL,
  `tld_extension` varchar(25) default NULL,
  `tld_name` varchar(100) default NULL,
  `tld_whois_server` varchar(100) default NULL,
  `tld_whois_resp` varchar(100) default NULL,
  `tld_active` tinyint(3) unsigned default NULL,
  `tld_auto_search` tinyint(3) unsigned default NULL,
  `tld_transfer_minimum_cycle_id` smallint(5) unsigned default NULL,
  `tld_minimum_cycle_id` smallint(5) unsigned default NULL,
  `tld_maximum_cycle_id` smallint(5) unsigned default NULL,
  `tld_renew_type` tinyint(3) unsigned default NULL,
  `tld_is_transferable` tinyint(3) unsigned default NULL,
  `tld_transfer_type` tinyint(3) unsigned default NULL,
  `tld_idn_support` tinyint(3) unsigned default NULL,
  `tld_idn_type` tinyint(3) unsigned default NULL,
  `tld_remote_lock_enabled` tinyint(3) unsigned default NULL,
  `tld_display_order` int(8) unsigned default NULL,
  `tld_whois_match_rule` varchar(25) default NULL,
  PRIMARY KEY  (`tld_id`),
  KEY `tld_extension` (`tld_extension`),
  KEY `tld_display_order` (`tld_display_order`),
  KEY `registrar_id` (`registrar_id`)
) ENGINE=innoDB ;

--
-- Dumping data for table `tlds`
--
LOCK TABLES `tlds` WRITE;
/*!40000 ALTER TABLE `tlds` DISABLE KEYS */;
INSERT INTO `tlds` VALUES (1,null,'ac','ac','','',0,1,6,6,15,2,1,0,1,0,0,11,NULL);
INSERT INTO `tlds` VALUES (2,null,'am','am','','',0,1,6,6,15,2,1,0,1,0,0,12,NULL);
INSERT INTO `tlds` VALUES (3,null,'at','at','','',0,1,6,6,15,2,1,0,1,0,0,13,NULL);
INSERT INTO `tlds` VALUES (5,null,'biz','biz','','',0,1,6,6,15,2,1,0,5,0,0,15,NULL);
INSERT INTO `tlds` VALUES (6,null,'ca','ca','','',0,1,6,6,15,2,1,0,1,0,0,16,NULL);
INSERT INTO `tlds` VALUES (7,null,'cc','cc','','',0,1,6,6,15,2,1,0,1,0,0,17,NULL);
INSERT INTO `tlds` VALUES (8,null,'cn','cn','','',0,1,6,6,15,2,1,0,1,0,0,18,NULL);
INSERT INTO `tlds` VALUES (9,null,'co.in','co.in','','',0,1,6,6,15,2,1,0,1,0,0,19,NULL);
INSERT INTO `tlds` VALUES (10,null,'co.uk','co.uk','','',0,1,7,7,15,2,1,0,1,0,0,4,NULL);
INSERT INTO `tlds` VALUES (11,null,'com','com','','',0,1,6,6,15,2,1,0,1,0,0,1,NULL);
INSERT INTO `tlds` VALUES (12,null,'com.cn','com.cn','','',0,1,6,6,15,2,1,0,1,0,0,22,NULL);
INSERT INTO `tlds` VALUES (13,null,'com.mx','com.mx','','',0,1,6,6,15,2,1,0,1,0,0,23,NULL);
INSERT INTO `tlds` VALUES (14,null,'com.tw','com.tw','','',0,1,6,6,15,2,1,0,1,0,0,24,NULL);
INSERT INTO `tlds` VALUES (15,null,'de','de','','',0,1,6,6,15,2,1,0,1,0,0,25,NULL);
INSERT INTO `tlds` VALUES (16,null,'eu','eu','','',0,1,6,6,15,2,1,0,1,0,0,26,NULL);
INSERT INTO `tlds` VALUES (17,null,'firm.in','firm.in','','',0,1,6,6,15,2,1,0,1,0,0,27,NULL);
INSERT INTO `tlds` VALUES (18,null,'gen.in','gen.in','','',0,1,6,6,15,2,1,0,1,0,0,28,NULL);
INSERT INTO `tlds` VALUES (19,null,'idv.tw','idv.tw','','',0,1,6,6,15,2,1,0,1,0,0,29,NULL);
INSERT INTO `tlds` VALUES (20,null,'in','in','','',0,1,6,6,15,2,1,0,1,0,0,30,NULL);
INSERT INTO `tlds` VALUES (21,null,'ind.in','ind.in','','',0,1,6,6,15,2,1,0,1,0,0,31,NULL);
INSERT INTO `tlds` VALUES (22,null,'info','info','','',0,1,6,6,15,2,1,0,1,0,0,6,NULL);
INSERT INTO `tlds` VALUES (23,null,'io','io','','',0,1,6,6,15,2,1,0,1,0,0,33,NULL);
INSERT INTO `tlds` VALUES (24,null,'it','it','','',0,1,6,6,15,2,1,0,1,0,0,34,NULL);
INSERT INTO `tlds` VALUES (25,null,'jobs','jobs','','',0,1,6,6,15,2,1,0,1,0,0,35,NULL);
INSERT INTO `tlds` VALUES (26,null,'jp','jp','','',0,1,6,6,15,2,1,0,1,0,0,36,NULL);
INSERT INTO `tlds` VALUES (27,null,'kids.us','kids.us','','',0,1,6,6,15,2,1,0,1,0,0,37,NULL);
INSERT INTO `tlds` VALUES (28,null,'me.uk','me.uk','','',0,1,6,6,15,2,1,0,1,0,0,38,NULL);
INSERT INTO `tlds` VALUES (29,null,'mobi','mobi','','',0,1,6,6,15,2,1,0,1,0,0,39,NULL);
INSERT INTO `tlds` VALUES (30,null,'name','name','','',0,1,6,6,15,2,1,0,1,0,0,40,NULL);
INSERT INTO `tlds` VALUES (31,null,'net','net','','',0,1,6,6,15,2,1,0,1,0,0,2,NULL);
INSERT INTO `tlds` VALUES (32,null,'net.in','net.in','','',0,1,6,6,15,2,1,0,1,0,0,42,NULL);
INSERT INTO `tlds` VALUES (33,null,'net.cn','net.cn','','',0,1,6,6,15,2,1,0,1,0,0,43,NULL);
INSERT INTO `tlds` VALUES (34,null,'nl','nl','','',0,1,6,6,15,2,1,0,1,0,0,44,NULL);
INSERT INTO `tlds` VALUES (35,null,'nu','nu','','',0,1,6,6,15,2,1,0,1,0,0,45,NULL);
INSERT INTO `tlds` VALUES (36,null,'org','org','','',0,1,6,6,15,2,1,0,1,0,0,3,NULL);
INSERT INTO `tlds` VALUES (37,null,'org.cn','org.cn','','',0,1,6,6,15,2,1,0,1,0,0,47,NULL);
INSERT INTO `tlds` VALUES (38,null,'org.in','org.in','','',0,1,6,6,15,2,1,0,1,0,0,48,NULL);
INSERT INTO `tlds` VALUES (39,null,'org.tw','org.tw','','',0,1,6,6,15,2,1,0,1,0,0,49,NULL);
INSERT INTO `tlds` VALUES (40,null,'org.uk','org.uk','','',0,1,6,6,15,2,1,0,1,0,0,50,NULL);
INSERT INTO `tlds` VALUES (41,null,'sh','sh','','',0,1,6,6,15,2,1,0,1,0,0,51,NULL);
INSERT INTO `tlds` VALUES (42,null,'tm','tm','','',0,1,6,6,15,2,1,0,1,0,0,52,NULL);
INSERT INTO `tlds` VALUES (43,null,'tv','tv','','',0,1,6,6,15,2,1,0,1,0,0,53,NULL);
INSERT INTO `tlds` VALUES (44,null,'tw','tw','','',0,1,6,6,15,2,1,0,1,0,0,54,NULL);
INSERT INTO `tlds` VALUES (45,null,'us','us','','',0,1,6,6,15,2,1,0,1,0,0,55,NULL);
INSERT INTO `tlds` VALUES (46,null,'ws','ws','','',0,1,6,6,15,2,1,0,1,0,0,56,NULL);
INSERT INTO `tlds` VALUES (48,null,'be','be','','',0,1,6,6,15,2,1,0,1,0,0,58,NULL);
INSERT INTO `tlds` VALUES (49,null,'ch','ch','','',0,1,6,6,15,2,1,0,1,0,0,59,NULL);
INSERT INTO `tlds` VALUES (50,null,'cz','cz','','',0,1,6,6,15,2,1,0,1,0,0,60,NULL);
INSERT INTO `tlds` VALUES (52,null,'dk','dk','','',0,1,6,6,15,2,1,0,1,0,0,62,NULL);
INSERT INTO `tlds` VALUES (53,null,'co.ee','co.ee','','',0,1,6,6,15,2,1,0,1,0,0,63,NULL);
INSERT INTO `tlds` VALUES (54,null,'es','es','','',0,1,6,6,15,2,1,0,1,0,0,64,NULL);
INSERT INTO `tlds` VALUES (55,null,'com.es','com.es','','',0,1,6,6,15,2,1,0,1,0,0,65,NULL);
INSERT INTO `tlds` VALUES (56,null,'org.es','org.es','','',0,1,6,6,15,2,1,0,1,0,0,66,NULL);
INSERT INTO `tlds` VALUES (57,null,'fr','fr','','',0,1,6,6,15,2,1,0,1,0,0,67,NULL);
INSERT INTO `tlds` VALUES (58,null,'gr','gr','','',0,1,6,6,15,2,1,0,1,0,0,68,NULL);
INSERT INTO `tlds` VALUES (59,null,'hu','hu','','',0,1,6,6,15,2,1,0,1,0,0,69,NULL);
INSERT INTO `tlds` VALUES (60,null,'ie','ie','','',0,1,6,6,15,2,1,0,1,0,0,70,NULL);
INSERT INTO `tlds` VALUES (62,null,'li','li','','',0,1,6,6,15,2,1,0,1,0,0,72,NULL);
INSERT INTO `tlds` VALUES (63,null,'lt','lt','','',0,1,6,6,15,2,1,0,1,0,0,73,NULL);
INSERT INTO `tlds` VALUES (64,null,'lu','lu','','',0,1,6,6,15,2,1,0,1,0,0,74,NULL);
INSERT INTO `tlds` VALUES (65,null,'lv','lv','','',0,1,6,6,15,2,1,0,1,0,0,75,NULL);
INSERT INTO `tlds` VALUES (67,null,'com.pt','com.pt','','',0,1,6,6,15,2,1,0,1,0,0,77,NULL);
INSERT INTO `tlds` VALUES (68,null,'se','se','','',0,1,6,6,15,2,1,0,1,0,0,78,NULL);
INSERT INTO `tlds` VALUES (69,null,'sk','sk','','',0,1,6,6,15,2,1,0,1,0,0,79,NULL);
INSERT INTO `tlds` VALUES (70,null,'ro','ro','','',0,1,6,6,15,2,1,0,1,0,0,80,NULL);
INSERT INTO `tlds` VALUES (71,null,'ru','ru','','',0,1,6,6,15,2,1,0,1,0,0,81,NULL);
INSERT INTO `tlds` VALUES (73,null,'la','la','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,83,NULL);
INSERT INTO `tlds` VALUES (74,null,'br.com','br.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,84,NULL);
INSERT INTO `tlds` VALUES (75,null,'cn.com','cn.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,85,NULL);
INSERT INTO `tlds` VALUES (76,null,'de.com','de.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,86,NULL);
INSERT INTO `tlds` VALUES (77,null,'eu.com','eu.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,87,NULL);
INSERT INTO `tlds` VALUES (78,null,'hu.com','hu.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,88,NULL);
INSERT INTO `tlds` VALUES (79,null,'no.com','no.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,89,NULL);
INSERT INTO `tlds` VALUES (80,null,'qc.com','qc.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,90,NULL);
INSERT INTO `tlds` VALUES (81,null,'ru.com','ru.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,91,NULL);
INSERT INTO `tlds` VALUES (82,null,'sa.com','sa.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,92,NULL);
INSERT INTO `tlds` VALUES (83,null,'se.com','se.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,93,NULL);
INSERT INTO `tlds` VALUES (84,null,'se.net','se.net','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,94,NULL);
INSERT INTO `tlds` VALUES (85,null,'uk.com','uk.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,95,NULL);
INSERT INTO `tlds` VALUES (86,null,'uk.net','uk.net','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,96,NULL);
INSERT INTO `tlds` VALUES (87,null,'us.com','us.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,97,NULL);
INSERT INTO `tlds` VALUES (88,null,'uy.com','uy.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,98,NULL);
INSERT INTO `tlds` VALUES (89,null,'za.com','za.com','whois.centralnic.net','',0,1,6,6,15,2,1,0,1,0,0,99,NULL);
INSERT INTO `tlds` VALUES (90,null,'cpa.pro','cpa.pro','whois.registrypro.pro','',0,1,6,6,15,2,1,0,1,0,0,100,NULL);
INSERT INTO `tlds` VALUES (91,null,'law.pro','law.pro','whois.registrypro.pro','',0,1,6,6,15,2,1,0,1,0,0,101,NULL);
INSERT INTO `tlds` VALUES (92,null,'med.pro','med.pro','whois.registrypro.pro','',0,1,6,6,15,2,1,0,1,0,0,102,NULL);
INSERT INTO `tlds` VALUES (93,null,'me','me','whois.meregistry.net','',0,1,7,7,15,2,1,0,1,0,0,0,NULL);
INSERT INTO `tlds` VALUES (94,null,'Ñ€Ñ„','Ñ€Ñ„','whois.ripn.ru','',0,1,6,6,15,2,1,0,1,0,0,103,NULL);
INSERT INTO `tlds` VALUES (95,null,'asia','asia','','',0,1,6,6,15,2,1,0,1,0,0,104,NULL);
INSERT INTO `tlds` VALUES (96,null,'bukhara.su','bukhara.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,105,NULL);
INSERT INTO `tlds` VALUES (97,null,'tashkent.su','tashkent.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,106,NULL);
INSERT INTO `tlds` VALUES (98,null,'grozny.su','grozny.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,107,NULL);
INSERT INTO `tlds` VALUES (99,null,'jambyl.su','jambyl.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,108,NULL);
INSERT INTO `tlds` VALUES (100,null,'kurgan.su','kurgan.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,109,NULL);
INSERT INTO `tlds` VALUES (101,null,'lenug.su','lenug.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,110,NULL);
INSERT INTO `tlds` VALUES (102,null,'obninsk.su','obninsk.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,111,NULL);
INSERT INTO `tlds` VALUES (103,null,'penza.su','penza.su','whois.ripn.net','No entries found',0,1,6,6,15,2,1,0,1,0,0,112,NULL);
/*!40000 ALTER TABLE `tlds` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `todos`
--

DROP TABLE IF EXISTS `todos`;


CREATE TABLE `todos` (
  `todo_id` int(8) unsigned NOT NULL auto_increment,
  `todo_title` varchar(255) default NULL,
  `todo_desc` longtext,
  `user_id` int(8) unsigned default NULL,
  `user_type` tinyint(3) unsigned default NULL,
  `todo_assigned_admin_id` smallint(5) unsigned default NULL,
  `todo_status_id` tinyint(3) unsigned default NULL,
  `todo_priority` tinyint(3) unsigned default NULL,
  `todo_is_public` tinyint(3) unsigned default NULL,
  `todo_link_pk` int(10) unsigned default NULL,
  `todo_link_name` varchar(50) default NULL,
  `todo_link_action_name` varchar(100) default NULL,
  `todo_link_file` varchar(75) default NULL,
  `todo_date_due` int(10) unsigned default NULL,
  `todo_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`todo_id`),
  KEY `user_id` (`user_id`),
  KEY `user_type` (`user_type`),
  KEY `todo_status_id` (`todo_status_id`),
  KEY `todo_priority` (`todo_priority`),
  KEY `todo_date_due` (`todo_date_due`),
  KEY `todo_assigned_admin_id` (`todo_assigned_admin_id`),
  KEY `todo_is_public` (`todo_is_public`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `todos`
--

LOCK TABLES `todos` WRITE;
/*!40000 ALTER TABLE `todos` DISABLE KEYS */;
/*!40000 ALTER TABLE `todos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transaction_log`
--
DROP TABLE IF EXISTS `transaction_log`;
CREATE TABLE `transaction_log` (
  `transaction_id` int(10) unsigned NOT NULL auto_increment,
  `auth_return` tinyint(3) unsigned default NULL,
  `transaction_payment_method` tinyint(3) unsigned default NULL,
  `transaction_code` varchar(255) default NULL,
  `transaction_notes` text,
  `transaction_date_created` int(10) unsigned default NULL,
  `auth_code` varchar(255) default NULL,
  `avs_code` varchar(255) default NULL,
  `transaction_amount` decimal(10,2) default '0.00',
  `transaction_amount_refunded` decimal(10,2) default '0.00',
  `currency_id` char(3) default NULL,
  `payment_gateway_id` int(10) unsigned,
  `billing_account_id` int(10) unsigned default '0',
  `command` ENUM('charge', 'auth', 'capture', 'refund', 'void') NULL default NULL,
  `command_args` text NULL default NULL,
  `command_error` varchar(255) NULL default NULL,
  PRIMARY KEY  (`transaction_id`),
  KEY `auth_return` (`auth_return`),
  KEY `currency_id` (`currency_id`),
  KEY `payment_gateway_id` (`payment_gateway_id`),
  KEY `billing_account_id` (`billing_account_id`),
  KEY `command` (`command`),
  KEY `command_error` (`command_error`)
) ENGINE=MyISAM ;

--
-- Table structure for table `transaction_success_rel`
--

DROP TABLE IF EXISTS `transaction_success_rel`;


CREATE TABLE `transaction_success_rel` (
  `transaction_id` int(10) unsigned default NULL,
  `billing_account_share_id` int(10) unsigned default NULL,
  `line_item_id` int(10) unsigned default NULL,
  `line_item_payment_amount` decimal(10,2) unsigned default '0.00',
  KEY `transaction_id` (`transaction_id`),
  KEY `billing_account_share_id` (`billing_account_share_id`),
  KEY `line_item_id` (`line_item_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `transaction_success_rel`
--

LOCK TABLES `transaction_success_rel` WRITE;
/*!40000 ALTER TABLE `transaction_success_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `transaction_success_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_contacts`
--

DROP TABLE IF EXISTS `vendor_contacts`;


CREATE TABLE `vendor_contacts` (
  `vendor_contact_id` smallint(5) unsigned NOT NULL auto_increment,
  `vendor_id` smallint(5) unsigned default NULL,
  `vendor_contact_first_name` varchar(100) default NULL,
  `vendor_contact_last_name` varchar(100) default NULL,
  `vendor_contact_phone1` varchar(25) default NULL,
  `vendor_contact_phone2` varchar(25) default NULL,
  `vendor_contact_fax` varchar(25) default NULL,
  `language_id` smallint(5) unsigned default NULL,
  `vendor_contact_active` tinyint(1) unsigned default '1',
  PRIMARY KEY  (`vendor_contact_id`),
  KEY `vendor_id` (`vendor_id`),
  KEY `vendor_contact_first_name` (`vendor_contact_first_name`),
  KEY `vendor_contact_last_name` (`vendor_contact_last_name`),
  KEY `language_id` (`language_id`),
  KEY `vendor_contact_active` (`vendor_contact_active`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_contacts`
--

LOCK TABLES `vendor_contacts` WRITE;
/*!40000 ALTER TABLE `vendor_contacts` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_contacts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inv_msg_note_rel`
--

DROP TABLE IF EXISTS `vendor_inv_msg_note_rel`;


CREATE TABLE `vendor_inv_msg_note_rel` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL default '0',
  `vendor_inv_note_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_inv_msg_id`,`vendor_inv_note_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_inv_msg_note_rel`
--

LOCK TABLES `vendor_inv_msg_note_rel` WRITE;
/*!40000 ALTER TABLE `vendor_inv_msg_note_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inv_msg_note_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inv_msg_prov_rel`
--

DROP TABLE IF EXISTS `vendor_inv_msg_prov_rel`;


CREATE TABLE `vendor_inv_msg_prov_rel` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL default '0',
  `vendor_prov_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_inv_msg_id`,`vendor_prov_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_inv_msg_prov_rel`
--

LOCK TABLES `vendor_inv_msg_prov_rel` WRITE;
/*!40000 ALTER TABLE `vendor_inv_msg_prov_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inv_msg_prov_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inventory_msgs`
--

DROP TABLE IF EXISTS `vendor_inventory_msgs`;


CREATE TABLE `vendor_inventory_msgs` (
  `vendor_inv_msg_id` int(10) unsigned NOT NULL auto_increment,
  `vendor_id` smallint(5) unsigned default NULL,
  `vendor_inv_msg_type` tinyint(3) unsigned default '1',
  `vendor_inv_msg_token` varchar(100) default NULL,
  `vendor_inv_msg_text` varchar(255) default NULL,
  PRIMARY KEY  (`vendor_inv_msg_id`),
  KEY `vendor_inv_msg_type` (`vendor_inv_msg_type`),
  KEY `vendor_inv_msg_token` (`vendor_inv_msg_token`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_inventory_msgs`
--

LOCK TABLES `vendor_inventory_msgs` WRITE;
/*!40000 ALTER TABLE `vendor_inventory_msgs` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_inventory_msgs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_inventory_notes`
--
DROP TABLE IF EXISTS `vendor_inventory_notes`;
CREATE TABLE `vendor_inventory_notes` (
  `vendor_inv_note_id` int(10) unsigned NOT NULL auto_increment,
  `vendor_inv_note_type` tinyint(3) unsigned default '1',
  `product_variant_id` int(10) unsigned default NULL,
  `vendor_inv_note_qty` int(10) unsigned default NULL,
  `vendor_inv_note_date` int(10) unsigned default NULL,
  PRIMARY KEY  (`vendor_inv_note_id`),
  KEY `vendor_inv_note_type` (`vendor_inv_note_type`),
  KEY `product_variant_id` (`product_variant_id`),
  KEY `vendor_inv_note_qty` (`vendor_inv_note_qty`),
  KEY `vendor_inv_note_date` (`vendor_inv_note_date`)
) ENGINE=MyISAM ;

--
-- Table structure for table `vendor_prov_package_rel`
--

DROP TABLE IF EXISTS `vendor_prov_package_rel`;


CREATE TABLE `vendor_prov_package_rel` (
  `vendor_prov_id` int(10) unsigned NOT NULL default '0',
  `ext_package_id` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`vendor_prov_id`,`ext_package_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_prov_package_rel`
--

LOCK TABLES `vendor_prov_package_rel` WRITE;
/*!40000 ALTER TABLE `vendor_prov_package_rel` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_prov_package_rel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendor_provisionings`
--

DROP TABLE IF EXISTS `vendor_provisionings`;


CREATE TABLE `vendor_provisionings` (
  `vendor_prov_id` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`vendor_prov_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendor_provisionings`
--

LOCK TABLES `vendor_provisionings` WRITE;
/*!40000 ALTER TABLE `vendor_provisionings` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendor_provisionings` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `vendors`
--

DROP TABLE IF EXISTS `vendors`;


CREATE TABLE `vendors` (
  `vendor_id` smallint(5) unsigned NOT NULL auto_increment,
  `admin_id` smallint(5) unsigned default NULL,
  `vendor_name` varchar(100) default NULL,
  `vendor_active` tinyint(1) unsigned default '1',
  `vendor_api_url` varchar(255) default NULL,
  `vendor_seller_username` varchar(255) default NULL,
  `vendor_seller_password` varchar(255) default NULL,
  `vendor_date_last_invoice_sync` int(10) unsigned default NULL,
  `vendor_activation_rule` tinyint(3) unsigned default '2',
  `vendor_markup_percentage` decimal(10,2) default NULL,
  `vendor_address_1` varchar(100) default NULL,
  `vendor_address_2` varchar(100) default NULL,
  `vendor_city` varchar(100) default NULL,
  `vendor_state` varchar(100) default NULL,
  `vendor_zip` varchar(100) default NULL,
  `countries_id` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`vendor_id`),
  KEY `vendor_name` (`vendor_name`),
  KEY `vendor_active` (`vendor_active`),
  KEY `vendor_seller_username` (`vendor_seller_username`),
  KEY `vendor_seller_password` (`vendor_seller_password`),
  KEY `vendor_date_last_invoice_sync` (`vendor_date_last_invoice_sync`),
  KEY `vendor_city` (`vendor_city`),
  KEY `vendor_state` (`vendor_state`),
  KEY `vendor_zip` (`vendor_zip`),
  KEY `countries_id` (`countries_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `vendors`
--

LOCK TABLES `vendors` WRITE;
/*!40000 ALTER TABLE `vendors` DISABLE KEYS */;
/*!40000 ALTER TABLE `vendors` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `website_widgets`
--

DROP TABLE IF EXISTS `website_widgets`;


CREATE TABLE `website_widgets` (
  `website_widget_id` int(10) unsigned NOT NULL auto_increment,
  `website_widget_name` varchar(100) default NULL,
  `website_widget_tpl` varchar(100) default NULL,
  `order_form_id` smallint(5) unsigned default NULL,
  `code` varchar(20) NOT NULL,
  `continue_shopping_url` TEXT,
  PRIMARY KEY  (`website_widget_id`),
  KEY `order_form_id` (`order_form_id`),
  UNIQUE KEY `code` (`code`)
) ENGINE=MyISAM AUTO_INCREMENT=2 ;


--
-- Dumping data for table `website_widgets`
--

LOCK TABLES `website_widgets` WRITE;
/*!40000 ALTER TABLE `website_widgets` DISABLE KEYS */;
INSERT INTO `website_widgets` VALUES (1,'WW 1','column',1,'widget-1', NULL);
/*!40000 ALTER TABLE `website_widgets` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `website_widgets_products_rel`
--

DROP TABLE IF EXISTS `website_widgets_products_rel`;


CREATE TABLE `website_widgets_products_rel` (
  `website_widget_id` int(10) unsigned NOT NULL default '0',
  `product_id` int(10) unsigned NOT NULL default '0',
  `website_widget_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`website_widget_id`,`product_id`)
) ENGINE=MyISAM;


--
-- Table structure for table `whois_stats`
--

DROP TABLE IF EXISTS `whois_stats`;


CREATE TABLE `whois_stats` (
  `whois_id` int(10) unsigned NOT NULL auto_increment,
  `whois_domain` varchar(255) default NULL,
  `whois_quantity` int(8) unsigned default NULL,
  `whois_from` varchar(25) default NULL,
  `whois_date_created` int(10) unsigned default NULL,
  PRIMARY KEY  (`whois_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `whois_stats`
--

LOCK TABLES `whois_stats` WRITE;
/*!40000 ALTER TABLE `whois_stats` DISABLE KEYS */;
/*!40000 ALTER TABLE `whois_stats` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_question_param_values`
--

DROP TABLE IF EXISTS `wizard_question_param_values`;


CREATE TABLE `wizard_question_param_values` (
  `question_param_value_id` int(10) unsigned NOT NULL auto_increment,
  `question_param_id` int(8) unsigned default NULL,
  `question_param_value_text` longtext,
  PRIMARY KEY  (`question_param_value_id`),
  KEY `question_param_id` (`question_param_id`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `wizard_question_param_values`
--

LOCK TABLES `wizard_question_param_values` WRITE;
/*!40000 ALTER TABLE `wizard_question_param_values` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_question_param_values` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_question_params`
--

DROP TABLE IF EXISTS `wizard_question_params`;


CREATE TABLE `wizard_question_params` (
  `question_param_id` int(8) unsigned NOT NULL auto_increment,
  `question_id` int(8) unsigned default NULL,
  `question_param_name` varchar(255) default NULL,
  `question_param_order` smallint(5) unsigned default NULL,
  PRIMARY KEY  (`question_param_id`),
  KEY `question_id` (`question_id`),
  KEY `question_param_name` (`question_param_name`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `wizard_question_params`
--

LOCK TABLES `wizard_question_params` WRITE;
/*!40000 ALTER TABLE `wizard_question_params` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_question_params` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_questions`
--

DROP TABLE IF EXISTS `wizard_questions`;


CREATE TABLE `wizard_questions` (
  `question_id` int(8) unsigned NOT NULL auto_increment,
  `step_id` smallint(5) unsigned default NULL,
  `question_display_name` varchar(80) default NULL,
  `question_order` tinyint(3) unsigned default NULL,
  PRIMARY KEY  (`question_id`),
  KEY `step_id` (`step_id`),
  KEY `question_order` (`question_order`),
  KEY `question_display_name` (`question_display_name`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `wizard_questions`
--

LOCK TABLES `wizard_questions` WRITE;
/*!40000 ALTER TABLE `wizard_questions` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_questions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizard_steps`
--

DROP TABLE IF EXISTS `wizard_steps`;


CREATE TABLE `wizard_steps` (
  `step_id` smallint(5) unsigned NOT NULL auto_increment,
  `step_name` varchar(255) default NULL,
  PRIMARY KEY  (`step_id`),
  KEY `step_name` (`step_name`)
) ENGINE=MyISAM ;


--
-- Dumping data for table `wizard_steps`
--

LOCK TABLES `wizard_steps` WRITE;
/*!40000 ALTER TABLE `wizard_steps` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizard_steps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `wizards`
--

DROP TABLE IF EXISTS `wizards`;


CREATE TABLE `wizards` (
  `wizard_id` int(10) unsigned default NULL,
  `session_id` varchar(40) default NULL,
  `wizard_date_modified` int(10) unsigned default NULL,
  `wizard_data` longtext,
  KEY `session_id` (`session_id`),
  KEY `wizard_id` (`wizard_id`)
) ENGINE=MyISAM ;

--
-- Dumping data for table `wizards`
--

LOCK TABLES `wizards` WRITE;
/*!40000 ALTER TABLE `wizards` DISABLE KEYS */;
/*!40000 ALTER TABLE `wizards` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2009-04-22 15:20:21
